%------------------------------------------------------------------------------
% File     : VBT00024^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Insert 00120_006446
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0066_VEBT_Insert_00120_006446 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9552 (2816 unt; 591 typ;   0 def)
%            Number of atoms       : 28973 (9296 equ;   0 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 169345 (2078   ~; 318   |;2252   &;151281   @)
%                                         (   0 <=>;13416  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   11 (  10 usr)
%            Number of type conns  : 3765 (3765   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  584 ( 581 usr;  12 con; 0-9 aty)
%            Number of variables   : 28207 (2764   ^24147   !; 795   ?;28207   :)
%                                         ( 501  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 19:19:30.198
%------------------------------------------------------------------------------
% Could-be-implicit typings (16)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (575)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onegative,type,
    code_negative: num > code_integer ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opositive,type,
    code_positive: num > code_integer ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : ( A > ( num > A > A ) > ( num > A > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > ( set @ A ) > A ) ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Ocr__real,type,
    cr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconnected,type,
    topolo1966860045006549960nected: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

% Relevant facts (8183)
thf(fact_0__C3_Oprems_C,axiom,
    ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "3.prems"
thf(fact_1_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_2_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_3_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_4_verit__eq__simplify_I8_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( ( bit0 @ X2 )
        = ( bit0 @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% verit_eq_simplify(8)
thf(fact_5_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_6_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_7_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_8_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_9_verit__eq__simplify_I10_J,axiom,
    ! [X2: num] :
      ( one2
     != ( bit0 @ X2 ) ) ).

% verit_eq_simplify(10)
thf(fact_10__C3_Ohyps_C_I4_J,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "3.hyps"(4)
thf(fact_11__092_060open_0620_A_060_An_092_060close_062,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ na ).

% \<open>0 < n\<close>
thf(fact_12_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_13_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_14_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_15_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_16_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_17_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_18__C3_Ohyps_C_I3_J,axiom,
    ( m
    = ( suc @ na ) ) ).

% "3.hyps"(3)
thf(fact_19_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_20_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_21_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y: A] : ( ord_less @ A @ Y @ X ) ) ).

% lt_ex
thf(fact_22_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_23_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ? [Z2: A] :
              ( ( ord_less @ A @ X @ Z2 )
              & ( ord_less @ A @ Z2 @ Y3 ) ) ) ) ).

% dense
thf(fact_24_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( X != Y3 ) ) ) ).

% less_imp_neq
thf(fact_25_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_26_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_27_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_28_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_29_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y3: A,X: A] :
          ( ~ ( ord_less @ A @ Y3 @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y3 ) )
            = ( X = Y3 ) ) ) ) ).

% antisym_conv3
thf(fact_30_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ~ ( ord_less @ A @ X @ Y3 )
         => ( ( X != Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) ).

% linorder_cases
thf(fact_31_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_32_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_33_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P2: A > $o] :
            ? [X4: A] : ( P2 @ X4 ) )
        = ( ^ [P3: A > $o] :
            ? [N2: A] :
              ( ( P3 @ N2 )
              & ! [M2: A] :
                  ( ( ord_less @ A @ M2 @ N2 )
                 => ~ ( P3 @ M2 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_34_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A3: A,B3: A] :
              ( ( ord_less @ A @ A3 @ B3 )
             => ( P @ A3 @ B3 ) )
         => ( ! [A3: A] : ( P @ A3 @ A3 )
           => ( ! [A3: A,B3: A] :
                  ( ( P @ B3 @ A3 )
                 => ( P @ A3 @ B3 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_35_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_36_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ~ ( ord_less @ A @ X @ Y3 ) )
          = ( ( ord_less @ A @ Y3 @ X )
            | ( X = Y3 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_37_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_38_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_39_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_40_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
         => ( ~ ( ord_less @ A @ X @ Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) ).

% linorder_neqE
thf(fact_41_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) ).

% order_less_asym
thf(fact_42_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ( X != Y3 ) )
          = ( ( ord_less @ A @ X @ Y3 )
            | ( ord_less @ A @ Y3 @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_43_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_44_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( collect @ A
        @ ^ [X5: A] : ( member @ A @ X5 @ A4 ) )
      = A4 ) ).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_47_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_48_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less @ A @ Y3 @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_trans
thf(fact_49_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less @ B @ X3 @ Y )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_50_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less @ A @ X3 @ Y )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_51_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_52_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less @ B @ X3 @ Y )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_53_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less @ A @ X3 @ Y )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_54_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) ).

% order_less_not_sym
thf(fact_55_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A,P: $o] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less @ A @ Y3 @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_56_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
          | ( X = Y3 )
          | ( ord_less @ A @ Y3 @ X ) ) ) ).

% linorder_less_linear
thf(fact_57_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( X != Y3 ) ) ) ).

% order_less_imp_not_eq
thf(fact_58_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( Y3 != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_59_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_60_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_61_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_62_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less @ A @ X @ Y3 )
            | ( X = Y3 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_63_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
          | ( ord_less @ A @ Y3 @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_64_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less @ A @ X3 @ Y )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_65_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_66_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_67_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less @ B @ X3 @ Y )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_68_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_69_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less @ A @ Y3 @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_70_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_71_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_72_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% order_less_imp_le
thf(fact_73_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ~ ( ord_less @ A @ X @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% linorder_not_less
thf(fact_74_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y3 ) )
          = ( ord_less @ A @ Y3 @ X ) ) ) ).

% linorder_not_le
thf(fact_75_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ( X5 != Y5 ) ) ) ) ) ).

% order_less_le
thf(fact_76_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less @ A @ X5 @ Y5 )
              | ( X5 = Y5 ) ) ) ) ) ).

% order_le_less
thf(fact_77_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_78_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_79_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ~ ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_80_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_81_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_82_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_83_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_84_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X @ W2 )
               => ( ( ord_less @ A @ W2 @ Y3 )
                 => ( ord_less_eq @ A @ W2 @ Z ) ) )
           => ( ord_less_eq @ A @ Y3 @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_85_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z @ W2 )
               => ( ( ord_less @ A @ W2 @ X )
                 => ( ord_less_eq @ A @ Y3 @ W2 ) ) )
           => ( ord_less_eq @ A @ Y3 @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_86_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_87_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_88_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_89_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_90_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_91_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y3: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y3 @ X )
         => ( ord_less @ A @ X @ Y3 ) ) ) ).

% not_le_imp_less
thf(fact_92_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ~ ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% less_le_not_le
thf(fact_93_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y3: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y3 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y3 @ Z ) ) ) ).

% dense_le
thf(fact_94_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y3: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y3 @ X3 ) )
         => ( ord_less_eq @ A @ Y3 @ Z ) ) ) ).

% dense_ge
thf(fact_95_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ~ ( ord_less @ A @ X @ Y3 ) )
            = ( X = Y3 ) ) ) ) ).

% antisym_conv2
thf(fact_96_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ~ ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
            = ( X = Y3 ) ) ) ) ).

% antisym_conv1
thf(fact_97_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_98_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ~ ( ord_less @ A @ X @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% leI
thf(fact_99_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ~ ( ord_less @ A @ X @ Y3 ) ) ) ).

% leD
thf(fact_100_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A6 ) )
          = ( ord_less @ B @ A6 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_101_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( ord_less_eq @ A @ X @ Y3 )
            = ( X = Y3 ) ) ) ) ).

% order_antisym_conv
thf(fact_102_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% linorder_le_cases
thf(fact_103_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_104_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_105_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
          | ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% linorder_linear
thf(fact_106_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_107_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( X = Y3 )
         => ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% order_eq_refl
thf(fact_108_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_109_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_110_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_111_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
            ! [X5: A] : ( ord_less_eq @ B @ ( F3 @ X5 ) @ ( G2 @ X5 ) ) ) ) ) ).

% le_fun_def
thf(fact_112_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_113_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_114_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_115_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_116_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_117_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_118_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_119_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
             => ( P @ A3 @ B3 ) )
         => ( ! [A3: A,B3: A] :
                ( ( P @ B3 @ A3 )
               => ( P @ A3 @ B3 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_120_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% order_trans
thf(fact_121_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_122_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ X )
           => ( X = Y3 ) ) ) ) ).

% order_antisym
thf(fact_123_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_124_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_125_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_126_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y3 )
           => ~ ( ord_less_eq @ A @ Y3 @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y3 @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y3 ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y3 )
                 => ~ ( ord_less_eq @ A @ Y3 @ X ) )
               => ( ( ( ord_less_eq @ A @ Y3 @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_127_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_128_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_129_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_130_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_131_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_132_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_133_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_134_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_135_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_136_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_137_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_138_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_139_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_140__C3_Ohyps_C_I2_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "3.hyps"(2)
thf(fact_141_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N3: nat] :
          ( X
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_142_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_143_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_144_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_145_nat_Oinject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% nat.inject
thf(fact_146_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_147_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_148_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_149_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y3: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y3 ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_150_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y3: A] :
          ( ( ( plus_plus @ A @ X @ Y3 )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_151_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_152_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_153_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_154_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_155_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_156_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_157_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_158_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_159_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_160_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_161_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_162_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_163_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_164_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_165_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_166_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_167_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_168_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_169_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_170_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_171_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_172_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_173_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_174_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_175_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_176_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_177_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_178_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_179_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_180_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_181_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_182_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_183_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_184_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_185_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_186_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_187_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_188_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_189_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_190_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_191_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_192_nat__zero__less__power__iff,axiom,
    ! [X: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_193_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_194_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_195_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_196_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_197_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_198_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_199_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_200_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_201_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_202_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_203_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y3 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_204_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_205_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_206_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_207_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y3: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y3 ) )
         => ( X != Y3 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_208_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M3: nat] :
          ( N
          = ( suc @ M3 ) ) ) ).

% not0_implies_Suc
thf(fact_209_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_210_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_211_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_212_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_213_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_214_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_215_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X3: nat] : ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y ) )
       => ( ! [X3: nat,Y: nat] :
              ( ( P @ X3 @ Y )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_216_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_217_Suc__inject,axiom,
    ! [X: nat,Y3: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y3 ) )
     => ( X = Y3 ) ) ).

% Suc_inject
thf(fact_218_old_Onat_Oexhaust,axiom,
    ! [Y3: nat] :
      ( ( Y3
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y3
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_219_nat_OdiscI,axiom,
    ! [Nat: nat,X2: nat] :
      ( ( Nat
        = ( suc @ X2 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_220_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_221_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_222_nat_Odistinct_I1_J,axiom,
    ! [X2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X2 ) ) ).

% nat.distinct(1)
thf(fact_223_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J: nat] :
            ( ( M
              = ( suc @ J ) )
            & ( ord_less @ nat @ J @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_224_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M3: nat] :
          ( N
          = ( suc @ M3 ) ) ) ).

% gr0_implies_Suc
thf(fact_225_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
           => ( P @ I ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I: nat] :
            ( ( ord_less @ nat @ I @ N )
           => ( P @ ( suc @ I ) ) ) ) ) ).

% All_less_Suc2
thf(fact_226_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M2: nat] :
            ( N
            = ( suc @ M2 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_227_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
            & ( P @ I ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ N )
            & ( P @ ( suc @ I ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_228_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_229_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_230_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_231_strict__inc__induct,axiom,
    ! [I2: nat,J2: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ! [I3: nat] :
            ( ( J2
              = ( suc @ I3 ) )
           => ( P @ I3 ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ J2 )
             => ( ( P @ ( suc @ I3 ) )
               => ( P @ I3 ) ) )
         => ( P @ I2 ) ) ) ) ).

% strict_inc_induct
thf(fact_232_less__Suc__induct,axiom,
    ! [I2: nat,J2: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ! [I3: nat] : ( P @ I3 @ ( suc @ I3 ) )
       => ( ! [I3: nat,J3: nat,K2: nat] :
              ( ( ord_less @ nat @ I3 @ J3 )
             => ( ( ord_less @ nat @ J3 @ K2 )
               => ( ( P @ I3 @ J3 )
                 => ( ( P @ J3 @ K2 )
                   => ( P @ I3 @ K2 ) ) ) ) )
         => ( P @ I2 @ J2 ) ) ) ) ).

% less_Suc_induct
thf(fact_233_less__trans__Suc,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( ord_less @ nat @ J2 @ K )
       => ( ord_less @ nat @ ( suc @ I2 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_234_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_235_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_236_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M4: nat] :
            ( ( M
              = ( suc @ M4 ) )
            & ( ord_less @ nat @ N @ M4 ) ) ) ) ).

% Suc_less_eq2
thf(fact_237_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
           => ( P @ I ) ) )
      = ( ( P @ N )
        & ! [I: nat] :
            ( ( ord_less @ nat @ I @ N )
           => ( P @ I ) ) ) ) ).

% All_less_Suc
thf(fact_238_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_239_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_240_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( suc @ N ) )
            & ( P @ I ) ) )
      = ( ( P @ N )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ N )
            & ( P @ I ) ) ) ) ).

% Ex_less_Suc
thf(fact_241_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_242_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_243_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_244_Suc__lessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ K )
     => ~ ! [J3: nat] :
            ( ( ord_less @ nat @ I2 @ J3 )
           => ( K
             != ( suc @ J3 ) ) ) ) ).

% Suc_lessE
thf(fact_245_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_246_Nat_OlessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ K )
     => ( ( K
         != ( suc @ I2 ) )
       => ~ ! [J3: nat] :
              ( ( ord_less @ nat @ I2 @ J3 )
             => ( K
               != ( suc @ J3 ) ) ) ) ) ).

% Nat.lessE
thf(fact_247_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_248_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_249_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_250_Suc__le__D,axiom,
    ! [N: nat,M5: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M5 )
     => ? [M3: nat] :
          ( M5
          = ( suc @ M3 ) ) ) ).

% Suc_le_D
thf(fact_251_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_252_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_253_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_254_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M6: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M6 ) @ N3 )
             => ( P @ M6 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_255_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_256_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X3: nat] : ( R @ X3 @ X3 )
       => ( ! [X3: nat,Y: nat,Z2: nat] :
              ( ( R @ X3 @ Y )
             => ( ( R @ Y @ Z2 )
               => ( R @ X3 @ Z2 ) ) )
         => ( ! [N3: nat] : ( R @ N3 @ ( suc @ N3 ) )
           => ( R @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_257_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_258_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_259_nat__arith_Osuc1,axiom,
    ! [A4: nat,K: nat,A2: nat] :
      ( ( A4
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A4 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_260_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_261_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_262_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N )
            & ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ K2 )
               => ~ ( P @ I4 ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_263_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_264_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_265_nat__one__le__power,axiom,
    ! [I2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I2 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I2 @ N ) ) ) ).

% nat_one_le_power
thf(fact_266_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_267_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N @ N4 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_268_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_269_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N4 ) @ ( F2 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_270_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_271_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_272_dec__induct,axiom,
    ! [I2: nat,J2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( P @ I2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J2 )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J2 ) ) ) ) ).

% dec_induct
thf(fact_273_inc__induct,axiom,
    ! [I2: nat,J2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( P @ J2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J2 )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% inc_induct
thf(fact_274_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_275_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_276_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_277_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat] : ( ord_less_eq @ nat @ ( suc @ N2 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_278_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_279_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K2: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_280_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M2: nat,N2: nat] :
        ? [K3: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M2 @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_281_less__add__Suc2,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ M @ I2 ) ) ) ).

% less_add_Suc2
thf(fact_282_less__add__Suc1,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ I2 @ M ) ) ) ).

% less_add_Suc1
thf(fact_283_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q2: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q2 ) ) ) ) ).

% less_natE
thf(fact_284_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_285_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_286_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_287_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_288_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_289_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_290_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_291_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_292_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_293_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_294_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_295_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X: A] :
      ( ! [X3: A] :
          ( ( ( V2 @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y4: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X3 ) )
                  & ~ ( P @ Y4 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_296_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M6: nat] :
                  ( ( ord_less @ nat @ M6 @ N3 )
                  & ~ ( P @ M6 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_297_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_298_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_299_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_300_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_301_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_302_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_303_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_304_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_305_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_306_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_307_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_308_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_309_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_310_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_311_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_312_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_313_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_314_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_315_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_316_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ B4 @ A5 ) ) ) ) ).

% add.commute
thf(fact_317_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_318_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_319_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_320_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: A,K: A,B2: A,A2: A] :
          ( ( B6
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B6 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_321_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: A,K: A,A2: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_322_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I2 @ K )
            = ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_323_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_324_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_325_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_326_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y4: A] :
              ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X3 ) )
              & ~ ( P @ Y4 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_327_linorder__neqE__nat,axiom,
    ! [X: nat,Y3: nat] :
      ( ( X != Y3 )
     => ( ~ ( ord_less @ nat @ X @ Y3 )
       => ( ord_less @ nat @ Y3 @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_328_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M6: nat] :
              ( ( ord_less @ nat @ M6 @ N3 )
              & ~ ( P @ M6 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_329_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M6: nat] :
              ( ( ord_less @ nat @ M6 @ N3 )
             => ( P @ M6 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_330_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_331_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_332_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_333_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_334_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_335_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_336_le__trans,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ord_less_eq @ nat @ J2 @ K )
       => ( ord_less_eq @ nat @ I2 @ K ) ) ) ).

% le_trans
thf(fact_337_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_338_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_339_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_340_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y: nat] :
            ( ( P @ Y )
           => ( ord_less_eq @ nat @ Y @ B2 ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ Y4 @ X3 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_341_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_342_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_343_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_344_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_345_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_346_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_347_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ( ( plus_plus @ A @ X @ Y3 )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y3
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_348_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y3 )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y3
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_349_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_350_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_351_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_352_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_353_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_354_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_355_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_356_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K2 )
               => ~ ( P @ I4 ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_357_less__imp__add__positive,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I2 @ K2 )
            = J2 ) ) ) ).

% less_imp_add_positive
thf(fact_358_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_359_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_360_nat__power__less__imp__less,axiom,
    ! [I2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_361_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_362_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_363_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_364_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_365_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_366_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_367_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_368_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_369_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_370_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_371_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_372_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_373_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J2 )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_374_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_375_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_376_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_377_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_378_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_379_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_380_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C4: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_381_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_382_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_383_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_384_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_385_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_386_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_387_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_388_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J2 )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_389_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_390_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_391_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) ) ).

% nat_less_le
thf(fact_392_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_393_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less @ nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_394_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_395_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_396_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I2: nat,J2: nat] :
      ( ! [I3: nat,J3: nat] :
          ( ( ord_less @ nat @ I3 @ J3 )
         => ( ord_less @ nat @ ( F2 @ I3 ) @ ( F2 @ J3 ) ) )
     => ( ( ord_less_eq @ nat @ I2 @ J2 )
       => ( ord_less_eq @ nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_397_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_398_trans__less__add2,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ M @ J2 ) ) ) ).

% trans_less_add2
thf(fact_399_trans__less__add1,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ J2 @ M ) ) ) ).

% trans_less_add1
thf(fact_400_add__less__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% add_less_mono1
thf(fact_401_not__add__less2,axiom,
    ! [J2: nat,I2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J2 @ I2 ) @ I2 ) ).

% not_add_less2
thf(fact_402_not__add__less1,axiom,
    ! [I2: nat,J2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J2 ) @ I2 ) ).

% not_add_less1
thf(fact_403_add__less__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J2 @ L ) ) ) ) ).

% add_less_mono
thf(fact_404_add__lessD1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J2 ) @ K )
     => ( ord_less @ nat @ I2 @ K ) ) ).

% add_lessD1
thf(fact_405_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_406_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_407_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_408_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_409_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_410_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_411_add__le__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J2 @ L ) ) ) ) ).

% add_le_mono
thf(fact_412_add__le__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% add_le_mono1
thf(fact_413_trans__le__add1,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ J2 @ M ) ) ) ).

% trans_le_add1
thf(fact_414_trans__le__add2,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ M @ J2 ) ) ) ).

% trans_le_add2
thf(fact_415_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N2: nat] :
        ? [K3: nat] :
          ( N2
          = ( plus_plus @ nat @ M2 @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_416_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_417_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_418_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y3: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
             => ( X = Y3 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_419_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ).

% power2_le_imp_le
thf(fact_420_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_421_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_422_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_423_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_424_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_425_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_426_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_427_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_428_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_429_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M3: nat,N3: nat] :
          ( ( ord_less @ nat @ M3 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M3 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_430_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less @ A @ X @ Y3 ) ) ) ) ).

% power2_less_imp_less
thf(fact_431_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_432_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_433_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_434_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y3
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_435_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_436_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_437_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_438_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_439_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_440_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_441_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y3 @ E ) ) )
         => ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% field_le_epsilon
thf(fact_442_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ? [Y4: A] :
                ( ( P @ Y4 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) ) )
       => ? [Y: A] :
            ( ( P @ Y )
            & ~ ( ord_less @ nat @ ( F2 @ Y ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_443_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y3 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_444_num_Osize__gen_I2_J,axiom,
    ! [X2: num] :
      ( ( size_num @ ( bit0 @ X2 ) )
      = ( plus_plus @ nat @ ( size_num @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_445_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_446_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L2: nat,D3: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D3 ) ) @ L2 ) ) ) ).

% bit_concat_def
thf(fact_447_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_448_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X5: nat,N2: nat] : ( divide_divide @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% high_def
thf(fact_449_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_450_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_451_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_452_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_453_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_454_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_455_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_456_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_457_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_458_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_459_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_460_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_461_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_462_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_463_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_464_high__inv,axiom,
    ! [X: nat,N: nat,Y3: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = Y3 ) ) ).

% high_inv
thf(fact_465_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_466_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_467_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_468_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_469_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_470_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_471_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_472_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_473_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_474_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_475_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_476_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_477_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_478_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_479_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_480_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_481_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_482_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_483_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_484_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_485_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_486_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_487_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_488_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_489_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_490_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_491_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_492_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_493_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_494_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_495_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_496_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_497_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_498_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_499_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_500_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_501_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_502_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
          & ( ( power_power @ real @ R2 @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_503_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M6: extended_enat] :
              ( ( ord_less @ extended_enat @ M6 @ N3 )
             => ( P @ M6 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% enat_less_induct
thf(fact_504_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_505_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_506_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_507_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ B4 @ A5 ) ) ) ) ).

% mult.commute
thf(fact_508_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_509_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_510_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_511_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_512_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_513_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y3: A,Z: A,X: A,W: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y3 )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X @ Z )
                = ( times_times @ A @ W @ Y3 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_514_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_515_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y3: A,Z: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y3 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_516_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y3: A,Z: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W ) @ ( times_times @ A @ Y3 @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_517_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_518_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_519_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_520_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_521_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_522_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_523_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_524_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_525_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_526_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_527_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_528_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_529_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_530_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_531_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_532_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y3 ) @ X )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_533_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z @ Y3 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y3 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_534_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_535_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_536_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_537_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_538_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_539_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_540_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z ) @ Y3 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y3 @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_541_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y3 @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ Y3 ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_542_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X @ Y3 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y3 ) ) @ Y3 ) ) ) ) ).

% add_num_frac
thf(fact_543_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y3: A,X: A,Z: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y3 ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y3 ) ) @ Y3 ) ) ) ) ).

% add_frac_num
thf(fact_544_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y3: A,Z: A,X: A,W: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y3 ) ) @ ( times_times @ A @ Y3 @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_545_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_546_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_547_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_548_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
            & ( ( power_power @ real @ X3 @ N )
              = A2 )
            & ! [Y4: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ( power_power @ real @ Y4 @ N )
                    = A2 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_549_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ( ( power_power @ real @ R2 @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_550_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_551_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_552_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_553_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_554_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_555_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_556_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_557_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_558_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_559_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_560_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z @ Y3 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_561_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y3 ) @ X )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_562_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_563_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_564_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_565_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_566_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y3: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y3 )
            = ( times_times @ A @ Y3 @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y3 )
            = ( times_times @ A @ Y3 @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_567_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_568_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_569_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_570_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_571_mult__le__mono2,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J2 ) ) ) ).

% mult_le_mono2
thf(fact_572_mult__le__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J2 @ K ) ) ) ).

% mult_le_mono1
thf(fact_573_mult__le__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J2 @ L ) ) ) ) ).

% mult_le_mono
thf(fact_574_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_575_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_576_left__add__mult__distrib,axiom,
    ! [I2: nat,U: nat,J2: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I2 @ J2 ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_577_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_578_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_579_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_580_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_581_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_582_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_583_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_584_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_585_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_586_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_587_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_588_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_589_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_590_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_591_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_592_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_593_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_594_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_595_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_596_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_597_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_598_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_599_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_600_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_601_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_602_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_603_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_604_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_605_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_606_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_607_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_608_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_609_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_610_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_611_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_612_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_613_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_614_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_615_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_616_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_617_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_618_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_619_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_620_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_621_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_622_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_623_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_624_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_625_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_626_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_627_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_628_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_629_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_630_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_631_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_632_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_633_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_634_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_635_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_636_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_637_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_638_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,X: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y3 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_639_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y3 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_640_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y3 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_641_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_642_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_643_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_644_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_645_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_646_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_647_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_648_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_649_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_650_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_651_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_652_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_653_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_654_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_655_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_656_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_657_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_658_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_659_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_660_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_661_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y3: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_662_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_663_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_664_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_665_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_666_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_667_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_668_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_669_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_670_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_671_mult__less__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J2 @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_672_mult__less__mono2,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J2 ) ) ) ) ).

% mult_less_mono2
thf(fact_673_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_674_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_675_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_676_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_677_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_678_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y3
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_679_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y3: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y3 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_680_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_681_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_682_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_683_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_684_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X6: A] :
        ? [Y: A] : ( ord_less @ A @ Y @ X6 ) ) ).

% linordered_field_no_lb
thf(fact_685_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X6: A] :
        ? [X_1: A] : ( ord_less @ A @ X6 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_686_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
         => ( ~ ( ord_less @ A @ X @ Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_687_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X3: A] :
          ( ( P @ X3 )
          & ! [Y4: A] :
              ( ( P @ Y4 )
             => ( ord_less_eq @ nat @ ( M @ X3 ) @ ( M @ Y4 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_688_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_689_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_690_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_691_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_692_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_693_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_694_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_695_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_696_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_697_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_698_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_699_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y3 ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_700_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_701_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y3: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y3 ) ) ) ) ).

% power2_sum
thf(fact_702_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_703_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y: A] :
            ( ( P @ Y )
           => ( ord_less @ nat @ ( F2 @ Y ) @ B2 ) )
       => ? [X3: A] :
            ( ( P @ X3 )
            & ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_704_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_705_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_706_num_Osize_I5_J,axiom,
    ! [X2: num] :
      ( ( size_size @ num @ ( bit0 @ X2 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_707_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_708_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_709_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_710_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_711_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_712_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_713_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_714_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_715_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_716_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_717_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_718_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_719_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_720_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_721_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_722_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_723_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_724_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_725_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_726_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_727_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_728_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_729_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_730_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_731_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_732_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_733_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_734_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_735_zmult__zless__mono2,axiom,
    ! [I2: int,J2: int,K: int] :
      ( ( ord_less @ int @ I2 @ J2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I2 ) @ ( times_times @ int @ K @ J2 ) ) ) ) ).

% zmult_zless_mono2
thf(fact_736_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_737_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_738_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_739_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_740_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_741_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( ( ord_less_eq @ int @ A2 @ X )
      | ( A2 = X )
      | ( ord_less_eq @ int @ X @ A2 ) ) ).

% verit_la_generic
thf(fact_742_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_743_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_744_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_745_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_746_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ( ( X
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_747_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_748_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_749_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N @ Q3 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N ) @ Q3 ) ) ).

% div_mult2_eq
thf(fact_750_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_751_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_752_less__mult__imp__div__less,axiom,
    ! [M: nat,I2: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I2 @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I2 ) ) ).

% less_mult_imp_div_less
thf(fact_753_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_754_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_755_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit0_div_2
thf(fact_756_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_757_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_758_div__less__iff__less__mult,axiom,
    ! [Q3: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q3 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q3 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_759_div__nat__eqI,axiom,
    ! [N: nat,Q3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q3 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q3 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q3 ) ) ) ).

% div_nat_eqI
thf(fact_760_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q3: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q3 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q3 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_761_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_762_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_763_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I: nat,J: nat] :
              ( ( ord_less @ nat @ J @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I ) @ J ) )
               => ( P @ I ) ) ) ) ) ) ).

% split_div
thf(fact_764_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_765_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_766_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_767_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_768_low__inv,axiom,
    ! [X: nat,N: nat,Y3: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = X ) ) ).

% low_inv
thf(fact_769_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_770_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_771_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_772_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_773_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_774_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_775_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_776_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_777_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_778_real__divide__square__eq,axiom,
    ! [R3: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R3 @ A2 ) @ ( times_times @ real @ R3 @ R3 ) )
      = ( divide_divide @ real @ A2 @ R3 ) ) ).

% real_divide_square_eq
thf(fact_779_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_780_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_781_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_782_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_783_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X6: real] : ( member @ real @ X6 @ S2 )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S2 )
           => ( ord_less_eq @ real @ X3 @ Z4 ) )
       => ? [Y: real] :
            ( ! [X6: real] :
                ( ( member @ real @ X6 @ S2 )
               => ( ord_less_eq @ real @ X6 @ Y ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S2 )
                   => ( ord_less_eq @ real @ X3 @ Z4 ) )
               => ( ord_less_eq @ real @ Y @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_784_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_785_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X5: real,Y5: real] :
          ( ( ord_less @ real @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) ) ).

% less_eq_real_def
thf(fact_786_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_787_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_788_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_789_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_790_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_791_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R4: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( ord_less @ int @ B2 @ R4 )
           => ( ord_less_eq @ int @ Q3 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_792_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_793_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_794_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_795_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R4: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
       => ( ( ord_less @ int @ R4 @ B2 )
         => ( ( ord_less @ int @ R3 @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q3 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_796_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,B5: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q3 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_797_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I2 @ K ) )
        = ( ord_less_eq @ int @ K @ I2 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_798_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_799_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_800_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,B5: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
       => ( ( ord_less @ int @ R4 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q3 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_801_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_802_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_803_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B5 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_804_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_805_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_pos_eq
thf(fact_806_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_neg_eq
thf(fact_807_zdiv__eq__0__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( divide_divide @ int @ I2 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_808_q__pos__lemma,axiom,
    ! [B5: int,Q5: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ R4 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_809_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_810_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_811_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I: int,J: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J )
                & ( ord_less @ int @ J @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ I ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I: int,J: int] :
              ( ( ( ord_less @ int @ K @ J )
                & ( ord_less_eq @ int @ J @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ I ) ) ) ) ) ).

% split_zdiv
thf(fact_812_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X6: int] :
              ( ( P @ X6 )
             => ( P @ ( plus_plus @ int @ X6 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_813_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y3 @ Z ) )
            = ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_814_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X ) @ ( times_times @ A @ Z @ Y3 ) )
            = ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_815_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X5: nat,N2: nat] : ( modulo_modulo @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% low_def
thf(fact_816_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R3: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R3
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R3 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R3 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_817_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y3 @ Z ) )
            = ( ord_less @ A @ X @ Y3 ) ) ) ) ).

% mult_less_iff1
thf(fact_818_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_819_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_820_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_821_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y3: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y3 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_822_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_823_real__sqrt__eq__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ( sqrt @ X )
        = ( sqrt @ Y3 ) )
      = ( X = Y3 ) ) ).

% real_sqrt_eq_iff
thf(fact_824_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_825_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_826_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_827_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_828_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_829_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_830_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_831_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_832_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_833_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_834_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_835_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_836_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_837_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_838_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_839_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_840_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_841_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_842_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_843_real__sqrt__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) )
      = ( ord_less @ real @ X @ Y3 ) ) ).

% real_sqrt_less_iff
thf(fact_844_real__sqrt__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) )
      = ( ord_less_eq @ real @ X @ Y3 ) ) ).

% real_sqrt_le_iff
thf(fact_845_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_846_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_847_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_848_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_849_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_850_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_851_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_852_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_853_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_854_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_855_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_856_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_857_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_858_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_859_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_860_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_861_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_862_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_863_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_864_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_865_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_866_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_867_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_868_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_869_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_870_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_871_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_872_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_873_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_874_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_875_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_876_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_877_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_878_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_879_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_880_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_881_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_882_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_883_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_884_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_885_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_886_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_887_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_888_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_889_real__sqrt__gt__0__iff,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y3 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_890_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_891_real__sqrt__ge__0__iff,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_892_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_893_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_894_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_895_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_896_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_897_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_898_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_899_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_900_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_901_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_902_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_903_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y3: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y3 ) )
            = ( ord_less @ nat @ X @ Y3 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_904_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_905_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_906_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_907_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self1
thf(fact_908_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N @ K ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self2
thf(fact_909_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self3
thf(fact_910_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self4
thf(fact_911_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_912_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_913_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_914_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_915_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_916_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_917_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_918_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y3: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y3 ) )
            = ( ord_less_eq @ nat @ X @ Y3 ) ) ) ) ).

% power_increasing_iff
thf(fact_919_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_920_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_921_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_922_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_923_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_924_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_925_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_926_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_927_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_928_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_929_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_930_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_931_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_932_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_933_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_934_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_935_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_936_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_937_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_938_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_939_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_940_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_941_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_942_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_943_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_944_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_945_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_946_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_947_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_948_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_949_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_950_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_951_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y3: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_952_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_953_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_954_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_955_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_956_real__sqrt__divide,axiom,
    ! [X: real,Y3: real] :
      ( ( sqrt @ ( divide_divide @ real @ X @ Y3 ) )
      = ( divide_divide @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) ) ) ).

% real_sqrt_divide
thf(fact_957_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_958_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_959_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_960_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_961_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_962_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_963_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_964_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_965_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_966_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_967_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_968_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_969_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_970_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_971_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_972_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_973_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_974_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_975_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_976_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_977_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N ) ) ) ) ) ).

% dvd_mod
thf(fact_978_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_979_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_980_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( modulo_modulo @ A @ B4 @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_981_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_982_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_983_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_984_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_985_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_986_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_987_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_988_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_989_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_990_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_991_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_992_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_993_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_994_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_995_real__sqrt__less__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ X @ Y3 )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) ) ) ).

% real_sqrt_less_mono
thf(fact_996_real__sqrt__le__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ X @ Y3 )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) ) ) ).

% real_sqrt_le_mono
thf(fact_997_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_998_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_999_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_1000_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_1001_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_1002_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_1003_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_1004_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_1005_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_1006_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_1007_real__sqrt__mult,axiom,
    ! [X: real,Y3: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y3 ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) ) ) ).

% real_sqrt_mult
thf(fact_1008_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_1009_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_1010_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1011_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( zero_zero @ A ) )
             => ( B4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1012_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N ) ) ).

% mod_Suc_Suc_eq
thf(fact_1013_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% mod_Suc_eq
thf(fact_1014_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1015_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1016_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1017_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1018_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1019_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1020_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1021_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A5: A] :
            ? [K3: A] :
              ( A5
              = ( times_times @ A @ B4 @ K3 ) ) ) ) ) ).

% dvd_def
thf(fact_1022_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1023_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K2: A] :
                ( A2
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1024_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1025_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1026_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1027_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1028_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1029_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1030_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_1031_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y3: A,N: nat] :
          ( ( dvd_dvd @ A @ X @ Y3 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y3 @ N ) ) ) ) ).

% dvd_power_same
thf(fact_1032_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1033_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1034_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_1035_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_1036_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_1037_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_1038_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_1039_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X6: B] :
          ( ( ord_less @ B @ Z2 @ X6 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1040_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X6: B] :
          ( ( ord_less @ B @ Z2 @ X6 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1041_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X6: B] :
          ( ( ord_less @ B @ X6 @ Z2 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1042_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z2: B] :
        ! [X6: B] :
          ( ( ord_less @ B @ X6 @ Z2 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X6 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1043_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B3: A] :
                  ( ( B3
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B3 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B3 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B3 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B3 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1044_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1045_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1046_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1047_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1048_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_1049_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1050_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1051_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1052_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_1053_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_1054_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_1055_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_1056_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1057_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_1058_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_1059_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_1060_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_1061_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X5: A] : ( P @ ( times_times @ A @ L @ X5 ) ) )
          = ( ? [X5: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X5 @ ( zero_zero @ A ) ) )
                & ( P @ X5 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1062_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1063_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_1064_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P4: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P4 )
       => ( ( ord_less @ nat @ M @ P4 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P4 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P4 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_1065_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1066_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1067_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1068_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1069_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1070_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1071_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_1072_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1073_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1074_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_1075_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_1076_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q2: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q2 ) ) ) ).

% mod_eq_0D
thf(fact_1077_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1078_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1079_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y3: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y3 )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y3 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1080_nat__mod__eq__iff,axiom,
    ! [X: nat,N: nat,Y3: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y3 @ N ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X @ ( times_times @ nat @ N @ Q1 ) )
            = ( plus_plus @ nat @ Y3 @ ( times_times @ nat @ N @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_1081_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1082_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_1083_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_1084_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_1085_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_1086_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_1087_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_1088_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_1089_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_1090_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_1091_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_1092_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_1093_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1094_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_1095_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_1096_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_1097_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y3: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y3 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y3 @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_1098_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_1099_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_1100_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1101_int__ge__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I2 )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_ge_induct
thf(fact_1102_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_1103_int__gr__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I2 )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_gr_induct
thf(fact_1104_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1105_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_1106_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1107_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1108_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_1109_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_1110_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_1111_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_1112_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1113_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_1114_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_1115_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_1116_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_1117_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1118_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1119_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1120_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y3 ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y3 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_1121_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y3 @ Y3 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_1122_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1123_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1124_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1125_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1126_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ).

% even_numeral
thf(fact_1127_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_1128_div__less__mono,axiom,
    ! [A4: nat,B6: nat,N: nat] :
      ( ( ord_less @ nat @ A4 @ B6 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A4 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B6 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A4 @ N ) @ ( divide_divide @ nat @ B6 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1129_nat__mod__eq__lemma,axiom,
    ! [X: nat,N: nat,Y3: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y3 @ N ) )
     => ( ( ord_less_eq @ nat @ Y3 @ X )
       => ? [Q2: nat] :
            ( X
            = ( plus_plus @ nat @ Y3 @ ( times_times @ nat @ N @ Q2 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_1130_mod__eq__nat2E,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N @ Q3 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q3 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_1131_mod__eq__nat1E,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N @ Q3 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q3 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_1132_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_1133_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N @ Q3 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N ) @ Q3 ) ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ).

% mod_mult2_eq
thf(fact_1134_div__mod__decomp,axiom,
    ! [A4: nat,N: nat] :
      ( A4
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A4 @ N ) @ N ) @ ( modulo_modulo @ nat @ A4 @ N ) ) ) ).

% div_mod_decomp
thf(fact_1135_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_1136_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1137_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ( ord_less_eq @ A @ Y3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y3 @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1138_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
           => ( ( ord_less_eq @ A @ Y3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y3 ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1139_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1140_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_1141_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_1142_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1143_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1144_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1145_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1146_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z2: A] :
              ! [X6: A] :
                ( ( ord_less @ A @ Z2 @ X6 )
               => ( ( ( P @ X6 )
                    & ( Q @ X6 ) )
                  = ( ( P5 @ X6 )
                    & ( Q6 @ X6 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1147_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z2: A] :
              ! [X6: A] :
                ( ( ord_less @ A @ Z2 @ X6 )
               => ( ( ( P @ X6 )
                    | ( Q @ X6 ) )
                  = ( ( P5 @ X6 )
                    | ( Q6 @ X6 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1148_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ( X6 != T2 ) ) ) ).

% pinf(3)
thf(fact_1149_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ( X6 != T2 ) ) ) ).

% pinf(4)
thf(fact_1150_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ~ ( ord_less @ A @ X6 @ T2 ) ) ) ).

% pinf(5)
thf(fact_1151_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ( ord_less @ A @ T2 @ X6 ) ) ) ).

% pinf(7)
thf(fact_1152_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z2: C] :
        ! [X6: C] :
          ( ( ord_less @ C @ Z2 @ X6 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1153_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z2: A] :
              ! [X6: A] :
                ( ( ord_less @ A @ X6 @ Z2 )
               => ( ( ( P @ X6 )
                    & ( Q @ X6 ) )
                  = ( ( P5 @ X6 )
                    & ( Q6 @ X6 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1154_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z2: A] :
              ! [X6: A] :
                ( ( ord_less @ A @ X6 @ Z2 )
               => ( ( ( P @ X6 )
                    | ( Q @ X6 ) )
                  = ( ( P5 @ X6 )
                    | ( Q6 @ X6 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1155_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ( X6 != T2 ) ) ) ).

% minf(3)
thf(fact_1156_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ( X6 != T2 ) ) ) ).

% minf(4)
thf(fact_1157_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ( ord_less @ A @ X6 @ T2 ) ) ) ).

% minf(5)
thf(fact_1158_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ~ ( ord_less @ A @ T2 @ X6 ) ) ) ).

% minf(7)
thf(fact_1159_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z2: C] :
        ! [X6: C] :
          ( ( ord_less @ C @ X6 @ Z2 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1160_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1161_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1162_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1163_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1164_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1165_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1166_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_1167_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_1168_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_1169_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_1170_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_increasing
thf(fact_1171_real__sqrt__power__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_1172_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_1173_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1174_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1175_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_1176_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_1177_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1178_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_1179_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1180_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) ) ) ).

% evenE
thf(fact_1181_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1182_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) )
              & ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1183_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I: nat,J: nat] :
              ( ( ord_less @ nat @ J @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I ) @ J ) )
               => ( P @ J ) ) ) ) ) ) ).

% split_mod
thf(fact_1184_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
             => ( ( ord_less @ A @ Z2 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ Y3 ) ) )
         => ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% field_le_mult_one_interval
thf(fact_1185_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1186_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1187_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1188_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1189_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1190_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1191_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1192_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1193_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y3: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y3 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y3 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1194_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1195_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1196_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1197_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1198_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1199_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1200_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1201_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_1202_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1203_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_1204_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1205_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1206_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_1207_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_1208_real__less__rsqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y3 )
     => ( ord_less @ real @ X @ ( sqrt @ Y3 ) ) ) ).

% real_less_rsqrt
thf(fact_1209_sqrt__le__D,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y3 )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_1210_real__le__rsqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y3 )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y3 ) ) ) ).

% real_le_rsqrt
thf(fact_1211_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1212_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1213_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_1214_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_1215_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_1216_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1217_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y3: A,U: A,V: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y3 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y3 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1218_real__le__lsqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y3 ) ) ) ) ).

% real_le_lsqrt
thf(fact_1219_real__sqrt__unique,axiom,
    ! [Y3: real,X: real] :
      ( ( ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( sqrt @ X )
          = Y3 ) ) ) ).

% real_sqrt_unique
thf(fact_1220_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1221_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_1222_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y3: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y3
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_1223_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y3: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y3 )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_1224_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_1225_real__sqrt__sum__squares__ge2,axiom,
    ! [Y3: real,X: real] : ( ord_less_eq @ real @ Y3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_1226_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_1227_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_1228_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1229_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1230_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_1231_real__less__lsqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y3 ) ) ) ) ).

% real_less_lsqrt
thf(fact_1232_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1233_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y3 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_1234_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y3 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_1235_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ~ ( ord_less_eq @ A @ T2 @ X6 ) ) ) ).

% minf(8)
thf(fact_1236_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ X6 @ Z2 )
         => ( ord_less_eq @ A @ X6 @ T2 ) ) ) ).

% minf(6)
thf(fact_1237_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ( ord_less_eq @ A @ T2 @ X6 ) ) ) ).

% pinf(8)
thf(fact_1238_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X6: A] :
          ( ( ord_less @ A @ Z2 @ X6 )
         => ~ ( ord_less_eq @ A @ X6 @ T2 ) ) ) ).

% pinf(6)
thf(fact_1239_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_1240_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_1241_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y3: A,X: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y3 ) @ ( times_times @ A @ X @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X @ Y3 ) ) )
          = ( ( W = X )
            | ( Y3 = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_1242_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1243_imp__le__cong,axiom,
    ! [X: int,X7: int,P: $o,P5: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
           => P5 ) ) ) ) ).

% imp_le_cong
thf(fact_1244_conj__le__cong,axiom,
    ! [X: int,X7: int,P: $o,P5: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
            & P5 ) ) ) ) ).

% conj_le_cong
thf(fact_1245_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1246_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y3: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_1247_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1248_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1249_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1250_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1251_div2__even__ext__nat,axiom,
    ! [X: nat,Y3: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y3 ) )
       => ( X = Y3 ) ) ) ).

% div2_even_ext_nat
thf(fact_1252_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1253_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1254_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X3: nat,Y: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X3 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1255_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D2 ) ) )
         => ? [X3: nat,Y: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1256_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_1257_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_1258_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_1259_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1260_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_1261_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_1262_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_1263_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1264_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1265_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1266_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1267_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_1268_real__sqrt__gt__1__iff,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y3 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y3 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_1269_real__sqrt__ge__1__iff,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y3 ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y3 ) ) ).

% real_sqrt_ge_1_iff
thf(fact_1270_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_1271_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1272_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1273_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_1274_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_1275_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_1276_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_1277_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_1278_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_1279_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1280_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_1281_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_1282_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1283_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1284_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_1285_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q2: int] :
          ( M
          = ( times_times @ int @ D2 @ Q2 ) ) ) ).

% zmod_eq_0D
thf(fact_1286_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1287_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1288_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1289_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_1290_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1291_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1292_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_1293_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_1294_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_1295_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_1296_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_1297_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] : ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_1298_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_1299_real__arch__pow,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N3: nat] : ( ord_less @ real @ Y3 @ ( power_power @ real @ X @ N3 ) ) ) ).

% real_arch_pow
thf(fact_1300_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_1301_zmod__trivial__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( modulo_modulo @ int @ I2 @ K )
        = I2 )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1302_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1303_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1304_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1305_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1306_zdiv__mono__strict,axiom,
    ! [A4: int,B6: int,N: int] :
      ( ( ord_less @ int @ A4 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A4 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B6 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A4 @ N ) @ ( divide_divide @ int @ B6 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1307_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( ( dvd_dvd @ int @ Z @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z @ N ) ) ) ).

% zdvd_imp_le
thf(fact_1308_div__mod__decomp__int,axiom,
    ! [A4: int,N: int] :
      ( A4
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A4 @ N ) @ N ) @ ( modulo_modulo @ int @ A4 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_1309_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1310_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1311_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1312_real__arch__pow__inv,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N3 ) @ Y3 ) ) ) ).

% real_arch_pow_inv
thf(fact_1313_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs )
      = N ) ).

% Ex_list_of_length
thf(fact_1314_neq__if__length__neq,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs2 != Ys ) ) ).

% neq_if_length_neq
thf(fact_1315_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1316_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_1317_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1318_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1319_power__dvd__imp__le,axiom,
    ! [I2: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I2 )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_1320_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R3 ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1321_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R3 ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1322_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I: int,J: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J )
                & ( ord_less @ int @ J @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ J ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I: int,J: int] :
              ( ( ( ord_less @ int @ K @ J )
                & ( ord_less_eq @ int @ J @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ J ) ) ) ) ) ).

% split_zmod
thf(fact_1323_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1324_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_1325_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_1326_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1327_verit__le__mono__div__int,axiom,
    ! [A4: int,B6: int,N: int] :
      ( ( ord_less @ int @ A4 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A4 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B6 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B6 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1328_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I: int,J: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J )
                & ( ord_less @ int @ J @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ I @ J ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1329_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I: int,J: int] :
              ( ( ( ord_less @ int @ K @ J )
                & ( ord_less_eq @ int @ J @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I ) @ J ) ) )
             => ( P @ I @ J ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1330_verit__le__mono__div,axiom,
    ! [A4: nat,B6: nat,N: nat] :
      ( ( ord_less @ nat @ A4 @ B6 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A4 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B6 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B6 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_1331_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P4: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P4 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X3: A,Y: A] :
                ( ( P4
                  = ( times_times @ A @ X3 @ Y ) )
               => ( ( dvd_dvd @ A @ X3 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1332_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1333_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_1334_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( P @ A3 @ B3 )
          = ( P @ B3 @ A3 ) )
     => ( ! [A3: nat] : ( P @ A3 @ ( zero_zero @ nat ) )
       => ( ! [A3: nat,B3: nat] :
              ( ( P @ A3 @ B3 )
             => ( P @ A3 @ ( plus_plus @ nat @ A3 @ B3 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1335_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs2: list @ A] :
      ( ! [Xs: list @ A] :
          ( ! [Ys2: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs ) )
     => ( P @ Xs2 ) ) ).

% length_induct
thf(fact_1336_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_1337_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_1338_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_1339_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_1340_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_1341_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_1342_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_1343_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1344_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1345_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1346_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1347_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M3: nat] : ( P @ M3 @ ( zero_zero @ nat ) )
     => ( ! [M3: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M3 @ N3 ) )
             => ( P @ M3 @ N3 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_1348_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ D4 ) )
        | ( ( times_times @ nat @ B2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y ) @ D4 ) ) ) ) ).

% bezout_add_nat
thf(fact_1349_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_1350_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N2: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1351_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1352_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1353_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1354_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_1355_set__decode__Suc,axiom,
    ! [N: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1356_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1357_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1358_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_1359_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1360_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_1361_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1362_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_1363_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1364_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1365_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1366_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_1367_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_1368_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1369_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1370_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_1371_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1372_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1373_diff__diff__cancel,axiom,
    ! [I2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I2 ) )
        = I2 ) ) ).

% diff_diff_cancel
thf(fact_1374_diff__diff__left,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ K )
      = ( minus_minus @ nat @ I2 @ ( plus_plus @ nat @ J2 @ K ) ) ) ).

% diff_diff_left
thf(fact_1375_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1376_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1377_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1378_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1379_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1380_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1381_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1382_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1383_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_1384_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1385_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1386_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1387_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_1388_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1389_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1390_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1391_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1392_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1393_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1394_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_1395_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_1396_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1397_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1398_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1399_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ I2 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J2 ) ) ) ).

% Nat.diff_diff_right
thf(fact_1400_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I2 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J2 @ I2 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1401_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J2 ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1402_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_1403_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1404_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1405_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1406_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1407_triangle__Suc,axiom,
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) ).

% triangle_Suc
thf(fact_1408_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_1409_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J2 @ K ) ) @ I2 )
        = ( minus_minus @ nat @ ( suc @ J2 ) @ ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1410_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ I2 @ ( suc @ ( minus_minus @ nat @ J2 @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( suc @ J2 ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1411_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1412_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P4: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P4 ) ) )
          = P4 ) ) ).

% odd_of_bool_self
thf(fact_1413_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_1414_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1415_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1416_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_1417_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_1418_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1419_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1420_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1421_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1422_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1423_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P4: $o,Q3: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P4 )
            = ( zero_neq_one_of_bool @ A @ Q3 ) )
          = ( P4 = Q3 ) ) ) ).

% of_bool_eq_iff
thf(fact_1424_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1425_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_1426_diff__commute,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ K ) @ J2 ) ) ).

% diff_commute
thf(fact_1427_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1428_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1429_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1430_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1431_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1432_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( minus_minus @ A @ A5 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1433_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1434_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1435_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1436_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1437_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X6: A,K4: A] :
                ( ( ( P @ X6 )
                  & ( Q @ X6 ) )
                = ( ( P @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1438_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X6: A,K4: A] :
                ( ( ( P @ X6 )
                  | ( Q @ X6 ) )
                = ( ( P @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1439_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1440_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1441_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1442_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1443_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1444_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1445_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1446_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1447_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1448_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1449_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1450_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1451_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A2: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1452_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1453_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1454_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( dvd_dvd @ A @ X @ Y3 )
         => ( ( dvd_dvd @ A @ X @ Z )
           => ( dvd_dvd @ A @ X @ ( minus_minus @ A @ Y3 @ Z ) ) ) ) ) ).

% dvd_diff
thf(fact_1455_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1456_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I2: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I2 ) ) ) ) ).

% zero_induct_lemma
thf(fact_1457_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1458_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_1459_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_1460_less__imp__diff__less,axiom,
    ! [J2: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J2 @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J2 @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1461_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_1462_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1463_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1464_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1465_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1466_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_1467_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_1468_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_1469_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1470_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_1471_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_1472_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_1473_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_1474_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_1475_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_1476_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_1477_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_1478_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_1479_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1480_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_1481_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_1482_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_1483_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1484_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1485_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ~ ( ( P4
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P4
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1486_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ( P4
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P4
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1487_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1488_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1489_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1490_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1491_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1492_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1493_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1494_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1495_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1496_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1497_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1498_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_1499_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1500_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1501_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1502_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N: A,J2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J2 ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1503_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
         => ( ord_less_eq @ A @ I2 @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1504_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1505_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1506_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1507_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y3: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y3 @ Y3 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( minus_minus @ A @ X @ Y3 ) ) ) ) ).

% square_diff_square_factored
thf(fact_1508_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1509_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1510_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y3: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y3 ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y3 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1511_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1512_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1513_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_1514_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1515_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_1516_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_1517_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_1518_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1519_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1520_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1521_less__diff__conv,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ J2 @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J2 ) ) ).

% less_diff_conv
thf(fact_1522_Nat_Ole__imp__diff__is__add,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ( minus_minus @ nat @ J2 @ I2 )
          = K )
        = ( J2
          = ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1523_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J2 @ I2 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I2 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1524_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J2 ) @ K )
        = ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J2 @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1525_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( ord_less_eq @ nat @ I2 @ ( minus_minus @ nat @ J2 @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J2 ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1526_le__diff__conv,axiom,
    ! [J2: nat,K: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I2 )
      = ( ord_less_eq @ nat @ J2 @ ( plus_plus @ nat @ I2 @ K ) ) ) ).

% le_diff_conv
thf(fact_1527_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_1528_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X5: A] : ( plus_plus @ A @ X5 @ X5 ) ) ) ) ).

% dbl_def
thf(fact_1529_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1530_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_1531_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1532_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y ) )
          = D4 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y ) )
          = D4 ) ) ) ).

% bezout1_nat
thf(fact_1533_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_1534_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M2: nat,N2: nat] : ( if @ nat @ ( ord_less @ nat @ M2 @ N2 ) @ M2 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ).

% mod_if
thf(fact_1535_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_1536_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1537_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1538_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1539_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1540_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1541_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y3: A,Z: A,X: A,W: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y3 ) ) @ ( times_times @ A @ Y3 @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1542_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y3 @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ Y3 ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1543_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z ) @ Y3 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y3 @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1544_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1545_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X6: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X6 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1546_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X6: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X6 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1547_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1548_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1549_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1550_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1551_diff__Suc__less,axiom,
    ! [N: nat,I2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_1552_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1553_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1554_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N2
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% add_eq_if
thf(fact_1555_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D3: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D3 ) )
                & ~ ( P @ D3 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1556_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D3: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D3 ) )
           => ( P @ D3 ) ) ) ) ).

% nat_diff_split
thf(fact_1557_less__diff__conv2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J2 )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J2 @ K ) @ I2 )
        = ( ord_less @ nat @ J2 @ ( plus_plus @ nat @ I2 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1558_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1559_nat__diff__add__eq2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I2 ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1560_nat__diff__add__eq1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_1561_nat__le__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I2 ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1562_nat__le__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_1563_nat__eq__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I2 ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1564_nat__eq__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_1565_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q3 )
          = ( modulo_modulo @ nat @ N @ Q3 ) )
        = ( dvd_dvd @ nat @ Q3 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1566_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M2: nat,N2: nat] : ( minus_minus @ nat @ M2 @ ( times_times @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ).

% modulo_nat_def
thf(fact_1567_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1568_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,Z: A,X: A,W: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y3 ) ) @ ( times_times @ A @ Y3 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1569_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,Z: A,X: A,W: A] :
          ( ( Y3
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y3 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y3 ) ) @ ( times_times @ A @ Y3 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1570_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y3: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y3 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1571_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M2: nat] :
              ( if @ A
              @ ( M2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1572_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1573_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1574_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M2 @ N2 )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ) ).

% div_if
thf(fact_1575_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1576_nat__less__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J2 @ I2 ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1577_nat__less__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J2 @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J2 ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_1578_dvd__minus__add,axiom,
    ! [Q3: nat,N: nat,R3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q3 @ N )
     => ( ( ord_less_eq @ nat @ Q3 @ ( times_times @ nat @ R3 @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q3 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R3 @ M ) @ Q3 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1579_mod__nat__eqI,axiom,
    ! [R3: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R3 @ N )
     => ( ( ord_less_eq @ nat @ R3 @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R3 ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R3 ) ) ) ) ).

% mod_nat_eqI
thf(fact_1580_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1581_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R3: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R3 )
           => ( ( ord_less_eq @ A @ R3 @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R3 @ ( minus_minus @ A @ V @ U ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1582_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1583_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1584_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1585_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1586_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1587_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1588_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A3: A] :
              ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A3 )
             => ( P @ A3 ) )
         => ( ! [A3: A,B3: $o] :
                ( ( P @ A3 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A3 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1589_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1590_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1591_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_1592_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y3: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y3 ) ) ) ) ).

% power2_diff
thf(fact_1593_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1594_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1595_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1596_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1597_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1598_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1599_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_1600_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H2 @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = ( H2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1601_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_1602_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_1603_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1604_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_1605_arctan__half,axiom,
    ( arctan
    = ( ^ [X5: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X5 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_1606_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1607_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1608_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_1609_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1610_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_1611_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1612_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1613_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1614_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1615_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1616_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1617_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1618_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1619_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1620_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1621_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1622_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1623_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1624_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1625_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1626_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1627_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y3: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X ) @ Y3 )
          = ( dvd_dvd @ A @ X @ Y3 ) ) ) ).

% minus_dvd_iff
thf(fact_1628_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y3: A] :
          ( ( dvd_dvd @ A @ X @ ( uminus_uminus @ A @ Y3 ) )
          = ( dvd_dvd @ A @ X @ Y3 ) ) ) ).

% dvd_minus_iff
thf(fact_1629_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1630_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_1631_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_1632_arctan__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ( arctan @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_1633_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_1634_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1635_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1636_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1637_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1638_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1639_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1640_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1641_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1642_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1643_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1644_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1645_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1646_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1647_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1648_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1649_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1650_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1651_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1652_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1653_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1654_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1655_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_1656_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_less_arctan_iff
thf(fact_1657_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_1658_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_1659_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_1660_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1661_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1662_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1663_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1664_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1665_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1666_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1667_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1668_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1669_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1670_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1671_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y3 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y3 ) ) ) ).

% semiring_norm(168)
thf(fact_1672_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1673_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1674_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y3 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y3 ) ) ) ).

% semiring_norm(172)
thf(fact_1675_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y3 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y3 ) ) ) ).

% semiring_norm(171)
thf(fact_1676_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y3 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y3 ) ) ) ).

% semiring_norm(170)
thf(fact_1677_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1678_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1679_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1680_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1681_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1682_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1683_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1684_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1685_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1686_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1687_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1688_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1689_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1690_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1691_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1692_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1693_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1694_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1695_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1696_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1697_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1698_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1699_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_1700_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1701_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1702_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1703_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1704_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1705_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1706_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1707_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1708_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X5: real,Y5: real] : ( plus_plus @ real @ X5 @ ( uminus_uminus @ real @ Y5 ) ) ) ) ).

% minus_real_def
thf(fact_1709_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_1710_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1711_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_1712_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1713_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1714_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_1715_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1716_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1717_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1718_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1719_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1720_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1721_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1722_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1723_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1724_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1725_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1726_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1727_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1728_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1729_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1730_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1731_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1732_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1733_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1734_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1735_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1736_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1737_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_1738_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1739_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A6 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A6 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1740_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1741_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_1742_arctan__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y3 ) )
      = ( ord_less @ real @ X @ Y3 ) ) ).

% arctan_less_iff
thf(fact_1743_arctan__monotone,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ X @ Y3 )
     => ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y3 ) ) ) ).

% arctan_monotone
thf(fact_1744_arctan__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y3 ) )
      = ( ord_less_eq @ real @ X @ Y3 ) ) ).

% arctan_le_iff
thf(fact_1745_arctan__monotone_H,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ X @ Y3 )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y3 ) ) ) ).

% arctan_monotone'
thf(fact_1746_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1747_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1748_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_1749_real__sqrt__minus,axiom,
    ! [X: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_minus
thf(fact_1750_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R3: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L @ R3 ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L ) @ R3 ) ) ).

% concat_bit_assoc
thf(fact_1751_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1752_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1753_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1754_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1755_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1756_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1757_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1758_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1759_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1760_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1761_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1762_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1763_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1764_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1765_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1766_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1767_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1768_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1769_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1770_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1771_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1772_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1773_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1774_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1775_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1776_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1777_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1778_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B6: A,K: A,B2: A,A2: A] :
          ( ( B6
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B6 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1779_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1780_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1781_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_1782_int__le__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I2 @ K )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_le_induct
thf(fact_1783_int__less__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I2 @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_less_induct
thf(fact_1784_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1785_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1786_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1787_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1788_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y3: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y3 )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y3 @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y3 ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_1789_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1790_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1791_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1792_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1793_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1794_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1795_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1796_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1797_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1798_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1799_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1800_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_1801_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1802_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1803_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_1804_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1805_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1806_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1807_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1808_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1809_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1810_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1811_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1812_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1813_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1814_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1815_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_1816_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_1817_real__add__less__0__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y3 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y3 @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_1818_real__0__less__add__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y3 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y3 ) ) ).

% real_0_less_add_iff
thf(fact_1819_real__add__le__0__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y3 @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_1820_real__0__le__add__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y3 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y3 ) ) ).

% real_0_le_add_iff
thf(fact_1821_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P1 @ X3 )
            = ( P1 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P1 @ X3 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_1822_plusinfinity,axiom,
    ! [D2: int,P5: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P5 @ X3 )
            = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [X_12: int] : ( P5 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_1823_int__induct,axiom,
    ! [P: int > $o,K: int,I2: int] :
      ( ( P @ K )
     => ( ! [I3: int] :
            ( ( ord_less_eq @ int @ K @ I3 )
           => ( ( P @ I3 )
             => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_induct
thf(fact_1824_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M7: nat] :
      ( ( P @ X )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq @ nat @ X3 @ M7 ) )
       => ~ ! [M3: nat] :
              ( ( P @ M3 )
             => ~ ! [X6: nat] :
                    ( ( P @ X6 )
                   => ( ord_less_eq @ nat @ X6 @ M3 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1825_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1826_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1827_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1828_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1829_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1830_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1831_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1832_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1833_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1834_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y3 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y3 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1835_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y3 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y3 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1836_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1837_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1838_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_1839_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y3 )
            | ( X
              = ( uminus_uminus @ A @ Y3 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_1840_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X6: int] :
              ( ( P @ X6 )
             => ( P @ ( minus_minus @ int @ X6 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1841_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1842_verit__less__mono__div__int2,axiom,
    ! [A4: int,B6: int,N: int] :
      ( ( ord_less_eq @ int @ A4 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B6 @ N ) @ ( divide_divide @ int @ A4 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1843_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1844_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1845_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1846_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1847_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1848_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1849_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1850_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1851_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1852_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1853_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_power @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_1854_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1855_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_1856_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_1857_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_1858_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_1859_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_1860_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1861_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1862_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1863_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_1864_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1865_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1866_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_1867_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_1868_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1869_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_1870_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1871_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_1872_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_1873_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_1874_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1875_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1876_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1877_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X5 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_1878_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y3 ) )
          = ( ord_less @ A @ Y3 @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_1879_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_1880_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A3: real,B3: real,C3: real] :
            ( ( P @ A3 @ B3 )
           => ( ( P @ B3 @ C3 )
             => ( ( ord_less_eq @ real @ A3 @ B3 )
               => ( ( ord_less_eq @ real @ B3 @ C3 )
                 => ( P @ A3 @ C3 ) ) ) ) )
       => ( ! [X3: real] :
              ( ( ord_less_eq @ real @ A2 @ X3 )
             => ( ( ord_less_eq @ real @ X3 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A3: real,B3: real] :
                        ( ( ( ord_less_eq @ real @ A3 @ X3 )
                          & ( ord_less_eq @ real @ X3 @ B3 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B3 @ A3 ) @ D6 ) )
                       => ( P @ A3 @ B3 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1881_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_1882_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_1883_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_1884_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1885_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1886_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1887_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_1888_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_1889_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_1890_ln__inj__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y3 ) )
          = ( X = Y3 ) ) ) ) ).

% ln_inj_iff
thf(fact_1891_ln__less__cancel__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y3 ) )
          = ( ord_less @ real @ X @ Y3 ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_1892_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_1893_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1894_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_1895_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_1896_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_1897_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_1898_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_1899_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_1900_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_1901_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_1902_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1903_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_1904_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_1905_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_1906_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_1907_ln__le__cancel__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y3 ) )
          = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_1908_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_1909_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_1910_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_1911_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_1912_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_1913_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_1914_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_1915_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_1916_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_1917_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_1918_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_1919_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_1920_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_1921_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_1922_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_1923_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_1924_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_1925_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_1926_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_1927_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_1928_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_1929_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_1930_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_1931_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y3: A] :
          ( ( ( abs_abs @ A @ X )
            = ( abs_abs @ A @ Y3 ) )
          = ( ( X = Y3 )
            | ( X
              = ( uminus_uminus @ A @ Y3 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_1932_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_1933_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_1934_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D4 )
               => ( ( ord_less @ real @ A2 @ Y4 )
                  & ( ord_less @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_1935_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_1936_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_1937_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_1938_ln__less__self,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_less_self
thf(fact_1939_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_1940_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_1941_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_1942_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_1943_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_1944_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_1945_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_1946_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_1947_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_1948_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_1949_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_1950_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D4 )
               => ( ( ord_less_eq @ real @ A2 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_1951_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A5: real] : ( if @ real @ ( ord_less @ real @ A5 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A5 ) @ A5 ) ) ) ).

% abs_real_def
thf(fact_1952_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_1953_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y3 ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y3 @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_1954_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_1955_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_1956_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_1957_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_1958_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_1959_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y3 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y3 ) ) ) ) ) ).

% abs_div_pos
thf(fact_1960_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_1961_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_1962_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if_raw
thf(fact_1963_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if
thf(fact_1964_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_1965_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_1966_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R3 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R3 ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R3 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_1967_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_1968_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_1969_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_1970_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_1971_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R3 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R3 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R3 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_1972_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_1973_ln__div,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y3 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y3 ) ) ) ) ) ).

% ln_div
thf(fact_1974_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_1975_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_1976_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_1977_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_1978_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_1979_ln__diff__le,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y3 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y3 ) @ Y3 ) ) ) ) ).

% ln_diff_le
thf(fact_1980_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_1981_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_1982_ln__mult,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y3 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y3 ) ) ) ) ) ).

% ln_mult
thf(fact_1983_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y3 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_1984_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_1985_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_1986_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_even_abs
thf(fact_1987_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_1988_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y3 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y3 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_1989_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_1990_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_1991_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_1992_sqrt__ge__absD,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y3 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y3 ) ) ).

% sqrt_ge_absD
thf(fact_1993_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_1994_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X5: real] : ( ln_ln @ real @ ( plus_plus @ real @ X5 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_1995_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y3 ) ) ) ).

% compl_le_swap2
thf(fact_1996_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y3 ) ) ) ) ).

% compl_le_swap1
thf(fact_1997_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_1998_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y3 ) ) ) ) ).

% compl_less_swap1
thf(fact_1999_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y3 ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y3 ) ) ) ).

% compl_less_swap2
thf(fact_2000_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y3 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_2001_real__sqrt__ge__abs2,axiom,
    ! [Y3: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_2002_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_2003_arctan__add,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y3 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y3 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y3 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2004_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2005_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_2006_cos__x__y__le__one,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_2007_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y3 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_2008_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2009_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( P @ X3 @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2010_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2011_sin__bound__lemma,axiom,
    ! [X: real,Y3: real,U: real,V: real] :
      ( ( X = Y3 )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U ) @ Y3 ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_2012_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2013_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2014_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2015_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_2016_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_2017_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_2018_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_2019_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_2020_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2021_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2022_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_2023_tanh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( tanh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_2024_tanh__real__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y3 ) )
      = ( ord_less @ real @ X @ Y3 ) ) ).

% tanh_real_less_iff
thf(fact_2025_tanh__real__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y3 ) )
      = ( ord_less_eq @ real @ X @ Y3 ) ) ).

% tanh_real_le_iff
thf(fact_2026_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2027_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2028_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2029_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_2030_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_2031_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_2032_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_2033_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2034_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2035_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2036_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2037_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_pos_iff
thf(fact_2038_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2039_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2040_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_2041_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2042_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_2043_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2044_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2045_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2046_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2047_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2048_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2049_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2050_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2051_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2052_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2053_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2054_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2055_verit__eq__simplify_I14_J,axiom,
    ! [X2: num,X32: num] :
      ( ( bit0 @ X2 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2056_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2057_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( ( dvd_dvd @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A2 )
       => ( ( abs_abs @ int @ A2 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2058_num_Oexhaust,axiom,
    ! [Y3: num] :
      ( ( Y3 != one2 )
     => ( ! [X22: num] :
            ( Y3
           != ( bit0 @ X22 ) )
       => ~ ! [X33: num] :
              ( Y3
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2059_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2060_abs__div,axiom,
    ! [Y3: int,X: int] :
      ( ( dvd_dvd @ int @ Y3 @ X )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X @ Y3 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X ) @ ( abs_abs @ int @ Y3 ) ) ) ) ).

% abs_div
thf(fact_2061_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2062_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2063_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2064_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2065_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2066_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2067_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2068_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I: int] : ( if @ int @ ( ord_less @ int @ I @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I ) @ I ) ) ) ).

% zabs_def
thf(fact_2069_dvd__imp__le__int,axiom,
    ! [I2: int,D2: int] :
      ( ( I2
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I2 )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I2 ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2070_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_2071_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_2072_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2073_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ).

% odd_numeral
thf(fact_2074_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2075_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2076_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2077_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2078_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2079_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2080_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2081_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2082_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2083_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2084_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2085_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2086_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2087_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2088_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I3 )
            & ( ord_less @ nat @ I3 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I3: nat] :
                ( ( ord_less_eq @ nat @ M @ I3 )
                & ( ord_less_eq @ nat @ I3 @ N )
                & ( ( F2 @ I3 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2089_decr__lemma,axiom,
    ! [D2: int,X: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_2090_incr__lemma,axiom,
    ! [D2: int,Z: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2091_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2092_eq__diff__eq_H,axiom,
    ! [X: real,Y3: real,Z: real] :
      ( ( X
        = ( minus_minus @ real @ Y3 @ Z ) )
      = ( Y3
        = ( plus_plus @ real @ X @ Z ) ) ) ).

% eq_diff_eq'
thf(fact_2093_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2094_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2095_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2096_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2097_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2098_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2099_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2100_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X5: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2101_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L2
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_2102_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_2103_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_2104_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_2105_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2106_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_2107_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_2108_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_2109_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_2110_exp__less__cancel__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y3 ) )
      = ( ord_less @ real @ X @ Y3 ) ) ).

% exp_less_cancel_iff
thf(fact_2111_exp__less__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ X @ Y3 )
     => ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y3 ) ) ) ).

% exp_less_mono
thf(fact_2112_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_2113_exp__le__cancel__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y3 ) )
      = ( ord_less_eq @ real @ X @ Y3 ) ) ).

% exp_le_cancel_iff
thf(fact_2114_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2115_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2116_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_2117_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2118_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2119_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_2120_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_2121_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_2122_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_2123_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2124_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2125_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2126_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_2127_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_2128_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_2129_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2130_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2131_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2132_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2133_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_2134_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_2135_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2136_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2137_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2138_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_2139_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_2140_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_2141_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_2142_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2143_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2144_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2145_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2146_exp__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X ) ) ).

% exp_ln
thf(fact_2147_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% exp_ln_iff
thf(fact_2148_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2149_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2150_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2151_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2152_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_2153_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_2154_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_2155_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_2156_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_2157_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_2158_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_2159_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_2160_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2161_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_2162_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_2163_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2164_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2165_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_2166_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_2167_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2168_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2169_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_2170_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344872417868541ns_and @ A @ B4 @ A5 ) ) ) ) ).

% and.commute
thf(fact_2171_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_2172_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_2173_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2174_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2175_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q3 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q3 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2176_exp__less__cancel,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y3 ) )
     => ( ord_less @ real @ X @ Y3 ) ) ).

% exp_less_cancel
thf(fact_2177_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ X )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_2178_take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2179_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A4: A] :
          ( ( times_times @ A @ ( exp @ A @ A4 ) @ A4 )
          = ( times_times @ A @ A4 @ ( exp @ A @ A4 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_2180_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_2181_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_2182_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L: int,R3: int,S: int] :
      ( ( ( bit_concat_bit @ N @ K @ L )
        = ( bit_concat_bit @ N @ R3 @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N @ R3 ) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_2183_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] :
      ( ( bit_concat_bit @ N @ ( bit_se2584673776208193580ke_bit @ int @ N @ B2 ) )
      = ( bit_concat_bit @ N @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2184_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_2185_exp__total,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
     => ? [X3: real] :
          ( ( exp @ real @ X3 )
          = Y3 ) ) ).

% exp_total
thf(fact_2186_exp__gt__zero,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_gt_zero
thf(fact_2187_not__exp__less__zero,axiom,
    ! [X: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_2188_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_2189_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_2190_AND__lower,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) ) ) ).

% AND_lower
thf(fact_2191_AND__upper1,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) @ X ) ) ).

% AND_upper1
thf(fact_2192_AND__upper2,axiom,
    ! [Y3: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) @ Y3 ) ) ).

% AND_upper2
thf(fact_2193_AND__upper1_H,axiom,
    ! [Y3: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( ord_less_eq @ int @ Y3 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y3 @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_2194_AND__upper2_H,axiom,
    ! [Y3: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( ord_less_eq @ int @ Y3 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_2195_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2196_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_2197_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_2198_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2199_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_2200_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_2201_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2202_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( times_times @ A @ X @ Y3 )
            = ( times_times @ A @ Y3 @ X ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X @ Y3 ) )
            = ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y3 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_2203_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y3 ) )
          = ( exp @ A @ ( plus_plus @ A @ X @ Y3 ) ) ) ) ).

% mult_exp_exp
thf(fact_2204_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X @ Y3 ) )
          = ( divide_divide @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y3 ) ) ) ) ).

% exp_diff
thf(fact_2205_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_2206_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_2207_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2208_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2209_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2210_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_2211_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2212_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_2213_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2214_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_2215_AND__upper1_H_H,axiom,
    ! [Y3: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( ord_less @ int @ Y3 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y3 @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_2216_AND__upper2_H_H,axiom,
    ! [Y3: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( ord_less @ int @ Y3 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_2217_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_2218_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_2219_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2220_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_2221_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2222_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_2223_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_2224_lemma__exp__total,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y3 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( minus_minus @ real @ Y3 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X3 )
            = Y3 ) ) ) ).

% lemma_exp_total
thf(fact_2225_ln__ge__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y3 @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y3 ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_2226_ln__x__over__x__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y3 )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y3 ) @ Y3 ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_2227_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X5: A] : ( plus_plus @ A @ ( plus_plus @ A @ X5 @ X5 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2228_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2229_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( modulo_modulo @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2230_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_2231_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_2232_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_2233_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_2234_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_2235_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2236_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N2: nat,M2: nat] : ( modulo_modulo @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_nat_def
thf(fact_2237_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_2238_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_def
thf(fact_2239_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_2240_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2241_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2242_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2243_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2244_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2245_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2246_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2247_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X5: A] : ( minus_minus @ A @ ( plus_plus @ A @ X5 @ X5 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2248_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2249_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2250_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2251_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2252_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2253_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2254_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2255_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2256_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2257_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2258_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2259_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2260_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2261_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2262_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2263_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2264_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2265_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2266_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_2267_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2268_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_2269_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2270_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2271_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_2272_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2273_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2274_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_2275_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2276_and__nat__numerals_I1_J,axiom,
    ! [Y3: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y3 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2277_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2278_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2279_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_2280_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_2281_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_2282_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_2283_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y3 ) )
            = ( ord_less @ real @ X @ Y3 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_2284_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_2285_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2286_and__nat__numerals_I2_J,axiom,
    ! [Y3: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2287_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2288_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_2289_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_2290_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_2291_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_2292_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y3 ) )
            = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_2293_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2294_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2295_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2296_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2297_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2298_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_2299_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2300_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_2301_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X3: num] :
            ( ( P @ X3 )
           => ( P @ ( inc @ X3 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_2302_add__inc,axiom,
    ! [X: num,Y3: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y3 ) )
      = ( inc @ ( plus_plus @ num @ X @ Y3 ) ) ) ).

% add_inc
thf(fact_2303_log__def,axiom,
    ( log
    = ( ^ [A5: real,X5: real] : ( divide_divide @ real @ ( ln_ln @ real @ X5 ) @ ( ln_ln @ real @ A5 ) ) ) ) ).

% log_def
thf(fact_2304_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2305_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2306_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2307_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_2308_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2309_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2310_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_2311_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_2312_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_2313_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_2314_mult__inc,axiom,
    ! [X: num,Y3: num] :
      ( ( times_times @ num @ X @ ( inc @ Y3 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y3 ) @ X ) ) ).

% mult_inc
thf(fact_2315_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_2316_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2317_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_2318_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2319_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2320_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2321_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2322_log__mult,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y3 ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y3 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_2323_log__divide,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y3 ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y3 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_2324_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2325_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2326_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2327_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_2328_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_2329_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_2330_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2331_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2332_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2333_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2334_arctan__ubound,axiom,
    ! [Y3: real] : ( ord_less @ real @ ( arctan @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2335_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2336_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2337_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2338_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N2: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2339_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2340_arctan__bounded,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y3 ) )
      & ( ord_less @ real @ ( arctan @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2341_arctan__lbound,axiom,
    ! [Y3: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y3 ) ) ).

% arctan_lbound
thf(fact_2342_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N2: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2343_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( ( M2
              = ( zero_zero @ nat ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_2344_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_2345_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2346_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_2347_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_2348_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_2349_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_2350_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2351_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_2352_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_2353_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2354_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_2355_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_2356_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_2357_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2358_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2359_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2360_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_2361_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_2362_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_2363_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_2364_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_2365_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2366_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2367_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2368_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2369_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2370_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_2371_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2372_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2373_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_2374_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2375_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2376_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2377_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2378_sin__periodic__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi
thf(fact_2379_sin__periodic__pi2,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi2
thf(fact_2380_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2381_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_2382_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_2383_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2384_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2385_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2386_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2387_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N: nat,Y3: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( semiring_1_of_nat @ A @ Y3 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
            = Y3 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2388_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y3: nat,X: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y3 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y3
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2389_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2390_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2391_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2392_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2393_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2394_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2395_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2396_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2397_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2398_sin__arcsin,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y3 ) )
          = Y3 ) ) ) ).

% sin_arcsin
thf(fact_2399_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_2400_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2401_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_2402_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_2403_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2404_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2405_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_2406_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2407_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2408_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2409_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2410_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2411_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2412_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2413_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_2414_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_2415_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2416_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_2417_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2418_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% bit_numeral_iff
thf(fact_2419_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2420_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2421_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y3 )
          = ( times_times @ A @ Y3 @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2422_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_and_iff
thf(fact_2423_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_2424_bit__and__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_and_int_iff
thf(fact_2425_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2426_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_2427_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_2428_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2429_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2430_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_2431_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2432_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2433_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_2434_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2435_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2436_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_2437_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_2438_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_2439_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2440_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I2: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J2 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J2 ) ) ) ) ).

% of_nat_mono
thf(fact_2441_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_2442_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2443_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_2444_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2445_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_2446_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_2447_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2448_sin__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero
thf(fact_2449_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_2450_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_2451_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_2452_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_2453_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_2454_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_2455_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_2456_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_2457_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y4: real] :
        ? [N3: nat] : ( ord_less @ real @ Y4 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_2458_real__of__nat__div4,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_2459_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2460_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N2 @ A5 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2461_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_2462_arcsin__le__arcsin,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y3 )
       => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y3 ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_2463_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_2464_arcsin__le__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y3 ) )
          = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ).

% arcsin_le_mono
thf(fact_2465_arcsin__eq__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y3 ) )
          = ( X = Y3 ) ) ) ) ).

% arcsin_eq_iff
thf(fact_2466_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_2467_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2468_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ( ( sin @ real @ X )
            = ( zero_zero @ real ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_2469_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ pi )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_2470_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2471_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2472_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2473_le__arcsin__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y3 @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y3 ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_2474_arcsin__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y3 )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y3 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_2475_arcsin__pi,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y3 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y3 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y3 ) )
            = Y3 ) ) ) ) ).

% arcsin_pi
thf(fact_2476_arcsin,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y3 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y3 ) )
            = Y3 ) ) ) ) ).

% arcsin
thf(fact_2477_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat,M2: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ).

% nat_less_real_le
thf(fact_2478_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N2: nat,M2: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2479_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_2480_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_2481_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2482_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_concat_bit @ N2 @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2483_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2484_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_2485_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2486_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2487_arcsin__less__arcsin,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y3 )
       => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y3 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_2488_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_2489_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_2490_arcsin__less__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y3 ) )
          = ( ord_less @ real @ X @ Y3 ) ) ) ) ).

% arcsin_less_mono
thf(fact_2491_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_2492_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M6: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M6 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M6 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_2493_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_2494_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2495_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_2496_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M3 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M3 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2497_real__of__nat__div2,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_2498_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_2499_log__base__pow,axiom,
    ! [A2: real,N: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_2500_ln__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_2501_real__of__nat__div3,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2502_log__nat__power,axiom,
    ! [X: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_2503_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2504_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_2505_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_2506_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N2: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_int_def
thf(fact_2507_linear__plus__1__le__power,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_2508_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2509_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_2510_Bernoulli__inequality,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_2511_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2512_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2513_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_2514_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_2515_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_2516_sin__monotone__2pi__le,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y3 ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_2517_sin__mono__le__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y3 ) )
              = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_2518_sin__inj__pi,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y3 ) )
             => ( X = Y3 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_2519_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_2520_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_2521_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J3: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2522_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2523_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_2524_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_2525_sin__mono__less__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y3 ) )
              = ( ord_less @ real @ X @ Y3 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_2526_sin__monotone__2pi,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y3 ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_2527_sin__total,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X3 )
              = Y3 )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y4 )
                    = Y3 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% sin_total
thf(fact_2528_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2529_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2530_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% set_bit_eq
thf(fact_2531_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2532_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_2533_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2534_Bernoulli__inequality__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2535_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_2536_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_2537_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_2538_arcsin__lt__bounded,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y3 ) )
          & ( ord_less @ real @ ( arcsin @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_2539_arcsin__bounded,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y3 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_2540_arcsin__ubound,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_2541_arcsin__lbound,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y3 ) ) ) ) ).

% arcsin_lbound
thf(fact_2542_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_2543_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2544_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z: A,K5: real,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2545_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2546_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2547_sincos__total__2pi,axiom,
    ! [X: real,Y3: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
           => ( ( ord_less @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T3 ) )
               => ( Y3
                 != ( sin @ real @ T3 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_2548_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_2549_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2550_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_2551_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_2552_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_2553_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( dvd_dvd @ nat @ M @ N ) ) ).

% int_dvd_int_iff
thf(fact_2554_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2555_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2556_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_2557_tan__periodic__pi,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_pi
thf(fact_2558_cos__periodic__pi2,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi2
thf(fact_2559_cos__periodic__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi
thf(fact_2560_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ X ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2561_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_2562_tan__periodic__n,axiom,
    ! [X: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_2563_tan__periodic__nat,axiom,
    ! [X: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_2564_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2565_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2566_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_2567_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_2568_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_2569_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_2570_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_2571_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2572_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2573_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2574_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_2575_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sin @ A @ X5 ) @ ( cos @ A @ X5 ) ) ) ) ) ).

% tan_def
thf(fact_2576_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% int_cases2
thf(fact_2577_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M3: nat,N3: nat] :
          ( Z
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_diff_cases
thf(fact_2578_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_2579_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_2580_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_2581_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_2582_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_2583_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2584_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_2585_polar__Ex,axiom,
    ! [X: real,Y3: real] :
    ? [R2: real,A3: real] :
      ( ( X
        = ( times_times @ real @ R2 @ ( cos @ real @ A3 ) ) )
      & ( Y3
        = ( times_times @ real @ R2 @ ( sin @ real @ A3 ) ) ) ) ).

% polar_Ex
thf(fact_2586_int__cases,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_2587_int__of__nat__induct,axiom,
    ! [P: int > $o,Z: int] :
      ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_2588_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2589_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_2590_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2591_cos__arctan__not__zero,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_2592_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2593_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_2594_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_2595_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_2596_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2597_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2598_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2599_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2600_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z5: int] :
        ? [N2: nat] :
          ( Z5
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_2601_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2602_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2603_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2604_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y3 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y3 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_2605_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_2606_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X @ Y3 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y3 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y3 ) ) ) ) ) ).

% sin_add
thf(fact_2607_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X @ Y3 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y3 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y3 ) ) ) ) ) ).

% sin_diff
thf(fact_2608_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_2609_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y3 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y3 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y3 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_2610_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y3 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y3 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y3 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_2611_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y3 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y3 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y3 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_2612_cos__inj__pi,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y3 ) )
             => ( X = Y3 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_2613_cos__mono__le__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y3 ) )
              = ( ord_less_eq @ real @ Y3 @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_2614_cos__monotone__0__pi__le,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y3 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_2615_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_2616_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_2617_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( cos @ A @ X5 ) @ ( sin @ A @ X5 ) ) ) ) ) ).

% cot_def
thf(fact_2618_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2619_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2620_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2621_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2622_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z5: int] :
        ? [N2: nat] :
          ( Z5
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2623_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2624_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2625_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_2626_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X @ Y3 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y3 ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y3 ) ) ) ) ) ).

% cos_diff
thf(fact_2627_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X @ Y3 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y3 ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y3 ) ) ) ) ) ).

% cos_add
thf(fact_2628_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_2629_cos__monotone__0__pi,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y3 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_2630_cos__mono__less__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
         => ( ( ord_less_eq @ real @ Y3 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y3 ) )
              = ( ord_less @ real @ Y3 @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_2631_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X5 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X5 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_2632_cos__monotone__minus__pi__0_H,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y3 ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_2633_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_2634_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2635_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2636_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2637_zmult__zless__mono2__lemma,axiom,
    ! [I2: int,J2: int,K: nat] :
      ( ( ord_less @ int @ I2 @ J2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I2 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J2 ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2638_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_2639_negD,axiom,
    ! [X: int] :
      ( ( ord_less @ int @ X @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_2640_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2641_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2642_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_2643_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_2644_cos__is__zero,axiom,
    ? [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
      & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      & ! [Y4: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
            & ( ord_less_eq @ real @ Y4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y4 )
              = ( zero_zero @ real ) ) )
         => ( Y4 = X3 ) ) ) ).

% cos_is_zero
thf(fact_2645_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_2646_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_2647_cos__monotone__minus__pi__0,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y3 ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_2648_cos__total,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ pi )
            & ( ( cos @ real @ X3 )
              = Y3 )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ pi )
                  & ( ( cos @ real @ Y4 )
                    = Y3 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% cos_total
thf(fact_2649_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2650_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2651_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y )
      & ( ord_less_eq @ real @ Y @ pi )
      & ( ( sin @ real @ Y )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_2652_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_2653_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2654_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y3: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y3 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y3 @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y3 ) ) ) )
        & ( ( ord_less @ nat @ X @ Y3 )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2655_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_nat_def
thf(fact_2656_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_2657_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_2658_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_2659_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_2660_sin__cos__le1,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y3 ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y3 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_2661_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_2662_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_2663_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_2664_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_2665_lemma__tan__total,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
     => ? [X3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y3 @ ( tan @ real @ X3 ) ) ) ) ).

% lemma_tan_total
thf(fact_2666_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_2667_lemma__tan__total1,axiom,
    ! [Y3: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y3 ) ) ).

% lemma_tan_total1
thf(fact_2668_tan__mono__lt__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
         => ( ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y3 ) )
              = ( ord_less @ real @ X @ Y3 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_2669_tan__monotone_H,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y3 @ X )
              = ( ord_less @ real @ ( tan @ real @ Y3 ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_2670_tan__monotone,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y3 ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_2671_tan__total,axiom,
    ! [Y3: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y3 )
      & ! [Y4: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
            & ( ord_less @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y4 )
              = Y3 ) )
         => ( Y4 = X3 ) ) ) ).

% tan_total
thf(fact_2672_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_2673_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_2674_tan__inverse,axiom,
    ! [Y3: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y3 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y3 ) ) ) ).

% tan_inverse
thf(fact_2675_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_2676_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_2677_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_2678_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2679_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_2680_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_12: nat] : ( P @ X_12 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2681_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2682_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_2683_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_2684_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_2685_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_2686_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_2687_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_2688_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_2689_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_2690_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_2691_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_2692_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_2693_tan__total__pos,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X3 )
            = Y3 ) ) ) ).

% tan_total_pos
thf(fact_2694_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_2695_tan__mono__le__eq,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
         => ( ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y3 ) )
              = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_2696_tan__mono__le,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y3 )
       => ( ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y3 ) ) ) ) ) ).

% tan_mono_le
thf(fact_2697_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_2698_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_2699_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_2700_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_2701_arctan,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y3 ) )
      & ( ord_less @ real @ ( arctan @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y3 ) )
        = Y3 ) ) ).

% arctan
thf(fact_2702_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_2703_arctan__unique,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y3 )
         => ( ( arctan @ Y3 )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_2704_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X5: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X5: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_2705_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_2706_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z2: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z2 )
          & ( ord_less @ real @ Z2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z2 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_2707_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_2708_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2709_sincos__total__pi,axiom,
    ! [Y3: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less_eq @ real @ T3 @ pi )
            & ( X
              = ( cos @ real @ T3 ) )
            & ( Y3
              = ( sin @ real @ T3 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_2710_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_2711_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_2712_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_2713_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_2714_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_2715_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_2716_sincos__total__pi__half,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T3: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
              & ( ord_less_eq @ real @ T3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T3 ) )
              & ( Y3
                = ( sin @ real @ T3 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_2717_sincos__total__2pi__le,axiom,
    ! [X: real,Y3: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
          & ( ord_less_eq @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T3 ) )
          & ( Y3
            = ( sin @ real @ T3 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_2718_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2719_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2720_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2721_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2722_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2723_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
          = ( ( X
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2724_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2725_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2726_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2727_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) ).

% int_int_eq
thf(fact_2728_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    = ( ^ [A5: nat,B4: nat] :
          ( ( semiring_1_of_nat @ int @ A5 )
          = ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_2729_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A2 ) ) )
      & ( ~ P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_2730_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2731_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2732_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y3 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) ) ) ).

% norm_mult
thf(fact_2733_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2734_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power
thf(fact_2735_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ Y3 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y3 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2736_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2737_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2738_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R3: real,Y3: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y3 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y3 ) ) @ ( times_times @ real @ R3 @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2739_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) ) ) ).

% norm_mult_ineq
thf(fact_2740_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2741_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R3: real,Y3: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y3 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ ( plus_plus @ real @ R3 @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2742_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R3: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R3 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R3 @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2743_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2744_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2745_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2746_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2747_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y3 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y3 @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2748_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y3 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y3 ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2749_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2750_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A,E1: real,Z: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y3 ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y3 @ Z ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2751_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y3: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y3 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y3 ) ) @ E2 ) ) ) ).

% norm_triangle_le_diff
thf(fact_2752_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2753_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2754_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2755_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2756_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2757_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2758_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2759_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2760_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_2761_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_2762_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
           => ( ( ord_less @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T3 ) @ ( sin @ real @ T3 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_2763_sin__arccos__abs,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y3 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_2764_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_2765_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_2766_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_2767_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_2768_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_2769_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_2770_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2771_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_2772_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_2773_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_2774_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_2775_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_2776_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2777_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2778_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_2779_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2780_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_2781_cos__arccos,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y3 ) )
          = Y3 ) ) ) ).

% cos_arccos
thf(fact_2782_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_2783_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_2784_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2785_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2786_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_2787_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2788_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2789_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_2790_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_2791_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_2792_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_2793_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_2794_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_2795_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y3 ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_2796_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y3 ) )
         => ( ord_less @ A @ X @ Y3 ) ) ) ).

% ceiling_less_cancel
thf(fact_2797_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_2798_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_2799_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_2800_complex__add,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( plus_plus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( plus_plus @ real @ A2 @ C2 ) @ ( plus_plus @ real @ B2 @ D2 ) ) ) ).

% complex_add
thf(fact_2801_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y3 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y3 ) ) ) ) ).

% ceiling_add_le
thf(fact_2802_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_2803_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_2804_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_2805_arccos__le__arccos,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y3 )
       => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y3 ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_2806_arccos__eq__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y3 ) )
        = ( X = Y3 ) ) ) ).

% arccos_eq_iff
thf(fact_2807_arccos__le__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y3 ) )
          = ( ord_less_eq @ real @ Y3 @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_2808_arccos__lbound,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y3 ) ) ) ) ).

% arccos_lbound
thf(fact_2809_arccos__less__arccos,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y3 )
       => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y3 ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_2810_arccos__less__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y3 ) )
          = ( ord_less @ real @ Y3 @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_2811_arccos__ubound,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y3 ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_2812_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_2813_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_2814_cos__arccos__abs,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y3 ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y3 ) )
        = Y3 ) ) ).

% cos_arccos_abs
thf(fact_2815_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_2816_arccos__lt__bounded,axiom,
    ! [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y3 ) )
          & ( ord_less @ real @ ( arccos @ Y3 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_2817_arccos__bounded,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y3 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y3 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_2818_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_2819_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_2820_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_2821_arccos,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y3 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y3 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y3 ) )
            = Y3 ) ) ) ) ).

% arccos
thf(fact_2822_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_2823_complex__norm,axiom,
    ! [X: real,Y3: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y3 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_2824_arccos__le__pi2,axiom,
    ! [Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( ord_less_eq @ real @ Y3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_2825_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_2826_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_2827_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_2828_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2829_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_2830_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_2831_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: int,Z: int] :
          ( ( ( ring_1_of_int @ A @ W )
            = ( ring_1_of_int @ A @ Z ) )
          = ( W = Z ) ) ) ).

% of_int_eq_iff
thf(fact_2832_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_2833_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_2834_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N2: int] :
                ( X
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_2835_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N2: int] :
                ( X
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_2836_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_2837_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_2838_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_2839_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_2840_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% of_int_le_iff
thf(fact_2841_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2842_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N ) )
          = ( Z
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2843_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_2844_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2845_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2846_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_2847_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_2848_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_2849_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_minus
thf(fact_2850_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_2851_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_diff
thf(fact_2852_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( ( X
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_2853_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_int_of_nat_eq
thf(fact_2854_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_2855_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2856_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_2857_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_2858_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% of_int_abs
thf(fact_2859_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2860_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2861_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N ) ) ) ).

% of_int_power
thf(fact_2862_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_2863_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_2864_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_2865_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_2866_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_2867_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_2868_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_2869_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_2870_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2871_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_2872_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2873_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2874_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2875_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2876_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2877_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_2878_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2879_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_2880_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2881_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_2882_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_2883_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_2884_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_2885_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_2886_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_2887_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_2888_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_2889_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_2890_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_2891_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2892_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2893_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y3: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y3 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y3
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2894_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y3: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( ring_1_of_int @ A @ Y3 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
            = Y3 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2895_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2896_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2897_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_2898_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_2899_log__powr__cancel,axiom,
    ! [A2: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y3 ) )
          = Y3 ) ) ) ).

% log_powr_cancel
thf(fact_2900_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2901_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_2902_tan__periodic__int,axiom,
    ! [X: real,I2: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_int
thf(fact_2903_powr__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_2904_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_2905_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2906_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_2907_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2908_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_2909_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_2910_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2911_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2912_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2913_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2914_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y3: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y3 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( Y3
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2915_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y3: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N )
            = ( ring_1_of_int @ A @ Y3 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N )
            = Y3 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2916_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_2917_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_2918_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2919_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_2920_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_2921_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_2922_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2923_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2924_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2925_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2926_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_2927_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_2928_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_2929_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_2930_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% le_floor_iff
thf(fact_2931_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_2932_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N ) ) ) ) ).

% floor_power
thf(fact_2933_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_2934_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_2935_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z2: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ).

% ex_le_of_int
thf(fact_2936_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z2: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ).

% ex_of_int_less
thf(fact_2937_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z2: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ).

% ex_less_of_int
thf(fact_2938_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y3: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y3 )
          = ( times_times @ A @ Y3 @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_2939_powr__powr,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_2940_real__of__int__floor__add__one__gt,axiom,
    ! [R3: real] : ( ord_less @ real @ R3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_2941_floor__eq,axiom,
    ! [N: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq
thf(fact_2942_real__of__int__floor__add__one__ge,axiom,
    ! [R3: real] : ( ord_less_eq @ real @ R3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_2943_real__of__int__floor__gt__diff__one,axiom,
    ! [R3: real] : ( ord_less @ real @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_2944_real__of__int__floor__ge__diff__one,axiom,
    ! [R3: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_2945_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X5: A] :
              ( if @ int
              @ ( X5
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X5 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X5 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X5 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_2946_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_2947_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_2948_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I ) @ ( one_one @ A ) ) ) )
               => ( P @ I ) ) ) ) ) ).

% floor_split
thf(fact_2949_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_2950_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_2951_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_2952_floor__eq2,axiom,
    ! [N: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq2
thf(fact_2953_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_2954_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) ) ) ) ).

% floor_mono
thf(fact_2955_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) )
         => ( ord_less @ A @ X @ Y3 ) ) ) ).

% floor_less_cancel
thf(fact_2956_powr__non__neg,axiom,
    ! [A2: real,X: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_2957_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y3 )
         => ( ord_less @ real @ ( powr @ real @ Y3 @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_2958_powr__mono2,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y3 )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y3 @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_2959_powr__ge__pzero,axiom,
    ! [X: real,Y3: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y3 ) ) ).

% powr_ge_pzero
thf(fact_2960_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_2961_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_2962_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_2963_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% floor_le_ceiling
thf(fact_2964_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_2965_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_2966_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_2967_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ Q3 ) @ P4 ) ) ) ).

% floor_divide_lower
thf(fact_2968_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_2969_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_2970_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_2971_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_2972_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_int_mask_eq
thf(fact_2973_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ P4 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) ) ) ) ).

% floor_divide_upper
thf(fact_2974_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y3 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y3 @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_2975_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y3 )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y3 @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_2976_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y3 ) ) ) ) ).

% le_floor_add
thf(fact_2977_powr__inj,axiom,
    ! [A2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y3 ) )
          = ( X = Y3 ) ) ) ) ).

% powr_inj
thf(fact_2978_gr__one__powr,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y3 ) ) ) ) ).

% gr_one_powr
thf(fact_2979_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_2980_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y3 )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y3 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_2981_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_2982_powr__divide,axiom,
    ! [X: real,Y3: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y3 ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y3 @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_2983_powr__mult,axiom,
    ! [X: real,Y3: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y3 ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y3 @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_2984_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_2985_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_2986_ln__powr,axiom,
    ! [X: real,Y3: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y3 ) )
        = ( times_times @ real @ Y3 @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_2987_log__powr,axiom,
    ! [X: real,B2: real,Y3: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y3 ) )
        = ( times_times @ real @ Y3 @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_2988_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_2989_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_2990_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_2991_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2992_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A,B2: A] :
          ( ( powr @ A @ X @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X @ A2 ) @ ( powr @ A @ X @ B2 ) ) ) ) ).

% powr_add
thf(fact_2993_real__of__int__div4,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_2994_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_2995_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2996_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2997_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_2998_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_2999_powr__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X @ N ) ) ) ).

% powr_realpow
thf(fact_3000_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_3001_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_3002_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_3003_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_3004_less__log__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y3 @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y3 ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_3005_log__less__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y3 )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y3 ) ) ) ) ) ).

% log_less_iff
thf(fact_3006_less__powr__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y3 ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y3 ) ) ) ) ).

% less_powr_iff
thf(fact_3007_powr__less__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y3 ) @ X )
          = ( ord_less @ real @ Y3 @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_3008_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y4: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y4 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y4 @ ( one_one @ int ) ) ) ) )
             => ( Y4 = X3 ) ) ) ) ).

% floor_exists1
thf(fact_3009_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_3010_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R3 ) ) @ ( plus_plus @ A @ R3 @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3011_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_3012_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R3 ) ) @ ( one_one @ A ) ) @ R3 ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3013_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_3014_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_3015_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N2: int,M2: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M2 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_3016_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N2: int,M2: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M2 ) ) ) ) ).

% int_less_real_le
thf(fact_3017_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3018_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3019_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_3020_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_3021_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_3022_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_3023_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_3024_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_3025_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_3026_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_3027_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_3028_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_3029_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_3030_binomial__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_3031_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_3032_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_3033_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_3034_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_3035_powr__mult__base,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y3 ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y3 ) ) ) ) ).

% powr_mult_base
thf(fact_3036_powr__le__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y3 ) @ X )
          = ( ord_less_eq @ real @ Y3 @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_3037_le__powr__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y3 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y3 ) ) ) ) ).

% le_powr_iff
thf(fact_3038_log__le__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y3 )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y3 ) ) ) ) ) ).

% log_le_iff
thf(fact_3039_le__log__iff,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y3 @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y3 ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_3040_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I ) ) )
               => ( P @ I ) ) ) ) ) ).

% ceiling_split
thf(fact_3041_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3042_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_3043_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_3044_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3045_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_3046_real__of__int__div2,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_3047_real__of__int__div3,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_3048_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_3049_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_3050_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_3051_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_3052_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_3053_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ P4 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ Q3 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3054_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_3055_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_3056_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y3 )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y3 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_3057_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y3 @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y3 ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_3058_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y3 @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y3 ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_3059_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_3060_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R3: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R3 ) @ K ) )
          = ( times_times @ A @ R3 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R3 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_3061_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X5: A,A5: A] :
              ( if @ A
              @ ( X5
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A5 @ ( ln_ln @ A @ X5 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_3062_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) @ P4 ) ) ) ).

% ceiling_divide_lower
thf(fact_3063_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y3 )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y3 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_3064_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3065_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X5: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3066_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_3067_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_3068_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_3069_powr__neg__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_3070_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3071_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_3072_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3073_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3074_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_3075_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_3076_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_3077_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_3078_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_3079_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_3080_binomial__Suc__n,axiom,
    ! [N: nat] :
      ( ( binomial @ ( suc @ N ) @ N )
      = ( suc @ N ) ) ).

% binomial_Suc_n
thf(fact_3081_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_3082_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_3083_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_3084_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) ) ).

% Suc_times_binomial
thf(fact_3085_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_3086_choose__mult__lemma,axiom,
    ! [M: nat,R3: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R3 ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R3 ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R3 ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_3087_binomial__le__pow,axiom,
    ! [R3: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R3 @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R3 ) @ ( power_power @ nat @ N @ R3 ) ) ) ).

% binomial_le_pow
thf(fact_3088_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_3089_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_3090_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_3091_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_3092_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_3093_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_3094_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_3095_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_3096_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_3097_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_3098_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_3099_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y3 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y3 ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y3 ) ) ) ) ).

% round_unique
thf(fact_3100_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_3101_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_3102_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X5: A] : ( ln_ln @ A @ ( plus_plus @ A @ X5 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_3103_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X5: A] : ( ln_ln @ A @ ( plus_plus @ A @ X5 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_3104_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_3105_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_3106_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y3: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y3 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y3 ) ) ) ) ).

% of_real_mult
thf(fact_3107_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_3108_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real,Y3: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y3 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y3 ) ) ) ) ).

% of_real_divide
thf(fact_3109_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y3: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y3 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y3 ) ) ) ) ).

% of_real_add
thf(fact_3110_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N ) ) ) ).

% of_real_power
thf(fact_3111_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_3112_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_3113_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_3114_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_3115_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_3116_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_3117_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_3118_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3119_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3120_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A3: complex,R2: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( exp @ complex @ A3 ) ) ) ).

% complex_exp_exists
thf(fact_3121_complex__eq__cancel__iff2,axiom,
    ! [X: real,Y3: real,Xa: real] :
      ( ( ( complex2 @ X @ Y3 )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X = Xa )
        & ( Y3
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_3122_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X5: real] : ( complex2 @ X5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_3123_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_3124_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y3: real,X: real] :
          ( ( Y3
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y3 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y3 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_3125_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y3 ) ) ) ) ).

% round_mono
thf(fact_3126_complex__of__real__mult__Complex,axiom,
    ! [R3: real,X: real,Y3: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ ( complex2 @ X @ Y3 ) )
      = ( complex2 @ ( times_times @ real @ R3 @ X ) @ ( times_times @ real @ R3 @ Y3 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_3127_Complex__mult__complex__of__real,axiom,
    ! [X: real,Y3: real,R3: real] :
      ( ( times_times @ complex @ ( complex2 @ X @ Y3 ) @ ( real_Vector_of_real @ complex @ R3 ) )
      = ( complex2 @ ( times_times @ real @ X @ R3 ) @ ( times_times @ real @ Y3 @ R3 ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_3128_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_round @ A @ X ) ) ) ).

% floor_le_round
thf(fact_3129_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% ceiling_ge_round
thf(fact_3130_complex__of__real__add__Complex,axiom,
    ! [R3: real,X: real,Y3: real] :
      ( ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ ( complex2 @ X @ Y3 ) )
      = ( complex2 @ ( plus_plus @ real @ R3 @ X ) @ Y3 ) ) ).

% complex_of_real_add_Complex
thf(fact_3131_Complex__add__complex__of__real,axiom,
    ! [X: real,Y3: real,R3: real] :
      ( ( plus_plus @ complex @ ( complex2 @ X @ Y3 ) @ ( real_Vector_of_real @ complex @ R3 ) )
      = ( complex2 @ ( plus_plus @ real @ X @ R3 ) @ Y3 ) ) ).

% Complex_add_complex_of_real
thf(fact_3132_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_3133_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_3134_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_3135_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3136_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3137_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X5: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3138_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X5: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3139_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3140_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X5: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X5 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_3141_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_3142_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_3143_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_3144_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X5: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X5 ) ) @ ( archimedean_ceiling @ A @ X5 ) @ ( archim6421214686448440834_floor @ A @ X5 ) ) ) ) ) ).

% round_altdef
thf(fact_3145_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_3146_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3147_powr__int,axiom,
    ! [X: real,I2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( power_power @ real @ X @ ( nat2 @ I2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I2 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_3148_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3149_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_3150_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_3151_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_3152_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_3153_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_3154_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_3155_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_3156_nat__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N ) )
      = N ) ).

% nat_int
thf(fact_3157_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3158_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_3159_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_3160_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_3161_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_3162_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_3163_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_3164_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3165_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3166_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_3167_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_3168_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_3169_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3170_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_3171_nat__0__iff,axiom,
    ! [I2: int] :
      ( ( ( nat2 @ I2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_3172_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_3173_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_3174_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3175_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3176_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_3177_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_3178_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3179_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R3: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R3 ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R3
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_3180_dvd__sgn__mult__iff,axiom,
    ! [L: int,R3: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R3 ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R3
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_3181_mult__sgn__dvd__iff,axiom,
    ! [L: int,R3: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R3 ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R3
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_3182_sgn__mult__dvd__iff,axiom,
    ! [R3: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R3 ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R3
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_3183_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3184_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_3185_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_3186_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_3187_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_3188_diff__nat__numeral,axiom,
    ! [V: num,V3: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V3 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V3 ) ) ) ) ).

% diff_nat_numeral
thf(fact_3189_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y3: int,X: num,N: nat] :
      ( ( ( nat2 @ Y3 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( Y3
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_3190_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N: nat,Y3: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
        = ( nat2 @ Y3 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
        = Y3 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_3191_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_abs_dvd_iff
thf(fact_3192_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( ( dvd_dvd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_3193_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_3194_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_3195_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_3196_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_3197_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_3198_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_3199_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_3200_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_3201_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_3202_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y3 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y3 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_3203_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_3204_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( sgn_sgn @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_3205_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_3206_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_3207_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_3208_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_3209_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_3210_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_3211_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_3212_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_3213_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I: num] : ( nat2 @ ( numeral_numeral @ int @ I ) ) ) ) ).

% nat_numeral_as_int
thf(fact_3214_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_3215_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_3216_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_3217_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_3218_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K3: A] : ( times_times @ A @ K3 @ ( sgn_sgn @ A @ K3 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_3219_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_3220_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_3221_nat__mono,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ X @ Y3 )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y3 ) ) ) ).

% nat_mono
thf(fact_3222_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L3: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_3223_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_3224_eq__nat__nat__iff,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z6 ) )
          = ( Z = Z6 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_3225_all__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ! [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ! [X5: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
         => ( P3 @ ( nat2 @ X5 ) ) ) ) ) ).

% all_nat
thf(fact_3226_ex__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [X5: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
          & ( P3 @ ( nat2 @ X5 ) ) ) ) ) ).

% ex_nat
thf(fact_3227_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_3228_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_3229_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_3230_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L ) )
     => ( ( divide_divide @ int @ K @ L )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_3231_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_3232_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M2: nat,N2: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M2 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_3233_nat__mask__eq,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% nat_mask_eq
thf(fact_3234_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_3235_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_3236_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_3237_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_3238_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_3239_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3240_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_3241_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_3242_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ R3 @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R3 ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_3243_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_3244_nat__le__iff,axiom,
    ! [X: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_3245_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_3246_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_3247_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_3248_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_3249_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_3250_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_3251_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_3252_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_3253_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_3254_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_3255_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M2: nat,N2: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% and_nat_def
thf(fact_3256_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_3257_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_3258_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X5: A] :
              ( if @ A
              @ ( X5
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X5 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3259_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3260_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R3 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R3 ) ) ) @ R3 ) ) ) ).

% of_nat_floor
thf(fact_3261_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I: int] :
          ( if @ int
          @ ( I
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_3262_fact__div__fact__le__pow,axiom,
    ! [R3: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R3 @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R3 ) ) ) @ ( power_power @ nat @ N @ R3 ) ) ) ).

% fact_div_fact_le_pow
thf(fact_3263_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_3264_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_3265_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_3266_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_3267_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_3268_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_3269_split__nat,axiom,
    ! [P: nat > $o,I2: int] :
      ( ( P @ ( nat2 @ I2 ) )
      = ( ! [N2: nat] :
            ( ( I2
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ( P @ N2 ) )
        & ( ( ord_less @ int @ I2 @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_3270_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_3271_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_3272_nat__add__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z6 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_3273_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_3274_nat__mult__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ).

% nat_mult_distrib
thf(fact_3275_Suc__as__int,axiom,
    ( suc
    = ( ^ [A5: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_3276_nat__diff__distrib,axiom,
    ! [Z6: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
     => ( ( ord_less_eq @ int @ Z6 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z6 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_3277_nat__diff__distrib_H,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
       => ( ( nat2 @ ( minus_minus @ int @ X @ Y3 ) )
          = ( minus_minus @ nat @ ( nat2 @ X ) @ ( nat2 @ Y3 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_3278_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_3279_nat__div__distrib_H,axiom,
    ! [Y3: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y3 ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y3 ) ) ) ) ).

% nat_div_distrib'
thf(fact_3280_nat__div__distrib,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y3 ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y3 ) ) ) ) ).

% nat_div_distrib
thf(fact_3281_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_3282_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_3283_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N ) ) ) ).

% nat_power_eq
thf(fact_3284_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_3285_nat__mod__distrib,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y3 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y3 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_3286_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_3287_floor__eq3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_3288_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_3289_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_3290_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_3291_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_3292_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_3293_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3294_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3295_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L2 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3296_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_3297_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_3298_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_3299_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_3300_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z6 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_3301_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_3302_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_3303_floor__eq4,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_3304_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y3 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y3 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_3305_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_3306_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] : ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K3 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K3 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_3307_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_3308_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M2: nat] :
              ( if @ A
              @ ( M2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_3309_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_3310_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_3311_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_3312_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_3313_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3314_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_3315_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y3 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y3 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y3 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_3316_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_3317_binomial__code,axiom,
    ( binomial
    = ( ^ [N2: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N2 @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ K3 ) @ ( one_one @ nat ) ) @ N2 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_3318_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_3319_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3320_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3321_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_3322_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_3323_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_3324_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_3325_divide__i,axiom,
    ! [X: complex] :
      ( ( divide_divide @ complex @ X @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X ) ) ).

% divide_i
thf(fact_3326_complex__i__mult__minus,axiom,
    ! [X: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X ) )
      = ( uminus_uminus @ complex @ X ) ) ).

% complex_i_mult_minus
thf(fact_3327_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3328_divide__numeral__i,axiom,
    ! [Z: complex,N: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N ) ) ) ).

% divide_numeral_i
thf(fact_3329_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3330_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3331_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3332_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3333_complex__i__not__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( numeral_numeral @ complex @ W ) ) ).

% complex_i_not_numeral
thf(fact_3334_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X5: real] : ( divide_divide @ real @ X5 @ ( abs_abs @ real @ X5 ) ) ) ) ).

% real_sgn_eq
thf(fact_3335_sgn__eq,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [Z5: complex] : ( divide_divide @ complex @ Z5 @ ( real_Vector_of_real @ complex @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) ) ) ) ) ).

% sgn_eq
thf(fact_3336_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3337_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3338_complex__i__not__neg__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_i_not_neg_numeral
thf(fact_3339_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3340_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3341_Complex__eq__i,axiom,
    ! [X: real,Y3: real] :
      ( ( ( complex2 @ X @ Y3 )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y3
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3342_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3343_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3344_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A5: real] :
          ( if @ real
          @ ( A5
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A5 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_3345_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_3346_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A5: nat,B4: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B4 @ A5 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B4 @ ( F3 @ A5 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_3347_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y3: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y3 )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y3 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y3
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_3348_complex__of__real__i,axiom,
    ! [R3: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R3 ) ) ).

% complex_of_real_i
thf(fact_3349_i__complex__of__real,axiom,
    ! [R3: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R3 ) )
      = ( complex2 @ ( zero_zero @ real ) @ R3 ) ) ).

% i_complex_of_real
thf(fact_3350_Complex__eq,axiom,
    ( complex2
    = ( ^ [A5: real,B4: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A5 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% Complex_eq
thf(fact_3351_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R2: real,A3: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A3 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A3 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3352_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3353_cmod__complex__polar,axiom,
    ! [R3: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R3 ) ) ).

% cmod_complex_polar
thf(fact_3354_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_3355_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_3356_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3357_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3358_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3359_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3360_powr__real__of__int,axiom,
    ! [X: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3361_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3362_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3363_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3364_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3365_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3366_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3367_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3368_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3369_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3370_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3371_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_3372_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_3373_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3374_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3375_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3376_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3377_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3378_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3379_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3380_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3381_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3382_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3383_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3384_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3385_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3386_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_3387_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3388_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3389_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_3390_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3391_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3392_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3393_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3394_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3395_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3396_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y3: A,X: A] :
          ( ( ( times_times @ A @ Y3 @ X )
            = ( times_times @ A @ X @ Y3 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y3 ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y3 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3397_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3398_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_3399_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real] :
          ( ( X
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_3400_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3401_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R3: real,X: A] :
          ( ( ord_less_eq @ real @ R3 @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R3 ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3402_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3403_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3404_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3405_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3406_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3407_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3408_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3409_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3410_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3411_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3412_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3413_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3414_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3415_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_3416_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A5 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3417_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3418_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3419_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3420_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3421_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3422_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3423_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X5: real,Y5: real] : ( times_times @ real @ X5 @ ( inverse_inverse @ real @ Y5 ) ) ) ) ).

% divide_real_def
thf(fact_3424_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3425_cis__Arg__unique,axiom,
    ! [Z: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_3426_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3427_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3428_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3429_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3430_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3431_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3432_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3433_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3434_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3435_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3436_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3437_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3438_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3439_inverse__powr,axiom,
    ! [Y3: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y3 ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y3 @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3440_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3441_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3442_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3443_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3444_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3445_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3446_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3447_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3448_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_3449_forall__pos__mono__1,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3450_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_3451_forall__pos__mono,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_3452_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3453_ln__inverse,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_inverse
thf(fact_3454_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3455_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3456_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_3457_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B4: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3458_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3459_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_3460_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3461_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3462_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3463_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3464_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3465_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3466_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3467_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3468_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3469_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3470_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_3471_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_3472_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y3 ) )
          = Y3 ) ) ).

% bit.xor_left_self
thf(fact_3473_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_3474_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_3475_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_3476_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_3477_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3478_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_3479_sinh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sinh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3480_sinh__real__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y3 ) )
      = ( ord_less @ real @ X @ Y3 ) ) ).

% sinh_real_less_iff
thf(fact_3481_sinh__real__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y3 ) )
      = ( ord_less_eq @ real @ X @ Y3 ) ) ).

% sinh_real_le_iff
thf(fact_3482_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3483_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3484_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_pos_iff
thf(fact_3485_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3486_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3487_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_3488_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y3: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y3 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y3 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y3 ) ) ) ) ) ).

% floor_add2
thf(fact_3489_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_3490_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_3491_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_3492_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_3493_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) ) ) ).

% xor_numerals(2)
thf(fact_3494_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) ) ) ).

% xor_numerals(1)
thf(fact_3495_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_3496_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_3497_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_3498_xor__nat__numerals_I2_J,axiom,
    ! [Y3: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y3 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_3499_xor__nat__numerals_I1_J,axiom,
    ! [Y3: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y3 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_3500_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_3501_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_3502_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sinh @ A @ X5 ) @ ( cosh @ A @ X5 ) ) ) ) ) ).

% tanh_def
thf(fact_3503_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_3504_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_3505_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% sinh_plus_cosh
thf(fact_3506_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% cosh_plus_sinh
thf(fact_3507_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_3508_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X @ Y3 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y3 ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y3 ) ) ) ) ) ).

% cosh_add
thf(fact_3509_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X @ Y3 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y3 ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y3 ) ) ) ) ) ).

% sinh_add
thf(fact_3510_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X @ Y3 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y3 ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y3 ) ) ) ) ) ).

% sinh_diff
thf(fact_3511_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X @ Y3 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y3 ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y3 ) ) ) ) ) ).

% cosh_diff
thf(fact_3512_cosh__real__nonzero,axiom,
    ! [X: real] :
      ( ( cosh @ real @ X )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3513_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3514_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_3515_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344971392196577ns_xor @ A @ B4 @ A5 ) ) ) ) ).

% xor.commute
thf(fact_3516_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_3517_sinh__less__cosh__real,axiom,
    ! [X: real] : ( ord_less @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_less_cosh_real
thf(fact_3518_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_3519_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ ( uminus_uminus @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_3520_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( uminus_uminus @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_3521_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_3522_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_3523_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_3524_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3525_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_3526_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_3527_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ Y3 @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y3 ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_3528_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y3 @ Z ) @ X )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y3 @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_3529_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_xor_iff
thf(fact_3530_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( abs_abs @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_3531_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q3: A] :
          ( ( member @ A @ Q3 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z2: int] :
                ( Q3
               != ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% Ints_cases
thf(fact_3532_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q3: A,P: A > $o] :
          ( ( member @ A @ Q3 @ ( ring_1_Ints @ A ) )
         => ( ! [Z2: int] : ( P @ ( ring_1_of_int @ A @ Z2 ) )
           => ( P @ Q3 ) ) ) ) ).

% Ints_induct
thf(fact_3533_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] : ( member @ A @ ( ring_1_of_int @ A @ Z ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_3534_cosh__real__pos,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_pos
thf(fact_3535_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_3536_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y3 ) )
          = ( ord_less_eq @ real @ X @ Y3 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3537_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y3 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y3 ) )
          = ( ord_less_eq @ real @ Y3 @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3538_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3539_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3540_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_3541_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( times_times @ complex @ X5 @ ( inverse_inverse @ complex @ Y5 ) ) ) ) ).

% divide_complex_def
thf(fact_3542_cosh__real__strict__mono,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y3 )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y3 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3543_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y3 ) )
          = ( ord_less @ real @ X @ Y3 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3544_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y3 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y3 ) )
          = ( ord_less @ real @ Y3 @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3545_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3546_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3547_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3548_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3549_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_3550_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_3551_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3552_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_3553_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3554_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3555_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3556_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y3: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y3 @ ( ring_1_Ints @ A ) )
           => ( ( X = Y3 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y3 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3557_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3558_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_3559_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3560_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3561_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3562_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y3 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y3 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y3 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y3 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3563_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3564_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3565_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3566_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M2
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_3567_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3568_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_3569_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_3570_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_3571_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3572_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3573_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3574_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_3575_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3576_psubsetI,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( A4 != B6 )
       => ( ord_less @ ( set @ A ) @ A4 @ B6 ) ) ) ).

% psubsetI
thf(fact_3577_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( uminus_uminus @ ( set @ A ) @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ B6 @ A4 ) ) ).

% Compl_subset_Compl_iff
thf(fact_3578_subsetI,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( member @ A @ X3 @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% subsetI
thf(fact_3579_subset__antisym,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
       => ( A4 = B6 ) ) ) ).

% subset_antisym
thf(fact_3580_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3581_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3582_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3583_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3584_Compl__anti__mono,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B6 ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) ) ).

% Compl_anti_mono
thf(fact_3585_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_3586_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_3587_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_3588_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_3589_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_3590_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3591_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_3592_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_3593_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_3594_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_3595_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_3596_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_3597_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3598_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_3599_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3600_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3601_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_3602_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ) ).

% bit_xor_int_iff
thf(fact_3603_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_3604_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_3605_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_3606_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_3607_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3608_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ? [B3: A] : ( member @ A @ B3 @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_3609_psubset__trans,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ B6 @ C6 )
       => ( ord_less @ ( set @ A ) @ A4 @ C6 ) ) ) ).

% psubset_trans
thf(fact_3610_psubsetD,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B6 ) ) ) ).

% psubsetD
thf(fact_3611_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_3612_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_3613_XOR__lower,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y3 ) ) ) ) ).

% XOR_lower
thf(fact_3614_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_3615_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_3616_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M2: nat,N2: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_3617_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_3618_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_3619_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3620_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M2: nat,N2: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% xor_nat_def
thf(fact_3621_double__diff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B6 @ ( minus_minus @ ( set @ A ) @ C6 @ A4 ) )
          = A4 ) ) ) ).

% double_diff
thf(fact_3622_Diff__subset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) @ A4 ) ).

% Diff_subset
thf(fact_3623_Diff__mono,axiom,
    ! [A: $tType,A4: set @ A,C6: set @ A,D5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_3624_in__mono,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B6 ) ) ) ).

% in_mono
thf(fact_3625_subsetD,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B6 ) ) ) ).

% subsetD
thf(fact_3626_equalityE,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( A4 = B6 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B6 @ A4 ) ) ) ).

% equalityE
thf(fact_3627_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A7 )
           => ( member @ A @ X5 @ B8 ) ) ) ) ).

% subset_eq
thf(fact_3628_equalityD1,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( A4 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% equalityD1
thf(fact_3629_equalityD2,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( A4 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ B6 @ A4 ) ) ).

% equalityD2
thf(fact_3630_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [T4: A] :
            ( ( member @ A @ T4 @ A7 )
           => ( member @ A @ T4 @ B8 ) ) ) ) ).

% subset_iff
thf(fact_3631_subset__refl,axiom,
    ! [A: $tType,A4: set @ A] : ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) ).

% subset_refl
thf(fact_3632_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_3633_subset__trans,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C6 ) ) ) ).

% subset_trans
thf(fact_3634_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y6: set @ A,Z3: set @ A] : ( Y6 = Z3 ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_3635_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X5: A] :
            ( ( P @ X5 )
           => ( Q @ X5 ) ) ) ) ).

% Collect_mono_iff
thf(fact_3636_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
            | ( A7 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_3637_subset__psubset__trans,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ B6 @ C6 )
       => ( ord_less @ ( set @ A ) @ A4 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_3638_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_3639_psubset__subset__trans,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
       => ( ord_less @ ( set @ A ) @ A4 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_3640_psubset__imp__subset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% psubset_imp_subset
thf(fact_3641_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( A7 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_3642_psubsetE,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ord_less_eq @ ( set @ A ) @ B6 @ A4 ) ) ) ).

% psubsetE
thf(fact_3643_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q3 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q3 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3644_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K3: int,L2: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L2 ) ) ) ) ).

% concat_bit_eq
thf(fact_3645_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344971392196577ns_xor @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3646_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_3647_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3648_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3649_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3650_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3651_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3652_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3653_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3654_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3655_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3656_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_int_def
thf(fact_3657_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N2: nat,M2: nat] : ( times_times @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_nat_def
thf(fact_3658_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( times_times @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3659_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 )
         => ~ ! [B3: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B3 ) ) ) ) ).

% exp_dvdE
thf(fact_3660_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3661_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3662_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3663_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A5 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3664_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_3665_XOR__upper,axiom,
    ! [X: int,N: nat,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y3 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_3666_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3667_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3668_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A5 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3669_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3670_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_3671_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L2 )
          @ ( if @ int
            @ ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L2
              @ ( if @ int
                @ ( L2
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_3672_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_3673_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X9: nat > real] :
        ! [J: nat] :
        ? [M8: nat] :
        ! [M2: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M2 )
         => ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N2 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_3674_length__subseqs,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_subseqs
thf(fact_3675_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_3676_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = X ) ) ).

% bit.double_compl
thf(fact_3677_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X )
            = ( bit_ri4277139882892585799ns_not @ A @ Y3 ) )
          = ( X = Y3 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_3678_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y3 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y3 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_3679_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y3 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y3 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_3680_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_3681_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_3682_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_3683_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3684_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3685_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_3686_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_3687_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_3688_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_3689_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_3690_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_3691_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_3692_Re__divide__of__nat,axiom,
    ! [Z: complex,N: nat] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Re_divide_of_nat
thf(fact_3693_Re__divide__of__real,axiom,
    ! [Z: complex,R3: real] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R3 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ R3 ) ) ).

% Re_divide_of_real
thf(fact_3694_Re__sgn,axiom,
    ! [Z: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Re_sgn
thf(fact_3695_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_3696_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3697_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_3698_cos__Arg__i__mult__zero,axiom,
    ! [Y3: complex] :
      ( ( Y3
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y3 )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y3 ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_3699_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_3700_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_3701_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff
thf(fact_3702_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_3703_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_3704_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_3705_nth__equalityI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I3 )
              = ( nth @ A @ Ys @ I3 ) ) )
       => ( Xs2 = Ys ) ) ) ).

% nth_equalityI
thf(fact_3706_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ K )
           => ? [X9: A] : ( P @ I @ X9 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K )
               => ( P @ I @ ( nth @ A @ Xs3 @ I ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_3707_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y6: list @ A,Z3: list @ A] : ( Y6 = Z3 ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I )
                  = ( nth @ A @ Ys3 @ I ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_3708_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_3709_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_3710_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_3711_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_3712_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_3713_plus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y3: complex] :
      ( ( re @ ( plus_plus @ complex @ X @ Y3 ) )
      = ( plus_plus @ real @ ( re @ X ) @ ( re @ Y3 ) ) ) ).

% plus_complex.simps(1)
thf(fact_3714_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_3715_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A5: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_3716_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_3717_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_3718_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_3719_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_3720_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_3721_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_3722_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_3723_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_3724_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_3725_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_3726_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_3727_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_3728_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_3729_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_3730_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_3731_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_3732_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_3733_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3734_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_3735_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_3736_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_3737_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_3738_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_3739_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_3740_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_3741_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3742_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_3743_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M9: nat] :
              ! [M6: nat] :
                ( ( ord_less_eq @ nat @ M9 @ M6 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M9 @ N7 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M6 ) @ ( X8 @ N7 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_3744_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_3745_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X9: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_3746_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_3747_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_3748_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z5: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z5 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z5 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_3749_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_3750_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_3751_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( re @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_3752_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_3753_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_3754_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_3755_Im__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_3756_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_3757_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_3758_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_3759_Im__divide__of__real,axiom,
    ! [Z: complex,R3: real] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R3 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ R3 ) ) ).

% Im_divide_of_real
thf(fact_3760_Im__sgn,axiom,
    ! [Z: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Im_sgn
thf(fact_3761_Re__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N ) )
        = ( power_power @ real @ ( re @ X ) @ N ) ) ) ).

% Re_power_real
thf(fact_3762_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_3763_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_3764_Im__divide__of__nat,axiom,
    ! [Z: complex,N: nat] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Im_divide_of_nat
thf(fact_3765_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_3766_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_3767_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_3768_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_3769_plus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y3: complex] :
      ( ( im @ ( plus_plus @ complex @ X @ Y3 ) )
      = ( plus_plus @ real @ ( im @ X ) @ ( im @ Y3 ) ) ) ).

% plus_complex.simps(2)
thf(fact_3770_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I ) ) ) ) ).

% complex_is_Int_iff
thf(fact_3771_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_3772_times__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y3: complex] :
      ( ( im @ ( times_times @ complex @ X @ Y3 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y3 ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y3 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_3773_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_3774_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_3775_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_3776_cmod__Re__le__iff,axiom,
    ! [X: complex,Y3: complex] :
      ( ( ( im @ X )
        = ( im @ Y3 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y3 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y3 ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_3777_cmod__Im__le__iff,axiom,
    ! [X: complex,Y3: complex] :
      ( ( ( re @ X )
        = ( re @ Y3 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y3 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y3 ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_3778_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y3: complex] :
      ( ( re @ ( times_times @ complex @ X @ Y3 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y3 ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y3 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_3779_plus__complex_Ocode,axiom,
    ( ( plus_plus @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( complex2 @ ( plus_plus @ real @ ( re @ X5 ) @ ( re @ Y5 ) ) @ ( plus_plus @ real @ ( im @ X5 ) @ ( im @ Y5 ) ) ) ) ) ).

% plus_complex.code
thf(fact_3780_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_3781_cmod__le,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_le
thf(fact_3782_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_3783_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_3784_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_3785_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_3786_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X5: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X5 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_3787_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( im @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( re @ Y5 ) ) ) ) ) ) ).

% times_complex.code
thf(fact_3788_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z5: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z5 ) ) ) @ ( cis @ ( im @ Z5 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_3789_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_3790_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_3791_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_3792_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_3793_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_3794_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_3795_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_3796_Re__divide,axiom,
    ! [X: complex,Y3: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y3 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y3 ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y3 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_3797_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_3798_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_3799_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_3800_Im__divide,axiom,
    ! [X: complex,Y3: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y3 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y3 ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y3 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_3801_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_3802_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_3803_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X5: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X5 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X5 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_3804_Im__Reals__divide,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R3 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R3 ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_3805_Re__Reals__divide,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R3 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R3 ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_3806_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_3807__C3_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "3.hyps"(1)
thf(fact_3808_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_3809_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_3810_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_3811_complex__cnj__mult,axiom,
    ! [X: complex,Y3: complex] :
      ( ( cnj @ ( times_times @ complex @ X @ Y3 ) )
      = ( times_times @ complex @ ( cnj @ X ) @ ( cnj @ Y3 ) ) ) ).

% complex_cnj_mult
thf(fact_3812_complex__cnj__divide,axiom,
    ! [X: complex,Y3: complex] :
      ( ( cnj @ ( divide_divide @ complex @ X @ Y3 ) )
      = ( divide_divide @ complex @ ( cnj @ X ) @ ( cnj @ Y3 ) ) ) ).

% complex_cnj_divide
thf(fact_3813_complex__cnj__add,axiom,
    ! [X: complex,Y3: complex] :
      ( ( cnj @ ( plus_plus @ complex @ X @ Y3 ) )
      = ( plus_plus @ complex @ ( cnj @ X ) @ ( cnj @ Y3 ) ) ) ).

% complex_cnj_add
thf(fact_3814_complex__cnj__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( numeral_numeral @ complex @ W ) )
      = ( numeral_numeral @ complex @ W ) ) ).

% complex_cnj_numeral
thf(fact_3815_complex__cnj__neg__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_cnj_neg_numeral
thf(fact_3816_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_3817_Re__divide__Reals,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z @ R3 ) )
        = ( divide_divide @ real @ ( re @ Z ) @ ( re @ R3 ) ) ) ) ).

% Re_divide_Reals
thf(fact_3818_imaginary__eq__real__iff,axiom,
    ! [Y3: complex,X: complex] :
      ( ( member @ complex @ Y3 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y3 )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y3
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_3819_real__eq__imaginary__iff,axiom,
    ! [Y3: complex,X: complex] :
      ( ( member @ complex @ Y3 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y3 ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y3
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_3820_Im__divide__Reals,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z @ R3 ) )
        = ( divide_divide @ real @ ( im @ Z ) @ ( re @ R3 ) ) ) ) ).

% Im_divide_Reals
thf(fact_3821__C3_Ohyps_C_I5_J,axiom,
    ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ summary @ X_12 ) ).

% "3.hyps"(5)
thf(fact_3822_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_3823_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_3824_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_3825_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_3826_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_3827_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_3828_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_3829_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_3830_Complex__in__Reals,axiom,
    ! [X: real] : ( member @ complex @ ( complex2 @ X @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_3831_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_3832_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_3833_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_3834_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z5 @ ( cnj @ Z5 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_3835_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_3836_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_3837_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_3838_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_3839_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_3840_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_3841_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_3842_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_3843_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_3844_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_3845_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_3846_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_3847_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_3848_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A5: complex,B4: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A5 @ ( cnj @ B4 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_3849_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_3850_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X: nat,N: nat] :
      ( ( vEBT_vebt_member @ Tree @ X )
     => ( ( vEBT_invar_vebt @ Tree @ N )
       => ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% member_bound
thf(fact_3851_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_3852_set__n__deg__not__0,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_3853__092_060open_062_092_060forall_062t_092_060in_062set_AtreeList_O_Ainvar__vebt_At_An_092_060close_062,axiom,
    ! [X6: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( vEBT_invar_vebt @ X6 @ na ) ) ).

% \<open>\<forall>t\<in>set treeList. invar_vebt t n\<close>
thf(fact_3854__C3_Ohyps_C_I6_J,axiom,
    ! [X6: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) ) ).

% "3.hyps"(6)
thf(fact_3855_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
       => ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% valid_member_both_member_options
thf(fact_3856_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
        = ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% both_member_options_equiv_member
thf(fact_3857_inthall,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,N: nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X3 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( P @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% inthall
thf(fact_3858_member__correct,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_vebt_member @ T2 @ X )
        = ( member @ nat @ X @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_3859__C3_OIH_C_I1_J,axiom,
    ! [X6: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X6 @ na )
        & ! [Xa2: nat] :
            ( ( ord_less @ nat @ Xa2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ X6 @ Xa2 ) @ Xa2 ) ) ) ) ).

% "3.IH"(1)
thf(fact_3860_subset__code_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ B6 )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
           => ( member @ A @ X5 @ B6 ) ) ) ) ).

% subset_code(1)
thf(fact_3861_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_pos_if_in_set
thf(fact_3862_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X5 ) ) )
      = ( ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( P @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_3863_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,X: A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I3 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_3864_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ I )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_3865_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X3 ) )
       => ( P @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% list_ball_nth
thf(fact_3866_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ ( nth @ A @ Xs2 @ N ) @ ( set2 @ A @ Xs2 ) ) ) ).

% nth_mem
thf(fact_3867__C3_OIH_C_I2_J,axiom,
    ! [X: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ summary @ X ) @ X ) ) ).

% "3.IH"(2)
thf(fact_3868_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N2: nat,TreeList2: list @ vEBT_VEBT,X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X5 @ N2 ) ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) ) ) ).

% in_children_def
thf(fact_3869_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_3870_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_3871_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N )
     => ( Deg = N ) ) ).

% deg_deg_n
thf(fact_3872_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N ) ) @ TreeList3 @ S3 ) ) ) ).

% deg_SUcn_Node
thf(fact_3873_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_3874_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_3875_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) ) ).

% vebt_insert.simps(3)
thf(fact_3876_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_3877_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) ) ).

% vebt_insert.simps(2)
thf(fact_3878_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N )
     => ( ( vEBT_vebt_member @ Tree @ X )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X )
          | ( vEBT_VEBT_membermima @ Tree @ X ) ) ) ) ).

% member_valid_both_member_options
thf(fact_3879_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X ) ) ).

% min_Null_member
thf(fact_3880_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T4: vEBT_VEBT,X5: nat] :
          ( ( vEBT_V5719532721284313246member @ T4 @ X5 )
          | ( vEBT_VEBT_membermima @ T4 @ X5 ) ) ) ) ).

% both_member_options_def
thf(fact_3881_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_1 ) ) ).

% not_min_Null_member
thf(fact_3882_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_3883_inrange,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_3884_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_3885_length__mul__elem,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs2 ) )
         => ( ( size_size @ ( list @ A ) @ X3 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) @ N ) ) ) ).

% length_mul_elem
thf(fact_3886_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_3887_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( N
          = ( one_one @ nat ) )
       => ? [A3: $o,B3: $o] :
            ( T2
            = ( vEBT_Leaf @ A3 @ B3 ) ) ) ) ).

% deg_1_Leafy
thf(fact_3888_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A3: $o,B3: $o] :
          ( T2
          = ( vEBT_Leaf @ A3 @ B3 ) ) ) ).

% deg_1_Leaf
thf(fact_3889_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A5: $o,B4: $o] :
            ( T2
            = ( vEBT_Leaf @ A5 @ B4 ) ) ) ) ).

% deg1Leaf
thf(fact_3890_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y22: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 ) ) ) ).

% VEBT.inject(2)
thf(fact_3891_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_3892_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H2: A,L4: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) )
          = ( ( ( L = L4 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H2 )
              & ~ ( ord_less_eq @ A @ L4 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_3893_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_3894_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_3895_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_3896_VEBT_Oexhaust,axiom,
    ! [Y3: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y3
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y3
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_3897_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_3898_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M2: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N )
            & ( P @ M2 ) ) )
      = ( ? [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X5 ) ) ) ) ).

% ex_nat_less
thf(fact_3899_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M2: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N )
           => ( P @ M2 ) ) )
      = ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X5 ) ) ) ) ).

% all_nat_less
thf(fact_3900_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_3901_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_3902_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_3903_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_3904_vebt__insert_Osimps_I1_J,axiom,
    ! [X: nat,A2: $o,B2: $o] :
      ( ( ( X
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X
         != ( zero_zero @ nat ) )
       => ( ( ( X
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_3905_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_3906_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_3907_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_3908_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_3909_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_3910_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A1: vEBT_VEBT,A22: nat] :
          ( ( ? [A5: $o,B4: $o] :
                ( A1
                = ( vEBT_Leaf @ A5 @ B4 ) )
            & ( A22
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N2: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X5 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A22
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X9 )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N2: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X5 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X9 )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N2: nat,Summary2: vEBT_VEBT,Mi: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X5 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A22
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ! [I: nat] :
                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                 => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X9 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
              & ( ( Mi = Ma2 )
               => ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
              & ( ord_less_eq @ nat @ Mi @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi != Ma2 )
               => ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N2 )
                          = I )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N2 ) ) )
                      & ! [X5: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                              = I )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N2: nat,Summary2: vEBT_VEBT,Mi: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X5 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ! [I: nat] :
                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                 => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X9 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
              & ( ( Mi = Ma2 )
               => ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
              & ( ord_less_eq @ nat @ Mi @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi != Ma2 )
               => ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N2 )
                          = I )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N2 ) ) )
                      & ! [X5: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                              = I )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_3911_mi__eq__ma__no__ch,axiom,
    ! [Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg )
     => ( ( Mi2 = Ma )
       => ( ! [X6: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList ) )
             => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) )
          & ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_3912_insert__simp__mima,axiom,
    ! [X: nat,Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X = Mi2 )
        | ( X = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_3913_mi__ma__2__deg,axiom,
    ! [Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_3914_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi2: nat,Ma: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi2 )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_3915_member__inv,axiom,
    ! [Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi2 )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi2 @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_3916_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi2: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_3917_option_Osize_I4_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X2 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_3918_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_3919_vebt__insert_Osimps_I4_J,axiom,
    ! [V: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V ) ) @ TreeList @ Summary ) @ X )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ X ) ) @ ( suc @ ( suc @ V ) ) @ TreeList @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_3920_vebt__member_Osimps_I3_J,axiom,
    ! [V: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X ) ).

% vebt_member.simps(3)
thf(fact_3921_vebt__member_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X ) ).

% vebt_member.simps(4)
thf(fact_3922_bset_I1_J,axiom,
    ! [D5: int,B6: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X6 )
                & ( Q @ X6 ) )
             => ( ( P @ ( minus_minus @ int @ X6 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X6 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_3923_bset_I2_J,axiom,
    ! [D5: int,B6: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X6 )
                | ( Q @ X6 ) )
             => ( ( P @ ( minus_minus @ int @ X6 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X6 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_3924_aset_I1_J,axiom,
    ! [D5: int,A4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A4 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A4 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X6 )
                & ( Q @ X6 ) )
             => ( ( P @ ( plus_plus @ int @ X6 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X6 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_3925_aset_I2_J,axiom,
    ! [D5: int,A4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A4 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A4 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X6 )
                | ( Q @ X6 ) )
             => ( ( P @ ( plus_plus @ int @ X6 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X6 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_3926_option_Osize__neq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( size_size @ ( option @ A ) @ X )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_3927_bset_I9_J,axiom,
    ! [D2: int,D5: int,B6: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B6 )
                 => ( X6
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X6 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_3928_bset_I10_J,axiom,
    ! [D2: int,D5: int,B6: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B6 )
                 => ( X6
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X6 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_3929_aset_I9_J,axiom,
    ! [D2: int,D5: int,A4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X6
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X6 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_3930_aset_I10_J,axiom,
    ! [D2: int,D5: int,A4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X6
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X6 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_3931_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P @ X3 )
            = ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X9: int] : ( P @ X9 ) )
          = ( ? [X5: int] :
                ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X5 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_3932_aset_I7_J,axiom,
    ! [D5: int,A4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X6
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X6 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X6 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_3933_aset_I5_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A4 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X6 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_3934_aset_I4_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A4 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X6 != T2 )
             => ( ( plus_plus @ int @ X6 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_3935_aset_I3_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A4 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X6 = T2 )
             => ( ( plus_plus @ int @ X6 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_3936_bset_I7_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B6 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X6 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X6 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_3937_bset_I5_J,axiom,
    ! [D5: int,B6: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B6 )
                 => ( X6
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X6 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_3938_bset_I4_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B6 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X6 != T2 )
             => ( ( minus_minus @ int @ X6 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_3939_bset_I3_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B6 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X6 = T2 )
             => ( ( minus_minus @ int @ X6 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_3940_aset_I8_J,axiom,
    ! [D5: int,A4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X6
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X6 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X6 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_3941_aset_I6_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A4 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X6
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X6 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_3942_bset_I8_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B6 )
       => ! [X6: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B6 )
                   => ( X6
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X6 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X6 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_3943_bset_I6_J,axiom,
    ! [D5: int,B6: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X6: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B6 )
                 => ( X6
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X6 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X6 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_3944_cpmi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z4 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ B6 )
                     => ( X3
                       != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X9: int] : ( P @ X9 ) )
              = ( ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X5 ) )
                | ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ B6 )
                        & ( P @ ( plus_plus @ int @ Y5 @ X5 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_3945_cppi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z4 @ X3 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ A4 )
                     => ( X3
                       != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X9: int] : ( P @ X9 ) )
              = ( ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X5 ) )
                | ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ A4 )
                        & ( P @ ( minus_minus @ int @ Y5 @ X5 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_3946_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi2: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X9 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_3947_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi2: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X9 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_3948_invar__vebt_Ocases,axiom,
    ! [A12: vEBT_VEBT,A23: nat] :
      ( ( vEBT_invar_vebt @ A12 @ A23 )
     => ( ( ? [A3: $o,B3: $o] :
              ( A12
              = ( vEBT_Leaf @ A3 @ B3 ) )
         => ( A23
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M3: nat,Deg2: nat] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( A23 = Deg2 )
               => ( ! [X6: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X6 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary3 @ M3 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                     => ( ( M3 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M3 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                           => ~ ! [X6: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M3: nat,Deg2: nat] :
                ( ( A12
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( A23 = Deg2 )
                 => ( ! [X6: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X6 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary3 @ M3 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                       => ( ( M3
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M3 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                             => ~ ! [X6: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M3: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                  ( ( A12
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                 => ( ( A23 = Deg2 )
                   => ( ! [X6: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X6 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary3 @ M3 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                         => ( ( M3 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M3 ) )
                             => ( ! [I4: nat] :
                                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                   => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X9 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                               => ( ( ( Mi3 = Ma3 )
                                   => ! [X6: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                   => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi3 != Ma3 )
                                         => ! [I4: nat] :
                                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                                                    = I4 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                                                & ! [X6: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X6 @ N3 )
                                                        = I4 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X6 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi3 @ X6 )
                                                      & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M3: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                    ( ( A12
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                   => ( ( A23 = Deg2 )
                     => ( ! [X6: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X6 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary3 @ M3 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                           => ( ( M3
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M3 ) )
                               => ( ! [I4: nat] :
                                      ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                     => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X9 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                                 => ( ( ( Mi3 = Ma3 )
                                     => ! [X6: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X6 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                     => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi3 != Ma3 )
                                           => ! [I4: nat] :
                                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                                                      = I4 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                                                  & ! [X6: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X6 @ N3 )
                                                          = I4 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X6 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi3 @ X6 )
                                                        & ( ord_less_eq @ nat @ X6 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_3949_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R3: A,Q3: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R3 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R3 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R3 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ R3 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_3950_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: A,R3: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
          = ( R3
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_3951_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs2: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs2 @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_3952_insert__simp__norm,axiom,
    ! [X: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi2: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less @ nat @ Mi2 @ X )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ ( ord_max @ nat @ X @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_3953_length__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs2 @ I2 @ X ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_list_update
thf(fact_3954_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_3955_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_3956_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_3957_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_3958_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_3959_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_3960_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_3961_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_3962_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_3963_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_3964_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_3965_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_3966_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_3967_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_3968_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_3969_list__update__beyond,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I2 )
     => ( ( list_update @ A @ Xs2 @ I2 @ X )
        = Xs2 ) ) ).

% list_update_beyond
thf(fact_3970_length__product,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs2 @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_3971_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_3972_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_3973_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_3974_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ I2 )
        = X ) ) ).

% nth_list_update_eq
thf(fact_3975_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_3976_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_3977_insert__simp__excp,axiom,
    ! [Mi2: nat,Deg: nat,TreeList: list @ vEBT_VEBT,X: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less @ nat @ X @ Mi2 )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ ( ord_max @ nat @ Mi2 @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_3978_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J2: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ ( nth @ A @ Xs2 @ J2 ) ) @ J2 @ ( nth @ A @ Xs2 @ I2 ) ) )
          = ( set2 @ A @ Xs2 ) ) ) ) ).

% set_swap
thf(fact_3979_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y3 ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y3 @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_3980_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y3: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y3 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y3 ) ) ) ) ).

% of_nat_max
thf(fact_3981_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def
thf(fact_3982_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( ord_max @ A @ X @ Y3 )
            = X ) ) ) ).

% max_absorb1
thf(fact_3983_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_max @ A @ X @ Y3 )
            = Y3 ) ) ) ).

% max_absorb2
thf(fact_3984_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q3 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q3 ) @ ( plus_plus @ nat @ N @ Q3 ) ) ) ).

% nat_add_max_left
thf(fact_3985_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q3 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q3 ) ) ) ).

% nat_add_max_right
thf(fact_3986_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q3 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q3 ) ) ) ).

% nat_mult_max_right
thf(fact_3987_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q3 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q3 ) @ ( times_times @ nat @ N @ Q3 ) ) ) ).

% nat_mult_max_left
thf(fact_3988_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y3 ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y3 @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_3989_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y3 @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_3990_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y3: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X @ Y3 ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y3 ) ) ) ) ).

% of_int_max
thf(fact_3991_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_3992_set__update__subsetI,axiom,
    ! [A: $tType,Xs2: list @ A,A4: set @ A,X: A,I2: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) ) @ A4 ) ) ) ).

% set_update_subsetI
thf(fact_3993_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,Deg3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_3994_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M3: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) )
           => ( ! [M3: num,N3: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M3: num,N3: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M3: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) )
                 => ( ! [M3: num,N3: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M3: num,N3: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_3995_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs2 @ N @ X ) ) ) ) ).

% set_update_memI
thf(fact_3996_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J2: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( I2 = J2 )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ J2 )
            = X ) )
        & ( ( I2 != J2 )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ J2 )
            = ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ).

% nth_list_update
thf(fact_3997_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( list_update @ A @ Xs2 @ I2 @ X )
          = Xs2 )
        = ( ( nth @ A @ Xs2 @ I2 )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_3998_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A3: $o,B3: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ X3 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ X3 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_3999_vebt__insert_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A3: $o,B3: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ X3 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ X3 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ X3 ) )
         => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) @ X3 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ X3 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_4000_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X3 ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ X3 ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ X3 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_4001_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A3: $o,B3: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ X3 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X3 ) )
       => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X3 ) )
         => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X3 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ X3 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_4002_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y3 ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            & ( ord_less @ A @ Y3 @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_4003_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4004_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_4005_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_4006_max__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q3 )
      = Q3 ) ).

% max_enat_simps(3)
thf(fact_4007_max__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ Q3 @ ( zero_zero @ extended_enat ) )
      = Q3 ) ).

% max_enat_simps(2)
thf(fact_4008_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_4009_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_4010_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_4011_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_4012_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% max.absorb_iff2
thf(fact_4013_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% max.absorb_iff1
thf(fact_4014_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X @ Y3 ) )
          = ( ( ord_less_eq @ A @ Z @ X )
            | ( ord_less_eq @ A @ Z @ Y3 ) ) ) ) ).

% le_max_iff_disj
thf(fact_4015_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_4016_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_4017_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( ord_max @ A @ A5 @ B4 ) ) ) ) ) ).

% max.order_iff
thf(fact_4018_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_4019_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_4020_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_4021_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4022_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4023_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4024_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4025_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( ord_max @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4026_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4027_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X @ Y3 ) )
          = ( ( ord_less @ A @ Z @ X )
            | ( ord_less @ A @ Z @ Y3 ) ) ) ) ).

% less_max_iff_disj
thf(fact_4028_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_4029_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_4030_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R3 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_4031_Divides_Oadjust__div__eq,axiom,
    ! [Q3: int,R3: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
      = ( plus_plus @ int @ Q3
        @ ( zero_neq_one_of_bool @ int
          @ ( R3
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_4032_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_4033_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_4034_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_4035_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_4036_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_4037_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_4038_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_4039_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_4040_unique__remainder,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( R3 = R4 ) ) ) ).

% unique_remainder
thf(fact_4041_unique__quotient,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( Q3 = Q5 ) ) ) ).

% unique_quotient
thf(fact_4042_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_4043_div__int__unique,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q3 ) ) ).

% div_int_unique
thf(fact_4044_mod__int__unique,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( modulo_modulo @ int @ K @ L )
        = R3 ) ) ).

% mod_int_unique
thf(fact_4045_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q3: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q3 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_4046_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_4047_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M2: num,N2: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% divmod_int_def
thf(fact_4048_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M2: num,N2: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ) ).

% divmod_def
thf(fact_4049_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M2: num,N2: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_4050_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R3
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q3 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q3 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R3 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_4051_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q3 ) @ R3 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
            & ( ord_less @ int @ R3 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R3 )
                & ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q3
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_4052_eucl__rel__int__remainderI,axiom,
    ! [R3: int,L: int,K: int,Q3: int] :
      ( ( ( sgn_sgn @ int @ R3 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R3 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q3 @ L ) @ R3 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4053_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A1: int,A22: int,A32: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A1 = K3 )
              & ( A22
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L2: int,K3: int,Q4: int] :
              ( ( A1 = K3 )
              & ( A22 = L2 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L2
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q4 @ L2 ) ) )
          | ? [R5: int,L2: int,K3: int,Q4: int] :
              ( ( A1 = K3 )
              & ( A22 = L2 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L2 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L2 ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L2 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4054_eucl__rel__int_Ocases,axiom,
    ! [A12: int,A23: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A12 @ A23 @ A33 )
     => ( ( ( A23
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A12 ) ) )
       => ( ! [Q2: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) )
             => ( ( A23
                 != ( zero_zero @ int ) )
               => ( A12
                 != ( times_times @ int @ Q2 @ A23 ) ) ) )
         => ~ ! [R2: int,Q2: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q2 @ R2 ) )
               => ( ( ( sgn_sgn @ int @ R2 )
                    = ( sgn_sgn @ int @ A23 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ A23 ) )
                   => ( A12
                     != ( plus_plus @ int @ ( times_times @ int @ Q2 @ A23 ) @ R2 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4055_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M2: num,N2: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M2 @ N2 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M2 ) ) @ ( unique1321980374590559556d_step @ A @ N2 @ ( unique8689654367752047608divmod @ A @ M2 @ ( bit0 @ N2 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_4056_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R3 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_4057_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4058_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X2: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X2 ) )
      = ( plus_plus @ nat @ ( X @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_4059_vebt__insert_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa )
        = Y3 )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => ( Y3
                    = ( vEBT_Leaf @ $true @ B3 ) ) )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => ( Y3
                        = ( vEBT_Leaf @ A3 @ $true ) ) )
                    & ( ( Xa
                       != ( one_one @ nat ) )
                     => ( Y3
                        = ( vEBT_Leaf @ A3 @ B3 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
             => ( Y3
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
               => ( Y3
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) ) )
           => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                 => ( Y3
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y3
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa = Mi3 )
                              | ( Xa = Ma3 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Xa @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_4060_buildup__gives__empty,axiom,
    ! [N: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_4061_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T4: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T4 ) ) ) ) ).

% set_vebt'_def
thf(fact_4062_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X5: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_4063_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4064_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4065_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_4066_empty__subsetI,axiom,
    ! [A: $tType,A4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) ).

% empty_subsetI
thf(fact_4067_subset__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_4068_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4069_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4070_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% max_bot
thf(fact_4071_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% max_bot2
thf(fact_4072_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4073_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4074_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4075_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4076_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4077_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A4 @ B6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% Diff_eq_empty_iff
thf(fact_4078_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4079_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4080_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4081_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4082_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y3 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y3 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4083_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y3 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y3 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4084_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4085_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) ) ) ).

% or_numerals(2)
thf(fact_4086_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_4087_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4088_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4089_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4090_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) ) ) ).

% or_numerals(1)
thf(fact_4091_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_4092_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4093_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4094_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4095_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4096_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4097_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4098_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y3 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y3 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4099_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def_raw
thf(fact_4100_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T4: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T4 ) ) ) ) ).

% set_vebt_def
thf(fact_4101_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_4102_not__psubset__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_4103_bit__or__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_or_int_iff
thf(fact_4104_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se1065995026697491101ons_or @ A @ Y3 @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y3 ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4105_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_se5824344872417868541ns_and @ A @ Y3 @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y3 ) @ ( bit_se1065995026697491101ons_or @ A @ X @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4106_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y3 @ Z ) @ X )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y3 @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4107_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y3: A,Z: A,X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y3 @ Z ) @ X )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y3 @ X ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4108_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_or_iff
thf(fact_4109_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4110_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_4111_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_4112_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X5: A] : ( times_times @ A @ X5 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_4113_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X5: A] : X5 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_4114_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X5: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_4115_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4116_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se1065995026697491101ons_or @ A @ B4 @ A5 ) ) ) ) ).

% or.commute
thf(fact_4117_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4118_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_4119_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4120_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4121_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_4122_Collect__subset,axiom,
    ! [A: $tType,A4: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X5: A] :
            ( ( member @ A @ X5 @ A4 )
            & ( P @ X5 ) ) )
      @ A4 ) ).

% Collect_subset
thf(fact_4123_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X5: A] : ( member @ A @ X5 @ A7 )
            @ ^ [X5: A] : ( member @ A @ X5 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_4124_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X5: A] : ( member @ A @ X5 @ A7 )
            @ ^ [X5: A] : ( member @ A @ X5 @ B8 ) ) ) ) ).

% less_set_def
thf(fact_4125_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_4126_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4127_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4128_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4129_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_leq_as_int
thf(fact_4130_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_less_as_int
thf(fact_4131_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_4132_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_4133_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_4134_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_4135_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4136_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4137_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_4138_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4139_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_4140_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ( minus_minus @ A @ X @ Y3 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% diff_shunt_var
thf(fact_4141_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_4142_OR__lower,axiom,
    ! [X: int,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y3 ) ) ) ) ).

% OR_lower
thf(fact_4143_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4144_plus__and__or,axiom,
    ! [X: int,Y3: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y3 ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y3 ) )
      = ( plus_plus @ int @ X @ Y3 ) ) ).

% plus_and_or
thf(fact_4145_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4146_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4147_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) ) ) ) ).

% or_int_def
thf(fact_4148_subset__Compl__self__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_4149_diff__nat__eq__if,axiom,
    ! [Z6: int,Z: int] :
      ( ( ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z6 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z6 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4150_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4151_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X5: A,Y5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X5 @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X5 ) @ Y5 ) ) ) ) ) ).

% bit.xor_def
thf(fact_4152_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X5: A,Y5: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X5 @ Y5 ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X5 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4153_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4154_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X5: nat] :
          ( collect @ nat
          @ ^ [N2: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_4155_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L2 ) ) ) ) ).

% xor_int_def
thf(fact_4156_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L2 ) ) ) ) ).

% concat_bit_def
thf(fact_4157_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4158_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ N2 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4159_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4160_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y3: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y3 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y3 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y3 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4161_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4162_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4163_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_4164_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y3: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y3 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y3 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y3 ) ) ) ) ).

% bit.compl_unique
thf(fact_4165_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4166_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4167_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L2: nat] : ( times_times @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ L2 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_4168_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4169_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_4170_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_4171_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4172_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_4173_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4174_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4175_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4176_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi2: nat,Ma: nat,V: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ V ) @ TreeList @ Vc ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_4177_OR__upper,axiom,
    ! [X: int,N: nat,Y3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y3 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_4178_vebt__member_Osimps_I5_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList @ Summary ) @ X )
      = ( ( X != Mi2 )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi2 )
            & ( ~ ( ord_less @ nat @ X @ Mi2 )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_4179_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4180_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y3 )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ( Y3
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y3 )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( Y3
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_4181_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A3 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B3 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_4182_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A3 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B3 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_4183_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A5 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4184_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Mi3: nat,Ma3: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa = Mi3 )
                | ( Xa = Ma3 ) ) )
       => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa = Mi3 )
                  | ( Xa = Ma3 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_4185_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4186_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4187_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4188_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A3 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B3 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
             => ~ ( ( Xa != Mi3 )
                 => ( ( Xa != Ma3 )
                   => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                      & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                       => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                          & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_4189_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_4190_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa = Mi3 )
                  | ( Xa = Ma3 ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa = Mi3 )
                    | ( Xa = Ma3 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_4191_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y3 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y3 )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y3 )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y3
                  = ( ~ ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( Y3
                    = ( ~ ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( Y3
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_4192_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList @ Summary ) @ X )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
          & ~ ( ( X = Mi2 )
              | ( X = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ X @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ Ma ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi2 ) @ Mi2 @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_4193_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A3 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B3 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
         => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_4194_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y3 )
     => ( ! [A3: $o,B3: $o] :
            ( ( X
              = ( vEBT_Leaf @ A3 @ B3 ) )
           => ( Y3
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => Y3 )
         => ( ( ? [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y3 )
           => ( ( ? [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y3 )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y3
                      = ( ~ ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_4195_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_4196_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_4197_vebt__insert_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => ( Y3
                      = ( vEBT_Leaf @ $true @ B3 ) ) )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => ( Y3
                          = ( vEBT_Leaf @ A3 @ $true ) ) )
                      & ( ( Xa
                         != ( one_one @ nat ) )
                       => ( Y3
                          = ( vEBT_Leaf @ A3 @ B3 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
               => ( ( Y3
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ Xa ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                 => ( ( Y3
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ Xa ) ) ) )
             => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Y3
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y3
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa = Mi3 )
                                  | ( Xa = Ma3 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Xa @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_4198_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4199_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_4200_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4201_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_4202_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A4: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( semiring_1_of_nat @ A @ ( F2 @ X5 ) )
            @ A4 ) ) ) ).

% of_nat_prod
thf(fact_4203_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A4: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( ring_1_of_int @ A @ ( F2 @ X5 ) )
            @ A4 ) ) ) ).

% of_int_prod
thf(fact_4204_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_4205_or__nat__numerals_I2_J,axiom,
    ! [Y3: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) ) ).

% or_nat_numerals(2)
thf(fact_4206_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4207_or__nat__numerals_I1_J,axiom,
    ! [Y3: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y3 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y3 ) ) ) ).

% or_nat_numerals(1)
thf(fact_4208_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_4209_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4210_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A4: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I: B] : ( modulo_modulo @ A @ ( F2 @ I ) @ A2 )
              @ A4 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_4211_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4212_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A4: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A5: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A5 ) )
            @ A4 ) ) ) ).

% norm_prod_le
thf(fact_4213_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X: A,Q: A > $o] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) ).

% rev_predicate1D
thf(fact_4214_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) ).

% predicate1D
thf(fact_4215_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M2: nat,N2: nat] : ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4216_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_4217_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_4218_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M2: nat,N2: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% or_nat_def
thf(fact_4219_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_4220_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4221_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4222_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4223_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ ( suc @ I ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4224_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( times_times @ A @ ( F2 @ A5 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_4225_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P4 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P4 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4226_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X5: nat] : X5
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4227_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_4228_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4229_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4230_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4231_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_4232_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4233_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4234_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4235_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4236_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4237_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M2
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4238_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A3 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B3 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                       => ( ( Xa != Mi3 )
                         => ( ( Xa != Ma3 )
                           => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                              & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                               => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                  & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_4239_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( Y3
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ~ Y3
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y3
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y3
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y3
                          = ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_4240_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A3 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B3 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_4241_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_4242_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A4: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A4 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X5: B] : ( semiring_1_of_nat @ int @ ( F2 @ X5 ) )
        @ A4 ) ) ).

% int_prod
thf(fact_4243_prod__int__plus__eq,axiom,
    ! [I2: nat,J2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I2 @ ( plus_plus @ nat @ I2 @ J2 ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X5: int] : X5
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I2 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I2 @ J2 ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4244_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_4245_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A3: $o,B3: $o] :
              ( ( X
                = ( vEBT_Leaf @ A3 @ B3 ) )
             => ( ( Y3
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A3 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B3 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A3 @ B3 ) @ Xa ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y3
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( Y3
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_4246_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
                   => ( ( Xa = Mi3 )
                      | ( Xa = Ma3 ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                     => ( ( Xa = Mi3 )
                        | ( Xa = Ma3 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_4247_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y3
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y3
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y3
                      = ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y3
                        = ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( Y3
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_4248_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
               => ~ ( ( Xa = Mi3 )
                    | ( Xa = Ma3 ) ) ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                 => ~ ( ( Xa = Mi3 )
                      | ( Xa = Ma3 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_4249_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_4250_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_4251_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_4252_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_4253_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_4254_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N2: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_4255_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4256_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_4257_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I2: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I2 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_4258_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N2: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_4259_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_4260_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_4261_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_4262_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_4263_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_4264_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_4265_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_4266_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_4267_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_4268_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_4269_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N5: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_4270_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_4271_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_4272_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_Suc_iff
thf(fact_4273_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_4274_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_add
thf(fact_4275_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_4276_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_4277_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_mult
thf(fact_4278_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_4279_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_4280_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_4281_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N2: nat] :
                    ( ( F2 @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_4282_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_4283_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_zero_power'
thf(fact_4284_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_0_powser
thf(fact_4285_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_4286_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_4287_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N2 @ M ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_4288_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_4289_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_4290_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs
thf(fact_4291_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_4292_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_4293_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_4294_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_4295_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_4296_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm
thf(fact_4297_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N5: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N5 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4298_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ).

% powser_inside
thf(fact_4299_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp
thf(fact_4300_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_4301_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_4302_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R3: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( ( summable @ A @ F2 )
           => ? [N9: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N7 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I: nat] : ( F2 @ ( plus_plus @ nat @ I @ N7 ) ) ) )
                  @ R3 ) ) ) ) ) ).

% suminf_exist_split
thf(fact_4303_summable__power__series,axiom,
    ! [F2: nat > real,Z: real] :
      ( ! [I3: nat] : ( ord_less_eq @ real @ ( F2 @ I3 ) @ ( one_one @ real ) )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I: nat] : ( times_times @ real @ ( F2 @ I ) @ ( power_power @ real @ Z @ I ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_4304_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R3: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R3 )
         => ( ( ord_less @ real @ R3 @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R3 @ N2 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_4305_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N5: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_4306_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ ( G @ X5 ) @ ( H2 @ X5 ) )
            @ A4 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A4 ) ) ) ) ).

% prod.distrib
thf(fact_4307_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ A4 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ).

% prod_dividef
thf(fact_4308_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A4: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
            @ A4 ) ) ) ).

% prod_power_distrib
thf(fact_4309_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_nonneg
thf(fact_4310_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ).

% prod_mono
thf(fact_4311_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_pos
thf(fact_4312_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_ge_1
thf(fact_4313_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y3: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y3 )
     => ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y3
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y3
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4314_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4315_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y3: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y3 )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y3
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y3
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_4316_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_4317_intind,axiom,
    ! [A: $tType,I2: nat,N: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X ) @ I2 ) ) ) ) ).

% intind
thf(fact_4318_insert__subset,axiom,
    ! [A: $tType,X: A,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B6 )
      = ( ( member @ A @ X @ B6 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ) ).

% insert_subset
thf(fact_4319_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat,Y3: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N @ Y3 ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y3 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_4320_length__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X ) )
      = N ) ).

% length_replicate
thf(fact_4321_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N2: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_4322_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A4: set @ A,B2: A] :
      ( ( ( insert @ A @ A2 @ A4 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4323_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A4: set @ A] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A4 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4324_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y3: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y3 ) ) )
      = ( ( X = Y3 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_4325_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P @ X5 ) ) )
      = ( ( P @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_4326_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P @ X5 ) ) )
      = ( ( P @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_4327_nth__replicate,axiom,
    ! [A: $tType,I2: nat,N: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X ) @ I2 )
        = X ) ) ).

% nth_replicate
thf(fact_4328_subset__Compl__singleton,axiom,
    ! [A: $tType,A4: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A4 ) ) ) ).

% subset_Compl_singleton
thf(fact_4329_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4330_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_4331_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_4332_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N3: nat] :
              ( ( F2 @ N3 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_4333_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_4334_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_4335_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I2: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I2 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I2 ) ) ) ).

% sums_single
thf(fact_4336_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_4337_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_4338_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4339_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4340_insert__mono,axiom,
    ! [A: $tType,C6: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C6 ) @ ( insert @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_4341_subset__insert,axiom,
    ! [A: $tType,X: A,A4: set @ A,B6: set @ A] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B6 ) )
        = ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ) ).

% subset_insert
thf(fact_4342_subset__insertI,axiom,
    ! [A: $tType,B6: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B6 @ ( insert @ A @ A2 @ B6 ) ) ).

% subset_insertI
thf(fact_4343_subset__insertI2,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B2 @ B6 ) ) ) ).

% subset_insertI2
thf(fact_4344_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_4345_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_4346_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4347_subset__singletonD,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( A4
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4348_replicate__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = N )
     => ( ! [Y: A] :
            ( ( member @ A @ Y @ ( set2 @ A @ Xs2 ) )
           => ( Y = X ) )
       => ( Xs2
          = ( replicate @ A @ N @ X ) ) ) ) ).

% replicate_eqI
thf(fact_4349_replicate__length__same,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
         => ( X3 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ X )
        = Xs2 ) ) ).

% replicate_length_same
thf(fact_4350_subset__Diff__insert,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,X: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B6 @ ( insert @ A @ X @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B6 @ C6 ) )
        & ~ ( member @ A @ X @ A4 ) ) ) ).

% subset_Diff_insert
thf(fact_4351_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_4352_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
              @ S )
           => ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_4353_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_4354_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_4355_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F2: nat > A,S: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ N )
             => ( ( F2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I: nat] : ( F2 @ ( plus_plus @ nat @ I @ N ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_4356_Diff__single__insert,axiom,
    ! [A: $tType,A4: set @ A,X: A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B6 ) ) ) ).

% Diff_single_insert
thf(fact_4357_subset__insert__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B6 ) )
      = ( ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 ) )
        & ( ~ ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% subset_insert_iff
thf(fact_4358_set__update__subset__insert,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) ) @ ( insert @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% set_update_subset_insert
thf(fact_4359_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( if @ A @ ( N2 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N2 ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_4360_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_4361_psubset__insert__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B6 ) )
      = ( ( ( member @ A @ X @ B6 )
         => ( ord_less @ ( set @ A ) @ A4 @ B6 ) )
        & ( ~ ( member @ A @ X @ B6 )
         => ( ( ( member @ A @ X @ A4 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 ) )
            & ( ~ ( member @ A @ X @ A4 )
             => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4362_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4363_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I: int,J: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J @ I ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ) ).

% simp_from_to
thf(fact_4364_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4365_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_4366_power__half__series,axiom,
    ( sums @ real
    @ ^ [N2: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N2 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_4367_sums__if_H,axiom,
    ! [G: nat > real,X: real] :
      ( ( sums @ real @ G @ X )
     => ( sums @ real
        @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_4368_sums__if,axiom,
    ! [G: nat > real,X: real,F2: nat > real,Y3: real] :
      ( ( sums @ real @ G @ X )
     => ( ( sums @ real @ F2 @ Y3 )
       => ( sums @ real
          @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( F2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y3 ) ) ) ) ).

% sums_if
thf(fact_4369_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_4370_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_4371_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_4372_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( C2 @ N2 ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_4373_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4374_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y3: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y3
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y3
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_4375_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4376_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_4377_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A4 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4378_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A4: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : ( semiring_1_of_nat @ A @ ( F2 @ X5 ) )
            @ A4 ) ) ) ).

% of_nat_sum
thf(fact_4379_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A4: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : ( ring_1_of_int @ A @ ( F2 @ X5 ) )
            @ A4 ) ) ) ).

% of_int_sum
thf(fact_4380_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4381_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A4: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] : ( abs_abs @ B @ ( F2 @ I ) )
            @ A4 ) ) ) ).

% sum_abs
thf(fact_4382_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A4: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] : ( abs_abs @ B @ ( F2 @ I ) )
            @ A4 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4383_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4384_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I ) )
            @ A4 ) ) ) ).

% norm_sum
thf(fact_4385_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,G: B > real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S2 ) ) ) ) ).

% sum_norm_le
thf(fact_4386_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A4: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I: B] : ( modulo_modulo @ A @ ( F2 @ I ) @ A2 )
              @ A4 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_4387_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R3: A,F2: B > A,A4: set @ B] :
          ( ( times_times @ A @ R3 @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ R3 @ ( F2 @ N2 ) )
            @ A4 ) ) ) ).

% sum_distrib_left
thf(fact_4388_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A4: set @ B,R3: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ R3 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ ( F2 @ N2 ) @ R3 )
            @ A4 ) ) ) ).

% sum_distrib_right
thf(fact_4389_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A4: set @ A,G: C > B,B6: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B6 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J: C] : ( times_times @ B @ ( F2 @ I ) @ ( G @ J ) )
                @ B6 )
            @ A4 ) ) ) ).

% sum_product
thf(fact_4390_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : ( plus_plus @ A @ ( G @ X5 ) @ ( H2 @ X5 ) )
            @ A4 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A4 ) ) ) ) ).

% sum.distrib
thf(fact_4391_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A4: set @ B,R3: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ R3 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( divide_divide @ A @ ( F2 @ N2 ) @ R3 )
            @ A4 ) ) ) ).

% sum_divide_distrib
thf(fact_4392_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A4: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
           != ( zero_zero @ A ) )
         => ~ ! [A3: B] :
                ( ( member @ B @ A3 @ A4 )
               => ( ( G @ A3 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4393_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ( G @ X3 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4394_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_4395_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) ) ) ) ).

% sum_nonneg
thf(fact_4396_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4397_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 )
         => ( ! [X3: nat] :
                ( ( member @ nat @ ( suc @ X3 ) @ A4 )
               => ( ( F2 @ ( suc @ X3 ) )
                  = ( G @ ( suc @ X3 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A4 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A4 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4398_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_4399_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_4400_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4401_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4402_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4403_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4404_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_4405_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_4406_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4407_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4408_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4409_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4410_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( C4 @ ( suc @ N2 ) ) ) ) ) ) ).

% diffs_def
thf(fact_4411_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ ( suc @ I ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4412_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I ) ) @ ( F2 @ I ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4413_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( plus_plus @ A @ ( F2 @ A5 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4414_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X3: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_4415_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P4 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P4 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4416_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I5 )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I: A] : ( times_times @ B @ ( A2 @ I ) @ ( X @ I ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4417_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4418_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4419_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E2: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N9: nat] :
                  ~ ! [M6: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M6 )
                     => ! [N7: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M6 @ N7 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4420_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z ) )
        = ( insert @ nat @ N @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4421_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4422_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4423_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_4424_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K5 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 )
               => ( summable @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_4425_and__int_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [K2: int,L3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L3 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L3 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% and_int.pinduct
thf(fact_4426_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4427_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4428_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4429_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_4430_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4431_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4432_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4433_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4434_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4435_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4436_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4437_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4438_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R3: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R3 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R3 @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4439_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less @ real @ T3 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4440_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T3: real] :
            ( ( ord_less @ real @ X @ T3 )
            & ( ord_less @ real @ T3 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4441_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less @ real @ T3 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4442_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
          & ( ord_less_eq @ real @ T3 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4443_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I2 @ K ) ) ) ).

% lessThan_iff
thf(fact_4444_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y3 ) )
          = ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% lessThan_subset_iff
thf(fact_4445_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4446_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_4447_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_4448_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M2 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4449_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_4450_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X3: A] : ( ord_less_eq @ nat @ ( Q @ X3 ) @ ( P @ X3 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X5: A] : ( minus_minus @ nat @ ( P @ X5 ) @ ( Q @ X5 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4451_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A4: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X5: B] : ( semiring_1_of_nat @ int @ ( F2 @ X5 ) )
        @ A4 ) ) ).

% int_sum
thf(fact_4452_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X5: A] : ( complex2 @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
        @ S )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4453_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X5: A] : ( ord_less @ A @ X5 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_4454_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_4455_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4456_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4457_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A4: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A5: B] : ( power_power @ A @ C2 @ ( F2 @ A5 ) )
            @ A4 ) ) ) ).

% power_sum
thf(fact_4458_sum__subtractf__nat,axiom,
    ! [A: $tType,A4: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ord_less_eq @ nat @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X5: A] : ( minus_minus @ nat @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ A4 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A4 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4459_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A4: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
        = ( suc @ N ) )
     => ? [X3: A] :
          ( ( member @ A @ X3 @ A4 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ).

% sum_SucD
thf(fact_4460_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_4461_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_4462_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_4463_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4464_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N: nat,R3: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R3 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ ( F2 @ I ) @ R3 )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4465_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4466_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4467_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4468_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4469_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4470_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I: nat] : ( F2 @ ( plus_plus @ nat @ I @ N ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_4471_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I: nat] : ( F2 @ ( plus_plus @ nat @ I @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) )
          = ( sums @ A @ F2 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_4472_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A,N: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( sums @ A
            @ ^ [I: nat] : ( F2 @ ( plus_plus @ nat @ I @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_4473_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4474_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( F2 @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_4475_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X5: complex] : X5
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4476_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I6,Z: I6 > A,W: I6 > A] :
          ( ! [I3: I6] :
              ( ( member @ I6 @ I3 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I3 ) ) @ ( one_one @ real ) ) )
         => ( ! [I3: I6] :
                ( ( member @ I6 @ I3 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I3 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I6 @ A @ Z @ I5 ) @ ( groups7121269368397514597t_prod @ I6 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I6 @ real
                @ ^ [I: I6] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I ) @ ( W @ I ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4477_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4478_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4479_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4480_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_4481_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_4482_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X5: complex] : X5
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4483_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M3: nat] :
                ( ( ord_less_eq @ nat @ N @ M3 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M3 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4484_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4485_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z @ P6 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P6 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P6 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4486_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y3: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y3 @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y3 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X @ P6 ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ N @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4487_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y3: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y3 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y3 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ N @ ( suc @ I ) ) ) @ ( power_power @ A @ X @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4488_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4489_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M3: nat] :
                ( ( ord_less_eq @ nat @ N @ M3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M3 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4490_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4491_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4492_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J2: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J2 @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H2 @ M2 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4493_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( F2 @ I ) @ ( G @ I ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_4494_Maclaurin__exp__le,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4495_Maclaurin__sin__bound,axiom,
    ! [X: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4496_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X5: int] : X5
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4497_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4498_Maclaurin__exp__lt,axiom,
    ! [X: real,N: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T3 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4499_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z: A,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P6: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P6 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4500_Maclaurin__sin__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4501_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4502_Maclaurin__cos__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4503_upto_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [I3: int,J3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J3 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) )
             => ( P @ I3 @ J3 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% upto.pinduct
thf(fact_4504_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4505_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4506_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_4507_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I2 @ K ) ) ) ).

% atMost_iff
thf(fact_4508_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y3 ) )
          = ( ord_less_eq @ A @ X @ Y3 ) ) ) ).

% atMost_subset_iff
thf(fact_4509_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_4510_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_4511_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_4512_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4513_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X5: A] : ( ord_less_eq @ A @ X5 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_4514_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4515_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_4516_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_4517_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L4: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_4518_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4519_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4520_sum__choose__upper,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ K3 @ M )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ N ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_4521_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_4522_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ ( F2 @ I ) @ ( F2 @ ( suc @ I ) ) )
            @ ( set_ord_atMost @ nat @ I2 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I2 ) ) ) ) ) ).

% sum_telescope
thf(fact_4523_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X5 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( D2 @ I ) @ ( power_power @ A @ X5 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
               => ( ( C2 @ I )
                  = ( D2 @ I ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_4524_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B6: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B6 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_4525_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4526_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I ) @ ( set_ord_lessThan @ nat @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nested_swap'
thf(fact_4527_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I ) @ ( set_ord_lessThan @ nat @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nested_swap'
thf(fact_4528_sum__choose__lower,axiom,
    ! [R3: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ ( plus_plus @ nat @ R3 @ K3 ) @ K3 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R3 @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_4529_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J: nat] : ( binomial @ ( plus_plus @ nat @ N @ J ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_4530_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J: nat] : ( binomial @ ( plus_plus @ nat @ N @ J ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_4531_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ W2 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_4532_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X5 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
               => ( ( C2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_4533_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4534_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_4535_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( G @ ( suc @ I ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4536_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4537_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4538_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N @ K3 ) @ ( minus_minus @ nat @ M @ K3 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4539_vandermonde,axiom,
    ! [M: nat,N: nat,R3: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( binomial @ M @ K3 ) @ ( binomial @ N @ ( minus_minus @ nat @ R3 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ R3 ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N ) @ R3 ) ) ).

% vandermonde
thf(fact_4540_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4541_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ A2 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B3: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( B3 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4542_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B3: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( B3 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ A2 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4543_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4544_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( summable @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_4545_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_4546_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I ) ) )
                    @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_4547_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K3 ) ) @ ( power_power @ nat @ A2 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_4548_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4549_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ M @ I3 )
             => ( ( A2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ! [J3: nat] :
                ( ( ord_less @ nat @ N @ J3 )
               => ( ( B2 @ J3 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X @ I ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J: nat] : ( times_times @ A @ ( B2 @ J ) @ ( power_power @ A @ X @ J ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4550_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4551_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X5 @ I ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X5: nat] :
                ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X5 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4552_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4553_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( power_power @ A @ A2 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_4554_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4555_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X: nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ M @ I3 )
         => ( ( A2 @ I3 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J3: nat] :
            ( ( ord_less @ nat @ N @ J3 )
           => ( ( B2 @ J3 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I: nat] : ( times_times @ nat @ ( A2 @ I ) @ ( power_power @ nat @ X @ I ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J: nat] : ( times_times @ nat @ ( B2 @ J ) @ ( power_power @ nat @ X @ J ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4556_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_4557_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( sums @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_4558_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( if @ A @ ( J = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( H2 @ J ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4559_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( if @ A @ ( J = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( H2 @ J ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4560_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y3: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4561_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4562_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4563_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I ) @ ( semiring_1_of_nat @ A @ I ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4564_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4565_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y3: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A2 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4566_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y3: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y3 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y3 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y3 @ K3 ) ) @ ( power_power @ A @ X @ J ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4567_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4568_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I: nat] : ( times_times @ nat @ I @ ( binomial @ N @ I ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4569_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4570_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M9: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M9 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z4 @ I ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4571_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y3: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ X @ I ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y3 @ I ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y3 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( A2 @ I ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J ) @ N ) )
                    @ ( power_power @ A @ X @ J ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4572_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4573_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_4574_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ P6 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y3 ) ) ) ) ).

% sin_x_sin_y
thf(fact_4575_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ P6 @ N2 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y3 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_4576_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y3: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ P6 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y3 ) ) ) ) ).

% cos_x_cos_y
thf(fact_4577_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X9: nat > A] :
              ( ! [M2: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M2 @ N2 )
                 => ( ord_less_eq @ A @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) )
              | ! [M2: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M2 @ N2 )
                 => ( ord_less_eq @ A @ ( X9 @ N2 ) @ ( X9 @ M2 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_4578_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N2: nat] : N2 ) ) ).

% of_nat_id
thf(fact_4579_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( ( A2 = B2 )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_4580_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_4581_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X: A,A2: real,Y3: A] :
          ( ( times_times @ A @ X @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y3 ) ) ) ) ).

% mult_scaleR_right
thf(fact_4582_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X: A,Y3: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ Y3 )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y3 ) ) ) ) ).

% mult_scaleR_left
thf(fact_4583_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y3: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) )
          = ( ( X = Y3 )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_4584_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) ).

% scaleR_scaleR
thf(fact_4585_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_4586_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_4587_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_4588_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y3: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y3 ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N ) @ ( power_power @ A @ Y3 @ N ) ) ) ) ).

% scaleR_power
thf(fact_4589_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_4590_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_scaleR
thf(fact_4591_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_4592_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_4593_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_4594_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_4595_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,A2: real,B2: real] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_4596_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y3 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_4597_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y3: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) )
           => ( X = Y3 ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_4598_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_4599_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_distrib
thf(fact_4600_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y3: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X @ Y3 ) @ Xa )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y3 @ Xa ) ) ) ) ).

% scaleR_left.add
thf(fact_4601_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_4602_scaleR__complex_Osimps_I1_J,axiom,
    ! [R3: real,X: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R3 @ X ) )
      = ( times_times @ real @ R3 @ ( re @ X ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4603_scaleR__complex_Osimps_I2_J,axiom,
    ! [R3: real,X: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R3 @ X ) )
      = ( times_times @ real @ R3 @ ( im @ X ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_4604_complex__scaleR,axiom,
    ! [R3: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R3 @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R3 @ A2 ) @ ( times_times @ real @ R3 @ B2 ) ) ) ).

% complex_scaleR
thf(fact_4605_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_4606_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_4607_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_4608_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_4609_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_4610_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_4611_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y3: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_4612_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_4613_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_4614_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_4615_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_4616_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_4617_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_4618_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y3: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y3 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_4619_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_4620_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_4621_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_4622_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_4623_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_4624_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_4625_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_4626_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_4627_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_4628_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y3: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y3 )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y3 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_4629_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y3: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y3
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y3 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_4630_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_4631_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_4632_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_4633_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_4634_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_4635_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_4636_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_4637_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_4638_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_4639_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X5: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X5 ) ) @ ( times_times @ real @ R5 @ ( im @ X5 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_4640_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp_generic
thf(fact_4641_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_4642_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) ) ) ) ) ).

% sin_def
thf(fact_4643_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_4644_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) ) ) ) ) ).

% cos_def
thf(fact_4645_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_4646_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_4647_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_4648_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_4649_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_4650_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_4651_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_4652_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_4653_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_4654_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_4655_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_4656_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X5 @ N2 ) ) ) ) ) ) ).

% exp_def
thf(fact_4657_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_4658_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_4659_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_4660_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_4661_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_4662_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y3: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y3 )
            = ( times_times @ A @ Y3 @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y3 ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I ) ) @ ( power_power @ A @ X @ I ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I ) ) ) @ ( power_power @ A @ Y3 @ ( minus_minus @ nat @ N @ I ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4663_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N2 ) ) ) @ ( power_power @ A @ X5 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_4664_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X5: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X5 @ N2 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ K ) ) ) @ ( power_power @ A @ X5 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4665_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_4666_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_4667_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_4668_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_4669_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X9: nat > A] :
              ( ! [N2: nat] : ( ord_less_eq @ A @ ( X9 @ N2 ) @ ( X9 @ ( suc @ N2 ) ) )
              | ! [N2: nat] : ( ord_less_eq @ A @ ( X9 @ ( suc @ N2 ) ) @ ( X9 @ N2 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_4670_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X5 )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X5 @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_4671_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M3: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_4672_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M3: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_4673_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I: A] : ( plus_plus @ A @ I @ ( one_one @ A ) )
              @ N2
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_4674_Arg__def,axiom,
    ( arg
    = ( ^ [Z5: complex] :
          ( if @ real
          @ ( Z5
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A5: real] :
                ( ( ( sgn_sgn @ complex @ Z5 )
                  = ( cis @ A5 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A5 )
                & ( ord_less_eq @ real @ A5 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4675_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_4676_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_4677_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_4678_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_4679_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A4: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A4 )
     => ( ( ? [X9: A] : ( P @ X9 ) )
        = A4 ) ) ).

% verit_sko_ex'
thf(fact_4680_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P2: A > $o] :
          ! [X4: A] : ( P2 @ X4 ) )
      = ( ^ [P3: A > $o] :
            ( P3
            @ ( fChoice @ A
              @ ^ [X5: A] :
                  ~ ( P3 @ X5 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4681_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A4: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X5: A] :
                ~ ( P @ X5 ) ) )
        = A4 )
     => ( ( ! [X9: A] : ( P @ X9 ) )
        = A4 ) ) ).

% verit_sko_forall'
thf(fact_4682_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B6: A,A4: A,P: A > $o] :
      ( ( B6 = A4 )
     => ( ( ( fChoice @ A @ P )
          = A4 )
        = ( ( fChoice @ A @ P )
          = B6 ) ) ) ).

% verit_sko_forall''
thf(fact_4683_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ( ? [X9: A] : ( P @ X9 ) )
        = ( P @ X ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4684_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P5: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ! [X3: A] :
            ( ( P @ X3 )
            = ( P5 @ X3 ) )
       => ( ( ? [X9: A] : ( P5 @ X9 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4685_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X5: A] :
              ~ ( P @ X5 ) ) )
     => ( ( ! [X9: A] : ( P @ X9 ) )
        = ( P @ X ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4686_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P5: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X5: A] :
              ~ ( P @ X5 ) ) )
     => ( ! [X3: A] :
            ( ( P @ X3 )
            = ( P5 @ X3 ) )
       => ( ( ! [X9: A] : ( P5 @ X9 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4687_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_4688_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_4689_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_4690_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_4691_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I2 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I2 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_4692_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I2 )
          = I2 ) ) ).

% of_nat_aux.simps(1)
thf(fact_4693_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_4694_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_4695_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_4696_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_4697_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_4698_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4699_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4700_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4701_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y3: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y3 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y3
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y3
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y3
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y3
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_4702_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4703_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4704_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4705_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4706_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4707_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4708_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4709_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4710_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4711_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4712_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4713_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4714_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4715_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa: num,Y3: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa )
        = Y3 )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y3 != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M3: num] :
                ( ( Xa
                  = ( bit0 @ M3 ) )
               => ( Y3
                 != ( bit1 @ M3 ) ) ) )
         => ( ( ( X = one2 )
             => ! [M3: num] :
                  ( ( Xa
                    = ( bit1 @ M3 ) )
                 => ( Y3
                   != ( bit1 @ M3 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X
                    = ( bit0 @ N3 ) )
               => ( ( Xa = one2 )
                 => ( Y3
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ! [M3: num] :
                        ( ( Xa
                          = ( bit0 @ M3 ) )
                       => ( Y3
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M3: num] :
                          ( ( Xa
                            = ( bit1 @ M3 ) )
                         => ( Y3
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M3 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X
                          = ( bit1 @ N3 ) )
                     => ( ( Xa = one2 )
                       => ( Y3 != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ! [M3: num] :
                              ( ( Xa
                                = ( bit0 @ M3 ) )
                             => ( Y3
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M3: num] :
                                ( ( Xa
                                  = ( bit1 @ M3 ) )
                               => ( Y3
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4716_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4717_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4718_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4719_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_4720_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4721_arctan__def,axiom,
    ( arctan
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
              & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arctan_def
thf(fact_4722_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_4723_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X5: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_4724_arccos__def,axiom,
    ( arccos
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
              & ( ord_less_eq @ real @ X5 @ pi )
              & ( ( cos @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arccos_def
thf(fact_4725_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L2: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L2 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L2 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_4726_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L2: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L2 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L2 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_4727_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X5 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4728_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X5: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X5 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4729_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L2: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L2 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_4730_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
              & ( ord_less_eq @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arcsin_def
thf(fact_4731_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M2: nat,N2: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N2
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M2 @ N2 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M2 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_4732_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs2 ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% set_n_lists
thf(fact_4733_pred__subset__eq,axiom,
    ! [A: $tType,R: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X5: A] : ( member @ A @ X5 @ R )
        @ ^ [X5: A] : ( member @ A @ X5 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R @ S2 ) ) ).

% pred_subset_eq
thf(fact_4734_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ J ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K3 @ I ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_4735_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ J ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K3 @ I ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_4736_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K3 @ I ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_4737_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I: nat,J: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( G @ I @ ( minus_minus @ nat @ K3 @ I ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_4738_subrelI,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X3: A,Y: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ R3 )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S ) ) ).

% subrelI
thf(fact_4739_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ R )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ).

% pred_subset_eq2
thf(fact_4740_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N: nat,Xs2: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs2 ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N ) ) ).

% length_n_lists_elem
thf(fact_4741_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M2: nat,N2: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) ) ).

% divmod_nat_def
thf(fact_4742_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M2: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_4743_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs2 ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% length_n_lists
thf(fact_4744_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4745_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X3: A,Y: B] :
          ( ( P @ X3 @ Y )
         => ( Q @ X3 @ Y ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_4746_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4747_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Y3: B,Q: A > B > $o] :
      ( ( P @ X @ Y3 )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y3 ) ) ) ).

% rev_predicate2D
thf(fact_4748_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X: A,Y3: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y3 )
       => ( Q @ X @ Y3 ) ) ) ).

% predicate2D
thf(fact_4749_accp__subset,axiom,
    ! [A: $tType,R1: A > A > $o,R22: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) ).

% accp_subset
thf(fact_4750_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A4: A > B > $o,B6: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A4 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B6 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_4751_set__encode__insert,axiom,
    ! [A4: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A4 )
     => ( ~ ( member @ nat @ N @ A4 )
       => ( ( nat_set_encode @ ( insert @ nat @ N @ A4 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A4 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4752_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4753_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4754_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F4 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F4 )
              = ( zero_zero @ A ) )
            = ( ! [X5: B] :
                  ( ( member @ B @ X5 @ F4 )
                 => ( ( F2 @ X5 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4755_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 )
              = ( zero_zero @ A ) )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                  & ( ( F2 @ X5 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4756_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4757_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4758_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4759_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4760_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A4 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A4 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4761_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ~ ( member @ B @ X @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4762_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ~ ( member @ B @ X @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4763_prod__pos__nat__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A4 ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ A4 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4764_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) )
                @ A4 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4765_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) ) @ ( D2 @ I ) )
                @ A4 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ ( zero_zero @ A ) @ I ) ) @ ( D2 @ I ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4766_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N2: nat] : ( ord_less_eq @ nat @ ( F2 @ N2 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4767_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M2: nat] :
        ! [X5: nat] :
          ( ( member @ nat @ X5 @ N6 )
         => ( ord_less_eq @ nat @ X5 @ M2 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4768_finite__lists__length__eq,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
              & ( ( size_size @ ( list @ A ) @ Xs3 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4769_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M2: nat] :
        ! [X5: nat] :
          ( ( member @ nat @ X5 @ N6 )
         => ( ord_less @ nat @ X5 @ M2 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4770_bounded__nat__set__is__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ! [X3: nat] :
          ( ( member @ nat @ X3 @ N5 )
         => ( ord_less @ nat @ X3 @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4771_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I2: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I2 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4772_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ X8 )
                    & ( ord_less @ A @ X3 @ Xa2 ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_4773_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ~ ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S2 )
                      & ( ord_less @ A @ Xa2 @ X3 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4774_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I6 > A,I5: set @ I6,G: I6 > A,I2: I6] :
          ( ( ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ I5 )
            = ( groups7311177749621191930dd_sum @ I6 @ A @ G @ I5 ) )
         => ( ! [I3: I6] :
                ( ( member @ I6 @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
           => ( ( member @ I6 @ I2 @ I5 )
             => ( ( finite_finite @ I6 @ I5 )
               => ( ( F2 @ I2 )
                  = ( G @ I2 ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4775_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ? [X6: B] :
                ( ( member @ B @ X6 @ A4 )
                & ( ( F2 @ X6 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4776_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4777_finite__lists__length__le,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4778_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_4779_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X: B > A,Y3: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I: B] :
                  ( ( member @ B @ I @ I5 )
                  & ( ( X @ I )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I5 )
                    & ( ( Y3 @ I )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I5 )
                    & ( ( plus_plus @ A @ ( X @ I ) @ ( Y3 @ I ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4780_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,X: B > A,Y3: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I: B] :
                  ( ( member @ B @ I @ I5 )
                  & ( ( X @ I )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I5 )
                    & ( ( Y3 @ I )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I: B] :
                    ( ( member @ B @ I @ I5 )
                    & ( ( times_times @ A @ ( X @ I ) @ ( Y3 @ I ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4781_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                    & ( P @ X5 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( G @ X5 ) @ ( zero_zero @ A ) )
              @ A4 ) ) ) ) ).

% sum.inter_filter
thf(fact_4782_set__encode__inf,axiom,
    ! [A4: set @ nat] :
      ( ~ ( finite_finite @ nat @ A4 )
     => ( ( nat_set_encode @ A4 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4783_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X5 )
                & ( ord_less_eq @ A @ X5 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4784_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G: C > A,I2: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X3 ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ? [Xa2: C] :
                        ( ( member @ C @ Xa2 @ T2 )
                        & ( ( I2 @ Xa2 )
                          = X3 )
                        & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ Xa2 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4785_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 )
                = ( zero_zero @ A ) )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                   => ( ( F2 @ X5 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4786_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A4: set @ I6,F2: I6 > A,G: I6 > A] :
          ( ( finite_finite @ I6 @ A4 )
         => ( ! [X3: I6] :
                ( ( member @ I6 @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ? [X6: I6] :
                  ( ( member @ I6 @ X6 @ A4 )
                  & ( ord_less @ A @ ( F2 @ X6 ) @ ( G @ X6 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ I6 @ A @ G @ A4 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4787_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X22: A,Y23: A] :
                ( ( ( R @ X1 @ X22 )
                  & ( R @ Y1 @ Y23 ) )
               => ( R @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X22 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( R @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4788_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B,S4: set @ B] :
                  ( ( finite_finite @ B @ S4 )
                 => ( ! [Y4: B] :
                        ( ( member @ B @ Y4 @ S4 )
                       => ( ord_less_eq @ A @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) )
                   => ( ( P @ S4 )
                     => ( P @ ( insert @ B @ X3 @ S4 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4789_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B3: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A8 )
                       => ( ord_less @ A @ X6 @ B3 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B3 @ A8 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4790_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B3: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A8 )
                       => ( ord_less @ A @ B3 @ X6 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B3 @ A8 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4791_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A4 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4792_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X22: A,Y23: A] :
                ( ( ( R @ X1 @ X22 )
                  & ( R @ Y1 @ Y23 ) )
               => ( R @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X22 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( R @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4793_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( member @ B @ X @ A4 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) )
            & ( ~ ( member @ B @ X @ A4 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
                = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4794_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,S2: set @ B,I2: C > B,J2: B > C,T6: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A3: B] :
                  ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                 => ( ( I2 @ ( J2 @ A3 ) )
                    = A3 ) )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                   => ( member @ C @ ( J2 @ A3 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B3: C] :
                      ( ( member @ C @ B3 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J2 @ ( I2 @ B3 ) )
                        = B3 ) )
                 => ( ! [B3: C] :
                        ( ( member @ C @ B3 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I2 @ B3 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) ) )
                   => ( ! [A3: B] :
                          ( ( member @ B @ A3 @ S5 )
                         => ( ( G @ A3 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B3: C] :
                            ( ( member @ C @ B3 @ T5 )
                           => ( ( H2 @ B3 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A3: B] :
                              ( ( member @ B @ A3 @ S2 )
                             => ( ( H2 @ ( J2 @ A3 ) )
                                = ( G @ A3 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4795_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( member @ B @ X @ A4 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) )
            & ( ~ ( member @ B @ X @ A4 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4796_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B6: set @ B,A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B6 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B6 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_4797_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B6: set @ B,A4: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B6 )
           => ( ! [A3: B] :
                  ( ( member @ B @ A3 @ A4 )
                 => ( dvd_dvd @ A @ ( F2 @ A3 ) @ ( G @ A3 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_4798_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ A4 )
              & ( ( F2 @ X5 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A4 )
                 => ( ( X5 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4799_sum__eq__1__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
          = ( one_one @ nat ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ A4 )
              & ( ( F2 @ X5 )
                = ( one_one @ nat ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A4 )
                 => ( ( X5 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4800_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I2 @ S )
               => ( ( F2 @ I2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4801_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B6: A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B6 )
             => ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ B6 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4802_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A4
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( G @ X5 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4803_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4804_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% sums_finite
thf(fact_4805_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_4806_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A4 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A4 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A4 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4807_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% suminf_finite
thf(fact_4808_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4809_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4810_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I2: B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member @ B @ I2 @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4811_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4812_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I2: A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member @ A @ I2 @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) )
             => ( ! [I3: A] :
                    ( ( member @ A @ I3 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4813_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4814_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4815_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4816_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4817_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4818_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A4: set @ B,B6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C6 )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ C6 @ A4 ) )
                   => ( ( G @ A3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B6 ) )
                     => ( ( H2 @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4819_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A4: set @ B,B6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C6 )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ C6 @ A4 ) )
                   => ( ( G @ A3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B6 ) )
                     => ( ( H2 @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B6 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4820_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: set @ B,A4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A4 )
         => ( ( finite_finite @ B @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4821_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: set @ B,B6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ord_less_eq @ ( set @ B ) @ B6 @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B6 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4822_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B6: set @ B,A4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A4 )
         => ( ( finite_finite @ B @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4823_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A4: set @ B,B6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C6 )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ C6 @ A4 ) )
                   => ( ( G @ A3 )
                      = ( one_one @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B6 ) )
                     => ( ( H2 @ B3 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B6 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4824_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A4: set @ B,B6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C6 )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ ( minus_minus @ ( set @ B ) @ C6 @ A4 ) )
                   => ( ( G @ A3 )
                      = ( one_one @ A ) ) )
               => ( ! [B3: B] :
                      ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ C6 @ B6 ) )
                     => ( ( H2 @ B3 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4825_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4826_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4827_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4828_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4829_sum__diff__nat,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B6 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4830_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z5: A] :
                  ( ( power_power @ A @ Z5 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4831_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S2: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A3: B] :
                    ( ( member @ B @ A3 @ S5 )
                   => ( ( G @ ( H2 @ A3 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B3: C] :
                      ( ( member @ C @ B3 @ T5 )
                     => ( ( G @ B3 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X5: B] : ( G @ ( H2 @ X5 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4832_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S2: A,A4: set @ nat,S5: A,F2: nat > A] :
          ( ( sums @ A @ G @ S2 )
         => ( ( finite_finite @ nat @ A4 )
           => ( ( S5
                = ( plus_plus @ A @ S2
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
                    @ A4 ) ) )
             => ( sums @ A
                @ ^ [N2: nat] : ( if @ A @ ( member @ nat @ N2 @ A4 ) @ ( F2 @ N2 ) @ ( G @ N2 ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4833_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A4 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                  & ( ord_less @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4834_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B6: set @ B,A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B6 )
           => ( ! [B3: B] :
                  ( ( member @ B @ B3 @ ( minus_minus @ ( set @ B ) @ B6 @ A4 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B6 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4835_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4836_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( member @ B @ X @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4837_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
            = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4838_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A4 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4839_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( member @ B @ X @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4840_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I5 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4841_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4842_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4843_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B6: set @ A,A4: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ B6 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B6 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4844_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I2: C,A4: set @ C,F2: C > B] :
          ( ( member @ C @ I2 @ A4 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ ( minus_minus @ ( set @ C ) @ A4 @ ( insert @ C @ I2 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
           => ( ( finite_finite @ C @ A4 )
             => ( ord_less_eq @ B @ ( F2 @ I2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A4 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4845_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B6: set @ A,A4: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
           => ( ! [B3: A] :
                  ( ( member @ A @ B3 @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B3 ) ) )
             => ( ! [A3: A] :
                    ( ( member @ A @ A3 @ A4 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A3 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B6 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4846_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4847_ln__prod,axiom,
    ! [A: $tType,I5: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I5 )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I5 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) )
            @ I5 ) ) ) ) ).

% ln_prod
thf(fact_4848_even__set__encode__iff,axiom,
    ! [A4: set @ nat] :
      ( ( finite_finite @ nat @ A4 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A4 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4849_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X5: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ X5 @ I ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I: nat] :
                ( ( ord_less_eq @ nat @ I @ N )
                & ( ( C2 @ I )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4850_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z5 @ I ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4851_accp__subset__induct,axiom,
    ! [A: $tType,D5: A > $o,R: A > A > $o,X: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D5 @ ( accp @ A @ R ) )
     => ( ! [X3: A,Z2: A] :
            ( ( D5 @ X3 )
           => ( ( R @ Z2 @ X3 )
             => ( D5 @ Z2 ) ) )
       => ( ( D5 @ X )
         => ( ! [X3: A] :
                ( ( D5 @ X3 )
               => ( ! [Z4: A] :
                      ( ( R @ Z4 @ X3 )
                     => ( P @ Z4 ) )
                 => ( P @ X3 ) ) )
           => ( P @ X ) ) ) ) ) ).

% accp_subset_induct
thf(fact_4852_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4853_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less @ nat @ N2 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4854_finite__Collect__subsets,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A4 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4855_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less_eq @ int @ A2 @ I )
            & ( ord_less_eq @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4856_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less @ int @ A2 @ I )
            & ( ord_less @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4857_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less @ int @ A2 @ I )
            & ( ord_less_eq @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4858_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I: int] :
            ( ( ord_less_eq @ int @ A2 @ I )
            & ( ord_less @ int @ I @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4859_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4860_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X6: list @ A] :
          ( ( member @ ( list @ A ) @ X6 @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X6 ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_4861_finite__divisors__int,axiom,
    ! [I2: int] :
      ( ( I2
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D3: int] : ( dvd_dvd @ int @ D3 @ I2 ) ) ) ) ).

% finite_divisors_int
thf(fact_4862_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4863_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( ord_less_eq @ A @ X3 @ A2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4864_finite__subset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( finite_finite @ A @ B6 )
       => ( finite_finite @ A @ A4 ) ) ) ).

% finite_subset
thf(fact_4865_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_4866_rev__finite__subset,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( finite_finite @ A @ A4 ) ) ) ).

% rev_finite_subset
thf(fact_4867_finite__psubset__induct,axiom,
    ! [A: $tType,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A4 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite @ A @ A8 )
           => ( ! [B10: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B10 @ A8 )
                 => ( P @ B10 ) )
             => ( P @ A8 ) ) )
       => ( P @ A4 ) ) ) ).

% finite_psubset_induct
thf(fact_4868_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4869_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4870_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A4 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A3: A,F5: set @ A] :
                ( ( finite_finite @ A @ F5 )
               => ( ( member @ A @ A3 @ A4 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F5 @ A4 )
                   => ( ~ ( member @ A @ A3 @ F5 )
                     => ( ( P @ F5 )
                       => ( P @ ( insert @ A @ A3 @ F5 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4871_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A4 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A3: A,F5: set @ A] :
                ( ( finite_finite @ A @ F5 )
               => ( ( member @ A @ A3 @ A4 )
                 => ( ~ ( member @ A @ A3 @ F5 )
                   => ( ( P @ F5 )
                     => ( P @ ( insert @ A @ A3 @ F5 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4872_finite__remove__induct,axiom,
    ! [A: $tType,B6: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B6 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B6 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B6 ) ) ) ) ).

% finite_remove_induct
thf(fact_4873_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B6: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B6 )
         => ( P @ B6 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B6 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B6 ) ) ) ) ).

% remove_induct
thf(fact_4874_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S2 )
             => ( ( P @ T7 )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ ( minus_minus @ ( set @ A ) @ S2 @ T7 ) )
                    & ( P @ ( insert @ A @ X6 @ T7 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_4875_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_4876_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4877_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_lessThan @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_4878_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4879_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_4880_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4881_real__root__eq__iff,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y3 ) )
        = ( X = Y3 ) ) ) ).

% real_root_eq_iff
thf(fact_4882_real__root__eq__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4883_real__root__less__iff,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) )
        = ( ord_less @ real @ X @ Y3 ) ) ) ).

% real_root_less_iff
thf(fact_4884_real__root__le__iff,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) )
        = ( ord_less_eq @ real @ X @ Y3 ) ) ) ).

% real_root_le_iff
thf(fact_4885_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4886_real__root__eq__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4887_real__root__gt__0__iff,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y3 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) ) ).

% real_root_gt_0_iff
thf(fact_4888_real__root__lt__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4889_real__root__ge__0__iff,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y3 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 ) ) ) ).

% real_root_ge_0_iff
thf(fact_4890_real__root__le__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4891_real__root__gt__1__iff,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y3 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y3 ) ) ) ).

% real_root_gt_1_iff
thf(fact_4892_real__root__lt__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4893_real__root__ge__1__iff,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y3 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y3 ) ) ) ).

% real_root_ge_1_iff
thf(fact_4894_real__root__le__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4895_real__root__pow__pos2,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_4896_real__root__minus,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( root @ N @ X ) ) ) ).

% real_root_minus
thf(fact_4897_real__root__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N @ X ) ) ) ).

% real_root_inverse
thf(fact_4898_real__root__divide,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( root @ N @ ( divide_divide @ real @ X @ Y3 ) )
      = ( divide_divide @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) ) ) ).

% real_root_divide
thf(fact_4899_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X )
      = ( root @ M @ ( root @ N @ X ) ) ) ).

% real_root_mult_exp
thf(fact_4900_real__root__mult,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( root @ N @ ( times_times @ real @ X @ Y3 ) )
      = ( times_times @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) ) ) ).

% real_root_mult
thf(fact_4901_real__root__commute,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ M @ ( root @ N @ X ) )
      = ( root @ N @ ( root @ M @ X ) ) ) ).

% real_root_commute
thf(fact_4902_real__root__pos__pos__le,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_4903_real__root__less__mono,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ Y3 )
       => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) ) ) ) ).

% real_root_less_mono
thf(fact_4904_real__root__le__mono,axiom,
    ! [N: nat,X: real,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X @ Y3 )
       => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y3 ) ) ) ) ).

% real_root_le_mono
thf(fact_4905_real__root__power,axiom,
    ! [N: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_4906_real__root__abs,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N @ X ) ) ) ) ).

% real_root_abs
thf(fact_4907_sgn__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_4908_real__root__gt__zero,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_4909_real__root__strict__decreasing,axiom,
    ! [N: nat,N5: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N5 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4910_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4911_root__abs__power,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y3 @ N ) ) )
        = ( abs_abs @ real @ Y3 ) ) ) ).

% root_abs_power
thf(fact_4912_real__root__pos__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_4913_real__root__strict__increasing,axiom,
    ! [N: nat,N5: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N5 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4914_real__root__decreasing,axiom,
    ! [N: nat,N5: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N5 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4915_real__root__pow__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_4916_real__root__pos__unique,axiom,
    ! [N: nat,Y3: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
       => ( ( ( power_power @ real @ Y3 @ N )
            = X )
         => ( ( root @ N @ X )
            = Y3 ) ) ) ) ).

% real_root_pos_unique
thf(fact_4917_real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ ( power_power @ real @ X @ N ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_4918_odd__real__root__pow,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X ) @ N )
        = X ) ) ).

% odd_real_root_pow
thf(fact_4919_odd__real__root__unique,axiom,
    ! [N: nat,Y3: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y3 @ N )
          = X )
       => ( ( root @ N @ X )
          = Y3 ) ) ) ).

% odd_real_root_unique
thf(fact_4920_odd__real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ N ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_4921_real__root__increasing,axiom,
    ! [N: nat,N5: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N5 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4922_root__sgn__power,axiom,
    ! [N: nat,Y3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y3 ) @ ( power_power @ real @ ( abs_abs @ real @ Y3 ) @ N ) ) )
        = Y3 ) ) ).

% root_sgn_power
thf(fact_4923_sgn__power__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X ) ) @ N ) )
        = X ) ) ).

% sgn_power_root
thf(fact_4924_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_4925_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_4926_log__base__root,axiom,
    ! [N: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_4927_split__root,axiom,
    ! [P: real > $o,N: nat,X: real] :
      ( ( P @ ( root @ N @ X ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y5: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N ) )
                = X )
             => ( P @ Y5 ) ) ) ) ) ).

% split_root
thf(fact_4928_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M2: int] :
          ? [N2: int] :
            ( ( ord_less_eq @ int @ M2 @ ( abs_abs @ int @ N2 ) )
            & ( member @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_4929_infinite__int__iff__unbounded,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M2: int] :
          ? [N2: int] :
            ( ( ord_less @ int @ M2 @ ( abs_abs @ int @ N2 ) )
            & ( member @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4930_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set @ nat] :
      ( ! [M3: nat] :
          ( ( ord_less @ nat @ K @ M3 )
         => ? [N7: nat] :
              ( ( ord_less @ nat @ M3 @ N7 )
              & ( member @ nat @ N7 @ S2 ) ) )
     => ~ ( finite_finite @ nat @ S2 ) ) ).

% unbounded_k_infinite
thf(fact_4931_infinite__nat__iff__unbounded,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N2: nat] :
            ( ( ord_less @ nat @ M2 @ N2 )
            & ( member @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4932_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N2: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N2 )
            & ( member @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4933_root__powr__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4934_finite__nat__bounded,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S2 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ).

% finite_nat_bounded
thf(fact_4935_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_4936_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y3: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y3 )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb @ Xa )
               => ( Y3 = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb @ Xa )
               => ( Y3
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_4937_in__measure,axiom,
    ! [A: $tType,X: A,Y3: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) ) ) ).

% in_measure
thf(fact_4938_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A12: nat,A23: nat,A33: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A12 @ ( product_Pair @ nat @ A @ A23 @ A33 ) ) ) )
     => ( ! [F6: nat > A > A,A3: nat,B3: nat,Acc3: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F6 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A3 @ ( product_Pair @ nat @ A @ B3 @ Acc3 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B3 @ A3 )
               => ( P @ F6 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B3 @ ( F6 @ A3 @ Acc3 ) ) )
             => ( P @ F6 @ A3 @ B3 @ Acc3 ) ) )
       => ( P @ A0 @ A12 @ A23 @ A33 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_4939_in__finite__psubset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A4 @ B6 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
        & ( finite_finite @ A @ B6 ) ) ) ).

% in_finite_psubset
thf(fact_4940_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y3: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y3 = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [M3: num] :
                  ( ( Xa
                    = ( bit0 @ M3 ) )
                 => ( ( Y3
                      = ( bit1 @ M3 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [M3: num] :
                    ( ( Xa
                      = ( bit1 @ M3 ) )
                   => ( ( Y3
                        = ( bit1 @ M3 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M3 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y3
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M3: num] :
                          ( ( Xa
                            = ( bit0 @ M3 ) )
                         => ( ( Y3
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M3 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X
                          = ( bit0 @ N3 ) )
                       => ! [M3: num] :
                            ( ( Xa
                              = ( bit1 @ M3 ) )
                           => ( ( Y3
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M3 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y3 = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M3: num] :
                                ( ( Xa
                                  = ( bit0 @ M3 ) )
                               => ( ( Y3
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M3 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X
                                = ( bit1 @ N3 ) )
                             => ! [M3: num] :
                                  ( ( Xa
                                    = ( bit1 @ M3 ) )
                                 => ( ( Y3
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_4941_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z5: int] :
                ( ( ord_less_eq @ int @ D3 @ Z5 )
                & ( ord_less @ int @ Z7 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_4942_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A7: set @ A,B8: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
              & ( finite_finite @ A @ B8 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_4943_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z5: int] :
                ( ( ord_less_eq @ int @ D3 @ Z7 )
                & ( ord_less @ int @ Z7 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_4944_sum__count__set,axiom,
    ! [A: $tType,Xs2: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs2 ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% sum_count_set
thf(fact_4945_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I5: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I: A] :
                    ( ( member @ A @ I @ I5 )
                    & ( ( F2 @ I )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I2 @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I2 ) ) ) )
              & ( ~ ( member @ A @ I2 @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4946_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_4947_count__notin,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( count_list @ A @ Xs2 @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4948_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P4: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I5 )
                  & ( ( P4 @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I2 @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I5 ) ) )
            & ( ~ ( member @ B @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I2 @ I5 ) )
                = ( plus_plus @ A @ ( P4 @ I2 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4949_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I5 )
                  & ( ( G @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) ) ) ).

% sum.non_neutral'
thf(fact_4950_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I: B] : ( plus_plus @ A @ ( G @ I ) @ ( H2 @ I ) )
              @ I5 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_4951_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4952_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4953_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4954_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4955_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I5 )
                  & ( ( G @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ I5 )
                    & ( ( H2 @ X5 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I: B] : ( plus_plus @ A @ ( G @ I ) @ ( H2 @ I ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4956_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P6: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I7 )
                      & ( ( P6 @ X5 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I7 )
                      & ( ( P6 @ X5 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_4957_count__le__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs2 @ X ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% count_le_length
thf(fact_4958_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I: A] :
                  ( ( member @ A @ I @ I5 )
                  & ( ( F2 @ I )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I2 ) ) ) )
            & ( ~ ( member @ A @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_4959_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_4960_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_4961_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_4962_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_4963_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4964_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4965_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4966_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4967_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4968_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,J2: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J2 ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J2 @ I2 )
            | ( ( ord_less_eq @ A @ M @ I2 )
              & ( ord_less_eq @ A @ J2 @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_4969_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4970_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4971_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4972_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I2 @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_4973_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_4974_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4975_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4976_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4977_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4978_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4979_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4980_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4981_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M2: nat] :
            ( ( ord_less @ nat @ M2 @ N )
            & ( P @ M2 ) ) )
      = ( ? [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X5 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4982_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M2: nat] :
            ( ( ord_less @ nat @ M2 @ N )
           => ( P @ M2 ) ) )
      = ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X5 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4983_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_4984_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4985_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_4986_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_4987_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4988_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( suc @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_4989_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( plus_plus @ nat @ I @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4990_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4991_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4992_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4993_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P4: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4994_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y3: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less @ nat @ Y3 @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y3 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation
thf(fact_4995_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y3: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ Y3 @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y3 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation'
thf(fact_4996_size__list__pointwise,axiom,
    ! [A: $tType,Xs2: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ G @ Xs2 ) ) ) ).

% size_list_pointwise
thf(fact_4997_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4998_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_4999_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_5000_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_5001_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_5002_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_5003_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_5004_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_5005_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_5006_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_5007_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_5008_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_5009_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_5010_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_5011_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I ) ) @ ( F2 @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_5012_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_5013_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_5014_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_5015_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_5016_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( A2 @ I @ J )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_5017_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M2 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_5018_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M2: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M2 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_5019_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_5020_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_5021_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_5022_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_5023_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_5024_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_5025_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_5026_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_5027_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_5028_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_5029_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M2 )
                 => ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_5030_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_5031_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% take_bit_sum
thf(fact_5032_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_5033_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_5034_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_5035_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_5036_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_5037_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_5038_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I: nat] : ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_5039_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs3 @ N2 ) ) @ ( power_power @ A @ A5 @ N2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_5040_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I3: nat,J3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ J3 )
             => ( ( ord_less @ nat @ J3 @ N )
               => ( ord_less_eq @ A @ ( A2 @ I3 ) @ ( A2 @ J3 ) ) ) )
         => ( ! [I3: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J3 ) @ ( B2 @ I3 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_5041_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I3: nat,J3: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J3 )
         => ( ( ord_less @ nat @ J3 @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I3 ) @ ( A2 @ J3 ) ) ) )
     => ( ! [I3: nat,J3: nat] :
            ( ( ord_less_eq @ nat @ I3 @ J3 )
           => ( ( ord_less @ nat @ J3 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J3 ) @ ( B2 @ I3 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I: nat] : ( times_times @ nat @ ( A2 @ I ) @ ( B2 @ I ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_5042_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_5043_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_5044_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_5045_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_5046_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_5047_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L2: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L2 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L2 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_5048_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A5: B] :
                      ( ( member @ B @ A5 @ A4 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A5 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_5049_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] : ( ord_less @ nat @ I @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_5050_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_5051_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] : ( ord_less_eq @ nat @ I @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_5052_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_5053_card_Oinfinite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( finite_card @ A @ A4 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_5054_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L ) ) ).

% card_atLeastAtMost
thf(fact_5055_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y3: A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : Y3
            @ A4 )
          = ( power_power @ A @ Y3 @ ( finite_card @ B @ A4 ) ) ) ) ).

% prod_constant
thf(fact_5056_card__0__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( finite_card @ A @ A4 )
          = ( zero_zero @ nat ) )
        = ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5057_card__insert__disjoint,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ~ ( member @ A @ X @ A4 )
       => ( ( finite_card @ A @ ( insert @ A @ X @ A4 ) )
          = ( suc @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_5058_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y3: A,A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : Y3
            @ A4 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ Y3 ) ) ) ).

% sum_constant
thf(fact_5059_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_5060_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M2: num,N2: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M2 ) @ ( numeral_numeral @ code_integer @ N2 ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M2 ) @ ( numeral_numeral @ code_integer @ N2 ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_5061_n__subsets,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A4 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A4 ) @ K ) ) ) ).

% n_subsets
thf(fact_5062_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_5063_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_5064_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_5065_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_5066_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_5067_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_5068_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ~ ( finite_finite @ A @ A4 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A4 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_5069_card__subset__eq,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( ( ( finite_card @ A @ A4 )
            = ( finite_card @ A @ B6 ) )
         => ( A4 = B6 ) ) ) ) ).

% card_subset_eq
thf(fact_5070_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B6: set @ A,A4: set @ B,R3: B > A > $o] :
      ( ( finite_finite @ A @ B6 )
     => ( ! [A3: B] :
            ( ( member @ B @ A3 @ A4 )
           => ? [B11: A] :
                ( ( member @ A @ B11 @ B6 )
                & ( R3 @ A3 @ B11 ) ) )
       => ( ! [A13: B,A24: B,B3: A] :
              ( ( member @ B @ A13 @ A4 )
             => ( ( member @ B @ A24 @ A4 )
               => ( ( member @ A @ B3 @ B6 )
                 => ( ( R3 @ A13 @ B3 )
                   => ( ( R3 @ A24 @ B3 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5071_card__insert__le,axiom,
    ! [A: $tType,A4: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ ( insert @ A @ X @ A4 ) ) ) ).

% card_insert_le
thf(fact_5072_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_5073_card__lists__length__eq,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A4 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_5074_card__2__iff_H,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X5: A] :
            ( ( member @ A @ X5 @ S2 )
            & ? [Y5: A] :
                ( ( member @ A @ Y5 @ S2 )
                & ( X5 != Y5 )
                & ! [Z5: A] :
                    ( ( member @ A @ Z5 @ S2 )
                   => ( ( Z5 = X5 )
                      | ( Z5 = Y5 ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5075_card__eq__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( zero_zero @ nat ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A4 ) ) ) ).

% card_eq_0_iff
thf(fact_5076_card__ge__0__finite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A4 ) )
     => ( finite_finite @ A @ A4 ) ) ).

% card_ge_0_finite
thf(fact_5077_card__insert__if,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( member @ A @ X @ A4 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A4 ) )
            = ( finite_card @ A @ A4 ) ) )
        & ( ~ ( member @ A @ X @ A4 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A4 ) )
            = ( suc @ ( finite_card @ A @ A4 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_5078_card__Suc__eq__finite,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A4
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_5079_card__mono,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ) ).

% card_mono
thf(fact_5080_card__seteq,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B6 ) @ ( finite_card @ A @ A4 ) )
         => ( A4 = B6 ) ) ) ) ).

% card_seteq
thf(fact_5081_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C6: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F4 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5082_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5083_card__less__sym__Diff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5084_card__le__sym__Diff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5085_card__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% card_length
thf(fact_5086_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5087_psubset__card__mono,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
       => ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ) ).

% psubset_card_mono
thf(fact_5088_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_5089_card__less__Suc2,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                & ( ord_less @ nat @ K3 @ I2 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5090_card__less__Suc,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                  & ( ord_less @ nat @ K3 @ I2 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5091_card__less,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5092_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_5093_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A4: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X5: A] : ( suc @ ( F2 @ X5 ) )
        @ A4 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( finite_card @ A @ A4 ) ) ) ).

% sum_Suc
thf(fact_5094_subset__card__intvl__is__intvl,axiom,
    ! [A4: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A4 ) ) ) )
     => ( A4
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A4 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5095_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T6: set @ B,R: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ! [X3: B] :
              ( ( member @ B @ X3 @ T6 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I: A] :
                        ( ( member @ A @ I @ S2 )
                        & ( R @ I @ X3 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J: B] :
                        ( ( member @ B @ J @ T6 )
                        & ( R @ I @ J ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T6 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5096_real__of__card,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A4 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X5: A] : ( one_one @ real )
        @ A4 ) ) ).

% real_of_card
thf(fact_5097_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5098_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,K5: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) ) ) ) ).

% sum_bounded_below
thf(fact_5099_card__gt__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A4 ) )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A4 ) ) ) ).

% card_gt_0_iff
thf(fact_5100_card__Suc__eq,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A4
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_5101_card__eq__SucD,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
     => ? [B3: A,B9: set @ A] :
          ( ( A4
            = ( insert @ A @ B3 @ B9 ) )
          & ~ ( member @ A @ B3 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_5102_card__1__singleton__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X5: A] :
            ( A4
            = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_5103_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ A4 )
             => ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A4 )
                 => ( X5 = Y5 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5104_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A4: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A4 ) )
      = ( ? [A5: A,B8: set @ A] :
            ( ( A4
              = ( insert @ A @ A5 @ B8 ) )
            & ~ ( member @ A @ A5 @ B8 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5105_card__Diff1__le,axiom,
    ! [A: $tType,A4: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ).

% card_Diff1_le
thf(fact_5106_card__Diff__subset,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5107_card__psubset,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% card_psubset
thf(fact_5108_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5109_card__lists__length__le,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A4 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_5110_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5111_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( power_power @ A @ Z5 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_5112_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N5 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5113_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_5114_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z5: complex] :
                  ( ( power_power @ complex @ Z5 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_5115_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_5116_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X5: A,Y5: A] :
            ( ( S2
              = ( insert @ A @ X5 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X5 != Y5 ) ) ) ) ).

% card_2_iff
thf(fact_5117_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X5: A,Y5: A,Z5: A] :
            ( ( S2
              = ( insert @ A @ X5 @ ( insert @ A @ Y5 @ ( insert @ A @ Z5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X5 != Y5 )
            & ( Y5 != Z5 )
            & ( X5 != Z5 ) ) ) ) ).

% card_3_iff
thf(fact_5118_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A4 ) )
     => ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5119_card__Suc__Diff1,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A4 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5120_card_Oinsert__remove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ A @ ( insert @ A @ X @ A4 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5121_card_Oremove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( finite_card @ A @ A4 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5122_card__Diff1__less,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% card_Diff1_less
thf(fact_5123_card__Diff2__less,axiom,
    ! [A: $tType,A4: set @ A,X: A,Y3: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( member @ A @ Y3 @ A4 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5124_card__Diff1__less__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) )
      = ( ( finite_finite @ A @ A4 )
        & ( member @ A @ X @ A4 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5125_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,K5: real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5126_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A4 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5127_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A4 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5128_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) ) ) )
         => ( ( finite_finite @ B @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5129_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y3: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y3 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X @ Y3 ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_5130_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z5 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_5131_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5132_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z5 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z5: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z5 @ I ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5133_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_5134_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A4 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X5: nat] : X5
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5135_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A4: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A4 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5136_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J2: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ ( nth @ A @ Xs2 @ J2 ) ) @ J2 @ ( nth @ A @ Xs2 @ I2 ) ) )
          = ( distinct @ A @ Xs2 ) ) ) ) ).

% distinct_swap
thf(fact_5137_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = N )
              & ( distinct @ A @ Xs3 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5138_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_5139_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less @ int @ Xa @ X ) ) ).

% less_integer.abs_eq
thf(fact_5140_unset__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X: int] :
      ( ( bit_se2638667681897837118et_bit @ code_integer @ Xa @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( bit_se2638667681897837118et_bit @ int @ Xa @ X ) ) ) ).

% unset_bit_integer.abs_eq
thf(fact_5141_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_5142_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa @ X ) ) ) ).

% divide_integer.abs_eq
thf(fact_5143_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K3: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K3 ) @ K3 ) ) ) ).

% abs_integer_code
thf(fact_5144_plus__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( plus_plus @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( plus_plus @ int @ Xa @ X ) ) ) ).

% plus_integer.abs_eq
thf(fact_5145_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa @ X ) ) ) ).

% times_integer.abs_eq
thf(fact_5146_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less_eq @ int @ Xa @ X ) ) ).

% less_eq_integer.abs_eq
thf(fact_5147_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J: nat] :
                ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I != J )
                 => ( ( nth @ A @ Xs3 @ I )
                   != ( nth @ A @ Xs3 @ J ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5148_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,J2: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( ( nth @ A @ Xs2 @ I2 )
              = ( nth @ A @ Xs2 @ J2 ) )
            = ( I2 = J2 ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5149_distinct__card,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% distinct_card
thf(fact_5150_card__distinct,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( distinct @ A @ Xs2 ) ) ).

% card_distinct
thf(fact_5151_distinct__Ex1,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ X3 )
              = X )
            & ! [Y4: nat] :
                ( ( ( ord_less @ nat @ Y4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                  & ( ( nth @ A @ Xs2 @ Y4 )
                    = X ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5152_bij__betw__nth,axiom,
    ! [A: $tType,Xs2: list @ A,A4: set @ nat,B6: set @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( A4
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
       => ( ( B6
            = ( set2 @ A @ Xs2 ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs2 ) @ A4 @ B6 ) ) ) ) ).

% bij_betw_nth
thf(fact_5153_set__update__distinct,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs2 @ N @ X ) )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5154_Code__Numeral_Opositive__def,axiom,
    ( code_positive
    = ( numeral_numeral @ code_integer ) ) ).

% Code_Numeral.positive_def
thf(fact_5155_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_5156_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_5157_integer__of__num__def,axiom,
    ( code_integer_of_num
    = ( numeral_numeral @ code_integer ) ) ).

% integer_of_num_def
thf(fact_5158_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_5159_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_5160_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_5161_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S7: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S7 ) )
                @ ( S7
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_5162_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K3 @ L2 ) @ ( modulo_modulo @ code_integer @ K3 @ L2 ) ) ) ) ).

% divmod_integer_def
thf(fact_5163_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) ) ) ) ).

% divmod_abs_def
thf(fact_5164_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L2 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S7: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S7
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L2 @ S7 ) ) )
                @ ( code_divmod_abs @ K3 @ L2 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L2
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L2 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S7: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S7
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L2 ) @ S7 ) ) )
                    @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_5165_card__Pow,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A4 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% card_Pow
thf(fact_5166_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_5167_PowI,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( member @ ( set @ A ) @ A4 @ ( pow2 @ A @ B6 ) ) ) ).

% PowI
thf(fact_5168_Pow__iff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( member @ ( set @ A ) @ A4 @ ( pow2 @ A @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% Pow_iff
thf(fact_5169_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_5170_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X2: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X2 ) )
      = ( F22 @ X2 ) ) ).

% old.nat.simps(5)
thf(fact_5171_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5172_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X5: nat] : ( H2 @ ( F22 @ X5 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5173_Pow__mono,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A4 ) @ ( pow2 @ A @ B6 ) ) ) ).

% Pow_mono
thf(fact_5174_PowD,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( member @ ( set @ A ) @ A4 @ ( pow2 @ A @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% PowD
thf(fact_5175_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_5176_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5177_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5178_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_5179_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M4: nat] : ( suc @ ( ord_max @ nat @ N @ M4 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5180_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M4: nat] : ( suc @ ( ord_max @ nat @ M4 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5181_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_5182_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_5183_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_5184_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X5: A,F3: nat > A,N2: nat] :
            ( if @ A
            @ ( N2
              = ( zero_zero @ nat ) )
            @ X5
            @ ( F3 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5185_binomial__def,axiom,
    ( binomial
    = ( ^ [N2: nat,K3: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K6: set @ nat] :
                ( ( member @ ( set @ nat ) @ K6 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
                & ( ( finite_card @ nat @ K6 )
                  = K3 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5186_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5187_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5188_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_5189_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_5190_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_5191_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_5192_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X23: nat] : X23 ) ) ).

% pred_def
thf(fact_5193_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X5: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X5 ) ) ) ) ).

% old.rec_nat_def
thf(fact_5194_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_5195_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A,N: nat] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( suc @ N ) )
        = ( F22 @ N @ ( F2 @ N ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_5196_subset__CollectI,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ B6 )
           => ( ( Q @ X3 )
             => ( P @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ B6 )
                & ( Q @ X5 ) ) )
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ A4 )
                & ( P @ X5 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_5197_subset__Collect__iff,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ A4 )
                & ( P @ X5 ) ) ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ B6 )
             => ( P @ X5 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_5198_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X5: real] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z5 ) @ X5 )
              & ( ord_less @ real @ X5 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_5199_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X5: rat] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z5 ) @ X5 )
              & ( ord_less @ rat @ X5 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_5200_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_5201_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M2: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M2 @ K3 ) @ ( product_Pair @ nat @ nat @ M2 @ ( minus_minus @ nat @ K3 @ M2 ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M2 @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_5202_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A5: rat] : ( if @ rat @ ( ord_less @ rat @ A5 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A5 ) @ A5 ) ) ) ).

% abs_rat_def
thf(fact_5203_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A5: rat] :
          ( if @ rat
          @ ( A5
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A5 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5204_obtain__pos__sum,axiom,
    ! [R3: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R3 )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T3: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T3 )
               => ( R3
                 != ( plus_plus @ rat @ S3 @ T3 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5205_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X5: rat,Y5: rat] :
          ( ( ord_less @ rat @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) ) ).

% less_eq_rat_def
thf(fact_5206_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y3: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y3 )
     => ( ( ( ord_less_eq @ nat @ Xa @ X )
         => ( Y3
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X )
         => ( Y3
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_5207_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y3: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X )
               => ( Y3
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X )
               => ( Y3
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_5208_rat__inverse__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A5 ) @ B4 ) @ ( abs_abs @ int @ A5 ) ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_inverse_code
thf(fact_5209_normalize__negative,axiom,
    ! [Q3: int,P4: int] :
      ( ( ord_less @ int @ Q3 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q3 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P4 ) @ ( uminus_uminus @ int @ Q3 ) ) ) ) ) ).

% normalize_negative
thf(fact_5210_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5211_normalize__denom__zero,axiom,
    ! [P4: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P4 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5212_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5213_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5214_diff__rat__def,axiom,
    ( ( minus_minus @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( plus_plus @ rat @ Q4 @ ( uminus_uminus @ rat @ R5 ) ) ) ) ).

% diff_rat_def
thf(fact_5215_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_5216_rat__times__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ B4 ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_times_code
thf(fact_5217_rat__divide__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_divide_code
thf(fact_5218_quotient__of__div,axiom,
    ! [R3: rat,N: int,D2: int] :
      ( ( ( quotient_of @ R3 )
        = ( product_Pair @ int @ int @ N @ D2 ) )
     => ( R3
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_5219_rat__plus__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A5 @ D3 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_plus_code
thf(fact_5220_rat__minus__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A5 @ D3 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_minus_code
thf(fact_5221_quotient__of__denom__pos,axiom,
    ! [R3: rat,P4: int,Q3: int] :
      ( ( ( quotient_of @ R3 )
        = ( product_Pair @ int @ int @ P4 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% quotient_of_denom_pos
thf(fact_5222_normalize__denom__pos,axiom,
    ! [R3: product_prod @ int @ int,P4: int,Q3: int] :
      ( ( ( normalize @ R3 )
        = ( product_Pair @ int @ int @ P4 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% normalize_denom_pos
thf(fact_5223_normalize__crossproduct,axiom,
    ! [Q3: int,S: int,P4: int,R3: int] :
      ( ( Q3
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q3 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R3 @ S ) ) )
         => ( ( times_times @ int @ P4 @ S )
            = ( times_times @ int @ R3 @ Q3 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_5224_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D3: int] : ( ord_less @ int @ ( times_times @ int @ A5 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_5225_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D3: int] : ( ord_less_eq @ int @ ( times_times @ int @ A5 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_eq_code
thf(fact_5226_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5227_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5228_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5229_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5230_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5231_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5232_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5233_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5234_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5235_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5236_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5237_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5238_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5239_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5240_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5241_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_5242_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5243_fst__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( divide_divide @ nat @ M @ N ) ) ).

% fst_divmod_nat
thf(fact_5244_snd__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( modulo_modulo @ nat @ M @ N ) ) ).

% snd_divmod_nat
thf(fact_5245_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5246_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5247_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5248_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_5249_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_5250_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5251_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5252_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5253_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5254_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5255_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5256_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5257_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5258_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5259_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% fst_divmod
thf(fact_5260_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% snd_divmod
thf(fact_5261_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5262_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5263_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_5264_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5265_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5266_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_int_def
thf(fact_5267_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5268_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5269_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5270_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5271_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5272_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ A5
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5273_in__set__enumerate__eq,axiom,
    ! [A: $tType,P4: product_prod @ nat @ A,N: nat,Xs2: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P4 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P4 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P4 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
        & ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P4 ) @ N ) )
          = ( product_snd @ nat @ A @ P4 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5274_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5275_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_5276_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_enumerate
thf(fact_5277_fst__divmod__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L ) )
      = ( divide_divide @ code_integer @ K @ L ) ) ).

% fst_divmod_integer
thf(fact_5278_fst__divmod__abs,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L ) )
      = ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L ) ) ) ).

% fst_divmod_abs
thf(fact_5279_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5280_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5281_quotient__of__denom__pos_H,axiom,
    ! [R3: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R3 ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5282_bezw__non__0,axiom,
    ! [Y3: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y3 )
     => ( ( bezw @ X @ Y3 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y3 @ ( modulo_modulo @ nat @ X @ Y3 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y3 @ ( modulo_modulo @ nat @ X @ Y3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y3 @ ( modulo_modulo @ nat @ X @ Y3 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y3 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5283_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y3: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y3 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y3
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y3
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5284_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X5: nat,Y5: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X5 @ Y5 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5285_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N2: nat,M2: nat] : ( divide_divide @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5286_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_5287_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_5288_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5289_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs2 @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5290_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y3: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y3
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y3
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_5291_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5292_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5293_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5294_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5295_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L2: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L2 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5296_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5297_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F3: A > nat,G2: B > nat,P6: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F3 @ ( product_fst @ A @ B @ P6 ) ) @ ( G2 @ ( product_snd @ A @ B @ P6 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5298_finite__enumerate,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [R2: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R2 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S2 ) ) )
          & ! [N7: nat] :
              ( ( ord_less @ nat @ N7 @ ( finite_card @ nat @ S2 ) )
             => ( member @ nat @ ( R2 @ N7 ) @ S2 ) ) ) ) ).

% finite_enumerate
thf(fact_5299_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_5300_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add2
thf(fact_5301_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add1
thf(fact_5302_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_5303_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5304_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5305_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5306_gcd__neg__numeral__2__int,axiom,
    ! [X: int,N: num] :
      ( ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5307_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5308_gcd__0__left__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_left_int
thf(fact_5309_gcd__0__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ X @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_int
thf(fact_5310_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add_mult
thf(fact_5311_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5312_gcd__ge__0__int,axiom,
    ! [X: int,Y3: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X @ Y3 ) ) ).

% gcd_ge_0_int
thf(fact_5313_bezout__int,axiom,
    ! [X: int,Y3: int] :
    ? [U3: int,V4: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X ) @ ( times_times @ int @ V4 @ Y3 ) )
      = ( gcd_gcd @ int @ X @ Y3 ) ) ).

% bezout_int
thf(fact_5314_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) ) ) ).

% gcd_mult_distrib_int
thf(fact_5315_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5316_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5317_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5318_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5319_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5320_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5321_gcd__cases__int,axiom,
    ! [X: int,Y3: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
         => ( P @ ( gcd_gcd @ int @ X @ Y3 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y3 @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y3 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y3 )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y3 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y3 @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y3 ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X @ Y3 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5322_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5323_gcd__non__0__int,axiom,
    ! [Y3: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y3 )
     => ( ( gcd_gcd @ int @ X @ Y3 )
        = ( gcd_gcd @ int @ Y3 @ ( modulo_modulo @ int @ X @ Y3 ) ) ) ) ).

% gcd_non_0_int
thf(fact_5324_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K3: int,L2: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L2
              = ( zero_zero @ int ) )
            @ K3
            @ ( gcd_gcd @ int @ L2 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K3 ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5325_less__by__empty,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),B6: set @ ( product_prod @ A @ A )] :
      ( ( A4
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A4 @ B6 ) ) ).

% less_by_empty
thf(fact_5326_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less @ nat @ K2 @ I4 )
                 => ( P @ I4 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5327_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F3: A > B,A7: set @ A] :
            ! [R5: A,S7: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S7 @ A7 )
                & ( ord_less @ A @ R5 @ S7 ) )
             => ( ord_less @ B @ ( F3 @ R5 ) @ ( F3 @ S7 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5328_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [R2: A,S3: A] :
              ( ( member @ A @ R2 @ A4 )
             => ( ( member @ A @ S3 @ A4 )
               => ( ( ord_less @ A @ R2 @ S3 )
                 => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A4 ) ) ) ).

% strict_mono_onI
thf(fact_5329_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A4: set @ A,R3: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A4 )
         => ( ( member @ A @ R3 @ A4 )
           => ( ( member @ A @ S @ A4 )
             => ( ( ord_less @ A @ R3 @ S )
               => ( ord_less @ B @ ( F2 @ R3 ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5330_gcd__0__left__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X )
      = X ) ).

% gcd_0_left_nat
thf(fact_5331_gcd__0__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ X @ ( zero_zero @ nat ) )
      = X ) ).

% gcd_0_nat
thf(fact_5332_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_5333_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5334_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_5335_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5336_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5337_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5338_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5339_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5340_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5341_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_5342_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_5343_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa: nat,Y3: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y3 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y3 = X ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y3
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5344_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X5: nat,Y5: nat] :
          ( if @ nat
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ X5
          @ ( gcd_gcd @ nat @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5345_gcd__non__0__nat,axiom,
    ! [Y3: nat,X: nat] :
      ( ( Y3
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X @ Y3 )
        = ( gcd_gcd @ nat @ Y3 @ ( modulo_modulo @ nat @ X @ Y3 ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5346_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X3: nat,Y: nat] :
          ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5347_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y ) @ ( times_times @ nat @ A2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y ) @ ( times_times @ nat @ B2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5348_bezw__aux,axiom,
    ! [X: nat,Y3: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y3 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y3 ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y3 ) ) @ ( semiring_1_of_nat @ int @ Y3 ) ) ) ) ).

% bezw_aux
thf(fact_5349_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A4: set @ A,X: A,Y3: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( member @ A @ Y3 @ A4 )
             => ( ( ord_less_eq @ A @ X @ Y3 )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5350_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y3: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y3 = X ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y3
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5351_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L2
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L2 ) )
                @ ( code_divmod_abs @ K3 @ L2 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S7: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S7
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L2 ) @ S7 ) ) )
                  @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5352_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate1
thf(fact_5353_length__rotate1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_rotate1
thf(fact_5354_rotate1__length01,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs2 )
        = Xs2 ) ) ).

% rotate1_length01
thf(fact_5355_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A4: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X3: B,Y: B] :
                ( ( H2 @ ( plus_plus @ B @ X3 @ Y ) )
                = ( plus_plus @ A @ ( H2 @ X3 ) @ ( H2 @ Y ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A4 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A4 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5356_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_5357_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5358_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5359_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5360_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5361_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5362_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5363_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5364_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5365_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5366_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5367_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5368_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5369_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5370_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y3 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y3 ) ) ) ).

% semiring_norm(166)
thf(fact_5371_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y3 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y3 ) ) ) ).

% semiring_norm(167)
thf(fact_5372_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5373_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5374_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5375_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5376_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_5377_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5378_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5379_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5380_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5381_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5382_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5383_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5384_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5385_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5386_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5387_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5388_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5389_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5390_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5391_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L2: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L2 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5392_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5393_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5394_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5395_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5396_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5397_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5398_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5399_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5400_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5401_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5402_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5403_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_5404_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_5405_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_5406_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_5407_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_5408_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_5409_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5410_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5411_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5412_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5413_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5414_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5415_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5416_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5417_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5418_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5419_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5420_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5421_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5422_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5423_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5424_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5425_Code__Numeral_Onegative__def,axiom,
    ( code_negative
    = ( comp @ code_integer @ code_integer @ num @ ( uminus_uminus @ code_integer ) @ ( numeral_numeral @ code_integer ) ) ) ).

% Code_Numeral.negative_def
thf(fact_5426_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5427_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5428_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L ) ) ) ).

% card_greaterThanLessThan
thf(fact_5429_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5430_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_5431_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y3: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y3 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y3 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5432_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y3: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y3 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y3 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y3 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5433_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y3: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y3 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5434_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y3: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y3 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5435_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y3: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y3 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5436_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y3: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y3 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5437_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_5438_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y3: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y3 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5439_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y3: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y3 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5440_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5441_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F3: A > B] :
            ? [K6: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5442_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( times_times @ A @ A5 ) @ ( F3 @ ( nth @ B @ Xs3 @ N2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5443_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_5444_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_5445_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% comp_funpow
thf(fact_5446_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5447_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5448_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow_add
thf(fact_5449_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_5450_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S2: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_5451_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F2: A > A,X: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ X )
        = X )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N ) @ F2 @ X )
        = ( compow @ ( A > A ) @ M @ F2 @ X ) ) ) ).

% funpow_mod_eq
thf(fact_5452_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_5453_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F2 ) ) ).

% funpow_mult
thf(fact_5454_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5455_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5456_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5457_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N2: nat,P3: A > A > $o,X5: A,Y5: A] :
          ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = X5 )
            & ( ( F3 @ N2 )
              = Y5 )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ N2 )
               => ( P3 @ ( F3 @ I ) @ ( F3 @ ( suc @ I ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5458_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5459_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_5460_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y3: A,N: nat,Z: A] :
      ( ( P @ X @ Y3 )
     => ( ( compow @ ( A > A > $o ) @ N @ P @ Y3 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z ) ) ) ).

% relpowp_Suc_I2
thf(fact_5461_relpowp__Suc__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ~ ! [Y: A] :
            ( ( P @ X @ Y )
           => ~ ( compow @ ( A > A > $o ) @ N @ P @ Y @ Z ) ) ) ).

% relpowp_Suc_E2
thf(fact_5462_relpowp__Suc__D2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ? [Y: A] :
          ( ( P @ X @ Y )
          & ( compow @ ( A > A > $o ) @ N @ P @ Y @ Z ) ) ) ).

% relpowp_Suc_D2
thf(fact_5463_relpowp__Suc__I,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Y3: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Y3 )
     => ( ( P @ Y3 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z ) ) ) ).

% relpowp_Suc_I
thf(fact_5464_relpowp__Suc__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ~ ! [Y: A] :
            ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Y )
           => ~ ( P @ Y @ Z ) ) ) ).

% relpowp_Suc_E
thf(fact_5465_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R )
      = ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) ) ) ).

% relpowp.simps(1)
thf(fact_5466_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y3: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ Y3 )
     => ( X = Y3 ) ) ).

% relpowp_0_E
thf(fact_5467_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ X ) ).

% relpowp_0_I
thf(fact_5468_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_5469_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_5470_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y: A,M3: nat] :
              ( ( N
                = ( suc @ M3 ) )
             => ( ( P @ X @ Y )
               => ~ ( compow @ ( A > A > $o ) @ M3 @ P @ Y @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_5471_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y: A,M3: nat] :
              ( ( N
                = ( suc @ M3 ) )
             => ( ( compow @ ( A > A > $o ) @ M3 @ P @ X @ Y )
               => ~ ( P @ Y @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_5472_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5473_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L2: code_integer,J: code_integer] :
                ( if @ nat
                @ ( J
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_5474_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X5: nat,Y5: nat] : ( ord_less_eq @ nat @ Y5 @ X5 )
    @ ^ [X5: nat,Y5: nat] : ( ord_less @ nat @ Y5 @ X5 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5475_card__UNION,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A4 )
     => ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A4 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A4 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5476_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
            = Y3 ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5477_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5478_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y3 ) )
            = Y3 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5479_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y3 ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5480_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y3 ) )
            = Y3 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5481_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y3 ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5482_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y3: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X @ Y3 ) ).

% bot2E
thf(fact_5483_card__Union__le__sum__card,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ).

% card_Union_le_sum_card
thf(fact_5484_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5485_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B6 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B6 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B6 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G @ X3 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B6 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B6 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5486_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ U4 )
         => ( finite_finite @ A @ X3 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5487_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_5488_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_5489_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M2: nat,N2: nat] :
        ( ( dvd_dvd @ nat @ M2 @ N2 )
        & ( M2 != N2 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5490_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y3 @ X ) )
            = Y3 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5491_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y3 @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5492_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y3 @ X ) )
            = Y3 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5493_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5494_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y3 @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5495_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y3 @ X ) )
            = Y3 ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5496_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y3 @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5497_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
          | ( ord_less @ A @ B3 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5498_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X6: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X6 )
                        & ( ord_less @ A @ X6 @ C3 ) )
                     => ( P @ X6 ) )
                  & ! [D6: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D6 ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5499_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ X3 @ A2 ) )
         => ( ! [Y: A] :
                ( ! [X6: A] :
                    ( ( member @ A @ X6 @ X8 )
                   => ( ord_less_eq @ A @ X6 @ Y ) )
               => ( ord_less_eq @ A @ A2 @ Y ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5500_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5501_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X3 ) )
         => ( ! [Y: A] :
                ( ! [X6: A] :
                    ( ( member @ A @ X6 @ X8 )
                   => ( ord_less_eq @ A @ Y @ X6 ) )
               => ( ord_less_eq @ A @ Y @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5502_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5503_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ! [Y: A] :
                  ( ! [X6: A] :
                      ( ( member @ A @ X6 @ X8 )
                     => ( ord_less_eq @ A @ X6 @ Y ) )
                 => ( ord_less_eq @ A @ A2 @ Y ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5504_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_5505_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5506_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y3: A,X8: set @ A] :
          ( ( ord_less @ A @ Y3 @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ~ ( ord_less @ A @ Y3 @ X3 ) ) ) ) ) ).

% less_cSupE
thf(fact_5507_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ Z @ X3 ) ) ) ) ) ).

% less_cSupD
thf(fact_5508_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ X3 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5509_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X3 ) )
           => ( ! [Y: A] :
                  ( ! [X6: A] :
                      ( ( member @ A @ X6 @ X8 )
                     => ( ord_less_eq @ A @ Y @ X6 ) )
                 => ( ord_less_eq @ A @ Y @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5510_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5511_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_5512_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ X3 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_5513_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ A2 @ X3 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5514_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less @ A @ X5 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5515_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less @ A @ A2 @ X5 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5516_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5517_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A4 )
            = ( bot_bot @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X5 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A4 )
                    & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5518_finite__subset__Union,axiom,
    ! [A: $tType,A4: set @ A,B12: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ B12 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B12 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5519_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5520_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ! [Y: A] :
              ( ( member @ A @ Y @ A4 )
             => ( ord_less_eq @ A @ Y @ X ) )
         => ( ! [Y: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A4 )
                   => ( ord_less_eq @ A @ Z4 @ Y ) )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( ( complete_Sup_Sup @ A @ A4 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_5521_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ! [A3: A] :
              ( ( member @ A @ A3 @ A4 )
             => ? [X6: A] :
                  ( ( member @ A @ X6 @ B6 )
                  & ( ord_less_eq @ A @ A3 @ X6 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_mono
thf(fact_5522_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ Z ) ) ) ).

% Sup_least
thf(fact_5523_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A4: set @ A] :
          ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Sup_upper
thf(fact_5524_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ B2 )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ A4 )
               => ( ord_less_eq @ A @ X5 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5525_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A4: set @ A,V: A] :
          ( ( member @ A @ U @ A4 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5526_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S2: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ( ord_less @ A @ A2 @ X5 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5527_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ A4 )
             => ( ord_less_eq @ A @ X @ I3 ) )
         => ( ! [Y: A] :
                ( ! [I4: A] :
                    ( ( member @ A @ I4 @ A4 )
                   => ( ord_less_eq @ A @ Y @ I4 ) )
               => ( ord_less_eq @ A @ Y @ X ) )
           => ( ( complete_Inf_Inf @ A @ A4 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5528_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ! [B3: A] :
              ( ( member @ A @ B3 @ B6 )
             => ? [X6: A] :
                  ( ( member @ A @ X6 @ A4 )
                  & ( ord_less_eq @ A @ X6 @ B3 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ).

% Inf_mono
thf(fact_5529_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A4: set @ A] :
          ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5530_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A4: set @ A,V: A] :
          ( ( member @ A @ U @ A4 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5531_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A4: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A4 ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ A4 )
               => ( ord_less_eq @ A @ B2 @ X5 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5532_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ Z @ X3 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ).

% Inf_greatest
thf(fact_5533_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_12: A] : ( P @ ( zero_zero @ nat ) @ X_12 )
     => ( ! [X3: A,N3: nat] :
            ( ( P @ N3 @ X3 )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N3 ) @ Y4 )
                & ( Q @ N3 @ X3 @ Y4 ) ) )
       => ? [F6: nat > A] :
          ! [N7: nat] :
            ( ( P @ N7 @ ( F6 @ N7 ) )
            & ( Q @ N7 @ ( F6 @ N7 ) @ ( F6 @ ( suc @ N7 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_5534_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ( ord_less @ A @ X5 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5535_Union__least,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ C6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) @ C6 ) ) ).

% Union_least
thf(fact_5536_Union__upper,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B6 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ B6 @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) ) ) ).

% Union_upper
thf(fact_5537_Union__subsetI,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B6: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ A4 )
         => ? [Y4: set @ A] :
              ( ( member @ ( set @ A ) @ Y4 @ B6 )
              & ( ord_less_eq @ ( set @ A ) @ X3 @ Y4 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_subsetI
thf(fact_5538_Inter__lower,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B6 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ B6 ) ) ).

% Inter_lower
thf(fact_5539_Inter__greatest,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ C6 @ X10 ) )
     => ( ord_less_eq @ ( set @ A ) @ C6 @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) ) ) ).

% Inter_greatest
thf(fact_5540_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A4: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5541_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X @ Y5 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5542_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5543_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5544_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5545_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5546_Union__mono,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B6: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_mono
thf(fact_5547_Inter__anti__mono,axiom,
    ! [A: $tType,B6: set @ ( set @ A ),A4: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B6 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B6 ) ) ) ).

% Inter_anti_mono
thf(fact_5548_Inter__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B6 ) )
     => ( ( A4
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ B6 ) ) ) ).

% Inter_subset
thf(fact_5549_subset__Pow__Union,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A4 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) ) ) ).

% subset_Pow_Union
thf(fact_5550_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5551_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5552_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L2: code_integer,J: code_integer] :
                  ( if @ int
                  @ ( J
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_5553_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y3 @ Z ) )
          = ( ( ord_less_eq @ A @ X @ Y3 )
            & ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_5554_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5555_Int__subset__iff,axiom,
    ! [A: $tType,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C6 @ A4 )
        & ( ord_less_eq @ ( set @ A ) @ C6 @ B6 ) ) ) ).

% Int_subset_iff
thf(fact_5556_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_5557_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_5558_plus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( plus_plus @ code_integer @ X @ Xa ) )
      = ( plus_plus @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% plus_integer.rep_eq
thf(fact_5559_times__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X @ Xa ) )
      = ( times_times @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% times_integer.rep_eq
thf(fact_5560_divide__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X @ Xa ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% divide_integer.rep_eq
thf(fact_5561_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X5 ) ) @ ( F2 @ X5 ) )
              @ A4 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5562_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X5 ) ) )
              @ A4 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5563_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B6: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5564_Union__Int__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B6: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A4 @ B6 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_Int_subset
thf(fact_5565_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_5566_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_5567_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5568_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5569_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5570_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( inf_inf @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5571_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5572_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5573_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5574_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5575_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5576_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5577_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5578_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5579_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( inf_inf @ A @ A5 @ B4 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5580_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less_eq @ A @ X @ Z )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y3 @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_5581_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5582_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5583_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( inf_inf @ A @ X @ Y3 )
            = Y3 ) ) ) ).

% inf_absorb2
thf(fact_5584_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( inf_inf @ A @ X @ Y3 )
            = X ) ) ) ).

% inf_absorb1
thf(fact_5585_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5586_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5587_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( inf_inf @ A @ X5 @ Y5 )
              = X5 ) ) ) ) ).

% le_iff_inf
thf(fact_5588_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y3: A] :
          ( ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y ) @ X3 )
         => ( ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y ) @ Y )
           => ( ! [X3: A,Y: A,Z2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ( ord_less_eq @ A @ X3 @ Z2 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y @ Z2 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y3 )
                = ( F2 @ X @ Y3 ) ) ) ) ) ) ).

% inf_unique
thf(fact_5589_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5590_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5591_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_5592_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_5593_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5594_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5595_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_5596_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y3 ) @ Y3 ) ) ).

% inf_le2
thf(fact_5597_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y3 ) @ X ) ) ).

% inf_le1
thf(fact_5598_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y3 ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_5599_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y3 ) @ Y3 ) ) ).

% inf_sup_ord(2)
thf(fact_5600_Int__Collect__mono,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( ( P @ X3 )
             => ( Q @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B6 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5601_Int__greatest,axiom,
    ! [A: $tType,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% Int_greatest
thf(fact_5602_Int__absorb2,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B6 )
        = A4 ) ) ).

% Int_absorb2
thf(fact_5603_Int__absorb1,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B6 )
        = B6 ) ) ).

% Int_absorb1
thf(fact_5604_Int__lower2,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) @ B6 ) ).

% Int_lower2
thf(fact_5605_Int__lower1,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) @ A4 ) ).

% Int_lower1
thf(fact_5606_Int__mono,axiom,
    ! [A: $tType,A4: set @ A,C6: set @ A,B6: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) @ ( inf_inf @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_5607_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X5: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X5 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_5608_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_iff
thf(fact_5609_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_5610_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X5: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X5 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_5611_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ( inf_inf @ A @ X @ Y3 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y3 ) ) ) ) ).

% inf_shunt
thf(fact_5612_unset__bit__integer_Orep__eq,axiom,
    ! [X: nat,Xa: code_integer] :
      ( ( code_int_of_integer @ ( bit_se2638667681897837118et_bit @ code_integer @ X @ Xa ) )
      = ( bit_se2638667681897837118et_bit @ int @ X @ ( code_int_of_integer @ Xa ) ) ) ).

% unset_bit_integer.rep_eq
thf(fact_5613_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B6 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5614_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,B6: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( member @ B @ X5 @ B6 ) @ ( G @ X5 ) @ ( zero_zero @ A ) )
              @ A4 ) ) ) ) ).

% sum.inter_restrict
thf(fact_5615_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T6 ) )
                   => ( ( G @ I3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S2 @ T6 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5616_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5617_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,B6: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5618_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,B6: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5619_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( H2 @ X5 ) @ ( G @ X5 ) )
              @ A4 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5620_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( H2 @ X5 ) @ ( G @ X5 ) )
              @ A4 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5621_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A5: B] : ( divide_divide @ A @ ( F2 @ A5 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A4
                  @ ( collect @ B
                    @ ^ [A5: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A5 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A4
                    @ ( collect @ B
                      @ ^ [A5: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A5 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5622_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5623_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X6: A] :
                  ( ( member @ A @ X6 @ S2 )
                  & ( ord_less @ B @ ( F2 @ X6 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5624_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y3: A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y3 @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y3 ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5625_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5626_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) @ S2 ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_5627_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) )
          @ Xa
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_5628_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5629_insert__subsetI,axiom,
    ! [A: $tType,X: A,A4: set @ A,X8: set @ A] :
      ( ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A4 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X8 ) @ A4 ) ) ) ).

% insert_subsetI
thf(fact_5630_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_5631_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( gcd_Gcd @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5632_int_Oabs__induct,axiom,
    ! [P: int > $o,X: int] :
      ( ! [Y: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y ) )
     => ( P @ X ) ) ).

% int.abs_induct
thf(fact_5633_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X3: nat,Y: nat] :
          ( Z
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X3 @ Y ) ) ) ).

% eq_Abs_Integ
thf(fact_5634_nat_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X ) ) ).

% nat.abs_eq
thf(fact_5635_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5636_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N2: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5637_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_5638_prop__restrict,axiom,
    ! [A: $tType,X: A,Z8: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( P @ X5 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_5639_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X5: A] :
            ( ( member @ A @ X5 @ X8 )
            & ( P @ X5 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_5640_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5641_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) )
            @ X ) ) ) ).

% of_int.abs_eq
thf(fact_5642_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa
        @ X ) ) ).

% less_int.abs_eq
thf(fact_5643_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_5644_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) )
          @ Xa
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_5645_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) )
          @ Xa
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_5646_subset__emptyI,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ! [X3: A] :
          ~ ( member @ A @ X3 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_5647_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( semiring_1_of_nat @ A @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_5648_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5649_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y3: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y3 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y3 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5650_num__of__nat__numeral__eq,axiom,
    ! [Q3: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q3 ) )
      = Q3 ) ).

% num_of_nat_numeral_eq
thf(fact_5651_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5652_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z5: A] :
              ( Z5
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5653_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5654_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5655_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5656_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [X5: A,Y5: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X5 @ Y5 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5657_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5658_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5659_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y3: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y3 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y3 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5660_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5661_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5662_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5663_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y3: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y3 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y3 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5664_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_5665_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5666_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y3: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y3 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y3 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5667_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5668_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5669_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y3: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y3 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y3 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5670_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y3: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y3 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y3 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5671_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y3: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y3 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y3 @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5672_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5673_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_5674_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5675_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y3: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y3 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y3 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5676_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5677_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5678_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X5: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X5 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5679_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X5: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X5 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5680_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M2: nat,N2: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M2 @ N2 ) ) @ M2 ) ) ) ).

% prod_encode_def
thf(fact_5681_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_5682_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_5683_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X5: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X5 ) ) ) ) ).

% nat.rep_eq
thf(fact_5684_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X5: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) )
              @ ( rep_Integ @ X5 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5685_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) ) ).

% prod_encode_prod_decode_aux
thf(fact_5686_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 ) ) ) ) ).

% uminus_int_def
thf(fact_5687_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M2: nat,N2: nat] :
            ( N2
            = ( suc @ M2 ) ) ) ) ) ).

% pred_nat_def
thf(fact_5688_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,P4: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I5 )
                  & ( ( P4 @ X5 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I2 @ I5 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P4 @ I5 ) ) )
            & ( ~ ( member @ B @ I2 @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I2 @ I5 ) )
                = ( times_times @ A @ ( P4 @ I2 ) @ ( groups1962203154675924110t_prod @ B @ A @ P4 @ I5 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5689_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I: B] : ( times_times @ A @ ( G @ I ) @ ( H2 @ I ) )
              @ I5 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5690_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T6 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5691_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5692_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5693_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5694_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I5 )
                  & ( ( G @ X5 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ I5 )
                    & ( ( H2 @ X5 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I: B] : ( times_times @ A @ ( G @ I ) @ ( H2 @ I ) )
                @ I5 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5695_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5696_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5697_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5698_pow_Osimps_I3_J,axiom,
    ! [X: num,Y3: num] :
      ( ( pow @ X @ ( bit1 @ Y3 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y3 ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_5699_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs2: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs2 @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5700_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y3: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y3 )
       => ( ( image @ nat @ nat
            @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y3 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y3 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y3 )
       => ( ( ( ord_less @ nat @ X @ Y3 )
           => ( ( image @ nat @ nat
                @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y3 ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y3 )
           => ( ( image @ nat @ nat
                @ ^ [I: nat] : ( minus_minus @ nat @ I @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y3 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5701_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N5: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N5 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N5 ) ) ).

% bij_betw_Suc
thf(fact_5702_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_5703_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I2 @ J2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5704_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5705_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5706_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A4: set @ A,B6: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A4 @ B6 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A4 )
            = B6 ) ) ) ).

% bij_betw_add
thf(fact_5707_image__Suc__atLeastAtMost,axiom,
    ! [I2: nat,J2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I2 @ J2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I2 ) @ ( suc @ J2 ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5708_image__Suc__atLeastLessThan,axiom,
    ! [I2: nat,J2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J2 ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I2 ) @ ( suc @ J2 ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5709_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J2: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I2 @ J2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5710_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J2: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I2 @ J2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5711_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
            = ( bot_bot @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X5 )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A4 )
                    & ( ord_less @ A @ ( F2 @ Y5 ) @ X5 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5712_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5713_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5714_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B6: set @ B] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( member @ B @ ( F2 @ X3 ) @ B6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B6 ) ) ).

% image_Collect_subsetI
thf(fact_5715_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5716_zero__notin__Suc__image,axiom,
    ! [A4: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A4 ) ) ).

% zero_notin_Suc_image
thf(fact_5717_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ( finite_finite @ A @ B8 )
              & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A4 ) ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ( finite_finite @ B @ B8 )
              & ( ord_less_eq @ ( set @ B ) @ B8 @ A4 ) )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_5718_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B8: set @ A] :
            ( ( finite_finite @ A @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A4 ) )
            & ( P @ B8 ) ) )
      = ( ? [B8: set @ B] :
            ( ( finite_finite @ B @ B8 )
            & ( ord_less_eq @ ( set @ B ) @ B8 @ A4 )
            & ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_5719_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A4 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A4 )
            & ( finite_finite @ B @ C7 )
            & ( B6
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_5720_finite__surj,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A4 ) )
       => ( finite_finite @ B @ B6 ) ) ) ).

% finite_surj
thf(fact_5721_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A4: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A4 ) ) @ ( pow2 @ A @ B6 ) ) ) ).

% image_Pow_mono
thf(fact_5722_image__mono,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B6: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ).

% image_mono
thf(fact_5723_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,F2: A > B,B6: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( member @ B @ ( F2 @ X3 ) @ B6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B6 ) ) ).

% image_subsetI
thf(fact_5724_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A4: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A4 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A4 )
           => ( B6
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_5725_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) @ B6 )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ A4 )
           => ( member @ A @ ( F2 @ X5 ) @ B6 ) ) ) ) ).

% image_subset_iff
thf(fact_5726_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A4: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A4 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A4 )
            & ( B6
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_5727_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A4 ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B8 @ A4 )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_subset_image
thf(fact_5728_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5729_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,B6: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) @ ( image @ B @ A @ F2 @ B6 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) ) ).

% image_diff_subset
thf(fact_5730_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B6: set @ C,F2: B > A,G: C > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ B6 )
                  & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ X6 ) ) ) )
         => ( ! [J3: C] :
                ( ( member @ C @ J3 @ B6 )
               => ? [X6: B] :
                    ( ( member @ B @ X6 @ A4 )
                    & ( ord_less_eq @ A @ ( G @ J3 ) @ ( F2 @ X6 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B6 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5731_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B6: set @ C,G: C > A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ B6 )
                  & ( ord_less_eq @ A @ ( G @ X6 ) @ ( F2 @ I3 ) ) ) )
         => ( ! [J3: C] :
                ( ( member @ C @ J3 @ B6 )
               => ? [X6: B] :
                    ( ( member @ B @ X6 @ A4 )
                    & ( ord_less_eq @ A @ ( F2 @ X6 ) @ ( G @ J3 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B6 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5732_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_5733_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,F8: B > A,F2: A > B,A9: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ( F8 @ ( F2 @ X3 ) )
            = X3 ) )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ A9 )
           => ( ( F2 @ ( F8 @ X3 ) )
              = X3 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F8 @ A9 ) @ A4 )
           => ( bij_betw @ A @ B @ F2 @ A4 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_5734_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: set @ A,A9: set @ B,B6: set @ A,B13: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A4 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
       => ( ( ( image @ A @ B @ F2 @ B6 )
            = B13 )
         => ( bij_betw @ A @ B @ F2 @ B6 @ B13 ) ) ) ) ).

% bij_betw_subset
thf(fact_5735_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B,B6: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) @ ( image @ B @ A @ F2 @ B6 ) ) ) ).

% image_Int_subset
thf(fact_5736_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_5737_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5738_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A,X: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ X ) )
         => ( ! [Y: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A4 )
                   => ( ord_less_eq @ A @ ( F2 @ I4 ) @ Y ) )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_5739_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B6: set @ C,F2: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A4 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ B6 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X6 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B6 ) ) ) ) ) ).

% SUP_mono
thf(fact_5740_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5741_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5742_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A4: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A4 )
         => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% SUP_upper
thf(fact_5743_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U )
          = ( ! [X5: B] :
                ( ( member @ B @ X5 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5744_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A4: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I2 @ A4 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I2 ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5745_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: set @ B,Y3: A,I2: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ Y3 )
         => ( ( member @ B @ I2 @ A4 )
           => ( ord_less @ A @ ( F2 @ I2 ) @ Y3 ) ) ) ) ).

% SUP_lessD
thf(fact_5746_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A4: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ? [X5: B] :
                ( ( member @ B @ X5 @ A4 )
                & ( ord_less @ A @ A2 @ ( F2 @ X5 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5747_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,X: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I3 ) ) )
         => ( ! [Y: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A4 )
                   => ( ord_less_eq @ A @ Y @ ( F2 @ I4 ) ) )
               => ( ord_less_eq @ A @ Y @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_5748_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ B,A4: set @ C,F2: C > A,G: B > A] :
          ( ! [M3: B] :
              ( ( member @ B @ M3 @ B6 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ A4 )
                  & ( ord_less_eq @ A @ ( F2 @ X6 ) @ ( G @ M3 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B6 ) ) ) ) ) ).

% INF_mono
thf(fact_5749_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A4: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( F2 @ I2 ) ) ) ) ).

% INF_lower
thf(fact_5750_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% INF_mono'
thf(fact_5751_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A4: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I2 @ A4 )
         => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5752_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A4: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ! [X5: B] :
                ( ( member @ B @ X5 @ A4 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X5 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5753_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% INF_greatest
thf(fact_5754_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y3: A,F2: B > A,A4: set @ B,I2: B] :
          ( ( ord_less @ A @ Y3 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
         => ( ( member @ B @ I2 @ A4 )
           => ( ord_less @ A @ Y3 @ ( F2 @ I2 ) ) ) ) ) ).

% less_INF_D
thf(fact_5755_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ A2 )
          = ( ? [X5: B] :
                ( ( member @ B @ X5 @ A4 )
                & ( ord_less @ A @ ( F2 @ X5 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5756_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A4: set @ A,F2: nat > A,N: nat] :
      ( ( A4
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I: nat] : ( ord_less @ nat @ I @ N ) ) ) )
     => ( finite_finite @ A @ A4 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5757_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N2: nat,F3: nat > A] :
            ( A7
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I: nat] : ( ord_less @ nat @ I @ N2 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5758_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X5: num] : ( times_times @ num @ X5 @ X5 ) ) ) ).

% sqr_conv_mult
thf(fact_5759_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A4: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                    & ( ord_less @ A @ Y5 @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5760_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ X )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X @ Y5 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                    & ( ord_less @ A @ ( F2 @ X5 ) @ Y5 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5761_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F2: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I3 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ I5 )
                   => ( ( F2 @ X5 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5762_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,M7: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_5763_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F2: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ I5 )
                   => ( ( F2 @ X5 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5764_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,M: A,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5765_card__image__le,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( finite_card @ A @ A4 ) ) ) ).

% card_image_le
thf(fact_5766_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: A > B,A9: set @ A,A10: set @ B,F2: C > A,A4: set @ C] :
      ( ( bij_betw @ A @ B @ F8 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A4 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F2 @ A4 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F8 @ F2 ) @ A4 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_5767_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B6: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A4 @ B6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5768_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ B,A4: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A4 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ B6 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5769_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X5: B] :
                            ( ( member @ B @ X5 @ S2 )
                            & ( ( G @ X5 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_5770_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X5: B] :
                            ( ( member @ B @ X5 @ S2 )
                            & ( ( G @ X5 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_5771_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5772_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X3: B,Y: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ( member @ B @ Y @ A4 )
                 => ( ( X3 != Y )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H2 @ A4 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_5773_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5774_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A4 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B6 ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% surj_card_le
thf(fact_5775_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X: A,Y3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y3 ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5776_image__Suc__lessThan,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ).

% image_Suc_lessThan
thf(fact_5777_image__Suc__atMost,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N ) ) ) ).

% image_Suc_atMost
thf(fact_5778_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5779_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5780_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5781_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5782_pow_Osimps_I2_J,axiom,
    ! [X: num,Y3: num] :
      ( ( pow @ X @ ( bit0 @ Y3 ) )
      = ( sqr @ ( pow @ X @ Y3 ) ) ) ).

% pow.simps(2)
thf(fact_5783_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I3: C] :
                ( ( member @ C @ I3 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I3 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_5784_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y3: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y3 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y3 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y3 ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y3 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5785_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_5786_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y3 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y3 @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y3 )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5787_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5788_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5789_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5790_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5791_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S2 ) @ R )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y5: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X5: A] :
                                ( ( member @ A @ X5 @ S2 )
                                & ( ( G @ X5 )
                                  = Y5 ) ) ) ) )
                      @ ( F2 @ Y5 ) )
                  @ R ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5792_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: A,B6: A] :
          ( ( inf_inf @ A @ A4
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X5: nat] : B6
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A4 @ B6 ) ) ) ).

% INF_nat_binary
thf(fact_5793_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_5794_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5795_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X5: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_5796_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_5797_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_5798_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_5799_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_5800_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A4 )
            = ( top_top @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ ( top_top @ A ) )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A4 )
                    & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_5801_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5802_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_5803_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5804_floor__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A2 @ B2 ) )
      = ( divide_divide @ int @ A2 @ B2 ) ) ).

% floor_Fract
thf(fact_5805_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
            = ( top_top @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ ( top_top @ A ) )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A4 )
                    & ( ord_less @ A @ X5 @ ( F2 @ Y5 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_5806_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_5807_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5808_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_5809_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_5810_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_5811_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5812_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B6: B > ( set @ A ),A4: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X5: B] : ( pow2 @ A @ ( B6 @ X5 ) )
          @ A4 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B6 @ A4 ) ) ) ) ).

% UN_Pow_subset
thf(fact_5813_UN__UN__finite__eq,axiom,
    ! [A: $tType,A4: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N2: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_5814_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X9: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X9 ) ) ) ) ) ).

% Inf_real_def
thf(fact_5815_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_5816_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5817_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q3: rat] :
      ( ! [A3: int,B3: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B3 )
         => ( P @ ( fract @ A3 @ B3 ) ) )
     => ( P @ Q3 ) ) ).

% Rat_induct_pos
thf(fact_5818_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_5819_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_5820_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5821_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5822_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5823_subset__UNIV,axiom,
    ! [A: $tType,A4: set @ A] : ( ord_less_eq @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_5824_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_5825_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5826_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5827_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_5828_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_5829_UN__finite__subset,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_5830_UN__finite2__eq,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),B6: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5831_Fract__coprime,axiom,
    ! [A2: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) )
      = ( fract @ A2 @ B2 ) ) ).

% Fract_coprime
thf(fact_5832_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B6: set @ A,I2: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B6 )
     => ( member @ A @ ( F2 @ I2 ) @ B6 ) ) ).

% range_subsetD
thf(fact_5833_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) ) ) ).

% not_UNIV_le_Icc
thf(fact_5834_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_UNIV_le_Iic
thf(fact_5835_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_lessThan @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_5836_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_atMost @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_5837_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A4: B > ( set @ A ),I5: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A4 @ I5 ) ) @ B6 )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ ( A4 @ X5 ) @ B6 ) ) ) ) ).

% UN_subset_iff
thf(fact_5838_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A4: set @ A,B6: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ord_less_eq @ ( set @ B ) @ ( B6 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A4 ) ) ) ) ).

% UN_upper
thf(fact_5839_UN__least,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B6: A > ( set @ B ),C6: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ord_less_eq @ ( set @ B ) @ ( B6 @ X3 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A4 ) ) @ C6 ) ) ).

% UN_least
thf(fact_5840_UN__mono,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B6: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B6 ) ) ) ) ) ).

% UN_mono
thf(fact_5841_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5842_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,A4: B > ( set @ A ),I5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A4 @ I5 ) ) )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ B6 @ ( A4 @ X5 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5843_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B6: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B6 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A4 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5844_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,C6: set @ B,B6: A > ( set @ B )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B6 @ X3 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A4 ) ) ) ) ).

% INT_greatest
thf(fact_5845_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A4: set @ A,B6: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A4 ) ) @ ( B6 @ A2 ) ) ) ).

% INT_lower
thf(fact_5846_UN__finite2__subset,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),B6: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5847_Fract__of__int__quotient,axiom,
    ( fract
    = ( ^ [K3: int,L2: int] : ( divide_divide @ rat @ ( ring_1_of_int @ rat @ K3 ) @ ( ring_1_of_int @ rat @ L2 ) ) ) ) ).

% Fract_of_int_quotient
thf(fact_5848_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5849_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5850_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_5851_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A4 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_5852_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set @ A,A4: A > ( set @ B ),F2: B > C,A9: A > ( set @ C )] :
      ( ! [I3: A,J3: A] :
          ( ( member @ A @ I3 @ I5 )
         => ( ( member @ A @ J3 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A4 @ I3 ) @ ( A4 @ J3 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A4 @ J3 ) @ ( A4 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ( bij_betw @ B @ C @ F2 @ ( A4 @ I3 ) @ ( A9 @ I3 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A4 @ I5 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I5 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5853_suminf__eq__SUP__real,axiom,
    ! [X8: nat > real] :
      ( ( summable @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X8 @ I3 ) )
       => ( ( suminf @ real @ X8 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X8 @ ( set_ord_lessThan @ nat @ I ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_5854_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I3 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N8: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N8 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ M3 @ N8 )
                     => ( ( ord_less @ nat @ M3 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M3 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ( F2 @ N8 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5855_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X8: set @ A,A4: set @ ( product_prod @ A @ B ),Y7: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X8
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A4 ) )
     => ( ( Y7
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A4 ) )
       => ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ! [Xa3: B] :
                  ( ( member @ B @ Xa3 @ Y7 )
                 => ( ( P @ X3 @ Xa3 )
                   => ( Q @ X3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A4 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A4 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_5856_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5857_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_5858_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_5859_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5860_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5861_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5862_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5863_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I: nat] : ( M7 @ ( plus_plus @ nat @ I @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_5864_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I: nat] : ( M7 @ ( plus_plus @ nat @ I @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_5865_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs2: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs2 ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ) ) ).

% subset_subseqs
thf(fact_5866_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X5: int] : ( plus_plus @ int @ X5 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_5867_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_5868_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_5869_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5870_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5871_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5872_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A4: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A4 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I: A] : ( finite_card @ B @ ( A4 @ I ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_5873_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_5874_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5875_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F3: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_5876_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M2: nat] : ( modulo_modulo @ nat @ M2 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_5877_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_5878_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_5879_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G @ X ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X )
        @ ( collect @ B
          @ ^ [X5: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X5 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_5880_INF__filter__not__bot,axiom,
    ! [I6: $tType,A: $tType,B6: set @ I6,F4: I6 > ( filter @ A )] :
      ( ! [X10: set @ I6] :
          ( ( ord_less_eq @ ( set @ I6 ) @ X10 @ B6 )
         => ( ( finite_finite @ I6 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F4 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F4 @ B6 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_5881_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5882_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5883_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,F4: A > ( filter @ B )] :
      ( ! [I3: A] :
          ( ( member @ A @ I3 @ I5 )
         => ! [J3: A] :
              ( ( member @ A @ J3 @ I5 )
             => ? [X6: A] :
                  ( ( member @ A @ X6 @ I5 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X6 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ I3 ) @ ( F4 @ J3 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I5 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ I5 )
              & ( ( F4 @ X5 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_5884_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_5885_Inf__filter__not__bot,axiom,
    ! [A: $tType,B6: set @ ( filter @ A )] :
      ( ! [X10: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X10 @ B6 )
         => ( ( finite_finite @ ( filter @ A ) @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X10 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B6 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_5886_int__in__range__abs,axiom,
    ! [N: nat] : ( member @ int @ ( semiring_1_of_nat @ int @ N ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_5887_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_5888_conj__subset__def,axiom,
    ! [A: $tType,A4: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A4
        @ ( collect @ A
          @ ^ [X5: A] :
              ( ( P @ X5 )
              & ( Q @ X5 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5889_root__def,axiom,
    ( root
    = ( ^ [N2: nat,X5: real] :
          ( if @ real
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N2 ) )
            @ X5 ) ) ) ) ).

% root_def
thf(fact_5890_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_5891_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_5892_length__remdups__eq,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( remdups @ A @ Xs2 )
        = Xs2 ) ) ).

% length_remdups_eq
thf(fact_5893_length__remdups__leq,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_remdups_leq
thf(fact_5894_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_5895_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) ) ).

% length_remdups_card_conv
thf(fact_5896_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_5897_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_5898_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N ) ) ) ).

% char_of_mod_256
thf(fact_5899_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_5900_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_5901_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N2: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_5902_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_5903_char_Osize_I2_J,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X15 @ X2 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_5904_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_5905_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_5906_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_5907_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_5908_char_Osize__gen,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X15 @ X2 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_5909_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_5910_DERIV__even__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_5911_DERIV__real__root__generic,axiom,
    ! [N: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_5912_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X16: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X16 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_5913_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y3: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ Z @ X5 ) )
            @ Y3
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_5914_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_5915_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y3: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z ) ) @ Y3 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_5916_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y3: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X3: real] :
                ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X )
              = ( F2 @ Y3 ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_5917_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_5918_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_5919_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_5920_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_5921_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_5922_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_5923_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_5924_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_5925_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_5926_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_5927_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E4 ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_5928_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ E4 ) @ ( times_times @ A @ D5 @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_5929_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X ) ) @ ( times_times @ A @ Db @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_5930_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ C2 )
            @ ( divide_divide @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_5931_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( times_times @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_5932_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( times_times @ A @ C2 @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_5933_has__field__derivative__sinh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X5: A11] : ( sinh @ A11 @ ( G @ X5 ) )
            @ ( times_times @ A11 @ ( cosh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_5934_has__field__derivative__cosh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X5: A11] : ( cosh @ A11 @ ( G @ X5 ) )
            @ ( times_times @ A11 @ ( sinh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_5935_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_5936_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X5: A] : K
          @ ( zero_zero @ A )
          @ F4 ) ) ).

% DERIV_const
thf(fact_5937_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F4: filter @ A,G: A > A,G4: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G4 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] : ( plus_plus @ A @ ( F2 @ Z5 ) @ ( G @ Z5 ) )
              @ ( plus_plus @ A @ F8 @ G4 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_5938_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ D5 @ E4 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_5939_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_5940_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_5941_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y3: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_5942_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_5943_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G4: real > real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G4 @ X3 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_5944_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_5945_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_5946_DERIV__isconst__all,axiom,
    ! [F2: real > real,X: real,Y3: real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X )
        = ( F2 @ Y3 ) ) ) ).

% DERIV_isconst_all
thf(fact_5947_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y3: A,X: A,Z: A] :
          ( ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ Z ) )
            @ Y3
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_5948_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_5949_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_5950_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( exp @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_5951_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( sin @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_5952_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ ( F2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
              @ ( times_times @ A @ E4 @ D5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_5953_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_5954_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G4: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X3: A] : ( has_field_derivative @ A @ G @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
              @ ( times_times @ A @ F8 @ ( G4 @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_5955_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G4: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S )
             => ( has_field_derivative @ A @ G @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( times_times @ A @ F8 @ ( G4 @ ( F2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_5956_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_5957_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z2: real] :
            ( ( ord_less @ real @ A2 @ Z2 )
            & ( ord_less @ real @ Z2 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F8 @ Z2 ) ) ) ) ) ) ).

% MVT2
thf(fact_5958_DERIV__local__const,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ D2 )
             => ( ( F2 @ X )
                = ( F2 @ Y ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_5959_DERIV__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_5960_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( cos @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_5961_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa: A] :
          ( has_field_derivative @ A
          @ ^ [X5: A] : ( cos @ A @ ( plus_plus @ A @ X5 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_5962_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( power_power @ A @ ( F2 @ X5 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_5963_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_5964_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_5965_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( power_power @ A @ ( F2 @ X5 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_5966_DERIV__local__max,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y ) @ ( F2 @ X ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_5967_DERIV__local__min,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X ) @ ( F2 @ Y ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_5968_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_5969_DERIV__pow,axiom,
    ! [N: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X5: real] : ( power_power @ real @ X5 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_5970_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_5971_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_5972_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X5: real] : ( power_power @ real @ ( G @ X5 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_5973_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_5974_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,G: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E2 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y5: A] : ( divide_divide @ A @ ( F2 @ Y5 ) @ ( G @ Y5 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X ) ) @ ( times_times @ A @ E2 @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_5975_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_5976_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F8: A,Z: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) )
                @ ( F2 @ Z2 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) )
                @ F8 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_5977_has__real__derivative__powr,axiom,
    ! [Z: real,R3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z5: real] : ( powr @ real @ Z5 @ R3 )
        @ ( times_times @ real @ R3 @ ( powr @ real @ Z @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_5978_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F8: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X5: real] : ( F2 @ X5 @ N3 )
          @ ( F8 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X3 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F8 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N3: nat,X3: real,Y: real] :
                    ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X3 @ N3 ) @ ( F2 @ Y @ N3 ) ) ) @ ( times_times @ real @ ( L5 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X5: real] : ( suminf @ real @ ( F2 @ X5 ) )
                  @ ( suminf @ real @ ( F8 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_5979_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z: A] :
          ( ! [Z2: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_5980_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_5981_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X5: A] :
                      ( suminf @ A
                      @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) )
                  @ ( suminf @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_5982_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_5983_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X: real,R3: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X5: real] : ( powr @ real @ ( G @ X5 ) @ R3 )
          @ ( times_times @ real @ ( times_times @ real @ R3 @ ( powr @ real @ ( G @ X ) @ ( minus_minus @ real @ R3 @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_5984_DERIV__powr,axiom,
    ! [G: real > real,M: real,X: real,F2: real > real,R3: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R3 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X5: real] : ( powr @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R3 @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_5985_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_5986_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_5987_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_5988_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_5989_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_5990_has__field__derivative__tanh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,X: A11,Db: A11,S: set @ A11] :
          ( ( ( cosh @ A11 @ ( G @ X ) )
           != ( zero_zero @ A11 ) )
         => ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
           => ( has_field_derivative @ A11
              @ ^ [X5: A11] : ( tanh @ A11 @ ( G @ X5 ) )
              @ ( times_times @ A11 @ ( minus_minus @ A11 @ ( one_one @ A11 ) @ ( power_power @ A11 @ ( tanh @ A11 @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_5991_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_5992_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_5993_artanh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_5994_DERIV__power__series_H,axiom,
    ! [R: real,F2: nat > real,X0: real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R ) @ R ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X3 @ N2 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R ) @ R ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( has_field_derivative @ real
            @ ^ [X5: real] :
                ( suminf @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( F2 @ N2 ) @ ( power_power @ real @ X5 @ ( suc @ N2 ) ) ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X0 @ N2 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_5995_DERIV__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_5996_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_5997_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_5998_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_5999_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T3: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6000_DERIV__odd__real__root,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6001_Maclaurin,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M3: nat,T3: real] :
                ( ( ( ord_less @ nat @ M3 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
                  & ( ord_less_eq @ real @ T3 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
                & ( ord_less @ real @ T3 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H2 @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6002_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( ( ord_less @ nat @ M3 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
                & ( ord_less_eq @ real @ T3 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
              & ( ord_less_eq @ real @ T3 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H2 @ M2 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6003_Maclaurin__minus,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M3: nat,T3: real] :
                ( ( ( ord_less @ nat @ M3 @ N )
                  & ( ord_less_eq @ real @ H2 @ T3 )
                  & ( ord_less_eq @ real @ T3 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ H2 @ T3 )
                & ( ord_less @ real @ T3 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H2 @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6004_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T3 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6005_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M3: nat,T3: real] :
            ( ( ( ord_less @ nat @ M3 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6006_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( ( ord_less @ nat @ M3 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T3: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T3 )
                            & ( ord_less @ real @ T3 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T3 )
                            & ( ord_less @ real @ T3 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M2 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6007_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( ( ord_less @ nat @ M3 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T3: real] :
                  ( ( ord_less @ real @ C2 @ T3 )
                  & ( ord_less @ real @ T3 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M2 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6008_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T3: real] :
              ( ( ( ord_less @ nat @ M3 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T3: real] :
                  ( ( ord_less @ real @ A2 @ T3 )
                  & ( ord_less @ real @ T3 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M2 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6009_Maclaurin__lemma2,axiom,
    ! [N: nat,H2: real,Diff: nat > real > real,K: nat,B6: real] :
      ( ! [M3: nat,T3: real] :
          ( ( ( ord_less @ nat @ M3 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less_eq @ real @ T3 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M6: nat,T8: real] :
            ( ( ( ord_less @ nat @ M6 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M6 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M6 @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ U2 @ P6 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M6 ) ) )
                    @ ( times_times @ real @ B6 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M6 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M6 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M6 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M6 ) @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ T8 @ P6 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M6 ) ) ) )
                  @ ( times_times @ real @ B6 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M6 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M6 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6010_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( arcsin @ ( G @ X5 ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6011_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( arccos @ ( G @ X5 ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6012_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( tan @ real @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6013_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ F4 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6014_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A > A,F4: filter @ A,D7: A] :
          ( ( has_derivative @ A @ A @ F2 @ D5 @ F4 )
         => ( ! [X3: A] :
                ( ( times_times @ A @ X3 @ D7 )
                = ( D5 @ X3 ) )
           => ( has_field_derivative @ A @ F2 @ D7 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6015_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F3: A > A,D8: A] : ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D8 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6016_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F8: D > real,X: D,S: set @ D,G: D > C,G4: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G4 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X5: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G4 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6017_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6018_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F4: filter @ A,G: A > B,G4: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G4 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [X5: A] : ( plus_plus @ B @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_6019_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F4: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X5: A] : C2
          @ ^ [X5: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% has_derivative_const
thf(fact_6020_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,Y3: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ ( G @ X5 ) @ Y3 )
            @ ^ [X5: C] : ( times_times @ A @ ( G4 @ X5 ) @ Y3 )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_6021_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,X: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ X @ ( G @ X5 ) )
            @ ^ [X5: C] : ( times_times @ A @ X @ ( G4 @ X5 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_6022_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: A > B,X: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X5: A] : ( zero_zero @ B )
            @ F4
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( F4
            = ( ^ [H: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_6023_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F8: D > A,X: D,S: set @ D,G: D > A,G4: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G4 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ ( G4 @ H ) ) @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6024_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G4: A > A > B,F2: C > A,S: set @ C,X: C,F8: C > A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X5: C] : ( G @ ( F2 @ X5 ) )
                  @ ^ [Y5: C] : ( G4 @ ( F2 @ X ) @ ( F8 @ Y5 ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6025_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( exp @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( exp @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_6026_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( sin @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( cos @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_6027_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( cosh @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_6028_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( sinh @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_6029_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S2: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G4 @ H ) ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6030_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F8: C > A,S2: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X5: C] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F8 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6031_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6032_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F8: real,G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F8 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ F8 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6033_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( cos @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_6034_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S2: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
            @ ^ [Y5: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F8 @ Y5 ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_6035_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( ln_ln @ real @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( inverse_inverse @ real @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6036_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S2: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X ) ) @ ( G4 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X ) ) ) ) @ ( divide_divide @ A @ ( F8 @ H ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6037_has__derivative__prod,axiom,
    ! [B: $tType,I6: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I5: set @ I6,F2: I6 > A > B,F8: I6 > A > B,X: A,S2: set @ A] :
          ( ! [I3: I6] :
              ( ( member @ I6 @ I3 @ I5 )
             => ( has_derivative @ A @ B @ ( F2 @ I3 ) @ ( F8 @ I3 ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X5: A] :
                ( groups7121269368397514597t_prod @ I6 @ B
                @ ^ [I: I6] : ( F2 @ I @ X5 )
                @ I5 )
            @ ^ [Y5: A] :
                ( groups7311177749621191930dd_sum @ I6 @ B
                @ ^ [I: I6] :
                    ( times_times @ B @ ( F8 @ I @ Y5 )
                    @ ( groups7121269368397514597t_prod @ I6 @ B
                      @ ^ [J: I6] : ( F2 @ J @ X )
                      @ ( minus_minus @ ( set @ I6 ) @ I5 @ ( insert @ I6 @ I @ ( bot_bot @ ( set @ I6 ) ) ) ) ) )
                @ I5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_prod
thf(fact_6038_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,X8: set @ A,F2: A > real,F8: A > real] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
             => ( ( member @ A @ X @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X5: A] : ( powr @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F8 @ H ) @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G4 @ H ) @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6039_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( sqrt @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6040_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( arctan @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_6041_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X: A,F2: real > Aa,G4: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X5 ) ) ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G4 @ X5 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6042_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H ) @ N2 ) @ ( power_power @ A @ X @ N2 ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6043_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6044_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6045_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X5: A] : ( power_power @ real @ ( F2 @ X5 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6046_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6047_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y5 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6048_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y5 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6049_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L: filter @ B,X: A,S2: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_6050_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6051_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X5: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_6052_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6053_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6054_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6055_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6056_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6057_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( artanh @ real @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_6058_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_6059_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X5: B] : ( arcosh @ real @ ( F2 @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_6060_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6061_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6062_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_6063_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6064_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6065_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6066_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X5: D] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6067_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_6068_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_6069_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F4: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_6070_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_6071_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_6072_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6073_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6074_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6075_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_6076_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_6077_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6078_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6079_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_6080_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( sqrt @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_6081_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6082_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6083_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_6084_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_6085_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A,N: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( root @ N @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N @ X ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_6086_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6087_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_cot
thf(fact_6088_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tanh
thf(fact_6089_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tan
thf(fact_6090_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_ln
thf(fact_6091_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_6092_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_6093_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_norm_zero
thf(fact_6094_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr
thf(fact_6095_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( sgn_sgn @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_sgn
thf(fact_6096_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_inverse
thf(fact_6097_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X5: B] : ( plus_plus @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6098_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6099_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_6100_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_rabs_zero
thf(fact_6101_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_6102_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_6103_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( F2 @ X5 @ I3 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F4 ) ) ) ).

% tendsto_null_sum
thf(fact_6104_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F4: filter @ B,F11: filter @ B,F2: B > A,L: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F11 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mono
thf(fact_6105_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F24: filter @ B,F13: filter @ A,F25: filter @ B,F14: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ F24 @ F13 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F24 @ F25 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F14 @ F13 )
         => ( filterlim @ A @ B @ F2 @ F25 @ F14 ) ) ) ) ).

% filterlim_mono
thf(fact_6106_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X3 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6107_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6108_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y3: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y3 )
         => ( ( ord_less_eq @ B @ Y3 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y3 ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6109_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y3: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y3 )
         => ( ( ord_less_eq @ B @ Y3 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y3 ) ) ) ) ) ) ) ).

% IVT
thf(fact_6110_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R: real,A2: A,F2: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ R )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6111_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X5: A] :
                        ( ( ( X5 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S7 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6112_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L5 ) ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6113_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R3: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X6: A] :
                    ( ( ( X6 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X6 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X6 ) @ L5 ) ) @ R3 ) ) ) ) ) ) ).

% LIM_D
thf(fact_6114_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X5 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X5 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6115_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M9: real] :
            ( ! [X6: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X6 )
                  & ( ord_less_eq @ real @ X6 @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X6 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X6 ) @ M9 ) ) )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ M9 ) )
               => ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y4 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6116_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X6: real] :
                ( ( ( X6 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X6 ) ) @ R2 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X6 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6117_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X6: real] :
                ( ( ( X6 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X6 ) ) @ R2 ) )
               => ( ( F2 @ X6 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6118_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X6: real] :
                ( ( ( X6 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X6 ) ) @ R2 ) )
               => ( ord_less @ real @ ( F2 @ X6 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6119_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6120_isCont__real__sqrt,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_6121_isCont__real__root,axiom,
    ! [X: real,N: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( root @ N ) ) ).

% isCont_real_root
thf(fact_6122_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6123_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6124_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6125_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_6126_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_6127_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_6128_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6129_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6130_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( one_one @ A ) ) @ Z5 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6131_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6132_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
              ! [X6: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X6 )
                  & ( ord_less_eq @ real @ X6 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X6 ) @ M9 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6133_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X6: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X6 )
                      & ( ord_less_eq @ real @ X6 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X6 ) @ M9 ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M9 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6134_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X6: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X6 )
                      & ( ord_less_eq @ real @ X6 @ B2 ) )
                   => ( ord_less_eq @ A @ M9 @ ( F2 @ X6 ) ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M9 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6135_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ A2 @ Z2 )
             => ( ( ord_less_eq @ real @ Z2 @ B2 )
               => ( ( G @ ( F2 @ Z2 ) )
                  = Z2 ) ) )
         => ( ! [Z2: real] :
                ( ( ord_less_eq @ real @ A2 @ Z2 )
               => ( ( ord_less_eq @ real @ Z2 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6136_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6137_isCont__ln,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_6138_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6139_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_6140_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6141_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_6142_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_6143_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: C,A4: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A4 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A4 )
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_6144_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G2: A > A] :
                ( ! [Z5: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z5 ) @ ( F2 @ X ) )
                    = ( times_times @ A @ ( G2 @ Z5 ) @ ( minus_minus @ A @ Z5 @ X ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ G2 )
                & ( ( G2 @ X )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6145_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X6: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X6 )
                      & ( ord_less_eq @ real @ X6 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X6 ) @ M9 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M9 )
                   => ? [X3: real] :
                        ( ( ord_less_eq @ real @ A2 @ X3 )
                        & ( ord_less_eq @ real @ X3 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6146_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_6147_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6148_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6149_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_6150_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_6151_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X3: A] :
                ( ( X3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S )
                 => ( sums @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
                    @ ( F2 @ X3 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6152_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S )
               => ( sums @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
                  @ ( F2 @ X3 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6153_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6154_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_6155_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6156_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X5: real] : ( divide_divide @ real @ ( cos @ real @ X5 ) @ ( sin @ real @ X5 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6157_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_6158_DERIV__inverse__function,axiom,
    ! [F2: real > real,D5: real,G: real > real,X: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D5 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D5
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X )
         => ( ( ord_less @ real @ X @ B2 )
           => ( ! [Y: real] :
                  ( ( ord_less @ real @ A2 @ Y )
                 => ( ( ord_less @ real @ Y @ B2 )
                   => ( ( F2 @ ( G @ Y ) )
                      = Y ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D5 ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6159_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ W3 @ I ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_6160_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6161_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6162_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X5: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6163_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6164_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6165_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z2: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z2 @ X ) ) @ D2 )
           => ( ( G @ ( F2 @ Z2 ) )
              = Z2 ) )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z2 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6166_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G4: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z2: real] :
            ( ( ord_less_eq @ real @ A2 @ Z2 )
           => ( ( ord_less_eq @ real @ Z2 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z2: real] :
              ( ( ord_less_eq @ real @ A2 @ Z2 )
             => ( ( ord_less_eq @ real @ Z2 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
               => ( ( ord_less @ real @ Z2 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G4 @ Z2 ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z2: real] :
                  ( ( ord_less @ real @ A2 @ Z2 )
                 => ( ( ord_less @ real @ Z2 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F8 @ Z2 ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G4 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F8 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6167_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ A @ ( F2 @ X ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X5: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X5 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_6168_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ K5 @ N2 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X5: A] :
                    ( suminf @ Aa
                    @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ ( F2 @ X5 ) @ N2 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6169_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6170_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_6171_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_6172_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_6173_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( A2 @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_6174_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_6175_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ ( U3 @ N7 ) @ X )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_6176_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ X @ ( U3 @ N7 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_6177_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: nat > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X5: nat] : ( F2 @ ( suc @ X5 ) )
        @ F4
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F2 @ F4 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_6178_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_6179_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X5: A] : ( sqrt @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_6180_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X5: A] : ( root @ N @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_real_root
thf(fact_6181_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_6182_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_6183_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_6184_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_6185_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ ( X8 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_6186_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_6187_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N5: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C6 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_6188_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C6 ) )
           => ( ord_less_eq @ A @ L @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_6189_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,Y7: nat > A,Y3: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y7 @ N3 ) ) )
             => ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6190_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N5: nat,X8: nat > A,Y7: nat > A,X: A,Y3: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N5 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y7 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ) ).

% lim_mono
thf(fact_6191_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_6192_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6193_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_6194_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S )
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_6195_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,S: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_6196_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X5: nat] : ( times_times @ nat @ X5 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6197_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6198_monoseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( topological_monoseq @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X8 @ I3 ) ) @ B6 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6199_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( root @ N2 @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_6200_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_6201_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_6202_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N7: nat] : ( ord_less_eq @ A @ ( A2 @ N7 ) @ X )
                & ! [M6: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M6 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ M6 ) @ ( A2 @ N7 ) ) ) )
              | ( ! [N7: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N7 ) )
                & ! [M6: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M6 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ N7 ) @ ( A2 @ M6 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6203_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N2: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6204_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_6205_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X: A,L: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( X8 @ ( times_times @ nat @ N2 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6206_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) ) ) ) ) ).

% telescope_summable
thf(fact_6207_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6208_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N2: nat] : ( minus_minus @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L3: real] :
                ( ! [N7: nat] : ( ord_less_eq @ real @ ( F2 @ N7 ) @ L3 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) )
                & ! [N7: nat] : ( ord_less_eq @ real @ L3 @ ( G @ N7 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6209_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R2: real] :
        ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less @ real @ R2 @ ( X8 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( X8 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6210_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6211_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( root @ N2 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6212_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_6213_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R3 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6214_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6215_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ L )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N7: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F2 @ N7 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6216_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6217_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6218_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6219_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6220_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6221_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6222_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6223_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6224_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6225_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6226_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F3: nat > A,S7: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S7 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_6227_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N2: nat] : ( root @ N2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_6228_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R3 @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6229_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6230_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A,R3: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [No: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No @ N7 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N7 ) @ L5 ) ) @ R3 ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6231_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L5 ) ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6232_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N2 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6233_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6234_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6235_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y5: B] : ( power_power @ A @ X @ ( F2 @ Y5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6236_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( times_times @ real @ R3 @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6237_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6238_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6239_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z @ ( S @ N2 ) ) ) @ ( F2 @ Z ) ) @ ( S @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6240_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6241_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6242_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ) ).

% summable
thf(fact_6243_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J: nat] : ( minus_minus @ real @ ( Theta @ J ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6244_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J: nat] : ( cos @ real @ ( Theta @ J ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J: nat] : ( minus_minus @ real @ ( Theta @ J ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6245_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6246_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6247_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6248_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6249_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L3: real] :
              ( ! [N7: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                  @ L3 )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) )
              & ! [N7: nat] :
                  ( ord_less_eq @ real @ L3
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6250_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6251_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_6252_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I ) @ ( A2 @ I ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6253_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6254_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6255_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y3: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X5: A] : ( divide_divide @ A @ X5 @ Y3 ) ) ) ).

% bounded_linear_divide
thf(fact_6256_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X ) ) ) ).

% bounded_linear_mult_right
thf(fact_6257_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y3: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ ( G @ X5 ) @ Y3 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6258_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ X @ ( G @ X5 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6259_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y3: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X5: A] : ( times_times @ A @ X5 @ Y3 ) ) ) ).

% bounded_linear_mult_left
thf(fact_6260_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F3: real > real] :
        ? [C4: real] :
          ( F3
          = ( ^ [X5: real] : ( times_times @ real @ X5 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6261_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X5: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_6262_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6263_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X6 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X6 ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6264_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X5: C] : ( F2 @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_6265_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X6 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X6 ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6266_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X6: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X6 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X6 ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6267_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X3: A,Y: A] :
              ( ( F2 @ ( plus_plus @ A @ X3 @ Y ) )
              = ( plus_plus @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
         => ( ! [R2: real,X3: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R2 @ X3 ) )
                = ( real_V8093663219630862766scaleR @ B @ R2 @ ( F2 @ X3 ) ) )
           => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6268_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ real
              @ ^ [Y5: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6269_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F8: A > B,X: A,F2: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F8 )
         => ( ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_6270_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_6271_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ? [E3: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E3 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6272_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_6273_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F3: A > B,F15: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F15 )
              & ( filterlim @ A @ B
                @ ^ [Y5: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F3 @ Y5 )
                        @ ( F3
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) )
                      @ ( F15
                        @ ( minus_minus @ A @ Y5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_6274_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S2: set @ A,F2: A > B,F8: A > B] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
                & ? [E3: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H ) @ S2 )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E3 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_6275_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I4: nat] :
              ( ( member @ A @ X @ ( A8 @ I4 ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) ) )
          & ! [S9: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S9 )
                & ( member @ A @ X @ S9 ) )
             => ? [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S9 ) ) ) ) ).

% first_countable_basis
thf(fact_6276_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X5: A] :
              ( ( member @ A @ X5 @ S6 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X5 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S6 ) ) ) ) ) ) ).

% open_subopen
thf(fact_6277_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S2 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X3 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_6278_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A4: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less @ A @ X @ X3 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A4 ) @ A4 ) ) ) ) ).

% Inf_notin_open
thf(fact_6279_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A4: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less @ A @ X3 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A4 ) @ A4 ) ) ) ) ).

% Sup_notin_open
thf(fact_6280_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S2: set @ A,T6: set @ A] :
          ( ( member @ A @ A2 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T6 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_6281_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y3: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ X @ Y3 )
             => ? [B3: A] :
                  ( ( ord_less @ A @ X @ B3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B3 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_6282_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S6 )
               => ( ( member @ A @ F0 @ S6 )
                 => ? [N6: nat] :
                    ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N2 )
                     => ( member @ A @ ( F2 @ N2 ) @ S6 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_6283_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X5: A] : X5 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6284_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_6285_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_6286_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X5: A] : X5 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F4
                @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_6287_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_6288_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X5: A] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_6289_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X5: A] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_6290_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F4
                    @ ^ [X5: C] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F4
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_6291_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X5: A] : X5 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X5: A] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6292_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S2: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_6293_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X5: A] : X5 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X5: A] : X5 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X5: A] : X5 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6294_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F8: A > B,S: set @ A,X: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F8 )
           => ( ! [Y: A] :
                  ( ( member @ A @ Y @ S )
                 => ( ( Y != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) ) @ ( H6 @ Y ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_6295_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y5 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y5 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_6296_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I2 ) ) ) ).

% greaterThan_iff
thf(fact_6297_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_6298_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_6299_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ X @ X )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_6300_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X @ Y3 )
            = ( zero_zero @ real ) )
          = ( X = Y3 ) ) ) ).

% dist_eq_0_iff
thf(fact_6301_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_6302_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X )
          = ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% dist_0_norm
thf(fact_6303_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) )
          = ( ( X != Y3 ) ) ) ) ).

% zero_less_dist_iff
thf(fact_6304_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ ( zero_zero @ real ) )
          = ( X = Y3 ) ) ) ).

% dist_le_zero_iff
thf(fact_6305_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_6306_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: real,A2: A,Y3: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y3 @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_6307_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y5 ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_6308_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) ) ) ) ).

% dist_pos_lt
thf(fact_6309_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_6310_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y3: A,X: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_6311_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less @ A @ L2 ) ) ) ) ) ).

% greaterThan_def
thf(fact_6312_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y3: A,E1: real,X2: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y3 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y3 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X2 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_6313_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y3: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y3 @ Z ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_6314_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X5: A] : ( real_V557655796197034286t_dist @ A @ X5 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_6315_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y3: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ ( real_V557655796197034286t_dist @ A @ Y3 @ Z ) ) ) ) ).

% dist_triangle
thf(fact_6316_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A,Z: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y3 @ Z ) ) ) ) ).

% dist_triangle2
thf(fact_6317_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y3 ) ) ) ) ).

% dist_triangle3
thf(fact_6318_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y3: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y3 @ Z ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) @ E2 ) ) ) ).

% dist_triangle_le
thf(fact_6319_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y3 ) ) ) ).

% zero_le_dist
thf(fact_6320_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X5: A] :
              ( ( member @ A @ X5 @ S6 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y5: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X5 ) @ E3 )
                     => ( member @ A @ Y5 @ S6 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_6321_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_6322_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_6323_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,A2: A,S2: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S2 )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D2 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( has_field_derivative @ A @ G @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_6324_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X @ S )
             => ( ! [X17: A] :
                    ( ( member @ A @ X17 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X ) @ D2 )
                     => ( ( F2 @ X17 )
                        = ( G @ X17 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_6325_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_6326_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M9: nat] :
              ! [M6: nat] :
                ( ( ord_less_eq @ nat @ M9 @ M6 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M9 @ N7 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M6 ) @ ( X8 @ N7 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_6327_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S7: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S7 @ N2 ) @ ( S7 @ N6 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_6328_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X9: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_6329_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ? [A3: A,B3: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A3 ) )
              & ( member @ A @ Y3 @ ( set_ord_greaterThan @ A @ B3 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A3 ) @ ( set_ord_greaterThan @ A @ B3 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_6330_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( plus_plus @ real @ X5 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_6331_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X3: C] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X3 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_6332_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L: B,X: A,S2: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X17: A] :
                  ( ( member @ A @ X17 @ S2 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X17 @ X ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X ) @ D2 )
                     => ( ( F2 @ X17 )
                        = ( G @ X17 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_6333_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y3: A,E2: real,X2: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y3 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y3 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X2 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_6334_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y3: A,X15: A,E2: real,X2: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X15 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X2 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_6335_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X2: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_6336_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G5: filter @ B,X: A,S2: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G5 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X17: A] :
                    ( ( member @ A @ X17 @ S2 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X17 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X ) @ D2 )
                       => ( ( F2 @ X17 )
                          = ( G @ X17 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_6337_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M2 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ M2 ) @ ( F3 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_6338_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M3 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_6339_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_dist_iff
thf(fact_6340_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P4: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P4 @ ( set_ord_greaterThan @ A @ P4 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P4 ) )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_6341_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X5: A] :
                        ( ( ( X5 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S7 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_6342_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R3: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X6: A] :
                    ( ( ( X6 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X6 @ A2 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X6 ) @ L5 ) @ R3 ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_6343_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L5 ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_6344_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A2: A,R: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ R )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_6345_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A,R3: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [No: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No @ N7 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N7 ) @ L5 ) @ R3 ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_6346_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_6347_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_6348_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X9: nat > A] :
            ! [J: nat] :
            ? [M8: nat] :
            ! [M2: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M2 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_6349_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_6350_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_6351_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_6352_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( if @ B @ ( ord_less_eq @ A @ X5 @ A2 ) @ ( G @ X5 ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_6353_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No3 )
                    & ! [N2: nat] :
                        ( ( ord_less_eq @ nat @ No3 @ N2 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_6354_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S6: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S6
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X5: A] :
                            ( collect @ A
                            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E3 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_6355_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_6356_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_6357_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_6358_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_6359_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_6360_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_6361_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_6362_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_6363_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ X3 @ B2 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_6364_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X5: real] : ( power_power @ real @ ( F2 @ X5 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_6365_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_6366_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X5: real] : ( power_power @ real @ ( F2 @ X5 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_6367_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X5: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_6368_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_6369_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_6370_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6371_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( plus_plus @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_add_at_top
thf(fact_6372_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_6373_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( plus_plus @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_tendsto_add_at_top
thf(fact_6374_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( power_power @ real @ ( F2 @ X5 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6375_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6376_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6377_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_6378_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_6379_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_6380_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6381_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6382_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_6383_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6384_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X5: real] : ( divide_divide @ real @ ( ln_ln @ real @ X5 ) @ X5 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6385_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6386_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( inverse_inverse @ real @ X5 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_6387_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( inverse_inverse @ real @ X5 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_6388_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6389_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_6390_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_6391_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_6392_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6393_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X5: real] : ( divide_divide @ real @ ( power_power @ real @ X5 @ K ) @ ( exp @ real @ X5 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6394_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( inverse_inverse @ B @ ( G @ X5 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F4 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_6395_tendsto__exp__limit__at__top,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ Y5 ) ) @ Y5 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6396_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6397_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6398_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ B2 @ X3 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6399_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6400_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6401_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_6402_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B6: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z5: A] :
                    ( ord_less_eq @ real @ B6
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I: nat] : ( times_times @ A @ ( C2 @ I ) @ ( power_power @ A @ Z5 @ I ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6403_lhopital__left__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F8: real > real,Y3: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G4 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6404_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I: nat] : ( P @ ( suc @ I ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_6405_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N2: nat] : ( P @ ( plus_plus @ nat @ N2 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6406_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N2 )
           => ( P @ N2 ) ) ) ) ).

% eventually_sequentially
thf(fact_6407_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X3: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X3 )
         => ( P @ X3 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6408_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6409_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ C2 @ X3 )
             => ( P @ X3 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6410_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_6411_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6412_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I: nat] : ( P @ ( plus_plus @ nat @ I @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6413_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6414_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6415_filter__leD,axiom,
    ! [A: $tType,F4: filter @ A,F11: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ( eventually @ A @ P @ F11 )
       => ( eventually @ A @ P @ F4 ) ) ) ).

% filter_leD
thf(fact_6416_filter__leI,axiom,
    ! [A: $tType,F11: filter @ A,F4: filter @ A] :
      ( ! [P8: A > $o] :
          ( ( eventually @ A @ P8 @ F11 )
         => ( eventually @ A @ P8 @ F4 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 ) ) ).

% filter_leI
thf(fact_6417_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
          ! [P3: A > $o] :
            ( ( eventually @ A @ P3 @ F10 )
           => ( eventually @ A @ P3 @ F9 ) ) ) ) ).

% le_filter_def
thf(fact_6418_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F4: filter @ B,G5: filter @ A,F11: filter @ B,G6: filter @ A,F8: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F4 @ G5 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G6 @ G5 )
         => ( ( eventually @ A
              @ ^ [X5: A] :
                  ( ( F2 @ X5 )
                  = ( F8 @ X5 ) )
              @ G6 )
           => ( filterlim @ A @ B @ F8 @ F11 @ G6 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_6419_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ A @ X5 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6420_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6421_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X5: A] : ( ord_less_eq @ A @ X5 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6422_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6423_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ ( top_top @ A ) )
                  & ! [Z5: A] :
                      ( ( ord_less @ A @ B4 @ Z5 )
                     => ( P @ Z5 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6424_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X3: A,Y: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y )
               => ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6425_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ B4 @ X )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ B4 @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ X )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6426_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y3: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ B4 @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ X )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6427_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y3: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ X @ B4 )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ X @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ B4 )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_6428_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ X @ B4 )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ X @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ B4 )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6429_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
              ! [X5: A] :
                ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X5 ) )
               => ( P @ X5 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6430_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N2: B] : ( ord_less_eq @ A @ ( G @ N2 ) @ ( H2 @ N2 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6431_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y3: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ F4 )
         => ( ( ord_less @ A @ Y3 @ A2 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6432_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y3: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y3 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ A @ A2 @ ( F2 @ X5 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6433_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y3: A,F2: B > A,F4: filter @ B] :
          ( ! [A3: A] :
              ( ( ord_less @ A @ A3 @ Y3 )
             => ( eventually @ B
                @ ^ [X5: B] : ( ord_less @ A @ A3 @ ( F2 @ X5 ) )
                @ F4 ) )
         => ( ! [A3: A] :
                ( ( ord_less @ A @ Y3 @ A3 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ A3 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_6434_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L2: A] :
                ( ( ord_less @ A @ L2 @ X )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ L2 @ ( F2 @ X5 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X @ U2 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6435_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6436_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6437_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_6438_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less @ B @ Z9 @ ( F2 @ X5 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6439_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_6440_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6441_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6442_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6443_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N2: B] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N2: B] : ( ord_less_eq @ real @ ( G @ N2 ) @ ( H2 @ N2 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6444_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I4: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) )
             => ( ! [I4: nat] : ( member @ A @ X @ ( A8 @ I4 ) )
               => ~ ! [S9: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S9 )
                     => ( ( member @ A @ X @ S9 )
                       => ( eventually @ nat
                          @ ^ [I: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I ) @ S9 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_6445_eventually__Inf__base,axiom,
    ! [A: $tType,B6: set @ ( filter @ A ),P: A > $o] :
      ( ( B6
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F5: filter @ A] :
            ( ( member @ ( filter @ A ) @ F5 @ B6 )
           => ! [G3: filter @ A] :
                ( ( member @ ( filter @ A ) @ G3 @ B6 )
               => ? [X6: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X6 @ B6 )
                    & ( ord_less_eq @ ( filter @ A ) @ X6 @ ( inf_inf @ ( filter @ A ) @ F5 @ G3 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B6 ) )
          = ( ? [X5: filter @ A] :
                ( ( member @ ( filter @ A ) @ X5 @ B6 )
                & ( eventually @ A @ P @ X5 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_6446_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ S2 )
                   => ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 ) )
                     => ( P @ X5 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6447_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 )
                   => ( P @ X5 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6448_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6449_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_6450_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X5: A] : ( P @ ( plus_plus @ A @ X5 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6451_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ L @ ( F2 @ N2 ) )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ L @ X3 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ ( F2 @ N2 ) @ X3 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6452_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ L )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ L )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ X3 @ ( F2 @ N2 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_6453_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6454_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6455_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I: B] : ( ord_less_eq @ A @ ( F2 @ I ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6456_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6457_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G: B > A,Y3: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y3 ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X5: B] : ( ord_less_eq @ A @ ( G @ X5 ) @ ( F2 @ X5 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y3 @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6458_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X5: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X5 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6459_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6460_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6461_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( plus_plus @ real @ X5 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_6462_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B6: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B6 ) ) )
      = ( ? [X9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X9 @ B6 )
            & ( finite_finite @ B @ X9 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X9 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6463_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X5: A] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6464_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X5: real] : ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_6465_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X5: real] : ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_6466_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ S2 )
                   => ( ( ( X5 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 ) )
                     => ( P @ X5 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_6467_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P4: A > $o] :
          ( ( eventually @ A @ P4 @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B4 )
                & ! [X5: A] :
                    ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X5 ) )
                   => ( P4 @ X5 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6468_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6469_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ L5 @ ( F2 @ X5 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_6470_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E3 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_6471_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E )
                @ F4 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% tendstoI
thf(fact_6472_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E2 )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_6473_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B6: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B6 ) )
      = ( ? [X9: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X9 @ B6 )
            & ( finite_finite @ ( filter @ A ) @ X9 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X9 ) ) ) ) ) ).

% eventually_Inf
thf(fact_6474_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6475_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( inverse_inverse @ real @ X5 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_6476_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( inverse_inverse @ real @ X5 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_6477_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X5: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X5: B] : ( arcosh @ real @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6478_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y )
               => ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B3: A] :
                      ( ( Q @ B3 )
                     => ( ord_less @ A @ B3 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6479_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B6: set @ A,F4: A > ( filter @ B ),P: B > $o] :
      ( ( B6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A3: A] :
            ( ( member @ A @ A3 @ B6 )
           => ! [B3: A] :
                ( ( member @ A @ B3 @ B6 )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ B6 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X6 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ A3 ) @ ( F4 @ B3 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ B6 ) ) )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ B6 )
                & ( eventually @ B @ P @ ( F4 @ X5 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_6480_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y )
               => ( ( ord_less_eq @ A @ X3 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B3: A] :
                      ( ( Q @ B3 )
                     => ( ord_less @ A @ A2 @ B3 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_6481_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_6482_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X5: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_6483_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6484_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6485_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_6486_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X5 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_6487_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6488_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6489_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_6490_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_6491_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_6492_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_6493_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_6494_lhopital,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G4 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6495_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_6496_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_6497_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_6498_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F8: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G4 @ X5 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6499_lhopital__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F8: real > real,Y3: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G4 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6500_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G0 @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G4 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F0 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G0 @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F0 @ X5 ) @ ( G0 @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_6501_lhopital__right,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G4 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_6502_lhopital__left,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G4 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6503_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_6504_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_6505_lhopital__right__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F8: real > real,Y3: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G4 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y3 )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_6506_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F8: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G4 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G4 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G4 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_6507_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M2: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M2 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) @ ( G @ M2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6508_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [Y5: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X5 ) @ Y5 ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_6509_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X5: nat] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_6510_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X5: nat] : ( plus_plus @ A @ ( F2 @ X5 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_6511_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X5: nat] : ( plus_plus @ A @ ( F2 @ X5 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_6512_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_6513_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X8 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_6514_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X8 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_6515_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X5: A] :
              ! [Y5: A] :
                ( ( ord_less_eq @ A @ X5 @ Y5 )
               => ( P @ Y5 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6516_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,K5: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_6517_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X5: nat] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6518_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_6519_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_6520_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_6521_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_6522_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X8: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_6523_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_6524_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_6525_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_6526_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6527_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ K5 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_6528_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X5: A] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N2 ) @ ( uminus_uminus @ A @ X5 ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6529_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N6: nat] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N2 ) @ ( uminus_uminus @ A @ ( X8 @ N6 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6530_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X5: B] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ F4 ) ) ) ) ).

% Bfun_inverse
thf(fact_6531_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X5 ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_6532_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ B9 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_6533_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A5: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A5 )
               => ! [B4: nat] :
                    ( ( ord_less @ nat @ A5 @ B4 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A5 @ B4 ) ) ) @ ( G @ A5 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6534_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X5: A] :
                  ( ( P3 @ X5 )
                  & ! [Y5: A] :
                      ( ( P3 @ Y5 )
                     => ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_6535_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_6536_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_6537_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_6538_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_6539_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_6540_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_6541_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y3 ) )
            = Y3 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_6542_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y3 @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_6543_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y3 ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_6544_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y3 @ X ) )
            = Y3 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_6545_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_6546_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_6547_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_6548_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_6549_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y: nat] :
            ( ( P @ Y )
           => ( ord_less_eq @ nat @ Y @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_6550_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y: nat] :
            ( ( P @ Y )
           => ( ord_less_eq @ nat @ Y @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_6551_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y: nat] :
            ( ( P @ Y )
           => ( ord_less_eq @ nat @ Y @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_6552_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_6553_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y3: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ Y3 @ X )
             => ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B3 @ X ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_6554_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y: A] :
                ( ( P @ Y )
               => ( ord_less_eq @ A @ Y @ X ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ Y4 @ X3 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_6555_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y: A] :
                ( ( P @ Y )
               => ( ord_less_eq @ A @ Y @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_6556_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_6557_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_6558_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_6559_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_6560_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_6561_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A3: A,B3: A,X3: A] :
              ( ( member @ A @ A3 @ S2 )
             => ( ( member @ A @ B3 @ S2 )
               => ( ( ord_less_eq @ A @ A3 @ X3 )
                 => ( ( ord_less_eq @ A @ X3 @ B3 )
                   => ( member @ A @ X3 @ S2 ) ) ) ) )
         => ? [A3: A,B3: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B3 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B3 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A3 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A3 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A3 @ B3 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A3 @ B3 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A3 @ B3 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A3 @ B3 ) ) ) ) ) ).

% interval_cases
thf(fact_6562_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F6: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ A2 @ ( F6 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F6 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F6 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_6563_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_6564_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I2 ) ) ) ).

% atLeast_iff
thf(fact_6565_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_6566_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I2 ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I2 ) ) ) ) ).

% image_add_atLeast
thf(fact_6567_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,L4: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atLeast @ A @ L4 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ L4 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_6568_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_6569_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L4: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_6570_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less_eq @ A @ L2 ) ) ) ) ) ).

% atLeast_def
thf(fact_6571_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
             => ( ord_less_eq @ B @ ( F3 @ Y5 ) @ ( F3 @ X5 ) ) ) ) ) ) ).

% antimono_def
thf(fact_6572_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y: A] :
              ( ( ord_less_eq @ A @ X3 @ Y )
             => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_6573_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_6574_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_6575_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_6576_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_6577_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L4: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_ord_atLeast @ A @ L4 ) ) ) ).

% not_Iic_le_Ici
thf(fact_6578_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_6579_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_6580_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: nat > A,I2: nat] :
          ( ( order_antimono @ nat @ A @ A4 )
         => ( ord_less_eq @ A @ ( A4 @ ( suc @ I2 ) ) @ ( A4 @ I2 ) ) ) ) ).

% decseq_SucD
thf(fact_6581_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J2: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ord_less_eq @ A @ ( F2 @ J2 ) @ ( F2 @ I2 ) ) ) ) ) ).

% decseqD
thf(fact_6582_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X9: nat > A] :
            ! [M2: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N2 )
             => ( ord_less_eq @ A @ ( X9 @ N2 ) @ ( X9 @ M2 ) ) ) ) ) ) ).

% decseq_def
thf(fact_6583_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( set_ord_greaterThan @ nat @ K ) ) ).

% atLeast_Suc_greaterThan
thf(fact_6584_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_6585_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_6586_decseq__bounded,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B6 @ ( X8 @ I3 ) )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_6587_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X8 @ N ) ) ) ) ) ).

% decseq_ge
thf(fact_6588_decseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B6 @ ( X8 @ I3 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I4: nat] : ( ord_less_eq @ real @ L6 @ ( X8 @ I4 ) ) ) ) ) ).

% decseq_convergent
thf(fact_6589_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_6590_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S4: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ A2 @ ( S4 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ B @ ( S4 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N2: nat] : ( X8 @ ( S4 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_6591_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y7: set @ B,X8: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y7 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X5: B] : ( member @ B @ X5 @ Y7 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y7 @ G @ F4 ) )
          = ( map_filter_on @ B @ C @ Y7 @ ( comp @ A @ C @ B @ F2 @ G ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_6592_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P3: A > $o] :
                  ( ( eventually @ A @ P3 @ F9 )
                  & ! [X5: A,Y5: A] :
                      ( ( ( P3 @ X5 )
                        & ( P3 @ Y5 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_6593_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [F4: filter @ A,X: A] :
          ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( topolo7230453075368039082e_nhds @ A @ X ) )
         => ( topolo6773858410816713723filter @ A @ F4 ) ) ) ).

% nhds_imp_cauchy_filter
thf(fact_6594_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X3: real] :
              ( ( ( ord_less @ real @ A2 @ X3 )
                & ( ord_less @ real @ X3 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X3: real] :
                  ( ( ( ord_less @ real @ A2 @ X3 )
                    & ( ord_less @ real @ X3 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_6595_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X5: A] :
                ( ( P3 @ X5 )
                & ! [Y5: A] :
                    ( ( P3 @ Y5 )
                   => ( Less_eq @ X5 @ Y5 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_6596_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q3: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T4: B] : ( times_times @ A @ ( Q3 @ T4 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_6597_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q3: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T4: B] : ( times_times @ A @ C2 @ ( Q3 @ T4 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_6598_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_6599_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_6600_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_6601_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_6602_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% differentiable_power
thf(fact_6603_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_6604_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_inverse
thf(fact_6605_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L3: real,Z2: real] :
              ( ( ord_less @ real @ A2 @ Z2 )
              & ( ord_less @ real @ Z2 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L3 @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L3 ) ) ) ) ) ) ).

% MVT
thf(fact_6606_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A4: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A4 ) @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A4 ) ) @ ( finite_Fpow @ A @ B6 ) ) ) ).

% image_Fpow_mono
thf(fact_6607_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_6608_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_6609_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,N: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X5: A] : ( root @ N @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_6610_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_6611_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A4: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A4 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A4 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A4
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_6612_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X5: A] : ( sqrt @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_6613_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_6614_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_6615_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A4: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A4 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A4 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A4
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_6616_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_6617_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_6618_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( ( G @ X3 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_6619_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_6620_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_6621_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_6622_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y3: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y3 )
         => ( ( ord_less_eq @ B @ Y3 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y3 ) ) ) ) ) ) ) ).

% IVT'
thf(fact_6623_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y3: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y3 )
         => ( ( ord_less_eq @ B @ Y3 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y3 ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_6624_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X5: C] : ( G @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_6625_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_6626_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A4 ) )
         => ( ! [X3: A,Y: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y @ A4 )
                 => ( ( ord_less_eq @ A @ X3 @ Y )
                   => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A4 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_6627_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_6628_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( cos @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_6629_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                  = ( collect @ A
                    @ ^ [X5: A] :
                        ( ( member @ A @ X5 @ S )
                        & ( ord_less @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_6630_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( sin @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_6631_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A4: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A4 @ F2 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A4 )
               => ( ( cosh @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A4
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_6632_continuous__on__arcosh_H,axiom,
    ! [A4: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A4 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A4 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A4
          @ ^ [X5: real] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_6633_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C3: real,D4: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D4 ) )
            & ( ord_less_eq @ real @ C3 @ D4 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_6634_continuous__on__arcosh,axiom,
    ! [A4: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A4 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A4 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_6635_Fpow__mono,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A4 ) @ ( finite_Fpow @ A @ B6 ) ) ) ).

% Fpow_mono
thf(fact_6636_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X5: A] :
                      ( ( member @ A @ X5 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_6637_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
                    & ( ( ( F2 @ X3 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_6638_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( F2 @ X3 )
                     != ( one_one @ real ) ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_6639_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X5: A] : ( arccos @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_6640_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X5: A] : ( arcsin @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_6641_Fpow__subset__Pow,axiom,
    ! [A: $tType,A4: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A4 ) @ ( pow2 @ A @ A4 ) ) ).

% Fpow_subset_Pow
thf(fact_6642_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X9: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X9 @ A7 )
                & ( finite_finite @ A @ X9 ) ) ) ) ) ).

% Fpow_def
thf(fact_6643_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ A2 @ X3 )
             => ( ( ord_less_eq @ A @ X3 @ B2 )
               => ? [Y4: A] : ( has_field_derivative @ A @ F2 @ Y4 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_6644_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
                & ( ord_less @ real @ Z2 @ B2 )
                & ( ( F8 @ Z2 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_6645_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F8 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_6646_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_6647_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_6648_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_6649_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_6650_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_6651_continuous__on__artanh,axiom,
    ! [A4: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A4 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A4 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_6652_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F2 @ X )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_6653_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X3: A] :
                  ( ( ord_less @ A @ A2 @ X3 )
                 => ( ( ord_less @ A @ X3 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_6654_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z2: real] :
                ( ( ord_less @ real @ A2 @ Z2 )
                & ( ord_less @ real @ Z2 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_6655_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C6 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C6 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_6656_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S6: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X5: set @ A] :
                    ( ( member @ ( set @ A ) @ X5 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X5 ) )
                & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D8: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D8 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D8 )
                  & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ D8 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_6657_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ X3 @ Xa2 ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_6658_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ Xa2 @ X3 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_6659_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Xa2 ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_6660_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa2 ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_6661_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_6662_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X6: set @ A] :
                  ( ( member @ ( set @ A ) @ X6 @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X6 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_6663_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F6: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ B2 @ ( F6 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F6 @ N7 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F6 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_6664_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_6665_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I: nat] : ( compow @ ( A > A ) @ I @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_6666_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ) ).

% mono_pow
thf(fact_6667_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_6668_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_6669_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_6670_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_6671_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_6672_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A,P: A > $o] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ A @ N3 ) )
           => ( P @ X ) ) ) ) ).

% Nats_induct
thf(fact_6673_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ~ ! [N3: nat] :
                ( X
               != ( semiring_1_of_nat @ A @ N3 ) ) ) ) ).

% Nats_cases
thf(fact_6674_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_6675_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_6676_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_6677_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) )
           => ( ord_less @ A @ X @ Y3 ) ) ) ) ).

% mono_strict_invE
thf(fact_6678_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) )
           => ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ).

% mono_invE
thf(fact_6679_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A4: A,B6: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A4 @ B6 ) ) @ ( inf_inf @ B @ ( F2 @ A4 ) @ ( F2 @ B6 ) ) ) ) ) ).

% mono_inf
thf(fact_6680_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: nat > A,I2: nat] :
          ( ( order_mono @ nat @ A @ A4 )
         => ( ord_less_eq @ A @ ( A4 @ I2 ) @ ( A4 @ ( suc @ I2 ) ) ) ) ) ).

% incseq_SucD
thf(fact_6681_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_6682_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_6683_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) ) ) ) ).

% monoD
thf(fact_6684_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y3 )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) ) ) ) ).

% monoE
thf(fact_6685_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y: A] :
              ( ( ord_less_eq @ A @ X3 @ Y )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_6686_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
             => ( ord_less_eq @ B @ ( F3 @ X5 ) @ ( F3 @ Y5 ) ) ) ) ) ) ).

% mono_def
thf(fact_6687_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J2: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) ) ) ) ).

% incseqD
thf(fact_6688_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X9: nat > A] :
            ! [M2: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N2 )
             => ( ord_less_eq @ A @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) ) ) ) ) ).

% incseq_def
thf(fact_6689_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A4: A,B6: A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A4 @ B6 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ A4 ) @ ( compow @ ( A > A ) @ N @ F2 @ B6 ) ) ) ) ) ).

% funpow_mono
thf(fact_6690_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_6691_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_6692_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N: A,M5: B,N4: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M5 @ N4 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F2 @ M )
                = M5 ) ) ) ) ) ).

% mono_image_least
thf(fact_6693_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P4 @ ( F2 @ P4 ) )
           => ( ord_less_eq @ A @ P4 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_6694_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P4 ) @ P4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P4 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_6695_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I2: nat,J2: nat,X: A,Y3: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less_eq @ A @ X @ Y3 )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I2 @ F2 @ X ) @ ( compow @ ( A > A ) @ J2 @ F2 @ Y3 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_6696_incseq__bounded,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X8 @ I3 ) @ B6 )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_6697_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_6698_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% mono_Sup
thf(fact_6699_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X5: C] : ( F2 @ ( A4 @ X5 ) )
                @ I5 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A4 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_6700_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% mono_Inf
thf(fact_6701_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A4 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X5: C] : ( F2 @ ( A4 @ X5 ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_6702_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_6703_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I: nat] : ( compow @ ( A > A ) @ I @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_6704_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_6705_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_6706_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_6707_incseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X8 @ I3 ) @ B6 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I4: nat] : ( ord_less_eq @ real @ ( X8 @ I4 ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_6708_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_6709_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N2: A] :
              ( ( member @ A @ N2 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_6710_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M2 ) @ M2 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_6711_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N9 )
                     => ! [M6: nat] :
                          ( ( ord_less_eq @ nat @ M6 @ N9 )
                         => ( ( ord_less @ nat @ M6 @ N7 )
                           => ( ord_less @ A @ ( F2 @ M6 ) @ ( F2 @ N7 ) ) ) ) )
                  & ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N7 )
                     => ( ( F2 @ N9 )
                        = ( F2 @ N7 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_6712_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S4: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ ( S4 @ N7 ) @ A2 )
               => ( ! [N7: nat] : ( ord_less @ B @ B2 @ ( S4 @ N7 ) )
                 => ( ( order_mono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N2: nat] : ( X8 @ ( S4 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_6713_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = Ys )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I )
                  = ( nth @ A @ Ys @ ( F3 @ I ) ) ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( ( nth @ A @ Xs2 @ I )
                    = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I )
                    = ( F3 @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_6714_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I5: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I3 ) ) )
           => ( ! [I8: set @ B] :
                  ( ( finite_finite @ B @ I8 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I8 @ I5 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I8 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I5 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_6715_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A4: set @ A,B6: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A4 ) @ ( F2 @ B6 ) ) ) ) ).

% mono_Int
thf(fact_6716_remdups__adj__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% remdups_adj_length
thf(fact_6717_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_6718_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_6719_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y3: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member @ A @ Y3 @ S2 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y3 @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_6720_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ I2 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ ( suc @ I2 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_6721_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A4: set @ A] :
          ( ( member @ A @ X @ A4 )
         => ( ( topolo1002775350975398744n_open @ A @ A4 )
           => ? [A15: set @ A] :
                ( ( member @ A @ X @ A15 )
                & ( topolo7761053866217962861closed @ A @ A15 )
                & ( ord_less_eq @ ( set @ A ) @ A15 @ A4 )
                & ( eventually @ A
                  @ ^ [Y5: A] : ( member @ A @ Y5 @ A15 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_6722_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I: nat] :
            ( ( re @ Z )
            = ( semiring_1_of_nat @ real @ I ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_6723_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F4: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F4 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F16: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F16 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F16 @ F4 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F16 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F4 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_6724_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U6: set @ A] :
            ! [A7: set @ ( set @ A )] :
              ( ! [X5: set @ A] :
                  ( ( member @ ( set @ A ) @ X5 @ A7 )
                 => ( topolo7761053866217962861closed @ A @ X5 ) )
             => ( ! [B8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B8 @ A7 )
                   => ( ( finite_finite @ ( set @ A ) @ B8 )
                     => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ A7 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_6725_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X5: nat] : ( F2 @ ( G @ X5 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_6726_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_6727_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_6728_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B4: A] : ( divide_divide @ A @ B4 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_6729_strict__mono__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% strict_mono_mono
thf(fact_6730_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_6731_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_6732_strict__mono__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ( F2 @ X )
              = ( F2 @ Y3 ) )
            = ( X = Y3 ) ) ) ) ).

% strict_mono_eq
thf(fact_6733_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A4: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A4 ) ) ) ).

% inj_on_mult
thf(fact_6734_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A4: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( plus_plus @ A @ B4 @ A2 )
          @ A4 ) ) ).

% inj_on_add'
thf(fact_6735_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A4: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A4 ) ) ).

% inj_on_add
thf(fact_6736_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K ) ) ) ).

% strict_mono_add
thf(fact_6737_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) )
            = ( ord_less @ A @ X @ Y3 ) ) ) ) ).

% strict_mono_less
thf(fact_6738_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less @ A @ X5 @ Y5 )
             => ( ord_less @ B @ ( F3 @ X5 ) @ ( F3 @ Y5 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_6739_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_6740_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y3 )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) ) ) ) ).

% strict_monoD
thf(fact_6741_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X3: A,Y: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ( F2 @ X3 )
               != ( F2 @ Y ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_6742_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ A4 @ B6 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_6743_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S2
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_6744_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
         => ( ( ( image @ A @ B @ F2 @ A4 )
              = ( image @ A @ B @ F2 @ B6 ) )
            = ( A4 = B6 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_6745_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A2: A,A4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( member @ A @ A2 @ B6 )
       => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A4 ) )
            = ( member @ A @ A2 @ A4 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_6746_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A,Y: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y @ A4 )
                 => ( ( F2 @ X3 )
                   != ( F2 @ Y ) ) ) ) )
         => ( ! [X3: A,Y: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y @ A4 )
                 => ( ( ord_less_eq @ A @ X3 @ Y )
                    | ( ord_less_eq @ A @ Y @ X3 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A4 ) ) ) ) ).

% linorder_inj_onI
thf(fact_6747_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
       => ( inj_on @ A @ B @ F2 @ B6 ) ) ) ).

% inj_on_subset
thf(fact_6748_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
       => ( inj_on @ A @ B @ F2 @ A4 ) ) ) ).

% subset_inj_on
thf(fact_6749_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R3: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R3 )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R3 @ M ) @ ( R3 @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_6750_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N @ ( F2 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_6751_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y3: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) )
            = ( ord_less_eq @ A @ X @ Y3 ) ) ) ) ).

% strict_mono_less_eq
thf(fact_6752_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_6753_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ ( image @ A @ B @ F2 @ B6 ) )
        = ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ) ).

% inj_image_subset_iff
thf(fact_6754_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,A9: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F3: A > B] :
              ( ( inj_on @ A @ B @ F3 @ A4 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A4 ) @ A9 ) ) )
        = ( ? [G2: B > A] :
              ( ( image @ B @ A @ G2 @ A9 )
              = A4 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_6755_finite__surj__inj,axiom,
    ! [A: $tType,A4: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( image @ A @ A @ F2 @ A4 ) )
       => ( inj_on @ A @ A @ F2 @ A4 ) ) ) ).

% finite_surj_inj
thf(fact_6756_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: set @ A,B6: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B6 )
       => ( ( finite_finite @ B @ B6 )
         => ( finite_finite @ A @ A4 ) ) ) ) ).

% inj_on_finite
thf(fact_6757_endo__inj__surj,axiom,
    ! [A: $tType,A4: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A4 ) @ A4 )
       => ( ( inj_on @ A @ A @ F2 @ A4 )
         => ( ( image @ A @ A @ F2 @ A4 )
            = A4 ) ) ) ) ).

% endo_inj_surj
thf(fact_6758_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_6759_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_6760_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( finite_card @ B @ A4 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A4 ) ) ).

% pigeonhole
thf(fact_6761_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_6762_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: set @ A,X: B,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F2 @ A4 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A4 @ F2 @ X ) @ B6 ) ) ) ) ).

% the_inv_into_into
thf(fact_6763_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_6764_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set @ A,A4: A > ( set @ B ),F2: B > C] :
      ( ! [I3: A,J3: A] :
          ( ( member @ A @ I3 @ I5 )
         => ( ( member @ A @ J3 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A4 @ I3 ) @ ( A4 @ J3 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A4 @ J3 ) @ ( A4 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ( inj_on @ B @ C @ F2 @ ( A4 @ I3 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A4 @ I5 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_6765_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: set @ A,B6: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B6 )
       => ( ( inj_on @ B @ A @ G @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B6 ) @ A4 )
           => ( ( finite_finite @ A @ A4 )
             => ( ( finite_finite @ B @ B6 )
               => ( ( finite_card @ A @ A4 )
                  = ( finite_card @ B @ B6 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_6766_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S2 ) @ T6 )
           => ( ( ! [X5: B] :
                    ( ( member @ B @ X5 @ T6 )
                   => ? [Y5: A] :
                        ( ( member @ A @ Y5 @ S2 )
                        & ( ( F2 @ Y5 )
                          = X5 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_6767_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_6768_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C6: set @ A,A4: set @ C,B6: C > ( set @ A ),J2: C] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ! [X3: C] :
            ( ( member @ C @ X3 @ A4 )
           => ( ord_less_eq @ ( set @ A ) @ ( B6 @ X3 ) @ C6 ) )
       => ( ( member @ C @ J2 @ A4 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B6 @ A4 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X5: C] : ( image @ A @ B @ F2 @ ( B6 @ X5 ) )
                @ A4 ) ) ) ) ) ) ).

% image_INT
thf(fact_6769_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B6: set @ B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ B @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B6 ) )
         => ? [F6: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F6 @ A4 ) @ B6 )
              & ( inj_on @ A @ B @ F6 @ A4 ) ) ) ) ) ).

% card_le_inj
thf(fact_6770_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: set @ A,B6: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B6 )
       => ( ( finite_finite @ B @ B6 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B6 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_6771_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B6: set @ B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ B @ B6 )
       => ( ( ? [F3: A > B] :
                ( ( inj_on @ A @ B @ F3 @ A4 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A4 ) @ B6 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B6 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_6772_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_6773_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_6774_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_6775_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_6776_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X3: nat,Y: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X5: nat] : ( F2 @ ( G @ X5 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_6777_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: set @ A,B6: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B6 )
       => ( ( inj_on @ B @ A @ G @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B6 ) @ A4 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A4 @ B6 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_6778_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_6779_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_6780_inj__Suc,axiom,
    ! [N5: set @ nat] : ( inj_on @ nat @ nat @ suc @ N5 ) ).

% inj_Suc
thf(fact_6781_inj__on__diff__nat,axiom,
    ! [N5: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N5 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ K )
        @ N5 ) ) ).

% inj_on_diff_nat
thf(fact_6782_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X9: $o > A,Y8: $o > A] :
              ( ( ord_less_eq @ A @ ( X9 @ $false ) @ ( Y8 @ $false ) )
              & ( ord_less_eq @ A @ ( X9 @ $true ) @ ( Y8 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_6783_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ? [N3: nat,F6: nat > A] :
          ( ( A4
            = ( image @ nat @ A @ F6
              @ ( collect @ nat
                @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F6
            @ ( collect @ nat
              @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_6784_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ? [F6: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F6 @ A4 )
            = ( collect @ nat
              @ ^ [I: nat] : ( ord_less @ nat @ I @ N3 ) ) )
          & ( inj_on @ A @ nat @ F6 @ A4 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_6785_inj__on__nth,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ I5 )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs2 ) @ I5 ) ) ) ).

% inj_on_nth
thf(fact_6786_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F6: nat > A] :
          ( ( inj_on @ nat @ A @ F6 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F6 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_6787_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F3: nat > A] :
            ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_6788_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_6789_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S )
        = S )
     => ( ! [M3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M3 )
           => ( ( ord_less @ nat @ M3 @ N )
             => ( ( compow @ ( A > A ) @ M3 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_6790_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_6791_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_6792_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ! [X3: nat] :
                ( ~ ( member @ nat @ X3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_6793_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F8: real > real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F8 @ X3 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_6794_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_6795_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X: C,F8: C > A,S2: set @ C,N: int] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X5: C] : ( power_int @ A @ ( F2 @ X5 ) @ N )
              @ ^ [H: C] : ( times_times @ A @ ( F8 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_6796_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N: int,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( power_int @ A @ X5 @ N )
            @ ^ [Y5: A] : ( times_times @ A @ Y5 @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_6797_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_6798_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y3: A] :
          ( ( power_int @ A @ Y3 @ ( one_one @ int ) )
          = Y3 ) ) ).

% power_int_1_right
thf(fact_6799_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_int_sgn
thf(fact_6800_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y3: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y3 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y3 @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_6801_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_6802_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_6803_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( power_int @ A @ X @ N )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( N
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_6804_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_6805_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ).

% abs_power_int_minus
thf(fact_6806_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N ) )
          = ( power_power @ A @ X @ N ) ) ) ).

% power_int_of_nat
thf(fact_6807_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_6808_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_6809_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_6810_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% power_int_numeral
thf(fact_6811_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: num,N: int,Y3: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( real_Vector_of_real @ A @ Y3 ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N )
            = Y3 ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_6812_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y3: real,X: num,N: int] :
          ( ( ( real_Vector_of_real @ A @ Y3 )
            = ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y3
            = ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_6813_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y3: A] :
          ( ( power_int @ A @ Y3 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y3 ) ) ) ).

% power_int_minus1_right
thf(fact_6814_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_6815_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_6816_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_6817_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_6818_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_int @ A @ A2 @ N ) ) ) ) ).

% power_int_minus_left_even
thf(fact_6819_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_6820_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B,N: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_6821_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ X @ ( uminus_uminus @ int @ N ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus
thf(fact_6822_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_6823_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X ) @ N )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_inverse
thf(fact_6824_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_int_abs
thf(fact_6825_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y3: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y3 ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y3 @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_6826_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( power_int @ A @ X @ ( times_times @ int @ M @ N ) )
          = ( power_int @ A @ ( power_int @ A @ X @ M ) @ N ) ) ) ).

% power_int_mult
thf(fact_6827_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y3: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y3 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y3 @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_6828_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_6829_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_6830_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_less_power_int
thf(fact_6831_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_le_power_int
thf(fact_6832_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_6833_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N5 ) ) ) ) ) ).

% power_int_increasing
thf(fact_6834_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A2: A] :
          ( ( ord_less @ int @ N @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N5 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_6835_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) ) ) ).

% power_int_minus_one_minus
thf(fact_6836_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M != N ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M @ N ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_diff
thf(fact_6837_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_6838_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,N: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( power_int @ A @ ( F2 @ X5 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N ) )
              @ F4 ) ) ) ) ).

% tendsto_power_int
thf(fact_6839_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_6840_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_power_int
thf(fact_6841_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N ) ) ) ) ) ).

% continuous_power_int
thf(fact_6842_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A2: A] :
          ( ( ord_less @ int @ N @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N5 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_6843_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y3: A,N: int] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( power_int @ A @ Y3 @ N ) ) ) ) ) ) ).

% power_int_mono
thf(fact_6844_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_6845_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_6846_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_6847_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_6848_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A2: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_6849_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_6850_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_6851_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_6852_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N5
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N5 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_6853_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_6854_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_6855_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_int @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_6856_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_6857_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_6858_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_6859_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X5: A,N2: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) @ ( power_power @ A @ X5 @ ( nat2 @ N2 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X5 ) @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_6860_powr__real__of__int_H,axiom,
    ! [X: real,N: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( X
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N ) )
       => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
          = ( power_int @ real @ X @ N ) ) ) ) ).

% powr_real_of_int'
thf(fact_6861_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,N: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( power_int @ A @ ( F2 @ X5 ) @ N )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_6862_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A5 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_6863_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less @ A @ Y3 @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A5 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_6864_principal__le__iff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A4 ) @ ( principal @ A @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B6 ) ) ).

% principal_le_iff
thf(fact_6865_le__principal,axiom,
    ! [A: $tType,F4: filter @ A,A4: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( principal @ A @ A4 ) )
      = ( eventually @ A
        @ ^ [X5: A] : ( member @ A @ X5 @ A4 )
        @ F4 ) ) ).

% le_principal
thf(fact_6866_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I5: set @ A,F4: A > ( set @ B ),F2: B > C,G5: D > ( set @ C ),J4: set @ D] :
      ( ( I5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ! [J3: A] :
                ( ( member @ A @ J3 @ I5 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I3 ) @ ( F4 @ J3 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J3 ) @ ( F4 @ I3 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J: D] : ( principal @ C @ ( G5 @ J ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I: A] : ( principal @ B @ ( F4 @ I ) )
                @ I5 ) ) )
          = ( ! [X5: D] :
                ( ( member @ D @ X5 @ J4 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ I5 )
                    & ! [Z5: B] :
                        ( ( member @ B @ Z5 @ ( F4 @ Y5 ) )
                       => ( member @ C @ ( F2 @ Z5 ) @ ( G5 @ X5 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_6867_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X5: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X5 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_6868_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X5: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X5 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_6869_complete__uniform,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo2479028161051973599mplete @ A )
        = ( ^ [S6: set @ A] :
            ! [F9: filter @ A] :
              ( ( ord_less_eq @ ( filter @ A ) @ F9 @ ( principal @ A @ S6 ) )
             => ( ( F9
                 != ( bot_bot @ ( filter @ A ) ) )
               => ( ( topolo6773858410816713723filter @ A @ F9 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ S6 )
                      & ( ord_less_eq @ ( filter @ A ) @ F9 @ ( topolo7230453075368039082e_nhds @ A @ X5 ) ) ) ) ) ) ) ) ) ).

% complete_uniform
thf(fact_6870_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X5: A,Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_6871_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X9: nat > A] :
            ! [P3: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P3 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ M2 )
                     => ( P3 @ ( product_Pair @ A @ A @ ( X9 @ N2 ) @ ( X9 @ M2 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_6872_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X5: real,Y5: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X5 @ Y5 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_6873_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X5: complex,Y5: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X5 @ Y5 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_6874_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X5: A,Y5: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X5 @ Y5 ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_6875_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y3 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y3
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( Y3
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                       => ( ( ord_less @ nat @ Mi @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_6876_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X6: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X6 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi: nat,Ma2: nat] :
                          ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                          & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I: nat] :
                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                          & ( ( Mi = Ma2 )
                           => ! [X5: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                          & ( ( Mi != Ma2 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                              & ! [X5: nat] :
                                  ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_6877_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less_eq @ A @ X5 @ Y5 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_6878_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_6879_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A7 )
           => ( P3 @ X5 ) ) ) ) ).

% Ball_def_raw
thf(fact_6880_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6881_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6882_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X5: A] :
                    ( ( member @ A @ X5 @ A7 )
                   => ( ord_less_eq @ A @ X5 @ B4 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6883_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X5: A] :
                    ( ( member @ A @ X5 @ A7 )
                   => ( ord_less_eq @ A @ B4 @ X5 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6884_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I ) )
                & ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_6885_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X5: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
           => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X9 )
            & ! [X5: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
               => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi: nat,Ma2: nat] :
                ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I: nat] :
                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I ) @ X9 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I ) ) )
                & ( ( Mi = Ma2 )
                 => ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                & ( ( Mi != Ma2 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma2 )
                    & ! [X5: nat] :
                        ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X5 )
                         => ( ( ord_less @ nat @ Mi @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_6886_funpow__inj__finite,axiom,
    ! [A: $tType,P4: A > A,X: A] :
      ( ( inj_on @ A @ A @ P4 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y5: A] :
              ? [N2: nat] :
                ( Y5
                = ( compow @ ( A > A ) @ N2 @ P4 @ X ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P4 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_6887_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( Deg2 = Xa )
                & ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                    & ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi: nat,Ma2: nat] :
                        ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                        & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I: nat] :
                            ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                        & ( ( Mi = Ma2 )
                         => ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                        & ( ( Mi != Ma2 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                            & ! [X5: nat] :
                                ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                 => ( ( ord_less @ nat @ Mi @ X5 )
                                    & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_6888_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y3: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y3
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( Y3
                    = ( ( Deg2 = Xa )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                       => ( ( ord_less @ nat @ Mi @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_6889_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X6: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X6 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X6 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I: nat] :
                                  ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                       => ( ( ord_less @ nat @ Mi @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_6890_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A4 )
                       => ( member @ A @ ( F3 @ X5 ) @ X5 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6891_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A4 )
                       => ( member @ A @ ( F3 @ X5 ) @ X5 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6892_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S6: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F9: filter @ A] :
                ! [X5: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X5 @ S6 )
                 => ( ord_less_eq @ ( filter @ A ) @ F9 @ X5 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_6893_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X9: set @ int] :
          ( the @ int
          @ ^ [X5: int] :
              ( ( member @ int @ X5 @ X9 )
              & ! [Y5: int] :
                  ( ( member @ int @ Y5 @ X9 )
                 => ( ord_less_eq @ int @ Y5 @ X5 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_6894_Union__maximal__sets,axiom,
    ! [A: $tType,F17: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ F17 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T9: set @ A] :
                ( ( member @ ( set @ A ) @ T9 @ F17 )
                & ! [X5: set @ A] :
                    ( ( member @ ( set @ A ) @ X5 @ F17 )
                   => ~ ( ord_less @ ( set @ A ) @ T9 @ X5 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F17 ) ) ) ).

% Union_maximal_sets
thf(fact_6895_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu3: A] :
            ? [N2: int] :
              ( ( Uu3
                = ( ring_1_of_int @ A @ N2 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_6896_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X9 )
                        & ! [X5: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi: nat,Ma2: nat] :
                            ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                            & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I: nat] :
                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X9 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                            & ( ( Mi = Ma2 )
                             => ! [X5: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X9: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X9 ) ) )
                            & ( ( Mi != Ma2 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                & ! [X5: nat] :
                                    ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X5 )
                                     => ( ( ord_less @ nat @ Mi @ X5 )
                                        & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_6897_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A4 )
                       => ( member @ A @ ( F3 @ X5 ) @ X5 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6898_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P3 ) ) ) ) ).

% Ball_Collect
thf(fact_6899_refl__ge__eq,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ! [X3: A] : ( R @ X3 @ X3 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ R ) ) ).

% refl_ge_eq
thf(fact_6900_ge__eq__refl,axiom,
    ! [A: $tType,R: A > A > $o,X: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ R )
     => ( R @ X @ X ) ) ).

% ge_eq_refl
thf(fact_6901_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X5: A,Y5: A] :
                  ( ( ord_less @ nat @ ( F3 @ X5 ) @ ( F3 @ Y5 ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X5 ) @ ( F3 @ Y5 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_6902_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I: int,N2: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
          & ( N2
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_6903_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_6904_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_6905_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_6906_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_6907_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_6908_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_6909_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_6910_Rats__dense__in__real,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ X @ Y3 )
     => ? [X3: real] :
          ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X3 )
          & ( ord_less @ real @ X3 @ Y3 ) ) ) ).

% Rats_dense_in_real
thf(fact_6911_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X3 @ X ) ) ).

% Rats_no_bot_less
thf(fact_6912_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X3 ) ) ).

% Rats_no_top_le
thf(fact_6913_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_6914_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Nats_subset_Rats
thf(fact_6915_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y3: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( mlex_prod @ A @ F2 @ R ) ) ) ).

% mlex_less
thf(fact_6916_mlex__iff,axiom,
    ! [A: $tType,X: A,Y3: A,F2: A > nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( mlex_prod @ A @ F2 @ R ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y3 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R ) ) ) ) ).

% mlex_iff
thf(fact_6917_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y3: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( mlex_prod @ A @ F2 @ R ) ) ) ) ).

% mlex_leq
thf(fact_6918_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I: int,J: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I ) @ ( ring_1_of_int @ real @ J ) ) )
          & ( J
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_6919_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6920_set__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs2 @ I ) )
            & ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( member @ nat @ I @ I5 ) ) ) ) ).

% set_nths
thf(fact_6921_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y3 ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y3 @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_6922_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6923_Un__subset__iff,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) @ C6 )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
        & ( ord_less_eq @ ( set @ A ) @ B6 @ C6 ) ) ) ).

% Un_subset_iff
thf(fact_6924_set__nths__subset,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_nths_subset
thf(fact_6925_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6926_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) @ C6 )
        = ( inf_inf @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B6 @ C6 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C6 @ A4 ) ) ).

% Un_Int_assoc_eq
thf(fact_6927_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y3: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y3 ) @ ( inf_inf @ A @ X @ Z ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y3 @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_6928_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y3: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y3 @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y3 ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_6929_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6930_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6931_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6932_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6933_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6934_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6935_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6936_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( sup_sup @ A @ A5 @ B4 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6937_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_6938_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_6939_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( sup_sup @ A @ X @ Y3 )
            = Y3 ) ) ) ).

% sup_absorb2
thf(fact_6940_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( sup_sup @ A @ X @ Y3 )
            = X ) ) ) ).

% sup_absorb1
thf(fact_6941_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6942_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_6943_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y3: A] :
          ( ! [X3: A,Y: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y ) )
         => ( ! [X3: A,Y: A] : ( ord_less_eq @ A @ Y @ ( F2 @ X3 @ Y ) )
           => ( ! [X3: A,Y: A,Z2: A] :
                  ( ( ord_less_eq @ A @ Y @ X3 )
                 => ( ( ord_less_eq @ A @ Z2 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y @ Z2 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X @ Y3 )
                = ( F2 @ X @ Y3 ) ) ) ) ) ) ).

% sup_unique
thf(fact_6944_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_6945_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6946_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( sup_sup @ A @ X5 @ Y5 )
              = Y5 ) ) ) ) ).

% le_iff_sup
thf(fact_6947_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y3: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( ord_less_eq @ A @ Z @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y3 @ Z ) @ X ) ) ) ) ).

% sup_least
thf(fact_6948_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6949_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6950_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6951_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6952_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y3: A,X: A] : ( ord_less_eq @ A @ Y3 @ ( sup_sup @ A @ X @ Y3 ) ) ) ).

% sup_ge2
thf(fact_6953_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y3 ) ) ) ).

% sup_ge1
thf(fact_6954_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_6955_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_6956_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y3: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y3 ) ) ) ).

% inf_sup_ord(3)
thf(fact_6957_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y3: A,X: A] : ( ord_less_eq @ A @ Y3 @ ( sup_sup @ A @ X @ Y3 ) ) ) ).

% inf_sup_ord(4)
thf(fact_6958_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B8 )
            = B8 ) ) ) ).

% subset_Un_eq
thf(fact_6959_subset__UnE,axiom,
    ! [A: $tType,C6: set @ A,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
     => ~ ! [A15: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A15 @ A4 )
           => ! [B14: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B14 @ B6 )
               => ( C6
                 != ( sup_sup @ ( set @ A ) @ A15 @ B14 ) ) ) ) ) ).

% subset_UnE
thf(fact_6960_Un__absorb2,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
     => ( ( sup_sup @ ( set @ A ) @ A4 @ B6 )
        = A4 ) ) ).

% Un_absorb2
thf(fact_6961_Un__absorb1,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( sup_sup @ ( set @ A ) @ A4 @ B6 )
        = B6 ) ) ).

% Un_absorb1
thf(fact_6962_Un__upper2,axiom,
    ! [A: $tType,B6: set @ A,A4: set @ A] : ( ord_less_eq @ ( set @ A ) @ B6 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) ).

% Un_upper2
thf(fact_6963_Un__upper1,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) ).

% Un_upper1
thf(fact_6964_Un__least,axiom,
    ! [A: $tType,A4: set @ A,C6: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) @ C6 ) ) ) ).

% Un_least
thf(fact_6965_Un__mono,axiom,
    ! [A: $tType,A4: set @ A,C6: set @ A,B6: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) @ ( sup_sup @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_6966_Un__Pow__subset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A4 ) @ ( pow2 @ A @ B6 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) ) ).

% Un_Pow_subset
thf(fact_6967_Diff__subset__conv,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B6 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_6968_Diff__partition,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( sup_sup @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) )
        = B6 ) ) ).

% Diff_partition
thf(fact_6969_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6970_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A4: set @ A,B6: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A4 ) @ ( F2 @ B6 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% mono_Un
thf(fact_6971_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A4: A,B6: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A4 ) @ ( F2 @ B6 ) ) @ ( F2 @ ( sup_sup @ A @ A4 @ B6 ) ) ) ) ) ).

% mono_sup
thf(fact_6972_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_6973_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_6974_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( sup_sup @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_6975_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_6976_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_6977_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_6978_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_6979_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_6980_nths__all,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( member @ nat @ I3 @ I5 ) )
     => ( ( nths @ A @ Xs2 @ I5 )
        = Xs2 ) ) ).

% nths_all
thf(fact_6981_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A] :
          ( ( ( sup_sup @ A @ X @ Y3 )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y3 ) ) ) ).

% sup_shunt
thf(fact_6982_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y3 ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y3 ) @ Z ) ) ) ) ).

% shunt1
thf(fact_6983_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y3 ) ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y3 @ Z ) ) ) ) ).

% shunt2
thf(fact_6984_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P4: A,Q3: A,R3: A] :
          ( ( ord_less_eq @ A @ P4 @ ( sup_sup @ A @ Q3 @ R3 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P4 @ ( uminus_uminus @ A @ Q3 ) ) @ R3 ) ) ) ).

% sup_neg_inf
thf(fact_6985_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B6: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6986_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6987_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6988_card__Un__le,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ).

% card_Un_le
thf(fact_6989_atLeastLessThan__add__Un,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( set_or7035219750837199246ssThan @ nat @ I2 @ ( plus_plus @ nat @ J2 @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J2 ) @ ( set_or7035219750837199246ssThan @ nat @ J2 @ ( plus_plus @ nat @ J2 @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6990_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6991_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_6992_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6993_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_6994_Inter__Un__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B6: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B6 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A4 @ B6 ) ) ) ).

% Inter_Un_subset
thf(fact_6995_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6996_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6997_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B6 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6998_card__Un__Int,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6999_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_7000_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_7001_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_7002_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_7003_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_7004_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7005_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_7006_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: A,B6: A] :
          ( ( sup_sup @ A @ A4
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X5: nat] : B6
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A4 @ B6 ) ) ) ).

% SUP_nat_binary
thf(fact_7007_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7008_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 )
        @ ^ [X5: A,Y5: A] : ( ord_less @ A @ Y5 @ X5 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_7009_length__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs2 @ I5 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] :
              ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( member @ nat @ I @ I5 ) ) ) ) ) ).

% length_nths
thf(fact_7010_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_7011_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: set @ B,B6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_7012_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( ( inf_inf @ ( set @ B ) @ A4 @ B6 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_7013_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_7014_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( ( inf_inf @ ( set @ B ) @ A4 @ B6 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_7015_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_7016_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A4: set @ A,B6: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A4 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B6 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_7017_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B6 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_7018_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B6: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B6 @ A4 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_7019_card__Un__disjoint,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B6 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B6 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_7020_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_7021_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_7022_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_7023_sum__Un__nat,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_7024_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_7025_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_7026_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A4: set @ B,B6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A4 @ B6 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ B6 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_7027_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C6: set @ A,B6: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I: B] : ( if @ A @ ( member @ B @ I @ ( image @ A @ B @ G @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G @ I ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_7028_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_7029_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_7030_id__funpow,axiom,
    ! [A: $tType,N: nat] :
      ( ( compow @ ( A > A ) @ N @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_7031_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_7032_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_7033_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_7034_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_7035_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_7036_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_7037_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) ) ) ) ).

% less_int_def
thf(fact_7038_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_7039_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_7040_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A16: set @ B,B15: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A16 )
        = B15 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B15 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_7041_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_7042_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_7043_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_7044_take__bit__num__simps_I5_J,axiom,
    ! [R3: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_7045_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_7046_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ N @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ one2 )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_7047_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num,Q3: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( some @ num @ Q3 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_7048_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_7049_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A16: set @ B,F1: B > C,B15: set @ C,F22: D > A,B23: set @ D] :
      ( ( member @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A16 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A16 ) @ B15 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B15 ) ) ) ) ) ).

% Func_map
thf(fact_7050_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M2: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M2 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M2 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_7051_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_7052_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_7053_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_7054_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_7055_take__bit__num__simps_I7_J,axiom,
    ! [R3: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R3 ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_7056_take__bit__num__simps_I6_J,axiom,
    ! [R3: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R3 ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_7057_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_7058_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_7059_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(8)
thf(fact_7060_and__not__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_7061_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_7062_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_7063_and__not__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_7064_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N2 @ M ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_7065_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_7066_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N: num,Q3: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( some @ num @ Q3 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( numeral_numeral @ int @ Q3 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_7067_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_7068_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_7069_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_7070_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_7071_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G: C > A,R: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite673082921795544331dem_on @ C @ B @ R @ ( comp @ A @ ( B > B ) @ C @ F2 @ G ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_7072_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_7073_Rat_Opositive__add,axiom,
    ! [X: rat,Y3: rat] :
      ( ( positive @ X )
     => ( ( positive @ Y3 )
       => ( positive @ ( plus_plus @ rat @ X @ Y3 ) ) ) ) ).

% Rat.positive_add
thf(fact_7074_Rat_Opositive__mult,axiom,
    ! [X: rat,Y3: rat] :
      ( ( positive @ X )
     => ( ( positive @ Y3 )
       => ( positive @ ( times_times @ rat @ X @ Y3 ) ) ) ) ).

% Rat.positive_mult
thf(fact_7075_less__rat__def,axiom,
    ( ( ord_less @ rat )
    = ( ^ [X5: rat,Y5: rat] : ( positive @ ( minus_minus @ rat @ Y5 @ X5 ) ) ) ) ).

% less_rat_def
thf(fact_7076_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X5: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X5 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X5 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_7077_and__not__num_Oelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa )
        = Y3 )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y3
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y3
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y3
                 != ( none @ num ) ) ) )
           => ( ! [M3: num] :
                  ( ( X
                    = ( bit0 @ M3 ) )
                 => ( ( Xa = one2 )
                   => ( Y3
                     != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y3
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y3
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X
                          = ( bit1 @ M3 ) )
                       => ( ( Xa = one2 )
                         => ( Y3
                           != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y3
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M3 @ N3 ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y3
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_7078_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(5)
thf(fact_7079_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(6)
thf(fact_7080_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(9)
thf(fact_7081_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y3
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y3
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y3
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y3
                          = ( some @ num @ ( bit0 @ M3 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y3
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X
                          = ( bit0 @ M3 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y3
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y3
                                = ( some @ num @ ( bit0 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y3
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M3 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X
                                = ( bit1 @ M3 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y3
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_7082_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X5: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ X5 ) ) ) ) ) ).

% Rat.positive_def
thf(fact_7083_and__num_Oelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa )
        = Y3 )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y3
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y3
               != ( none @ num ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y3
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M3: num] :
                    ( X
                    = ( bit0 @ M3 ) )
               => ( ( Xa = one2 )
                 => ( Y3
                   != ( none @ num ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y3
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y3
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) ) ) )
                 => ( ( ? [M3: num] :
                          ( X
                          = ( bit1 @ M3 ) )
                     => ( ( Xa = one2 )
                       => ( Y3
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y3
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y3
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_7084_xor__num_Oelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa )
        = Y3 )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y3
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ! [N3: num] :
                ( ( Xa
                  = ( bit0 @ N3 ) )
               => ( Y3
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit1 @ N3 ) )
                 => ( Y3
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M3: num] :
                  ( ( X
                    = ( bit0 @ M3 ) )
                 => ( ( Xa = one2 )
                   => ( Y3
                     != ( some @ num @ ( bit1 @ M3 ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y3
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y3
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X
                          = ( bit1 @ M3 ) )
                       => ( ( Xa = one2 )
                         => ( Y3
                           != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y3
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y3
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_7085_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_7086_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_7087_and__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(5)
thf(fact_7088_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(5)
thf(fact_7089_and__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_7090_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_7091_and__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_7092_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_7093_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q3: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_7094_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q3: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_7095_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(9)
thf(fact_7096_and__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(6)
thf(fact_7097_and__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(8)
thf(fact_7098_xor__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ ( bit1 @ N ) ) ) ).

% xor_num.simps(2)
thf(fact_7099_xor__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ ( bit0 @ N ) ) ) ).

% xor_num.simps(3)
thf(fact_7100_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_7101_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_7102_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_7103_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_7104_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_7105_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_7106_and__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(9)
thf(fact_7107_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(6)
thf(fact_7108_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(8)
thf(fact_7109_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y3
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y3
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y3
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y3
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y3
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X
                          = ( bit0 @ M3 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y3
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y3
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y3
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X
                                = ( bit1 @ M3 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y3
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M3 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_7110_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y3: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y3
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y3
                      = ( some @ num @ ( bit1 @ N3 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y3
                        = ( some @ num @ ( bit0 @ N3 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X
                      = ( bit0 @ M3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y3
                          = ( some @ num @ ( bit1 @ M3 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X
                        = ( bit0 @ M3 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y3
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X
                          = ( bit0 @ M3 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y3
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X
                            = ( bit1 @ M3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y3
                                = ( some @ num @ ( bit0 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X
                              = ( bit1 @ M3 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y3
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X
                                = ( bit1 @ M3 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y3
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_7111_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_7112_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_7113_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_7114_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_7115_of__rat__def,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( map_fun @ rat @ ( product_prod @ int @ int ) @ A @ A @ rep_Rat @ ( id @ A )
          @ ^ [X5: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X5 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X5 ) ) ) ) ) ) ).

% of_rat_def
thf(fact_7116_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M2: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A5: nat,X5: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P6 ) ) )
                  @ X5 )
              @ A5 )
          @ ( product_Pair @ nat @ num @ N2 @ M2 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_7117_of__rat__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( zero_zero @ rat ) )
        = ( zero_zero @ A ) ) ) ).

% of_rat_0
thf(fact_7118_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ rat ) ) ) ) ).

% of_rat_eq_0_iff
thf(fact_7119_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( zero_zero @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( zero_zero @ rat )
            = A2 ) ) ) ).

% zero_eq_of_rat_iff
thf(fact_7120_of__rat__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( numeral_numeral @ rat @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_rat_numeral_eq
thf(fact_7121_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R3 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_7122_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R3 ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R3 ) ) ) ).

% zero_less_of_rat_iff
thf(fact_7123_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R3 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R3 ) ) ) ).

% one_less_of_rat_iff
thf(fact_7124_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R3 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_7125_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R3 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_7126_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R3 ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R3 ) ) ) ).

% zero_le_of_rat_iff
thf(fact_7127_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R3 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R3 ) ) ) ).

% one_le_of_rat_iff
thf(fact_7128_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R3 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_7129_of__rat__neg__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_rat_neg_numeral_eq
thf(fact_7130_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X32: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 ) ) ).

% verit_eq_simplify(18)
thf(fact_7131_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X5: num] : ( H2 @ ( F22 @ X5 ) )
        @ ^ [X5: num] : ( H2 @ ( F32 @ X5 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_7132_of__rat__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,N: nat] :
          ( ( field_char_0_of_rat @ A @ ( power_power @ rat @ A2 @ N ) )
          = ( power_power @ A @ ( field_char_0_of_rat @ A @ A2 ) @ N ) ) ) ).

% of_rat_power
thf(fact_7133_of__rat__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat,S: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less @ rat @ R3 @ S ) ) ) ).

% of_rat_less
thf(fact_7134_of__rat__dense,axiom,
    ! [X: real,Y3: real] :
      ( ( ord_less @ real @ X @ Y3 )
     => ? [Q2: rat] :
          ( ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ Q2 ) )
          & ( ord_less @ real @ ( field_char_0_of_rat @ real @ Q2 ) @ Y3 ) ) ) ).

% of_rat_dense
thf(fact_7135_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A2 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_7136_of__rat__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( plus_plus @ rat @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_add
thf(fact_7137_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_7138_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X2: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X2 ) )
      = ( F22 @ X2 ) ) ).

% verit_eq_simplify(17)
thf(fact_7139_of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_divide
thf(fact_7140_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R3: rat,S: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R3 ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less_eq @ rat @ R3 @ S ) ) ) ).

% of_rat_less_eq
thf(fact_7141_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_7142_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_7143_of__rat_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( ^ [X5: rat] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ ( rep_Rat @ X5 ) ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ ( rep_Rat @ X5 ) ) ) ) ) ) ) ).

% of_rat.rep_eq
thf(fact_7144_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) ) ) ) ).

% plus_rat_def
thf(fact_7145_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X5: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X5 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_fst @ int @ int @ X5 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_7146_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X5: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X5 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_7147_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_7148_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_fst @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) ) ) ) ).

% times_rat_def
thf(fact_7149_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( plus_plus @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% plus_rat.abs_eq
thf(fact_7150_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_7151_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X5 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y5 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_7152_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_7153_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X5 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y5 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_7154_of__rat_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: product_prod @ int @ int] :
          ( ( ratrel @ X @ X )
         => ( ( field_char_0_of_rat @ A @ ( abs_Rat @ X ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ).

% of_rat.abs_eq
thf(fact_7155_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( times_times @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_fst @ int @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% times_rat.abs_eq
thf(fact_7156_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( positive @ ( abs_Rat @ X ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_7157_nth__image,axiom,
    ! [A: $tType,L: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs2 ) ) ) ) ).

% nth_image
thf(fact_7158_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L2: code_integer,J: code_integer] :
                ( if @ num
                @ ( J
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_7159_take__all,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N )
     => ( ( take @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% take_all
thf(fact_7160_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N @ Xs2 )
        = Xs2 )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% take_all_iff
thf(fact_7161_nth__take,axiom,
    ! [A: $tType,I2: nat,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs2 ) @ I2 )
        = ( nth @ A @ Xs2 @ I2 ) ) ) ).

% nth_take
thf(fact_7162_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A,Y3: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs2 @ M @ Y3 ) )
        = ( take @ A @ N @ Xs2 ) ) ) ).

% take_update_cancel
thf(fact_7163_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs2 ) ) ) ) ).

% set_take_subset_set_take
thf(fact_7164_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_take_subset
thf(fact_7165_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ K )
             => ( ( nth @ A @ Xs2 @ I3 )
                = ( nth @ A @ Ys @ I3 ) ) )
         => ( ( take @ A @ K @ Xs2 )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_7166_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_7167_lex__take__index,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lex @ A @ R3 ) )
     => ~ ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I3 @ Xs2 )
                  = ( take @ A @ I3 @ Ys ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Ys @ I3 ) ) @ R3 ) ) ) ) ) ).

% lex_take_index
thf(fact_7168_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_7169_ord_Omin__def,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( ^ [Less_eq: A > A > $o,A5: A,B4: A] : ( if @ A @ ( Less_eq @ A5 @ B4 ) @ A5 @ B4 ) ) ) ).

% ord.min_def
thf(fact_7170_ord_Omin_Ocong,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( min @ A ) ) ).

% ord.min.cong
thf(fact_7171_listrel1__iff__update,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R3 ) )
      = ( ? [Y5: A,N2: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs2 @ N2 ) @ Y5 ) @ R3 )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( Ys
              = ( list_update @ A @ Xs2 @ N2 @ Y5 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_7172_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_7173_listrel1__eq__len,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R3 ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_7174_listrel1__mono,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R3 ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_7175_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R3 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_7176_filterlim__finite__subsets__at__top,axiom,
    ! [A: $tType,B: $tType,F2: A > ( set @ B ),A4: set @ B,F4: filter @ A] :
      ( ( filterlim @ A @ ( set @ B ) @ F2 @ ( finite5375528669736107172at_top @ B @ A4 ) @ F4 )
      = ( ! [X9: set @ B] :
            ( ( ( finite_finite @ B @ X9 )
              & ( ord_less_eq @ ( set @ B ) @ X9 @ A4 ) )
           => ( eventually @ A
              @ ^ [Y5: A] :
                  ( ( finite_finite @ B @ ( F2 @ Y5 ) )
                  & ( ord_less_eq @ ( set @ B ) @ X9 @ ( F2 @ Y5 ) )
                  & ( ord_less_eq @ ( set @ B ) @ ( F2 @ Y5 ) @ A4 ) )
              @ F4 ) ) ) ) ).

% filterlim_finite_subsets_at_top
thf(fact_7177_card__Min__le__sum,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A4 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F2 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) ) ) ).

% card_Min_le_sum
thf(fact_7178_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Min_singleton
thf(fact_7179_eventually__finite__subsets__at__top__weakI,axiom,
    ! [A: $tType,A4: set @ A,P: ( set @ A ) > $o] :
      ( ! [X10: set @ A] :
          ( ( finite_finite @ A @ X10 )
         => ( ( ord_less_eq @ ( set @ A ) @ X10 @ A4 )
           => ( P @ X10 ) ) )
     => ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A4 ) ) ) ).

% eventually_finite_subsets_at_top_weakI
thf(fact_7180_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X @ X5 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_7181_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less @ A @ X @ X5 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_7182_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_7183_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ).

% Min_in
thf(fact_7184_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X ) ) ) ) ).

% Min_le
thf(fact_7185_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [Y: A] :
                ( ( member @ A @ Y @ A4 )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( ( member @ A @ X @ A4 )
             => ( ( lattic643756798350308766er_Min @ A @ A4 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_7186_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_7187_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A3: A] :
                  ( ( member @ A @ A3 @ A4 )
                 => ( ord_less_eq @ A @ X @ A3 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_7188_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A4 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_7189_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ( member @ A @ M @ A4 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ M @ X5 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_7190_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less_eq @ A @ X5 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_7191_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A4 )
                = M )
              = ( ( member @ A @ M @ A4 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ M @ X5 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_7192_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less @ A @ X5 @ X ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_7193_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [B3: A] :
                ( ( member @ A @ B3 @ A4 )
               => ( ord_less_eq @ A @ A2 @ B3 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ A2 @ A4 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_7194_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Min_Inf
thf(fact_7195_eventually__finite__subsets__at__top,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A4: set @ A] :
      ( ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A4 ) )
      = ( ? [X9: set @ A] :
            ( ( finite_finite @ A @ X9 )
            & ( ord_less_eq @ ( set @ A ) @ X9 @ A4 )
            & ! [Y8: set @ A] :
                ( ( ( finite_finite @ A @ Y8 )
                  & ( ord_less_eq @ ( set @ A ) @ X9 @ Y8 )
                  & ( ord_less_eq @ ( set @ A ) @ Y8 @ A4 ) )
               => ( P @ Y8 ) ) ) ) ) ).

% eventually_finite_subsets_at_top
thf(fact_7196_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B6 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_7197_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N5 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N5 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N5 ) @ ( lattic643756798350308766er_Min @ A @ M7 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_7198_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_7199_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_7200_finite__subsets__at__top__def,axiom,
    ! [A: $tType] :
      ( ( finite5375528669736107172at_top @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Inf_Inf @ ( filter @ ( set @ A ) )
            @ ( image @ ( set @ A ) @ ( filter @ ( set @ A ) )
              @ ^ [X9: set @ A] :
                  ( principal @ ( set @ A )
                  @ ( collect @ ( set @ A )
                    @ ^ [Y8: set @ A] :
                        ( ( finite_finite @ A @ Y8 )
                        & ( ord_less_eq @ ( set @ A ) @ X9 @ Y8 )
                        & ( ord_less_eq @ ( set @ A ) @ Y8 @ A7 ) ) ) )
              @ ( collect @ ( set @ A )
                @ ^ [X9: set @ A] :
                    ( ( finite_finite @ A @ X9 )
                    & ( ord_less_eq @ ( set @ A ) @ X9 @ A7 ) ) ) ) ) ) ) ).

% finite_subsets_at_top_def
thf(fact_7201_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 )
            = ( fChoice @ A
              @ ^ [Y5: A] :
                  ( ( member @ A @ Y5 @ S2 )
                  & ( ( F2 @ Y5 )
                    = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ) ).

% arg_min_SOME_Min
thf(fact_7202_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_7203_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J2: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J2 @ ( suc @ I2 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J2 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_7204_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A4 ) )
          = ( finite_card @ A @ A4 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_7205_linorder_OMax_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Max @ A )
      = ( lattices_Max @ A ) ) ).

% linorder.Max.cong
thf(fact_7206_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J2: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J2 @ I2 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J2 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_7207_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S2 ) )
              = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_7208_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S2 ) )
              = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_7209_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_7210_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Max_singleton
thf(fact_7211_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D3: int] : ( dvd_dvd @ int @ D3 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_7212_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X5 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_7213_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less @ A @ X5 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_7214_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_7215_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
              = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max_insert
thf(fact_7216_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ).

% Max_in
thf(fact_7217_Max_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max.in_idem
thf(fact_7218_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_7219_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( finite_finite @ A @ B6 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A4 )
                 => ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ B6 )
                      & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ B6 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A4 )
                        & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_7220_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [Y: A] :
                ( ( member @ A @ Y @ A4 )
               => ( ord_less_eq @ A @ Y @ X ) )
           => ( ( member @ A @ X @ A4 )
             => ( ( lattic643756798349783984er_Max @ A @ A4 )
                = X ) ) ) ) ) ).

% Max_eqI
thf(fact_7221_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max_ge
thf(fact_7222_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A3: A] :
                  ( ( member @ A @ A3 @ A4 )
                 => ( ord_less_eq @ A @ A3 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_7223_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A4 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_7224_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ( member @ A @ M @ A4 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X5 @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_7225_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less_eq @ A @ X @ X5 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_7226_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A4 )
                = M )
              = ( ( member @ A @ M @ A4 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X5 @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_7227_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                    & ( ord_less @ A @ X @ X5 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_7228_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [B3: A] :
                ( ( member @ A @ B3 @ A4 )
               => ( ord_less_eq @ A @ B3 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ A2 @ A4 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_7229_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Max_Sup
thf(fact_7230_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D3: int] :
                ( ( dvd_dvd @ int @ D3 @ M )
                & ( dvd_dvd @ int @ D3 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_7231_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_7232_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N5 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N5 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M7 ) @ ( lattic643756798349783984er_Max @ A @ N5 ) ) ) ) ) ) ).

% Max_mono
thf(fact_7233_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y: A] :
              ( ( H2 @ ( ord_max @ A @ X3 @ Y ) )
              = ( ord_max @ A @ ( H2 @ X3 ) @ ( H2 @ Y ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N5 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_7234_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B6 ) @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max.subset
thf(fact_7235_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_7236_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y: A] : ( member @ A @ ( ord_max @ A @ X3 @ Y ) @ ( insert @ A @ X3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Max.closed
thf(fact_7237_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_7238_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_7239_card__le__Suc__Max,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S2 ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S2 ) ) ) ) ).

% card_le_Suc_Max
thf(fact_7240_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X9: set @ nat] :
          ( if @ nat
          @ ( X9
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X9 ) ) ) ) ).

% Sup_nat_def
thf(fact_7241_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M2: nat,N2: nat] :
          ( if @ nat
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K3 @ N2 ) @ M2 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_7242_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_7243_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D3: nat] :
                ( ( dvd_dvd @ nat @ D3 @ M )
                & ( dvd_dvd @ nat @ D3 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_7244_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_7245_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_7246_Gcd__eq__Max,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( M7
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
         => ( ( gcd_Gcd @ nat @ M7 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M2: nat] :
                      ( collect @ nat
                      @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M2 ) )
                  @ M7 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_7247_sum__le__card__Max,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( times_times @ nat @ ( finite_card @ A @ A4 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F2 @ A4 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_7248_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_7249_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_7250_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_7251_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_7252_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_7253_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y3: A] :
          ( ( ord_less @ A @ Z @ ( ord_min @ A @ X @ Y3 ) )
          = ( ( ord_less @ A @ Z @ X )
            & ( ord_less @ A @ Z @ Y3 ) ) ) ) ).

% min_less_iff_conj
thf(fact_7254_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_7255_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_7256_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% min_top
thf(fact_7257_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% min_top2
thf(fact_7258_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_7259_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_7260_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_max @ A @ Y3 @ ( ord_min @ A @ X @ Y3 ) )
          = Y3 ) ) ).

% max_min_same(4)
thf(fact_7261_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y3 ) @ Y3 )
          = Y3 ) ) ).

% max_min_same(3)
thf(fact_7262_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y3 ) @ X )
          = X ) ) ).

% max_min_same(2)
thf(fact_7263_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_max @ A @ X @ ( ord_min @ A @ X @ Y3 ) )
          = X ) ) ).

% max_min_same(1)
thf(fact_7264_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_7265_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_7266_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_7267_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_7268_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_7269_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_7270_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_7271_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_7272_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_7273_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_7274_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_7275_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_7276_length__take,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N @ Xs2 ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% length_take
thf(fact_7277_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N ) ) ) ) ).

% take_bit_of_mask
thf(fact_7278_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_7279_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_7280_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_7281_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_7282_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_7283_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
              = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min_insert
thf(fact_7284_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y3: A,X: A] :
          ( ( ord_less_eq @ A @ Y3 @ X )
         => ( ( ord_min @ A @ X @ Y3 )
            = Y3 ) ) ) ).

% min_absorb2
thf(fact_7285_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y3: A] :
          ( ( ord_less_eq @ A @ X @ Y3 )
         => ( ( ord_min @ A @ X @ Y3 )
            = X ) ) ) ).

% min_absorb1
thf(fact_7286_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def
thf(fact_7287_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_7288_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_7289_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_7290_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_7291_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_7292_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( ord_min @ A @ A5 @ B4 ) ) ) ) ) ).

% min.order_iff
thf(fact_7293_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_7294_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_7295_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% min.absorb_iff1
thf(fact_7296_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% min.absorb_iff2
thf(fact_7297_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_7298_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_7299_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y3 ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            | ( ord_less_eq @ A @ Y3 @ Z ) ) ) ) ).

% min_le_iff_disj
thf(fact_7300_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def_raw
thf(fact_7301_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y3 ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            | ( ord_less @ A @ Y3 @ Z ) ) ) ) ).

% min_less_iff_disj
thf(fact_7302_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_7303_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( ord_min @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_7304_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_7305_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_7306_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R3: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L ) @ R3 )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L @ R3 ) ) ) ).

% concat_bit_assoc_sym
thf(fact_7307_min__diff,axiom,
    ! [M: nat,I2: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I2 ) @ ( minus_minus @ nat @ N @ I2 ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I2 ) ) ).

% min_diff
thf(fact_7308_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y3 ) @ Z )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y3 @ Z ) ) ) ) ).

% min_diff_distrib_left
thf(fact_7309_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q3 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q3 ) @ ( times_times @ nat @ N @ Q3 ) ) ) ).

% nat_mult_min_left
thf(fact_7310_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q3 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q3 ) ) ) ).

% nat_mult_min_right
thf(fact_7311_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y3: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X @ Y3 ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y3 ) ) ) ) ).

% of_int_min
thf(fact_7312_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y3: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y3 ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y3 ) ) ) ) ).

% of_nat_min
thf(fact_7313_linorder_OMin_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Min @ A )
      = ( lattices_Min @ A ) ) ).

% linorder.Min.cong
thf(fact_7314_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y3 @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y3 ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_7315_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y3: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y3 ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y3 @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_7316_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y3: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y3 ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y3 ) ) ) ) ).

% minus_max_eq_min
thf(fact_7317_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y3: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y3 ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y3 ) ) ) ) ).

% minus_min_eq_max
thf(fact_7318_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_7319_Min_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ).

% Min.in_idem
thf(fact_7320_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_7321_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y3 ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y3 @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y3 ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y3 @ P4 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_7322_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y3 ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y3 @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y3 ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y3 @ P4 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_7323_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y3 ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y3 ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y3 ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_7324_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y3 ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y3 ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y3 ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_7325_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y3 ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y3 @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y3 ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y3 @ P4 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_7326_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y3: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y3 ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y3 @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y3 ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y3 @ P4 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_7327_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M4: nat] : ( suc @ ( ord_min @ nat @ N @ M4 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_7328_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M4: nat] : ( suc @ ( ord_min @ nat @ M4 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_7329_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y: A] :
              ( ( H2 @ ( ord_min @ A @ X3 @ Y ) )
              = ( ord_min @ A @ ( H2 @ X3 ) @ ( H2 @ Y ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N5 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_7330_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B6 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset
thf(fact_7331_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_7332_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y: A] : ( member @ A @ ( ord_min @ A @ X3 @ Y ) @ ( insert @ A @ X3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Min.closed
thf(fact_7333_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ ( lattic643756798350308766er_Min @ A @ B6 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_7334_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_7335_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_7336_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_7337_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y3: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y3 ) @ ( lexord @ A @ R3 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y3 ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y3 )
            = X ) )
        | ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y3 ) ) )
            & ( ( take @ A @ I @ X )
              = ( take @ A @ I @ Y3 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I ) @ ( nth @ A @ Y3 @ I ) ) @ R3 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_7338_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I ) @ ( nth @ B @ Ys @ I ) ) )
            & ( ord_less @ nat @ I @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_7339_min__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ Q3 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_7340_min__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q3 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_7341_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_zip
thf(fact_7342_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs2: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) @ I2 )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ).

% nth_zip
thf(fact_7343_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_7344_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,P: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws: list @ B,N3: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws ) )
         => ( ( N3
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
           => ( ( Zs2
                = ( take @ A @ N3 @ Xs2 ) )
             => ( ( Ws
                  = ( take @ B @ N3 @ Ys ) )
               => ( P @ ( zip @ A @ B @ Zs2 @ Ws ) ) ) ) ) )
     => ( P @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ).

% zip_obtain_same_length
thf(fact_7345_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y6: list @ A,Z3: list @ A] : ( Y6 = Z3 ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X5: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X5 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
                  @ X5 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_7346_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Y3: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ B @ Y3 @ ( set2 @ B @ Ys ) )
       => ~ ! [X3: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_7347_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ~ ! [Y: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_7348_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y3: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y3 ) @ ( lex @ A @ R3 ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y3 ) @ ( lexord @ A @ R3 ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y3 ) ) ) ) ).

% lexord_lex
thf(fact_7349_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y5: list @ A,Z5: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y5 )
                = ( size_size @ ( list @ A ) @ Z5 ) )
            @ X3 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs2 )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs2 )
            = ( concat @ A @ Ys ) )
          = ( Xs2 = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_7350_concat__injective,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs2 )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs2 )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y5: list @ A,Z5: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y5 )
                    = ( size_size @ ( list @ A ) @ Z5 ) )
                @ X3 ) )
         => ( Xs2 = Ys ) ) ) ) ).

% concat_injective
thf(fact_7351_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B,Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P4 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
      = ( ? [N2: nat] :
            ( ( ( nth @ A @ Xs2 @ N2 )
              = ( product_fst @ A @ B @ P4 ) )
            & ( ( nth @ B @ Ys @ N2 )
              = ( product_snd @ A @ B @ P4 ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ).

% in_set_zip
thf(fact_7352_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B,R3: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R3 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X5: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X5 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y5: A,Z5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y5 @ Z5 ) @ R3 )
              @ X5 ) ) ) ) ).

% listrel_iff_zip
thf(fact_7353_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_7354_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_7355_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,R3: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R3 ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_7356_ord_Omax_Ocong,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( max @ A ) ) ).

% ord.max.cong
thf(fact_7357_ord_Omax__def,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( ^ [Less_eq: A > A > $o,A5: A,B4: A] : ( if @ A @ ( Less_eq @ A5 @ B4 ) @ B4 @ A5 ) ) ) ).

% ord.max_def
thf(fact_7358_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R3 ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_7359_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,R3: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R3 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [N2: nat] :
            ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ N2 ) @ ( nth @ B @ Ys @ N2 ) ) @ R3 ) ) ) ) ).

% listrel_iff_nth
thf(fact_7360_listrel1__subset__listrel,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ R4 )
     => ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R3 ) @ ( listrel @ A @ A @ R4 ) ) ) ) ).

% listrel1_subset_listrel
thf(fact_7361_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs2 )
        = ( some @ A @ X ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I ) )
            & ( X
              = ( nth @ A @ Xs2 @ I ) )
            & ! [J: nat] :
                ( ( ord_less @ nat @ J @ I )
               => ~ ( P @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7362_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs2: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs2 ) )
      = ( ? [I: nat] :
            ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I ) )
            & ( X
              = ( nth @ A @ Xs2 @ I ) )
            & ! [J: nat] :
                ( ( ord_less @ nat @ J @ I )
               => ~ ( P @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7363_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,M: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate
thf(fact_7364_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X5: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X5
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_7365_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A2 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B2 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_7366_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B2 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_7367_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_7368_length__rotate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_rotate
thf(fact_7369_coprime__abs__left__iff,axiom,
    ! [K: int,L: int] :
      ( ( algebr8660921524188924756oprime @ int @ ( abs_abs @ int @ K ) @ L )
      = ( algebr8660921524188924756oprime @ int @ K @ L ) ) ).

% coprime_abs_left_iff
thf(fact_7370_coprime__abs__right__iff,axiom,
    ! [K: int,L: int] :
      ( ( algebr8660921524188924756oprime @ int @ K @ ( abs_abs @ int @ L ) )
      = ( algebr8660921524188924756oprime @ int @ K @ L ) ) ).

% coprime_abs_right_iff
thf(fact_7371_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_7372_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_left_iff
thf(fact_7373_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ A2 @ ( modulo_modulo @ A @ B2 @ A2 ) )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_right_iff
thf(fact_7374_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_left_iff
thf(fact_7375_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( power_power @ A @ B2 @ N ) )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_right_iff
thf(fact_7376_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ ( suc @ N ) @ Xs2 )
      = ( rotate1 @ A @ ( rotate @ A @ N @ Xs2 ) ) ) ).

% rotate_Suc
thf(fact_7377_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_7378_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_7379_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_7380_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_7381_rotate__length01,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% rotate_length01
thf(fact_7382_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% rotate_id
thf(fact_7383_coprime__right__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_right_2_iff_odd
thf(fact_7384_coprime__left__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_left_2_iff_odd
thf(fact_7385_normalize__stable,axiom,
    ! [Q3: int,P4: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q3 )
     => ( ( algebr8660921524188924756oprime @ int @ P4 @ Q3 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q3 ) )
          = ( product_Pair @ int @ int @ P4 @ Q3 ) ) ) ) ).

% normalize_stable
thf(fact_7386_coprime__common__divisor__int,axiom,
    ! [A2: int,B2: int,X: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ X @ A2 )
       => ( ( dvd_dvd @ int @ X @ B2 )
         => ( ( abs_abs @ int @ X )
            = ( one_one @ int ) ) ) ) ) ).

% coprime_common_divisor_int
thf(fact_7387_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N2: nat,Xs3: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ).

% rotate_conv_mod
thf(fact_7388_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_7389_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_7390_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_7391_coprime__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [B4: A,A5: A] : ( algebr8660921524188924756oprime @ A @ A5 @ B4 ) ) ) ) ).

% coprime_commute
thf(fact_7392_coprime__divisors,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ D2 )
           => ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_divisors
thf(fact_7393_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A2 ) ) ).

% coprime_1_left
thf(fact_7394_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_7395_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N @ Xs2 ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N ) @ Xs2 ) ) ).

% rotate_rotate
thf(fact_7396_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ A2 ) ) ).

% coprime_add_one_left
thf(fact_7397_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_7398_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ! [C3: A] :
              ( ( dvd_dvd @ A @ C3 @ A2 )
             => ( ( dvd_dvd @ A @ C3 @ B2 )
               => ( dvd_dvd @ A @ C3 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% coprimeI
thf(fact_7399_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A5: A,B4: A] :
            ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A5 )
             => ( ( dvd_dvd @ A @ C4 @ B4 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_7400_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( dvd_dvd @ A @ C3 @ A2 )
               => ( ( dvd_dvd @ A @ C3 @ B2 )
                 => ( dvd_dvd @ A @ C3 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_7401_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% not_coprimeI
thf(fact_7402_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,Y3: A] :
          ( ( dvd_dvd @ A @ X @ Y3 )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y3 )
            = ( dvd_dvd @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_7403_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
         => ( ! [E: A] :
                ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E @ A2 )
                 => ( ( dvd_dvd @ A @ E @ B2 )
                   => ( dvd_dvd @ A @ E @ C2 ) ) ) )
           => ( ! [E: A] :
                  ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E @ A2 )
                   => ( ( dvd_dvd @ A @ E @ B2 )
                     => ( dvd_dvd @ A @ E @ D2 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_7404_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y3: A,X: A] :
          ( ( dvd_dvd @ A @ Y3 @ X )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y3 )
            = ( dvd_dvd @ A @ Y3 @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_7405_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_7406_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_7407_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_7408_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N: A,A2: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N @ A2 ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ N @ B2 ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_7409_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A2: A,N: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ N ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ B2 @ N ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_7410_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_7411_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_7412_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_7413_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_7414_coprime__crossproduct__int,axiom,
    ! [A2: int,D2: int,B2: int,C2: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ D2 )
     => ( ( algebr8660921524188924756oprime @ int @ B2 @ C2 )
       => ( ( ( times_times @ int @ ( abs_abs @ int @ A2 ) @ ( abs_abs @ int @ C2 ) )
            = ( times_times @ int @ ( abs_abs @ int @ B2 ) @ ( abs_abs @ int @ D2 ) ) )
          = ( ( ( abs_abs @ int @ A2 )
              = ( abs_abs @ int @ B2 ) )
            & ( ( abs_abs @ int @ C2 )
              = ( abs_abs @ int @ D2 ) ) ) ) ) ) ).

% coprime_crossproduct_int
thf(fact_7415_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_7416_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_7417_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( A2
             != ( zero_zero @ A ) )
            | ( B2
             != ( zero_zero @ A ) ) )
         => ( algebr8660921524188924756oprime @ A @ ( divide_divide @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) @ ( divide_divide @ A @ B2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% div_gcd_coprime
thf(fact_7418_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,A6: A,B5: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( times_times @ A @ A6 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B5 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A6 @ B5 ) ) ) ) ) ).

% gcd_coprime
thf(fact_7419_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A18: A,B7: A] :
              ( ( A2
                = ( times_times @ A @ A18 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B7 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A18 @ B7 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_7420_Rat__cases,axiom,
    ! [Q3: rat] :
      ~ ! [A3: int,B3: int] :
          ( ( Q3
            = ( fract @ A3 @ B3 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B3 )
           => ~ ( algebr8660921524188924756oprime @ int @ A3 @ B3 ) ) ) ).

% Rat_cases
thf(fact_7421_Rat__induct,axiom,
    ! [P: rat > $o,Q3: rat] :
      ( ! [A3: int,B3: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B3 )
         => ( ( algebr8660921524188924756oprime @ int @ A3 @ B3 )
           => ( P @ ( fract @ A3 @ B3 ) ) ) )
     => ( P @ Q3 ) ) ).

% Rat_induct
thf(fact_7422_Rat__cases__nonzero,axiom,
    ! [Q3: rat] :
      ( ! [A3: int,B3: int] :
          ( ( Q3
            = ( fract @ A3 @ B3 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B3 )
           => ( ( A3
               != ( zero_zero @ int ) )
             => ~ ( algebr8660921524188924756oprime @ int @ A3 @ B3 ) ) ) )
     => ( Q3
        = ( zero_zero @ rat ) ) ) ).

% Rat_cases_nonzero
thf(fact_7423_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( field_char_0_Rats @ A ) )
         => ~ ! [A3: int,B3: int] :
                ( ( ord_less @ int @ ( zero_zero @ int ) @ B3 )
               => ( ( algebr8660921524188924756oprime @ int @ A3 @ B3 )
                 => ( X
                   != ( divide_divide @ A @ ( ring_1_of_int @ A @ A3 ) @ ( ring_1_of_int @ A @ B3 ) ) ) ) ) ) ) ).

% Rats_cases'
thf(fact_7424_quotient__of__unique,axiom,
    ! [R3: rat] :
    ? [X3: product_prod @ int @ int] :
      ( ( R3
        = ( fract @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
      & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ X3 ) )
      & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) )
      & ! [Y4: product_prod @ int @ int] :
          ( ( ( R3
              = ( fract @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
            & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Y4 ) )
            & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
         => ( Y4 = X3 ) ) ) ).

% quotient_of_unique
thf(fact_7425_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs2: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ X ) @ ( nth @ A @ Xs2 @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7426_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ( countable_countable @ A @ X8 )
     => ~ ! [F5: nat > ( set @ A )] :
            ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F5 @ I4 ) @ X8 )
           => ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F5 @ I4 ) @ ( F5 @ ( suc @ I4 ) ) )
             => ( ! [I4: nat] : ( finite_finite @ A @ ( F5 @ I4 ) )
               => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F5 @ ( top_top @ ( set @ nat ) ) ) )
                 != X8 ) ) ) ) ) ).

% finite_sequence_to_countable_set
thf(fact_7427_coprime__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( algebr8660921524188924756oprime @ nat @ M @ N ) ) ).

% coprime_int_iff
thf(fact_7428_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ns ) )
               => ( X5
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7429_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( algebr8660921524188924756oprime @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% coprime_nat_abs_left_iff
thf(fact_7430_coprime__nat__abs__right__iff,axiom,
    ! [N: nat,K: int] :
      ( ( algebr8660921524188924756oprime @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% coprime_nat_abs_right_iff
thf(fact_7431_coprime__crossproduct__nat,axiom,
    ! [A2: nat,D2: nat,B2: nat,C2: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ D2 )
     => ( ( algebr8660921524188924756oprime @ nat @ B2 @ C2 )
       => ( ( ( times_times @ nat @ A2 @ C2 )
            = ( times_times @ nat @ B2 @ D2 ) )
          = ( ( A2 = B2 )
            & ( C2 = D2 ) ) ) ) ) ).

% coprime_crossproduct_nat
thf(fact_7432_coprime__Suc__left__nat,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ N ) @ N ) ).

% coprime_Suc_left_nat
thf(fact_7433_coprime__Suc__right__nat,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ N ) ) ).

% coprime_Suc_right_nat
thf(fact_7434_coprime__Suc__0__left,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ).

% coprime_Suc_0_left
thf(fact_7435_coprime__Suc__0__right,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ).

% coprime_Suc_0_right
thf(fact_7436_coprime__common__divisor__nat,axiom,
    ! [A2: nat,B2: nat,X: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ X @ A2 )
       => ( ( dvd_dvd @ nat @ X @ B2 )
         => ( X
            = ( one_one @ nat ) ) ) ) ) ).

% coprime_common_divisor_nat
thf(fact_7437_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% member_le_sum_list
thf(fact_7438_ccInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
            = ( ? [X5: A] :
                  ( ( member @ A @ X5 @ S2 )
                  & ( ord_less @ A @ X5 @ A2 ) ) ) ) ) ) ).

% ccInf_less_iff
thf(fact_7439_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% ccInf_greatest
thf(fact_7440_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A4 ) )
            = ( ! [X5: A] :
                  ( ( member @ A @ X5 @ A4 )
                 => ( ord_less_eq @ A @ B2 @ X5 ) ) ) ) ) ) ).

% le_ccInf_iff
thf(fact_7441_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ U @ A4 )
           => ( ( ord_less_eq @ A @ U @ V )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ V ) ) ) ) ) ).

% ccInf_lower2
thf(fact_7442_ccInf__lower,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X ) ) ) ) ).

% ccInf_lower
thf(fact_7443_ccInf__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( countable_countable @ A @ A4 )
           => ( ! [B3: A] :
                  ( ( member @ A @ B3 @ B6 )
                 => ? [X6: A] :
                      ( ( member @ A @ X6 @ A4 )
                      & ( ord_less_eq @ A @ X6 @ B3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ) ).

% ccInf_mono
thf(fact_7444_countable__image__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% countable_image_eq
thf(fact_7445_countable__subset__image,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A4: set @ B] :
      ( ( ( countable_countable @ A @ B6 )
        & ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A4 ) ) )
      = ( ? [A19: set @ B] :
            ( ( countable_countable @ B @ A19 )
            & ( ord_less_eq @ ( set @ B ) @ A19 @ A4 )
            & ( B6
              = ( image @ B @ A @ F2 @ A19 ) ) ) ) ) ).

% countable_subset_image
thf(fact_7446_ex__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( countable_countable @ A @ T9 )
            & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_countable_subset_image
thf(fact_7447_all__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ( countable_countable @ A @ T9 )
              & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( countable_countable @ B @ T9 )
              & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_countable_subset_image
thf(fact_7448_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ).

% ccInf_superset_mono
thf(fact_7449_countable__image__eq__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T9 ) )
            & ( inj_on @ B @ A @ F2 @ T9 ) ) ) ) ).

% countable_image_eq_inj
thf(fact_7450_ex__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( countable_countable @ A @ T9 )
            & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_countable_subset_image_inj
thf(fact_7451_all__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ( countable_countable @ A @ T9 )
              & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( countable_countable @ B @ T9 )
              & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_countable_subset_image_inj
thf(fact_7452_less__ccSup__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
            = ( ? [X5: A] :
                  ( ( member @ A @ X5 @ S2 )
                  & ( ord_less @ A @ A2 @ X5 ) ) ) ) ) ) ).

% less_ccSup_iff
thf(fact_7453_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ).

% ccSup_subset_mono
thf(fact_7454_infinite__countable__subset_H,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ~ ( finite_finite @ A @ X8 )
     => ? [C7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ C7 @ X8 )
          & ( countable_countable @ A @ C7 )
          & ~ ( finite_finite @ A @ C7 ) ) ) ).

% infinite_countable_subset'
thf(fact_7455_countable__subset,axiom,
    ! [A: $tType,A4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
     => ( ( countable_countable @ A @ B6 )
       => ( countable_countable @ A @ A4 ) ) ) ).

% countable_subset
thf(fact_7456_countable__Collect__finite__subset,axiom,
    ! [A: $tType,T6: set @ A] :
      ( ( countable_countable @ A @ T6 )
     => ( countable_countable @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [A7: set @ A] :
              ( ( finite_finite @ A @ A7 )
              & ( ord_less_eq @ ( set @ A ) @ A7 @ T6 ) ) ) ) ) ).

% countable_Collect_finite_subset
thf(fact_7457_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ U @ A4 )
           => ( ( ord_less_eq @ A @ V @ U )
             => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% ccSup_upper2
thf(fact_7458_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ B2 )
            = ( ! [X5: A] :
                  ( ( member @ A @ X5 @ A4 )
                 => ( ord_less_eq @ A @ X5 @ B2 ) ) ) ) ) ) ).

% ccSup_le_iff
thf(fact_7459_ccSup__upper,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% ccSup_upper
thf(fact_7460_ccSup__least,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ Z ) ) ) ) ).

% ccSup_least
thf(fact_7461_ccSup__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( countable_countable @ A @ A4 )
           => ( ! [A3: A] :
                  ( ( member @ A @ A3 @ A4 )
                 => ? [X6: A] :
                      ( ( member @ A @ X6 @ B6 )
                      & ( ord_less_eq @ A @ A3 @ X6 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ).

% ccSup_mono
thf(fact_7462_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7463_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs2 )
              = ( zero_zero @ A ) )
            = ( ! [X5: A] :
                  ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
                 => ( X5
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7464_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7465_ccSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I2: B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I2 @ A4 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ I2 ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% ccSUP_upper2
thf(fact_7466_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U )
            = ( ! [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ U ) ) ) ) ) ) ).

% ccSUP_le_iff
thf(fact_7467_ccSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I2: B,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I2 @ A4 )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% ccSUP_upper
thf(fact_7468_ccSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ).

% ccSUP_least
thf(fact_7469_ccSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B6: set @ C,F2: B > A,G: C > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( countable_countable @ C @ B6 )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A4 )
                 => ? [X6: C] :
                      ( ( member @ C @ X6 @ B6 )
                      & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X6 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B6 ) ) ) ) ) ) ) ).

% ccSUP_mono
thf(fact_7470_less__ccSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A4: set @ B,A2: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                  & ( ord_less @ A @ A2 @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% less_ccSUP_iff
thf(fact_7471_ccINF__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B6: set @ C,F2: B > A,G: C > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( countable_countable @ C @ B6 )
           => ( ! [M3: C] :
                  ( ( member @ C @ M3 @ B6 )
                 => ? [X6: B] :
                      ( ( member @ B @ X6 @ A4 )
                      & ( ord_less_eq @ A @ ( F2 @ X6 ) @ ( G @ M3 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B6 ) ) ) ) ) ) ) ).

% ccINF_mono
thf(fact_7472_ccINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I2: B,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I2 @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( F2 @ I2 ) ) ) ) ) ).

% ccINF_lower
thf(fact_7473_ccINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I2: B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I2 @ A4 )
           => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ) ).

% ccINF_lower2
thf(fact_7474_le__ccINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
            = ( ! [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                 => ( ord_less_eq @ A @ U @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% le_ccINF_iff
thf(fact_7475_ccINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A4 )
               => ( ord_less_eq @ A @ U @ ( F2 @ I3 ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% ccINF_greatest
thf(fact_7476_ccINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A4: set @ B,F2: B > A,A2: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ A2 )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A4 )
                  & ( ord_less @ A @ ( F2 @ X5 ) @ A2 ) ) ) ) ) ) ).

% ccINF_less_iff
thf(fact_7477_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7478_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ N ) ) ).

% coprime_diff_one_left_nat
thf(fact_7479_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_7480_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( countable_countable @ A @ B6 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ).

% ccSup_inter_less_eq
thf(fact_7481_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( countable_countable @ A @ B6 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B6 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) ) ) ) ) ) ).

% less_eq_ccInf_inter
thf(fact_7482_ccSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ B,A4: set @ B,F2: B > A,G: B > A] :
          ( ( countable_countable @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A4 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% ccSUP_subset_mono
thf(fact_7483_ccINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B6: set @ B,F2: B > A,G: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ ( set @ B ) @ B6 @ A4 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ B6 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B6 ) ) ) ) ) ) ) ).

% ccINF_superset_mono
thf(fact_7484_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7485_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I5: set @ C,A4: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B
              @ ( complete_Sup_Sup @ B
                @ ( image @ C @ B
                  @ ^ [X5: C] : ( F2 @ ( A4 @ X5 ) )
                  @ I5 ) )
              @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A4 @ I5 ) ) ) ) ) ) ) ).

% mono_ccSUP
thf(fact_7486_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A4 )
           => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% mono_ccSup
thf(fact_7487_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A4 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ).

% mono_ccInf
thf(fact_7488_mono__ccINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I5: set @ C,A4: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A4 @ I5 ) ) )
              @ ( complete_Inf_Inf @ B
                @ ( image @ C @ B
                  @ ^ [X5: C] : ( F2 @ ( A4 @ X5 ) )
                  @ I5 ) ) ) ) ) ) ).

% mono_ccINF
thf(fact_7489_card__length__sum__list__rec,axiom,
    ! [M: nat,N5: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L2: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L2 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L2 )
                  = N5 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L2 )
                    = N5 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L2 ) @ ( one_one @ nat ) )
                    = N5 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7490_card__length__sum__list,axiom,
    ! [M: nat,N5: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L2: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L2 )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L2 )
                = N5 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N5 @ M ) @ ( one_one @ nat ) ) @ N5 ) ) ).

% card_length_sum_list
thf(fact_7491_Rats__abs__nat__div__natE,axiom,
    ! [X: real] :
      ( ( member @ real @ X @ ( field_char_0_Rats @ real ) )
     => ~ ! [M3: nat,N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( ( ( abs_abs @ real @ X )
                = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( semiring_1_of_nat @ real @ N3 ) ) )
             => ~ ( algebr8660921524188924756oprime @ nat @ M3 @ N3 ) ) ) ) ).

% Rats_abs_nat_div_natE
thf(fact_7492_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7493_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs2: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X5: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X5 ) @ ( F2 @ X5 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7494_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
    @ ^ [X5: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ X5 ) ) )
    @ ^ [X5: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ X5 ) ) ) ) ).

% Rat.positive.rsp
thf(fact_7495_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( size_size @ ( list @ B ) @ Xs2 ) ) ).

% length_map
thf(fact_7496_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( zero_zero @ A )
              @ Xs2 ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_7497_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs2: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs2 ) @ N )
        = ( F2 @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% nth_map
thf(fact_7498_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ Xs2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_addf
thf(fact_7499_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ Xs2 ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7500_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
              @ Xs2 ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7501_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F3: B > nat,Xs3: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F3 @ Xs3 ) ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7502_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_7503_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs2: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs2 ) ) ) ) ).

% sum_list_abs
thf(fact_7504_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X5: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_7505_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs2: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs2 )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_7506_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
                @ R
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_7507_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R @ R @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
                  @ R
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_7508_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
                @ R )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_7509_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X5: A] : ( suc @ ( F2 @ X5 ) )
          @ Xs2 ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% sum_list_Suc
thf(fact_7510_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ).

% sum_list_mono
thf(fact_7511_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A4: A > B > $o,B6: C > D > $o,F2: A > C,G: B > D,X8: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A4 @ B6 @ F2 @ G )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ X8 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A4 ) ) )
       => ( ( member @ ( product_prod @ A @ B ) @ X @ X8 )
         => ( B6 @ ( comp @ A @ C @ ( product_prod @ A @ B ) @ F2 @ ( product_fst @ A @ B ) @ X ) @ ( comp @ B @ D @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) @ X ) ) ) ) ) ).

% rel_fun_Collect_case_prodD
thf(fact_7512_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R3: B,Xs2: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X5: C] : R3
              @ Xs2 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs2 ) ) @ R3 ) ) ) ).

% sum_list_triv
thf(fact_7513_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X5: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X5 ) @ ( F2 @ X5 ) )
        @ ( set2 @ A @ Xs2 ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7514_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ A @ A @ ratrel
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ ^ [X5: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X5 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X5 ) ) )
        @ ^ [X5: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X5 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X5 ) ) ) ) ) ).

% of_rat.rsp
thf(fact_7515_fun_Oin__rel,axiom,
    ! [B: $tType,A: $tType,D: $tType,R: A > B > $o,A2: D > A,B2: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y6: D,Z3: D] : ( Y6 = Z3 )
        @ R
        @ A2
        @ B2 )
      = ( ? [Z5: D > ( product_prod @ A @ B )] :
            ( ( member @ ( D > ( product_prod @ A @ B ) ) @ Z5
              @ ( collect @ ( D > ( product_prod @ A @ B ) )
                @ ^ [X5: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ D @ ( product_prod @ A @ B ) @ X5 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) ) )
            & ( ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) @ Z5 )
              = A2 )
            & ( ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) @ Z5 )
              = B2 ) ) ) ) ).

% fun.in_rel
thf(fact_7516_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
                @ R
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_7517_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
        = Xs2 ) ) ).

% map_fst_zip
thf(fact_7518_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
        = Ys ) ) ).

% map_snd_zip
thf(fact_7519_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) ) ) ).

% plus_rat.rsp
thf(fact_7520_less__eq__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_integer.rsp
thf(fact_7521_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_7522_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ratrel )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) ) ) ).

% Fract.rsp
thf(fact_7523_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_fst @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_fst @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) ) ) ).

% times_rat.rsp
thf(fact_7524_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
              @ R
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_7525_less__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ nat ) ) ).

% less_natural.rsp
thf(fact_7526_less__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( ord_less @ int )
    @ ( ord_less @ int ) ) ).

% less_integer.rsp
thf(fact_7527_sub_Orsp,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > int )
    @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ num @ num @ int @ int
      @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    @ ^ [M2: num,N2: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) )
    @ ^ [M2: num,N2: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) ) ) ).

% sub.rsp
thf(fact_7528_times__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    @ ( times_times @ int )
    @ ( times_times @ int ) ) ).

% times_integer.rsp
thf(fact_7529_times__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    @ ( times_times @ nat )
    @ ( times_times @ nat ) ) ).

% times_natural.rsp
thf(fact_7530_divide__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    @ ( divide_divide @ int )
    @ ( divide_divide @ int ) ) ).

% divide_integer.rsp
thf(fact_7531_divide__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    @ ( divide_divide @ nat )
    @ ( divide_divide @ nat ) ) ).

% divide_natural.rsp
thf(fact_7532_Suc_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ nat @ nat
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ suc
    @ suc ) ).

% Suc.rsp
thf(fact_7533_unset__bit__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    @ ( bit_se2638667681897837118et_bit @ nat )
    @ ( bit_se2638667681897837118et_bit @ nat ) ) ).

% unset_bit_natural.rsp
thf(fact_7534_unset__bit__integer_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( int > int ) @ ( int > int )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    @ ( bit_se2638667681897837118et_bit @ int )
    @ ( bit_se2638667681897837118et_bit @ int ) ) ).

% unset_bit_integer.rsp
thf(fact_7535_dup_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ int @ int
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ^ [K3: int] : ( plus_plus @ int @ K3 @ K3 )
    @ ^ [K3: int] : ( plus_plus @ int @ K3 @ K3 ) ) ).

% dup.rsp
thf(fact_7536_plus__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    @ ( plus_plus @ int )
    @ ( plus_plus @ int ) ) ).

% plus_integer.rsp
thf(fact_7537_plus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    @ ( plus_plus @ nat )
    @ ( plus_plus @ nat ) ) ).

% plus_natural.rsp
thf(fact_7538_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S2: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A ) > ( num > A ) > num > A ) @ ( ( num > B ) > ( num > B ) > num > B ) @ S2
      @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( ( num > A ) > num > A ) @ ( ( num > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ A @ B
          @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
          @ S2 )
        @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
            @ S2 )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
            @ S2 ) ) )
      @ ( case_num @ A )
      @ ( case_num @ B ) ) ).

% num.case_transfer
thf(fact_7539_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( zip @ A @ B @ Xs2 @ Ys )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs2 )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys ) ) ) ) ).

% zip_eq_conv
thf(fact_7540_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: A > B > $o,R22: C > D > $o,P: A > C > $o,Q: B > D > $o,A2: product_prod @ A @ B,A4: set @ ( product_prod @ A @ B ),B2: product_prod @ C @ D,B6: set @ ( product_prod @ C @ D )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ R1
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ R22
          @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
        @ P
        @ Q )
     => ( ( member @ ( product_prod @ A @ B ) @ A2 @ A4 )
       => ( ( member @ ( product_prod @ C @ D ) @ B2 @ B6 )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A4 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R1 ) ) )
           => ( ( ord_less_eq @ ( set @ ( product_prod @ C @ D ) ) @ B6 @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ R22 ) ) )
             => ( ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_fst @ C @ D @ B2 ) )
                = ( Q @ ( product_snd @ A @ B @ A2 ) @ ( product_snd @ C @ D @ B2 ) ) ) ) ) ) ) ) ).

% predicate2_transferD
thf(fact_7541_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) @ Xs2 ) ) ).

% map_fst_zip_take
thf(fact_7542_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ B,Ys: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs2 @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ Ys ) ) ).

% map_snd_zip_take
thf(fact_7543_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X5: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X5 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_fst @ int @ int @ X5 ) ) )
    @ ^ [X5: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X5 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_fst @ int @ int @ X5 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_7544_fun_Orel__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,R: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R @ Ra )
     => ( ord_less_eq @ ( ( D > A ) > ( D > B ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y6: D,Z3: D] : ( Y6 = Z3 )
          @ R )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y6: D,Z3: D] : ( Y6 = Z3 )
          @ Ra ) ) ) ).

% fun.rel_mono
thf(fact_7545_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ X5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_7546_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X5: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X5 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_fst @ int @ int @ X5 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_7547_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_7548_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 )
      @ pcr_rat )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7549_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ A @ A @ pcr_rat
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ ^ [X5: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X5 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X5 ) ) )
        @ ( field_char_0_of_rat @ A ) ) ) ).

% of_rat.transfer
thf(fact_7550_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X5: product_prod @ int @ int,Y5: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_fst @ int @ int @ Y5 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_7551_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
    @ ^ [X5: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X5 ) @ ( product_snd @ int @ int @ X5 ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_7552_fun__mono,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,C6: A > B > $o,A4: A > B > $o,B6: C > D > $o,D5: C > D > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ C6 @ A4 )
     => ( ( ord_less_eq @ ( C > D > $o ) @ B6 @ D5 )
       => ( ord_less_eq @ ( ( A > C ) > ( B > D ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A4 @ B6 ) @ ( bNF_rel_fun @ A @ B @ C @ D @ C6 @ D5 ) ) ) ) ).

% fun_mono
thf(fact_7553_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7554_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7555_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X5: B,B4: A] : ( plus_plus @ A @ ( F3 @ X5 ) @ ( times_times @ A @ A5 @ B4 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7556_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_7557_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7558_take__upt,axiom,
    ! [I2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I2 @ N ) )
        = ( upt @ I2 @ ( plus_plus @ nat @ I2 @ M ) ) ) ) ).

% take_upt
thf(fact_7559_nth__upt,axiom,
    ! [I2: nat,K: nat,J2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J2 )
     => ( ( nth @ nat @ ( upt @ I2 @ J2 ) @ K )
        = ( plus_plus @ nat @ I2 @ K ) ) ) ).

% nth_upt
thf(fact_7560_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% map_fst_enumerate
thf(fact_7561_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_7562_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ) ) ) ).

% atMost_upto
thf(fact_7563_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N2: nat,M2: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ ( suc @ M2 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7564_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N2: nat,M2: nat] : ( set2 @ nat @ ( upt @ N2 @ ( suc @ M2 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7565_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast_upt
thf(fact_7566_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N2: nat,M2: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ M2 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7567_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] :
      ( ( map @ nat @ A
        @ ^ [I: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I2 ) )
      = ( replicate @ A @ I2 @ X ) ) ).

% map_replicate_trivial
thf(fact_7568_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I: nat] : ( plus_plus @ nat @ I @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_7569_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_7570_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N2: nat,Xs3: list @ A] : ( zip @ nat @ A @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) @ Xs3 ) ) ) ).

% enumerate_eq_zip
thf(fact_7571_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_7572_map__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs2 ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
      = Xs2 ) ).

% map_nth
thf(fact_7573_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_7574_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,N: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N ) ) @ I2 )
        = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) ) ).

% nth_map_upt
thf(fact_7575_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ pcr_int
    @ ^ [N2: nat] : ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_7576_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_7577_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7578_map__upt__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I3 )
              = ( F2 @ ( plus_plus @ nat @ M @ I3 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N ) )
          = Xs2 ) ) ) ).

% map_upt_eqI
thf(fact_7579_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_7580_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_7581_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_7582_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_7583_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_7584_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_7585_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_7586_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X3: nat,Y: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7587_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S2: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A > A ) > ( num > A > A ) > num > A ) @ ( ( num > B > B ) > ( num > B > B ) > num > B ) @ S2
      @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( ( num > A > A ) > num > A ) @ ( ( num > B > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
          @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ S2 @ S2 ) )
        @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
            @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
            @ ( bNF_rel_fun @ A @ B @ A @ B @ S2 @ S2 ) )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y6: num,Z3: num] : ( Y6 = Z3 )
            @ S2 ) ) )
      @ ( rec_num @ A )
      @ ( rec_num @ B ) ) ).

% num.rec_transfer
thf(fact_7588_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_7589_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_7590_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
          = ( sorted_wrt @ B
            @ ^ [X5: B,Y5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y5 ) )
            @ Xs2 ) ) ) ).

% sorted_map
thf(fact_7591_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A4 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7592_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs2 @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_7593_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs2 ) ) ) ) ).

% sorted_remdups
thf(fact_7594_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_7595_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7596_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7597_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_7598_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs2 ) ) ) ) ).

% sorted_take
thf(fact_7599_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs2 )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs2 = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7600_sorted__wrt01,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs2 ) ) ).

% sorted_wrt01
thf(fact_7601_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P3: A > A > $o,Xs3: list @ A] :
          ! [I: nat,J: nat] :
            ( ( ord_less @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ ( nth @ A @ Xs3 @ I ) @ ( nth @ A @ Xs3 @ J ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7602_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A,I2: nat,J2: nat] :
      ( ( sorted_wrt @ A @ P @ Xs2 )
     => ( ( ord_less @ nat @ I2 @ J2 )
       => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7603_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs2 ) )
             => ( Ys = Xs2 ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7604_verit__eq__simplify_I21_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A,X32: num] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 @ ( rec_num @ A @ F1 @ F22 @ F32 @ X32 ) ) ) ).

% verit_eq_simplify(21)
thf(fact_7605_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(19)
thf(fact_7606_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A,X2: num] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X2 ) )
      = ( F22 @ X2 @ ( rec_num @ A @ F1 @ F22 @ F32 @ X2 ) ) ) ).

% verit_eq_simplify(20)
thf(fact_7607_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A4 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7608_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) ) ).

% sorted_enumerate
thf(fact_7609_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I: nat,J: nat] :
                ( ( ord_less @ nat @ I @ J )
               => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7610_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted01
thf(fact_7611_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A4 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y4: list @ A] :
                  ( ( ( ( set2 @ A @ Y4 )
                      = A4 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y4 )
                    & ( distinct @ A @ Y4 ) )
                 => ( Y4 = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7612_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7613_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I: nat] :
                ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ ( suc @ I ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7614_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ~ ! [L3: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L3 )
               => ( ( ( set2 @ A @ L3 )
                    = A4 )
                 => ( ( size_size @ ( list @ A ) @ L3 )
                   != ( finite_card @ A @ A4 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7615_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I: nat,J: nat] :
                ( ( ord_less_eq @ nat @ I @ J )
               => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7616_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I2: nat,J2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7617_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I2 @ ( nth @ nat @ Ns @ I2 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7618_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ? [X6: A] :
                ( ( member @ A @ X6 @ ( set2 @ A @ Xs2 ) )
                & ( P @ X6 ) )
           => ( ( find @ A @ P @ Xs2 )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X5: A] :
                        ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
                        & ( P @ X5 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_7619_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs2 )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs2 = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7620_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A4 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A4 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A4 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7621_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ~ ! [L3: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L3 ) )
               => ( ( ( set2 @ B @ L3 )
                    = A4 )
                 => ( ( size_size @ ( list @ B ) @ L3 )
                   != ( finite_card @ B @ A4 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_7622_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs3: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A7 )
              @ ( zip @ A @ nat @ Xs3 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7623_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs2: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs2 ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs2 ) ) ) ).

% length_filter_map
thf(fact_7624_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs2: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X5: B] :
                  ( ( F2 @ X5 )
                  = ( G @ Xs2 ) )
              @ Xs2 ) ) ) ) ).

% sorted_map_same
thf(fact_7625_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ).

% sorted_filter
thf(fact_7626_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( F2 @ X5 ) @ ( zero_zero @ A ) )
              @ Xs2 ) ) ) ) ).

% sum_list_map_filter'
thf(fact_7627_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs2: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X5: A] :
                ( X5
                = ( G @ Xs2 ) )
            @ Xs2 ) ) ) ).

% sorted_same
thf(fact_7628_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% filter_is_subset
thf(fact_7629_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_filter_less
thf(fact_7630_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X5: A] :
                ~ ( P @ X5 )
            @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% sum_length_filter_compl
thf(fact_7631_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
              @ X )
            @ Xs2 ) )
        @ X )
      = ( filter2 @ A
        @ ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
          @ X )
        @ Xs2 ) ) ).

% replicate_length_filter
thf(fact_7632_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_filter_le
thf(fact_7633_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs2 ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7634_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B,P: B > $o,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs2 ) )
             => ( ~ ( P @ X3 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7635_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( nths @ A @ Xs3
            @ ( collect @ nat
              @ ^ [I: nat] :
                  ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs3 ) )
                  & ( P3 @ ( nth @ A @ Xs3 @ I ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7636_length__filter__conv__card,axiom,
    ! [A: $tType,P4: A > $o,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P4 @ Xs2 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] :
              ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( P4 @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7637_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X5: A] : X5 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7638_distinct__length__filter,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs2 )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% distinct_length_filter
thf(fact_7639_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs2: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P6 ) ) )
          @ ( zip @ A @ nat @ Xs2 @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P6 ) )
          @ ( zip @ A @ nat @ Xs2 @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7640_nths__shift__lemma,axiom,
    ! [A: $tType,A4: set @ nat,Xs2: list @ A,I2: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A4 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ I2 @ ( plus_plus @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P6 ) @ I2 ) @ A4 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7641_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A4 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A4 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_7642_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq2 @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( ( distinct @ B @ Xs2 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( set2 @ B @ Xs2 ) )
              = Xs2 ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_7643_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B,B6: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B6 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ B6 ) )
           => ( ( finite_finite @ B @ A4 )
             => ( ( finite_finite @ B @ B6 )
               => ( A4 = B6 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_7644_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) )
            = A4 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_7645_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) )
          = ( finite_card @ B @ A4 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_7646_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_7647_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_7648_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( sorted_wrt @ A @ Less_eq2 @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_7649_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( insert @ B @ X @ A4 ) )
            = ( insort_key @ A @ B @ Less_eq2 @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_7650_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ~ ( member @ B @ X @ A4 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( insert @ B @ X @ A4 ) )
              = ( insort_key @ A @ B @ Less_eq2 @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_7651_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_7652_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I2 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I2 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs2 ) ) ) ) ).

% nth_transpose
thf(fact_7653_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs2 ) ) ) ) ).

% sorted_remove1
thf(fact_7654_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_remove1_subset
thf(fact_7655_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7656_length__remove1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_remove1
thf(fact_7657_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
            = ( plus_plus @ A @ ( F2 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7658_length__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs2
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7659_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat,J2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
       => ( ( ord_less @ nat @ J2
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs2 ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I2 ) @ J2 )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J2 ) @ I2 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7660_transpose__column,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I2 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( nth @ ( list @ A ) @ Xs2 @ I2 ) ) ) ) ).

% transpose_column
thf(fact_7661_length__rev,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_rev
thf(fact_7662_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs2 ) @ ( rev @ B @ Ys ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ).

% zip_rev
thf(fact_7663_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) @ Xs2 ) ) ) ).

% rotate_rev
thf(fact_7664_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rev @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_7665_rev__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Y3: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs2 @ K @ Y3 ) )
        = ( list_update @ A @ ( rev @ A @ Xs2 ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ K ) @ ( one_one @ nat ) ) @ Y3 ) ) ) ).

% rev_update
thf(fact_7666_sorted__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) ) ) ).

% sorted_transpose
thf(fact_7667_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I: nat] :
                ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ ( suc @ I ) ) @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7668_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I2: nat,J2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J2 ) @ ( nth @ A @ Xs2 @ I2 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7669_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I: nat,J: nat] :
                ( ( ord_less_eq @ nat @ I @ J )
               => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J ) @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7670_transpose__column__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I2 ) ) ) ) ) ).

% transpose_column_length
thf(fact_7671_length__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ( Xs2
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs2
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7672_transpose__rectangle,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ( ( Xs2
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I3 ) )
              = N ) )
       => ( ( transpose @ A @ Xs2 )
          = ( map @ nat @ ( list @ A )
            @ ^ [I: nat] :
                ( map @ nat @ A
                @ ^ [J: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J ) @ I )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7673_length__concat__rev,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) ) ) ).

% length_concat_rev
thf(fact_7674_length__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( zero_zero @ nat ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_7675_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_7676_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs2 ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_7677_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N @ Xs2 )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_7678_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs3: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_7679_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_7680_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_7681_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_7682_length__greater__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( Xs2
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_7683_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7684_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7685_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_7686_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y3: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y3 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_7687_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_7688_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_7689_take__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( nil @ A ) ) ).

% take_0
thf(fact_7690_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7691_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7692_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A4 )
              = ( nil @ B ) )
            = ( A4
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_7693_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Y3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ( Xs2
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y3 )
                = Y3 ) )
            & ( ( Xs2
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y3 )
                = ( ord_max @ A @ ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) @ Y3 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7694_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X5: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X5 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7695_transpose__max__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs2 )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X5: list @ A] :
              ( X5
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_max_length
thf(fact_7696_transpose__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs2 ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X5: list @ A] :
              ( X5
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_transpose
thf(fact_7697_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) )
         => ( ( filter2 @ B
              @ ^ [X5: B] : ( ord_less @ A @ T2 @ ( F2 @ X5 ) )
              @ Xs2 )
            = ( takeWhile @ B
              @ ^ [X5: B] : ( ord_less @ A @ T2 @ ( F2 @ X5 ) )
              @ Xs2 ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7698_upt__conv__Nil,axiom,
    ! [J2: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ J2 @ I2 )
     => ( ( upt @ I2 @ J2 )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7699_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ( upt @ I2 @ J2 )
        = ( nil @ nat ) )
      = ( ( J2
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J2 @ I2 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7700_upt__0,axiom,
    ! [I2: nat] :
      ( ( upt @ I2 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7701_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs3 ) ) @ Xs3 ) ) ) ).

% takeWhile_eq_take
thf(fact_7702_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_takeWhile_le
thf(fact_7703_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_takeWhile
thf(fact_7704_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ~ ( P @ ( nth @ A @ Xs2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7705_takeWhile__nth,axiom,
    ! [A: $tType,J2: nat,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs2 ) @ J2 )
        = ( nth @ A @ Xs2 @ J2 ) ) ) ).

% takeWhile_nth
thf(fact_7706_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J2: nat,P: A > $o,Xs2: list @ A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ J2 )
         => ( P @ ( nth @ A @ Xs2 @ I3 ) ) )
     => ( ( ord_less_eq @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ord_less_eq @ nat @ J2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7707_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,P: A > $o] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( P @ ( nth @ A @ Xs2 @ I3 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ~ ( P @ ( nth @ A @ Xs2 @ N ) ) )
       => ( ( takeWhile @ A @ P @ Xs2 )
          = ( take @ A @ N @ Xs2 ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_7708_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_7709_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_7710_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ N ) )
      = ( nth @ A @ Xs2 @ N ) ) ).

% nth_Cons_Suc
thf(fact_7711_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_7712_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X @ ( take @ A @ N @ Xs2 ) ) ) ).

% take_Suc_Cons
thf(fact_7713_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( plus_plus @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% sum_list.Cons
thf(fact_7714_intrel__iff,axiom,
    ! [X: nat,Y3: nat,U: nat,V: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y3 ) @ ( product_Pair @ nat @ nat @ U @ V ) )
      = ( ( plus_plus @ nat @ X @ V )
        = ( plus_plus @ nat @ U @ Y3 ) ) ) ).

% intrel_iff
thf(fact_7715_nths__singleton,axiom,
    ! [A: $tType,A4: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A4 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A4 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A4 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_7716_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X: B,Xs2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X @ Xs2 ) )
          = ( plus_plus @ A @ ( F2 @ X ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_7717_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs2: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs2 ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs2 ) ) ) ).

% enumerate_simps(2)
thf(fact_7718_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_7719_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs2: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% take_Cons_numeral
thf(fact_7720_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y3: A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y3 @ Ys ) ) @ ( lex @ A @ R3 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R3 )
          & ( ( size_size @ ( list @ A ) @ Xs2 )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y3 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lex @ A @ R3 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_7721_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_7722_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7723_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C,Ws2: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws2 ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X3: A,Xs: list @ A,Y: B,Ys4: list @ B,Z2: C,Zs2: list @ C,W2: D,Ws: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws ) )
                     => ( ( P @ Xs @ Ys4 @ Zs2 @ Ws )
                       => ( P @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y @ Ys4 ) @ ( cons @ C @ Z2 @ Zs2 ) @ ( cons @ D @ W2 @ Ws ) ) ) ) ) )
             => ( P @ Xs2 @ Ys @ Zs @ Ws2 ) ) ) ) ) ) ).

% list_induct4
thf(fact_7724_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X3: A,Xs: list @ A,Y: B,Ys4: list @ B,Z2: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y @ Ys4 ) @ ( cons @ C @ Z2 @ Zs2 ) ) ) ) )
           => ( P @ Xs2 @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_7725_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs: list @ A,Y: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs @ Ys4 )
               => ( P @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y @ Ys4 ) ) ) )
         => ( P @ Xs2 @ Ys ) ) ) ) ).

% list_induct2
thf(fact_7726_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y3: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y3 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y3 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y3 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7727_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X5 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_7728_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X @ X5 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7729_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y3: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_7730_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_7731_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [X5: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X5 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_7732_impossible__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs2
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_7733_length__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_Cons
thf(fact_7734_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_7735_length__Suc__conv,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_7736_int_Oabs__eq__iff,axiom,
    ! [X: product_prod @ nat @ nat,Y3: product_prod @ nat @ nat] :
      ( ( ( abs_Integ @ X )
        = ( abs_Integ @ Y3 ) )
      = ( intrel @ X @ Y3 ) ) ).

% int.abs_eq_iff
thf(fact_7737_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N @ X ) ) ) ).

% replicate_Suc
thf(fact_7738_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I2: nat,Y3: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ I2 ) @ Y3 )
      = ( cons @ A @ X @ ( list_update @ A @ Xs2 @ I2 @ Y3 ) ) ) ).

% list_update_code(3)
thf(fact_7739_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y3: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) @ Y3 )
      = ( cons @ A @ Y3 @ Xs2 ) ) ).

% list_update_code(2)
thf(fact_7740_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_7741_set__subset__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ ( cons @ A @ X @ Xs2 ) ) ) ).

% set_subset_Cons
thf(fact_7742_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 ) ) ) ).

% uminus_int.rsp
thf(fact_7743_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_7744_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_7745_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y3: A,Xs2: list @ A] :
      ( ( ( X = Y3 )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y3 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs2 @ Y3 ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y3 )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y3 )
          = ( count_list @ A @ Xs2 @ Y3 ) ) ) ) ).

% count_list.simps(2)
thf(fact_7746_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X18: list @ A,X23: list @ A] :
            ( ? [Y5: A,Ys3: list @ A] :
                ( ( X18
                  = ( nil @ A ) )
                & ( X23
                  = ( cons @ A @ Y5 @ Ys3 ) ) )
            | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X18
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( X23
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ( ord_less @ A @ X5 @ Y5 ) )
            | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X18
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( X23
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ~ ( ord_less @ A @ X5 @ Y5 )
                & ~ ( ord_less @ A @ Y5 @ X5 )
                & ( P6 @ Xs3 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7747_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y6: A,Z3: A] : ( Y6 = Z3 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I: nat,J: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ) ).

% of_int.rsp
thf(fact_7748_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_7749_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs2 )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y5: A] : ( cons @ A @ Y5 @ Ys3 )
              @ Xs2 )
          @ ( n_lists @ A @ N @ Xs2 ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7750_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_7751_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7752_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs2
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_7753_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X5 @ V5 )
              = ( plus_plus @ nat @ U2 @ Y5 ) ) ) ) ) ).

% intrel_def
thf(fact_7754_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_7755_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I: nat] : ( F2 @ ( suc @ I ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_7756_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_7757_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y3: A,Xs2: list @ A,N: nat] :
      ( ( X != Y3 )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = Y3 )
        = ( ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_7758_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ) ).

% take_Cons'
thf(fact_7759_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat,Y3: A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( replicate @ A @ N @ Y3 ) )
      = ( ( X = Y3 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs2
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_7760_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R3 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R3 ) )
        | ( ( M = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R3 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_7761_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) ) ) ).

% less_int.rsp
thf(fact_7762_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_7763_int_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ intrel
    @ ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) ) ).

% int.rel_eq_transfer
thf(fact_7764_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_7765_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X5: nat,Y5: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_7766_concat__inth,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X ) ).

% concat_inth
thf(fact_7767_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( take @ A @ ( suc @ I2 ) @ Xs2 )
        = ( append @ A @ ( take @ A @ I2 @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_7768_append__eq__append__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs2 @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs2 = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_7769_length__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_7770_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_7771_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Us: list @ B,Ys: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs2 @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) ).

% zip_append
thf(fact_7772_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_7773_nth__append__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X ) ).

% nth_append_length
thf(fact_7774_nth__append__length__plus,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
      = ( nth @ A @ Ys @ N ) ) ).

% nth_append_length_plus
thf(fact_7775_take__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% take_append
thf(fact_7776_list__update__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A,Y3: A] :
      ( ( list_update @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) @ Y3 )
      = ( append @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys ) ) ) ).

% list_update_length
thf(fact_7777_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_7778_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_7779_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_7780_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7781_upt__Suc,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ( ord_less_eq @ nat @ I2 @ J2 )
       => ( ( upt @ I2 @ ( suc @ J2 ) )
          = ( append @ nat @ ( upt @ I2 @ J2 ) @ ( cons @ nat @ J2 @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I2 @ J2 )
       => ( ( upt @ I2 @ ( suc @ J2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7782_upt__Suc__append,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( upt @ I2 @ ( suc @ J2 ) )
        = ( append @ nat @ ( upt @ I2 @ J2 ) @ ( cons @ nat @ J2 @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7783_same__length__different,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2 != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X3: A,Xs4: list @ A,Y: A,Ys5: list @ A] :
            ( ( X3 != Y )
            & ( Xs2
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_7784_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q3: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q3 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q3 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7785_upt__conv__Cons,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( upt @ I2 @ J2 )
        = ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J2 ) ) ) ) ).

% upt_conv_Cons
thf(fact_7786_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ I2 @ X )
        = ( append @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_7787_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F2: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I: A,X5: D] : ( Q @ I @ ( F2 @ X5 ) ) ) ) ) ).

% mono_compose
thf(fact_7788_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ M @ X ) ) ) ).

% replicate_add
thf(fact_7789_rotate__append,axiom,
    ! [A: $tType,L: list @ A,Q3: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L ) @ ( append @ A @ L @ Q3 ) )
      = ( append @ A @ Q3 @ L ) ) ).

% rotate_append
thf(fact_7790_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_7791_upt__add__eq__append,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J2 )
     => ( ( upt @ I2 @ ( plus_plus @ nat @ J2 @ K ) )
        = ( append @ nat @ ( upt @ I2 @ J2 ) @ ( upt @ J2 @ ( plus_plus @ nat @ J2 @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7792_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs2 @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
               => ! [Y5: A] :
                    ( ( member @ A @ Y5 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% sorted_append
thf(fact_7793_lexord__sufE,axiom,
    ! [A: $tType,Xs2: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R3 ) )
     => ( ( Xs2 != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs2 )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lexord @ A @ R3 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_7794_lex__append__rightI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lex @ A @ R3 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R3 ) ) ) ) ).

% lex_append_rightI
thf(fact_7795_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs2: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs2 ) @ ( lenlex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs2 @ Ys ) ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append1
thf(fact_7796_nths__append,axiom,
    ! [A: $tType,L: list @ A,L4: list @ A,A4: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L4 ) @ A4 )
      = ( append @ A @ ( nths @ A @ L @ A4 )
        @ ( nths @ A @ L4
          @ ( collect @ nat
            @ ^ [J: nat] : ( member @ nat @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ L ) ) @ A4 ) ) ) ) ) ).

% nths_append
thf(fact_7797_length__append__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_append_singleton
thf(fact_7798_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_7799_nth__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Xs2 @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nth_append
thf(fact_7800_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs2 @ N @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ Xs2 @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_7801_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs2 @ Ys )
            = ( append @ A @ Ys @ Xs2 ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs2 @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_7802_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R3: set @ ( product_prod @ A @ A ),V: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R3 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z ) ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_sufI
thf(fact_7803_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J2: nat,X: nat,Xs2: list @ nat] :
      ( ( ( upt @ I2 @ J2 )
        = ( cons @ nat @ X @ Xs2 ) )
      = ( ( ord_less @ nat @ I2 @ J2 )
        & ( I2 = X )
        & ( ( upt @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ J2 )
          = Xs2 ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7804_upt__rec,axiom,
    ( upt
    = ( ^ [I: nat,J: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I @ J ) @ ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7805_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_7806_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I2 ) @ J2 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J2 ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I2 ) @ J2 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_7807_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ J2 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J2 ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I2 ) @ J2 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_7808_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs2: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs2 ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_7809_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A4: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A4 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A4 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J: nat] : ( member @ nat @ ( suc @ J ) @ A4 ) ) ) ) ) ).

% nths_Cons
thf(fact_7810_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X5: A,Y5: A,Xs5: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X5 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_7811_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N: nat,X: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) @ M )
            = ( nth @ A @ Xs2 @ M ) ) ) ) ) ).

% nth_repl
thf(fact_7812_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Y3: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs2 ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_7813_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X5: list @ A] : X5 ) ) ).

% drop0
thf(fact_7814_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M ) @ Xs2 ) ) ).

% drop_drop
thf(fact_7815_drop__upt,axiom,
    ! [M: nat,I2: nat,J2: nat] :
      ( ( drop @ nat @ M @ ( upt @ I2 @ J2 ) )
      = ( upt @ ( plus_plus @ nat @ I2 @ M ) @ J2 ) ) ).

% drop_upt
thf(fact_7816_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs2 ) )
      = ( drop @ A @ N @ Xs2 ) ) ).

% drop_Suc_Cons
thf(fact_7817_length__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% length_drop
thf(fact_7818_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs2 @ N @ X ) )
        = ( drop @ A @ M @ Xs2 ) ) ) ).

% drop_update_cancel
thf(fact_7819_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs2 ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_7820_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( drop @ A @ N @ Xs2 )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% drop_eq_Nil
thf(fact_7821_drop__all,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N )
     => ( ( drop @ A @ N @ Xs2 )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_7822_drop__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( drop @ A @ N @ Xs2 ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_7823_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs2: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ).

% drop_Cons_numeral
thf(fact_7824_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,I2: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs2 ) @ I2 )
        = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ N @ I2 ) ) ) ) ).

% nth_drop
thf(fact_7825_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_drop_subset
thf(fact_7826_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs2 ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_7827_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = Zs )
      = ( ( Xs2
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ Zs ) )
        & ( Ys
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_7828_take__add,axiom,
    ! [A: $tType,I2: nat,J2: nat,Xs2: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I2 @ J2 ) @ Xs2 )
      = ( append @ A @ ( take @ A @ I2 @ Xs2 ) @ ( take @ A @ J2 @ ( drop @ A @ I2 @ Xs2 ) ) ) ) ).

% take_add
thf(fact_7829_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs2 @ N @ X ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs2 ) @ ( minus_minus @ nat @ N @ M ) @ X ) ) ) ).

% drop_update_swap
thf(fact_7830_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N2: nat,Xs3: list @ A] : ( nths @ A @ Xs3 @ ( collect @ nat @ ( ord_less_eq @ nat @ N2 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_7831_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs2 ) ) ) ) ).

% sorted_drop
thf(fact_7832_drop__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs2 )
      = Xs2 ) ).

% drop_0
thf(fact_7833_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N @ M ) @ Xs2 ) ) ) ).

% take_drop
thf(fact_7834_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,I5: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N @ Xs2 ) @ I5 )
      = ( nths @ A @ Xs2 @ ( image @ nat @ nat @ ( plus_plus @ nat @ N ) @ I5 ) ) ) ).

% nths_drop
thf(fact_7835_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ Xs2 ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ).

% drop_Cons'
thf(fact_7836_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_7837_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs2 @ ( append @ B @ Ys @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs2 ) @ Ys ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs2 ) @ Zs ) ) ) ).

% zip_append2
thf(fact_7838_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs2 @ Ys ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs2 ) @ Zs ) ) @ ( zip @ A @ B @ Ys @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs2 ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_7839_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ) ).

% drop_rev
thf(fact_7840_rev__drop,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I2 @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I2 ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_drop
thf(fact_7841_rev__take,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( take @ A @ I2 @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I2 ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_take
thf(fact_7842_take__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ) ).

% take_rev
thf(fact_7843_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( cons @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs2 ) )
        = ( drop @ A @ I2 @ Xs2 ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_7844_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N2: nat,Xs3: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) @ ( take @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ) ).

% rotate_drop_take
thf(fact_7845_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I2: nat,J2: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I2 @ J2 )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I2 @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J2 @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_7846_id__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( Xs2
        = ( append @ A @ ( take @ A @ I2 @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs2 ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_7847_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,A2: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ Xs2 @ I2 @ A2 )
        = ( append @ A @ ( take @ A @ I2 @ Xs2 ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I2 ) @ Xs2 ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_7848_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N2: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N2 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N2 )
                  & ? [Xys: list @ A,X5: A,Y5: A,Xs5: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X5 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_7849_list__encode_Oelims,axiom,
    ! [X: list @ nat,Y3: nat] :
      ( ( ( nat_list_encode @ X )
        = Y3 )
     => ( ( ( X
            = ( nil @ nat ) )
         => ( Y3
           != ( zero_zero @ nat ) ) )
       => ~ ! [X3: nat,Xs: list @ nat] :
              ( ( X
                = ( cons @ nat @ X3 @ Xs ) )
             => ( Y3
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_7850_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R3 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_7851_list__encode_Osimps_I1_J,axiom,
    ( ( nat_list_encode @ ( nil @ nat ) )
    = ( zero_zero @ nat ) ) ).

% list_encode.simps(1)
thf(fact_7852_lexn__length,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lexn @ A @ R3 @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N ) ) ) ).

% lexn_length
thf(fact_7853_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs2: list @ nat] :
      ( ( nat_list_encode @ ( cons @ nat @ X @ Xs2 ) )
      = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X @ ( nat_list_encode @ Xs2 ) ) ) ) ) ).

% list_encode.simps(2)
thf(fact_7854_list__encode_Opelims,axiom,
    ! [X: list @ nat,Y3: nat] :
      ( ( ( nat_list_encode @ X )
        = Y3 )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X )
       => ( ( ( X
              = ( nil @ nat ) )
           => ( ( Y3
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X3: nat,Xs: list @ nat] :
                ( ( X
                  = ( cons @ nat @ X3 @ Xs ) )
               => ( ( Y3
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X3 @ Xs ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_7855_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I: int,J: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J @ I ) @ Js @ ( upto_aux @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) @ ( cons @ int @ J @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_7856_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y3: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y3 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y3
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y3
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_7857_upto_Opsimps,axiom,
    ! [I2: int,J2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J2 ) )
     => ( ( ( ord_less_eq @ int @ I2 @ J2 )
         => ( ( upto @ I2 @ J2 )
            = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I2 @ J2 )
         => ( ( upto @ I2 @ J2 )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_7858_upto__Nil,axiom,
    ! [I2: int,J2: int] :
      ( ( ( upto @ I2 @ J2 )
        = ( nil @ int ) )
      = ( ord_less @ int @ J2 @ I2 ) ) ).

% upto_Nil
thf(fact_7859_upto__Nil2,axiom,
    ! [I2: int,J2: int] :
      ( ( ( nil @ int )
        = ( upto @ I2 @ J2 ) )
      = ( ord_less @ int @ J2 @ I2 ) ) ).

% upto_Nil2
thf(fact_7860_upto__empty,axiom,
    ! [J2: int,I2: int] :
      ( ( ord_less @ int @ J2 @ I2 )
     => ( ( upto @ I2 @ J2 )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_7861_nth__upto,axiom,
    ! [I2: int,K: nat,J2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) @ J2 )
     => ( ( nth @ int @ ( upto @ I2 @ J2 ) @ K )
        = ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_7862_length__upto,axiom,
    ! [I2: int,J2: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I2 @ J2 ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J2 @ I2 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_7863_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_7864_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_7865_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_7866_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_7867_sorted__wrt__upto,axiom,
    ! [I2: int,J2: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I2 @ J2 ) ) ).

% sorted_wrt_upto
thf(fact_7868_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_7869_upto__split2,axiom,
    ! [I2: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ J2 ) @ ( upto @ ( plus_plus @ int @ J2 @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_7870_upto__split1,axiom,
    ! [I2: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( upto @ J2 @ K ) ) ) ) ) ).

% upto_split1
thf(fact_7871_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I: int,J: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_7872_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y3: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y3 )
     => ( ( ( ord_less_eq @ int @ X @ Xa )
         => ( Y3
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa )
         => ( Y3
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_7873_upto_Osimps,axiom,
    ( upto
    = ( ^ [I: int,J: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I @ J ) @ ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_7874_upto__rec1,axiom,
    ! [I2: int,J2: int] :
      ( ( ord_less_eq @ int @ I2 @ J2 )
     => ( ( upto @ I2 @ J2 )
        = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) ) ) ) ).

% upto_rec1
thf(fact_7875_upto__rec2,axiom,
    ! [I2: int,J2: int] :
      ( ( ord_less_eq @ int @ I2 @ J2 )
     => ( ( upto @ I2 @ J2 )
        = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( cons @ int @ J2 @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_7876_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I: int,J: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_7877_upto__split3,axiom,
    ! [I2: int,J2: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J2 )
     => ( ( ord_less_eq @ int @ J2 @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) @ ( cons @ int @ J2 @ ( upto @ ( plus_plus @ int @ J2 @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_7878_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs2 ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs2 ) ) ) ).

% take_hd_drop
thf(fact_7879_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ A2
                @ Xs2 )
              = ( append @ A @ Xs2 @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7880_hd__upt,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( hd @ nat @ ( upt @ I2 @ J2 ) )
        = I2 ) ) ).

% hd_upt
thf(fact_7881_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% length_insort
thf(fact_7882_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_7883_hd__take,axiom,
    ! [A: $tType,J2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J2 )
     => ( ( hd @ A @ ( take @ A @ J2 @ Xs2 ) )
        = ( hd @ A @ Xs2 ) ) ) ).

% hd_take
thf(fact_7884_hd__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_7885_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X
              @ Xs2 ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted_insort
thf(fact_7886_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ).

% sorted_insort_key
thf(fact_7887_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y3: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y3 @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y3 @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y3 @ Ys ) )
              = ( cons @ B @ Y3 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_7888_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ B,F2: B > A,A2: B] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs2 ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs2 )
            = ( cons @ B @ A2 @ Xs2 ) ) ) ) ).

% insort_is_Cons
thf(fact_7889_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X5: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X5 ) )
                    @ Xs2 ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs2 ) )
                = Xs2 ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7890_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs2 ) )
        = ( nth @ A @ Xs2 @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_7891_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ) ).

% filter_insort
thf(fact_7892_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs2: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ A2
                @ ( remove1 @ A @ A2 @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% insort_remove1
thf(fact_7893_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N @ Xs2 ) )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_7894_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs2
         != ( nil @ A ) )
        & ( Xs2
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( hd @ A @ Xs2 ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7895_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7896_vanishes__mult__bounded,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ? [A17: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A17 )
          & ! [N3: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N3 ) ) @ A17 ) )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_7897_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_7898_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N2: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_7899_length__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7900_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ).

% sorted_tl
thf(fact_7901_take__tl,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs2 ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs2 ) ) ) ).

% take_tl
thf(fact_7902_vanishes__add,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N2: nat] : ( plus_plus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% vanishes_add
thf(fact_7903_vanishes__minus,axiom,
    ! [X8: nat > rat] :
      ( ( vanishes @ X8 )
     => ( vanishes
        @ ^ [N2: nat] : ( uminus_uminus @ rat @ ( X8 @ N2 ) ) ) ) ).

% vanishes_minus
thf(fact_7904_vanishes__diff,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% vanishes_diff
thf(fact_7905_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs2 )
      = ( drop @ A @ N @ ( tl @ A @ Xs2 ) ) ) ).

% drop_Suc
thf(fact_7906_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7907_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_7908_take__Suc,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs2 )
        = ( cons @ A @ ( hd @ A @ Xs2 ) @ ( take @ A @ N @ ( tl @ A @ Xs2 ) ) ) ) ) ).

% take_Suc
thf(fact_7909_vanishesD,axiom,
    ! [X8: nat > rat,R3: rat] :
      ( ( vanishes @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R3 )
       => ? [K2: nat] :
          ! [N7: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N7 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N7 ) ) @ R3 ) ) ) ) ).

% vanishesD
thf(fact_7910_vanishesI,axiom,
    ! [X8: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N3 ) ) @ R2 ) ) )
     => ( vanishes @ X8 ) ) ).

% vanishesI
thf(fact_7911_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X9: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N2 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X9 @ N2 ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_7912_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X9: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X9 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X9 @ N2 ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_7913_rcis__inverse,axiom,
    ! [R3: real,A2: real] :
      ( ( inverse_inverse @ complex @ ( rcis @ R3 @ A2 ) )
      = ( rcis @ ( divide_divide @ real @ ( one_one @ real ) @ R3 ) @ ( uminus_uminus @ real @ A2 ) ) ) ).

% rcis_inverse
thf(fact_7914_rcis__zero__arg,axiom,
    ! [R3: real] :
      ( ( rcis @ R3 @ ( zero_zero @ real ) )
      = ( real_Vector_of_real @ complex @ R3 ) ) ).

% rcis_zero_arg
thf(fact_7915_rcis__eq__zero__iff,axiom,
    ! [R3: real,A2: real] :
      ( ( ( rcis @ R3 @ A2 )
        = ( zero_zero @ complex ) )
      = ( R3
        = ( zero_zero @ real ) ) ) ).

% rcis_eq_zero_iff
thf(fact_7916_rcis__zero__mod,axiom,
    ! [A2: real] :
      ( ( rcis @ ( zero_zero @ real ) @ A2 )
      = ( zero_zero @ complex ) ) ).

% rcis_zero_mod
thf(fact_7917_Re__rcis,axiom,
    ! [R3: real,A2: real] :
      ( ( re @ ( rcis @ R3 @ A2 ) )
      = ( times_times @ real @ R3 @ ( cos @ real @ A2 ) ) ) ).

% Re_rcis
thf(fact_7918_Im__rcis,axiom,
    ! [R3: real,A2: real] :
      ( ( im @ ( rcis @ R3 @ A2 ) )
      = ( times_times @ real @ R3 @ ( sin @ real @ A2 ) ) ) ).

% Im_rcis
thf(fact_7919_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N2: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_7920_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N2: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_7921_uminus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X9: nat > rat,N2: nat] : ( uminus_uminus @ rat @ ( X9 @ N2 ) )
    @ ( uminus_uminus @ real ) ) ).

% uminus_real.transfer
thf(fact_7922_plus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( plus_plus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) )
    @ ( plus_plus @ real ) ) ).

% plus_real.transfer
thf(fact_7923_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_7924_rcis__mult,axiom,
    ! [R12: real,A2: real,R23: real,B2: real] :
      ( ( times_times @ complex @ ( rcis @ R12 @ A2 ) @ ( rcis @ R23 @ B2 ) )
      = ( rcis @ ( times_times @ real @ R12 @ R23 ) @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% rcis_mult
thf(fact_7925_rcis__divide,axiom,
    ! [R12: real,A2: real,R23: real,B2: real] :
      ( ( divide_divide @ complex @ ( rcis @ R12 @ A2 ) @ ( rcis @ R23 @ B2 ) )
      = ( rcis @ ( divide_divide @ real @ R12 @ R23 ) @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% rcis_divide
thf(fact_7926_rcis__def,axiom,
    ( rcis
    = ( ^ [R5: real,A5: real] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ R5 ) @ ( cis @ A5 ) ) ) ) ).

% rcis_def
thf(fact_7927_DeMoivre2,axiom,
    ! [R3: real,A2: real,N: nat] :
      ( ( power_power @ complex @ ( rcis @ R3 @ A2 ) @ N )
      = ( rcis @ ( power_power @ real @ R3 @ N ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_7928_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
    @ ^ [X9: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X9 @ N2 ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_7929_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A5: list @ A,B4: list @ B] :
          ? [Z5: list @ ( product_prod @ A @ B )] :
            ( ( member @ ( list @ ( product_prod @ A @ B ) ) @ Z5
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X5: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X5 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R6 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z5 )
              = A5 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z5 )
              = B4 ) ) ) ) ).

% list.in_rel
thf(fact_7930_length__transfer,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ nat @ nat @ ( list_all2 @ A @ B @ A4 )
      @ ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 )
      @ ( size_size @ ( list @ A ) )
      @ ( size_size @ ( list @ B ) ) ) ).

% length_transfer
thf(fact_7931_list__all2__lengthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs2: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% list_all2_lengthD
thf(fact_7932_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs2: list @ A,Ys: list @ B,P4: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys )
     => ( ( ord_less @ nat @ P4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( P @ ( nth @ A @ Xs2 @ P4 ) @ ( nth @ B @ Ys @ P4 ) ) ) ) ).

% list_all2_nthD
thf(fact_7933_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs2: list @ A,Ys: list @ B,P4: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys )
     => ( ( ord_less @ nat @ P4 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( P @ ( nth @ A @ Xs2 @ P4 ) @ ( nth @ B @ Ys @ P4 ) ) ) ) ).

% list_all2_nthD2
thf(fact_7934_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ( ( size_size @ ( list @ A ) @ A2 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ A2 ) )
           => ( P @ ( nth @ A @ A2 @ N3 ) @ ( nth @ B @ B2 @ N3 ) ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2_all_nthI
thf(fact_7935_list__all2__conv__all__nth,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( P3 @ ( nth @ A @ Xs3 @ I ) @ ( nth @ B @ Ys3 @ I ) ) ) ) ) ) ).

% list_all2_conv_all_nth
thf(fact_7936_list__all2__append2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs2: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs2 @ ( append @ B @ Ys @ Zs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Xs2
              = ( append @ A @ Us2 @ Vs2 ) )
            & ( ( size_size @ ( list @ A ) @ Us2 )
              = ( size_size @ ( list @ B ) @ Ys ) )
            & ( ( size_size @ ( list @ A ) @ Vs2 )
              = ( size_size @ ( list @ B ) @ Zs ) )
            & ( list_all2 @ A @ B @ P @ Us2 @ Ys )
            & ( list_all2 @ A @ B @ P @ Vs2 @ Zs ) ) ) ) ).

% list_all2_append2
thf(fact_7937_list__all2__append1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs2: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs2 @ Ys ) @ Zs )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Zs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( ( size_size @ ( list @ B ) @ Us2 )
              = ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( size_size @ ( list @ B ) @ Vs2 )
              = ( size_size @ ( list @ A ) @ Ys ) )
            & ( list_all2 @ A @ B @ P @ Xs2 @ Us2 )
            & ( list_all2 @ A @ B @ P @ Ys @ Vs2 ) ) ) ) ).

% list_all2_append1
thf(fact_7938_list__all2__append,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,P: A > B > $o,Us: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs2 @ Us ) @ ( append @ B @ Ys @ Vs ) )
        = ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys )
          & ( list_all2 @ A @ B @ P @ Us @ Vs ) ) ) ) ).

% list_all2_append
thf(fact_7939_Real_Opositive__mult,axiom,
    ! [X: real,Y3: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y3 )
       => ( positive2 @ ( times_times @ real @ X @ Y3 ) ) ) ) ).

% Real.positive_mult
thf(fact_7940_Real_Opositive__add,axiom,
    ! [X: real,Y3: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y3 )
       => ( positive2 @ ( plus_plus @ real @ X @ Y3 ) ) ) ) ).

% Real.positive_add
thf(fact_7941_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_7942_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ ( positive2 @ X )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X ) ) ) ) ).

% Real.positive_minus
thf(fact_7943_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R @ Ra )
     => ( ord_less_eq @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( list_all2 @ A @ B @ R ) @ ( list_all2 @ A @ B @ Ra ) ) ) ).

% list.rel_mono
thf(fact_7944_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X5: real,Y5: real] : ( positive2 @ ( minus_minus @ real @ Y5 @ X5 ) ) ) ) ).

% less_real_def
thf(fact_7945_list__all2I,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ! [X3: product_prod @ A @ B] :
          ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ A2 @ B2 ) ) )
         => ( product_case_prod @ A @ B @ $o @ P @ X3 ) )
     => ( ( ( size_size @ ( list @ A ) @ A2 )
          = ( size_size @ ( list @ B ) @ B2 ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2I
thf(fact_7946_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A4: A > B > $o] :
          ( ( A4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A4 ) @ A4 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_7947_list__all2__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [X5: product_prod @ A @ B] :
                ( ( member @ ( product_prod @ A @ B ) @ X5 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ B @ $o @ P3 @ X5 ) ) ) ) ) ).

% list_all2_iff
thf(fact_7948_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A4: A > B > $o,B6: C > D > $o] :
          ( ( A4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B6 @ A4 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A4 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B6 ) @ A4 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_7949_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X5: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N2 )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X5 @ N2 ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_7950_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
    @ ^ [X9: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X9 @ N2 ) ) ) )
    @ ^ [X9: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X9 @ N2 ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_7951_plus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( plus_plus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( plus_plus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ).

% plus_real.rsp
thf(fact_7952_uminus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X9: nat > rat,N2: nat] : ( uminus_uminus @ rat @ ( X9 @ N2 ) )
    @ ^ [X9: nat > rat,N2: nat] : ( uminus_uminus @ rat @ ( X9 @ N2 ) ) ) ).

% uminus_real.rsp
thf(fact_7953_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) )
    @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ).

% times_real.rsp
thf(fact_7954_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N2: nat] : ( one_one @ rat )
    @ ^ [N2: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_7955_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N2: nat] : ( zero_zero @ rat )
    @ ^ [N2: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_7956_real_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > $o ) @ ( real > $o ) @ pcr_real
    @ ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
      @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
    @ realrel
    @ ^ [Y6: real,Z3: real] : ( Y6 = Z3 ) ) ).

% real.rel_eq_transfer
thf(fact_7957_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X9: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X9 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X9 @ N2 ) ) )
    @ ^ [X9: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X9 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X9 @ N2 ) ) ) ) ).

% inverse_real.rsp
thf(fact_7958_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X9: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N2 )
             => ( ord_less @ rat @ R5 @ ( X9 @ N2 ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_7959_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A4: A > B > $o] :
          ( ( A4 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A4 ) @ A4 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_7960_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( times_times @ A @ X @ ( groups5270119922927024881d_list @ A @ Xs2 ) ) ) ) ).

% prod_list.Cons
thf(fact_7961_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs2 ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_7962_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( semiring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [Xs2: list @ A] :
          ( ( ( groups5270119922927024881d_list @ A @ Xs2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( zero_zero @ A ) @ ( set2 @ A @ Xs2 ) ) ) ) ).

% prod_list_zero_iff
thf(fact_7963_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs3 @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_7964_inverse__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( inverse_inverse @ real @ ( real2 @ X ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X )
            @ ^ [N2: nat] : ( zero_zero @ rat )
            @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X @ N2 ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_7965_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A4: A > B > $o,B6: C > D > $o] :
          ( ( bi_total @ A @ B @ A4 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A4
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A4
                @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B6
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B6
                  @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A4 @ B6 )
                @ ^ [Y6: $o,Z3: $o] : ( Y6 = Z3 )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_7966_int_Obi__total,axiom,
    bi_total @ ( product_prod @ nat @ nat ) @ int @ pcr_int ).

% int.bi_total
thf(fact_7967_of__rat__Real,axiom,
    ( ( field_char_0_of_rat @ real )
    = ( ^ [X5: rat] :
          ( real2
          @ ^ [N2: nat] : X5 ) ) ) ).

% of_rat_Real
thf(fact_7968_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N2: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_7969_of__nat__Real,axiom,
    ( ( semiring_1_of_nat @ real )
    = ( ^ [X5: nat] :
          ( real2
          @ ^ [N2: nat] : ( semiring_1_of_nat @ rat @ X5 ) ) ) ) ).

% of_nat_Real
thf(fact_7970_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N2: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_7971_of__int__Real,axiom,
    ( ( ring_1_of_int @ real )
    = ( ^ [X5: int] :
          ( real2
          @ ^ [N2: nat] : ( ring_1_of_int @ rat @ X5 ) ) ) ) ).

% of_int_Real
thf(fact_7972_real_Oabs__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [Y: nat > rat] :
          ( ( realrel @ Y @ Y )
         => ( P @ ( real2 @ Y ) ) )
     => ( P @ X ) ) ).

% real.abs_induct
thf(fact_7973_uminus__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( uminus_uminus @ real @ ( real2 @ X ) )
        = ( real2
          @ ^ [N2: nat] : ( uminus_uminus @ rat @ ( X @ N2 ) ) ) ) ) ).

% uminus_real.abs_eq
thf(fact_7974_plus__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( plus_plus @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N2: nat] : ( plus_plus @ rat @ ( Xa @ N2 ) @ ( X @ N2 ) ) ) ) ) ) ).

% plus_real.abs_eq
thf(fact_7975_times__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( times_times @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N2: nat] : ( times_times @ rat @ ( Xa @ N2 ) @ ( X @ N2 ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_7976_Real_Opositive_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( positive2 @ ( real2 @ X ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N2 )
                 => ( ord_less @ rat @ R5 @ ( X @ N2 ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_7977_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X9: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X9 )
          @ ^ [N2: nat] : ( zero_zero @ rat )
          @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X9 @ N2 ) ) ) ) ) ).

% inverse_real_def
thf(fact_7978_le__Real,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( ord_less_eq @ real @ ( real2 @ X8 ) @ ( real2 @ Y7 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N2 )
                   => ( ord_less_eq @ rat @ ( X8 @ N2 ) @ ( plus_plus @ rat @ ( Y7 @ N2 ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_7979_Real__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [X10: nat > rat] :
          ( ( cauchy @ X10 )
         => ( P @ ( real2 @ X10 ) ) )
     => ( P @ X ) ) ).

% Real_induct
thf(fact_7980_cr__real__eq,axiom,
    ( pcr_real
    = ( ^ [X5: nat > rat,Y5: real] :
          ( ( cauchy @ X5 )
          & ( ( real2 @ X5 )
            = Y5 ) ) ) ) ).

% cr_real_eq
thf(fact_7981_realrel__refl,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( realrel @ X8 @ X8 ) ) ).

% realrel_refl
thf(fact_7982_cauchy__mult,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% cauchy_mult
thf(fact_7983_cauchy__diff,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% cauchy_diff
thf(fact_7984_cauchy__const,axiom,
    ! [X: rat] :
      ( cauchy
      @ ^ [N2: nat] : X ) ).

% cauchy_const
thf(fact_7985_cauchy__minus,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( cauchy
        @ ^ [N2: nat] : ( uminus_uminus @ rat @ ( X8 @ N2 ) ) ) ) ).

% cauchy_minus
thf(fact_7986_cauchy__add,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N2: nat] : ( plus_plus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ).

% cauchy_add
thf(fact_7987_cauchy__inverse,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( cauchy
          @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) ) ) ) ).

% cauchy_inverse
thf(fact_7988_cauchy__imp__bounded,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ? [B3: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B3 )
          & ! [N7: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N7 ) ) @ B3 ) ) ) ).

% cauchy_imp_bounded
thf(fact_7989_less__RealD,axiom,
    ! [Y7: nat > rat,X: real] :
      ( ( cauchy @ Y7 )
     => ( ( ord_less @ real @ X @ ( real2 @ Y7 ) )
       => ? [N3: nat] : ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ ( Y7 @ N3 ) ) ) ) ) ).

% less_RealD
thf(fact_7990_le__RealI,axiom,
    ! [Y7: nat > rat,X: real] :
      ( ( cauchy @ Y7 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ X @ ( field_char_0_of_rat @ real @ ( Y7 @ N3 ) ) )
       => ( ord_less_eq @ real @ X @ ( real2 @ Y7 ) ) ) ) ).

% le_RealI
thf(fact_7991_Real__leI,axiom,
    ! [X8: nat > rat,Y3: real] :
      ( ( cauchy @ X8 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X8 @ N3 ) ) @ Y3 )
       => ( ord_less_eq @ real @ ( real2 @ X8 ) @ Y3 ) ) ) ).

% Real_leI
thf(fact_7992_minus__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( uminus_uminus @ real @ ( real2 @ X8 ) )
        = ( real2
          @ ^ [N2: nat] : ( uminus_uminus @ rat @ ( X8 @ N2 ) ) ) ) ) ).

% minus_Real
thf(fact_7993_add__Real,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( plus_plus @ real @ ( real2 @ X8 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N2: nat] : ( plus_plus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ) ).

% add_Real
thf(fact_7994_mult__Real,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( times_times @ real @ ( real2 @ X8 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ) ).

% mult_Real
thf(fact_7995_diff__Real,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( minus_minus @ real @ ( real2 @ X8 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ) ).

% diff_Real
thf(fact_7996_realrelI,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) )
         => ( realrel @ X8 @ Y7 ) ) ) ) ).

% realrelI
thf(fact_7997_eq__Real,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y7 )
       => ( ( ( real2 @ X8 )
            = ( real2 @ Y7 ) )
          = ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) ) ) ) ) ).

% eq_Real
thf(fact_7998_vanishes__diff__inverse,axiom,
    ! [X8: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( ( cauchy @ Y7 )
         => ( ~ ( vanishes @ Y7 )
           => ( ( vanishes
                @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y7 @ N2 ) ) )
             => ( vanishes
                @ ^ [N2: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X8 @ N2 ) ) @ ( inverse_inverse @ rat @ ( Y7 @ N2 ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_7999_realrel__def,axiom,
    ( realrel
    = ( ^ [X9: nat > rat,Y8: nat > rat] :
          ( ( cauchy @ X9 )
          & ( cauchy @ Y8 )
          & ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% realrel_def
thf(fact_8000_cauchy__not__vanishes__cases,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B3 )
            & ? [K2: nat] :
                ( ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B3 @ ( uminus_uminus @ rat @ ( X8 @ N7 ) ) ) )
                | ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B3 @ ( X8 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_8001_positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( positive2 @ ( real2 @ X8 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N2 )
                 => ( ord_less @ rat @ R5 @ ( X8 @ N2 ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_8002_uminus__real__def,axiom,
    ( ( uminus_uminus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X9: nat > rat,N2: nat] : ( uminus_uminus @ rat @ ( X9 @ N2 ) ) ) ) ).

% uminus_real_def
thf(fact_8003_cauchy__not__vanishes,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B3 )
            & ? [K2: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ B3 @ ( abs_abs @ rat @ ( X8 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_8004_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X9: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [M2: nat] :
              ( ( ord_less_eq @ nat @ K3 @ M2 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N2 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X9 @ M2 ) @ ( X9 @ N2 ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_8005_cauchyI,axiom,
    ! [X8: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M3 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) @ R2 ) ) ) )
     => ( cauchy @ X8 ) ) ).

% cauchyI
thf(fact_8006_cauchyD,axiom,
    ! [X8: nat > rat,R3: rat] :
      ( ( cauchy @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R3 )
       => ? [K2: nat] :
          ! [M6: nat] :
            ( ( ord_less_eq @ nat @ K2 @ M6 )
           => ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M6 ) @ ( X8 @ N7 ) ) ) @ R3 ) ) ) ) ) ).

% cauchyD
thf(fact_8007_inverse__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( real2
              @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_8008_not__positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ~ ( positive2 @ ( real2 @ X8 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K3: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N2 )
                 => ( ord_less_eq @ rat @ ( X8 @ N2 ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_8009_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ).

% times_real_def
thf(fact_8010_plus__real__def,axiom,
    ( ( plus_plus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X9: nat > rat,Y8: nat > rat,N2: nat] : ( plus_plus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ).

% plus_real_def
thf(fact_8011_cr__real__def,axiom,
    ( cr_real
    = ( ^ [X5: nat > rat,Y5: real] :
          ( ( realrel @ X5 @ X5 )
          & ( ( real2 @ X5 )
            = Y5 ) ) ) ) ).

% cr_real_def
thf(fact_8012_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P6: A,M2: nat] :
            ( if @ A
            @ ( M2
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P6 @ ( power2 @ A @ One @ Times @ P6 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_8013_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N ) ) ) ).

% power.power.power_Suc
thf(fact_8014_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_8015_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_8016_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
thf(fact_8017_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( butlast @ A @ ( take @ A @ N @ Xs2 ) )
        = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% butlast_take
thf(fact_8018_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) @ N )
              = ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_8019_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M: nat,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) )
            = ( ord_less @ nat @ M @ N ) ) ) ) ).

% enumerate_mono_iff
thf(fact_8020_length__butlast,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_8021_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M: nat,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ M @ ( finite_card @ A @ S2 ) )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
             => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) )
                = ( ord_less @ nat @ M @ N ) ) ) ) ) ) ).

% finite_enumerate_mono_iff
thf(fact_8022_le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ~ ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ).

% le_enumerate
thf(fact_8023_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ).

% enumerate_step
thf(fact_8024_enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ~ ( finite_finite @ A @ S2 )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% enumerate_mono
thf(fact_8025_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs2 ) ) ) ) ) ).

% sorted_butlast
thf(fact_8026_nth__butlast,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ N ) ) ) ).

% nth_butlast
thf(fact_8027_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
           => ( member @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S2 ) ) ) ) ).

% finite_enumerate_in_set
thf(fact_8028_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( member @ A @ S @ S2 )
           => ? [N3: nat] :
                ( ( ord_less @ nat @ N3 @ ( finite_card @ A @ S2 ) )
                & ( ( infini527867602293511546merate @ A @ S2 @ N3 )
                  = S ) ) ) ) ) ).

% finite_enumerate_Ex
thf(fact_8029_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y7: set @ A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I3 )
                = ( infini527867602293511546merate @ A @ Y7 @ I3 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y7 )
             => ( ( ( finite_card @ A @ X8 )
                  = ( finite_card @ A @ Y7 ) )
               => ( X8 = Y7 ) ) ) ) ) ) ).

% finite_enum_ext
thf(fact_8030_take__butlast,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( take @ A @ N @ ( butlast @ A @ Xs2 ) )
        = ( take @ A @ N @ Xs2 ) ) ) ).

% take_butlast
thf(fact_8031_butlast__power,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( butlast @ A ) @ Xs2 )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ).

% butlast_power
thf(fact_8032_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( finite_finite @ A @ S2 )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
             => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ) ).

% finite_enumerate_mono
thf(fact_8033_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs3: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( one_one @ nat ) ) @ Xs3 ) ) ) ).

% butlast_conv_take
thf(fact_8034_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,X: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
          = ( butlast @ A @ Xs2 ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
          = ( list_update @ A @ ( butlast @ A @ Xs2 ) @ K @ X ) ) ) ) ).

% butlast_list_update
thf(fact_8035_finite__le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ( ord_less @ nat @ N @ ( finite_card @ nat @ S2 ) )
       => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ) ).

% finite_le_enumerate
thf(fact_8036_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_8037_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_8038_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y7: set @ A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I3 )
                = ( infini527867602293511546merate @ A @ Y7 @ I3 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y7 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X8 ) @ ( finite_card @ A @ Y7 ) )
               => ( ord_less_eq @ ( set @ A ) @ X8 @ Y7 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_8039_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
              = ( ord_Least @ A
                @ ^ [S7: A] :
                    ( ( member @ A @ S7 @ S2 )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S7 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_8040_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A
            @ ( minus_minus @ ( set @ A ) @ S2
              @ ( insert @ A
                @ ( ord_Least @ A
                  @ ^ [N2: A] : ( member @ A @ N2 @ S2 ) )
                @ ( bot_bot @ ( set @ A ) ) ) )
            @ N ) ) ) ).

% enumerate_Suc
thf(fact_8041_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_8042_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N2: A] : ( member @ A @ N2 @ S2 ) ) ) ) ).

% enumerate_0
thf(fact_8043_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A3: A] :
                ( ( P @ A3 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A3 @ B11 ) )
                 => ( Q @ A3 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_8044_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A3: A] :
                ( ( P @ A3 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A3 @ B11 ) )
                 => ( Q @ A3 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_8045_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y: A] :
                ( ( P @ Y )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_8046_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y: A] :
                ( ( P @ Y )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ X3 @ Y4 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_8047_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z: A] :
          ( ? [X6: A] :
              ( ( P @ X6 )
              & ! [Y: A] :
                  ( ( P @ Y )
                 => ( ord_less_eq @ A @ X6 @ Y ) )
              & ! [Y: A] :
                  ( ( ( P @ Y )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y @ Ya2 ) ) )
                 => ( Y = X6 ) ) )
         => ( ( P @ Z )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z ) ) ) ) ).

% Least1_le
thf(fact_8048_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X6: A] :
              ( ( P @ X6 )
              & ! [Y: A] :
                  ( ( P @ Y )
                 => ( ord_less_eq @ A @ X6 @ Y ) )
              & ! [Y: A] :
                  ( ( ( P @ Y )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y @ Ya2 ) ) )
                 => ( Y = X6 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_8049_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_8050_Least__Suc2,axiom,
    ! [P: nat > $o,N: nat,Q: nat > $o,M: nat] :
      ( ( P @ N )
     => ( ( Q @ M )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K2: nat] :
                ( ( P @ ( suc @ K2 ) )
                = ( Q @ K2 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_8051_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_8052_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_8053_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_8054_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_8055_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_8056_Least__Suc,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M2: nat] : ( P @ ( suc @ M2 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_8057_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite @ A @ ( collect @ A @ P ) )
         => ( ? [X_12: A] : ( P @ X_12 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_8058_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X9: set @ real] :
          ( ord_Least @ real
          @ ^ [Z5: real] :
            ! [X5: real] :
              ( ( member @ real @ X5 @ X9 )
             => ( ord_less_eq @ real @ X5 @ Z5 ) ) ) ) ) ).

% Sup_real_def
thf(fact_8059_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X6: A] :
                ( ( member @ A @ X6 @ S2 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ X6 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y5: B] : ( member @ B @ Y5 @ ( image @ A @ B @ F2 @ S2 ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X5: A] : ( member @ A @ X5 @ S2 ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_8060_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X5: A] :
                  ( ( P3 @ X5 )
                  & ! [Y5: A] :
                      ( ( P3 @ Y5 )
                     => ( ord_less_eq @ A @ X5 @ Y5 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_8061_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
            = ( ord_Least @ A
              @ ^ [S7: A] :
                  ( ( member @ A @ S7 @ S2 )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S7 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_8062_independentD,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A,T2: set @ A,U: A > real,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ S )
         => ( ( finite_finite @ A @ T2 )
           => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U @ V5 ) @ V5 )
                    @ T2 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ V @ T2 )
                 => ( ( U @ V )
                    = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independentD
thf(fact_8063_dependent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [B8: set @ A] :
            ? [X9: A > real] :
              ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [X5: A] :
                      ( ( X9 @ X5 )
                     != ( zero_zero @ real ) ) ) )
              & ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X5: A] :
                      ( ( X9 @ X5 )
                     != ( zero_zero @ real ) ) )
                @ B8 )
              & ( ( groups7311177749621191930dd_sum @ A @ A
                  @ ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( X9 @ X5 ) @ X5 )
                  @ ( collect @ A
                    @ ^ [X5: A] :
                        ( ( X9 @ X5 )
                       != ( zero_zero @ real ) ) ) )
                = ( zero_zero @ A ) )
              & ? [X5: A] :
                  ( ( X9 @ X5 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% dependent_alt
thf(fact_8064_dependent__single,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V358717886546972837endent @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% dependent_single
thf(fact_8065_dependent__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ A4 )
         => ( real_V358717886546972837endent @ A @ A4 ) ) ) ).

% dependent_zero
thf(fact_8066_independent__Union__directed,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C6: set @ ( set @ A )] :
          ( ! [C3: set @ A,D4: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( member @ ( set @ A ) @ D4 @ C6 )
               => ( ( ord_less_eq @ ( set @ A ) @ C3 @ D4 )
                  | ( ord_less_eq @ ( set @ A ) @ D4 @ C3 ) ) ) )
         => ( ! [C3: set @ A] :
                ( ( member @ ( set @ A ) @ C3 @ C6 )
               => ~ ( real_V358717886546972837endent @ A @ C3 ) )
           => ~ ( real_V358717886546972837endent @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ).

% independent_Union_directed
thf(fact_8067_independent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ A4 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
           => ~ ( real_V358717886546972837endent @ A @ B6 ) ) ) ) ).

% independent_mono
thf(fact_8068_dependent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( real_V358717886546972837endent @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
           => ( real_V358717886546972837endent @ A @ A4 ) ) ) ) ).

% dependent_mono
thf(fact_8069_unique__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,F2: A > real,G: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ! [V4: A] :
                ( ( ( F2 @ V4 )
                 != ( zero_zero @ real ) )
               => ( member @ A @ V4 @ Basis ) )
           => ( ! [V4: A] :
                  ( ( ( G @ V4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ V4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [V5: A] :
                        ( ( F2 @ V5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( G @ V5 )
                         != ( zero_zero @ real ) ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( F2 @ V5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( G @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( G @ V5 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( F2 = G ) ) ) ) ) ) ) ) ).

% unique_representation
thf(fact_8070_dependent__finite,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( real_V358717886546972837endent @ A @ S2 )
            = ( ? [U2: A > real] :
                  ( ? [X5: A] :
                      ( ( member @ A @ X5 @ S2 )
                      & ( ( U2 @ X5 )
                       != ( zero_zero @ real ) ) )
                  & ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ S2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% dependent_finite
thf(fact_8071_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [F6: A > real,X3: A] :
                ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ A @ ( F6 @ Y5 ) @ Y5 )
                    @ A4 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ X3 @ A4 )
                 => ( ( F6 @ X3 )
                    = ( zero_zero @ real ) ) ) )
           => ~ ( real_V358717886546972837endent @ A @ A4 ) ) ) ) ).

% independent_if_scalars_zero
thf(fact_8072_independentD__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,X8: A > real,Y7: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X5: A] :
                    ( ( X8 @ X5 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X5: A] :
                      ( ( X8 @ X5 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X5: A] :
                        ( ( Y7 @ X5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X5: A] :
                          ( ( Y7 @ X5 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X5 ) @ X5 )
                        @ ( collect @ A
                          @ ^ [X5: A] :
                              ( ( X8 @ X5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( Y7 @ X5 ) @ X5 )
                        @ ( collect @ A
                          @ ^ [X5: A] :
                              ( ( Y7 @ X5 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( X8 = Y7 ) ) ) ) ) ) ) ) ).

% independentD_unique
thf(fact_8073_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ A4 ) )
          = ( ! [S6: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ S6 @ A4 )
               => ( ( finite_finite @ A @ S6 )
                 => ! [U2: A > real] :
                      ( ( ( groups7311177749621191930dd_sum @ A @ A
                          @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                          @ S6 )
                        = ( zero_zero @ A ) )
                     => ! [X5: A] :
                          ( ( member @ A @ X5 @ S6 )
                         => ( ( U2 @ X5 )
                            = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
thf(fact_8074_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ S ) )
          = ( ! [T4: set @ A,U2: A > real,V5: A] :
                ( ( finite_finite @ A @ T4 )
               => ( ( ord_less_eq @ ( set @ A ) @ T4 @ S )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ W3 ) @ W3 )
                        @ T4 )
                      = ( zero_zero @ A ) )
                   => ( ( member @ A @ V5 @ T4 )
                     => ( ( U2 @ V5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_module
thf(fact_8075_dependent__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [S7: set @ A] :
            ? [T4: set @ A] :
              ( ( finite_finite @ A @ T4 )
              & ( ord_less_eq @ ( set @ A ) @ T4 @ S7 )
              & ? [U2: A > real] :
                  ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ T4 )
                    = ( zero_zero @ A ) )
                  & ? [X5: A] :
                      ( ( member @ A @ X5 @ T4 )
                      & ( ( U2 @ X5 )
                       != ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% dependent_explicit
thf(fact_8076_independentD__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,X8: A > real,X: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X5: A] :
                    ( ( X8 @ X5 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X5: A] :
                      ( ( X8 @ X5 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X5 ) @ X5 )
                    @ ( collect @ A
                      @ ^ [X5: A] :
                          ( ( X8 @ X5 )
                         != ( zero_zero @ real ) ) ) )
                  = ( zero_zero @ A ) )
               => ( ( X8 @ X )
                  = ( zero_zero @ real ) ) ) ) ) ) ) ).

% independentD_alt
thf(fact_8077_independent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ B6 ) )
          = ( ! [X9: A > real] :
                ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X5: A] :
                        ( ( X9 @ X5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X5: A] :
                          ( ( X9 @ X5 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( X9 @ X5 ) @ X5 )
                        @ ( collect @ A
                          @ ^ [X5: A] :
                              ( ( X9 @ X5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( zero_zero @ A ) )
                   => ! [X5: A] :
                        ( ( X9 @ X5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independent_alt
thf(fact_8078_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X5: A,Y5: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ S7 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ ( F2 @ Y5 ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_8079_possible__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se6407376104438227557le_bit @ A )
        = ( ^ [Tyrep: itself @ A,N2: nat] :
              ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% possible_bit_def
thf(fact_8080_possible__bit__min,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I2: nat,J2: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ ( ord_min @ nat @ I2 @ J2 ) )
          = ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I2 )
            | ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J2 ) ) ) ) ).

% possible_bit_min
thf(fact_8081_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I2: nat,J2: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I2 )
         => ( ( ord_less_eq @ nat @ J2 @ I2 )
           => ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J2 ) ) ) ) ).

% possible_bit_less_imp
thf(fact_8082_possible__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Ty: itself @ A] : ( bit_se6407376104438227557le_bit @ A @ Ty @ ( zero_zero @ nat ) ) ) ).

% possible_bit_0
thf(fact_8083_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S7: set @ A,F3: A > B] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X5: A] :
                      ( ( member @ A @ X5 @ S7 )
                     => ! [Y5: A] :
                          ( ( member @ A @ Y5 @ S7 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X5 ) @ D3 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ Y5 ) @ ( F3 @ X5 ) ) @ E3 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_8084_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_8085_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% bit_minus_2_iff
thf(fact_8086_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% CHAR_eq_0
thf(fact_8087_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_CHAR
thf(fact_8088_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_8089_bit__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) @ N )
          = ( ( ( M = N )
              = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_flip_bit_iff
thf(fact_8090_bit__imp__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_imp_possible_bit
thf(fact_8091_impossible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% impossible_bit
thf(fact_8092_bit__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y6: A,Z3: A] : ( Y6 = Z3 ) )
        = ( ^ [A5: A,B4: A] :
            ! [N2: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 )
                = ( bit_se5641148757651400278ts_bit @ A @ B4 @ N2 ) ) ) ) ) ) ).

% bit_eq_iff
thf(fact_8093_bit__eqI,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
                = ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) ) )
         => ( A2 = B2 ) ) ) ).

% bit_eqI
thf(fact_8094_bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ~ ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff
thf(fact_8095_bit__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( ( M = N )
              & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ) ).

% bit_set_bit_iff
thf(fact_8096_bit__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_iff
thf(fact_8097_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ( semiring_1_of_nat @ A @ C2 )
            = ( zero_zero @ A ) )
         => ( ! [X3: nat] :
                ( ( ( semiring_1_of_nat @ A @ X3 )
                  = ( zero_zero @ A ) )
               => ( dvd_dvd @ nat @ C2 @ X3 ) )
           => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
              = C2 ) ) ) ) ).

% CHAR_eqI
thf(fact_8098_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ nat @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) @ N ) ) ) ).

% of_nat_eq_0_iff_char_dvd
thf(fact_8099_bit__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( ring_1_of_int @ A @ K ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ) ).

% bit_of_int_iff
thf(fact_8100_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ) ).

% bit_of_nat_iff
thf(fact_8101_bit__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% bit_signed_take_bit_iff
thf(fact_8102_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_8103_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
          = ( zero_zero @ nat ) )
        = ( ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( semiring_1_of_nat @ A @ N2 )
               != ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_eq0_iff
thf(fact_8104_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
         => ( ( ( semiring_1_of_nat @ A @ C2 )
              = ( zero_zero @ A ) )
           => ( ! [X3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
                 => ( ( ord_less @ nat @ X3 @ C2 )
                   => ( ( semiring_1_of_nat @ A @ X3 )
                     != ( zero_zero @ A ) ) ) )
             => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
                = C2 ) ) ) ) ) ).

% CHAR_eq_posI
thf(fact_8105_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( ? [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
              & ( ( semiring_1_of_nat @ A @ N2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_pos_iff
thf(fact_8106_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less_eq @ nat @ M @ N )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_push_bit_iff
thf(fact_8107_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% fold_possible_bit
thf(fact_8108_bit__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( M = N ) ) ) ) ).

% bit_exp_iff
thf(fact_8109_bit__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ ( one_one @ nat ) )
            & ( N
              = ( one_one @ nat ) ) ) ) ) ).

% bit_2_iff
thf(fact_8110_bit__not__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( N != M ) ) ) ) ).

% bit_not_exp_iff
thf(fact_8111_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% bit_minus_exp_iff
thf(fact_8112_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_8113_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_8114_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A4 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_8115_last__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,K: nat,X: A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( ( K
            = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = X ) )
        & ( ( K
           != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = ( last @ A @ Xs2 ) ) ) ) ) ).

% last_list_update
thf(fact_8116_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_8117_last__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_8118_last__upt,axiom,
    ! [I2: nat,J2: nat] :
      ( ( ord_less @ nat @ I2 @ J2 )
     => ( ( last @ nat @ ( upt @ I2 @ J2 ) )
        = ( minus_minus @ nat @ J2 @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_8119_last__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( last @ A @ ( drop @ A @ N @ Xs2 ) )
        = ( last @ A @ Xs2 ) ) ) ).

% last_drop
thf(fact_8120_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B6: set @ A,A4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
         => ( ( gcd_gcd @ A @ ( semiring_gcd_Gcd_fin @ A @ B6 ) @ ( semiring_gcd_Gcd_fin @ A @ A4 ) )
            = ( semiring_gcd_Gcd_fin @ A @ A4 ) ) ) ) ).

% Gcd_fin.subset
thf(fact_8121_last__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( ( size_size @ ( list @ A ) @ Xs2 )
            = ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( last @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
            = ( product_Pair @ A @ B @ ( last @ A @ Xs2 ) @ ( last @ B @ Ys ) ) ) ) ) ) ).

% last_zip
thf(fact_8122_last__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( last @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ) ) ).

% last_conv_nth
thf(fact_8123_connected__closedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,A4: set @ A,B6: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ S )
         => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B6 ) @ S )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
             => ( ( topolo7761053866217962861closed @ A @ A4 )
               => ( ( topolo7761053866217962861closed @ A @ B6 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A4 @ S )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ B6 @ S )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connected_closedD
thf(fact_8124_connected__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S7: set @ A] :
              ~ ? [A7: set @ A,B8: set @ A] :
                  ( ( topolo7761053866217962861closed @ A @ A7 )
                  & ( topolo7761053866217962861closed @ A @ B8 )
                  & ( ord_less_eq @ ( set @ A ) @ S7 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) @ S7 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A7 @ S7 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B8 @ S7 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_closed
thf(fact_8125_connected__iff__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [U6: set @ A] :
            ! [X5: A] :
              ( ( member @ A @ X5 @ U6 )
             => ! [Y5: A] :
                  ( ( member @ A @ Y5 @ U6 )
                 => ! [Z5: A] :
                      ( ( ord_less_eq @ A @ X5 @ Z5 )
                     => ( ( ord_less_eq @ A @ Z5 @ Y5 )
                       => ( member @ A @ Z5 @ U6 ) ) ) ) ) ) ) ) ).

% connected_iff_interval
thf(fact_8126_connectedI__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [U4: set @ A] :
          ( ! [X3: A,Y: A,Z2: A] :
              ( ( member @ A @ X3 @ U4 )
             => ( ( member @ A @ Y @ U4 )
               => ( ( ord_less_eq @ A @ X3 @ Z2 )
                 => ( ( ord_less_eq @ A @ Z2 @ Y )
                   => ( member @ A @ Z2 @ U4 ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U4 ) ) ) ).

% connectedI_interval
thf(fact_8127_connectedD__interval,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [U4: set @ A,X: A,Y3: A,Z: A] :
          ( ( topolo1966860045006549960nected @ A @ U4 )
         => ( ( member @ A @ X @ U4 )
           => ( ( member @ A @ Y3 @ U4 )
             => ( ( ord_less_eq @ A @ X @ Z )
               => ( ( ord_less_eq @ A @ Z @ Y3 )
                 => ( member @ A @ Z @ U4 ) ) ) ) ) ) ) ).

% connectedD_interval
thf(fact_8128_connected__contains__Icc,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A4: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( member @ A @ B2 @ A4 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ A4 ) ) ) ) ) ).

% connected_contains_Icc
thf(fact_8129_connected__contains__Ioo,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A4: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( member @ A @ B2 @ A4 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ A4 ) ) ) ) ) ).

% connected_contains_Ioo
thf(fact_8130_connected__diff__open__from__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,U: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ U )
           => ( ( topolo1002775350975398744n_open @ A @ S )
             => ( ( topolo7761053866217962861closed @ A @ T2 )
               => ( ( topolo1966860045006549960nected @ A @ U )
                 => ( ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ T2 @ S ) )
                   => ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ U @ S ) ) ) ) ) ) ) ) ) ).

% connected_diff_open_from_closed
thf(fact_8131_connectedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A4: set @ A,U4: set @ A,V2: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ A4 )
         => ( ( topolo1002775350975398744n_open @ A @ U4 )
           => ( ( topolo1002775350975398744n_open @ A @ V2 )
             => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U4 @ V2 ) @ A4 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ U4 @ V2 ) )
                 => ( ( ( inf_inf @ ( set @ A ) @ U4 @ A4 )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ V2 @ A4 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connectedD
thf(fact_8132_connectedI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [U4: set @ A] :
          ( ! [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
             => ! [B9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ B9 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A8 @ U4 )
                     != ( bot_bot @ ( set @ A ) ) )
                   => ( ( ( inf_inf @ ( set @ A ) @ B9 @ U4 )
                       != ( bot_bot @ ( set @ A ) ) )
                     => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A8 @ B9 ) @ U4 )
                          = ( bot_bot @ ( set @ A ) ) )
                       => ~ ( ord_less_eq @ ( set @ A ) @ U4 @ ( sup_sup @ ( set @ A ) @ A8 @ B9 ) ) ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U4 ) ) ) ).

% connectedI
thf(fact_8133_connected__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S6: set @ A] :
              ~ ? [A7: set @ A,B8: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A7 )
                  & ( topolo1002775350975398744n_open @ A @ B8 )
                  & ( ord_less_eq @ ( set @ A ) @ S6 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) @ S6 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A7 @ S6 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B8 @ S6 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_def
thf(fact_8134_flat__lub__def,axiom,
    ! [A: $tType] :
      ( ( partial_flat_lub @ A )
      = ( ^ [B4: A,A7: set @ A] :
            ( if @ A @ ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4
            @ ( the @ A
              @ ^ [X5: A] : ( member @ A @ X5 @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% flat_lub_def
thf(fact_8135_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ( inj_on @ A @ B @ F2 @ ( collect @ A @ P ) )
         => ( ( P @ A2 )
           => ( ! [Y: A] :
                  ( ( P @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ A2 ) @ ( F2 @ Y ) ) )
             => ( ( lattices_ord_arg_min @ A @ B @ F2 @ P )
                = A2 ) ) ) ) ) ).

% arg_min_inj_eq
thf(fact_8136_arg__min__nat__le,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ X ) ) ) ).

% arg_min_nat_le
thf(fact_8137_arg__min__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) )
        & ! [Y4: A] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ Y4 ) ) ) ) ) ).

% arg_min_nat_lemma
thf(fact_8138_arg__min__equality,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order @ A )
     => ! [P: C > $o,K: C,F2: C > A] :
          ( ( P @ K )
         => ( ! [X3: C] :
                ( ( P @ X3 )
               => ( ord_less_eq @ A @ ( F2 @ K ) @ ( F2 @ X3 ) ) )
           => ( ( F2 @ ( lattices_ord_arg_min @ C @ A @ F2 @ P ) )
              = ( F2 @ K ) ) ) ) ) ).

% arg_min_equality
thf(fact_8139_arg__minI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [P: A > $o,X: A,F2: A > B,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y: A] :
                ( ( P @ Y )
               => ~ ( ord_less @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ~ ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( lattices_ord_arg_min @ A @ B @ F2 @ P ) ) ) ) ) ) ).

% arg_minI
thf(fact_8140_arg__min__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic7623131987881927897min_on @ B @ A )
        = ( ^ [F3: B > A,S6: set @ B] :
              ( lattices_ord_arg_min @ B @ A @ F3
              @ ^ [X5: B] : ( member @ B @ X5 @ S6 ) ) ) ) ) ).

% arg_min_on_def
thf(fact_8141_arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattices_ord_arg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattic501386751177426532rg_min @ B @ A @ F3 @ P3 ) ) ) ) ) ).

% arg_min_def
thf(fact_8142_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y3: A,F2: A > nat,Fs: list @ ( A > nat )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y3 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measures @ A @ Fs ) ) ) ) ) ).

% in_measures(2)
thf(fact_8143_is__arg__min__arg__min__nat,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( lattic501386751177426532rg_min @ A @ nat @ M @ P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% is_arg_min_arg_min_nat
thf(fact_8144_arg__min__natI,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% arg_min_natI
thf(fact_8145_is__arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic501386751177426532rg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o,X5: B] :
              ( ( P3 @ X5 )
              & ~ ? [Y5: B] :
                    ( ( P3 @ Y5 )
                    & ( ord_less @ A @ ( F3 @ Y5 ) @ ( F3 @ X5 ) ) ) ) ) ) ) ).

% is_arg_min_def
thf(fact_8146_is__arg__min__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( ( lattic501386751177426532rg_min @ A @ B )
        = ( ^ [F3: A > B,P3: A > $o,X5: A] :
              ( ( P3 @ X5 )
              & ! [Y5: A] :
                  ( ( P3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F3 @ X5 ) @ ( F3 @ Y5 ) ) ) ) ) ) ) ).

% is_arg_min_linorder
thf(fact_8147_is__arg__min__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,X: A,Y3: A] :
          ( ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ X )
         => ( ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X ) )
           => ( ( P @ Y3 )
             => ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ Y3 ) ) ) ) ) ).

% is_arg_min_antimono
thf(fact_8148_measures__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y3: A,Fs: list @ ( A > nat )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ).

% measures_less
thf(fact_8149_measures__lesseq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y3: A,Fs: list @ ( A > nat )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measures @ A @ Fs ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ) ).

% measures_lesseq
thf(fact_8150_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X_1: A] :
                ( lattic501386751177426532rg_min @ A @ B @ F2
                @ ^ [X5: A] : ( member @ A @ X5 @ S2 )
                @ X_1 ) ) ) ) ).

% ex_is_arg_min_if_finite
thf(fact_8151_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_8152_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_8153_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( inf_inf @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = A2 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_8154_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Sup_fin.singleton
thf(fact_8155_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
              = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_8156_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_8157_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_8158_Sup__fin__Max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% Sup_fin_Max
thf(fact_8159_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X5 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_8160_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A3: A] :
                  ( ( member @ A @ A3 @ A4 )
                 => ( ord_less_eq @ A @ A3 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_8161_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A4 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_8162_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_8163_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B6 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_8164_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y: A] :
              ( ( H2 @ ( sup_sup @ A @ X3 @ Y ) )
              = ( sup_sup @ A @ ( H2 @ X3 ) @ ( H2 @ Y ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N5 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_8165_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A4 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B6 ) @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
                = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_8166_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_8167_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y: A] : ( member @ A @ ( sup_sup @ A @ X3 @ Y ) @ ( insert @ A @ X3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_8168_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B6 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_8169_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A5: A] :
                      ( ( Uu3
                        = ( inf_inf @ A @ X @ A5 ) )
                      & ( member @ A @ A5 @ A4 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_8170_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A5: A,B4: A] :
                          ( ( Uu3
                            = ( inf_inf @ A @ A5 @ B4 ) )
                          & ( member @ A @ A5 @ A4 )
                          & ( member @ A @ B4 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_8171_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_8172_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_8173_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Inf_fin.singleton
thf(fact_8174_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A2 )
              = A2 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_8175_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_8176_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A4 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_8177_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A3: A] :
                  ( ( member @ A @ A3 @ A4 )
                 => ( ord_less_eq @ A @ X @ A3 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_8178_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X @ X5 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_8179_Inf__fin__Min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% Inf_fin_Min
thf(fact_8180_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_8181_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_8182_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Inf_fin_Inf

% Type constructors (773)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( filter @ A11 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( set @ A11 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounded_lattice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple592849572758109894attice @ A20 )
     => ( counta4013691401010221786attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( condit1219197933456340205attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( counta3822494911875563373attice @ A20 )
     => ( counta3822494911875563373attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple592849572758109894attice @ A20 )
     => ( comple592849572758109894attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4967611905675639751up_bot @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4346867609351753570nf_top @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple6319245703460814977attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( boolea8198339166811842893lgebra @ A20 )
     => ( boolea8198339166811842893lgebra @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( semilattice_sup @ A20 )
     => ( semilattice_sup @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( semilattice_inf @ A20 )
     => ( semilattice_inf @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( distrib_lattice @ A20 )
     => ( distrib_lattice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order_top @ A20 )
     => ( order_top @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order_bot @ A20 )
     => ( order_bot @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( preorder @ A20 )
     => ( preorder @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( lattice @ A20 )
     => ( lattice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order @ A20 )
     => ( order @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( top @ A20 )
     => ( top @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ord @ A20 )
     => ( ord @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bot @ A20 )
     => ( bot @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( uminus @ A20 )
     => ( uminus @ ( A11 > A20 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_8,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_14,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_15,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_16,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_17,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_18,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_19,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_20,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_21,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_22,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_23,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_24,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_25,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_26,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_27,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_28,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_29,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_30,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_31,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_32,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_33,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_34,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_35,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_36,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_37,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_38,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_39,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_40,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_41,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_42,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_43,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_44,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_45,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_46,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_47,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_48,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_49,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_50,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_51,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_52,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_53,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_54,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_55,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_56,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_57,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_58,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_59,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_60,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_61,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_62,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_63,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_64,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_65,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_66,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_67,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_68,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_69,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_70,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_71,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_72,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_73,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_74,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_75,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_76,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_77,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_78,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_79,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_80,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_81,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_82,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_83,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_84,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_85,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_86,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_87,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_88,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_89,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_90,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_91,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_92,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_93,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_94,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_95,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_96,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Power_Opower_97,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_98,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_99,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_100,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_101,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_102,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_103,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_104,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_105,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_106,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_107,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_108,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_109,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_110,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_111,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_112,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_113,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_114,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_115,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_116,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_117,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_118,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_119,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_120,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_121,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_122,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_123,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_124,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_125,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_126,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_127,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_128,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_129,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_130,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_131,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_132,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_133,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_134,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_135,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_136,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_137,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_138,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_139,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_140,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_141,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_142,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_143,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_144,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_145,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_146,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_147,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_148,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_149,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_150,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_151,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_152,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_153,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_154,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_155,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_156,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_157,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_158,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_159,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_160,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_161,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_162,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_163,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_164,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_165,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_166,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_167,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_168,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_169,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_170,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_171,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_172,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_173,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_174,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_175,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_176,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_177,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_178,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_179,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_180,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_181,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_182,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_183,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_184,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_185,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_186,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_187,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_188,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_189,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_190,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_191,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_192,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_193,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_194,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_195,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_196,axiom,
    ! [A11: $tType] : ( counta4013691401010221786attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_197,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_198,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_199,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_200,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_201,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_202,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_203,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_204,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_205,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_206,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_207,axiom,
    ! [A11: $tType] : ( order_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_208,axiom,
    ! [A11: $tType] : ( order_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_209,axiom,
    ! [A11: $tType] : ( preorder @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_210,axiom,
    ! [A11: $tType] : ( lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_211,axiom,
    ! [A11: $tType] : ( order @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_212,axiom,
    ! [A11: $tType] : ( top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_213,axiom,
    ! [A11: $tType] : ( ord @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_214,axiom,
    ! [A11: $tType] : ( bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_215,axiom,
    ! [A11: $tType] : ( uminus @ ( set @ A11 ) ) ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_216,axiom,
    counta4013691401010221786attice @ $o ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_217,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_218,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_219,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_220,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_221,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_222,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_223,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_224,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_225,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_226,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_227,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_228,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_229,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_230,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_231,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_232,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_233,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_234,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_235,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_236,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_237,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_238,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_239,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_240,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_241,axiom,
    ! [A11: $tType] : ( size @ ( list @ A11 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_242,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_243,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_244,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_245,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_246,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_247,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_248,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_249,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_250,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_251,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_252,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_253,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_254,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_255,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_256,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_257,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_258,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_259,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_260,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_261,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_262,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_263,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_264,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_265,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_266,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_267,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_268,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_269,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_270,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_271,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_272,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_273,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_274,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_275,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_276,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_277,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_278,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_279,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_280,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_281,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_282,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_283,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_284,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_285,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_286,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_287,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Lattices_Odistrib__lattice_288,axiom,
    distrib_lattice @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_289,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_290,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_291,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_292,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_293,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_294,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_295,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_296,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_297,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_298,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_299,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_300,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_301,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_302,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_303,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_304,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_305,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_306,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_307,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_308,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_309,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_310,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_311,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_312,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_313,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_314,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_315,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_316,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_317,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_318,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_319,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_320,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_321,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_322,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_323,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_324,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_325,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_326,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_327,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_328,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_329,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_330,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_331,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_332,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_333,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_334,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_335,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_336,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_337,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_338,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_339,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_340,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_341,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_342,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_343,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_344,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_345,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_346,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_347,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_348,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_349,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_350,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_351,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_352,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_353,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_354,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_355,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_356,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_357,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_358,axiom,
    ! [A11: $tType] : ( order_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_359,axiom,
    ! [A11: $tType] : ( order_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_360,axiom,
    ! [A11: $tType] : ( preorder @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_361,axiom,
    ! [A11: $tType] : ( lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_362,axiom,
    ! [A11: $tType] : ( order @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_363,axiom,
    ! [A11: $tType] : ( top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_364,axiom,
    ! [A11: $tType] : ( ord @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_365,axiom,
    ! [A11: $tType] : ( bot @ ( filter @ A11 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_366,axiom,
    ! [A11: $tType] : ( size @ ( option @ A11 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_367,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_368,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_369,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_370,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_371,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_372,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_373,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_374,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_375,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_376,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_377,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_378,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_379,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_380,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_381,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_382,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_383,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_384,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_385,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_386,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_387,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_388,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_389,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_390,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_391,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_392,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_393,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_394,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_395,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_396,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_397,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_398,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_399,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_400,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_401,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_402,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_403,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_404,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_405,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_406,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_407,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_408,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_409,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_410,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_411,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_412,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_413,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_414,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_415,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_416,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_417,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_418,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_419,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_420,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_421,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_422,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_423,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_424,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_425,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_426,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_427,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_428,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_429,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_430,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_431,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_432,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_433,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_434,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_435,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_436,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_437,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_438,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_439,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_440,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_441,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_442,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_443,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_444,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_445,axiom,
    counta4013691401010221786attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_446,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_447,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_448,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_449,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_450,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_451,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_452,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_453,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_454,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_455,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_456,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_457,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_458,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_459,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_460,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_461,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_462,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Odistrib__lattice_463,axiom,
    distrib_lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_464,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_465,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_466,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_467,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_468,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_469,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_470,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_471,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_472,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_473,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_474,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_475,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_476,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_477,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_478,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_479,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_480,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_481,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_482,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_483,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_484,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_485,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_486,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_487,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_488,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_489,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_490,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Otop_491,axiom,
    top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_492,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Obot_493,axiom,
    bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_494,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_495,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_496,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_497,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_498,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_499,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_500,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ( topolo4958980785337419405_space @ A11 )
        & ( topolo4958980785337419405_space @ A20 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A11 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_501,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ( topological_t2_space @ A11 )
        & ( topological_t2_space @ A20 ) )
     => ( topological_t2_space @ ( product_prod @ A11 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_502,axiom,
    ! [A11: $tType,A20: $tType] : ( size @ ( product_prod @ A11 @ A20 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_503,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_504,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_505,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_506,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_507,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_508,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_509,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_510,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_511,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_512,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_513,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_514,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_515,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_516,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_517,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_518,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_519,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_520,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_521,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_522,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_523,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_524,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_525,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_526,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_527,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_528,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_529,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_530,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_531,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_532,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_533,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_534,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_535,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_536,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_537,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_538,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_539,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_540,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_541,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_542,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_543,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_544,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_545,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_546,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_547,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_548,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_549,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_550,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_551,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_552,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_553,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_554,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_555,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_556,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_557,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_558,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_559,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_560,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_561,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_562,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_563,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_564,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_565,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_566,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_567,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_568,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_569,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_570,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_571,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_572,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_573,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_574,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_575,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_576,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_577,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_578,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_579,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_580,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_581,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_582,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_583,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_584,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_585,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_586,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_587,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_588,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_589,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_590,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_591,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_592,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_593,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_594,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_595,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_596,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_597,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_598,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_599,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_600,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_601,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_602,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y3: A] :
      ( ( if @ A @ $false @ X @ Y3 )
      = Y3 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y3: A] :
      ( ( if @ A @ $true @ X @ Y3 )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X9: A] : ( P @ X9 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ).

%------------------------------------------------------------------------------
