%------------------------------------------------------------------------------
% File     : VBT00025^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Insert 00308_018939
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0066_VEBT_Insert_00308_018939 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9522 (3040 unt; 580 typ;   0 def)
%            Number of atoms       : 27662 (9376 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 173956 (2121   ~; 344   |;2178   &;156634   @)
%                                         (   0 <=>;12679  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 3594 (3594   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  573 ( 569 usr;  16 con; 0-9 aty)
%            Number of variables   : 29607 (2506   ^25692   !; 866   ?;29607   :)
%                                         ( 543  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 19:37:01.246
%------------------------------------------------------------------------------
% Could-be-implicit typings (16)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

% Explicit typings (564)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_OId,type,
    id: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_ma____,type,
    ma: nat ).

thf(sy_v_mi____,type,
    mi: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

thf(sy_v_ya____,type,
    ya: nat ).

% Relevant facts (8181)
thf(fact_0__092_060open_062both__member__options_A_ItreeList_A_B_Ahigh_Ama_An_J_A_Ilow_Ama_An_J_092_060close_062,axiom,
    vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ma @ na ) ) @ ( vEBT_VEBT_low @ ma @ na ) ).

% \<open>both_member_options (treeList ! high ma n) (low ma n)\<close>
thf(fact_1_False,axiom,
    xa != mi ).

% False
thf(fact_2__092_060open_062both__member__options_A_ItreeList_A_B_Ahigh_Ax_An_J_A_Ilow_Ax_An_J_A_092_060or_062_Ax_A_061_Ama_092_060close_062,axiom,
    ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ na ) ) @ ( vEBT_VEBT_low @ xa @ na ) )
    | ( xa = ma ) ) ).

% \<open>both_member_options (treeList ! high x n) (low x n) \<or> x = ma\<close>
thf(fact_3_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_4__C4_Ohyps_C_I3_J,axiom,
    m = na ).

% "4.hyps"(3)
thf(fact_5_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N: nat,TreeList: list @ vEBT_VEBT,X2: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ N ) ) @ ( vEBT_VEBT_low @ X2 @ N ) ) ) ) ).

% in_children_def
thf(fact_6__092_060open_062x_A_061_Ami_A_092_060or_062_Ax_A_061_Ama_A_092_060or_062_Aboth__member__options_A_ItreeList_A_B_Ahigh_Ax_An_J_A_Ilow_Ax_An_J_092_060close_062,axiom,
    ( ( xa = mi )
    | ( xa = ma )
    | ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ na ) ) @ ( vEBT_VEBT_low @ xa @ na ) ) ) ).

% \<open>x = mi \<or> x = ma \<or> both_member_options (treeList ! high x n) (low x n)\<close>
thf(fact_7_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_1 ) ) ).

% not_min_Null_member
thf(fact_8__C4_Ohyps_C_I6_J,axiom,
    ( ( mi = ma )
   => ! [X3: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ).

% "4.hyps"(6)
thf(fact_9_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X2: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X2 )
          | ( vEBT_VEBT_membermima @ T3 @ X2 ) ) ) ) ).

% both_member_options_def
thf(fact_10__C4_Ohyps_C_I4_J,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "4.hyps"(4)
thf(fact_11__C4_Ohyps_C_I9_J,axiom,
    ( ( mi != ma )
   => ! [I: nat] :
        ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( ( ( vEBT_VEBT_high @ ma @ na )
              = I )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ ma @ na ) ) )
          & ! [X3: nat] :
              ( ( ( ( vEBT_VEBT_high @ X3 @ na )
                  = I )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ X3 @ na ) ) )
             => ( ( ord_less @ nat @ mi @ X3 )
                & ( ord_less_eq @ nat @ X3 @ ma ) ) ) ) ) ) ).

% "4.hyps"(9)
thf(fact_12__C4_Oprems_C_I3_J,axiom,
    vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa ).

% "4.prems"(3)
thf(fact_13_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
        = ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% both_member_options_equiv_member
thf(fact_14_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
       => ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% valid_member_both_member_options
thf(fact_15__092_060open_062low_Ax_An_A_060_A2_A_094_An_A_092_060and_062_Alow_Ay_An_A_060_A2_A_094_An_092_060close_062,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ ya @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ) ).

% \<open>low x n < 2 ^ n \<and> low y n < 2 ^ n\<close>
thf(fact_16_intind,axiom,
    ! [A: $tType,I2: nat,N2: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N2 @ X ) @ I2 ) ) ) ) ).

% intind
thf(fact_17_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( Deg = N2 ) ) ).

% deg_deg_n
thf(fact_18__C4_Ohyps_C_I7_J,axiom,
    ord_less_eq @ nat @ mi @ ma ).

% "4.hyps"(7)
thf(fact_19_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X ) ) ).

% min_Null_member
thf(fact_20__C4_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "4.hyps"(1)
thf(fact_21__092_060open_062mi_A_092_060noteq_062_Ama_092_060close_062,axiom,
    mi != ma ).

% \<open>mi \<noteq> ma\<close>
thf(fact_22__C4_Ohyps_C_I8_J,axiom,
    ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.hyps"(8)
thf(fact_23__C4_Oprems_C_I1_J,axiom,
    ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.prems"(1)
thf(fact_24__C4_Oprems_C_I2_J,axiom,
    ord_less @ nat @ ya @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.prems"(2)
thf(fact_25_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N2 )
     => ( ( vEBT_vebt_member @ Tree @ X )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X )
          | ( vEBT_VEBT_membermima @ Tree @ X ) ) ) ) ).

% member_valid_both_member_options
thf(fact_26_member__correct,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_vebt_member @ T2 @ X )
        = ( member @ nat @ X @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_27__C0_C,axiom,
    ( ( ya != mi )
    & ( ya != ma ) ) ).

% "0"
thf(fact_28_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X3: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
             => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
          & ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_29__C4_Ohyps_C_I5_J,axiom,
    ! [I: nat] :
      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ X4 ) )
        = ( vEBT_V8194947554948674370ptions @ summary @ I ) ) ) ).

% "4.hyps"(5)
thf(fact_30_high__bound__aux,axiom,
    ! [Ma: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_31_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X: nat,N2: nat] :
      ( ( vEBT_vebt_member @ Tree @ X )
     => ( ( vEBT_invar_vebt @ Tree @ N2 )
       => ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% member_bound
thf(fact_32__092_060open_062high_Ama_An_A_060_A2_A_094_An_092_060close_062,axiom,
    ord_less @ nat @ ( vEBT_VEBT_high @ ma @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ).

% \<open>high ma n < 2 ^ n\<close>
thf(fact_33_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_34_xyprop,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_high @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_high @ ya @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ) ).

% xyprop
thf(fact_35__C001_C,axiom,
    vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ deg ).

% "001"
thf(fact_36__C4_OIH_C_I1_J,axiom,
    ! [X3: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X3 @ na )
        & ! [Xa: nat] :
            ( ( ord_less @ nat @ Xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
           => ! [Xb: nat] :
                ( ( ord_less @ nat @ Xb @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
               => ( ( vEBT_V8194947554948674370ptions @ X3 @ Xa )
                 => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ X3 @ Xb ) @ Xa ) ) ) ) ) ) ).

% "4.IH"(1)
thf(fact_37__C4_Ohyps_C_I2_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "4.hyps"(2)
thf(fact_38__C4_OIH_C_I2_J,axiom,
    ! [X: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ord_less @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( vEBT_V8194947554948674370ptions @ summary @ X )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ summary @ Y ) @ X ) ) ) ) ).

% "4.IH"(2)
thf(fact_39_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X ) @ X ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_40_insert__simp__mima,axiom,
    ! [X: nat,Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X = Mi )
        | ( X = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_41_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_42_nth__replicate,axiom,
    ! [A: $tType,I2: nat,N2: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( nth @ A @ ( replicate @ A @ N2 @ X ) @ I2 )
        = X ) ) ).

% nth_replicate
thf(fact_43_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L: nat,D3: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D3 ) ) @ L ) ) ) ).

% bit_concat_def
thf(fact_44_low__inv,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X ) @ N2 )
        = X ) ) ).

% low_inv
thf(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X5: A] :
          ( ( F2 @ X5 )
          = ( G @ X5 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_49_high__inv,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X ) @ N2 )
        = Y ) ) ).

% high_inv
thf(fact_50_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_le
thf(fact_51_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_less
thf(fact_52_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_53_power2__nat__le__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_eq_le
thf(fact_54_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N2: nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( P @ X5 ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% inthall
thf(fact_55_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_56_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X2: nat,N: nat] : ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% high_def
thf(fact_57_length__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N2 @ X ) )
      = N2 ) ).

% length_replicate
thf(fact_58_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_59_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_60_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
thf(fact_61_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
thf(fact_62_Ex__list__of__length,axiom,
    ! [A: $tType,N2: nat] :
    ? [Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N2 ) ).

% Ex_list_of_length
thf(fact_63_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys2: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_64_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_divide
thf(fact_65_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_66_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_mult_distrib
thf(fact_67_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_commutes
thf(fact_68_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N2 ) ) ) ).

% power_mult
thf(fact_69_mult__le__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_70_mult__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_71_mult__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ L2 ) ) ) ) ).

% mult_le_mono
thf(fact_72_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_73_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_74_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% add_mult_distrib2
thf(fact_75_add__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N2 ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% add_mult_distrib
thf(fact_76_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y2: list @ A,Z: list @ A] : ( Y2 = Z ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I3 )
                  = ( nth @ A @ Ys3 @ I3 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_77_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ K )
           => ? [X4: A] : ( P @ I3 @ X4 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ K )
               => ( P @ I3 @ ( nth @ A @ Xs3 @ I3 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_78_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I4 )
              = ( nth @ A @ Ys @ I4 ) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
thf(fact_79_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_add
thf(fact_80_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( X5 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X )
        = Xs ) ) ).

% replicate_length_same
thf(fact_81_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N2 )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( Y3 = X ) )
       => ( Xs
          = ( replicate @ A @ N2 @ X ) ) ) ) ).

% replicate_eqI
thf(fact_82_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) ) )
      = ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_83_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X: A] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I4 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_84_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I3 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_85_list__ball__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% list_ball_nth
thf(fact_86_nth__mem,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N2 ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_87_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_88_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_89_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_90_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X5 ) )
                 => ( P @ Y4 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_91_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X5 ) )
                 => ( P @ Y4 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_92_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V: A > nat,X: A] :
      ( ! [X5: A] :
          ( ~ ( P @ X5 )
         => ? [Y4: A] :
              ( ( ord_less @ nat @ ( V @ Y4 ) @ ( V @ X5 ) )
              & ~ ( P @ Y4 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_93_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_94_infinite__descent,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N2 ) ) ).

% infinite_descent
thf(fact_95_nat__less__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% nat_less_induct
thf(fact_96_less__irrefl__nat,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_irrefl_nat
thf(fact_97_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_98_less__not__refl2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( M != N2 ) ) ).

% less_not_refl2
thf(fact_99_less__not__refl,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_not_refl
thf(fact_100_nat__neq__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( M != N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( ord_less @ nat @ N2 @ M ) ) ) ).

% nat_neq_iff
thf(fact_101_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ? [X5: nat] :
            ( ( P @ X5 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ Y4 @ X5 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_102_nat__le__linear,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
      | ( ord_less_eq @ nat @ N2 @ M ) ) ).

% nat_le_linear
thf(fact_103_le__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% le_antisym
thf(fact_104_eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( M = N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% eq_imp_le
thf(fact_105_le__trans,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I2 @ K ) ) ) ).

% le_trans
thf(fact_106_le__refl,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ N2 ) ).

% le_refl
thf(fact_107_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_108_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I2: nat,J: nat] :
      ( ! [I4: nat,J2: nat] :
          ( ( ord_less @ nat @ I4 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I4 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_109_le__neq__implies__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( M != N2 )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% le_neq_implies_less
thf(fact_110_less__or__eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_or_eq_imp_le
thf(fact_111_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( ( ord_less @ nat @ M3 @ N )
          | ( M3 = N ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_112_less__imp__le__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_imp_le_nat
thf(fact_113_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N )
          & ( M3 != N ) ) ) ) ).

% nat_less_le
thf(fact_114_less__add__eq__less,axiom,
    ! [K: nat,L2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ L2 )
     => ( ( ( plus_plus @ nat @ M @ L2 )
          = ( plus_plus @ nat @ K @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% less_add_eq_less
thf(fact_115_trans__less__add2,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_116_trans__less__add1,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_117_add__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_118_not__add__less2,axiom,
    ! [J: nat,I2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I2 ) @ I2 ) ).

% not_add_less2
thf(fact_119_not__add__less1,axiom,
    ! [I2: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ I2 ) ).

% not_add_less1
thf(fact_120_add__less__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ K @ L2 )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_less_mono
thf(fact_121_add__lessD1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
     => ( ord_less @ nat @ I2 @ K ) ) ).

% add_lessD1
thf(fact_122_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N: nat] :
        ? [K2: nat] :
          ( N
          = ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ).

% nat_le_iff_add
thf(fact_123_trans__le__add2,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_124_trans__le__add1,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_125_add__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_126_add__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_le_mono
thf(fact_127_le__Suc__ex,axiom,
    ! [K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ K @ L2 )
     => ? [N3: nat] :
          ( L2
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_128_add__leD2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ K @ N2 ) ) ).

% add_leD2
thf(fact_129_add__leD1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% add_leD1
thf(fact_130_le__add2,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ).

% le_add2
thf(fact_131_le__add1,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ).

% le_add1
thf(fact_132_add__leE,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ~ ( ( ord_less_eq @ nat @ M @ N2 )
         => ~ ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% add_leE
thf(fact_133_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less @ nat @ M4 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_134_less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% less_exp
thf(fact_135_power2__nat__le__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_imp_le
thf(fact_136_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I4 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X5: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                        = I4 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_137__C00_C,axiom,
    ( ( deg
      = ( plus_plus @ nat @ na @ m ) )
    & ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
    & ( na = m )
    & ( ord_less_eq @ nat @ ( one_one @ nat ) @ na )
    & ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ) ).

% "00"
thf(fact_138_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_139_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_140_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_141_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_142_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_143_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_144_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_145_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_146_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,M: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N2 ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 ) ) ) ).

% set_n_deg_not_0
thf(fact_147_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_148_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% numeral_eq_iff
thf(fact_149_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_150_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% numeral_le_iff
thf(fact_151_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% numeral_less_iff
thf(fact_152_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V2: num,W: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_153_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% numeral_times_numeral
thf(fact_154_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% numeral_plus_numeral
thf(fact_155_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V2: num,W: num,Z2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V2 @ W ) ) @ Z2 ) ) ) ).

% add_numeral_left
thf(fact_156_num__double,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N2 )
      = ( bit0 @ N2 ) ) ).

% num_double
thf(fact_157_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_158_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_mult_numeral
thf(fact_159_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_160_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_161_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_162_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_163_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( numeral_numeral @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_164_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N2 ) )
          = ( one2 = N2 ) ) ) ).

% one_eq_numeral_iff
thf(fact_165_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N2 ) )
            = ( M = N2 ) ) ) ) ).

% power_inject_exp
thf(fact_166_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_add_numeral
thf(fact_167_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_168_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N2 @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_169_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ one2 @ N2 ) ) ) ).

% one_less_numeral_iff
thf(fact_170_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N2 @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_171_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% one_plus_numeral
thf(fact_172_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_173_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_174_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_175_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_176_add__One__commute,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ N2 )
      = ( plus_plus @ num @ N2 @ one2 ) ) ).

% add_One_commute
thf(fact_177_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_178_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_179_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_180_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_181_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B3 )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X2 @ B3 ) ) ) ) ).

% subset_code(1)
thf(fact_182_nat__mult__1,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N2 )
      = N2 ) ).

% nat_mult_1
thf(fact_183_nat__mult__1__right,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% nat_mult_1_right
thf(fact_184_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L2: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L2 ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L2 ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_185_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% one_le_numeral
thf(fact_186_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_187_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_188_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_189_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_190_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% one_le_power
thf(fact_191_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_192_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_one_over
thf(fact_193_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_194_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_195_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_196_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_197_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_198_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_199_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_200_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_201_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_202_div__le__mono,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N2 @ K ) ) ) ).

% div_le_mono
thf(fact_203_div__le__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ).

% div_le_dividend
thf(fact_204_div__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_205_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_206_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_207_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_208_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_209_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_Bit0
thf(fact_210_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_211_less__mult__imp__div__less,axiom,
    ! [M: nat,I2: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I2 @ N2 ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ I2 ) ) ).

% less_mult_imp_div_less
thf(fact_212_times__div__less__eq__dividend,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_213_div__times__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_214_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit0_div_2
thf(fact_215_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_216_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_217_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_218_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ).

% div_exp_eq
thf(fact_219_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_220_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I4 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X5: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                        = I4 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_221_enat__ord__number_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(1)
thf(fact_222_enat__ord__number_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(2)
thf(fact_223_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_224_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_225_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_226_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_227_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_228_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_229_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_230_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N3: nat] :
          ( X
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_231_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N2 ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S2: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N2 ) ) @ TreeList3 @ S2 ) ) ) ).

% deg_SUcn_Node
thf(fact_232_semiring__norm_I87_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(87)
thf(fact_233_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_234_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_235_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_236_semiring__norm_I83_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit0 @ N2 ) ) ).

% semiring_norm(83)
thf(fact_237_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_238_Suc__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_eq
thf(fact_239_Suc__mono,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% Suc_mono
thf(fact_240_lessI,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( suc @ N2 ) ) ).

% lessI
thf(fact_241_Suc__le__mono,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N2 @ M ) ) ).

% Suc_le_mono
thf(fact_242_add__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N2 ) )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc_right
thf(fact_243_semiring__norm_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(6)
thf(fact_244_semiring__norm_I13_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% semiring_norm(13)
thf(fact_245_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_246_semiring__norm_I12_J,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ one2 @ N2 )
      = N2 ) ).

% semiring_norm(12)
thf(fact_247_semiring__norm_I71_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(71)
thf(fact_248_semiring__norm_I78_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(78)
thf(fact_249_semiring__norm_I68_J,axiom,
    ! [N2: num] : ( ord_less_eq @ num @ one2 @ N2 ) ).

% semiring_norm(68)
thf(fact_250_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_251_mult__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc_right
thf(fact_252_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_253_semiring__norm_I76_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit0 @ N2 ) ) ).

% semiring_norm(76)
thf(fact_254_Suc__numeral,axiom,
    ! [N2: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% Suc_numeral
thf(fact_255_add__2__eq__Suc_H,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc'
thf(fact_256_add__2__eq__Suc,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc
thf(fact_257_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_258_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_259_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N2: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% enat_less_induct
thf(fact_260_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X2: real,Y5: real] :
          ( ( ord_less @ real @ X2 @ Y5 )
          | ( X2 = Y5 ) ) ) ) ).

% less_eq_real_def
thf(fact_261_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N3: nat] : ( ord_less @ real @ Y @ ( power_power @ real @ X @ N3 ) ) ) ).

% real_arch_pow
thf(fact_262_complete__real,axiom,
    ! [S3: set @ real] :
      ( ? [X3: real] : ( member @ real @ X3 @ S3 )
     => ( ? [Z3: real] :
          ! [X5: real] :
            ( ( member @ real @ X5 @ S3 )
           => ( ord_less_eq @ real @ X5 @ Z3 ) )
       => ? [Y3: real] :
            ( ! [X3: real] :
                ( ( member @ real @ X3 @ S3 )
               => ( ord_less_eq @ real @ X3 @ Y3 ) )
            & ! [Z3: real] :
                ( ! [X5: real] :
                    ( ( member @ real @ X5 @ S3 )
                   => ( ord_less_eq @ real @ X5 @ Z3 ) )
               => ( ord_less_eq @ real @ Y3 @ Z3 ) ) ) ) ) ).

% complete_real
thf(fact_263_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) ).

% Suc_inject
thf(fact_264_n__not__Suc__n,axiom,
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) ).

% n_not_Suc_n
thf(fact_265_not__less__less__Suc__eq,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_266_strict__inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I4: nat] :
            ( ( J
              = ( suc @ I4 ) )
           => ( P @ I4 ) )
       => ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ J )
             => ( ( P @ ( suc @ I4 ) )
               => ( P @ I4 ) ) )
         => ( P @ I2 ) ) ) ) ).

% strict_inc_induct
thf(fact_267_less__Suc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I4: nat] : ( P @ I4 @ ( suc @ I4 ) )
       => ( ! [I4: nat,J2: nat,K3: nat] :
              ( ( ord_less @ nat @ I4 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K3 )
               => ( ( P @ I4 @ J2 )
                 => ( ( P @ J2 @ K3 )
                   => ( P @ I4 @ K3 ) ) ) ) )
         => ( P @ I2 @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_268_less__trans__Suc,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I2 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_269_Suc__less__SucD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_SucD
thf(fact_270_less__antisym,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
       => ( M = N2 ) ) ) ).

% less_antisym
thf(fact_271_Suc__less__eq2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
      = ( ? [M5: nat] :
            ( ( M
              = ( suc @ M5 ) )
            & ( ord_less @ nat @ N2 @ M5 ) ) ) ) ).

% Suc_less_eq2
thf(fact_272_All__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
           => ( P @ I3 ) ) )
      = ( ( P @ N2 )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
           => ( P @ I3 ) ) ) ) ).

% All_less_Suc
thf(fact_273_not__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N2 ) )
      = ( ord_less @ nat @ N2 @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_274_less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) ) ) ).

% less_Suc_eq
thf(fact_275_Ex__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
            & ( P @ I3 ) ) )
      = ( ( P @ N2 )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
            & ( P @ I3 ) ) ) ) ).

% Ex_less_Suc
thf(fact_276_less__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% less_SucI
thf(fact_277_less__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( M = N2 ) ) ) ).

% less_SucE
thf(fact_278_Suc__lessI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ( suc @ M )
         != N2 )
       => ( ord_less @ nat @ ( suc @ M ) @ N2 ) ) ) ).

% Suc_lessI
thf(fact_279_Suc__lessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I2 @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_280_Suc__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_lessD
thf(fact_281_Nat_OlessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ K )
     => ( ( K
         != ( suc @ I2 ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_282_transitive__stepwise__le,axiom,
    ! [M: nat,N2: nat,R2: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ! [X5: nat] : ( R2 @ X5 @ X5 )
       => ( ! [X5: nat,Y3: nat,Z4: nat] :
              ( ( R2 @ X5 @ Y3 )
             => ( ( R2 @ Y3 @ Z4 )
               => ( R2 @ X5 @ Z4 ) ) )
         => ( ! [N3: nat] : ( R2 @ N3 @ ( suc @ N3 ) )
           => ( R2 @ M @ N2 ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_283_nat__induct__at__least,axiom,
    ! [M: nat,N2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_at_least
thf(fact_284_full__nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% full_nat_induct
thf(fact_285_not__less__eq__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N2 ) )
      = ( ord_less_eq @ nat @ ( suc @ N2 ) @ M ) ) ).

% not_less_eq_eq
thf(fact_286_Suc__n__not__le__n,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N2 ) @ N2 ) ).

% Suc_n_not_le_n
thf(fact_287_le__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        | ( M
          = ( suc @ N2 ) ) ) ) ).

% le_Suc_eq
thf(fact_288_Suc__le__D,axiom,
    ! [N2: nat,M6: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ M6 )
     => ? [M4: nat] :
          ( M6
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_289_le__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_SucI
thf(fact_290_le__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( M
          = ( suc @ N2 ) ) ) ) ).

% le_SucE
thf(fact_291_Suc__leD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_leD
thf(fact_292_add__Suc__shift,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ M @ ( suc @ N2 ) ) ) ).

% add_Suc_shift
thf(fact_293_add__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc
thf(fact_294_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_295_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( M = N2 ) ) ).

% Suc_mult_cancel1
thf(fact_296_two__realpow__ge__one,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% two_realpow_ge_one
thf(fact_297_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N2 @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_298_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N2 @ N5 )
           => ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_299_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_Suc
thf(fact_300_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_301_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N2 ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_302_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_303_le__imp__less__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_imp_less_Suc
thf(fact_304_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat] : ( ord_less_eq @ nat @ ( suc @ N ) ) ) ) ).

% less_eq_Suc_le
thf(fact_305_less__Suc__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_Suc_eq_le
thf(fact_306_le__less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% le_less_Suc_eq
thf(fact_307_Suc__le__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_lessD
thf(fact_308_inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ J )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% inc_induct
thf(fact_309_dec__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ I2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_310_Suc__le__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_eq
thf(fact_311_Suc__leI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_leI
thf(fact_312_less__imp__Suc__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ? [K3: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M @ K3 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_313_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N: nat] :
        ? [K2: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_314_less__add__Suc2,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ M @ I2 ) ) ) ).

% less_add_Suc2
thf(fact_315_less__add__Suc1,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ I2 @ M ) ) ) ).

% less_add_Suc1
thf(fact_316_less__natE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ~ ! [Q3: nat] :
            ( N2
           != ( suc @ ( plus_plus @ nat @ M @ Q3 ) ) ) ) ).

% less_natE
thf(fact_317_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_mult_less_cancel1
thf(fact_318_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_mult_le_cancel1
thf(fact_319_mult__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc
thf(fact_320_Suc__div__le__mono,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ ( divide_divide @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_div_le_mono
thf(fact_321_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N: nat] : ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_322_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_323_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_324_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) ) ) ) ).

% power_gt1
thf(fact_325_Suc__nat__number__of__add,axiom,
    ! [V2: num,N2: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V2 @ one2 ) ) @ N2 ) ) ).

% Suc_nat_number_of_add
thf(fact_326_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_327_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
        ? [X_1: A] : ( ord_less @ A @ X3 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_328_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X3 ) ) ).

% linordered_field_no_lb
thf(fact_329_div__nat__eqI,axiom,
    ! [N2: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N2 )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_330_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_331_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_332_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_333_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_334_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_335_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_336_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_337_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_338_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_339_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_340_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_341_left__add__mult__distrib,axiom,
    ! [I2: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I2 @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_342_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N2 ) ) ) ) ) ).

% less_1_mult
thf(fact_343_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_344_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_345_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_346_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_347_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_348_double__not__eq__Suc__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% double_not_eq_Suc_double
thf(fact_349_Suc__double__not__eq__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_double_not_eq_double
thf(fact_350_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_351_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_352_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_353_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_354_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_355_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_356_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_357_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X2: nat,N: nat] : ( modulo_modulo @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% low_def
thf(fact_358_buildup__nothing__in__leaf,axiom,
    ! [N2: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N2 ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_359_buildup__nothing__in__min__max,axiom,
    ! [N2: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N2 ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_360_zdiv__numeral__Bit0,axiom,
    ! [V2: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_361_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_362_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_363_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_364_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_365_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_366_mod__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = M ) ) ).

% mod_less
thf(fact_367_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_368_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_369_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_370_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_371_Suc__mod__mult__self4,axiom,
    ! [N2: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self4
thf(fact_372_Suc__mod__mult__self3,axiom,
    ! [K: nat,N2: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N2 ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self3
thf(fact_373_Suc__mod__mult__self2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N2 @ K ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self2
thf(fact_374_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self1
thf(fact_375_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_376_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_377_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_378_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N2 ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_379_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_380_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B4: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B4 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A5 @ B4 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_381_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_382_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_383_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_384_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_385_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_386_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B4: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B4 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A5 @ B4 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_387_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_388_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_389_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N2 ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 ) ) ) ).

% power_mod
thf(fact_390_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N2 ) ) ).

% mod_Suc_Suc_eq
thf(fact_391_mod__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% mod_Suc_eq
thf(fact_392_mod__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ M ) ).

% mod_less_eq_dividend
thf(fact_393_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_394_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_395_nat__mod__eq__iff,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N2 )
        = ( modulo_modulo @ nat @ Y @ N2 ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X @ ( times_times @ nat @ N2 @ Q1 ) )
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N2 @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_396_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_397_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_398_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_399_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_400_mod__induct,axiom,
    ! [P: nat > $o,N2: nat,P2: nat,M: nat] :
      ( ( P @ N2 )
     => ( ( ord_less @ nat @ N2 @ P2 )
       => ( ( ord_less @ nat @ M @ P2 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P2 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P2 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_401_mod__Suc__le__divisor,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N2 ) ) @ N2 ) ).

% mod_Suc_le_divisor
thf(fact_402_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ~ ! [S2: nat] :
              ( M
             != ( plus_plus @ nat @ N2 @ ( times_times @ nat @ Q2 @ S2 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_403_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ~ ! [S2: nat] :
              ( N2
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S2 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_404_nat__mod__eq__lemma,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N2 )
        = ( modulo_modulo @ nat @ Y @ N2 ) )
     => ( ( ord_less_eq @ nat @ Y @ X )
       => ? [Q3: nat] :
            ( X
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N2 @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_405_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_406_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_407_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_408_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_409_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_410_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_411_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_412_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_413_mod__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ).

% mod_mult2_eq
thf(fact_414_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_415_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_416_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B5: A] : ( times_times @ A @ B5 @ A4 ) ) ) ) ).

% mult.commute
thf(fact_417_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_418_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_419_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_420_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( K = L2 ) )
         => ( ( plus_plus @ A @ I2 @ K )
            = ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_421_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_422_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_423_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_424_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_425_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_426_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B5: A] : ( plus_plus @ A @ B5 @ A4 ) ) ) ) ).

% add.commute
thf(fact_427_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_428_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_429_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_430_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_431_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( K = L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_432_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_433_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_434_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_435_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_436_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_437_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_438_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
            ? [C4: A] :
              ( B5
              = ( plus_plus @ A @ A4 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_439_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_440_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_441_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_442_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_443_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( K = L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_444_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_445_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_446_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_447_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_448_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_449_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_450_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_451_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_452_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_453_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_454_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_455_div__mod__decomp,axiom,
    ! [A3: nat,N2: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ nat @ A3 @ N2 ) ) ) ).

% div_mod_decomp
thf(fact_456_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_457_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_458_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_459_product__nth,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N2 )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_460_VEBT__internal_OminNull_Osimps_I5_J,axiom,
    ! [Uz: product_prod @ nat @ nat,Va: nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va @ Vb @ Vc ) ) ).

% VEBT_internal.minNull.simps(5)
thf(fact_461_buildup__gives__valid,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N2 ) @ N2 ) ) ).

% buildup_gives_valid
thf(fact_462_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_463_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,X: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ X @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_464_insert__simp__norm,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ Mi @ X )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_465_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_466_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_467_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% deg_not_0
thf(fact_468_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_469_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A,Y: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 @ Y )
      = ( list_update @ A @ Xs @ I2 @ Y ) ) ).

% list_update_overwrite
thf(fact_470_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less_eq @ A @ N2 @ ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_471_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_472_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_473_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_474_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_475_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_476_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_477_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_478_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_479_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_480_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_481_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_482_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_483_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_484_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_485_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_486_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_487_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_488_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_489_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_490_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_491_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_492_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_493_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_494_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_495_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_496_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_497_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_498_less__nat__zero__code,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_499_neq0__conv,axiom,
    ! [N2: nat] :
      ( ( ( N2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% neq0_conv
thf(fact_500_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_501_le0,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% le0
thf(fact_502_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_503_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_504_add__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_505_mult__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N2 @ K ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_506_mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_507_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_508_mult__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_509_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N2: nat,Y: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N2 @ Y ) )
      = ( ( M = N2 )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_510_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I2 @ X ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_511_max__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ M @ N2 ) ) ) ).

% max_Suc_Suc
thf(fact_512_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_513_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_514_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_515_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_516_max__0L,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% max_0L
thf(fact_517_max__0R,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ N2 @ ( zero_zero @ nat ) )
      = N2 ) ).

% max_0R
thf(fact_518_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ I2 ) )
      = Xs ) ).

% list_update_id
thf(fact_519_nth__list__update__neq,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A,X: A] :
      ( ( I2 != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% nth_list_update_neq
thf(fact_520_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_521_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_522_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_523_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_524_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_525_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_526_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_527_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_528_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_529_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_530_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_531_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_532_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_533_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_534_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_535_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_536_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_537_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_538_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_539_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_540_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_541_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_542_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_543_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_544_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_545_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_546_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_547_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_548_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_549_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_550_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_551_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_552_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_553_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_554_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_555_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_556_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N2 ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_557_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_558_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_559_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_560_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_561_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_562_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_563_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_564_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_565_zmod__numeral__Bit0,axiom,
    ! [V2: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_566_less__Suc0,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_567_zero__less__Suc,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ).

% zero_less_Suc
thf(fact_568_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_569_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_570_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_571_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_572_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_573_add__gr__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% add_gr_0
thf(fact_574_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_575_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_576_one__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_577_mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_578_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_579_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% mult_less_cancel2
thf(fact_580_nat__0__less__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% nat_0_less_mult_iff
thf(fact_581_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_582_less__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( one_one @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_583_div__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_584_power__Suc__0,axiom,
    ! [N2: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_585_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_586_nat__zero__less__power__iff,axiom,
    ! [X: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_587_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_588_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_589_Ball__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
           => ( P @ X2 ) ) )
      = ( ( P @ A2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_590_Bex__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
            & ( P @ X2 ) ) )
      = ( ( P @ A2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_591_in__set__replicate,axiom,
    ! [A: $tType,X: A,N2: nat,Y: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N2 @ Y ) ) )
      = ( ( X = Y )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_592_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 )
     => ( ( list_update @ A @ Xs @ I2 @ X )
        = Xs ) ) ).

% list_update_beyond
thf(fact_593_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_594_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_595_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_596_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_597_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_598_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_599_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_600_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_601_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_602_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_603_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_604_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_605_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_606_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_607_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_608_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_609_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_610_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% power_eq_0_iff
thf(fact_611_one__le__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) ) ).

% one_le_mult_iff
thf(fact_612_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_613_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% mult_le_cancel2
thf(fact_614_div__mult__self__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N2 ) @ N2 )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_615_div__mult__self1__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N2 @ M ) @ N2 )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_616_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 )
        = X ) ) ).

% nth_list_update_eq
thf(fact_617_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_618_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_619_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_620_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_621_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less @ nat @ N2 @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_622_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_623_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_624_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_625_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_626_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_627_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less_eq @ nat @ N2 @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_628_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_629_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_630_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_631_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_632_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_633_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_634_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_635_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_636_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_637_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_638_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_639_div__mod__decomp__int,axiom,
    ! [A3: int,N2: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ int @ A3 @ N2 ) ) ) ).

% div_mod_decomp_int
thf(fact_640_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_641_list__update__swap,axiom,
    ! [A: $tType,I2: nat,I5: nat,Xs: list @ A,X: A,X6: A] :
      ( ( I2 != I5 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I5 @ X6 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I5 @ X6 ) @ I2 @ X ) ) ) ).

% list_update_swap
thf(fact_642_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_643_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) )] :
      ~ ! [F3: nat > A > A,A6: nat,B6: nat,Acc: A] :
          ( X
         != ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A6 @ ( product_Pair @ nat @ A @ B6 @ Acc ) ) ) ) ).

% fold_atLeastAtMost_nat.cases
thf(fact_644_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_645_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_646_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_647_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_648_nat__add__max__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_649_nat__add__max__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N2 @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_650_nat__mult__max__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N2 ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_651_nat__mult__max__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_652_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_653_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_654_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_655_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E2: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
                & ( ord_less @ A @ E2 @ D1 )
                & ( ord_less @ A @ E2 @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_656_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_657_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( ( N2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_658_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ M @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_659_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_660_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) ).

% gr_zeroI
thf(fact_661_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_neq_numeral
thf(fact_662_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_663_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_664_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_665_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_666_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_667_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_668_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_669_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_670_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_671_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_672_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_673_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ( ( X
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va2: nat] :
              ( X
             != ( suc @ ( suc @ Va2 ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_674_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_675_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_676_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_677_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_678_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ! [Nat4: nat] :
            ( Y
           != ( suc @ Nat4 ) ) ) ).

% old.nat.exhaust
thf(fact_679_nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N2 ) ) ) ).

% nat_induct
thf(fact_680_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [X5: nat] : ( P @ X5 @ ( zero_zero @ nat ) )
     => ( ! [Y3: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y3 ) )
       => ( ! [X5: nat,Y3: nat] :
              ( ( P @ X5 @ Y3 )
             => ( P @ ( suc @ X5 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N2 ) ) ) ) ).

% diff_induct
thf(fact_681_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_682_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_683_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_684_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_685_not0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_686_infinite__descent0__measure,axiom,
    ! [A: $tType,V: A > nat,P: A > $o,X: A] :
      ( ! [X5: A] :
          ( ( ( V @ X5 )
            = ( zero_zero @ nat ) )
         => ( P @ X5 ) )
     => ( ! [X5: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X5 ) )
           => ( ~ ( P @ X5 )
             => ? [Y4: A] :
                  ( ( ord_less @ nat @ ( V @ Y4 ) @ ( V @ X5 ) )
                  & ~ ( P @ Y4 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_687_infinite__descent0,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N3 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N2 ) ) ) ).

% infinite_descent0
thf(fact_688_gr__implies__not0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_689_less__zeroE,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_690_not__less0,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_691_not__gr0,axiom,
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_692_gr0I,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% gr0I
thf(fact_693_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_694_le__0__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_695_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_696_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_697_less__eq__nat_Osimps_I1_J,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% less_eq_nat.simps(1)
thf(fact_698_add__eq__self__zero,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = M )
     => ( N2
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_699_plus__nat_Oadd__0,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% plus_nat.add_0
thf(fact_700_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N2 ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_701_mult__0,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_702_vebt__member_Osimps_I2_J,axiom,
    ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ X ) ).

% vebt_member.simps(2)
thf(fact_703_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_704_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N2 )
                  = ( power_power @ A @ B2 @ N2 ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_705_VEBT__internal_OminNull_Osimps_I4_J,axiom,
    ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] : ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) ) ).

% VEBT_internal.minNull.simps(4)
thf(fact_706_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_707_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ A,X: A,I2: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ A3 ) ) ) ).

% set_update_subsetI
thf(fact_708_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_709_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_le_numeral
thf(fact_710_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_711_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_712_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_713_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_714_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_715_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_716_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_717_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_718_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_719_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_720_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_721_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_722_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_723_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_724_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_725_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_726_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_727_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_728_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_less_numeral
thf(fact_729_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_730_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_731_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_732_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_733_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_734_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_735_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_736_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_737_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_738_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_739_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_740_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_741_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_742_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_743_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_744_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_745_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_746_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_747_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_748_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_749_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_750_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_751_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_752_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_753_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_754_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_755_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_756_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_757_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_758_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_759_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_760_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_761_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_762_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_763_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_764_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_765_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_766_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_767_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_768_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_769_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_770_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_771_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_772_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_773_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_774_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_775_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_neg_neg
thf(fact_776_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_777_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_778_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_pos_pos
thf(fact_779_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_780_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_781_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_782_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_783_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_784_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_power
thf(fact_785_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono
thf(fact_786_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_less_power
thf(fact_787_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_788_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_789_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_790_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_791_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_792_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_793_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W @ Z2 ) )
              = ( ( times_times @ A @ X @ Z2 )
                = ( times_times @ A @ W @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_794_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_795_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_796_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_797_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_798_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_799_Ex__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
            & ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
            & ( P @ ( suc @ I3 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_800_gr0__conv__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( ? [M3: nat] :
            ( N2
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_801_All__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
           => ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
           => ( P @ ( suc @ I3 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_802_gr0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_803_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N2 ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_804_add__is__1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_805_one__is__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_806_ex__least__nat__le,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N2 )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K3 )
               => ~ ( P @ I ) )
            & ( P @ K3 ) ) ) ) ).

% ex_least_nat_le
thf(fact_807_less__imp__add__positive,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ? [K3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K3 )
          & ( ( plus_plus @ nat @ I2 @ K3 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_808_div__less__mono,axiom,
    ! [A3: nat,B3: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( modulo_modulo @ nat @ A3 @ N2 )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B3 @ N2 )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ ( divide_divide @ nat @ B3 @ N2 ) ) ) ) ) ) ).

% div_less_mono
thf(fact_809_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N2 ) )
        = ( M = N2 ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_810_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel1
thf(fact_811_mult__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_812_mult__less__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_813_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_814_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_815_nat__power__less__imp__less,axiom,
    ! [I2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_power_less_imp_less
thf(fact_816_mod__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
          = N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
         != N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ).

% mod_Suc
thf(fact_817_mult__eq__self__implies__10,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N2 ) )
     => ( ( N2
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_818_mod__less__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_less_divisor
thf(fact_819_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_820_vebt__member_Osimps_I3_J,axiom,
    ! [V2: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X ) ).

% vebt_member.simps(3)
thf(fact_821_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) ) ).

% vebt_insert.simps(2)
thf(fact_822_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_823_set__update__memI,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X ) ) ) ) ).

% set_update_memI
thf(fact_824_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_825_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_826_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I2 @ X )
          = Xs )
        = ( ( nth @ A @ Xs @ I2 )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_827_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I2 = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = X ) )
        & ( ( I2 != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_828_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_829_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_830_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_831_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_832_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_833_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_834_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_835_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_836_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_837_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_838_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_839_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_840_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_841_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_842_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_843_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y @ E2 ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_epsilon
thf(fact_844_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_845_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_846_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_847_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_848_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_849_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_850_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_851_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_852_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_853_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_854_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_855_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_856_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_857_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_858_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_859_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_860_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_861_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_862_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_863_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_864_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_865_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_866_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_867_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_868_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_869_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_870_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_871_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_872_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_873_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_874_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_875_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_876_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_877_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_878_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_879_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_880_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_881_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_882_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_883_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_884_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_885_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_886_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_887_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_888_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_889_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_890_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_891_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_892_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_893_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_894_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
            = ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_895_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_896_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_897_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_898_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_899_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_900_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_901_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M7: nat] :
      ( ( P @ X )
     => ( ! [X5: nat] :
            ( ( P @ X5 )
           => ( ord_less_eq @ nat @ X5 @ M7 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X3: nat] :
                    ( ( P @ X3 )
                   => ( ord_less_eq @ nat @ X3 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_902_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_903_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_904_vebt__member_Osimps_I4_J,axiom,
    ! [V2: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X ) ).

% vebt_member.simps(4)
thf(fact_905_ex__least__nat__less,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less @ nat @ K3 @ N2 )
            & ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ K3 )
               => ~ ( P @ I ) )
            & ( P @ ( suc @ K3 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_906_one__less__mult,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% one_less_mult
thf(fact_907_n__less__m__mult__n,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% n_less_m_mult_n
thf(fact_908_n__less__n__mult__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ N2 @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_909_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_910_nat__induct__non__zero,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_non_zero
thf(fact_911_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel1
thf(fact_912_power__gt__expt,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N2 @ K ) ) ) ).

% power_gt_expt
thf(fact_913_div__greater__zero__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ N2 @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% div_greater_zero_iff
thf(fact_914_div__le__mono2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N2 ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_915_nat__one__le__power,axiom,
    ! [I2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I2 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I2 @ N2 ) ) ) ).

% nat_one_le_power
thf(fact_916_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( divide_divide @ nat @ M @ N2 ) ) ) ).

% nat_mult_div_cancel1
thf(fact_917_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N2 )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_918_div__less__dividend,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ) ) ).

% div_less_dividend
thf(fact_919_div__eq__dividend__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N2 )
          = M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_920_mod__le__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_le_divisor
thf(fact_921_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) ) ).

% vebt_insert.simps(3)
thf(fact_922_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z4: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z4 )
             => ( ( ord_less @ A @ Z4 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z4 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_923_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_924_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_925_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_926_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_927_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_928_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_929_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_930_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_931_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_932_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_933_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_934_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_935_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_936_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_937_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_938_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_939_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_940_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_941_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_942_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_943_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_944_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_945_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_946_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_Suc_less
thf(fact_947_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_948_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_949_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_950_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_decreasing
thf(fact_951_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_952_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% self_le_power
thf(fact_953_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power
thf(fact_954_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_955_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_956_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N2 @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N2 ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_957_dividend__less__times__div,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_958_dividend__less__div__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) ) ) ) ).

% dividend_less_div_times
thf(fact_959_split__div,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I3 ) @ J3 ) )
               => ( P @ I3 ) ) ) ) ) ) ).

% split_div
thf(fact_960_split__mod,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I3 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_961_verit__le__mono__div,axiom,
    ! [A3: nat,B3: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N2 )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B3 @ N2 )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B3 @ N2 ) ) ) ) ).

% verit_le_mono_div
thf(fact_962_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ X )
      = ( ( X = Mi )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_963_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_964_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_965_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_966_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_967_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_968_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% power2_le_imp_le
thf(fact_969_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_970_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_971_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_972_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_973_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_974_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_975_less__2__cases__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_976_less__2__cases,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_977_nat__induct2,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct2
thf(fact_978_vebt__insert_Osimps_I4_J,axiom,
    ! [V2: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V2 ) ) @ TreeList2 @ Summary ) @ X )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ X ) ) @ ( suc @ ( suc @ V2 ) ) @ TreeList2 @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_979_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_980_Suc__times__mod__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N2 ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_981_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% power2_less_imp_less
thf(fact_982_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_983_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_984_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_985_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_986_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_987_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_988_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% zero_le_even_power'
thf(fact_989_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B4: B,A5: B] :
          ( ( ~ ( ord_less_eq @ B @ B4 @ A5 ) )
          = ( ord_less @ B @ A5 @ B4 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_990_nat__bit__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_bit_induct
thf(fact_991_Suc__n__div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_992_div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_993_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_994_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_995_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_996_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_997_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_998_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_999_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1000_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_1001_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1002_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_1003_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A1: vEBT_VEBT,A22: nat] :
          ( ( ? [A4: $o,B5: $o] :
                ( A1
                = ( vEBT_Leaf @ A4 @ B5 ) )
            & ( A22
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N ) )
              & ( vEBT_invar_vebt @ Summary2 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A22
                = ( plus_plus @ nat @ N @ N ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A22
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N ) )
              & ( vEBT_invar_vebt @ Summary2 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A22
                = ( plus_plus @ nat @ N @ N ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
              & ( ( Mi2 = Ma2 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi2 != Ma2 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma2 @ N ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A22
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
              & ( ( Mi2 = Ma2 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi2 != Ma2 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma2 @ N ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_1004_invar__vebt_Ocases,axiom,
    ! [A12: vEBT_VEBT,A23: nat] :
      ( ( vEBT_invar_vebt @ A12 @ A23 )
     => ( ( ? [A6: $o,B6: $o] :
              ( A12
              = ( vEBT_Leaf @ A6 @ B6 ) )
         => ( A23
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( A23 = Deg2 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X3 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M4 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                           => ~ ! [X3: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A12
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( A23 = Deg2 )
                 => ( ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X3 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M4 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                             => ~ ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                  ( ( A12
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                 => ( ( A23 = Deg2 )
                   => ( ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X3 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M4 ) )
                             => ( ! [I: nat] :
                                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X4 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                               => ( ( ( Mi3 = Ma3 )
                                   => ! [X3: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                   => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi3 != Ma3 )
                                         => ! [I: nat] :
                                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                                                    = I )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                                                & ! [X3: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                                                        = I )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi3 @ X3 )
                                                      & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                    ( ( A12
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                   => ( ( A23 = Deg2 )
                     => ( ! [X3: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X3 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M4 ) )
                               => ( ! [I: nat] :
                                      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X4 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary3 @ I ) ) )
                                 => ( ( ( Mi3 = Ma3 )
                                     => ! [X3: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                     => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi3 != Ma3 )
                                           => ! [I: nat] :
                                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                                                      = I )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                                                  & ! [X3: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                                                          = I )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi3 @ X3 )
                                                        & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_1005_not__Some__eq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ! [Y5: A] :
            ( X
           != ( some @ A @ Y5 ) ) )
      = ( X
        = ( none @ A ) ) ) ).

% not_Some_eq
thf(fact_1006_not__None__eq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ( X
         != ( none @ A ) ) )
      = ( ? [Y5: A] :
            ( X
            = ( some @ A @ Y5 ) ) ) ) ).

% not_None_eq
thf(fact_1007_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            & ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_1008_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_1009_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_1010_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_1011_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_1012_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_1013_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_1014_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A4: $o,B5: $o] :
            ( T2
            = ( vEBT_Leaf @ A4 @ B5 ) ) ) ) ).

% deg1Leaf
thf(fact_1015_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A6: $o,B6: $o] :
          ( T2
          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ).

% deg_1_Leaf
thf(fact_1016_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( N2
          = ( one_one @ nat ) )
       => ? [A6: $o,B6: $o] :
            ( T2
            = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ).

% deg_1_Leafy
thf(fact_1017_option_Oinject,axiom,
    ! [A: $tType,X22: A,Y22: A] :
      ( ( ( some @ A @ X22 )
        = ( some @ A @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% option.inject
thf(fact_1018_div__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1019_div__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1020_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_1021_mod__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1022_mod__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1023_i0__less,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( ( N2
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_1024_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_1025_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_1026_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_1027_split__zmod,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1028_q__pos__lemma,axiom,
    ! [B4: int,Q5: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B4 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B4 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_1029_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1030_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1031_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B4: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B4 @ Q5 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B4 @ Q5 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B4 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
             => ( ( ord_less_eq @ int @ B4 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1032_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B4: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B4 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B4 @ Q5 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
             => ( ( ord_less_eq @ int @ B4 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1033_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1034_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1035_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1036_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M
          = ( times_times @ int @ D2 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_1037_mod__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( plus_plus @ int @ K @ L2 ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1038_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L2 ) @ L2 ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1039_neg__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L2 @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% neg_mod_bound
thf(fact_1040_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1041_neg__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L2 ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1042_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1043_zmod__trivial__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( modulo_modulo @ int @ I2 @ K )
        = I2 )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1044_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1045_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1046_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_1047_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_1048_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_1049_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,Deg3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_1050_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_1051_VEBT__internal_OminNull_Osimps_I3_J,axiom,
    ! [Uu: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ Uu @ $true ) ) ).

% VEBT_internal.minNull.simps(3)
thf(fact_1052_VEBT__internal_OminNull_Osimps_I2_J,axiom,
    ! [Uv: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ $true @ Uv ) ) ).

% VEBT_internal.minNull.simps(2)
thf(fact_1053_VEBT__internal_OminNull_Osimps_I1_J,axiom,
    vEBT_VEBT_minNull @ ( vEBT_Leaf @ $false @ $false ) ).

% VEBT_internal.minNull.simps(1)
thf(fact_1054_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1055_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1056_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1057_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1058_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1059_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I2 @ K ) )
        = ( ord_less_eq @ int @ K @ I2 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1060_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1061_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1062_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1063_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1064_verit__le__mono__div__int,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N2 )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B3 @ N2 )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B3 @ N2 ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1065_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1066_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1067_div__positive__int,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ L2 @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) ) ) ) ).

% div_positive_int
thf(fact_1068_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1069_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1070_div__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L2
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1071_zdiv__mono2__neg,axiom,
    ! [A2: int,B4: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
       => ( ( ord_less_eq @ int @ B4 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B4 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1072_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A5 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1073_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1074_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1075_zdiv__eq__0__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( divide_divide @ int @ I2 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1076_zdiv__mono__strict,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( ( modulo_modulo @ int @ A3 @ N2 )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B3 @ N2 )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A3 @ N2 ) @ ( divide_divide @ int @ B3 @ N2 ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1077_zdiv__mono2,axiom,
    ! [A2: int,B4: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
       => ( ( ord_less_eq @ int @ B4 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B4 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1078_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A5 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1079_split__zdiv,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 ) ) ) ) ) ).

% split_zdiv
thf(fact_1080_not__iless0,axiom,
    ! [N2: extended_enat] :
      ~ ( ord_less @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_1081_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N2 ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ) ) ).

% enat_0_less_mult_iff
thf(fact_1082_i0__lb,axiom,
    ! [N2: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ).

% i0_lb
thf(fact_1083_ile0__eq,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = ( N2
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_1084_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_1085_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) @ X5 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_1086_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_1087_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_1088_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_1089_vebt__insert_Osimps_I1_J,axiom,
    ! [X: nat,A2: $o,B2: $o] :
      ( ( ( X
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X
         != ( zero_zero @ nat ) )
       => ( ( ( X
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_1090_VEBT__internal_OminNull_Ocases,axiom,
    ! [X: vEBT_VEBT] :
      ( ( X
       != ( vEBT_Leaf @ $false @ $false ) )
     => ( ! [Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv2 ) )
       => ( ! [Uu2: $o] :
              ( X
             != ( vEBT_Leaf @ Uu2 @ $true ) )
         => ( ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
           => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.cases
thf(fact_1091_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_1092_VEBT__internal_OminNull_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X )
     => ( ! [Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv2 ) )
       => ( ! [Uu2: $o] :
              ( X
             != ( vEBT_Leaf @ Uu2 @ $true ) )
         => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ).

% VEBT_internal.minNull.elims(3)
thf(fact_1093_VEBT__internal_OminNull_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X )
     => ( ( X
         != ( vEBT_Leaf @ $false @ $false ) )
       => ~ ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) ) ) ) ).

% VEBT_internal.minNull.elims(2)
thf(fact_1094_not__exp__less__eq__0__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_1095_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1096_realpow__pos__nth2,axiom,
    ! [A2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
          & ( ( power_power @ real @ R4 @ ( suc @ N2 ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_1097_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N3 ) @ Y ) ) ) ).

% real_arch_pow_inv
thf(fact_1098_VEBT__internal_OminNull_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Y: $o] :
      ( ( ( vEBT_VEBT_minNull @ X )
        = Y )
     => ( ( ( X
            = ( vEBT_Leaf @ $false @ $false ) )
         => ~ Y )
       => ( ( ? [Uv2: $o] :
                ( X
                = ( vEBT_Leaf @ $true @ Uv2 ) )
           => Y )
         => ( ( ? [Uu2: $o] :
                  ( X
                  = ( vEBT_Leaf @ Uu2 @ $true ) )
             => Y )
           => ( ( ? [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
               => ~ Y )
             => ~ ( ? [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) )
                 => Y ) ) ) ) ) ) ).

% VEBT_internal.minNull.elims(1)
thf(fact_1099_realpow__pos__nth__unique,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X5 )
            & ( ( power_power @ real @ X5 @ N2 )
              = A2 )
            & ! [Y4: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ( power_power @ real @ Y4 @ N2 )
                    = A2 ) )
               => ( Y4 = X5 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_1100_realpow__pos__nth,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ( ( power_power @ real @ R4 @ N2 )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_1101_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1102_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1103_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X5 ) )
         => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ X5 ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ X5 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1104_vebt__insert_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT,X5: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) @ X5 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) @ X5 ) )
         => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) @ X5 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ X5 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_1105_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X5: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X5 ) )
       => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X5 ) )
         => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X5 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ X5 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_1106_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_1107_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_1108_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_1109_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_1110_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_1111_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B5 ) ) ) ) ) ).

% max.order_iff
thf(fact_1112_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_1113_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_1114_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z2 @ X )
            | ( ord_less_eq @ A @ Z2 @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_1115_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B5 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_1116_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_max @ A @ A4 @ B5 )
              = B5 ) ) ) ) ).

% max.absorb_iff2
thf(fact_1117_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_1118_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_1119_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            | ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_1120_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_1121_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( A4
                = ( ord_max @ A @ A4 @ B5 ) )
              & ( A4 != B5 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_1122_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_1123_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_1124_option_Odistinct_I1_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( none @ A )
     != ( some @ A @ X22 ) ) ).

% option.distinct(1)
thf(fact_1125_option_OdiscI,axiom,
    ! [A: $tType,Option: option @ A,X22: A] :
      ( ( Option
        = ( some @ A @ X22 ) )
     => ( Option
       != ( none @ A ) ) ) ).

% option.discI
thf(fact_1126_option_Oexhaust,axiom,
    ! [A: $tType,Y: option @ A] :
      ( ( Y
       != ( none @ A ) )
     => ~ ! [X23: A] :
            ( Y
           != ( some @ A @ X23 ) ) ) ).

% option.exhaust
thf(fact_1127_split__option__ex,axiom,
    ! [A: $tType] :
      ( ( ^ [P3: ( option @ A ) > $o] :
          ? [X7: option @ A] : ( P3 @ X7 ) )
      = ( ^ [P4: ( option @ A ) > $o] :
            ( ( P4 @ ( none @ A ) )
            | ? [X2: A] : ( P4 @ ( some @ A @ X2 ) ) ) ) ) ).

% split_option_ex
thf(fact_1128_split__option__all,axiom,
    ! [A: $tType] :
      ( ( ^ [P3: ( option @ A ) > $o] :
          ! [X7: option @ A] : ( P3 @ X7 ) )
      = ( ^ [P4: ( option @ A ) > $o] :
            ( ( P4 @ ( none @ A ) )
            & ! [X2: A] : ( P4 @ ( some @ A @ X2 ) ) ) ) ) ).

% split_option_all
thf(fact_1129_combine__options__cases,axiom,
    ! [A: $tType,B: $tType,X: option @ A,P: ( option @ A ) > ( option @ B ) > $o,Y: option @ B] :
      ( ( ( X
          = ( none @ A ) )
       => ( P @ X @ Y ) )
     => ( ( ( Y
            = ( none @ B ) )
         => ( P @ X @ Y ) )
       => ( ! [A6: A,B6: B] :
              ( ( X
                = ( some @ A @ A6 ) )
             => ( ( Y
                  = ( some @ B @ B6 ) )
               => ( P @ X @ Y ) ) )
         => ( P @ X @ Y ) ) ) ) ).

% combine_options_cases
thf(fact_1130_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_1131_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_1132_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_1133_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1134_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ ( times_times @ A @ Z2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1135_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_1136_prod__cases4,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ~ ! [A6: A,B6: B,C3: C,D4: D] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C3 @ D4 ) ) ) ) ).

% prod_cases4
thf(fact_1137_prod__cases5,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ~ ! [A6: A,B6: B,C3: C,D4: D,E2: E3] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C3 @ ( product_Pair @ D @ E3 @ D4 @ E2 ) ) ) ) ) ).

% prod_cases5
thf(fact_1138_prod__cases6,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ~ ! [A6: A,B6: B,C3: C,D4: D,E2: E3,F3: F] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E2 @ F3 ) ) ) ) ) ) ).

% prod_cases6
thf(fact_1139_prod__cases7,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,G2: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ~ ! [A6: A,B6: B,C3: C,D4: D,E2: E3,F3: F,G3: G2] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E2 @ ( product_Pair @ F @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ).

% prod_cases7
thf(fact_1140_prod__induct4,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ( ! [A6: A,B6: B,C3: C,D4: D] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C3 @ D4 ) ) ) )
     => ( P @ X ) ) ).

% prod_induct4
thf(fact_1141_old_Oprod_Oinject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
      = ( ( A2 = A5 )
        & ( B2 = B4 ) ) ) ).

% old.prod.inject
thf(fact_1142_prod_Oinject,axiom,
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
thf(fact_1143_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_1144_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_1145_set__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1146_flip__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1147_unset__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_1148_unset__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_1149_flip__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1150_set__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1151_zle__add1__eq__le,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z2 ) ) ).

% zle_add1_eq_le
thf(fact_1152_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1153_int__one__le__iff__zero__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% int_one_le_iff_zero_less
thf(fact_1154_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_1155_iadd__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_1156_imult__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_1157_set__bit__greater__eq,axiom,
    ! [K: int,N2: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) ) ).

% set_bit_greater_eq
thf(fact_1158_unset__bit__less__eq,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_1159_Pair__inject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B4 ) ) ) ).

% Pair_inject
thf(fact_1160_prod__cases,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,P2: product_prod @ A @ B] :
      ( ! [A6: A,B6: B] : ( P @ ( product_Pair @ A @ B @ A6 @ B6 ) )
     => ( P @ P2 ) ) ).

% prod_cases
thf(fact_1161_surj__pair,axiom,
    ! [A: $tType,B: $tType,P2: product_prod @ A @ B] :
    ? [X5: A,Y3: B] :
      ( P2
      = ( product_Pair @ A @ B @ X5 @ Y3 ) ) ).

% surj_pair
thf(fact_1162_old_Oprod_Oexhaust,axiom,
    ! [A: $tType,B: $tType,Y: product_prod @ A @ B] :
      ~ ! [A6: A,B6: B] :
          ( Y
         != ( product_Pair @ A @ B @ A6 @ B6 ) ) ).

% old.prod.exhaust
thf(fact_1163_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N2 )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1164_zmult__zless__mono2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I2 ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_1165_zless__imp__add1__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ Z2 )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 ) ) ).

% zless_imp_add1_zle
thf(fact_1166_zless__add1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z2 )
        | ( W = Z2 ) ) ) ).

% zless_add1_eq
thf(fact_1167_int__gr__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I2 )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I4: int] :
              ( ( ord_less @ int @ K @ I4 )
             => ( ( P @ I4 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_gr_induct
thf(fact_1168_int__ge__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I2 )
     => ( ( P @ K )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ K @ I4 )
             => ( ( P @ I4 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_ge_induct
thf(fact_1169_add1__zle__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% add1_zle_eq
thf(fact_1170_odd__nonzero,axiom,
    ! [Z2: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1171_le__imp__0__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% le_imp_0_less
thf(fact_1172_odd__less__0__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1173_prod__induct3,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ C )] :
      ( ! [A6: A,B6: B,C3: C] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C3 ) ) )
     => ( P @ X ) ) ).

% prod_induct3
thf(fact_1174_prod__cases3,axiom,
    ! [A: $tType,B: $tType,C: $tType,Y: product_prod @ A @ ( product_prod @ B @ C )] :
      ~ ! [A6: A,B6: B,C3: C] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C3 ) ) ) ).

% prod_cases3
thf(fact_1175_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_1176_prod__induct7,axiom,
    ! [G2: $tType,F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ( ! [A6: A,B6: B,C3: C,D4: D,E2: E3,F3: F,G3: G2] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E2 @ ( product_Pair @ F @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct7
thf(fact_1177_prod__induct6,axiom,
    ! [F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ( ! [A6: A,B6: B,C3: C,D4: D,E2: E3,F3: F] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct6
thf(fact_1178_prod__induct5,axiom,
    ! [E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ( ! [A6: A,B6: B,C3: C,D4: D,E2: E3] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C3 @ ( product_Pair @ D @ E3 @ D4 @ E2 ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct5
thf(fact_1179_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int] :
            ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X3: int] :
              ( ( P @ X3 )
             => ( P @ ( plus_plus @ int @ X3 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1180_old_Oprod_Orec,axiom,
    ! [A: $tType,T: $tType,B: $tType,F1: A > B > T,A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) ).

% old.prod.rec
thf(fact_1181_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1182_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M4 @ N3 ) )
             => ( P @ M4 @ N3 ) ) )
       => ( P @ M @ N2 ) ) ) ).

% gcd_nat_induct
thf(fact_1183_concat__bit__Suc,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_concat_bit @ ( suc @ N2 ) @ K @ L2 )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N2 @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L2 ) ) ) ) ).

% concat_bit_Suc
thf(fact_1184_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1185_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N2: nat] :
      ( ( P @ K )
     => ( ! [X5: A] :
            ( ( P @ X5 )
           => ? [Y4: A] :
                ( ( P @ Y4 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X5 ) ) ) )
       => ? [Y3: A] :
            ( ( P @ Y3 )
            & ~ ( ord_less @ nat @ ( F2 @ Y3 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N2 ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1186_concat__bit__0,axiom,
    ! [K: int,L2: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L2 )
      = L2 ) ).

% concat_bit_0
thf(fact_1187_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1188_concat__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N2 @ K @ L2 ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1189_concat__bit__negative__iff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N2 @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1190_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1191_unique__remainder,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R3 ) )
       => ( R = R3 ) ) ) ).

% unique_remainder
thf(fact_1192_unique__quotient,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R3 ) )
       => ( Q2 = Q5 ) ) ) ).

% unique_quotient
thf(fact_1193_concat__bit__assoc,axiom,
    ! [N2: nat,K: int,M: nat,L2: int,R: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( bit_concat_bit @ M @ L2 @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_concat_bit @ N2 @ K @ L2 ) @ R ) ) ).

% concat_bit_assoc
thf(fact_1194_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1195_div__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = Q2 ) ) ).

% div_int_unique
thf(fact_1196_mod__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
        = R ) ) ).

% mod_int_unique
thf(fact_1197_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ X2 @ X2 ) ) ) ) ).

% dbl_def
thf(fact_1198_eucl__rel__int__dividesI,axiom,
    ! [L2: int,K: int,Q2: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L2 ) )
       => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1199_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z4: C] :
        ! [X3: C] :
          ( ( ord_less @ C @ X3 @ Z4 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1200_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ~ ( ord_less @ A @ T2 @ X3 ) ) ) ).

% minf(7)
thf(fact_1201_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ( ord_less @ A @ X3 @ T2 ) ) ) ).

% minf(5)
thf(fact_1202_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ( X3 != T2 ) ) ) ).

% minf(4)
thf(fact_1203_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ( X3 != T2 ) ) ) ).

% minf(3)
thf(fact_1204_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P5 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( ( P @ X3 )
                    | ( Q @ X3 ) )
                  = ( ( P5 @ X3 )
                    | ( Q6 @ X3 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1205_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P5 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( ( P @ X3 )
                    & ( Q @ X3 ) )
                  = ( ( P5 @ X3 )
                    & ( Q6 @ X3 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1206_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z4: C] :
        ! [X3: C] :
          ( ( ord_less @ C @ Z4 @ X3 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1207_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ( ord_less @ A @ T2 @ X3 ) ) ) ).

% pinf(7)
thf(fact_1208_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ~ ( ord_less @ A @ X3 @ T2 ) ) ) ).

% pinf(5)
thf(fact_1209_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ( X3 != T2 ) ) ) ).

% pinf(4)
thf(fact_1210_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ( X3 != T2 ) ) ) ).

% pinf(3)
thf(fact_1211_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P5 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( ( P @ X3 )
                    | ( Q @ X3 ) )
                  = ( ( P5 @ X3 )
                    | ( Q6 @ X3 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1212_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P5 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( ( P @ X3 )
                    & ( Q @ X3 ) )
                  = ( ( P5 @ X3 )
                    & ( Q6 @ X3 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1213_eucl__rel__int,axiom,
    ! [K: int,L2: int] : ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L2 ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% eucl_rel_int
thf(fact_1214_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X5: A] :
          ( ( P @ X5 )
          & ! [Y4: A] :
              ( ( P @ Y4 )
             => ( ord_less_eq @ nat @ ( M @ X5 ) @ ( M @ Y4 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_1215_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ~ ( ord_less_eq @ A @ T2 @ X3 ) ) ) ).

% minf(8)
thf(fact_1216_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z4 )
         => ( ord_less_eq @ A @ X3 @ T2 ) ) ) ).

% minf(6)
thf(fact_1217_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ( ord_less_eq @ A @ T2 @ X3 ) ) ) ).

% pinf(8)
thf(fact_1218_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z4 @ X3 )
         => ~ ( ord_less_eq @ A @ X3 @ T2 ) ) ) ).

% pinf(6)
thf(fact_1219_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: A] :
            ( ( P @ Y3 )
           => ( ord_less @ nat @ ( F2 @ Y3 ) @ B2 ) )
       => ? [X5: A] :
            ( ( P @ X5 )
            & ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1220_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A6: nat,B6: nat] :
          ( ( P @ A6 @ B6 )
          = ( P @ B6 @ A6 ) )
     => ( ! [A6: nat] : ( P @ A6 @ ( zero_zero @ nat ) )
       => ( ! [A6: nat,B6: nat] :
              ( ( P @ A6 @ B6 )
             => ( P @ A6 @ ( plus_plus @ nat @ A6 @ B6 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1221_eucl__rel__int__iff,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L2 @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L2 ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L2 @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1222_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1223_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X22: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_1224_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1225_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1226_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1227_vebt__insert_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => ( Y
                    = ( vEBT_Leaf @ $true @ B6 ) ) )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A6 @ $true ) ) )
                    & ( ( Xa2
                       != ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) )
             => ( Y
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) )
               => ( Y
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) ) )
           => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) )
                 => ( Y
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa2 = Mi3 )
                              | ( Xa2 = Ma3 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Xa2 @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_1228_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_1229_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_1230_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L2 ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L2 ) ) ) ) ).

% power_numeral
thf(fact_1231_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_1232_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1233_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1234_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_1235_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1236_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_1237_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1238_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_1239_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1240_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1241_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1242_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_1243_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_1244_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1245_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1246_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1247_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1248_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1249_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1250_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1251_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1252_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1253_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1254_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1255_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1256_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1257_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_1258_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1259_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1260_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1261_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1262_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1263_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1264_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1265_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1266_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1267_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1268_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1269_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1270_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1271_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1272_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1273_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1274_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1275_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1276_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1277_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1278_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1279_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1280_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1281_even__Suc__Suc__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N2 ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% even_Suc_Suc_iff
thf(fact_1282_even__Suc,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_Suc
thf(fact_1283_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1284_zle__diff1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% zle_diff1_eq
thf(fact_1285_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1286_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1287_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1288_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1289_even__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1290_odd__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1291_signed__take__bit__Suc__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1292_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1293_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1294_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1295_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1296_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1297_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1298_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1299_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1300_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1301_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% even_power
thf(fact_1302_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1303_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1304_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1305_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1306_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1307_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1308_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_1309_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1310_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( dvd_dvd @ A @ X @ Z2 )
           => ( dvd_dvd @ A @ X @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ) ).

% dvd_diff
thf(fact_1311_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_1312_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1313_signed__take__bit__diff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_diff
thf(fact_1314_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_1315_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_1316_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_1317_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X2: A] : X2 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_1318_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B5: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B5 ) @ B5 @ A4 ) ) ) ) ).

% max_def_raw
thf(fact_1319_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X3: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X3 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1320_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X3: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X3 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1321_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( A4
                = ( zero_zero @ A ) )
             => ( B5
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1322_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1323_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1324_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1325_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1326_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1327_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [A4: A,B5: A] :
              ( ( minus_minus @ A @ A4 @ B5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1328_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1329_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1330_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1331_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1332_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1333_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1334_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1335_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B5: A,A4: A] :
            ? [K2: A] :
              ( A4
              = ( times_times @ A @ B5 @ K2 ) ) ) ) ) ).

% dvd_def
thf(fact_1336_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1337_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K3: A] :
                ( A2
               != ( times_times @ A @ B2 @ K3 ) ) ) ) ).

% dvdE
thf(fact_1338_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1339_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P2 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X5: A,Y3: A] :
                ( ( P2
                  = ( times_times @ A @ X5 @ Y3 ) )
               => ( ( dvd_dvd @ A @ X5 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1340_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1341_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1342_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1343_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1344_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1345_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1346_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1347_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1348_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1349_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1350_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1351_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1352_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1353_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1354_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X5: A,K3: A] :
              ( ( P @ X5 )
              = ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
         => ( ! [X5: A,K3: A] :
                ( ( Q @ X5 )
                = ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
           => ! [X3: A,K4: A] :
                ( ( ( P @ X3 )
                  & ( Q @ X3 ) )
                = ( ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1355_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X5: A,K3: A] :
              ( ( P @ X5 )
              = ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
         => ( ! [X5: A,K3: A] :
                ( ( Q @ X5 )
                = ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
           => ! [X3: A,K4: A] :
                ( ( ( P @ X3 )
                  | ( Q @ X3 ) )
                = ( ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1356_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1357_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1358_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1359_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1360_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1361_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1362_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1363_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1364_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1365_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1366_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1367_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1368_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1369_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) ) ) ).

% dvd_power_same
thf(fact_1370_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1371_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N2: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N2 )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N2 ) ) ) ) ) ).

% dvd_mod
thf(fact_1372_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1373_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1374_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1375_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1376_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B4: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B4 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A5 @ B4 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1377_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1378_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1379_signed__take__bit__mult,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ K @ L2 ) ) ) ).

% signed_take_bit_mult
thf(fact_1380_signed__take__bit__add,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_add
thf(fact_1381_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_1382_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_code(2)
thf(fact_1383_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_1384_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1385_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_1386_even__diff__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_diff_iff
thf(fact_1387_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1388_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1389_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B5: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1390_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ Z4 @ X3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1391_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ Z4 @ X3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1392_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ X3 @ Z4 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1393_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z4: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ X3 @ Z4 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1394_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1395_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1396_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1397_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1398_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1399_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1400_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1401_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1402_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N2: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
         => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
             => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N2 @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1403_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
         => ( ord_less_eq @ A @ I2 @ ( minus_minus @ A @ N2 @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1404_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1405_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1406_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1407_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1408_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1409_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1410_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1411_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1412_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_1413_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1414_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1415_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1416_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1417_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1418_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1419_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1420_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1421_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1422_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1423_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1424_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1425_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1426_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1427_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1428_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1429_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1430_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1431_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1432_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ A @ X @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_1433_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1434_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% div_power
thf(fact_1435_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1436_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( modulo_modulo @ A @ B5 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1437_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1438_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1439_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1440_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N2: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1441_nat__dvd__not__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1442_dvd__pos__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1443_zdvd__not__zless,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N2 )
       => ~ ( dvd_dvd @ int @ N2 @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1444_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X5: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D4 ) )
        | ( ( times_times @ nat @ B2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D4 ) ) ) ) ).

% bezout_add_nat
thf(fact_1445_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y ) @ D2 ) ) )
         => ? [X5: nat,Y3: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X5 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y3 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X5 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1446_int__le__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I2 @ K )
     => ( ( P @ K )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_le_induct
thf(fact_1447_int__less__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I2 @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I4: int] :
              ( ( ord_less @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_less_induct
thf(fact_1448_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_1449_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_1450_signed__take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1451_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1452_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L2: A] :
          ( ( ? [X2: A] : ( P @ ( times_times @ A @ L2 @ X2 ) ) )
          = ( ? [X2: A] :
                ( ( dvd_dvd @ A @ L2 @ ( plus_plus @ A @ X2 @ ( zero_zero @ A ) ) )
                & ( P @ X2 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1453_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1454_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1455_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1456_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1457_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1458_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ).

% even_numeral
thf(fact_1459_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1460_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1461_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1462_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1463_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1464_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1465_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1466_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1467_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1468_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1469_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1470_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1471_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1472_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1473_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1474_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1475_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1476_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1477_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1478_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1479_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1480_dvd__imp__le,axiom,
    ! [K: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% dvd_imp_le
thf(fact_1481_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1482_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_mult_cancel
thf(fact_1483_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X5: nat,Y3: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X5 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1484_zdvd__imp__le,axiom,
    ! [Z2: int,N2: int] :
      ( ( dvd_dvd @ int @ Z2 @ N2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int @ Z2 @ N2 ) ) ) ).

% zdvd_imp_le
thf(fact_1485_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1486_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P1 @ X5 )
            = ( P1 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X5: int] :
              ( ( ord_less @ int @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P1 @ X5 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_1487_plusinfinity,axiom,
    ! [D2: int,P5: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P5 @ X5 )
            = ( P5 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X5: int] :
              ( ( ord_less @ int @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P5 @ X5 ) ) )
         => ( ? [X_12: int] : ( P5 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_1488_int__induct,axiom,
    ! [P: int > $o,K: int,I2: int] :
      ( ( P @ K )
     => ( ! [I4: int] :
            ( ( ord_less_eq @ int @ K @ I4 )
           => ( ( P @ I4 )
             => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_induct
thf(fact_1489_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% even_mask_div_iff'
thf(fact_1490_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va2: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va2 ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_1491_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% even_mask_div_iff
thf(fact_1492_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1493_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1494_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1495_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1496_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_1497_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1498_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1499_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1500_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [A4: A,B5: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) )
              & ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1501_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1502_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N2: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N2 ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1503_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% dvd_power
thf(fact_1504_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1505_even__even__mod__4__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1506_dvd__mult__cancel1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N2 ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1507_dvd__mult__cancel2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N2 @ M ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1508_power__dvd__imp__le,axiom,
    ! [I2: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N2 ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I2 )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% power_dvd_imp_le
thf(fact_1509_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int] :
            ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X3: int] :
              ( ( P @ X3 )
             => ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1510_mod__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( ( L2
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% mod_int_pos_iff
thf(fact_1511_mod__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) ) ) ) ).

% mod_pos_geq
thf(fact_1512_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1513_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V2: A,R: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V2 @ U ) ) @ S ) ) @ V2 ) ) ) ) ) ).

% scaling_mono
thf(fact_1514_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1515_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1516_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_odd
thf(fact_1517_odd__pos,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% odd_pos
thf(fact_1518_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% dvd_power_iff_le
thf(fact_1519_signed__take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1520_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1521_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1522_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1523_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_1524_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V2: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V2 ) @ TreeList2 @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_1525_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1526_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1527_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1528_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_even_power
thf(fact_1529_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1530_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1531_signed__take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1532_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1533_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V2: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V2 ) @ TreeList2 @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_1534_div__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1535_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V2: nat,TreeList2: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V2 ) @ TreeList2 @ Vc ) @ X )
      = ( ( X = Mi )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_1536_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( ( X != Mi )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi )
            & ( ~ ( ord_less @ nat @ X @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_1537_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_1538_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_1539_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y: A,X: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y ) @ ( times_times @ A @ X @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z2 ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W = X )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_1540_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_1541_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1542_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
               => ( Y
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_1543_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_1544_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_1545_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Mi3: nat,Ma3: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa2 = Mi3 )
                | ( Xa2 = Ma3 ) ) )
       => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa2 = Mi3 )
                  | ( Xa2 = Ma3 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_1546_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1547_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1548_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
             => ~ ( ( Xa2 != Mi3 )
                 => ( ( Xa2 != Ma3 )
                   => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                      & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                       => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                          & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_1549_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_1550_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y
                  = ( ~ ( ( Xa2 = Mi3 )
                        | ( Xa2 = Ma3 ) ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( Y
                    = ( ~ ( ( Xa2 = Mi3 )
                          | ( Xa2 = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( Y
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_1551_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa2 = Mi3 )
                  | ( Xa2 = Ma3 ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa2 = Mi3 )
                    | ( Xa2 = Ma3 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_1552_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
          & ~ ( ( X = Mi )
              | ( X = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ X @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ Ma ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_1553_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => Y )
         => ( ( ? [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y )
           => ( ( ? [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y )
             => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y
                      = ( ~ ( ( Xa2 != Mi3 )
                           => ( ( Xa2 != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_1554_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
         => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Xa2 != Mi3 )
                     => ( ( Xa2 != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_1555_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1556_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L2: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L2 ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1557_vebt__insert_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => ( Y
                      = ( vEBT_Leaf @ $true @ B6 ) ) )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A6 @ $true ) ) )
                      & ( ( Xa2
                         != ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) )
               => ( ( Y
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S2 ) @ Xa2 ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) )
                 => ( ( Y
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) @ Xa2 ) ) ) )
             => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Y
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary3 ) @ Xa2 ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa2 = Mi3 )
                                  | ( Xa2 = Ma3 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Xa2 @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi3 ) @ Mi3 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_1558_div2__even__ext__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y ) )
       => ( X = Y ) ) ) ).

% div2_even_ext_nat
thf(fact_1559_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa2 ) ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y
                          = ( ( Xa2 != Mi3 )
                           => ( ( Xa2 != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_1560_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa2 ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ Xa2 ) )
                       => ( ( Xa2 != Mi3 )
                         => ( ( Xa2 != Ma3 )
                           => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                              & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                               => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                  & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_1561_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi3: nat,Ma3: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary3 ) @ Xa2 ) )
                 => ~ ( ( Xa2 != Mi3 )
                     => ( ( Xa2 != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_1562_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa2 ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y
                      = ( ( Xa2 = Mi3 )
                        | ( Xa2 = Ma3 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y
                        = ( ( Xa2 = Mi3 )
                          | ( Xa2 = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( Y
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_1563_Suc__diff__diff,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1564_diff__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_Suc_Suc
thf(fact_1565_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1566_diff__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1567_diff__diff__cancel,axiom,
    ! [I2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ N2 )
     => ( ( minus_minus @ nat @ N2 @ ( minus_minus @ nat @ N2 @ I2 ) )
        = I2 ) ) ).

% diff_diff_cancel
thf(fact_1568_diff__diff__left,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_1569_idiff__0__right,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = N2 ) ).

% idiff_0_right
thf(fact_1570_idiff__0,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1571_zero__less__diff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% zero_less_diff
thf(fact_1572_diff__is__0__eq_H,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1573_diff__is__0__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% diff_is_0_eq
thf(fact_1574_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1575_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1576_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_1577_diff__Suc__1,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( one_one @ nat ) )
      = N2 ) ).

% diff_Suc_1
thf(fact_1578_Suc__pred,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% Suc_pred
thf(fact_1579_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1580_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I2 )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1581_Suc__diff__1,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
        = N2 ) ) ).

% Suc_diff_1
thf(fact_1582_odd__Suc__minus__one,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% odd_Suc_minus_one
thf(fact_1583_even__diff__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ).

% even_diff_nat
thf(fact_1584_odd__two__times__div__two__nat,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1585_dvd__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% dvd_antisym
thf(fact_1586_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% dvd_diff_nat
thf(fact_1587_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I2: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I2 ) ) ) ) ).

% zero_induct_lemma
thf(fact_1588_diffs0__imp__equal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N2 @ M )
          = ( zero_zero @ nat ) )
       => ( M = N2 ) ) ) ).

% diffs0_imp_equal
thf(fact_1589_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_1590_diff__less__mono2,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ M @ L2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L2 @ N2 ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_1591_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N2 ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1592_dvd__minus__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ( ord_less @ nat @ N2 @ M )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_minus_self
thf(fact_1593_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N2 @ K ) )
          = ( M = N2 ) ) ) ) ).

% eq_diff_iff
thf(fact_1594_le__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% le_diff_iff
thf(fact_1595_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1596_diff__le__mono,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L2 ) @ ( minus_minus @ nat @ N2 @ L2 ) ) ) ).

% diff_le_mono
thf(fact_1597_diff__le__self,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ).

% diff_le_self
thf(fact_1598_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_1599_diff__le__mono2,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L2 @ N2 ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ).

% diff_le_mono2
thf(fact_1600_less__eq__dvd__minus,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1601_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ N2 ) ) ) ) ).

% dvd_diffD1
thf(fact_1602_dvd__diffD,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1603_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% Nat.diff_cancel
thf(fact_1604_diff__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_cancel2
thf(fact_1605_diff__add__inverse,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ N2 )
      = M ) ).

% diff_add_inverse
thf(fact_1606_diff__add__inverse2,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ N2 )
      = M ) ).

% diff_add_inverse2
thf(fact_1607_diff__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1608_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% diff_mult_distrib2
thf(fact_1609_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X5: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X5 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = D4 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X5 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = D4 ) ) ) ).

% bezout1_nat
thf(fact_1610_diff__less__Suc,axiom,
    ! [M: nat,N2: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1611_Suc__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N2 ) ) )
        = ( minus_minus @ nat @ M @ N2 ) ) ) ).

% Suc_diff_Suc
thf(fact_1612_diff__less,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ) ) ).

% diff_less
thf(fact_1613_Suc__diff__le,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( suc @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Suc_diff_le
thf(fact_1614_less__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% less_diff_iff
thf(fact_1615_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1616_diff__add__0,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1617_less__diff__conv,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_1618_add__diff__inverse__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ M @ N2 ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1619_le__diff__conv,axiom,
    ! [J: nat,K: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ).

% le_diff_conv
thf(fact_1620_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1621_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1622_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1623_Nat_Ole__imp__diff__is__add,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( minus_minus @ nat @ J @ I2 )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1624_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N2 ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1625_mod__geq,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% mod_geq
thf(fact_1626_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ).

% mod_if
thf(fact_1627_le__mod__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% le_mod_geq
thf(fact_1628_mod__eq__dvd__iff__nat,axiom,
    ! [N2: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N2 @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1629_nat__minus__add__max,axiom,
    ! [N2: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ M ) @ M )
      = ( ord_max @ nat @ N2 @ M ) ) ).

% nat_minus_add_max
thf(fact_1630_add__diff__assoc__enat,axiom,
    ! [Z2: extended_enat,Y: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z2 @ Y )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y @ Z2 ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ Z2 ) ) ) ).

% add_diff_assoc_enat
thf(fact_1631_diff__Suc__less,axiom,
    ! [N2: nat,I2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ I2 ) ) @ N2 ) ) ).

% diff_Suc_less
thf(fact_1632_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D3: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D3 ) )
           => ( P @ D3 ) ) ) ) ).

% nat_diff_split
thf(fact_1633_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D3: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D3 ) )
                & ~ ( P @ D3 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1634_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1635_nat__eq__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M )
          = N2 ) ) ) ).

% nat_eq_add_iff1
thf(fact_1636_nat__eq__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1637_nat__le__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_le_add_iff1
thf(fact_1638_nat__le__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1639_nat__diff__add__eq1,axiom,
    ! [J: nat,I2: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_diff_add_eq1
thf(fact_1640_nat__diff__add__eq2,axiom,
    ! [I2: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1641_dvd__minus__add,axiom,
    ! [Q2: nat,N2: nat,R: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N2 )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1642_mod__nat__eqI,axiom,
    ! [R: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ R @ N2 )
     => ( ( ord_less_eq @ nat @ R @ M )
       => ( ( dvd_dvd @ nat @ N2 @ ( minus_minus @ nat @ M @ R ) )
         => ( ( modulo_modulo @ nat @ M @ N2 )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_1643_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N: nat] : ( minus_minus @ nat @ M3 @ ( times_times @ nat @ ( divide_divide @ nat @ M3 @ N ) @ N ) ) ) ) ).

% modulo_nat_def
thf(fact_1644_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod @ nat @ nat] :
      ~ ! [K3: nat,M4: nat] :
          ( X
         != ( product_Pair @ nat @ nat @ K3 @ M4 ) ) ).

% prod_decode_aux.cases
thf(fact_1645_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_diff
thf(fact_1646_Suc__pred_H,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( N2
        = ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1647_Suc__diff__eq__diff__pred,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1648_div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% div_geq
thf(fact_1649_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ) ).

% div_if
thf(fact_1650_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% add_eq_if
thf(fact_1651_nat__less__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_less_add_iff1
thf(fact_1652_nat__less__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1653_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% mult_eq_if
thf(fact_1654_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1655_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1656_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1657_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus_mult
thf(fact_1658_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1659_le__div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% le_div_geq
thf(fact_1660_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_1661_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1662_even__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1663_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1664_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ord_less @ nat @ N2 @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N2 )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1665_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) )
               => ~ ( ( Xa2 = Mi3 )
                    | ( Xa2 = Ma3 ) ) ) )
         => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 = Mi3 )
                      | ( Xa2 = Ma3 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_1666_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa2 ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) )
                   => ( ( Xa2 = Mi3 )
                      | ( Xa2 = Ma3 ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                     => ( ( Xa2 = Mi3 )
                        | ( Xa2 = Ma3 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_1667_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1668_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1669_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa2 ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) @ Xa2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_1670_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) @ Xa2 ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_1671_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa2 ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) )
                 => ( ( Y
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S2 ) @ Xa2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_1672_inrange,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_1673_psubsetI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( A3 != B3 )
       => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% psubsetI
thf(fact_1674_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1675_subset__antisym,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( A3 = B3 ) ) ) ).

% subset_antisym
thf(fact_1676_subsetI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( member @ A @ X5 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% subsetI
thf(fact_1677_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) )
          = ( ( ord_less_eq @ A @ L2 @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_1678_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,H2: A,L3: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L2 @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) )
          = ( ( ( L2 = L3 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L2 @ H2 )
              & ~ ( ord_less_eq @ A @ L3 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_1679_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_1680_triangle__Suc,axiom,
    ! [N2: nat] :
      ( ( nat_triangle @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N2 ) @ ( suc @ N2 ) ) ) ).

% triangle_Suc
thf(fact_1681_diff__commute,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ K ) @ J ) ) ).

% diff_commute
thf(fact_1682_ex__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less
thf(fact_1683_all__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less
thf(fact_1684_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_1685_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) ) ) ) ).

% Collect_mono_iff
thf(fact_1686_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y2: set @ A,Z: set @ A] : ( Y2 = Z ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_1687_subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% subset_trans
thf(fact_1688_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( Q @ X5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_1689_subset__refl,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) ).

% subset_refl
thf(fact_1690_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B8 ) ) ) ) ).

% subset_iff
thf(fact_1691_equalityD2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ).

% equalityD2
thf(fact_1692_equalityD1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% equalityD1
thf(fact_1693_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A7 )
           => ( member @ A @ X2 @ B8 ) ) ) ) ).

% subset_eq
thf(fact_1694_equalityE,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% equalityE
thf(fact_1695_subsetD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) ).

% subsetD
thf(fact_1696_in__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B3 ) ) ) ).

% in_mono
thf(fact_1697_Diff__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,D5: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_1698_Diff__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ A3 ) ).

% Diff_subset
thf(fact_1699_double__diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B3 @ ( minus_minus @ ( set @ A ) @ C6 @ A3 ) )
          = A3 ) ) ) ).

% double_diff
thf(fact_1700_psubsetD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) ).

% psubsetD
thf(fact_1701_psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_trans
thf(fact_1702_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ? [B6: A] : ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_1703_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X2: A] : ( times_times @ A @ X2 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_1704_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X2: A] : ( member @ A @ X2 @ A7 )
            @ ^ [X2: A] : ( member @ A @ X2 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_1705_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( P @ X2 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_1706_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X2: A] : ( member @ A @ X2 @ A7 )
            @ ^ [X2: A] : ( member @ A @ X2 @ B8 ) ) ) ) ).

% less_set_def
thf(fact_1707_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
            | ( A7 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_1708_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_1709_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_1710_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_1711_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% psubset_imp_subset
thf(fact_1712_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( A7 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_1713_psubsetE,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% psubsetE
thf(fact_1714_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A6: real,B6: real,C3: real] :
            ( ( P @ A6 @ B6 )
           => ( ( P @ B6 @ C3 )
             => ( ( ord_less_eq @ real @ A6 @ B6 )
               => ( ( ord_less_eq @ real @ B6 @ C3 )
                 => ( P @ A6 @ C3 ) ) ) ) )
       => ( ! [X5: real] :
              ( ( ord_less_eq @ real @ A2 @ X5 )
             => ( ( ord_less_eq @ real @ X5 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A6: real,B6: real] :
                        ( ( ( ord_less_eq @ real @ A6 @ X5 )
                          & ( ord_less_eq @ real @ X5 @ B6 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B6 @ A6 ) @ D6 ) )
                       => ( P @ A6 @ B6 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1715_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N2: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H2 @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = G ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = ( H2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1716_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1717_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va2: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va2 ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_1718_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1719_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_1720_set__decode__Suc,axiom,
    ! [N2: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N2 ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N2 @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1721_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X2: nat] :
          ( collect @ nat
          @ ^ [N: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% set_decode_def
thf(fact_1722_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1723_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1724_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ).

% Compl_subset_Compl_iff
thf(fact_1725_Compl__anti__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) ).

% Compl_anti_mono
thf(fact_1726_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1727_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1728_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1729_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1730_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1731_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1732_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1733_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( M = N2 ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1734_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1735_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1736_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1737_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1738_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1739_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1740_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1741_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1742_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X ) @ Y )
          = ( dvd_dvd @ A @ X @ Y ) ) ) ).

% minus_dvd_iff
thf(fact_1743_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ X @ ( uminus_uminus @ A @ Y ) )
          = ( dvd_dvd @ A @ X @ Y ) ) ) ).

% dvd_minus_iff
thf(fact_1744_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1745_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1746_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1747_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1748_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_1749_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1750_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1751_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1752_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_1753_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1754_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1755_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1756_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1757_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1758_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1759_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1760_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1761_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1762_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1763_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1764_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1765_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_1766_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_1767_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1768_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1769_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1770_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1771_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1772_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1773_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1774_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1775_Suc__0__mod__eq,axiom,
    ! [N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1776_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1777_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1778_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1779_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1780_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1781_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( N2 = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1782_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1783_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1784_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1785_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1786_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_1787_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_1788_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_1789_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V2 @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(168)
thf(fact_1790_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1791_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1792_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1793_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1794_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1795_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_1796_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_1797_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_1798_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1799_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1800_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1801_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1802_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1803_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1804_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1805_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1806_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1807_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1808_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1809_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P2: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P2 ) ) )
          = P2 ) ) ).

% odd_of_bool_self
thf(fact_1810_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1811_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1812_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1813_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1814_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1815_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1816_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1817_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1818_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_minus_odd
thf(fact_1819_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1820_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1821_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1822_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1823_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1824_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1825_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1826_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1827_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1828_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1829_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1830_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1831_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P2 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P2 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_1832_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1833_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1834_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1835_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1836_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1837_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1838_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1839_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1840_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1841_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1842_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1843_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1844_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1845_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1846_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1847_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1848_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1849_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1850_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1851_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1852_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1853_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1854_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1855_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1856_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A5 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A5 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1857_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1858_signed__take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1859_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1860_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1861_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ~ ( ( P2
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P2
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1862_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ( P2
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P2
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1863_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1864_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1865_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1866_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1867_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1868_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1869_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1870_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1871_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1872_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1873_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1874_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1875_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1876_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1877_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1878_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1879_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1880_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1881_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1882_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1883_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ N2 )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1884_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1885_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B5: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B5 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1886_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B5: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B5 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1887_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1888_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1889_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1890_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_1891_zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1892_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1893_zmod__zminus1__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1894_zmod__zminus2__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L2 ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1895_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X2: real,Y5: real] : ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ Y5 ) ) ) ) ).

% minus_real_def
thf(fact_1896_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1897_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1898_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1899_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1900_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1901_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1902_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1903_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1904_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1905_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_1906_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1907_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1908_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1909_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1910_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_1911_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1912_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1913_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1914_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1915_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1916_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1917_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1918_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1919_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1920_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1921_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1922_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus
thf(fact_1923_bset_I1_J,axiom,
    ! [D5: int,B3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B3 )
                 => ( X5
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X5
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
             => ( ( P @ ( minus_minus @ int @ X3 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_1924_bset_I2_J,axiom,
    ! [D5: int,B3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B3 )
                 => ( X5
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X5
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
             => ( ( P @ ( minus_minus @ int @ X3 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_1925_aset_I1_J,axiom,
    ! [D5: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
             => ( ( P @ ( plus_plus @ int @ X3 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_1926_aset_I2_J,axiom,
    ! [D5: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
             => ( ( P @ ( plus_plus @ int @ X3 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_1927_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_1928_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_less_add_iff
thf(fact_1929_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_1930_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_le_add_iff
thf(fact_1931_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_1932_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1933_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1934_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1935_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1936_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1937_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1938_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1939_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1940_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1941_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1942_subset__decode__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% subset_decode_imp_le
thf(fact_1943_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1944_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1945_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1946_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1947_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1948_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_1949_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% power2_eq_iff
thf(fact_1950_bset_I9_J,axiom,
    ! [D2: int,D5: int,B3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B3 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_1951_bset_I10_J,axiom,
    ! [D2: int,D5: int,B3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B3 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_1952_aset_I9_J,axiom,
    ! [D2: int,D5: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_1953_aset_I10_J,axiom,
    ! [D2: int,D5: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_1954_verit__less__mono__div__int2,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less_eq @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N2 ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B3 @ N2 ) @ ( divide_divide @ int @ A3 @ N2 ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1955_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1956_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1957_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1958_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1959_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1960_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1961_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1962_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1963_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1964_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1965_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P @ X5 )
            = ( P @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ( ? [X4: int] : ( P @ X4 ) )
          = ( ? [X2: int] :
                ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X2 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_1966_aset_I7_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X3 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_1967_aset_I5_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X3 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_1968_aset_I4_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X3 != T2 )
             => ( ( plus_plus @ int @ X3 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_1969_aset_I3_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X3 = T2 )
             => ( ( plus_plus @ int @ X3 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_1970_bset_I7_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X3 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_1971_bset_I5_J,axiom,
    ! [D5: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B3 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X3 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_1972_bset_I4_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X3 != T2 )
             => ( ( minus_minus @ int @ X3 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_1973_bset_I3_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X3 = T2 )
             => ( ( minus_minus @ int @ X3 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_1974_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1975_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_power @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_1976_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N2 @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1977_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_1978_minus__mod__int__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
        = ( minus_minus @ int @ ( minus_minus @ int @ L2 @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L2 ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1979_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1980_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1981_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1982_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_1983_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A6: A] :
              ( ( ( divide_divide @ A @ A6 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A6 )
             => ( P @ A6 ) )
         => ( ! [A6: A,B6: $o] :
                ( ( P @ A6 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A6 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1984_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1985_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1986_aset_I8_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X3 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_1987_aset_I6_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X3 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_1988_bset_I8_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B3 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X3 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_1989_bset_I6_J,axiom,
    ! [D5: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B3 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X3 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_1990_cpmi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less @ int @ X5 @ Z3 )
           => ( ( P @ X5 )
              = ( P5 @ X5 ) ) )
       => ( ! [X5: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ B3 )
                     => ( X5
                       != ( plus_plus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X5 )
               => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
         => ( ! [X5: int,K3: int] :
                ( ( P5 @ X5 )
                = ( P5 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ B3 )
                        & ( P @ ( plus_plus @ int @ Y5 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_1991_cppi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less @ int @ Z3 @ X5 )
           => ( ( P @ X5 )
              = ( P5 @ X5 ) ) )
       => ( ! [X5: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ A3 )
                     => ( X5
                       != ( minus_minus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X5 )
               => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
         => ( ! [X5: int,K3: int] :
                ( ( P5 @ X5 )
                = ( P5 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ A3 )
                        & ( P @ ( minus_minus @ int @ Y5 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_1992_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1993_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% minus_power_mult_self
thf(fact_1994_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1995_minus__1__div__exp__eq__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_1996_div__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1997_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_1998_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_1999_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2000_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_2001_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2002_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K3: int] :
              ( ( P @ K3 )
             => ( ( K3
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K3: int] :
                ( ( P @ K3 )
               => ( ( K3
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2003_signed__take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2004_signed__take__bit__int__eq__self,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2005_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N2 @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_2006_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2007_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_2008_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_2009_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_2010_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2011_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F5 @ G4 )
              & ~ ( ord_less_eq @ ( A > B ) @ G4 @ F5 ) ) ) ) ) ).

% less_fun_def
thf(fact_2012_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2013_signed__take__bit__Suc__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2014_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_2015_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_2016_semiring__norm_I90_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(90)
thf(fact_2017_semiring__norm_I88_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N2 ) ) ).

% semiring_norm(88)
thf(fact_2018_semiring__norm_I89_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N2 ) ) ).

% semiring_norm(89)
thf(fact_2019_semiring__norm_I84_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit1 @ N2 ) ) ).

% semiring_norm(84)
thf(fact_2020_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2021_semiring__norm_I73_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(73)
thf(fact_2022_semiring__norm_I80_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(80)
thf(fact_2023_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > C > A,A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F2 @ A2 @ B2 ) ) ).

% case_prod_conv
thf(fact_2024_semiring__norm_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(9)
thf(fact_2025_semiring__norm_I7_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(7)
thf(fact_2026_semiring__norm_I14_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N2 ) ) ) ) ).

% semiring_norm(14)
thf(fact_2027_semiring__norm_I15_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N2 ) ) ) ).

% semiring_norm(15)
thf(fact_2028_semiring__norm_I81_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(81)
thf(fact_2029_semiring__norm_I72_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(72)
thf(fact_2030_semiring__norm_I77_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit1 @ N2 ) ) ).

% semiring_norm(77)
thf(fact_2031_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2032_zdiv__numeral__Bit1,axiom,
    ! [V2: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2033_semiring__norm_I3_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% semiring_norm(3)
thf(fact_2034_semiring__norm_I4_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2035_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2036_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2037_semiring__norm_I10_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2038_semiring__norm_I16_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2039_semiring__norm_I79_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(79)
thf(fact_2040_semiring__norm_I74_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(74)
thf(fact_2041_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V2: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V2 ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2042_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2043_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V2: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V2 ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2044_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2045_zmod__numeral__Bit1,axiom,
    ! [V2: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2046_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2047_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2048_old_Oprod_Ocase,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > B > C,X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F2 @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F2 @ X1 @ X22 ) ) ).

% old.prod.case
thf(fact_2049_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P: B > C > A,Z2: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z2 ) )
     => ~ ! [X5: B,Y3: C] :
            ( ( Z2
              = ( product_Pair @ B @ C @ X5 @ Y3 ) )
           => ~ ( Q @ ( P @ X5 @ Y3 ) ) ) ) ).

% case_prodE2
thf(fact_2050_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X2: A,Y5: B] : ( F2 @ ( product_Pair @ A @ B @ X2 @ Y5 ) ) )
      = F2 ) ).

% case_prod_eta
thf(fact_2051_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X5: A,Y3: B] :
          ( ( F2 @ X5 @ Y3 )
          = ( G @ ( product_Pair @ A @ B @ X5 @ Y3 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F2 )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_2052_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M4: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N3: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M4: num,N3: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M4: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N3: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M4: num,N3: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_2053_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X23: num] :
            ( Y
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2054_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2055_eval__nat__numeral_I3_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N2 ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2056_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2057_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2058_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2059_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2060_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_2061_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_2062_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_2063_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_2064_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_2065_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_2066_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_2067_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_2068_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_less_eq @ A @ A4 @ B5 )
              & ( ord_less_eq @ A @ B5 @ A4 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_2069_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_2070_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_2071_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_2072_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_less_eq @ A @ B5 @ A4 )
              & ( ord_less_eq @ A @ A4 @ B5 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_2073_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less_eq @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A,B6: A] :
                ( ( P @ B6 @ A6 )
               => ( P @ A6 @ B6 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_2074_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% order_trans
thf(fact_2075_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_2076_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_2077_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_2078_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_2079_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [X2: A,Y5: A] :
              ( ( ord_less_eq @ A @ X2 @ Y5 )
              & ( ord_less_eq @ A @ Y5 @ X2 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_2080_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_2081_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_2082_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_2083_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_2084_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_2085_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_less_linear
thf(fact_2086_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_2087_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_not_sym
thf(fact_2088_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less @ A @ X5 @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_2089_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less @ B @ X5 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_2090_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_2091_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less @ A @ X5 @ Y3 )
                 => ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_2092_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less @ B @ X5 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_2093_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_2094_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_2095_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ( X != Y ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_2096_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_asym
thf(fact_2097_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE
thf(fact_2098_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_2099_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_2100_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_2101_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_2102_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_2103_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A] : ( P @ A6 @ A6 )
           => ( ! [A6: A,B6: A] :
                  ( ( P @ B6 @ A6 )
                 => ( P @ A6 @ B6 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_2104_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P3: A > $o] :
            ? [X7: A] : ( P3 @ X7 ) )
        = ( ^ [P4: A > $o] :
            ? [N: A] :
              ( ( P4 @ N )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N )
                 => ~ ( P4 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_2105_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_2106_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_2107_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_cases
thf(fact_2108_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv3
thf(fact_2109_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X5 )
                 => ( P @ Y4 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_2110_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_2111_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_2112_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_2113_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% less_imp_neq
thf(fact_2114_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z4: A] :
              ( ( ord_less @ A @ X @ Z4 )
              & ( ord_less @ A @ Z4 @ Y ) ) ) ) ).

% dense
thf(fact_2115_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_2116_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X ) ) ).

% lt_ex
thf(fact_2117_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2118_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2119_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2120_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ).

% odd_numeral
thf(fact_2121_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2122_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2123_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2124_Suc3__eq__add__3,axiom,
    ! [N2: nat] :
      ( ( suc @ ( suc @ ( suc @ N2 ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ).

% Suc3_eq_add_3
thf(fact_2125_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2126_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2127_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2128_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2129_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_div_eq_add3_div
thf(fact_2130_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2131_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_2132_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_2133_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less @ A @ X5 @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_2134_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_2135_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_2136_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y3: B] :
                  ( ( ord_less @ B @ X5 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_2137_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_2138_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_2139_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_2140_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_2141_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_2142_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_2143_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_2144_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y5: A] :
              ( ( ord_less_eq @ A @ X2 @ Y5 )
              & ( X2 != Y5 ) ) ) ) ) ).

% order_less_le
thf(fact_2145_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y5: A] :
              ( ( ord_less @ A @ X2 @ Y5 )
              | ( X2 = Y5 ) ) ) ) ) ).

% order_le_less
thf(fact_2146_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_2147_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_2148_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( ord_less_eq @ A @ B5 @ A4 )
              & ~ ( ord_less_eq @ A @ A4 @ B5 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_2149_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_2150_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_2151_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( ord_less_eq @ A @ B5 @ A4 )
              & ( A4 != B5 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_2152_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( ord_less @ A @ B5 @ A4 )
              | ( A4 = B5 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_2153_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X @ W2 )
               => ( ( ord_less @ A @ W2 @ Y )
                 => ( ord_less_eq @ A @ W2 @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_2154_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z2 @ W2 )
               => ( ( ord_less @ A @ W2 @ X )
                 => ( ord_less_eq @ A @ Y @ W2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_2155_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_less_eq @ A @ A4 @ B5 )
              & ~ ( ord_less_eq @ A @ B5 @ A4 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_2156_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_2157_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_2158_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_less_eq @ A @ A4 @ B5 )
              & ( A4 != B5 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_2159_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_less @ A @ A4 @ B5 )
              | ( A4 = B5 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_2160_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_2161_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y5: A] :
              ( ( ord_less_eq @ A @ X2 @ Y5 )
              & ~ ( ord_less_eq @ A @ Y5 @ X2 ) ) ) ) ) ).

% less_le_not_le
thf(fact_2162_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z2: A] :
          ( ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Y )
             => ( ord_less_eq @ A @ X5 @ Z2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_le
thf(fact_2163_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y: A] :
          ( ! [X5: A] :
              ( ( ord_less @ A @ Z2 @ X5 )
             => ( ord_less_eq @ A @ Y @ X5 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_ge
thf(fact_2164_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_2165_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_2166_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_2167_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_2168_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_2169_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_2170_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_2171_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_2172_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_2173_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_2174_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_2175_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_2176_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B5: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B5 ) @ B5 @ A4 ) ) ) ) ).

% max_def
thf(fact_2177_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
            ! [X2: A] : ( ord_less_eq @ B @ ( F5 @ X2 ) @ ( G4 @ X2 ) ) ) ) ) ).

% le_fun_def
thf(fact_2178_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_2179_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_2180_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_2181_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2182_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2183_odd__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2184_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2185_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2186_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2187_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2188_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2189_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2190_signed__take__bit__numeral__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2191_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A6: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A6 @ B6 ) )
         => ( C2 @ A6 @ B6 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P2 ) ) ).

% case_prodI2
thf(fact_2192_case__prodI,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( F2 @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) ).

% case_prodI
thf(fact_2193_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P2: product_prod @ A @ B,Z2: C,C2: A > B > ( set @ C )] :
      ( ! [A6: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A6 @ B6 ) )
         => ( member @ C @ Z2 @ ( C2 @ A6 @ B6 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P2 ) ) ) ).

% mem_case_prodI2
thf(fact_2194_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),A2: B,B2: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) ).

% mem_case_prodI
thf(fact_2195_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P2: product_prod @ A @ B,C2: A > B > C > $o,X: C] :
      ( ! [A6: A,B6: B] :
          ( ( ( product_Pair @ A @ B @ A6 @ B6 )
            = P2 )
         => ( C2 @ A6 @ B6 @ X ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ X ) ) ).

% case_prodI2'
thf(fact_2196_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2197_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2198_eq__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N2 ) )
      = ( ( pred_numeral @ K )
        = N2 ) ) ).

% eq_numeral_Suc
thf(fact_2199_Suc__eq__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ( suc @ N2 )
        = ( numeral_numeral @ nat @ K ) )
      = ( N2
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2200_less__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2201_less__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% less_numeral_Suc
thf(fact_2202_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2203_le__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2204_le__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% le_numeral_Suc
thf(fact_2205_diff__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2206_diff__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% diff_numeral_Suc
thf(fact_2207_max__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_2208_max__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% max_numeral_Suc
thf(fact_2209_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2210_numeral__div__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2211_minus__numeral__div__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2212_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N2 @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2213_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2214_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2215_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2216_one__div__minus__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2217_minus__one__div__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2218_signed__take__bit__numeral__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2219_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2220_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2221_mem__case__prodE,axiom,
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),P2: product_prod @ B @ C] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ! [X5: B,Y3: C] :
            ( ( P2
              = ( product_Pair @ B @ C @ X5 @ Y3 ) )
           => ~ ( member @ A @ Z2 @ ( C2 @ X5 @ Y3 ) ) ) ) ).

% mem_case_prodE
thf(fact_2222_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P2: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P2 )
     => ~ ! [X5: A,Y3: B] :
            ( ( P2
              = ( product_Pair @ A @ B @ X5 @ Y3 ) )
           => ~ ( C2 @ X5 @ Y3 ) ) ) ).

% case_prodE
thf(fact_2223_case__prodD,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F2 @ A2 @ B2 ) ) ).

% case_prodD
thf(fact_2224_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P2: product_prod @ A @ B,Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ Z2 )
     => ~ ! [X5: A,Y3: B] :
            ( ( P2
              = ( product_Pair @ A @ B @ X5 @ Y3 ) )
           => ~ ( C2 @ X5 @ Y3 @ Z2 ) ) ) ).

% case_prodE'
thf(fact_2225_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: A > B > C > $o,A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R2 @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R2 @ A2 @ B2 @ C2 ) ) ).

% case_prodD'
thf(fact_2226_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K2: num] : ( suc @ ( pred_numeral @ K2 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2227_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K2: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K2 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2228_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% divmod_int_def
thf(fact_2229_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_2230_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ) ).

% divmod_def
thf(fact_2231_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2232_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2233_eq__diff__eq_H,axiom,
    ! [X: real,Y: real,Z2: real] :
      ( ( X
        = ( minus_minus @ real @ Y @ Z2 ) )
      = ( Y
        = ( plus_plus @ real @ X @ Z2 ) ) ) ).

% eq_diff_eq'
thf(fact_2234_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2235_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2236_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2237_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K2 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_2238_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D3 @ Z6 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_2239_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D3 @ Z5 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_2240_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2241_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% of_int_le_iff
thf(fact_2242_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int,N2: num] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( numeral_numeral @ A @ N2 ) )
          = ( Z2
            = ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2243_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2244_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ W @ Z2 ) ) ) ).

% of_int_less_iff
thf(fact_2245_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2246_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2247_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_2248_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z2 ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_add
thf(fact_2249_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2250_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2251_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int,N2: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z2 @ N2 ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z2 ) @ N2 ) ) ) ).

% of_int_power
thf(fact_2252_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2253_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2254_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2255_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2256_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_le_iff
thf(fact_2257_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2258_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2259_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_less_iff
thf(fact_2260_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z2: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N2 ) @ Z2 ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2261_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N2: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ int @ Z2 @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2262_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z2: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N2 ) @ Z2 ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2263_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N2: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ int @ Z2 @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2264_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_2265_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2266_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_2267_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2268_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2269_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2270_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2271_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N2: nat,Y: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2272_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2273_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2274_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2275_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2276_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2277_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2278_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N2: nat,Y: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 )
            = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2279_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( Y
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2280_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2281_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2282_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2283_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2284_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_2285_real__of__int__div4,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_2286_real__of__int__div,axiom,
    ! [D2: int,N2: int] :
      ( ( dvd_dvd @ int @ D2 @ N2 )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2287_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_nonneg
thf(fact_2288_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_pos
thf(fact_2289_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2290_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_2291_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_2292_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2293_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2294_real__of__int__div2,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_2295_real__of__int__div3,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2296_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2297_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M3 @ N ) @ ( modulo_modulo @ nat @ M3 @ N ) ) ) ) ).

% divmod_nat_def
thf(fact_2298_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X5: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X5 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X5 @ ( one_one @ int ) ) ) )
          & ! [Y4: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y4 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y4 @ ( one_one @ int ) ) ) ) )
             => ( Y4 = X5 ) ) ) ) ).

% floor_exists1
thf(fact_2299_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z4: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z4 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z4 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2300_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_2301_Sum__Icc__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X2: int] : X2
          @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N2 @ ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_2302_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N2 ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2303_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2304_mask__nat__positive__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% mask_nat_positive_iff
thf(fact_2305_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2306_concat__bit__of__zero__2,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2307_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2308_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2309_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_2310_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2311_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N2 )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2312_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_2313_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2314_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2315_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2316_take__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2317_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_2318_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% take_bit_of_1
thf(fact_2319_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2320_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2321_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N2 @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_of_exp
thf(fact_2322_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2323_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_int_mask_eq
thf(fact_2324_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_2325_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_2326_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2327_take__bit__nat__less__eq__self,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2328_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2329_take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2330_take__bit__mult,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ K @ L2 ) ) ) ).

% take_bit_mult
thf(fact_2331_take__bit__diff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% take_bit_diff
thf(fact_2332_concat__bit__take__bit__eq,axiom,
    ! [N2: nat,B2: int] :
      ( ( bit_concat_bit @ N2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ B2 ) )
      = ( bit_concat_bit @ N2 @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2333_concat__bit__eq__iff,axiom,
    ! [N2: nat,K: int,L2: int,R: int,S: int] :
      ( ( ( bit_concat_bit @ N2 @ K @ L2 )
        = ( bit_concat_bit @ N2 @ R @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N2 @ R ) )
        & ( L2 = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_2334_less__eq__mask,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% less_eq_mask
thf(fact_2335_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_2336_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I3: B] : ( modulo_modulo @ A @ ( F2 @ I3 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_2337_take__bit__eq__mask__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2338_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2339_take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_2340_take__bit__nonnegative,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% take_bit_nonnegative
thf(fact_2341_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N2 @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2342_not__take__bit__negative,axiom,
    ! [N2: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_2343_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_2344_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N2 @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2345_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_2346_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_2347_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2348_mask__nonnegative__int,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N2 ) ) ).

% mask_nonnegative_int
thf(fact_2349_not__mask__negative__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2350_semiring__norm_I28_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ N2 ) ) ) ).

% semiring_norm(28)
thf(fact_2351_semiring__norm_I27_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit0 @ N2 ) )
      = ( bit1 @ ( bitM @ N2 ) ) ) ).

% semiring_norm(27)
thf(fact_2352_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2353_take__bit__decr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_2354_less__mask,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ) ).

% less_mask
thf(fact_2355_eval__nat__numeral_I2_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N2 ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_2356_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2357_BitM__plus__one,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ ( bitM @ N2 ) @ one2 )
      = ( bit0 @ N2 ) ) ).

% BitM_plus_one
thf(fact_2358_one__plus__BitM,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% one_plus_BitM
thf(fact_2359_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2360_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2361_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N2 ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_2362_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_2363_take__bit__nat__eq__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_2364_take__bit__nat__less__exp,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_nat_less_exp
thf(fact_2365_take__bit__nat__eq__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_2366_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( modulo_modulo @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_nat_def
thf(fact_2367_take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_int_less_exp
thf(fact_2368_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N: nat,K2: int] : ( modulo_modulo @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_def
thf(fact_2369_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2370_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2371_take__bit__nat__less__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2372_Suc__mask__eq__exp,axiom,
    ! [N2: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_mask_eq_exp
thf(fact_2373_mask__nat__less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% mask_nat_less_exp
thf(fact_2374_take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2375_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2376_take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2377_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2378_take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2379_take__bit__int__eq__self,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2380_take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2381_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2382_mask__half__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2383_take__bit__incr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2384_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_12: nat] : ( P @ X_12 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2385_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2386_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z4: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z4 ) ) ) ).

% ex_le_of_int
thf(fact_2387_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z4: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z4 ) @ X ) ) ).

% ex_of_int_less
thf(fact_2388_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z4: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z4 ) ) ) ).

% ex_less_of_int
thf(fact_2389_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2390_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2391_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2392_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2393_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2394_take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2395_take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2396_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( plus_plus @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2397_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2398_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2399_take__bit__minus__small__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2400_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_2401_take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2402_take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2403_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2404_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2405_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2406_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ int @ N2 ) ) ) ).

% round_numeral
thf(fact_2407_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2408_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2409_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_2410_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2411_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2412_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2413_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2414_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% round_neg_numeral
thf(fact_2415_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X5: num] :
            ( ( P @ X5 )
           => ( P @ ( inc @ X5 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_2416_add__inc,axiom,
    ! [X: num,Y: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y ) )
      = ( inc @ ( plus_plus @ num @ X @ Y ) ) ) ).

% add_inc
thf(fact_2417_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_2418_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_2419_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2420_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_2421_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_2422_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_2423_inc__BitM__eq,axiom,
    ! [N2: num] :
      ( ( inc @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% inc_BitM_eq
thf(fact_2424_BitM__inc__eq,axiom,
    ! [N2: num] :
      ( ( bitM @ ( inc @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% BitM_inc_eq
thf(fact_2425_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y ) ) ) ) ).

% round_mono
thf(fact_2426_mult__inc,axiom,
    ! [X: num,Y: num] :
      ( ( times_times @ num @ X @ ( inc @ Y ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y ) @ X ) ) ).

% mult_inc
thf(fact_2427_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I6: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I3 ) )
            @ I6 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I6 ) ) ) ) ).

% sum_power_add
thf(fact_2428_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_2429_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_2430_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_2431_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_2432_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_2433_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2434_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_2435_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_2436_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P2 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_2437_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_2438_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_2439_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_2440_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2441_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.in_pairs
thf(fact_2442_mask__eq__sum__exp__nat,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_2443_gauss__sum__nat,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_2444_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I3 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N2 @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_2445_Sum__Icc__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_2446_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N2: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2447_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A,N2: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
        = ( suc @ N2 ) )
     => ? [X5: A] :
          ( ( member @ A @ X5 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X5 ) ) ) ) ).

% sum_SucD
thf(fact_2448_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_2449_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_2450_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K2 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2451_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_2452_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% of_nat_eq_iff
thf(fact_2453_int__eq__iff__numeral,axiom,
    ! [M: nat,V2: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V2 ) )
      = ( M
        = ( numeral_numeral @ nat @ V2 ) ) ) ).

% int_eq_iff_numeral
thf(fact_2454_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2455_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( ( zero_zero @ nat )
            = N2 ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2456_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2457_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_iff
thf(fact_2458_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% of_nat_le_iff
thf(fact_2459_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% of_nat_numeral
thf(fact_2460_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_add
thf(fact_2461_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mult
thf(fact_2462_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2463_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2464_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2465_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 ) ) ) ).

% of_nat_power
thf(fact_2466_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2467_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2468_negative__zless,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2469_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2470_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2471_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2472_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2473_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N2 ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2474_real__of__nat__less__numeral__iff,axiom,
    ! [N2: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2475_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2476_numeral__le__real__of__nat__iff,axiom,
    ! [N2: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N2 ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N2 ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2477_signed__take__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2478_signed__take__bit__negative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ).

% signed_take_bit_negative_iff
thf(fact_2479_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% of_nat_0_less_iff
thf(fact_2480_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2481_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2482_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2483_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2484_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N2: nat,Y: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( semiring_1_of_nat @ A @ Y ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2485_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y: nat,X: num,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2486_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2487_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N2 ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2488_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2489_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N2 ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2490_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N2 ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2491_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_2492_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N2 ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2493_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2494_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_of_nat
thf(fact_2495_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N2: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2496_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2497_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N2: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2498_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2499_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 )
          = ( ( N2
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2500_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N2 ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2501_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% bit_numeral_iff
thf(fact_2502_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2503_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_2504_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2505_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2506_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( M != N2 ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2507_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2508_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N2 ) ) ) ).

% not_bit_1_Suc
thf(fact_2509_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2510_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2511_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% of_nat_0_le_iff
thf(fact_2512_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2513_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2514_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N2 ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2515_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N2 )
          = ( B2
            & ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2516_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% div_mult2_eq'
thf(fact_2517_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2518_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
         => ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_imp_less
thf(fact_2519_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I2: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_2520_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2521_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% of_nat_dvd_iff
thf(fact_2522_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2523_int__ops_I3_J,axiom,
    ! [N2: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ int @ N2 ) ) ).

% int_ops(3)
thf(fact_2524_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B5: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2525_int__cases,axiom,
    ! [Z2: int] :
      ( ! [N3: nat] :
          ( Z2
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z2
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_2526_int__of__nat__induct,axiom,
    ! [P: int > $o,Z2: int] :
      ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P @ Z2 ) ) ) ).

% int_of_nat_induct
thf(fact_2527_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B5: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2528_zle__int,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% zle_int
thf(fact_2529_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mod
thf(fact_2530_int__plus,axiom,
    ! [N2: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N2 @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2531_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2532_zadd__int__left,axiom,
    ! [M: nat,N2: nat,Z2: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ Z2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N2 ) ) @ Z2 ) ) ).

% zadd_int_left
thf(fact_2533_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2534_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2535_not__int__zless__negative,axiom,
    ! [N2: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2536_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2537_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_max
thf(fact_2538_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2539_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2540_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B5: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ).

% nat_less_as_int
thf(fact_2541_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_nat_mask_eq
thf(fact_2542_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B5: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2543_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2544_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% of_nat_diff
thf(fact_2545_bit__not__int__iff_H,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff'
thf(fact_2546_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y4: real] :
        ? [N3: nat] : ( ord_less @ real @ Y4 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_2547_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2548_real__of__nat__div4,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_2549_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2550_int__Suc,axiom,
    ! [N2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2551_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2552_real__of__nat__div,axiom,
    ! [D2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N2 )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2553_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A4: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N @ A4 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2554_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2555_bit__imp__take__bit__positive,axiom,
    ! [N2: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2556_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2557_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L2 ) @ N2 )
      = ( ( ( ord_less @ nat @ N2 @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) )
        | ( ( ord_less_eq @ nat @ M @ N2 )
          & ( bit_se5641148757651400278ts_bit @ int @ L2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2558_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2559_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2560_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2561_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_2562_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2563_zmult__zless__mono2__lemma,axiom,
    ! [I2: int,J: int,K: nat] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I2 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2564_not__zle__0__negative,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ).

% not_zle_0_negative
thf(fact_2565_negD,axiom,
    ! [X: int] :
      ( ( ord_less @ int @ X @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_2566_negative__zless__0,axiom,
    ! [N2: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2567_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2568_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2569_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K2: int] : ( bit_concat_bit @ N @ K2 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2570_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2571_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) ) ).

% bit_Suc
thf(fact_2572_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2573_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2574_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E ) ) ) ).

% nat_approx_posE
thf(fact_2575_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% of_nat_less_two_power
thf(fact_2576_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_2577_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2578_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2579_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2580_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y ) ) )
      = ( ( ( ord_less_eq @ nat @ Y @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y ) ) ) )
        & ( ( ord_less @ nat @ X @ Y )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2581_real__of__nat__div2,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_2582_real__of__nat__div3,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2583_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2584_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K2: int,N: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_int_def
thf(fact_2585_linear__plus__1__le__power,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N2 ) ) ) ).

% linear_plus_1_le_power
thf(fact_2586_Bernoulli__inequality,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N2 ) ) ) ).

% Bernoulli_inequality
thf(fact_2587_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2588_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2589_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
         => ( ! [X5: nat] :
                ( ( member @ nat @ ( suc @ X5 ) @ A3 )
               => ( ( F2 @ ( suc @ X5 ) )
                  = ( G @ ( suc @ X5 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A3 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_2590_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N2 )
            = ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N2 ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2591_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2592_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_2593_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_2594_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_2595_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F2: B > A,A3: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ R @ ( F2 @ N ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_2596_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ ( F2 @ N ) @ R )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_2597_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A3: set @ A,G: C > B,B3: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I3 ) @ ( G @ J3 ) )
                @ B3 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_2598_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( plus_plus @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_2599_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K2: int] :
          ( plus_plus @ int @ K2
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% set_bit_eq
thf(fact_2600_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K2: int] : ( minus_minus @ int @ K2 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2601_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( divide_divide @ A @ ( F2 @ N ) @ R )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_2602_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X5 ) @ ( F2 @ X5 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X2: A] : ( minus_minus @ nat @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_2603_take__bit__Suc__from__most,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2604_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_2605_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_2606_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_2607_Bernoulli__inequality__even,axiom,
    ! [N2: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N2 ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2608_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2609_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_2610_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z2: A,K5: real,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z2 @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2611_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N2 ) ) ) ) ).

% pochhammer_double
thf(fact_2612_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I3: A] : ( plus_plus @ A @ I3 @ ( one_one @ A ) )
              @ N
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_2613_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z2: A,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P6: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ Q4 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ P6 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_2614_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( K2
              = ( zero_zero @ int ) )
            | ( L
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K2
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_2615_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_2616_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_2617_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_2618_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I2 @ K ) ) ) ).

% lessThan_iff
thf(fact_2619_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_2620_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_2621_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_2622_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_2623_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_2624_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_2625_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% lessThan_subset_iff
thf(fact_2626_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_2627_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_2628_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_2629_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2630_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_2631_and__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% and_nonnegative_int_iff
thf(fact_2632_and__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_2633_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_2634_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_2635_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_2636_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_2637_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_2638_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_2639_and__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_2640_and__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_2641_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_2642_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_2643_and__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_2644_and__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_2645_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_2646_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_and_eq
thf(fact_2647_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_and_eq
thf(fact_2648_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_2649_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B5: A] : ( bit_se5824344872417868541ns_and @ A @ B5 @ A4 ) ) ) ) ).

% and.commute
thf(fact_2650_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_2651_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_and_iff
thf(fact_2652_bit__and__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ).

% bit_and_int_iff
thf(fact_2653_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less @ A @ X2 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_2654_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_2655_not__bit__Suc__0__Suc,axiom,
    ! [N2: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N2 ) ) ).

% not_bit_Suc_0_Suc
thf(fact_2656_bit__Suc__0__iff,axiom,
    ! [N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_2657_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) ) ) ).

% AND_lower
thf(fact_2658_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ X ) ) ).

% AND_upper1
thf(fact_2659_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Y ) ) ).

% AND_upper2
thf(fact_2660_AND__upper1_H,axiom,
    ! [Y: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z2 ) ) ) ).

% AND_upper1'
thf(fact_2661_AND__upper2_H,axiom,
    ! [Y: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z2 ) ) ) ).

% AND_upper2'
thf(fact_2662_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N2 ) )
          = ( ord_less @ A @ M @ N2 ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_2663_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_2664_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N2 ) ) ) ) ).

% pochhammer_pos
thf(fact_2665_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_2666_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_2667_not__bit__Suc__0__numeral,axiom,
    ! [N2: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N2 ) ) ).

% not_bit_Suc_0_numeral
thf(fact_2668_AND__upper2_H_H,axiom,
    ! [Y: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z2 ) ) ) ).

% AND_upper2''
thf(fact_2669_AND__upper1_H_H,axiom,
    ! [Y: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z2 ) ) ) ).

% AND_upper1''
thf(fact_2670_and__less__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ K ) ) ).

% and_less_eq
thf(fact_2671_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N2: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ I3 ) @ R )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_2672_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N2 ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2673_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N2: nat,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N2 ) @ I2 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N2 @ ( Inc @ I2 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_2674_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I2 )
          = I2 ) ) ).

% of_nat_aux.simps(1)
thf(fact_2675_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2676_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_2677_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N2: A] :
          ( ! [X5: A] : ( ord_less_eq @ nat @ ( Q @ X5 ) @ ( P @ X5 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N2 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N2 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X2: A] : ( minus_minus @ nat @ ( P @ X2 ) @ ( Q @ X2 ) )
              @ ( set_ord_lessThan @ A @ N2 ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_2678_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_2679_even__and__iff__int,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ).

% even_and_iff_int
thf(fact_2680_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2681_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2682_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% pochhammer_rec
thf(fact_2683_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N2 ) ) ) ) ).

% pochhammer_rec'
thf(fact_2684_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N2 ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2685_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,K: nat] :
          ( ( ord_less @ nat @ N2 @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_2686_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N2: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N2 @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_2687_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ? [K2: nat] :
                ( ( ord_less @ nat @ K2 @ N2 )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K2 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_2688_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_2689_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N2: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N2 @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_2690_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_2691_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_2692_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_2693_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_2694_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z2: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z2 @ P6 ) ) @ ( power_power @ A @ Z2 @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ Z2 @ P6 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ M @ P6 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_2695_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_2696_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_2697_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N2 )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_2698_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2699_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2700_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N2: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2701_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N2 )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2702_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_2703_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M3: nat,N: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_nat_def
thf(fact_2704_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2705_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( F2 @ I3 ) @ ( G @ I3 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum_split_even_odd
thf(fact_2706_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) ) @ ( power_power @ A @ X @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2707_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N2 ) ) @ ( power_power @ A @ Y @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X @ P6 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2708_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2709_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2710_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2711_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2712_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2713_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2714_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2715_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2716_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2717_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2718_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
          = ( ( X
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2719_norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) ).

% norm_one
thf(fact_2720_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2721_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2722_and__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2723_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2724_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2725_Suc__0__and__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_2726_and__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2727_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_2728_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_2729_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2730_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2731_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult
thf(fact_2732_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S3: set @ B,F2: B > A,G: B > real] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ S3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ ( G @ X5 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S3 ) ) ) ) ).

% sum_norm_le
thf(fact_2733_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2734_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N2: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N2 ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N2 ) ) ) ).

% norm_power
thf(fact_2735_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I3: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_2736_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% norm_uminus_minus
thf(fact_2737_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2738_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat,Z2: A] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( power_power @ A @ Z2 @ N2 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2739_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ R @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2740_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult_ineq
thf(fact_2741_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_lt
thf(fact_2742_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2743_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2744_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2745_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_le
thf(fact_2746_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2747_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N2 ) ) ) ).

% norm_power_ineq
thf(fact_2748_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z2 ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2749_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2750_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2751_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z2 ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2752_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_le_diff
thf(fact_2753_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2754_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2755_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2756_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2757_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2758_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z2 @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z2 @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2759_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_2760_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( F2 @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_2761_sumr__cos__zero__one,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_2762_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N2: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_2763_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_2764_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( power_power @ A @ Z2 @ N ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_2765_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu3: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_2766_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2767_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2768_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_2769_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2770_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
           != ( one_one @ A ) )
         => ~ ! [A6: B] :
                ( ( member @ B @ A6 @ A3 )
               => ( ( G @ A6 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_2771_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ( G @ X5 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_2772_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_2773_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_2774_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_2775_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A3: set @ A,N2: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ N2 )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_2776_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I3: B] : ( modulo_modulo @ A @ ( F2 @ I3 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_2777_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                & ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_2778_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_2779_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_2780_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_2781_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_2782_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_2783_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A4: B] : ( power_power @ A @ C2 @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_2784_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_2785_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) )
                & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_2786_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_2787_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_2788_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2789_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_2790_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2791_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2792_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_2793_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_2794_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_2795_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P2 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2796_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F5: nat > A > A,A4: nat,B5: nat,Acc2: A] : ( if @ A @ ( ord_less @ nat @ B5 @ A4 ) @ Acc2 @ ( set_fo6178422350223883121st_nat @ A @ F5 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B5 @ ( F5 @ A4 @ Acc2 ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2797_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa2: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa2 @ Xb3 @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa2 @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2798_norm__prod__diff,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I6: set @ I7,Z2: I7 > A,W: I7 > A] :
          ( ! [I4: I7] :
              ( ( member @ I7 @ I4 @ I6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z2 @ I4 ) ) @ ( one_one @ real ) ) )
         => ( ! [I4: I7] :
                ( ( member @ I7 @ I4 @ I6 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I4 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I7 @ A @ Z2 @ I6 ) @ ( groups7121269368397514597t_prod @ I7 @ A @ W @ I6 ) ) )
              @ ( groups7311177749621191930dd_sum @ I7 @ real
                @ ^ [I3: I7] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z2 @ I3 ) @ ( W @ I3 ) ) )
                @ I6 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_2799_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_2800_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_2801_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.in_pairs
thf(fact_2802_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( plus_plus @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_2803_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_2804_sums__if_H,axiom,
    ! [G: nat > real,X: real] :
      ( ( sums @ real @ G @ X )
     => ( sums @ real
        @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_2805_sums__if,axiom,
    ! [G: nat > real,X: real,F2: nat > real,Y: real] :
      ( ( sums @ real @ G @ X )
     => ( ( sums @ real @ F2 @ Y )
       => ( sums @ real
          @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( F2 @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sums_if
thf(fact_2806_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_2807_power__half__series,axiom,
    ( sums @ real
    @ ^ [N: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_2808_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
          = ( sums @ A @ F2 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_2809_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A,N2: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_2810_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_2811_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( if @ A @ ( N = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z2 @ N ) )
          @ ( power_power @ A @ Z2 @ M ) ) ) ).

% powser_sums_if
thf(fact_2812_prod__int__plus__eq,axiom,
    ! [I2: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I2 @ ( plus_plus @ nat @ I2 @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I2 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I2 @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_2813_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_2814_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_2815_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_2816_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_2817_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_2818_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_2819_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_2820_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_2821_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
              @ S )
           => ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_2822_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_2823_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ L2 )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_2824_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N2: nat,F2: nat > A,S: A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ N2 )
             => ( ( F2 @ I4 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_2825_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_2826_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2827_central__binomial__lower__bound,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2828_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2829_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2830_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_double
thf(fact_2831_binomial__Suc__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ ( suc @ N2 ) @ N2 )
      = ( suc @ N2 ) ) ).

% binomial_Suc_n
thf(fact_2832_binomial__n__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ N2 )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_2833_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% gbinomial_1
thf(fact_2834_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2835_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2836_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_2837_binomial__1,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = N2 ) ).

% binomial_1
thf(fact_2838_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_2839_binomial__eq__0__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N2 @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2840_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2841_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2842_binomial__Suc__Suc,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_2843_ln__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y ) )
          = ( X = Y ) ) ) ) ).

% ln_inj_iff
thf(fact_2844_ln__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_2845_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_2846_binomial__n__0,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2847_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2848_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_Suc
thf(fact_2849_zero__less__binomial__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) )
      = ( ord_less_eq @ nat @ K @ N2 ) ) ).

% zero_less_binomial_iff
thf(fact_2850_ln__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_2851_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2852_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_2853_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2854_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_2855_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_2856_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2857_fact__ge__self,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_self
thf(fact_2858_fact__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% fact_mono_nat
thf(fact_2859_choose__one,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% choose_one
thf(fact_2860_binomial__fact__lemma,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( binomial @ N2 @ K ) )
        = ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% binomial_fact_lemma
thf(fact_2861_binomial__altdef__nat,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2862_binomial__eq__0,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ N2 @ K )
     => ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2863_ln__less__self,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_less_self
thf(fact_2864_Suc__times__binomial__eq,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_2865_Suc__times__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) ) ).

% Suc_times_binomial
thf(fact_2866_fact__less__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% fact_less_mono_nat
thf(fact_2867_binomial__symmetric,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2868_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_2869_binomial__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( binomial @ N2 @ R ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% binomial_le_pow
thf(fact_2870_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_zero
thf(fact_2871_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_2872_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_gt_zero
thf(fact_2873_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_1
thf(fact_2874_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_mono
thf(fact_2875_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_2876_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2877_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2878_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2879_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_2880_zero__less__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) ) ) ).

% zero_less_binomial
thf(fact_2881_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_2882_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2883_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2884_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_2885_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_2886_fact__ge__Suc__0__nat,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_Suc_0_nat
thf(fact_2887_choose__mult,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( times_times @ nat @ ( binomial @ N2 @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ ( minus_minus @ nat @ N2 @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2888_binomial__Suc__Suc__eq__times,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_2889_binomial__absorb__comp,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N2 @ K ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_2890_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K2 ) ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2891_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K2 ) ) @ ( one_one @ A ) ) @ K2 ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2892_dvd__fact,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% dvd_fact
thf(fact_2893_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2894_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N2 )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% fact_less_mono
thf(fact_2895_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_2896_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N2 ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2897_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_2898_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N2 @ N2 ) ) ) ) ).

% fact_le_power
thf(fact_2899_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X2: nat] : X2
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod
thf(fact_2900_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_2901_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2902_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_2903_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_mult
thf(fact_2904_binomial__absorption,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_2905_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2906_ln__div,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_div
thf(fact_2907_fact__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_2908_fact__div__fact__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ R ) ) ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_2909_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2910_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2911_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_2912_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2913_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2914_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% choose_dvd
thf(fact_2915_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2916_fact__eq__fact__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N2 )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_2917_binomial__code,axiom,
    ( binomial
    = ( ^ [N: nat,K2: nat] : ( if @ nat @ ( ord_less @ nat @ N @ K2 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( binomial @ N @ ( minus_minus @ nat @ N @ K2 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N @ K2 ) @ ( one_one @ nat ) ) @ N @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K2 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2918_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2919_binomial__maximum_H,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% binomial_maximum'
thf(fact_2920_binomial__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_2921_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less_eq @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2922_binomial__maximum,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2923_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2924_binomial__le__pow2,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% binomial_le_pow2
thf(fact_2925_choose__reduce__nat,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N2 @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2926_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_2927_times__binomial__minus1__eq,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N2 @ K ) )
        = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2928_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2929_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y ) @ Y ) ) ) ) ).

% ln_diff_le
thf(fact_2930_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_2931_ln__realpow,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_2932_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2933_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2934_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2935_fact__div__fact,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_2936_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2937_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2938_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2939_central__binomial__odd,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_2940_binomial__addition__formula,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2941_square__fact__le__2__fact,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% square_fact_le_2_fact
thf(fact_2942_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2943_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2944_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2945_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2946_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A4 ) @ ( one_one @ A ) ) @ K2 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2947_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2948_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2949_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2950_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% pochhammer_same
thf(fact_2951_choose__two,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2952_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2953_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2954_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N2: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_2955_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_2956_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2957_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_2958_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2959_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2960_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N ) ) ) ) ) ) ) ).

% ln_series
thf(fact_2961_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2962_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_2963_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2964_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_2965_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_2966_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2967_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2968_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2969_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2970_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_numeral
thf(fact_2971_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2972_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2973_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2974_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2975_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_2976_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_2977_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2978_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2979_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% abs_of_nat
thf(fact_2980_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_2981_tanh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% tanh_real_less_iff
thf(fact_2982_tanh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% tanh_real_le_iff
thf(fact_2983_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2984_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2985_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2986_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2987_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_neg_numeral
thf(fact_2988_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2989_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% abs_power_minus
thf(fact_2990_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_pos_iff
thf(fact_2991_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2992_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_2993_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2994_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_2995_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2996_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2997_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2998_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_2999_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_3000_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_3001_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_3002_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_3003_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_3004_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_3005_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ( ( ( abs_abs @ A @ X )
            = ( abs_abs @ A @ Y ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% abs_eq_iff
thf(fact_3006_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_3007_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_3008_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_3009_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3010_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3011_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_3012_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_3013_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_3014_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% power_abs
thf(fact_3015_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L2: A,K: A] :
          ( ( ( abs_abs @ A @ L2 )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L2 @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_3016_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_3017_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_3018_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_3019_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_3020_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_3021_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_3022_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_3023_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_3024_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_3025_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_3026_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_3027_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_3028_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_3029_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_3030_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_3031_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3032_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_3033_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E2 ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_3034_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_3035_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_3036_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_3037_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_3038_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_3039_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% abs_div_pos
thf(fact_3040_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% zero_le_power_abs
thf(fact_3041_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if
thf(fact_3042_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_3043_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if_raw
thf(fact_3044_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_3045_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_3046_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_3047_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_3048_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3049_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_3050_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A4: real] : ( if @ real @ ( ord_less @ real @ A4 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A4 ) @ A4 ) ) ) ).

% abs_real_def
thf(fact_3051_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D4 )
               => ( ( ord_less @ real @ A2 @ Y4 )
                  & ( ord_less @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_3052_sin__bound__lemma,axiom,
    ! [X: real,Y: real,U: real,V2: real] :
      ( ( X = Y )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V2 )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U ) @ Y ) ) @ V2 ) ) ) ).

% sin_bound_lemma
thf(fact_3053_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_3054_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_3055_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_3056_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_3057_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D4 )
               => ( ( ord_less_eq @ real @ A2 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_3058_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_3059_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z2 ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_3060_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_3061_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_3062_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_even_abs
thf(fact_3063_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3064_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_3065_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_3066_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_3067_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_even
thf(fact_3068_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I6 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I4 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I6 )
              = ( one_one @ B ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I6 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I4 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I3: A] : ( times_times @ B @ ( A2 @ I3 ) @ ( X @ I3 ) )
                      @ I6 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_3069_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_3070_sin__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( sin_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( cos_coeff @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3071_cos__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( cos_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3072_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_3073_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N2 ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N2 ) ) ) ).

% round_unique'
thf(fact_3074_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_3075_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_3076_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 )
             => ( P @ X5 @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_3077_Maclaurin__sin__expansion3,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_3078_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_3079_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_3080_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_3081_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_3082_zabs__less__one__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z2 ) @ ( one_one @ int ) )
      = ( Z2
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_3083_sin__periodic__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi
thf(fact_3084_sin__periodic__pi2,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi2
thf(fact_3085_sin__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_3086_sin__npi2,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_3087_sin__npi__int,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_3088_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_3089_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_3090_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_3091_sin__2npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_3092_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_3093_sin__int__2pin,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_3094_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_3095_sin__cos__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% sin_cos_npi
thf(fact_3096_abs__zmult__eq__1,axiom,
    ! [M: int,N2: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N2 ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_3097_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_3098_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_3099_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_3100_abs__div,axiom,
    ! [Y: int,X: int] :
      ( ( dvd_dvd @ int @ Y @ X )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X ) @ ( abs_abs @ int @ Y ) ) ) ) ).

% abs_div
thf(fact_3101_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I3: int] : ( if @ int @ ( ord_less @ int @ I3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I3 ) @ I3 ) ) ) ).

% zabs_def
thf(fact_3102_abs__mod__less,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L2 ) ) @ ( abs_abs @ int @ L2 ) ) ) ).

% abs_mod_less
thf(fact_3103_sin__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero
thf(fact_3104_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_3105_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_3106_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_3107_zdvd__mult__cancel1,axiom,
    ! [M: int,N2: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N2 ) @ M )
        = ( ( abs_abs @ int @ N2 )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_3108_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_3109_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ( ( sin @ real @ X )
            = ( zero_zero @ real ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_3110_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ pi )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_3111_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3112_even__abs__add__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_abs_add_iff
thf(fact_3113_even__add__abs__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L2 ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_add_abs_iff
thf(fact_3114_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_3115_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_3116_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_3117_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_3118_nat__intermed__int__val,axiom,
    ! [M: nat,N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I4 )
            & ( ord_less @ nat @ I4 @ N2 ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
           => ? [I4: nat] :
                ( ( ord_less_eq @ nat @ M @ I4 )
                & ( ord_less_eq @ nat @ I4 @ N2 )
                & ( ( F2 @ I4 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_3119_incr__lemma,axiom,
    ! [D2: int,Z2: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z2 @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_3120_decr__lemma,axiom,
    ! [D2: int,X: int,Z2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z2 ) ) ).

% decr_lemma
thf(fact_3121_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_3122_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_3123_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_3124_sin__pi__divide__n__ge__0,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3125_nat__ivt__aux,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I4: nat] :
              ( ( ord_less_eq @ nat @ I4 @ N2 )
              & ( ( F2 @ I4 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_3126_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_3127_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_3128_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_3129_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3130_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_3131_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3132_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3133_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3134_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3135_nat0__intermed__int__val,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I4: nat] :
              ( ( ord_less_eq @ nat @ I4 @ N2 )
              & ( ( F2 @ I4 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_3136_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3137_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3138_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3139_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3140_sin__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X5: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X5 )
              = Y )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y4 )
                    = Y ) )
               => ( Y4 = X5 ) ) ) ) ) ).

% sin_total
thf(fact_3141_sum__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_3142_sum__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_3143_sin__pi__divide__n__gt__0,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3144_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3145_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3146_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3147_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K2: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_3148_Maclaurin__sin__expansion,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_3149_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_3150_Maclaurin__minus__cos__expansion,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_3151_Maclaurin__cos__expansion,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_3152_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_3153_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_3154_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_3155_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_3156_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_less_arctan_iff
thf(fact_3157_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_3158_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_3159_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_3160_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_3161_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_3162_cos__pi,axiom,
    ( ( cos @ real @ pi )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% cos_pi
thf(fact_3163_cos__periodic__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi
thf(fact_3164_cos__periodic__pi2,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi2
thf(fact_3165_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ X ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_3166_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_3167_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_3168_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_3169_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_3170_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_3171_cos__npi2,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi2
thf(fact_3172_cos__npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi
thf(fact_3173_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_3174_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_3175_cos__2npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_3176_cos__int__2pin,axiom,
    ! [N2: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3177_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3178_cos__npi__int,axiom,
    ! [N2: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3179_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_3180_arctan__monotone,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone
thf(fact_3181_arctan__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% arctan_less_iff
thf(fact_3182_arctan__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% arctan_le_iff
thf(fact_3183_arctan__monotone_H,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone'
thf(fact_3184_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_3185_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_3186_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_mult
thf(fact_3187_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_3188_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ).

% summable_add
thf(fact_3189_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_3190_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_Suc_iff
thf(fact_3191_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_3192_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_3193_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_3194_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3195_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_3196_polar__Ex,axiom,
    ! [X: real,Y: real] :
    ? [R4: real,A6: real] :
      ( ( X
        = ( times_times @ real @ R4 @ ( cos @ real @ A6 ) ) )
      & ( Y
        = ( times_times @ real @ R4 @ ( sin @ real @ A6 ) ) ) ) ).

% polar_Ex
thf(fact_3197_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_3198_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_3199_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_3200_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_3201_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_3202_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N: nat] :
                    ( ( F2 @ N )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_3203_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_3204_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_3205_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3206_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_add
thf(fact_3207_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_diff
thf(fact_3208_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_zero_power'
thf(fact_3209_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_0_powser
thf(fact_3210_cos__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3211_cos__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less_eq @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3212_cos__monotone__0__pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3213_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z2 @ N ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_3214_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z2 @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_3215_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_3216_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N @ M ) ) @ ( power_power @ A @ Z2 @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_3217_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3218_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_3219_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_3220_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) ) ) ) ).

% summable_rabs
thf(fact_3221_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_3222_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_3223_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_diff
thf(fact_3224_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_add
thf(fact_3225_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_3226_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3227_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3228_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) ) ) ) ) ).

% powser_inside
thf(fact_3229_cos__monotone__0__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3230_cos__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3231_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_3232_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_3233_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_3234_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3235_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( F2 @ ( suc @ N ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_3236_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3237_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) ) ) ).

% summable_norm
thf(fact_3238_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_3239_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3240_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3241_cos__is__zero,axiom,
    ? [X5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
      & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X5 )
        = ( zero_zero @ real ) )
      & ! [Y4: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
            & ( ord_less_eq @ real @ Y4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y4 )
              = ( zero_zero @ real ) ) )
         => ( Y4 = X5 ) ) ) ).

% cos_is_zero
thf(fact_3242_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3243_cos__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X5: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ pi )
            & ( ( cos @ real @ X5 )
              = Y )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ pi )
                  & ( ( cos @ real @ Y4 )
                    = Y ) )
               => ( Y4 = X5 ) ) ) ) ) ).

% cos_total
thf(fact_3244_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_3245_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_3246_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y3 )
      & ( ord_less_eq @ real @ Y3 @ pi )
      & ( ( sin @ real @ Y3 )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y3 )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_3247_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_3248_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z2 @ N ) ) )
                @ Z2 ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_3249_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z2 @ N ) ) )
              @ Z2 )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_3250_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ~ ! [N8: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ M2 )
                     => ! [N9: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N9 ) ) ) @ E ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_3251_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F2 )
           => ? [N8: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N9 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N9 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_3252_summable__power__series,axiom,
    ! [F2: nat > real,Z2: real] :
      ( ! [I4: nat] : ( ord_less_eq @ real @ ( F2 @ I4 ) @ ( one_one @ real ) )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I4 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z2 )
         => ( ( ord_less @ real @ Z2 @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( F2 @ I3 ) @ ( power_power @ real @ Z2 @ I3 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_3253_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N ) ) @ ( power_power @ real @ R @ N ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_3254_sin__cos__le1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3255_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3256_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3257_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_3258_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N2 @ I2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_3259_arctan__ubound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_3260_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3261_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3262_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_3263_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3264_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_3265_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3266_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3267_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3268_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3269_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z2 @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3270_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3271_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3272_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3273_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3274_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3275_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3276_arctan__lbound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) ) ).

% arctan_lbound
thf(fact_3277_arctan__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_3278_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3279_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_3280_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X2: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3281_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3282_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_3283_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_3284_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_3285_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X
              = ( cos @ real @ T4 ) )
            & ( Y
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3286_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3287_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3288_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_3289_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3290_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3291_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3292_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_3293_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T4 ) )
              & ( Y
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3294_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T4 ) )
          & ( Y
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3295_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_3296_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T4 ) )
               => ( Y
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3297_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( C2 @ N ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_3298_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3299_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_3300_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_even_sum
thf(fact_3301_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_odd_sum
thf(fact_3302_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I2 @ K ) ) ) ).

% atMost_iff
thf(fact_3303_tan__periodic__pi,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_pi
thf(fact_3304_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% atMost_subset_iff
thf(fact_3305_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_3306_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_3307_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_3308_tan__npi,axiom,
    ! [N2: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3309_tan__periodic__n,axiom,
    ! [X: real,N2: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_3310_tan__periodic__nat,axiom,
    ! [X: real,N2: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_3311_tan__periodic__int,axiom,
    ! [X: real,I2: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_int
thf(fact_3312_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_3313_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_3314_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_3315_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_3316_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_3317_sum__choose__upper,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ K2 @ M )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ N2 ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_3318_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ X2 ) ) ) ) ) ).

% tan_def
thf(fact_3319_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( C4 @ ( suc @ N ) ) ) ) ) ) ).

% diffs_def
thf(fact_3320_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_3321_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ I3 ) @ ( F2 @ ( suc @ I3 ) ) )
            @ ( set_ord_atMost @ nat @ I2 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I2 ) ) ) ) ) ).

% sum_telescope
thf(fact_3322_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,D2: nat > A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( D2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
               => ( ( C2 @ I3 )
                  = ( D2 @ I3 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_3323_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B3: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B3 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_3324_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_3325_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nested_swap'
thf(fact_3326_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nested_swap'
thf(fact_3327_sum__choose__lower,axiom,
    ! [R: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ ( plus_plus @ nat @ R @ K2 ) @ K2 )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N2 ) ) @ N2 ) ) ).

% sum_choose_lower
thf(fact_3328_choose__rising__sum_I1_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_3329_choose__rising__sum_I2_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_3330_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X5: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X5 @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3331_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N2: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_3332_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
               => ( ( C2 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_3333_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_3334_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_3335_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_3336_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K2 ) ) @ K2 )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ).

% gbinomial_parallel_sum
thf(fact_3337_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_3338_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_3339_sum__choose__diagonal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K2: nat] : ( binomial @ ( minus_minus @ nat @ N2 @ K2 ) @ ( minus_minus @ nat @ M @ K2 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N2 ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_3340_vandermonde,axiom,
    ! [M: nat,N2: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( binomial @ M @ K2 ) @ ( binomial @ N2 @ ( minus_minus @ nat @ R @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N2 ) @ R ) ) ).

% vandermonde
thf(fact_3341_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3342_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) ) ).

% sum_gp_basic
thf(fact_3343_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N2: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) )
         => ~ ! [B6: nat > A] :
                ~ ! [Z3: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( B6 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_3344_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N2: nat,A2: A] :
        ? [B6: nat > A] :
        ! [Z3: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( B6 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_3345_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_3346_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex
thf(fact_3347_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex
thf(fact_3348_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( summable @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_3349_choose__row__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N2 ) @ ( set_ord_atMost @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% choose_row_sum
thf(fact_3350_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                    @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_3351_binomial,axiom,
    ! [A2: nat,B2: nat,N2: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N2 )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N2 @ K2 ) ) @ ( power_power @ nat @ A2 @ K2 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N2 @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) ) ) ).

% binomial
thf(fact_3352_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_3353_lemma__tan__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y @ ( tan @ real @ X5 ) ) ) ) ).

% lemma_tan_total
thf(fact_3354_tan__total,axiom,
    ! [Y: real] :
    ? [X5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
      & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X5 )
        = Y )
      & ! [Y4: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
            & ( ord_less @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y4 )
              = Y ) )
         => ( Y4 = X5 ) ) ) ).

% tan_total
thf(fact_3355_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_3356_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y @ X )
              = ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3357_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3358_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
      & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X5 )
        = Y ) ) ).

% lemma_tan_total1
thf(fact_3359_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3360_tan__inverse,axiom,
    ! [Y: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y ) ) ) ).

% tan_inverse
thf(fact_3361_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.in_pairs_0
thf(fact_3362_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N2: nat,B2: nat > A,X: A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ M @ I4 )
             => ( ( A2 @ I4 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N2 @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_3363_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.in_pairs_0
thf(fact_3364_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,K: A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X2: nat] :
                ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) )
               => ( ( C2 @ X2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_3365_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_3366_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K2 ) ) @ ( power_power @ A @ A2 @ K2 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N2 @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% binomial_ring
thf(fact_3367_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3368_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N2 @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_3369_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N2: nat,B2: nat > nat,X: nat] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ M @ I4 )
         => ( ( A2 @ I4 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N2 @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( power_power @ nat @ X @ I3 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K2: nat] : ( times_times @ nat @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_3370_choose__square__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( power_power @ nat @ ( binomial @ N2 @ K2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% choose_square_sum
thf(fact_3371_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( sums @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_3372_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K5 )
         => ( ! [X5: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K5 )
               => ( summable @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X5 @ N ) ) ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3373_tan__total__pos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ? [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X5 )
            = Y ) ) ) ).

% tan_total_pos
thf(fact_3374_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3375_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3376_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) ) ) ) ) ).

% tan_mono_le
thf(fact_3377_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3378_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3379_arctan,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y ) )
        = Y ) ) ).

% arctan
thf(fact_3380_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_3381_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y )
         => ( ( arctan @ Y )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_3382_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_3383_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_3384_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_3385_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3386_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3387_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3388_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z4: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z4 )
          & ( ord_less @ real @ Z4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z4 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_3389_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,Z2: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( ( power_power @ A @ Z2 @ N2 )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I3
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I3 = N2 ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_3390_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_3391_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( N2
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_3392_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K2 ) ) @ K2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_3393_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A2 ) @ ( one_one @ A ) ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_3394_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K2 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y @ K2 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_3395_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_3396_choose__linear__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( times_times @ nat @ I3 @ ( binomial @ N2 @ I3 ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( times_times @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3397_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_3398_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E: real,C2: nat > A,N2: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ? [M8: real] :
            ! [Z3: A] :
              ( ( ord_less_eq @ real @ M8 @ ( real_V7770717601297561774m_norm @ A @ Z3 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) ) )
                @ ( times_times @ real @ E @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_3399_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_3400_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3401_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3402_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ).

% sin_x_sin_y
thf(fact_3403_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3404_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ).

% cos_x_cos_y
thf(fact_3405_complex__unimodular__polar,axiom,
    ! [Z2: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z2
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3406_Maclaurin__exp__lt,axiom,
    ! [X: real,N2: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_3407_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N: nat] : N ) ) ).

% of_nat_id
thf(fact_3408_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X: A,A2: real,Y: A] :
          ( ( times_times @ A @ X @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_right
thf(fact_3409_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ Y )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_left
thf(fact_3410_scaleR__one,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( one_one @ real ) @ X )
          = X ) ) ).

% scaleR_one
thf(fact_3411_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) ).

% scaleR_scaleR
thf(fact_3412_exp__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel_iff
thf(fact_3413_exp__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) ) ) ).

% exp_less_mono
thf(fact_3414_exp__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% exp_le_cancel_iff
thf(fact_3415_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_3416_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3417_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y: A,N2: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y ) @ N2 )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) ) ) ).

% scaleR_power
thf(fact_3418_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_3419_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
          = ( uminus_uminus @ A @ X ) ) ) ).

% scaleR_minus1_left
thf(fact_3420_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3421_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_3422_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_3423_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_3424_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_3425_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_scaleR
thf(fact_3426_exp__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X ) ) ).

% exp_ln
thf(fact_3427_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% exp_ln_iff
thf(fact_3428_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3429_norm__cos__sin,axiom,
    ! [T2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ ( cos @ real @ T2 ) @ ( sin @ real @ T2 ) ) )
      = ( one_one @ real ) ) ).

% norm_cos_sin
thf(fact_3430_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V2: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V2 ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3431_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V2: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V2 ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3432_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3433_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3434_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_3435_exp__less__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
     => ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel
thf(fact_3436_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3437_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3438_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_3439_exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X5: real] :
          ( ( exp @ real @ X5 )
          = Y ) ) ).

% exp_total
thf(fact_3440_exp__gt__zero,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_gt_zero
thf(fact_3441_not__exp__less__zero,axiom,
    ! [X: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_3442_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_3443_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_3444_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ) ).

% exp_add_commuting
thf(fact_3445_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) )
          = ( exp @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% mult_exp_exp
thf(fact_3446_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( divide_divide @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ).

% exp_diff
thf(fact_3447_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y: real,Xa2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X @ Y ) @ Xa2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa2 ) @ ( real_V8093663219630862766scaleR @ A @ Y @ Xa2 ) ) ) ) ).

% scaleR_left.add
thf(fact_3448_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3449_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3450_complex__add,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( plus_plus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( plus_plus @ real @ A2 @ C2 ) @ ( plus_plus @ real @ B2 @ D2 ) ) ) ).

% complex_add
thf(fact_3451_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_3452_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3453_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3454_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_3455_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3456_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3457_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3458_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3459_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3460_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V2: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 )
            = X )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V2 @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3461_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V2: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 ) )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V2 @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3462_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_3463_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3464_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3465_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N2 ) ) ) ).

% exp_of_nat_mult
thf(fact_3466_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N2: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N2 ) ) ) ).

% exp_of_nat2_mult
thf(fact_3467_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3468_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3469_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3470_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3471_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_3472_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3473_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3474_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3475_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3476_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3477_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3478_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3479_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3480_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3481_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3482_lemma__exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y )
     => ? [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less_eq @ real @ X5 @ ( minus_minus @ real @ Y @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X5 )
            = Y ) ) ) ).

% lemma_exp_total
thf(fact_3483_ln__ge__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_3484_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3485_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_3486_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y ) @ Y ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_3487_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3488_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_3489_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X @ N ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_3490_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% sin_def
thf(fact_3491_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X @ N ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_3492_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% cos_def
thf(fact_3493_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3494_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3495_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ N2 )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_3496_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_3497_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_3498_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_3499_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_3500_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) )
          = ( power_power @ A @ ( exp @ A @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_3501_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_3502_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_3503_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_3504_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_3505_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_3506_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_3507_Maclaurin__exp__le,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_3508_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_3509_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X2: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_3510_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3511_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3512_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_3513_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M4 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_3514_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [M3: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N )
                 => ( ord_less_eq @ A @ ( X4 @ M3 ) @ ( X4 @ N ) ) )
              | ! [M3: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N )
                 => ( ord_less_eq @ A @ ( X4 @ N ) @ ( X4 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_3515_real__sqrt__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ X )
        = ( sqrt @ Y ) )
      = ( X = Y ) ) ).

% real_sqrt_eq_iff
thf(fact_3516_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_3517_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_3518_real__sqrt__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% real_sqrt_less_iff
thf(fact_3519_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% real_sqrt_le_iff
thf(fact_3520_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_3521_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_3522_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_gt_0_iff
thf(fact_3523_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_3524_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_3525_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_ge_0_iff
thf(fact_3526_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_gt_1_iff
thf(fact_3527_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_3528_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_3529_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_ge_1_iff
thf(fact_3530_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_3531_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_3532_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_3533_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_3534_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_3535_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_3536_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa2: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_3537_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_3538_real__sqrt__divide,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_divide
thf(fact_3539_real__sqrt__mult,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_mult
thf(fact_3540_real__sqrt__minus,axiom,
    ! [X: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_minus
thf(fact_3541_real__sqrt__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_less_mono
thf(fact_3542_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_le_mono
thf(fact_3543_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_3544_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_3545_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_3546_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_3547_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_3548_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3549_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y @ Y ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3550_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_3551_real__less__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_less_rsqrt
thf(fact_3552_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_le_rsqrt
thf(fact_3553_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3554_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( sqrt @ X )
          = Y ) ) ) ).

% real_sqrt_unique
thf(fact_3555_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_le_lsqrt
thf(fact_3556_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3557_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3558_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3559_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3560_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ Y @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3561_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3562_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y ) ) ).

% sqrt_ge_absD
thf(fact_3563_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3564_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3565_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3566_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_less_lsqrt
thf(fact_3567_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3568_sqrt__even__pow2,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_3569_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3570_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3571_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3572_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3573_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3574_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3575_complex__norm,axiom,
    ! [X: real,Y: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3576_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3577_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa2: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3578_real__sqrt__power__even,axiom,
    ! [N2: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N2 )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3579_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3580_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3581_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3582_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_3583_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3584_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3585_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3586_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3587_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3588_arctan__half,axiom,
    ( arctan
    = ( ^ [X2: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3589_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [N: nat] : ( ord_less_eq @ A @ ( X4 @ N ) @ ( X4 @ ( suc @ N ) ) )
              | ! [N: nat] : ( ord_less_eq @ A @ ( X4 @ ( suc @ N ) ) @ ( X4 @ N ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3590_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_3591_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_3592_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X2: real] : ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3593_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3594_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3595_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3596_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3597_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3598_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3599_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3600_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3601_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3602_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3603_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3604_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3605_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3606_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3607_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3608_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3609_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3610_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3611_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3612_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3613_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3614_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3615_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3616_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3617_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3618_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3619_arccos__minus__1,axiom,
    ( ( arccos @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = pi ) ).

% arccos_minus_1
thf(fact_3620_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3621_cos__arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y ) )
          = Y ) ) ) ).

% cos_arccos
thf(fact_3622_sin__arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y ) )
          = Y ) ) ) ).

% sin_arcsin
thf(fact_3623_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3624_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3625_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3626_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3627_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_3628_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3629_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N2 )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_inverse
thf(fact_3630_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3631_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3632_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3633_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3634_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3635_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R: real,X: A] :
          ( ( ord_less_eq @ real @ R @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3636_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3637_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3638_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3639_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3640_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3641_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3642_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3643_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3644_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3645_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3646_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3647_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3648_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B5: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B5 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3649_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B5: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B5 ) ) ) ) ) ).

% divide_inverse
thf(fact_3650_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B5: A] : ( times_times @ A @ ( inverse_inverse @ A @ B5 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3651_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3652_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N2 ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3653_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3654_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3655_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3656_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3657_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X2: real,Y5: real] : ( times_times @ real @ X2 @ ( inverse_inverse @ real @ Y5 ) ) ) ) ).

% divide_real_def
thf(fact_3658_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3659_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3660_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3661_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3662_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3663_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3664_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3665_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3666_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3667_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3668_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3669_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3670_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3671_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y ) )
        = ( X = Y ) ) ) ).

% arccos_eq_iff
thf(fact_3672_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3673_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_3674_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3675_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y ) )
          = ( X = Y ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3676_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% arcsin_le_mono
thf(fact_3677_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3678_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3679_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3680_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3681_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3682_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3683_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_3684_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3685_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3686_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3687_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3688_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3689_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3690_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3691_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3692_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3693_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3694_forall__pos__mono__1,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3695_real__arch__inverse,axiom,
    ! [E: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
      = ( ? [N: nat] :
            ( ( N
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) @ E ) ) ) ) ).

% real_arch_inverse
thf(fact_3696_forall__pos__mono,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono
thf(fact_3697_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3698_ln__inverse,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_inverse
thf(fact_3699_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ).

% summable_exp
thf(fact_3700_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ).

% summable_exp_generic
thf(fact_3701_arccos__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) ) ) ) ).

% arccos_lbound
thf(fact_3702_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3703_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3704_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3705_arccos__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3706_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N2: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3707_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_3708_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3709_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% arcsin_less_mono
thf(fact_3710_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y ) )
        = Y ) ) ).

% cos_arccos_abs
thf(fact_3711_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3712_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3713_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3714_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3715_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3716_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3717_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3718_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3719_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3720_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_3721_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% exp_def
thf(fact_3722_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3723_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3724_arccos__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3725_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3726_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_3727_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3728_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3729_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3730_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3731_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3732_arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y ) )
            = Y ) ) ) ) ).

% arccos
thf(fact_3733_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3734_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3735_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3736_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3737_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I3 ) ) @ ( power_power @ A @ X @ I3 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ I3 ) ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ I3 ) ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_3738_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N ) ) ) @ ( power_power @ A @ X2 @ ( suc @ N ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3739_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3740_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3741_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3742_arcsin__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3743_arcsin__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3744_arcsin__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) ) ) ) ).

% arcsin_lbound
thf(fact_3745_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_3746_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X2: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ K ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_3747_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3748_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3749_arcsin__pi,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin_pi
thf(fact_3750_arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin
thf(fact_3751_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K3: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K3 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3752_Maclaurin__sin__bound,axiom,
    ! [X: real,N2: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N2 ) ) ) ).

% Maclaurin_sin_bound
thf(fact_3753_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_3754_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_3755_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3756_i__even__power,axiom,
    ! [N2: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N2 ) ) ).

% i_even_power
thf(fact_3757_sinh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% sinh_real_less_iff
thf(fact_3758_sinh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% sinh_real_le_iff
thf(fact_3759_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3760_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_pos_iff
thf(fact_3761_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3762_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3763_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3764_norm__ii,axiom,
    ( ( real_V7770717601297561774m_norm @ complex @ imaginary_unit )
    = ( one_one @ real ) ) ).

% norm_ii
thf(fact_3765_divide__i,axiom,
    ! [X: complex] :
      ( ( divide_divide @ complex @ X @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X ) ) ).

% divide_i
thf(fact_3766_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3767_divide__numeral__i,axiom,
    ! [Z2: complex,N2: num] :
      ( ( divide_divide @ complex @ Z2 @ ( times_times @ complex @ ( numeral_numeral @ complex @ N2 ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z2 ) ) @ ( numeral_numeral @ complex @ N2 ) ) ) ).

% divide_numeral_i
thf(fact_3768_cot__npi,axiom,
    ! [N2: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3769_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_3770_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3771_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X2: complex,Y5: complex] : ( times_times @ complex @ X2 @ ( inverse_inverse @ complex @ Y5 ) ) ) ) ).

% divide_complex_def
thf(fact_3772_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3773_sinh__less__cosh__real,axiom,
    ! [X: real] : ( ord_less @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_less_cosh_real
thf(fact_3774_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) ) ) ) ) ).

% tanh_def
thf(fact_3775_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_diff
thf(fact_3776_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_diff
thf(fact_3777_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_add
thf(fact_3778_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_add
thf(fact_3779_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% cosh_plus_sinh
thf(fact_3780_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% sinh_plus_cosh
thf(fact_3781_complex__i__not__one,axiom,
    imaginary_unit
 != ( one_one @ complex ) ).

% complex_i_not_one
thf(fact_3782_cosh__real__pos,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_pos
thf(fact_3783_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_3784_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3785_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3786_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3787_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3788_cosh__real__strict__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3789_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3790_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3791_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3792_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3793_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3794_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_3795_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( ( complex2 @ X @ Y )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3796_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3797_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3798_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ X2 ) ) ) ) ) ).

% cot_def
thf(fact_3799_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3800_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3801_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3802_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3803_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3804_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3805_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3806_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_3807_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3808_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3809_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_3810_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3811_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3812_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3813_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_3814_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_3815_norm__cis,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( cis @ A2 ) )
      = ( one_one @ real ) ) ).

% norm_cis
thf(fact_3816_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3817_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_3818_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_3819_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_3820_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_3821_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less @ real @ X @ Y ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_3822_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_3823_cis__pi,axiom,
    ( ( cis @ pi )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% cis_pi
thf(fact_3824_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_3825_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_3826_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_3827_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_3828_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_3829_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_3830_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3831_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3832_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3833_log__def,axiom,
    ( log
    = ( ^ [A4: real,X2: real] : ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ A4 ) ) ) ) ).

% log_def
thf(fact_3834_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3835_log__ln,axiom,
    ( ( ln_ln @ real )
    = ( log @ ( exp @ real @ ( one_one @ real ) ) ) ) ).

% log_ln
thf(fact_3836_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_3837_less__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_3838_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N2 )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_3839_DeMoivre,axiom,
    ! [A2: real,N2: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N2 )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3840_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_mult
thf(fact_3841_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_divide
thf(fact_3842_le__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_3843_log__base__pow,axiom,
    ! [A2: real,N2: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log_base_pow
thf(fact_3844_log__nat__power,axiom,
    ! [X: real,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_3845_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_3846_log2__of__power__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( semiring_1_of_nat @ real @ N2 )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_3847_log__of__power__less,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_less
thf(fact_3848_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_3849_Arg__bounded,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
      & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ).

% Arg_bounded
thf(fact_3850_log__of__power__le,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_le
thf(fact_3851_less__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_3852_le__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_3853_log2__of__power__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_less
thf(fact_3854_log2__of__power__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_le
thf(fact_3855_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_3856_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_3857_bij__betw__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( bij_betw @ nat @ complex
        @ ^ [K2: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        @ ( set_ord_lessThan @ nat @ N2 )
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N2 )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_3858_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_3859_ceiling__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_3860_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N: int] :
                ( X
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_3861_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% ceiling_numeral
thf(fact_3862_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_3863_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 ) ) ) ).

% ceiling_add_of_int
thf(fact_3864_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_3865_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_3866_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% ceiling_le_numeral
thf(fact_3867_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_3868_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_3869_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_3870_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_3871_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_3872_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_add_numeral
thf(fact_3873_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_3874_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_3875_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_3876_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_3877_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N2: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% ceiling_numeral_power
thf(fact_3878_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_3879_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_3880_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_3881_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_3882_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_3883_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_3884_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_3885_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_3886_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3887_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3888_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_3889_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_3890_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% ceiling_less_cancel
thf(fact_3891_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_3892_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% ceiling_le_iff
thf(fact_3893_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_3894_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) ) ) ) ).

% ceiling_add_le
thf(fact_3895_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3896_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3897_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3898_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I3 ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% ceiling_split
thf(fact_3899_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3900_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_3901_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_3902_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3903_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3904_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_3905_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P2 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3906_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P2 ) ) ) ).

% ceiling_divide_lower
thf(fact_3907_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N2 ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N2 ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3908_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3909_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_3910_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3911_arctan__def,axiom,
    ( arctan
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X2 )
                = Y5 ) ) ) ) ) ).

% arctan_def
thf(fact_3912_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% powr_one_eq_one
thf(fact_3913_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N: int] :
                ( X
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3914_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3915_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% floor_numeral
thf(fact_3916_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( ( X
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_3917_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_3918_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_3919_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3920_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3921_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_3922_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_3923_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3924_numeral__powr__numeral__real,axiom,
    ! [M: num,N2: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N2 ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3925_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_3926_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_3927_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_3928_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_3929_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3930_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% floor_less_numeral
thf(fact_3931_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_3932_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3933_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_neg_numeral
thf(fact_3934_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_diff_numeral
thf(fact_3935_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_3936_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% floor_numeral_power
thf(fact_3937_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_3938_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y ) )
          = Y ) ) ) ).

% log_powr_cancel
thf(fact_3939_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_3940_powr__numeral,axiom,
    ! [X: real,N2: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N2 ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% powr_numeral
thf(fact_3941_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_3942_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3943_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_3944_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_3945_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_3946_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_3947_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3948_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3949_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_3950_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3951_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_3952_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3953_powr__powr,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_3954_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ).

% floor_mono
thf(fact_3955_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_3956_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% floor_less_cancel
thf(fact_3957_powr__non__neg,axiom,
    ! [A2: real,X: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_3958_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_3959_powr__ge__pzero,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y ) ) ).

% powr_ge_pzero
thf(fact_3960_powr__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_3961_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3962_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3963_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_3964_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% le_floor_iff
thf(fact_3965_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% floor_less_iff
thf(fact_3966_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_3967_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_3968_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% le_floor_add
thf(fact_3969_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y ) ) ) ) ).

% gr_one_powr
thf(fact_3970_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) ).

% powr_inj
thf(fact_3971_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ) ).

% floor_add_int
thf(fact_3972_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( plus_plus @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_3973_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_3974_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_3975_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_3976_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_3977_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_3978_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) )
          = ( divide_divide @ int @ K @ L2 ) ) ) ).

% floor_divide_of_int_eq
thf(fact_3979_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3980_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N2: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N2 ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N2 ) ) ) ) ).

% floor_power
thf(fact_3981_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_3982_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_3983_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_3984_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_3985_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A,B2: A] :
          ( ( powr @ A @ X @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X @ A2 ) @ ( powr @ A @ X @ B2 ) ) ) ) ).

% powr_add
thf(fact_3986_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_3987_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X2: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_3988_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_3989_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_3990_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_3991_powr__realpow,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) )
        = ( power_power @ real @ X @ N2 ) ) ) ).

% powr_realpow
thf(fact_3992_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_3993_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_less_iff
thf(fact_3994_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% less_powr_iff
thf(fact_3995_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_3996_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X2: A] :
              ( if @ int
              @ ( X2
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X2 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_3997_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_3998_floor__eq,axiom,
    ! [N2: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N2 ) ) ) ).

% floor_eq
thf(fact_3999_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_4000_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_4001_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_4002_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_4003_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I3 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% floor_split
thf(fact_4004_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_4005_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_4006_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_4007_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_4008_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_4009_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_4010_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_4011_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_4012_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) ).

% powr_mult_base
thf(fact_4013_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_4014_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% le_powr_iff
thf(fact_4015_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_le_iff
thf(fact_4016_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_4017_floor__eq2,axiom,
    ! [N2: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N2 ) ) ) ).

% floor_eq2
thf(fact_4018_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_4019_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) @ P2 ) ) ) ).

% floor_divide_lower
thf(fact_4020_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_4021_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_4022_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_4023_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_4024_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_4025_arccos__def,axiom,
    ( arccos
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ pi )
              & ( ( cos @ real @ X2 )
                = Y5 ) ) ) ) ) ).

% arccos_def
thf(fact_4026_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X2: A,A4: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A4 @ ( ln_ln @ A @ X2 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_4027_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P2 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_4028_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_4029_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_4030_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_4031_powr__neg__numeral,axiom,
    ! [X: real,N2: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N2 ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_4032_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X2 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4033_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X2: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X2 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4034_floor__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_4035_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X2 )
                = Y5 ) ) ) ) ) ).

% arcsin_def
thf(fact_4036_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_4037_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X2 ) ) @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ).

% round_altdef
thf(fact_4038_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_4039_modulo__int__unfold,axiom,
    ! [L2: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N2
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_4040_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_4041_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_4042_sgn__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_one
thf(fact_4043_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_4044_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_4045_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_4046_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N2 ) ) ) ).

% power_sgn
thf(fact_4047_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_4048_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_4049_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_4050_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_4051_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_4052_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ real ) ) ) ) ).

% of_real_eq_1_iff
thf(fact_4053_of__real__1,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) ).

% of_real_1
thf(fact_4054_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_mult
thf(fact_4055_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_4056_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_divide
thf(fact_4057_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_add
thf(fact_4058_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N2: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N2 ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N2 ) ) ) ).

% of_real_power
thf(fact_4059_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_4060_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_4061_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_4062_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_4063_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_4064_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_4065_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_4066_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% cos_of_real_pi
thf(fact_4067_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sgn_of_nat
thf(fact_4068_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_4069_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_4070_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_4071_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_4072_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_4073_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_4074_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_4075_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_4076_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_4077_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_4078_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_4079_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_4080_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_4081_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_4082_of__real__def,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ ( one_one @ A ) ) ) ) ) ).

% of_real_def
thf(fact_4083_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_4084_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_4085_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K2: A] : ( times_times @ A @ K2 @ ( sgn_sgn @ A @ K2 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_4086_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_4087_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_4088_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_4089_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_4090_div__eq__sgn__abs,axiom,
    ! [K: int,L2: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_4091_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_4092_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_4093_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_4094_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y: real,X: real] :
          ( ( Y
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_4095_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_4096_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_4097_sgn__mod,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L2 @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L2 ) )
          = ( sgn_sgn @ int @ L2 ) ) ) ) ).

% sgn_mod
thf(fact_4098_complex__of__real__mult__Complex,axiom,
    ! [R: real,X: real,Y: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y ) )
      = ( complex2 @ ( times_times @ real @ R @ X ) @ ( times_times @ real @ R @ Y ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_4099_Complex__mult__complex__of__real,axiom,
    ! [X: real,Y: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X @ Y ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X @ R ) @ ( times_times @ real @ Y @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_4100_Complex__add__complex__of__real,axiom,
    ! [X: real,Y: real,R: real] :
      ( ( plus_plus @ complex @ ( complex2 @ X @ Y ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( plus_plus @ real @ X @ R ) @ Y ) ) ).

% Complex_add_complex_of_real
thf(fact_4101_complex__of__real__add__Complex,axiom,
    ! [R: real,X: real,Y: real] :
      ( ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y ) )
      = ( complex2 @ ( plus_plus @ real @ R @ X ) @ Y ) ) ).

% complex_of_real_add_Complex
thf(fact_4102_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_4103_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_4104_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X2: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_4105_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I3: int] :
          ( if @ int
          @ ( I3
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I3 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_4106_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_4107_div__sgn__abs__cancel,axiom,
    ! [V2: int,K: int,L2: int] :
      ( ( V2
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ L2 ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_4108_div__dvd__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( dvd_dvd @ int @ L2 @ K )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L2 ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_4109_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_4110_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_4111_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_4112_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% cos_int_times_real
thf(fact_4113_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% sin_int_times_real
thf(fact_4114_eucl__rel__int__remainderI,axiom,
    ! [R: int,L2: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L2 ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L2 ) @ R ) )
         => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4115_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A1: int,A22: int,A32: product_prod @ int @ int] :
          ( ? [K2: int] :
              ( ( A1 = K2 )
              & ( A22
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K2 ) ) )
          | ? [L: int,K2: int,Q4: int] :
              ( ( A1 = K2 )
              & ( A22 = L )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L
               != ( zero_zero @ int ) )
              & ( K2
                = ( times_times @ int @ Q4 @ L ) ) )
          | ? [R5: int,L: int,K2: int,Q4: int] :
              ( ( A1 = K2 )
              & ( A22 = L )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L ) )
              & ( K2
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4116_eucl__rel__int_Ocases,axiom,
    ! [A12: int,A23: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A12 @ A23 @ A33 )
     => ( ( ( A23
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A12 ) ) )
       => ( ! [Q3: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A23
                 != ( zero_zero @ int ) )
               => ( A12
                 != ( times_times @ int @ Q3 @ A23 ) ) ) )
         => ~ ! [R4: int,Q3: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q3 @ R4 ) )
               => ( ( ( sgn_sgn @ int @ R4 )
                    = ( sgn_sgn @ int @ A23 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R4 ) @ ( abs_abs @ int @ A23 ) )
                   => ( A12
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A23 ) @ R4 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4117_div__noneq__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L2 ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L2 @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_4118_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_4119_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_4120_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_4121_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_4122_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_4123_divide__int__unfold,axiom,
    ! [L2: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N2 )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_4124_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_4125_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ K2
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L @ K2 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_4126_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L @ K2 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_4127_powr__int,axiom,
    ! [X: real,I2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( power_power @ real @ X @ ( nat2 @ I2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I2 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_4128_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_4129_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_4130_csqrt__1,axiom,
    ( ( csqrt @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% csqrt_1
thf(fact_4131_csqrt__eq__1,axiom,
    ! [Z2: complex] :
      ( ( ( csqrt @ Z2 )
        = ( one_one @ complex ) )
      = ( Z2
        = ( one_one @ complex ) ) ) ).

% csqrt_eq_1
thf(fact_4132_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_4133_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_4134_zless__nat__conj,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
        & ( ord_less @ int @ W @ Z2 ) ) ) ).

% zless_nat_conj
thf(fact_4135_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_4136_zero__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% zero_less_nat_eq
thf(fact_4137_diff__nat__numeral,axiom,
    ! [V2: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_4138_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,N2: nat] :
      ( ( ( nat2 @ Y )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( Y
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_4139_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,Y: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 )
        = ( nat2 @ Y ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 )
        = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_4140_power2__csqrt,axiom,
    ! [Z2: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z2 ) ).

% power2_csqrt
thf(fact_4141_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_4142_one__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ).

% one_less_nat_eq
thf(fact_4143_nat__numeral__diff__1,axiom,
    ! [V2: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_4144_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N2: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_4145_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_4146_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_4147_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_4148_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I3: num] : ( nat2 @ ( numeral_numeral @ int @ I3 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_4149_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X2: real] : ( divide_divide @ real @ X2 @ ( abs_abs @ real @ X2 ) ) ) ) ).

% real_sgn_eq
thf(fact_4150_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ X @ Y )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ).

% nat_mono
thf(fact_4151_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_4152_sgn__eq,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [Z6: complex] : ( divide_divide @ complex @ Z6 @ ( real_Vector_of_real @ complex @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) ) ) ) ) ).

% sgn_eq
thf(fact_4153_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_4154_nat__mask__eq,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% nat_mask_eq
thf(fact_4155_nat__mono__iff,axiom,
    ! [Z2: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_mono_iff
thf(fact_4156_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ R @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_4157_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z2: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z2 ) ) ).

% zless_nat_eq_int_zless
thf(fact_4158_nat__le__iff,axiom,
    ! [X: int,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N2 )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nat_le_iff
thf(fact_4159_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_4160_nat__abs__mult__distrib,axiom,
    ! [W: int,Z2: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z2 ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z2 ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_4161_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% and_nat_def
thf(fact_4162_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A4: nat,B5: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4163_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A4: nat,B5: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4164_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_4165_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A4: nat,B5: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4166_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A4: nat,B5: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B5 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_4167_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A4: real] :
          ( if @ real
          @ ( A4
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A4 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_4168_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_4169_nat__less__eq__zless,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_less_eq_zless
thf(fact_4170_nat__le__eq__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% nat_le_eq_zle
thf(fact_4171_split__nat,axiom,
    ! [P: nat > $o,I2: int] :
      ( ( P @ ( nat2 @ I2 ) )
      = ( ! [N: nat] :
            ( ( I2
              = ( semiring_1_of_nat @ int @ N ) )
           => ( P @ N ) )
        & ( ( ord_less @ int @ I2 @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_4172_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_4173_le__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N2 @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ) ).

% le_nat_iff
thf(fact_4174_nat__add__distrib,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( nat2 @ ( plus_plus @ int @ Z2 @ Z7 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_4175_nat__mult__distrib,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) ) ) ) ).

% nat_mult_distrib
thf(fact_4176_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_4177_nat__abs__triangle__ineq,axiom,
    ! [K: int,L2: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L2 ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_4178_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib
thf(fact_4179_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib'
thf(fact_4180_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_4181_nat__power__eq,axiom,
    ! [Z2: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( power_power @ int @ Z2 @ N2 ) )
        = ( power_power @ nat @ ( nat2 @ Z2 ) @ N2 ) ) ) ).

% nat_power_eq
thf(fact_4182_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_4183_div__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_4184_floor__eq3,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N2 ) ) ) ).

% floor_eq3
thf(fact_4185_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_4186_mod__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_4187_take__bit__nat__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_4188_nat__take__bit__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_4189_bit__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N2 )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_nat_iff
thf(fact_4190_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_4191_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_4192_sgn__power__injE,axiom,
    ! [A2: real,N2: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N2 ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N2 ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_4193_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( suc @ ( nat2 @ Z2 ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_4194_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_4195_nat__mult__distrib__neg,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z2 ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z7 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_4196_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_4197_floor__eq4,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N2 ) ) ) ).

% floor_eq4
thf(fact_4198_diff__nat__eq__if,axiom,
    ! [Z7: int,Z2: int] :
      ( ( ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) )
          = ( nat2 @ Z2 ) ) )
      & ( ~ ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z2 @ Z7 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z2 @ Z7 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4199_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] : ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K2 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K2 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_4200_cis__Arg__unique,axiom,
    ! [Z2: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z2 )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z2 )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_4201_Arg__correct,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z2 )
          = ( cis @ ( arg @ Z2 ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
        & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ) ).

% Arg_correct
thf(fact_4202_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_4203_powr__real__of__int,axiom,
    ! [X: real,N2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N2 ) )
            = ( power_power @ real @ X @ ( nat2 @ N2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N2 ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_4204_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_4205_Arg__def,axiom,
    ( arg
    = ( ^ [Z6: complex] :
          ( if @ real
          @ ( Z6
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A4: real] :
                ( ( ( sgn_sgn @ complex @ Z6 )
                  = ( cis @ A4 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A4 )
                & ( ord_less_eq @ real @ A4 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4206_buildup__gives__empty,axiom,
    ! [N2: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N2 ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_4207_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ int ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( zero_zero @ int ) )
              @ K2
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4208_cis__multiple__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_4209_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_4210_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4211_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4212_empty__subsetI,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% empty_subsetI
thf(fact_4213_subset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_4214_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4215_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4216_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4217_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4218_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4219_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4220_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_4221_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% Diff_eq_empty_iff
thf(fact_4222_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4223_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4224_or__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4225_or__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4226_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_4227_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_4228_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ) ).

% floor_add2
thf(fact_4229_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_4230_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4231_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_4232_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_4233_or__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4234_or__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4235_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4236_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4237_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4238_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_or_eq
thf(fact_4239_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4240_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_4241_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z2 ) @ X )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ X ) @ ( bit_se1065995026697491101ons_or @ A @ Z2 @ X ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4242_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z2 ) @ X )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4243_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ X @ Z2 ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4244_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z2 ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4245_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_or_iff
thf(fact_4246_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4247_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4248_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_or_eq
thf(fact_4249_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4250_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B5: A] : ( bit_se1065995026697491101ons_or @ A @ B5 @ A4 ) ) ) ) ).

% or.commute
thf(fact_4251_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4252_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4253_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4254_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4255_bit__or__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        | ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ).

% bit_or_int_iff
thf(fact_4256_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_4257_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_4258_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_4259_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: num] : ( member @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_4260_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_4261_not__psubset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_4262_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_4263_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) ) ) ) ).

% OR_lower
thf(fact_4264_or__greater__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) ) ) ).

% or_greater_eq
thf(fact_4265_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4266_plus__and__or,axiom,
    ! [X: int,Y: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) )
      = ( plus_plus @ int @ X @ Y ) ) ).

% plus_and_or
thf(fact_4267_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_4268_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_4269_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_4270_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_4271_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4272_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4273_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_4274_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_4275_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_4276_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_4277_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_4278_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_4279_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% mask_Suc_exp
thf(fact_4280_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_4281_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_4282_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_4283_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4284_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4285_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4286_OR__upper,axiom,
    ! [X: int,N2: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% OR_upper
thf(fact_4287_sin__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_4288_cos__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_4289_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4290_or__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4291_or__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4292_pred__subset__eq,axiom,
    ! [A: $tType,R2: set @ A,S3: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X2: A] : ( member @ A @ X2 @ R2 )
        @ ^ [X2: A] : ( member @ A @ X2 @ S3 ) )
      = ( ord_less_eq @ ( set @ A ) @ R2 @ S3 ) ) ).

% pred_subset_eq
thf(fact_4293_xor__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_4294_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) )
          = Y ) ) ).

% bit.xor_left_self
thf(fact_4295_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4296_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_4297_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_4298_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_4299_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_4300_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_4301_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_4302_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_4303_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_4304_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_4305_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_4306_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_4307_or__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(2)
thf(fact_4308_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_4309_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_4310_or__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(1)
thf(fact_4311_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_4312_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_4313_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y ) ) ) ).

% xor_nat_numerals(2)
thf(fact_4314_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% xor_nat_numerals(1)
thf(fact_4315_or__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4316_or__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4317_or__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4318_or__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4319_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_4320_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_4321_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4322_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_4323_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4324_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4325_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_4326_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A4: A,B5: A] : ( bit_se5824344971392196577ns_xor @ A @ B5 @ A4 ) ) ) ) ).

% xor.commute
thf(fact_4327_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_4328_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_xor_eq
thf(fact_4329_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N2 )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_xor_iff
thf(fact_4330_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z2 ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_4331_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z2 ) @ X )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_4332_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_xor_eq
thf(fact_4333_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4334_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4335_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4336_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4337_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4338_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4339_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% or_nat_def
thf(fact_4340_subrelI,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X5: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y3 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y3 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ).

% subrelI
thf(fact_4341_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4342_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4343_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_4344_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R2 )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ S3 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S3 ) ) ).

% pred_subset_eq2
thf(fact_4345_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R2 ) )
        = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ S3 ) ) )
      = ( R2 = S3 ) ) ).

% pred_equals_eq2
thf(fact_4346_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa2: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M4: num] :
                ( ( Xa2
                  = ( bit0 @ M4 ) )
               => ( Y
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa2
                    = ( bit1 @ M4 ) )
                 => ( Y
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X
                    = ( bit0 @ N3 ) )
               => ( ( Xa2 = one2 )
                 => ( Y
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ! [M4: num] :
                        ( ( Xa2
                          = ( bit0 @ M4 ) )
                       => ( Y
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa2
                            = ( bit1 @ M4 ) )
                         => ( Y
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X
                          = ( bit1 @ N3 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ! [M4: num] :
                              ( ( Xa2
                                = ( bit0 @ M4 ) )
                             => ( Y
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa2
                                  = ( bit1 @ M4 ) )
                               => ( Y
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4347_Suc__0__or__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4348_or__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4349_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4350_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_4351_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_4352_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_4353_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_4354_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4355_Suc__0__xor__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_4356_and__int_Oelims,axiom,
    ! [X: int,Xa2: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4357_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4358_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4359_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P2 )
      = P2 ) ).

% case_prod_Pair_iden
thf(fact_4360_insert__subset,axiom,
    ! [A: $tType,X: A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B3 )
      = ( ( member @ A @ X @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% insert_subset
thf(fact_4361_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A3: set @ A] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4362_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B2: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4363_xor__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_4364_xor__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_4365_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A3 ) ) ) ).

% subset_Compl_singleton
thf(fact_4366_set__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4367_bit__xor__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ N2 )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
         != ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ) ).

% bit_xor_int_iff
thf(fact_4368_insert__mono,axiom,
    ! [A: $tType,C6: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C6 ) @ ( insert @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_4369_subset__insert,axiom,
    ! [A: $tType,X: A,A3: set @ A,B3: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% subset_insert
thf(fact_4370_subset__insertI,axiom,
    ! [A: $tType,B3: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert @ A @ A2 @ B3 ) ) ).

% subset_insertI
thf(fact_4371_subset__insertI2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) ).

% subset_insertI2
thf(fact_4372_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) ) ) ) ).

% XOR_lower
thf(fact_4373_subset__singletonD,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4374_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4375_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,X: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ ( insert @ A @ X @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ C6 ) )
        & ~ ( member @ A @ X @ A3 ) ) ) ).

% subset_Diff_insert
thf(fact_4376_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B3 ) ) ) ).

% Diff_single_insert
thf(fact_4377_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B3 ) )
      = ( ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% subset_insert_iff
thf(fact_4378_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ ( insert @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_4379_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% xor_nat_def
thf(fact_4380_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B3 ) )
      = ( ( ( member @ A @ X @ B3 )
         => ( ord_less @ ( set @ A ) @ A3 @ B3 ) )
        & ( ~ ( member @ A @ X @ B3 )
         => ( ( ( member @ A @ X @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
            & ( ~ ( member @ A @ X @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4381_set__replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N2 ) @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4382_set__replicate__conv__if,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4383_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4384_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I3: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I3 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I3 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4385_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4386_XOR__upper,axiom,
    ! [X: int,N2: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% XOR_upper
thf(fact_4387_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_4388_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N2 ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4389_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( K2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L )
          @ ( if @ int
            @ ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K2 )
            @ ( if @ int
              @ ( K2
                = ( zero_zero @ int ) )
              @ L
              @ ( if @ int
                @ ( L
                  = ( zero_zero @ int ) )
                @ K2
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_4390_and__int_Opsimps,axiom,
    ! [K: int,L2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L2 ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4391_and__int_Opelims,axiom,
    ! [X: int,Xa2: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% and_int.pelims
thf(fact_4392_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_4393_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X )
            = ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( X = Y ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_4394_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = X ) ) ).

% bit.double_compl
thf(fact_4395_push__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_4396_push__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_4397_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_4398_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_4399_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_4400_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_4401_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_right
thf(fact_4402_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_left
thf(fact_4403_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4404_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_4405_concat__bit__of__zero__1,axiom,
    ! [N2: nat,L2: int] :
      ( ( bit_concat_bit @ N2 @ ( zero_zero @ int ) @ L2 )
      = ( bit_se4730199178511100633sh_bit @ int @ N2 @ L2 ) ) ).

% concat_bit_of_zero_1
thf(fact_4406_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_4407_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_4408_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4409_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4410_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_4411_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_4412_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_4413_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4414_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4415_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_4416_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_4417_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_4418_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_4419_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_4420_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_4421_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_4422_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_4423_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_4424_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_4425_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_4426_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_4427_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_4428_push__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% push_bit_of_Suc_0
thf(fact_4429_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_of_1
thf(fact_4430_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( ( N2
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_4431_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_4432_and__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4433_or__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4434_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N2 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_4435_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_4436_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_4437_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_4438_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_4439_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_4440_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_4441_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_4442_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_4443_bit__not__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff
thf(fact_4444_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_push_bit
thf(fact_4445_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N2 @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_4446_push__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_4447_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K2: int] : ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_4448_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_4449_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_4450_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_4451_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_4452_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B5 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4453_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B5 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4454_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) ) ) ) ).

% or_int_def
thf(fact_4455_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_4456_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_4457_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( bit_se1065995026697491101ons_or @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4458_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_4459_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_4460_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_4461_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_4462_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_4463_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_4464_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4465_atLeast0__atMost__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4466_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_4467_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N2 )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4468_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) )
        = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4469_atLeastAtMost__insertL,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4470_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_4471_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_4472_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_4473_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y5 ) ) ) ) ) ).

% bit.xor_def
thf(fact_4474_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y5: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y5 ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4475_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4476_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4477_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_4478_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K2: int,L: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ) ) ).

% concat_bit_eq
thf(fact_4479_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ L ) ) ) ) ).

% xor_int_def
thf(fact_4480_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4481_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K2: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ) ) ).

% concat_bit_def
thf(fact_4482_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_4483_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K2: int] : ( bit_se1065995026697491101ons_or @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4484_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N: nat,K2: int] : ( bit_se5824344971392196577ns_xor @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_4485_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_4486_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_4487_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_4488_and__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_4489_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_4490_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4491_or__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4492_bit__minus__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N2 )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N2 ) ) ).

% bit_minus_int_iff
thf(fact_4493_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4494_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_4495_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_4496_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4497_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4498_numeral__or__not__num__eq,axiom,
    ! [M: num,N2: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4499_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_4500_and__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_4501_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_4502_or__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4503_and__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_4504_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4505_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N: nat,K2: int] : ( times_times @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_int_def
thf(fact_4506_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_nat_def
thf(fact_4507_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_4508_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_4509_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N2 @ B6 ) ) ) ) ).

% exp_dvdE
thf(fact_4510_atLeast1__atMost__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4511_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4512_and__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_4513_and__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_4514_or__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4515_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N2 )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_not_iff_eq
thf(fact_4516_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_4517_push__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_minus_one
thf(fact_4518_set__decode__plus__power__2,axiom,
    ! [N2: nat,Z2: nat] :
      ( ~ ( member @ nat @ N2 @ ( nat_set_decode @ Z2 ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ Z2 ) )
        = ( insert @ nat @ N2 @ ( nat_set_decode @ Z2 ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4519_or__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4520_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4521_and__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_4522_or__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4523_or__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4524_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_4525_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) @ N ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4526_and__int_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [K3: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K3 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K3 @ L4 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% and_int.pinduct
thf(fact_4527_upto_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [I4: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I4 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I4 @ J2 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I4 @ J2 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% upto.pinduct
thf(fact_4528_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4529_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4530_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_4531_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_4532_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_4533_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_4534_set__encode__insert,axiom,
    ! [A3: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ~ ( member @ nat @ N2 @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N2 @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4535_Sum__Ico__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4536_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4537_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X4: nat > real] :
        ! [J3: nat] :
        ? [M9: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M9 @ M3 )
         => ! [N: nat] :
              ( ( ord_less_eq @ nat @ M9 @ N )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X4 @ M3 ) @ ( X4 @ N ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_4538_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4539_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_4540_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) )
          = ( ( ord_less_eq @ A @ L2 @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4541_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4542_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4543_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,J: A,M: A,N2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
          = ( ( ord_less_eq @ A @ J @ I2 )
            | ( ( ord_less_eq @ A @ M @ I2 )
              & ( ord_less_eq @ A @ J @ N2 ) ) ) ) ) ).

% ivl_subset
thf(fact_4544_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4545_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4546_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4547_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_4548_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,N2: A,M: A] :
          ( ( ord_less_eq @ A @ I2 @ N2 )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ N2 ) )
            = ( set_or7035219750837199246ssThan @ A @ N2 @ M ) ) ) ) ).

% ivl_diff
thf(fact_4549_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( ( F2 @ X2 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_4550_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_4551_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_4552_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4553_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4554_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4555_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_4556_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4557_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4558_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4559_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D2 @ I3 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D2 @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4560_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less_eq @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4561_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N: nat] : ( ord_less_eq @ nat @ ( F2 @ N ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4562_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4563_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ! [X5: nat] :
          ( ( member @ nat @ X5 @ N4 )
         => ( ord_less @ nat @ X5 @ N2 ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4564_finite__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs2: list @ A] :
          ( ( set2 @ A @ Xs2 )
          = A3 ) ) ).

% finite_list
thf(fact_4565_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4566_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4567_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4568_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4569_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I2: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K2: nat] :
            ( ( P @ K2 )
            & ( ord_less @ nat @ K2 @ I2 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4570_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4571_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4572_all__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4573_ex__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4574_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L2 @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L2 @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_4575_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S3: set @ A] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S3 )
                & ~ ? [Xa: A] :
                      ( ( member @ A @ Xa @ S3 )
                      & ( ord_less @ A @ Xa @ X5 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4576_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ X8 )
                    & ( ord_less @ A @ X5 @ Xa ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_4577_sum__mono__inv,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I7 > A,I6: set @ I7,G: I7 > A,I2: I7] :
          ( ( ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ I6 )
            = ( groups7311177749621191930dd_sum @ I7 @ A @ G @ I6 ) )
         => ( ! [I4: I7] :
                ( ( member @ I7 @ I4 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
           => ( ( member @ I7 @ I2 @ I6 )
             => ( ( finite_finite @ I7 @ I6 )
               => ( ( F2 @ I2 )
                  = ( G @ I2 ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4578_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4579_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4580_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_4581_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4582_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I6 )
                  & ( ( X @ I3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I6 )
                    & ( ( Y @ I3 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I6 )
                    & ( ( plus_plus @ A @ ( X @ I3 ) @ ( Y @ I3 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4583_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_4584_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I6 )
                  & ( ( X @ I3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I6 )
                    & ( ( Y @ I3 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I6 )
                    & ( ( times_times @ A @ ( X @ I3 ) @ ( Y @ I3 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4585_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4586_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( P @ X2 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_4587_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X2 )
                & ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4588_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X5: B] :
                  ( ( ord_less_eq @ B @ C2 @ X5 )
                 => ( ( ord_less @ B @ X5 @ D2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4589_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X5: B] :
                  ( ( ord_less_eq @ B @ C2 @ X5 )
                 => ( ( ord_less @ B @ X5 @ D2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4590_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4591_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,P2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4592_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_4593_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_4594_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_4595_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4596_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                   => ( ( F2 @ X2 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4597_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G: C > A,I2: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X5: C] :
                  ( ( member @ C @ X5 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X5 ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S )
                   => ? [Xa: C] :
                        ( ( member @ C @ Xa @ T2 )
                        & ( ( I2 @ Xa )
                          = X5 )
                        & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ Xa ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4598_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I7,F2: I7 > A,G: I7 > A] :
          ( ( finite_finite @ I7 @ A3 )
         => ( ! [X5: I7] :
                ( ( member @ I7 @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ? [X3: I7] :
                  ( ( member @ I7 @ X3 @ A3 )
                  & ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ I7 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4599_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R2: A > A > $o,S3: set @ B,H2: B > A,G: B > A] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R2 @ X15 @ X23 )
                  & ( R2 @ Y15 @ Y23 ) )
               => ( R2 @ ( plus_plus @ A @ X15 @ Y15 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S3 )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( R2 @ ( H2 @ X5 ) @ ( G @ X5 ) ) )
               => ( R2 @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4600_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S3: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X5: B,S4: set @ B] :
                  ( ( finite_finite @ B @ S4 )
                 => ( ! [Y4: B] :
                        ( ( member @ B @ Y4 @ S4 )
                       => ( ord_less_eq @ A @ ( F2 @ Y4 ) @ ( F2 @ X5 ) ) )
                   => ( ( P @ S4 )
                     => ( P @ ( insert @ B @ X5 @ S4 ) ) ) ) )
             => ( P @ S3 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4601_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( ord_less @ A @ B6 @ X3 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4602_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( ord_less @ A @ X3 @ B6 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4603_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ A3 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4604_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R2: A > A > $o,S3: set @ B,H2: B > A,G: B > A] :
          ( ( R2 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R2 @ X15 @ X23 )
                  & ( R2 @ Y15 @ Y23 ) )
               => ( R2 @ ( times_times @ A @ X15 @ Y15 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S3 )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( R2 @ ( H2 @ X5 ) @ ( G @ X5 ) ) )
               => ( R2 @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4605_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4606_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4607_atLeast0__lessThan__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_4608_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_4609_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ A3 )
                 => ( dvd_dvd @ A @ ( F2 @ A6 ) @ ( G @ A6 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_4610_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,S3: set @ B,I2: C > B,J: B > C,T6: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                 => ( ( I2 @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                   => ( member @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I2 @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I2 @ B6 ) @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) ) )
                   => ( ! [A6: B] :
                          ( ( member @ B @ A6 @ S5 )
                         => ( ( G @ A6 )
                            = ( one_one @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T5 )
                           => ( ( H2 @ B6 )
                              = ( one_one @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member @ B @ A6 @ S3 )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_4611_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( ( F2 @ X2 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( ( X2 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4612_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( ( F2 @ X2 )
                = ( one_one @ nat ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( ( X2 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4613_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B3: A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B3 )
             => ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ B3 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4614_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I2 @ S )
               => ( ( F2 @ I2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4615_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4616_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_4617_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K2: A] :
                ( ( member @ A @ K2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K2 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4618_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4619_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4620_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4621_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4622_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4623_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4624_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4625_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4626_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4627_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ N2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4628_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,I2: B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( member @ B @ I2 @ I6 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4629_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ N2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4630_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4631_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,I2: A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( member @ A @ I2 @ I6 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) )
             => ( ! [I4: A] :
                    ( ( member @ A @ I4 @ I6 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4632_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I6 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4633_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4634_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4635_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4636_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4637_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B3 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4638_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B3 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4639_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4640_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4641_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4642_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4643_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ X5 )
                    = ( one_one @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S3 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4644_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S3 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4645_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4646_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4647_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4648_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4649_sum__diff__nat,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4650_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4651_atLeastLessThanSuc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4652_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sum.nested_swap
thf(fact_4653_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4654_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% prod.nested_swap
thf(fact_4655_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4656_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4657_prod__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_fact
thf(fact_4658_prod__Suc__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_Suc_fact
thf(fact_4659_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z6: A] :
                  ( ( power_power @ A @ Z6 @ N2 )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4660_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S3: A,A3: set @ nat,S5: A,F2: nat > A] :
          ( ( sums @ A @ G @ S3 )
         => ( ( finite_finite @ nat @ A3 )
           => ( ( S5
                = ( plus_plus @ A @ S3
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G @ N ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N: nat] : ( if @ A @ ( member @ nat @ N @ A3 ) @ ( F2 @ N ) @ ( G @ N ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4661_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S3: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ S5 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T5 )
                     => ( ( G @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S3 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4662_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4663_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4664_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                  & ( ord_less @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4665_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( ! [B6: B] :
                  ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4666_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A3 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4667_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4668_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4669_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4670_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4671_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I6: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I6 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I6 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I6 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4672_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4673_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4674_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4675_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4676_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4677_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4678_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S3 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4679_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M3 )
                 => ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N ) ) ) @ E4 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4680_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) ) @ E ) ) ) ) ) ) ).

% CauchyD
thf(fact_4681_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_4682_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X4 @ M3 ) @ ( X4 @ N ) ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_4683_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B3: set @ A,A3: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X5: A] :
                      ( ( member @ A @ X5 @ B3 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X5 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4684_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I2: C,A3: set @ C,F2: C > B] :
          ( ( member @ C @ I2 @ A3 )
         => ( ! [X5: C] :
                ( ( member @ C @ X5 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I2 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X5 ) ) )
           => ( ( finite_finite @ C @ A3 )
             => ( ord_less_eq @ B @ ( F2 @ I2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4685_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B3: set @ A,A3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B6 ) ) )
             => ( ! [A6: A] :
                    ( ( member @ A @ A6 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A6 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4686_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4687_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4688_ln__prod,axiom,
    ! [A: $tType,I6: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I6 )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I6 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I4 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I6 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) )
            @ I6 ) ) ) ) ).

% ln_prod
thf(fact_4689_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4690_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( bit_se4730199178511100633sh_bit @ A @ K2 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ K2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% take_bit_sum
thf(fact_4691_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
                & ( ( C2 @ I3 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4692_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4693_atLeast1__lessThan__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4694_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N2 @ K ) @ N2 ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4695_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4696_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K2 @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4697_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4698_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4699_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) )
              @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4700_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4701_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F5 @ ( nth @ B @ Xs3 @ N ) ) @ ( power_power @ A @ A4 @ N ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4702_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: nat > A,B2: nat > A] :
          ( ! [I4: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I4 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N2 )
               => ( ord_less_eq @ A @ ( A2 @ I4 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I4: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N2 )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I4 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ K2 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4703_Chebyshev__sum__upper__nat,axiom,
    ! [N2: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I4: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I4 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N2 )
           => ( ord_less_eq @ nat @ ( A2 @ I4 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I4: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I4 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N2 )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I4 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N2
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( B2 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4704_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4705_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4706_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4707_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less_eq @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4708_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less_eq @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4709_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less @ nat @ N @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4710_finite__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N2 )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4711_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X3 ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_4712_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L2 @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L2 @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_4713_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( ord_less_eq @ A @ X5 @ A2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X5 )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4714_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( ord_less_eq @ A @ A2 @ X5 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X5 @ Xa )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4715_rev__finite__subset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% rev_finite_subset
thf(fact_4716_infinite__super,axiom,
    ! [A: $tType,S3: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S3 @ T6 )
     => ( ~ ( finite_finite @ A @ S3 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_4717_finite__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( finite_finite @ A @ B3 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% finite_subset
thf(fact_4718_finite__psubset__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A3 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite @ A @ A8 )
           => ( ! [B10: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B10 @ A8 )
                 => ( P @ B10 ) )
             => ( P @ A8 ) ) )
       => ( P @ A3 ) ) ) ).

% finite_psubset_induct
thf(fact_4719_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X5 )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4720_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X5 @ Xa )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4721_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A6: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A6 @ A3 )
                 => ( ~ ( member @ A @ A6 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ A6 @ F6 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4722_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A6: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A6 @ A3 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A3 )
                   => ( ~ ( member @ A @ A6 @ F6 )
                     => ( ( P @ F6 )
                       => ( P @ ( insert @ A @ A6 @ F6 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4723_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B3: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B3 )
         => ( P @ B3 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% remove_induct
thf(fact_4724_finite__remove__induct,axiom,
    ! [A: $tType,B3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% finite_remove_induct
thf(fact_4725_finite__induct__select,axiom,
    ! [A: $tType,S3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S3 )
             => ( ( P @ T7 )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ ( minus_minus @ ( set @ A ) @ S3 @ T7 ) )
                    & ( P @ ( insert @ A @ X3 @ T7 ) ) ) ) )
         => ( P @ S3 ) ) ) ) ).

% finite_induct_select
thf(fact_4726_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4727_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N2 @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4728_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_4729_real__root__zero,axiom,
    ! [N2: nat] :
      ( ( root @ N2 @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4730_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_4731_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4732_real__root__eq__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( root @ N2 @ Y ) )
        = ( X = Y ) ) ) ).

% real_root_eq_iff
thf(fact_4733_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4734_real__root__eq__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4735_real__root__less__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ X @ Y ) ) ) ).

% real_root_less_iff
thf(fact_4736_real__root__le__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ X @ Y ) ) ) ).

% real_root_le_iff
thf(fact_4737_real__root__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4738_real__root__eq__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4739_real__root__lt__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4740_real__root__gt__0__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_gt_0_iff
thf(fact_4741_real__root__ge__0__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_ge_0_iff
thf(fact_4742_real__root__le__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4743_real__root__gt__1__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_gt_1_iff
thf(fact_4744_real__root__lt__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4745_real__root__ge__1__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_ge_1_iff
thf(fact_4746_real__root__le__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4747_real__root__pow__pos2,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_4748_real__root__minus,axiom,
    ! [N2: nat,X: real] :
      ( ( root @ N2 @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( root @ N2 @ X ) ) ) ).

% real_root_minus
thf(fact_4749_real__root__mult__exp,axiom,
    ! [M: nat,N2: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M @ N2 ) @ X )
      = ( root @ M @ ( root @ N2 @ X ) ) ) ).

% real_root_mult_exp
thf(fact_4750_real__root__mult,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( root @ N2 @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ).

% real_root_mult
thf(fact_4751_real__root__commute,axiom,
    ! [M: nat,N2: nat,X: real] :
      ( ( root @ M @ ( root @ N2 @ X ) )
      = ( root @ N2 @ ( root @ M @ X ) ) ) ).

% real_root_commute
thf(fact_4752_real__root__divide,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( root @ N2 @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ).

% real_root_divide
thf(fact_4753_real__root__inverse,axiom,
    ! [N2: nat,X: real] :
      ( ( root @ N2 @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N2 @ X ) ) ) ).

% real_root_inverse
thf(fact_4754_real__root__pos__pos__le,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_4755_real__root__less__mono,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ) ).

% real_root_less_mono
thf(fact_4756_real__root__le__mono,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ) ).

% real_root_le_mono
thf(fact_4757_real__root__power,axiom,
    ! [N2: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N2 @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_4758_real__root__abs,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N2 @ X ) ) ) ) ).

% real_root_abs
thf(fact_4759_sgn__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( sgn_sgn @ real @ ( root @ N2 @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_4760_real__root__gt__zero,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_4761_real__root__strict__decreasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N4 @ X ) @ ( root @ N2 @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4762_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4763_root__abs__power,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( abs_abs @ real @ ( root @ N2 @ ( power_power @ real @ Y @ N2 ) ) )
        = ( abs_abs @ real @ Y ) ) ) ).

% root_abs_power
thf(fact_4764_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_4765_real__root__pos__pos,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_4766_real__root__strict__increasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4767_real__root__decreasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N4 @ X ) @ ( root @ N2 @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4768_real__root__pow__pos,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_4769_real__root__pos__unique,axiom,
    ! [N2: nat,Y: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( power_power @ real @ Y @ N2 )
            = X )
         => ( ( root @ N2 @ X )
            = Y ) ) ) ) ).

% real_root_pos_unique
thf(fact_4770_real__root__power__cancel,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N2 @ ( power_power @ real @ X @ N2 ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_4771_odd__real__root__pow,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
        = X ) ) ).

% odd_real_root_pow
thf(fact_4772_odd__real__root__unique,axiom,
    ! [N2: nat,Y: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ( power_power @ real @ Y @ N2 )
          = X )
       => ( ( root @ N2 @ X )
          = Y ) ) ) ).

% odd_real_root_unique
thf(fact_4773_odd__real__root__power__cancel,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X @ N2 ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_4774_real__root__increasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4775_sgn__power__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N2 @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N2 @ X ) ) @ N2 ) )
        = X ) ) ).

% sgn_power_root
thf(fact_4776_root__sgn__power,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) ) )
        = Y ) ) ).

% root_sgn_power
thf(fact_4777_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4778_ln__root,axiom,
    ! [N2: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N2 @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% ln_root
thf(fact_4779_log__root,axiom,
    ! [N2: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N2 @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_root
thf(fact_4780_log__base__root,axiom,
    ! [N2: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N2 @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_4781_split__root,axiom,
    ! [P: real > $o,N2: nat,X: real] :
      ( ( P @ ( root @ N2 @ X ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ! [Y5: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N2 ) )
                = X )
             => ( P @ Y5 ) ) ) ) ) ).

% split_root
thf(fact_4782_root__powr__inverse,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N2 @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4783_infinite__int__iff__unbounded,axiom,
    ! [S3: set @ int] :
      ( ( ~ ( finite_finite @ int @ S3 ) )
      = ( ! [M3: int] :
          ? [N: int] :
            ( ( ord_less @ int @ M3 @ ( abs_abs @ int @ N ) )
            & ( member @ int @ N @ S3 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4784_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I6: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I3: A] :
                    ( ( member @ A @ I3 @ I6 )
                    & ( ( F2 @ I3 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I2 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I2 ) ) ) )
              & ( ~ ( member @ A @ I2 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4785_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_4786_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,P2: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I6 )
                  & ( ( P2 @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I2 @ I6 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I6 ) ) )
            & ( ~ ( member @ B @ I2 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I2 @ I6 ) )
                = ( plus_plus @ A @ ( P2 @ I2 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I6 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4787_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_4788_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
              @ I6 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_4789_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4790_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4791_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( H2 @ I4 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S3 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4792_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S3 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4793_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I6 )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I6 )
                    & ( ( H2 @ X2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
                @ I6 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4794_unbounded__k__infinite,axiom,
    ! [K: nat,S3: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N9: nat] :
              ( ( ord_less @ nat @ M4 @ N9 )
              & ( member @ nat @ N9 @ S3 ) ) )
     => ~ ( finite_finite @ nat @ S3 ) ) ).

% unbounded_k_infinite
thf(fact_4795_infinite__nat__iff__unbounded,axiom,
    ! [S3: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S3 ) )
      = ( ! [M3: nat] :
          ? [N: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( member @ nat @ N @ S3 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4796_infinite__nat__iff__unbounded__le,axiom,
    ! [S3: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S3 ) )
      = ( ! [M3: nat] :
          ? [N: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( member @ nat @ N @ S3 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4797_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X5 )
            = N2 ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N2 ) ) ) ).

% length_mul_elem
thf(fact_4798_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4799_csqrt_Osimps_I1_J,axiom,
    ! [Z2: complex] :
      ( ( re @ ( csqrt @ Z2 ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_4800_complex__Re__numeral,axiom,
    ! [V2: num] :
      ( ( re @ ( numeral_numeral @ complex @ V2 ) )
      = ( numeral_numeral @ real @ V2 ) ) ).

% complex_Re_numeral
thf(fact_4801_Re__divide__of__nat,axiom,
    ! [Z2: complex,N2: nat] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Re_divide_of_nat
thf(fact_4802_Re__divide__of__real,axiom,
    ! [Z2: complex,R: real] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ R ) ) ).

% Re_divide_of_real
thf(fact_4803_Re__sgn,axiom,
    ! [Z2: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z2 ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% Re_sgn
thf(fact_4804_Re__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_4805_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K2: code_integer] :
          ( if @ code_integer
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4806_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M3: num,N: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_4807_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_4808_one__complex_Osimps_I1_J,axiom,
    ( ( re @ ( one_one @ complex ) )
    = ( one_one @ real ) ) ).

% one_complex.simps(1)
thf(fact_4809_plus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( plus_plus @ complex @ X @ Y ) )
      = ( plus_plus @ real @ ( re @ X ) @ ( re @ Y ) ) ) ).

% plus_complex.simps(1)
thf(fact_4810_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( re @ X ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4811_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_4812_Re__csqrt,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) ) ).

% Re_csqrt
thf(fact_4813_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) ) ).

% one_integer.rsp
thf(fact_4814_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_4815_cmod__plus__Re__le__0__iff,axiom,
    ! [Z2: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z2 )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_4816_cos__n__Re__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_4817_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z6: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z6 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z6 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_4818_csqrt_Osimps_I2_J,axiom,
    ! [Z2: complex] :
      ( ( im @ ( csqrt @ Z2 ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z2 )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z2 ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4819_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K2: int] :
          ( if @ code_integer @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K2 ) ) )
          @ ( if @ code_integer
            @ ( K2
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4820_Im__divide__of__real,axiom,
    ! [Z2: complex,R: real] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ R ) ) ).

% Im_divide_of_real
thf(fact_4821_Im__sgn,axiom,
    ! [Z2: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z2 ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% Im_sgn
thf(fact_4822_Re__power__real,axiom,
    ! [X: complex,N2: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N2 ) )
        = ( power_power @ real @ ( re @ X ) @ N2 ) ) ) ).

% Re_power_real
thf(fact_4823_Im__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_4824_Im__divide__of__nat,axiom,
    ! [Z2: complex,N2: nat] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Im_divide_of_nat
thf(fact_4825_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_4826_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_4827_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_4828_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K2: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K2 ) @ K2 ) ) ) ).

% abs_integer_code
thf(fact_4829_less__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( ord_less @ int @ Xa2 @ X ) ) ).

% less_integer.abs_eq
thf(fact_4830_modulo__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( modulo_modulo @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( modulo_modulo @ int @ Xa2 @ X ) ) ) ).

% modulo_integer.abs_eq
thf(fact_4831_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_4832_divide__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa2 @ X ) ) ) ).

% divide_integer.abs_eq
thf(fact_4833_imaginary__unit_Osimps_I2_J,axiom,
    ( ( im @ imaginary_unit )
    = ( one_one @ real ) ) ).

% imaginary_unit.simps(2)
thf(fact_4834_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_4835_one__integer__def,axiom,
    ( ( one_one @ code_integer )
    = ( code_integer_of_int @ ( one_one @ int ) ) ) ).

% one_integer_def
thf(fact_4836_plus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( plus_plus @ complex @ X @ Y ) )
      = ( plus_plus @ real @ ( im @ X ) @ ( im @ Y ) ) ) ).

% plus_complex.simps(2)
thf(fact_4837_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( im @ X ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_4838_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_4839_times__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( times_times @ complex @ X @ Y ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) ) ) ).

% times_complex.simps(2)
thf(fact_4840_cmod__Re__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( im @ X )
        = ( im @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_4841_cmod__Im__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( re @ X )
        = ( re @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_4842_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( times_times @ complex @ X @ Y ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) ) ).

% times_complex.simps(1)
thf(fact_4843_plus__complex_Ocode,axiom,
    ( ( plus_plus @ complex )
    = ( ^ [X2: complex,Y5: complex] : ( complex2 @ ( plus_plus @ real @ ( re @ X2 ) @ ( re @ Y5 ) ) @ ( plus_plus @ real @ ( im @ X2 ) @ ( im @ Y5 ) ) ) ) ) ).

% plus_complex.code
thf(fact_4844_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X2: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X2 ) ) @ ( times_times @ real @ R5 @ ( im @ X2 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_4845_csqrt__principal,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) )
      | ( ( ( re @ ( csqrt @ Z2 ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z2 ) ) ) ) ) ).

% csqrt_principal
thf(fact_4846_cmod__le,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_le
thf(fact_4847_sin__n__Im__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_4848_Re__exp,axiom,
    ! [Z2: complex] :
      ( ( re @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( cos @ real @ ( im @ Z2 ) ) ) ) ).

% Re_exp
thf(fact_4849_Im__exp,axiom,
    ! [Z2: complex] :
      ( ( im @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( sin @ real @ ( im @ Z2 ) ) ) ) ).

% Im_exp
thf(fact_4850_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X2: complex,Y5: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y5 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y5 ) ) ) ) ) ) ).

% times_complex.code
thf(fact_4851_cmod__power2,axiom,
    ! [Z2: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_4852_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_4853_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_4854_complex__eq__0,axiom,
    ! [Z2: complex] :
      ( ( Z2
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_4855_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_4856_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_4857_complex__neq__0,axiom,
    ! [Z2: complex] :
      ( ( ( Z2
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_4858_Re__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_4859_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_4860_csqrt__unique,axiom,
    ! [W: complex,Z2: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z2 )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z2 )
          = W ) ) ) ).

% csqrt_unique
thf(fact_4861_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_4862_Im__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_4863_complex__abs__le__norm,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% complex_abs_le_norm
thf(fact_4864_complex__unit__circle,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_4865_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X2: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_4866_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X2: complex,Y5: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_4867_Im__Reals__divide,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_4868_Re__Reals__divide,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_4869_set__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_4870_Re__divide__Reals,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z2 @ R ) )
        = ( divide_divide @ real @ ( re @ Z2 ) @ ( re @ R ) ) ) ) ).

% Re_divide_Reals
thf(fact_4871_Im__divide__Reals,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z2 @ R ) )
        = ( divide_divide @ real @ ( im @ Z2 ) @ ( re @ R ) ) ) ) ).

% Im_divide_Reals
thf(fact_4872_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_4873_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_4874_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_4875_Reals__1,axiom,
    ! [B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ B )
     => ( member @ B @ ( one_one @ B ) @ ( real_Vector_Reals @ B ) ) ) ).

% Reals_1
thf(fact_4876_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_4877_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_4878_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_4879_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N2 ) ) ).

% length_n_lists_elem
thf(fact_4880_length__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_n_lists
thf(fact_4881_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4882_complex__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_4883_integer__of__num_I3_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit1 @ N2 ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_4884_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K2 ) ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_4885_complex__cnj__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( cnj @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ complex @ ( cnj @ X ) @ ( cnj @ Y ) ) ) ).

% complex_cnj_divide
thf(fact_4886_complex__cnj__one__iff,axiom,
    ! [Z2: complex] :
      ( ( ( cnj @ Z2 )
        = ( one_one @ complex ) )
      = ( Z2
        = ( one_one @ complex ) ) ) ).

% complex_cnj_one_iff
thf(fact_4887_complex__cnj__one,axiom,
    ( ( cnj @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% complex_cnj_one
thf(fact_4888_one__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ int ) ) ).

% one_integer.rep_eq
thf(fact_4889_divide__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X @ Xa2 ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% divide_integer.rep_eq
thf(fact_4890_modulo__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( modulo_modulo @ code_integer @ X @ Xa2 ) )
      = ( modulo_modulo @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% modulo_integer.rep_eq
thf(fact_4891_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X2: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_4892_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K2: code_integer,L: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K2 ) @ ( code_int_of_integer @ L ) ) ) ) ).

% integer_less_iff
thf(fact_4893_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_4894_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_4895_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_4896_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_4897_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_4898_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_4899_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_4900_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_4901_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_4902_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_4903_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_4904_integer__of__num_I2_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit0 @ N2 ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) ) ).

% integer_of_num(2)
thf(fact_4905_complex__mod__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_4906_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_4907_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_4908_complex__norm__square,axiom,
    ! [Z2: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) ) ).

% complex_norm_square
thf(fact_4909_complex__add__cnj,axiom,
    ! [Z2: complex] :
      ( ( plus_plus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z2 ) ) ) ) ).

% complex_add_cnj
thf(fact_4910_complex__diff__cnj,axiom,
    ! [Z2: complex] :
      ( ( minus_minus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z2 ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_4911_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A4: complex,B5: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A4 @ ( cnj @ B5 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_4912_cnj__add__mult__eq__Re,axiom,
    ! [Z2: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z2 ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_4913_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K2 @ L ) @ ( modulo_modulo @ code_integer @ K2 @ L ) ) ) ) ).

% divmod_integer_def
thf(fact_4914_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K2 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) ) @ one2 ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_4915_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_4916_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K2 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4917_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_4918_nat__of__integer__code__post_I2_J,axiom,
    ( ( code_nat_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ nat ) ) ).

% nat_of_integer_code_post(2)
thf(fact_4919_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4920_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A4: B] :
                      ( ( member @ B @ A4 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A4 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_4921_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K2: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L ) ) ) ) ) ).

% divmod_abs_def
thf(fact_4922_card__Collect__less__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N2 ) ) )
      = N2 ) ).

% card_Collect_less_nat
thf(fact_4923_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_4924_card__Collect__le__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] : ( ord_less_eq @ nat @ I3 @ N2 ) ) )
      = ( suc @ N2 ) ) ).

% card_Collect_le_nat
thf(fact_4925_card__atLeastAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L2 ) ) ).

% card_atLeastAtMost
thf(fact_4926_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : Y
            @ A3 )
          = ( power_power @ A @ Y @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_4927_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ~ ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
          = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_4928_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : Y
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_4929_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ A2 @ B3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_4930_card__atLeastAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L2 @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L2 ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_4931_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A3 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_4932_card__subset__eq,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ( finite_card @ A @ A3 )
            = ( finite_card @ A @ B3 ) )
         => ( A3 = B3 ) ) ) ) ).

% card_subset_eq
thf(fact_4933_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N2 )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A3 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_4934_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,A3: set @ B,R: B > A > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ! [A6: B] :
            ( ( member @ B @ A6 @ A3 )
           => ? [B11: A] :
                ( ( member @ A @ B11 @ B3 )
                & ( R @ A6 @ B11 ) ) )
       => ( ! [A13: B,A24: B,B6: A] :
              ( ( member @ B @ A13 @ A3 )
             => ( ( member @ B @ A24 @ A3 )
               => ( ( member @ A @ B6 @ B3 )
                 => ( ( R @ A13 @ B6 )
                   => ( ( R @ A24 @ B6 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_4935_card__insert__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( insert @ A @ X @ A3 ) ) ) ).

% card_insert_le
thf(fact_4936_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N2 ) ) ) ).

% card_lists_length_eq
thf(fact_4937_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_4938_card__2__iff_H,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ S3 )
            & ? [Y5: A] :
                ( ( member @ A @ Y5 @ S3 )
                & ( X2 != Y5 )
                & ! [Z6: A] :
                    ( ( member @ A @ Z6 @ S3 )
                   => ( ( Z6 = X2 )
                      | ( Z6 = Y5 ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_4939_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_4940_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B5: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B5 @ B8 ) )
            & ~ ( member @ A @ B5 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_4941_card__insert__if,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( member @ A @ X @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
            = ( finite_card @ A @ A3 ) ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
            = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_4942_card__mono,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% card_mono
thf(fact_4943_card__seteq,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B3 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B3 ) ) ) ) ).

% card_seteq
thf(fact_4944_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C6: nat] :
      ( ! [G5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G5 @ F4 )
         => ( ( finite_finite @ A @ G5 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G5 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_4945_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N2: nat,S3: set @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ S3 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S3 )
           => ( ( ( finite_card @ A @ T7 )
                = N2 )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_4946_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_4947_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_4948_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_4949_card__1__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( one_one @ nat ) )
     => ~ ! [X5: A] :
            ( A3
           != ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_4950_psubset__card__mono,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% psubset_card_mono
thf(fact_4951_card__less__Suc2,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                & ( ord_less @ nat @ K2 @ I2 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_4952_card__less__Suc,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] :
                  ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                  & ( ord_less @ nat @ K2 @ I2 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_4953_card__less,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_4954_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_4955_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_4956_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,T6: set @ B,R2: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S3 )
     => ( ( finite_finite @ B @ T6 )
       => ( ! [X5: B] :
              ( ( member @ B @ X5 @ T6 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I3: A] :
                        ( ( member @ A @ I3 @ S3 )
                        & ( R2 @ I3 @ X5 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I3: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T6 )
                        & ( R2 @ I3 @ J3 ) ) ) )
              @ S3 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T6 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_4957_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X2: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_4958_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_4959_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_4960_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_4961_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B5: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B5 @ B8 ) )
            & ~ ( member @ A @ B5 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_4962_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B6: A,B9: set @ A] :
          ( ( A3
            = ( insert @ A @ B6 @ B9 ) )
          & ~ ( member @ A @ B6 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_4963_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X2: A] :
            ( A3
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_4964_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( X2 = Y5 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_4965_card__le__Suc__iff,axiom,
    ! [A: $tType,N2: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ A4 @ B8 ) )
            & ~ ( member @ A @ A4 @ B8 )
            & ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_4966_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_4967_card__Diff__subset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_4968_card__psubset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% card_psubset
thf(fact_4969_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_4970_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% card_lists_length_le
thf(fact_4971_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_4972_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( power_power @ A @ Z6 @ N2 )
                    = ( one_one @ A ) ) ) )
            @ N2 ) ) ) ).

% card_roots_unity
thf(fact_4973_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N2 ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_4974_card__sum__le__nat__sum,axiom,
    ! [S3: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S3 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ S3 ) ) ).

% card_sum_le_nat_sum
thf(fact_4975_card__nth__roots,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z6: complex] :
                  ( ( power_power @ complex @ Z6 @ N2 )
                  = C2 ) ) )
          = N2 ) ) ) ).

% card_nth_roots
thf(fact_4976_card__roots__unity__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) ) )
        = N2 ) ) ).

% card_roots_unity_eq
thf(fact_4977_card__2__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A,Y5: A] :
            ( ( S3
              = ( insert @ A @ X2 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X2 != Y5 ) ) ) ) ).

% card_2_iff
thf(fact_4978_card__3__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X2: A,Y5: A,Z6: A] :
            ( ( S3
              = ( insert @ A @ X2 @ ( insert @ A @ Y5 @ ( insert @ A @ Z6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X2 != Y5 )
            & ( Y5 != Z6 )
            & ( X2 != Z6 ) ) ) ) ).

% card_3_iff
thf(fact_4979_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_4980_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_4981_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_4982_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_4983_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_4984_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( member @ A @ Y @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_4985_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite @ A @ A3 )
        & ( member @ A @ X @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_4986_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_4987_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_4988_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S3: set @ B,F2: B > A,K5: real] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ S3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S3 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_4989_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,N2: A,K: nat] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                & ( ord_less_eq @ A @ ( F2 @ I4 ) @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N2 )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( power_power @ A @ N2 @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_4990_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_4991_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_4992_card__insert__le__m1,axiom,
    ! [A: $tType,N2: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X @ Y ) ) @ N2 ) ) ) ).

% card_insert_le_m1
thf(fact_4993_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              @ N2 ) ) ) ) ).

% polyfun_roots_card
thf(fact_4994_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S3 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S3 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S3 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_4995_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z6: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                          @ ( set_ord_atMost @ nat @ N2 ) )
                        = ( zero_zero @ A ) ) ) )
                @ N2 ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_4996_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ ( code_divmod_abs @ K2 @ L )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L @ S6 ) ) )
                @ ( code_divmod_abs @ K2 @ L ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K2 @ L )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K2 @ L ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4997_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_4998_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_4999_apsnd__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,X: A,Y: C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_Pair @ A @ C @ X @ Y ) )
      = ( product_Pair @ A @ B @ X @ ( F2 @ Y ) ) ) ).

% apsnd_conv
thf(fact_5000_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_5001_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 )
              & ( distinct @ A @ Xs3 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5002_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_5003_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ) ).

% distinct_product
thf(fact_5004_finite__distinct__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs2: list @ A] :
          ( ( ( set2 @ A @ Xs2 )
            = A3 )
          & ( distinct @ A @ Xs2 ) ) ) ).

% finite_distinct_list
thf(fact_5005_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_5006_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I3 != J3 )
                 => ( ( nth @ A @ Xs3 @ I3 )
                   != ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5007_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Xs @ J ) )
            = ( I2 = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5008_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_5009_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_5010_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ? [X5: nat] :
            ( ( ord_less @ nat @ X5 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X5 )
              = X )
            & ! [Y4: nat] :
                ( ( ( ord_less @ nat @ Y4 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y4 )
                    = X ) )
               => ( Y4 = X5 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5011_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ nat,B3: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A3
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B3
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A3 @ B3 ) ) ) ) ).

% bij_betw_nth
thf(fact_5012_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A2: A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ I2 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I2 @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5013_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X ) )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ N2 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5014_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_5015_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_5016_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num,N2: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_5017_PowI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) ) ) ).

% PowI
thf(fact_5018_Pow__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% Pow_iff
thf(fact_5019_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_5020_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_5021_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V2 ) ) ) ) ).

% rec_nat_numeral
thf(fact_5022_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_5023_Pow__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B3 ) ) ) ).

% Pow_mono
thf(fact_5024_PowD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% PowD
thf(fact_5025_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X2: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X2 ) ) ) ) ).

% old.rec_nat_def
thf(fact_5026_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A,N2: nat] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( suc @ N2 ) )
        = ( F22 @ N2 @ ( F2 @ N2 ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_5027_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num,N2: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) ) ) ).

% case_nat_add_eq_if
thf(fact_5028_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y6: B] :
              ( ( X = X9 )
              & ( Y = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y ) ) ).

% The_split_eq
thf(fact_5029_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) ) ) ).

% case_nat_numeral
thf(fact_5030_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X2: nat] : ( H2 @ ( F22 @ X2 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5031_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_5032_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5033_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5034_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5035_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N2 ) ) ).

% less_eq_nat.simps(2)
thf(fact_5036_max__Suc1,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ M )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ N2 @ M5 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5037_max__Suc2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ M5 @ N2 ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5038_subset__CollectI,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ B3 )
           => ( ( Q @ X5 )
             => ( P @ X5 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ B3 )
                & ( Q @ X2 ) ) )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_5039_subset__Collect__iff,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ B3 )
             => ( P @ X2 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_5040_diff__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K2: nat] : K2
        @ ( minus_minus @ nat @ M @ N2 ) ) ) ).

% diff_Suc
thf(fact_5041_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(1)
thf(fact_5042_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(2)
thf(fact_5043_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X2: A,F5: nat > A,N: nat] :
            ( if @ A
            @ ( N
              = ( zero_zero @ nat ) )
            @ X2
            @ ( F5 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5044_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X2: real] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z6 ) @ X2 )
              & ( ord_less @ real @ X2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_5045_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X2: rat] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z6 ) @ X2 )
              & ( ord_less @ rat @ X2 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_5046_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5047_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5048_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X2: rat,Y5: rat] :
          ( ( ord_less @ rat @ X2 @ Y5 )
          | ( X2 = Y5 ) ) ) ) ).

% less_eq_rat_def
thf(fact_5049_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A4: rat] : ( if @ rat @ ( ord_less @ rat @ A4 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A4 ) @ A4 ) ) ) ).

% abs_rat_def
thf(fact_5050_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S2: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S2 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R
                 != ( plus_plus @ rat @ S2 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5051_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5052_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_5053_rat__inverse__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B5: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B5 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_inverse_code
thf(fact_5054_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P2 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_5055_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_5056_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5057_normalize__denom__zero,axiom,
    ! [P2: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P2 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5058_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_5059_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5060_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5061_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_5062_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_5063_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B5: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C4 @ B5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_divide_code
thf(fact_5064_quotient__of__div,axiom,
    ! [R: rat,N2: int,D2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ N2 @ D2 ) )
     => ( R
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N2 ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_5065_quotient__of__denom__pos,axiom,
    ! [R: rat,P2: int,Q2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_5066_normalize__denom__pos,axiom,
    ! [R: product_prod @ int @ int,P2: int,Q2: int] :
      ( ( ( normalize @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_5067_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B5: int,D3: int] : ( ord_less @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C4 @ B5 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_5068_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P6: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P6 ) ) ) ) ).

% rat_floor_code
thf(fact_5069_quotient__of__int,axiom,
    ! [A2: int] :
      ( ( quotient_of @ ( of_int @ A2 ) )
      = ( product_Pair @ int @ int @ A2 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_5070_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_5071_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K2: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K2 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K2 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K2 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K2 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_5072_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5073_Frct__code__post_I6_J,axiom,
    ! [K: num,L2: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L2 ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L2 ) ) ) ).

% Frct_code_post(6)
thf(fact_5074_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5075_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_div_numeral
thf(fact_5076_fst__divmod__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N2 ) )
      = ( divide_divide @ nat @ M @ N2 ) ) ).

% fst_divmod_nat
thf(fact_5077_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_div_numeral
thf(fact_5078_fst__eqD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X @ Y ) )
        = A2 )
     => ( X = A2 ) ) ).

% fst_eqD
thf(fact_5079_fst__conv,axiom,
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) ).

% fst_conv
thf(fact_5080_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% fst_divmod
thf(fact_5081_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_5082_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5083_drop__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5084_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5085_finite__enumerate,axiom,
    ! [S3: set @ nat] :
      ( ( finite_finite @ nat @ S3 )
     => ? [R4: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R4 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S3 ) ) )
          & ! [N9: nat] :
              ( ( ord_less @ nat @ N9 @ ( finite_card @ nat @ S3 ) )
             => ( member @ nat @ ( R4 @ N9 ) @ S3 ) ) ) ) ).

% finite_enumerate
thf(fact_5086_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5087_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5088_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5089_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5090_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5091_fst__divmod__integer,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L2 ) )
      = ( divide_divide @ code_integer @ K @ L2 ) ) ).

% fst_divmod_integer
thf(fact_5092_prod_Ocollapse,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) ).

% prod.collapse
thf(fact_5093_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N2
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5094_drop__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5095_drop__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5096_drop__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5097_fst__divmod__abs,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L2 ) )
      = ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L2 ) ) ) ).

% fst_divmod_abs
thf(fact_5098_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5099_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5100_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5101_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5102_snd__divmod__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N2 ) )
      = ( modulo_modulo @ nat @ M @ N2 ) ) ).

% snd_divmod_nat
thf(fact_5103_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5104_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5105_drop__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5106_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_mod_numeral
thf(fact_5107_drop__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5108_drop__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5109_snd__conv,axiom,
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) ).

% snd_conv
thf(fact_5110_snd__eqD,axiom,
    ! [B: $tType,A: $tType,X: B,Y: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
        = A2 )
     => ( Y = A2 ) ) ).

% snd_eqD
thf(fact_5111_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N2 @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5112_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5113_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,X: A,Y: B,A2: product_prod @ A @ B] :
      ( ( P @ X @ Y )
     => ( ( A2
          = ( product_Pair @ A @ B @ X @ Y ) )
       => ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_5114_surjective__pairing,axiom,
    ! [B: $tType,A: $tType,T2: product_prod @ A @ B] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) ).

% surjective_pairing
thf(fact_5115_prod_Oexhaust__sel,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ).

% prod.exhaust_sel
thf(fact_5116_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5117_drop__bit__push__bit__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N2 @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5118_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5119_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5120_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5121_prod_Osplit__sel__asm,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) ).

% prod.split_sel_asm
thf(fact_5122_prod_Osplit__sel,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ).

% prod.split_sel
thf(fact_5123_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% snd_divmod
thf(fact_5124_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5125_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5126_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_5127_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5128_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5129_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N: nat,K2: int] : ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_int_def
thf(fact_5130_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5131_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A4: A] : ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5132_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5133_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A4 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5134_rat__sgn__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P2 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P2 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_5135_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5136_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5137_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod @ nat @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P2 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N2 @ ( product_fst @ nat @ A @ P2 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P2 ) @ N2 ) )
          = ( product_snd @ nat @ A @ P2 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5138_exI__realizer,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Y: A,X: B] :
      ( ( P @ Y @ X )
     => ( P @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) ) ) ).

% exI_realizer
thf(fact_5139_conjI__realizer,axiom,
    ! [A: $tType,B: $tType,P: A > $o,P2: A,Q: B > $o,Q2: B] :
      ( ( P @ P2 )
     => ( ( Q @ Q2 )
       => ( ( P @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) ) ) ) ) ).

% conjI_realizer
thf(fact_5140_length__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_5141_snd__divmod__integer,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_snd @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L2 ) )
      = ( modulo_modulo @ code_integer @ K @ L2 ) ) ).

% snd_divmod_integer
thf(fact_5142_snd__divmod__abs,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_snd @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L2 ) )
      = ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L2 ) ) ) ).

% snd_divmod_abs
thf(fact_5143_drop__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5144_distinct__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ).

% distinct_enumerate
thf(fact_5145_drop__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5146_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5147_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5148_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N2: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N2 @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5149_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5150_bezw_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5151_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X2: nat,Y5: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X2 @ Y5 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X2 @ Y5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X2 @ Y5 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y5 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5152_minus__one__mod__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5153_one__mod__minus__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5154_minus__numeral__mod__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5155_numeral__mod__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5156_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5157_bezw_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% bezw.pelims
thf(fact_5158_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5159_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A3: set @ A,R: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ R @ A3 )
           => ( ( member @ A @ S @ A3 )
             => ( ( ord_less @ A @ R @ S )
               => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5160_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_5161_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_5162_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N2 ) @ N2 )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add1
thf(fact_5163_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add2
thf(fact_5164_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N2 ) ) ) ).

% gcd_exp
thf(fact_5165_gcd__1__int,axiom,
    ! [M: int] :
      ( ( gcd_gcd @ int @ M @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% gcd_1_int
thf(fact_5166_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N2: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5167_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N2: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N2 ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5168_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_5169_gcd__pos__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N2
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5170_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add_mult
thf(fact_5171_gcd__red__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X2: int,Y5: int] : ( gcd_gcd @ int @ Y5 @ ( modulo_modulo @ int @ X2 @ Y5 ) ) ) ) ).

% gcd_red_int
thf(fact_5172_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5173_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5174_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5175_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5176_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5177_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5178_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5179_gcd__non__0__int,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( gcd_gcd @ int @ Y @ ( modulo_modulo @ int @ X @ Y ) ) ) ) ).

% gcd_non_0_int
thf(fact_5180_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K2: int,L: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L
              = ( zero_zero @ int ) )
            @ K2
            @ ( gcd_gcd @ int @ L @ ( modulo_modulo @ int @ ( abs_abs @ int @ K2 ) @ ( abs_abs @ int @ L ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5181_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A3: set @ A,X: A,Y: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( member @ A @ Y @ A3 )
             => ( ( ord_less_eq @ A @ X @ Y )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5182_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F5: A > B,A7: set @ A] :
            ! [R5: A,S6: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S6 @ A7 )
                & ( ord_less @ A @ R5 @ S6 ) )
             => ( ord_less @ B @ ( F5 @ R5 ) @ ( F5 @ S6 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5183_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [R4: A,S2: A] :
              ( ( member @ A @ R4 @ A3 )
             => ( ( member @ A @ S2 @ A3 )
               => ( ( ord_less @ A @ R4 @ S2 )
                 => ( ord_less @ B @ ( F2 @ R4 ) @ ( F2 @ S2 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A3 ) ) ) ).

% strict_mono_onI
thf(fact_5184_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_5185_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F5: A > nat,G4: B > nat,P6: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F5 @ ( product_fst @ A @ B @ P6 ) ) @ ( G4 @ ( product_snd @ A @ B @ P6 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5186_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K2 )
                  = ( sgn_sgn @ code_integer @ L ) )
                @ ( code_divmod_abs @ K2 @ L )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K2 @ L ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5187_gcd__1__nat,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_5188_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5189_gcd__pos__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5190_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5191_gcd__red__nat,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X2: nat,Y5: nat] : ( gcd_gcd @ nat @ Y5 @ ( modulo_modulo @ nat @ X2 @ Y5 ) ) ) ) ).

% gcd_red_nat
thf(fact_5192_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5193_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5194_gcd__diff2__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N2 @ M ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff2_nat
thf(fact_5195_gcd__diff1__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff1_nat
thf(fact_5196_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa2 )
        = Y )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y = X ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y
            = ( gcd_gcd @ nat @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5197_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X2: nat,Y5: nat] :
          ( if @ nat
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ X2
          @ ( gcd_gcd @ nat @ Y5 @ ( modulo_modulo @ nat @ X2 @ Y5 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5198_gcd__non__0__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5199_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A3: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X5: B,Y3: B] :
                ( ( H2 @ ( plus_plus @ B @ X5 @ Y3 ) )
                = ( plus_plus @ A @ ( H2 @ X5 ) @ ( H2 @ Y3 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A3 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5200_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X5: nat,Y3: nat] :
          ( ( times_times @ nat @ A2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5201_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X5: nat,Y3: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( times_times @ nat @ A2 @ X5 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X5 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ ( times_times @ nat @ B2 @ X5 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X5 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5202_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K2: code_integer,L: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L
              = ( zero_zero @ code_integer ) )
            @ K2
            @ ( gcd_gcd @ code_integer @ L @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5203_nat__descend__induct,axiom,
    ! [N2: nat,P: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less @ nat @ N2 @ K3 )
         => ( P @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N2 )
           => ( ! [I: nat] :
                  ( ( ord_less @ nat @ K3 @ I )
                 => ( P @ I ) )
             => ( P @ K3 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5204_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q2: product_prod @ A @ B,F2: A > B > C,G: A > B > C,P2: product_prod @ A @ B] :
      ( ! [X5: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X5 @ Y3 )
            = Q2 )
         => ( ( F2 @ X5 @ Y3 )
            = ( G @ X5 @ Y3 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P2 )
          = ( product_case_prod @ A @ B @ C @ G @ Q2 ) ) ) ) ).

% split_cong
thf(fact_5205_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y = X ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( gcd_gcd @ nat @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5206_nth__rotate1,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_5207_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5208_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_5209_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_5210_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_5211_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_5212_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_5213_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_5214_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5215_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_5216_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_5217_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_5218_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X @ Xs ) ) ) ).

% distinct_remove1
thf(fact_5219_remove1__commute,axiom,
    ! [A: $tType,X: A,Y: A,Zs: list @ A] :
      ( ( remove1 @ A @ X @ ( remove1 @ A @ Y @ Zs ) )
      = ( remove1 @ A @ Y @ ( remove1 @ A @ X @ Zs ) ) ) ).

% remove1_commute
thf(fact_5220_notin__set__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( remove1 @ A @ Y @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_5221_remove1__idem,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_5222_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_5223_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5224_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5225_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5226_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5227_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5228_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5229_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5230_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5231_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N2 ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5232_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5233_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5234_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5235_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5236_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5237_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5238_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5239_length__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_5240_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5241_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5242_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5243_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5244_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5245_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5246_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X2: B,Y5: A] : ( product_Pair @ A @ B @ Y5 @ X2 ) ) ) ) ).

% snd_fst_flip
thf(fact_5247_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X2: A,Y5: B] : ( product_Pair @ B @ A @ Y5 @ X2 ) ) ) ) ).

% fst_snd_flip
thf(fact_5248_card__greaterThanLessThan__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L2 @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_5249_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
          = ( ( ord_less @ A @ L2 @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5250_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5251_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5252_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5253_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5254_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5255_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5256_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L2 @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_5257_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5258_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5259_fstI,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ A @ B,Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_fst @ A @ B @ X )
        = Y ) ) ).

% fstI
thf(fact_5260_sndI,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ A @ B,Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_snd @ A @ B @ X )
        = Z2 ) ) ).

% sndI
thf(fact_5261_xor__minus__numerals_I1_J,axiom,
    ! [N2: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N2 @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5262_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N2: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5263_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5264_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5265_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5266_card__greaterThanLessThan,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L2 ) ) ) ).

% card_greaterThanLessThan
thf(fact_5267_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5268_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5269_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5270_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5271_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V2 ) @ Y ) ) ) ).

% semiring_norm(167)
thf(fact_5272_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V2 @ W ) @ Y ) ) ) ).

% semiring_norm(166)
thf(fact_5273_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5274_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5275_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5276_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5277_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ one2 @ N2 ) ) ) ).

% diff_numeral_special(1)
thf(fact_5278_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5279_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5280_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5281_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5282_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5283_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5284_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5285_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5286_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5287_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5288_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5289_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L2 ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5290_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L2 ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5291_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L2 ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L2 @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_5292_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K2: num,L: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K2 ) @ ( numeral_numeral @ A @ L ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5293_tanh__real__bounds,axiom,
    ! [X: real] : ( member @ real @ ( tanh @ real @ X ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) ).

% tanh_real_bounds
thf(fact_5294_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% sub_non_positive
thf(fact_5295_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% sub_non_negative
thf(fact_5296_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% sub_positive
thf(fact_5297_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% sub_negative
thf(fact_5298_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N2 ) @ one2 )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% sub_inc_One_eq
thf(fact_5299_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5300_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5301_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5302_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5303_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5304_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5305_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5306_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N2: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% power_minus'
thf(fact_5307_sub__BitM__One__eq,axiom,
    ! [N2: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N2 ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5308_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5309_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5310_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5311_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F5: A > B] :
            ? [K6: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5312_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( times_times @ A @ A4 ) @ ( F5 @ ( nth @ B @ Xs3 @ N ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5313_Suc__funpow,axiom,
    ! [N2: nat] :
      ( ( compow @ ( nat > nat ) @ N2 @ suc )
      = ( plus_plus @ nat @ N2 ) ) ).

% Suc_funpow
thf(fact_5314_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_5315_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S3: set @ A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S3 @ S3 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ S3 @ S3 ) ) ).

% bij_betw_funpow
thf(fact_5316_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N2: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N2 @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N2 @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_5317_funpow__mod__eq,axiom,
    ! [A: $tType,N2: nat,F2: A > A,X: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ X )
        = X )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N2 ) @ F2 @ X )
        = ( compow @ ( A > A ) @ M @ F2 @ X ) ) ) ).

% funpow_mod_eq
thf(fact_5318_funpow__mult,axiom,
    ! [A: $tType,N2: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N2 @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N2 ) @ F2 ) ) ).

% funpow_mult
thf(fact_5319_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_5320_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N2 @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% comp_funpow
thf(fact_5321_funpow__Suc__right,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5322_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5323_funpow__add,axiom,
    ! [A: $tType,M: nat,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow_add
thf(fact_5324_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5325_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5326_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K2: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K2 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5327_relpowp__bot,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5328_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N: nat,P4: A > A > $o,X2: A,Y5: A] :
          ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = X2 )
            & ( ( F5 @ N )
              = Y5 )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ N )
               => ( P4 @ ( F5 @ I3 ) @ ( F5 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5329_relpowp__1,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P )
      = P ) ).

% relpowp_1
thf(fact_5330_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A,N2: nat,Z2: A] :
      ( ( P @ X @ Y )
     => ( ( compow @ ( A > A > $o ) @ N2 @ P @ Y @ Z2 )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X @ Z2 ) ) ) ).

% relpowp_Suc_I2
thf(fact_5331_relpowp__Suc__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X @ Z2 )
     => ~ ! [Y3: A] :
            ( ( P @ X @ Y3 )
           => ~ ( compow @ ( A > A > $o ) @ N2 @ P @ Y3 @ Z2 ) ) ) ).

% relpowp_Suc_E2
thf(fact_5332_relpowp__Suc__D2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X @ Z2 )
     => ? [Y3: A] :
          ( ( P @ X @ Y3 )
          & ( compow @ ( A > A > $o ) @ N2 @ P @ Y3 @ Z2 ) ) ) ).

% relpowp_Suc_D2
thf(fact_5333_relpowp__Suc__I,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Y: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X @ Y )
     => ( ( P @ Y @ Z2 )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X @ Z2 ) ) ) ).

% relpowp_Suc_I
thf(fact_5334_relpowp__Suc__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X @ Z2 )
     => ~ ! [Y3: A] :
            ( ( compow @ ( A > A > $o ) @ N2 @ P @ X @ Y3 )
           => ~ ( P @ Y3 @ Z2 ) ) ) ).

% relpowp_Suc_E
thf(fact_5335_relpowp__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X @ Z2 )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( compow @ ( A > A > $o ) @ M4 @ P @ X @ Y3 )
               => ~ ( P @ Y3 @ Z2 ) ) ) ) ) ).

% relpowp_E
thf(fact_5336_relpowp__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X @ Z2 )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( P @ X @ Y3 )
               => ~ ( compow @ ( A > A > $o ) @ M4 @ P @ Y3 @ Z2 ) ) ) ) ) ).

% relpowp_E2
thf(fact_5337_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5338_apfst__apsnd,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F2: C > A,G: D > B,X: product_prod @ C @ D] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_apsnd @ D @ B @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( F2 @ ( product_fst @ C @ D @ X ) ) @ ( G @ ( product_snd @ C @ D @ X ) ) ) ) ).

% apfst_apsnd
thf(fact_5339_apsnd__apfst,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F2: C > B,G: D > A,X: product_prod @ D @ C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apfst @ D @ A @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X ) ) @ ( F2 @ ( product_snd @ D @ C @ X ) ) ) ) ).

% apsnd_apfst
thf(fact_5340_apfst__conv,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: C > A,X: C,Y: B] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_Pair @ C @ B @ X @ Y ) )
      = ( product_Pair @ A @ B @ ( F2 @ X ) @ Y ) ) ).

% apfst_conv
thf(fact_5341_apfst__convE,axiom,
    ! [C: $tType,A: $tType,B: $tType,Q2: product_prod @ A @ B,F2: C > A,P2: product_prod @ C @ B] :
      ( ( Q2
        = ( product_apfst @ C @ A @ B @ F2 @ P2 ) )
     => ~ ! [X5: C,Y3: B] :
            ( ( P2
              = ( product_Pair @ C @ B @ X5 @ Y3 ) )
           => ( Q2
             != ( product_Pair @ A @ B @ ( F2 @ X5 ) @ Y3 ) ) ) ) ).

% apfst_convE
thf(fact_5342_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X2: nat,Y5: nat] : ( ord_less_eq @ nat @ Y5 @ X2 )
    @ ^ [X2: nat,Y5: nat] : ( ord_less @ nat @ Y5 @ X2 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5343_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A3 )
     => ( ! [X5: set @ A] :
            ( ( member @ ( set @ A ) @ X5 @ A3 )
           => ( finite_finite @ A @ X5 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I8: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I8 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I8 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I8 @ A3 )
                    & ( I8
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5344_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5345_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5346_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5347_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5348_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5349_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5350_card__Union__le__sum__card,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ).

% card_Union_le_sum_card
thf(fact_5351_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,A2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X5 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S3 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5352_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X5: set @ B] :
              ( ( member @ ( set @ B ) @ X5 @ B3 )
             => ( finite_finite @ B @ X5 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A14 != A25 )
                     => ! [X5: B] :
                          ( ( member @ B @ X5 @ A14 )
                         => ( ( member @ B @ X5 @ A25 )
                           => ( ( G @ X5 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_5353_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] :
      ( ! [X5: set @ A] :
          ( ( member @ ( set @ A ) @ X5 @ U3 )
         => ( finite_finite @ A @ X5 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5354_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,L2: A,E: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X5 @ L2 ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S3 ) @ L2 ) ) @ E ) ) ) ) ).

% cInf_asclose
thf(fact_5355_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,L2: A,E: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X5 @ L2 ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S3 ) @ L2 ) ) @ E ) ) ) ) ).

% cSup_asclose
thf(fact_5356_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5357_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5358_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5359_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5360_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5361_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5362_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
          | ( ord_less @ A @ B6 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5363_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X3: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X3 )
                        & ( ord_less @ A @ X3 @ C3 ) )
                     => ( P @ X3 ) )
                  & ! [D6: A] :
                      ( ! [X5: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X5 )
                            & ( ord_less @ A @ X5 @ D6 ) )
                         => ( P @ X5 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5364_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ Z2 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z2 ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5365_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ X8 )
             => ( ord_less_eq @ A @ X5 @ A2 ) )
         => ( ! [Y3: A] :
                ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less_eq @ A @ X3 @ Y3 ) )
               => ( ord_less_eq @ A @ A2 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5366_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X5 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z2 ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5367_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X5 ) )
         => ( ! [Y3: A] :
                ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less_eq @ A @ Y3 @ X3 ) )
               => ( ord_less_eq @ A @ Y3 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5368_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_5369_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ A2 ) )
           => ( ! [Y3: A] :
                  ( ! [X3: A] :
                      ( ( member @ A @ X3 @ X8 )
                     => ( ord_less_eq @ A @ X3 @ Y3 ) )
                 => ( ord_less_eq @ A @ A2 @ Y3 ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5370_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5371_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( ord_less @ A @ Z2 @ X5 ) ) ) ) ) ).

% less_cSupD
thf(fact_5372_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X8: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ~ ( ord_less @ A @ Y @ X5 ) ) ) ) ) ).

% less_cSupE
thf(fact_5373_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ( ord_less @ A @ X5 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5374_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X5 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5375_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X5 ) )
           => ( ! [Y3: A] :
                  ( ! [X3: A] :
                      ( ( member @ A @ X3 @ X8 )
                     => ( ord_less_eq @ A @ Y3 @ X3 ) )
                 => ( ord_less_eq @ A @ Y3 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5376_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_5377_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z2 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( ord_less @ A @ X5 @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_5378_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ( ord_less @ A @ A2 @ X5 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5379_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5380_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5381_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,A2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X5 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S3 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5382_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A3 )
                    & ( ord_less @ A @ Y5 @ X2 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5383_finite__subset__Union,axiom,
    ! [A: $tType,A3: set @ A,B12: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B12 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B12 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5384_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5385_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V2: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ V2 @ U )
           => ( ord_less_eq @ A @ V2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5386_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5387_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Sup_upper
thf(fact_5388_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ord_less_eq @ A @ X5 @ Z2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z2 ) ) ) ).

% Sup_least
thf(fact_5389_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ! [A6: A] :
              ( ( member @ A @ A6 @ A3 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ B3 )
                  & ( ord_less_eq @ A @ A6 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_mono
thf(fact_5390_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [Y3: A] :
              ( ( member @ A @ Y3 @ A3 )
             => ( ord_less_eq @ A @ Y3 @ X ) )
         => ( ! [Y3: A] :
                ( ! [Z3: A] :
                    ( ( member @ A @ Z3 @ A3 )
                   => ( ord_less_eq @ A @ Z3 @ Y3 ) )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ A3 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_5391_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S3: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S3 ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S3 )
                & ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5392_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ord_less_eq @ A @ Z2 @ X5 ) )
         => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_greatest
thf(fact_5393_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5394_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V2: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ U @ V2 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V2 ) ) ) ) ).

% Inf_lower2
thf(fact_5395_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5396_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A3: set @ A] :
          ( ! [B6: A] :
              ( ( member @ A @ B6 @ B3 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                  & ( ord_less_eq @ A @ X3 @ B6 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_mono
thf(fact_5397_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ A3 )
             => ( ord_less_eq @ A @ X @ I4 ) )
         => ( ! [Y3: A] :
                ( ! [I: A] :
                    ( ( member @ A @ I @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ I ) )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A3 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5398_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_12: A] : ( P @ ( zero_zero @ nat ) @ X_12 )
     => ( ! [X5: A,N3: nat] :
            ( ( P @ N3 @ X5 )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N3 ) @ Y4 )
                & ( Q @ N3 @ X5 @ Y4 ) ) )
       => ? [F3: nat > A] :
          ! [N9: nat] :
            ( ( P @ N9 @ ( F3 @ N9 ) )
            & ( Q @ N9 @ ( F3 @ N9 ) @ ( F3 @ ( suc @ N9 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_5399_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S3: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S3 ) @ A2 )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S3 )
                & ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5400_Union__subsetI,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ! [X5: set @ A] :
          ( ( member @ ( set @ A ) @ X5 @ A3 )
         => ? [Y4: set @ A] :
              ( ( member @ ( set @ A ) @ Y4 @ B3 )
              & ( ord_less_eq @ ( set @ A ) @ X5 @ Y4 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_subsetI
thf(fact_5401_Union__upper,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% Union_upper
thf(fact_5402_Union__least,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ C6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ C6 ) ) ).

% Union_least
thf(fact_5403_Inter__greatest,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ C6 @ X10 ) )
     => ( ord_less_eq @ ( set @ A ) @ C6 @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) ) ) ).

% Inter_greatest
thf(fact_5404_Inter__lower,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B3 ) ) ).

% Inter_lower
thf(fact_5405_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ Y5 @ X2 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5406_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X @ Y5 )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ X2 @ Y5 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5407_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ U @ V3 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5408_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5409_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ V3 @ U ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5410_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5411_Union__mono,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_mono
thf(fact_5412_Inter__anti__mono,axiom,
    ! [A: $tType,B3: set @ ( set @ A ),A3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) ) ).

% Inter_anti_mono
thf(fact_5413_Inter__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B3 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B3 ) ) ) ).

% Inter_subset
thf(fact_5414_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5415_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5416_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5417_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_5418_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5419_Int__subset__iff,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C6 @ A3 )
        & ( ord_less_eq @ ( set @ A ) @ C6 @ B3 ) ) ) ).

% Int_subset_iff
thf(fact_5420_removeAll__id,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_5421_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) @ ( F2 @ X2 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5422_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5423_Union__Int__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_Int_subset
thf(fact_5424_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5425_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_5426_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_5427_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5428_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5429_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5430_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( A4
                = ( inf_inf @ A @ A4 @ B5 ) )
              & ( A4 != B5 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5431_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5432_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5433_Int__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ ( inf_inf @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_5434_Int__lower1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ A3 ) ).

% Int_lower1
thf(fact_5435_Int__lower2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ B3 ) ).

% Int_lower2
thf(fact_5436_Int__absorb1,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = B3 ) ) ).

% Int_absorb1
thf(fact_5437_Int__absorb2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = A3 ) ) ).

% Int_absorb2
thf(fact_5438_Int__greatest,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% Int_greatest
thf(fact_5439_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ( P @ X5 )
             => ( Q @ X5 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B3 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5440_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_5441_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_5442_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_5443_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_5444_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_5445_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5446_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5447_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_5448_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_5449_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5450_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5451_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X5: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X5 @ Y3 ) @ X5 )
         => ( ! [X5: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X5 @ Y3 ) @ Y3 )
           => ( ! [X5: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ( ord_less_eq @ A @ X5 @ Z4 )
                   => ( ord_less_eq @ A @ X5 @ ( F2 @ Y3 @ Z4 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_5452_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y5: A] :
              ( ( inf_inf @ A @ X2 @ Y5 )
              = X2 ) ) ) ) ).

% le_iff_inf
thf(fact_5453_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5454_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5455_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_5456_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_5457_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5458_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5459_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_5460_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B5 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5461_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5462_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5463_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( inf_inf @ A @ A4 @ B5 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5464_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B5 )
              = B5 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5465_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5466_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5467_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_5468_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_5469_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_5470_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5471_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ Xs )
        = ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5472_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B3 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5473_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5474_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5475_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5476_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S3 )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ I4 )
                    = ( one_one @ A ) ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S3 @ T6 ) )
                   => ( ( G @ I4 )
                      = ( one_one @ A ) ) )
               => ( ! [X5: B] :
                      ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ S3 @ T6 ) )
                     => ( ( G @ X5 )
                        = ( H2 @ X5 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_5477_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_5478_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5479_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5480_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F2 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5481_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_5482_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5483_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X3: A] :
                  ( ( member @ A @ X3 @ S3 )
                  & ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S3 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5484_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S3: set @ A,Y: A,F2: A > B] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S3 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S3 ) ) @ ( F2 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5485_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% finite_shuffles
thf(fact_5486_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R2 )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S3 ) ) ) ) ).

% inf_Int_eq2
thf(fact_5487_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs3 ) ) ) ).

% shuffles_commutes
thf(fact_5488_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5489_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5490_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5491_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X5 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5492_times__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) )
          @ Xa2
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_5493_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( ( list_update @ A @ Xs @ K @ X )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5494_concat__replicate__trivial,axiom,
    ! [A: $tType,I2: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I2 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5495_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5496_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N2: nat] :
      ( ( enumerate @ A @ N2 @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5497_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5498_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5499_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5500_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5501_empty__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N2 @ X ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5502_replicate__empty,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( replicate @ A @ N2 @ X )
        = ( nil @ A ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5503_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5504_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5505_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5506_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5507_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5508_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5509_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5510_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5511_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remove1 @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5512_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X5: nat,Y3: nat] :
          ( Z2
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X5 @ Y3 ) ) ) ).

% eq_Abs_Integ
thf(fact_5513_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5514_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5515_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I2: nat,V2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ V2 )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5516_list__update__code_I1_J,axiom,
    ! [A: $tType,I2: nat,Y: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ Y )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5517_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5518_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5519_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5520_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5521_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_5522_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5523_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5524_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5525_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X2: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X2 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_5526_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5527_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5528_less__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa2
        @ X ) ) ).

% less_int.abs_eq
thf(fact_5529_less__eq__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa2
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_5530_plus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) )
          @ Xa2
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_5531_minus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) )
          @ Xa2
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_5532_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5533_eq__snd__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,P2: product_prod @ B @ A] :
      ( ( B2
        = ( product_snd @ B @ A @ P2 ) )
      = ( ? [A4: B] :
            ( P2
            = ( product_Pair @ B @ A @ A4 @ B2 ) ) ) ) ).

% eq_snd_iff
thf(fact_5534_eq__fst__iff,axiom,
    ! [A: $tType,B: $tType,A2: A,P2: product_prod @ A @ B] :
      ( ( A2
        = ( product_fst @ A @ B @ P2 ) )
      = ( ? [B5: B] :
            ( P2
            = ( product_Pair @ A @ B @ A2 @ B5 ) ) ) ) ).

% eq_fst_iff
thf(fact_5535_insert__subsetI,axiom,
    ! [A: $tType,X: A,A3: set @ A,X8: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X8 ) @ A3 ) ) ) ).

% insert_subsetI
thf(fact_5536_ssubst__Pair__rhs,axiom,
    ! [B: $tType,A: $tType,R: A,S: B,R2: set @ ( product_prod @ A @ B ),S7: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R2 )
     => ( ( S7 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S7 ) @ R2 ) ) ) ).

% ssubst_Pair_rhs
thf(fact_5537_prop__restrict,axiom,
    ! [A: $tType,X: A,Z8: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ X8 )
                & ( P @ X2 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_5538_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ X8 )
            & ( P @ X2 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_5539_subset__emptyI,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [X5: A] :
          ~ ( member @ A @ X5 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_5540_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_5541_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5542_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5543_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X2: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X2 ) ) ) ) ).

% uminus_int_def
thf(fact_5544_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5545_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5546_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5547_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5548_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [X2: A,Y5: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X2 @ Y5 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5549_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5550_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5551_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z6: A] :
              ( Z6
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5552_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5553_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5554_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5555_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5556_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5557_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5558_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5559_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5560_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5561_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5562_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5563_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5564_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5565_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5566_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5567_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5568_num__of__nat_Osimps_I2_J,axiom,
    ! [N2: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = ( inc @ ( num_of_nat @ N2 ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5569_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,P2: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I6 )
                  & ( ( P2 @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I2 @ I6 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P2 @ I6 ) ) )
            & ( ~ ( member @ B @ I2 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I2 @ I6 ) )
                = ( times_times @ A @ ( P2 @ I2 ) @ ( groups1962203154675924110t_prod @ B @ A @ P2 @ I6 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5570_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5571_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_5572_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5573_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5574_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A3 ) )
            = A3 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5575_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P2: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_5576_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) )
          = ( finite_card @ A @ A3 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5577_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( nil @ A ) )
            = ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5578_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( linord4507533701916653071of_set @ A @ B3 ) )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B3 )
             => ( A3 = B3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5579_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I6: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I6 )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) ) ) ).

% prod.non_neutral'
thf(fact_5580_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5581_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5582_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
              @ I6 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5583_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S3 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T6 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5584_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S3 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5585_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( H2 @ I4 )
                  = ( one_one @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S3 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S3 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5586_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S3 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5587_numeral__num__of__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N2 ) )
        = N2 ) ) ).

% numeral_num_of_nat
thf(fact_5588_num__of__nat__One,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N2 )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5589_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I6 )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I6 )
                    & ( ( H2 @ X2 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
                @ I6 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5590_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P6: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I8 )
                      & ( ( P6 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I8 )
                      & ( ( P6 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5591_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5592_num__of__nat__double,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N2 @ N2 ) )
        = ( bit0 @ ( num_of_nat @ N2 ) ) ) ) ).

% num_of_nat_double
thf(fact_5593_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N2 ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5594_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N2: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ ( suc @ I2 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I2 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5595_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5596_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit1 @ Y ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_5597_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set_def
thf(fact_5598_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_5599_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_5600_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X @ A3 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5601_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ X
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Y
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_5602_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Xs: list @ B] :
          ( ( ( F2 @ X )
           != ( F2 @ Y ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_insort_key @ B @ A @ F2 @ Y @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5603_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5604_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A2: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5605_sqr_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N2 ) ) ) ) ).

% sqr.simps(2)
thf(fact_5606_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5607_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( insert @ B @ X @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_5608_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( ~ ( member @ B @ X @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_5609_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X2: num] : ( times_times @ num @ X2 @ X2 ) ) ) ).

% sqr_conv_mult
thf(fact_5610_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5611_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X @ Y ) ) ) ).

% pow.simps(2)
thf(fact_5612_sqr_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N2 ) @ N2 ) ) ) ) ).

% sqr.simps(3)
thf(fact_5613_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5614_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N2: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ I2 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I2 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5615_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image @ nat @ nat
            @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5616_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5617_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_5618_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S3 )
          = S3 ) ) ).

% image_add_0
thf(fact_5619_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5620_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5621_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5622_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B3: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B3 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B3 ) ) ) ).

% bij_betw_add
thf(fact_5623_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
          = ( ( ord_less @ A @ L2 @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5624_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5625_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L2 ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5626_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5627_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5628_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_5629_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5630_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5631_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5632_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5633_image__Suc__atLeastAtMost,axiom,
    ! [I2: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I2 @ J ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I2 ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5634_image__Suc__atLeastLessThan,axiom,
    ! [I2: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I2 ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5635_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5636_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5637_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5638_floor__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A2 @ B2 ) )
      = ( divide_divide @ int @ A2 @ B2 ) ) ).

% floor_Fract
thf(fact_5639_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A3 )
                    & ( ord_less @ A @ ( F2 @ Y5 ) @ X2 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5640_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5641_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5642_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5643_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,A9: set @ B,B3: set @ A,B13: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( ( image @ A @ B @ F2 @ B3 )
            = B13 )
         => ( bij_betw @ A @ B @ F2 @ B3 @ B13 ) ) ) ) ).

% bij_betw_subset
thf(fact_5644_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F8: B > A,F2: A > B,A9: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ( F8 @ ( F2 @ X5 ) )
            = X5 ) )
     => ( ! [X5: B] :
            ( ( member @ B @ X5 @ A9 )
           => ( ( F2 @ ( F8 @ X5 ) )
              = X5 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F8 @ A9 ) @ A3 )
           => ( bij_betw @ A @ B @ F2 @ A3 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_5645_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_5646_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_5647_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B3 ) ) ) ).

% image_Int_subset
thf(fact_5648_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,G: C > A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B3 )
                  & ( ord_less_eq @ A @ ( G @ X3 ) @ ( F2 @ I4 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B3 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5649_zero__notin__Suc__image,axiom,
    ! [A3: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A3 ) ) ).

% zero_notin_Suc_image
thf(fact_5650_finite__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( finite_finite @ B @ B3 ) ) ) ).

% finite_surj
thf(fact_5651_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
            & ( finite_finite @ B @ C7 )
            & ( B3
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_5652_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B8: set @ A] :
            ( ( finite_finite @ A @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) )
            & ( P @ B8 ) ) )
      = ( ? [B8: set @ B] :
            ( ( finite_finite @ B @ B8 )
            & ( ord_less_eq @ ( set @ B ) @ B8 @ A3 )
            & ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_5653_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ( finite_finite @ A @ B8 )
              & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ( finite_finite @ B @ B8 )
              & ( ord_less_eq @ ( set @ B ) @ B8 @ A3 ) )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_5654_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A3 ) ) @ ( pow2 @ A @ B3 ) ) ) ).

% image_Pow_mono
thf(fact_5655_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A3 )
            & ( B3
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_5656_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( member @ A @ ( F2 @ X2 ) @ B3 ) ) ) ) ).

% image_subset_iff
thf(fact_5657_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
           => ( B3
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_5658_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: A > B,B3: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( member @ B @ ( F2 @ X5 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 ) ) ).

% image_subsetI
thf(fact_5659_image__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ).

% image_mono
thf(fact_5660_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5661_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B8 @ A3 )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_subset_image
thf(fact_5662_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ X3 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B3 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F2 @ X3 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5663_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5664_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A6: int,B6: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( P @ ( fract @ A6 @ B6 ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct_pos
thf(fact_5665_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5666_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B3 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ).

% image_diff_subset
thf(fact_5667_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B3: set @ B] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( member @ B @ ( F2 @ X5 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B3 ) ) ).

% image_Collect_subsetI
thf(fact_5668_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5669_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L2 ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L2 @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_5670_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5671_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5672_Fract__coprime,axiom,
    ! [A2: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) )
      = ( fract @ A2 @ B2 ) ) ).

% Fract_coprime
thf(fact_5673_One__rat__def,axiom,
    ( ( one_one @ rat )
    = ( fract @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% One_rat_def
thf(fact_5674_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,X: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ X ) )
         => ( ! [Y3: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ I ) @ Y3 ) )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_5675_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X3 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ).

% SUP_mono
thf(fact_5676_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,U: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5677_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5678_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_5679_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5680_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I2 ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5681_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,Y: A,I2: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ Y )
         => ( ( member @ B @ I2 @ A3 )
           => ( ord_less @ A @ ( F2 @ I2 ) @ Y ) ) ) ) ).

% SUP_lessD
thf(fact_5682_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ A2 @ ( F2 @ X2 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5683_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I4 ) ) )
         => ( ! [Y3: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ ( F2 @ I ) ) )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_5684_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A3: set @ C,F2: C > A,G: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ A3 )
                  & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ).

% INF_mono
thf(fact_5685_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( F2 @ I2 ) ) ) ) ).

% INF_lower
thf(fact_5686_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_5687_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5688_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X2 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5689_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_5690_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y: A,F2: B > A,A3: set @ B,I2: B] :
          ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
         => ( ( member @ B @ I2 @ A3 )
           => ( ord_less @ A @ Y @ ( F2 @ I2 ) ) ) ) ) ).

% less_INF_D
thf(fact_5691_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ A2 )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ ( F2 @ X2 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5692_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F2: nat > A,N2: nat] :
      ( ( A3
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N2 ) ) ) )
     => ( finite_finite @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5693_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N: nat,F5: nat > A] :
            ( A7
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5694_Fract__of__int__eq,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( one_one @ int ) )
      = ( ring_1_of_int @ rat @ K ) ) ).

% Fract_of_int_eq
thf(fact_5695_Fract__of__int__quotient,axiom,
    ( fract
    = ( ^ [K2: int,L: int] : ( divide_divide @ rat @ ( ring_1_of_int @ rat @ K2 ) @ ( ring_1_of_int @ rat @ L ) ) ) ) ).

% Fract_of_int_quotient
thf(fact_5696_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ Y5 @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5697_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ X )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X @ Y5 )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ ( F2 @ X2 ) @ Y5 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5698_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,C2: A,F2: B > A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I6 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I4 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I6 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5699_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,M7: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_5700_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,F2: B > A,C2: A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I4 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I6 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5701_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M: A,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X5 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5702_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( finite_card @ A @ A3 ) ) ) ).

% card_image_le
thf(fact_5703_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: A > B,A9: set @ A,A10: set @ B,F2: C > A,A3: set @ C] :
      ( ( bij_betw @ A @ B @ F8 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A3 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F2 @ A3 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F8 @ F2 ) @ A3 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_5704_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5705_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_5706_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5707_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ B3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5708_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S3 )
                            & ( ( G @ X2 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% sum.group
thf(fact_5709_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S3 )
                            & ( ( G @ X2 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% prod.group
thf(fact_5710_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_5711_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K2: num] : ( fract @ ( numeral_numeral @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5712_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5713_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X5: B,Y3: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ( member @ B @ Y3 @ A3 )
                 => ( ( X5 != Y3 )
                   => ( ( ( H2 @ X5 )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X5 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image @ B @ C @ H2 @ A3 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_5714_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B3 ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% surj_card_le
thf(fact_5715_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5716_image__Suc__lessThan,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ).

% image_Suc_lessThan
thf(fact_5717_image__Suc__atMost,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N2 ) ) ) ).

% image_Suc_atMost
thf(fact_5718_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.head
thf(fact_5719_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5720_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5721_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.head
thf(fact_5722_lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5723_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5724_atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5725_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5726_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_5727_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_5728_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5729_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5730_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5731_rat__number__collapse_I5_J,axiom,
    ( ( fract @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) )
    = ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ).

% rat_number_collapse(5)
thf(fact_5732_Fract__add__one,axiom,
    ! [N2: int,M: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N2 ) @ N2 )
        = ( plus_plus @ rat @ ( fract @ M @ N2 ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5733_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I6: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I6 )
         => ( ! [I4: C] :
                ( ( member @ C @ I4 @ I6 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I4 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I6 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I6 ) ) ) ) ) ).

% sum_image_le
thf(fact_5734_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_5735_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_5736_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5737_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5738_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_5739_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5740_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5741_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5742_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5743_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5744_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5745_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5746_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S3: set @ A,R2: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S3 )
         => ( ( finite_finite @ B @ R2 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S3 ) @ R2 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y5: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X2: A] :
                                ( ( member @ A @ X2 @ S3 )
                                & ( ( G @ X2 )
                                  = Y5 ) ) ) ) )
                      @ ( F2 @ Y5 ) )
                  @ R2 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5747_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B3: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B3 ) ) ) ).

% INF_nat_binary
thf(fact_5748_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_5749_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F5: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F5 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_5750_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: set @ ( product_prod @ A @ B ),F2: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ A3 )
     => ( member @ C @ ( F2 @ A2 @ B2 ) @ ( image @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F2 ) @ A3 ) ) ) ).

% pair_imageI
thf(fact_5751_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_5752_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_5753_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A3 )
                    & ( ord_less @ A @ X2 @ Y5 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_5754_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5755_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A3 )
                    & ( ord_less @ A @ X2 @ ( F2 @ Y5 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_5756_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_5757_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_5758_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I3: set @ ( product_prod @ A @ B ),X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ I3 )
          @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_5759_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I3: set @ ( product_prod @ A @ B ),X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ I3 )
          @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% INF_Int_eq2
thf(fact_5760_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I3: C,X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( R @ I3 ) )
          @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_5761_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I3: C,X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( R @ I3 ) )
          @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_5762_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X4: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X4 ) ) ) ) ) ).

% Inf_real_def
thf(fact_5763_notin__range__Some,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ~ ( member @ ( option @ A ) @ X @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) )
      = ( X
        = ( none @ A ) ) ) ).

% notin_range_Some
thf(fact_5764_finite__range__Some,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) )
      = ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% finite_range_Some
thf(fact_5765_UNIV__option__conv,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ ( option @ A ) ) )
      = ( insert @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% UNIV_option_conv
thf(fact_5766_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S8: set @ ( A > B > $o ),X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S8 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_5767_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S8: set @ ( A > B > $o ),X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S8 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_5768_None__notin__image__Some,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( member @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ) ).

% None_notin_image_Some
thf(fact_5769_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_5770_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_5771_subset__UNIV,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_5772_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5773_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5774_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5775_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_5776_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_5777_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5778_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B3: set @ A,I2: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B3 )
     => ( member @ A @ ( F2 @ I2 ) @ B3 ) ) ).

% range_subsetD
thf(fact_5779_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) ) ) ).

% not_UNIV_le_Icc
thf(fact_5780_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_UNIV_le_Iic
thf(fact_5781_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ B3 )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X2 ) @ B3 ) ) ) ) ).

% UN_subset_iff
thf(fact_5782_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B3 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_5783_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: A > ( set @ B ),C6: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B3 @ X5 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) @ C6 ) ) ).

% UN_least
thf(fact_5784_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B3 ) ) ) ) ) ).

% UN_mono
thf(fact_5785_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5786_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A3: B > ( set @ A ),I6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ B3 @ ( A3 @ X2 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5787_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5788_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C6: set @ B,B3: A > ( set @ B )] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B3 @ X5 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_5789_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) @ ( B3 @ A2 ) ) ) ).

% INT_lower
thf(fact_5790_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5791_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A3 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_5792_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L2 @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_5793_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F2: B > C,A9: A > ( set @ C )] :
      ( ! [I4: A,J2: A] :
          ( ( member @ A @ I4 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I4 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I4 ) ) ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I6 )
           => ( bij_betw @ B @ C @ F2 @ ( A3 @ I4 ) @ ( A9 @ I4 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I6 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5794_suminf__eq__SUP__real,axiom,
    ! [X8: nat > real] :
      ( ( summable @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X8 @ I4 ) )
       => ( ( suminf @ real @ X8 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X8 @ ( set_ord_lessThan @ nat @ I3 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_5795_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S3: set @ A] :
      ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I4 ) @ S3 )
     => ( ( finite_finite @ A @ S3 )
       => ( ? [N7: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N7 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N7 )
                     => ( ( ord_less @ nat @ M4 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ( F2 @ N7 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S3 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5796_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5797_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5798_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_5799_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_5800_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_5801_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_5802_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5803_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite @ A @ I6 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I3: A] : ( finite_card @ B @ ( A3 @ I3 ) )
          @ I6 ) ) ) ).

% card_UN_le
thf(fact_5804_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F5: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_lessThan @ nat @ N ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_5805_range__mod,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N2 )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% range_mod
thf(fact_5806_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_5807_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G @ X ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X )
        @ ( collect @ B
          @ ^ [X2: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X2 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_5808_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_5809_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_5810_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5811_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5812_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_5813_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_5814_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( finite_folding_on @ A @ nat @ ( top_top @ ( set @ A ) )
      @ ^ [Uu3: A] : suc ) ).

% card.folding_on_axioms
thf(fact_5815_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_5816_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5817_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu3: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_5818_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ A3 ) ) ) ) ) ) ) ).

% folding_on.insert
thf(fact_5819_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,X: A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ A3 )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_5820_root__def,axiom,
    ( root
    = ( ^ [N: nat,X2: real] :
          ( if @ real
          @ ( N
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N ) )
            @ X2 ) ) ) ) ).

% root_def
thf(fact_5821_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_5822_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_5823_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_5824_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( remdups @ A @ X )
        = ( nil @ A ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_5825_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_5826_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_5827_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_5828_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_5829_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_5830_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_5831_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_5832_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_5833_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_5834_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_5835_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_5836_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N2: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N2 ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_5837_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N2 ) ) ) ).

% char_of_mod_256
thf(fact_5838_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_5839_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_5840_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_5841_these__insert__Some,axiom,
    ! [A: $tType,X: A,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( some @ A @ X ) @ A3 ) )
      = ( insert @ A @ X @ ( these @ A @ A3 ) ) ) ).

% these_insert_Some
thf(fact_5842_these__image__Some__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( these @ A @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) )
      = A3 ) ).

% these_image_Some_eq
thf(fact_5843_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_5844_in__these__eq,axiom,
    ! [A: $tType,X: A,A3: set @ ( option @ A )] :
      ( ( member @ A @ X @ ( these @ A @ A3 ) )
      = ( member @ ( option @ A ) @ ( some @ A @ X ) @ A3 ) ) ).

% in_these_eq
thf(fact_5845_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_5846_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( these @ A @ A3 ) )
      = ( collect @ ( option @ A )
        @ ^ [X2: option @ A] :
            ( ( member @ ( option @ A ) @ X2 @ A3 )
            & ( X2
             != ( none @ A ) ) ) ) ) ).

% Some_image_these_eq
thf(fact_5847_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_5848_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N2 )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_5849_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_5850_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_5851_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ A3 ) ) ) ) ) ) ).

% folding_idem_on.insert_idem
thf(fact_5852_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
thf(fact_5853_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert @ A @ X21 @ ( set2 @ A @ X222 ) ) ) ).

% list.simps(15)
thf(fact_5854_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ N2 ) )
      = ( nth @ A @ Xs @ N2 ) ) ).

% nth_Cons_Suc
thf(fact_5855_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_5856_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_5857_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N2: nat,X: B,Xs: list @ B] :
      ( ( enumerate @ B @ N2 @ ( cons @ B @ X @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N2 @ X ) @ ( enumerate @ B @ ( suc @ N2 ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_5858_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list @ A,V2: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_5859_nth__Cons__pos,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_5860_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv
thf(fact_5861_Suc__length__conv,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( suc @ N2 )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% Suc_length_conv
thf(fact_5862_length__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_5863_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_5864_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X5: A,Xs2: list @ A,Y3: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X5 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys4 ) ) ) )
         => ( P @ Xs @ Ys ) ) ) ) ).

% list_induct2
thf(fact_5865_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X5: A,Xs2: list @ A,Y3: B,Ys4: list @ B,Z4: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs2 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X5 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys4 ) @ ( cons @ C @ Z4 @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_5866_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X5: A,Xs2: list @ A,Y3: B,Ys4: list @ B,Z4: C,Zs2: list @ C,W2: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs2 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X5 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys4 ) @ ( cons @ C @ Z4 @ Zs2 ) @ ( cons @ D @ W2 @ Ws2 ) ) ) ) ) )
             => ( P @ Xs @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_5867_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_5868_splice_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X5: A,Xs2: list @ A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_5869_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
       => ~ ! [X5: A,Xs2: list @ A,Y3: A,Ys4: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_5870_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X5: A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_5871_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F3: A > B,X5: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F3 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) )
         => ( ! [F3: A > B,X5: A,Y3: A,Zs2: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F3 @ ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Zs2 ) ) ) )
           => ~ ! [A6: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A6 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_5872_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X5: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X5: A,Y3: A,Xs2: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ).

% successively.cases
thf(fact_5873_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F3: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F3: A > B,A6: A,As: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_5874_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) ).

% list.distinct(1)
thf(fact_5875_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X222: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_5876_list_Oexhaust,axiom,
    ! [A: $tType,Y: list @ A] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ! [X212: A,X223: list @ A] :
            ( Y
           != ( cons @ A @ X212 @ X223 ) ) ) ).

% list.exhaust
thf(fact_5877_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A] :
          ( ! [X5: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X5 @ Xs2 ) )
         => ( X
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_5878_transpose_Ocases,axiom,
    ! [A: $tType,X: list @ ( list @ A )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X5: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
              ( X
             != ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_5879_remdups__adj_Ocases,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X5: A] :
            ( X
           != ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ~ ! [X5: A,Y3: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_5880_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( Xs
            = ( cons @ A @ Y5 @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_5881_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X5: A,Xs2: list @ A] : ( P @ ( cons @ A @ X5 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y3 @ Ys4 ) )
         => ( ! [X5: A,Xs2: list @ A,Y3: B,Ys4: list @ B] :
                ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X5 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys4 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_5882_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X5: A] : ( P @ ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ( ! [X5: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X5 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_5883_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( removeAll @ A @ X @ Xs ) ) )
      & ( ( X != Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( removeAll @ A @ X @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_5884_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,V2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ I2 @ V2 )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V2 @ Xs )
        @ ^ [J3: nat] : ( cons @ A @ X @ ( list_update @ A @ Xs @ J3 @ V2 ) )
        @ I2 ) ) ).

% list_update.simps(2)
thf(fact_5885_not__Cons__self2,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_5886_set__ConsD,axiom,
    ! [A: $tType,Y: A,X: A,Xs: list @ A] :
      ( ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_5887_list_Oset__cases,axiom,
    ! [A: $tType,E: A,A2: list @ A] :
      ( ( member @ A @ E @ ( set2 @ A @ A2 ) )
     => ( ! [Z23: list @ A] :
            ( A2
           != ( cons @ A @ E @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A2
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member @ A @ E @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_5888_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] : ( member @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ).

% list.set_intros(1)
thf(fact_5889_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y: A,X222: list @ A,X21: A] :
      ( ( member @ A @ Y @ ( set2 @ A @ X222 ) )
     => ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ) ).

% list.set_intros(2)
thf(fact_5890_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = Xs ) )
      & ( ( X != Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( remove1 @ A @ X @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_5891_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z2 @ Xs ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_5892_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z2 @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_5893_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_5894_distinct__singleton,axiom,
    ! [A: $tType,X: A] : ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_5895_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_5896_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_5897_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_5898_replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N2 ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N2 @ X ) ) ) ).

% replicate_Suc
thf(fact_5899_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ I2 ) @ Y )
      = ( cons @ A @ X @ ( list_update @ A @ Xs @ I2 @ Y ) ) ) ).

% list_update_code(3)
thf(fact_5900_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs ) ) ).

% list_update_code(2)
thf(fact_5901_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_5902_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( ( Zs = Xs )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X5: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X5 @ Xs4 ) )
               => ! [Z4: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z4 @ Zs4 ) )
                   => ( ( X5 = Z4 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys ) ) ) ) )
           => ~ ! [Y3: A,Ys5: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y3 @ Ys5 ) )
                 => ! [Z4: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z4 @ Zs4 ) )
                     => ( ( Y3 = Z4 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_5903_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( nil @ B ) )
          = ( cons @ B @ X @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_5904_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_5905_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y: A,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_5906_nth__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
      = ( case_nat @ A @ X @ ( nth @ A @ Xs ) @ N2 ) ) ).

% nth_Cons
thf(fact_5907_Suc__le__length__iff,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X2: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_5908_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A2: B] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X5 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_5909_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( count_list @ A @ Xs @ Y ) ) ) ) ).

% count_list.simps(2)
thf(fact_5910_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_5911_nth__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = X ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_5912_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_5913_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
            = X )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_5914_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A,N2: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = Y )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_5915_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( replicate @ A @ N2 @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_5916_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( set_Cons @ A @ A3 @ ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
        @ A3 ) ) ).

% set_Cons_sing_Nil
thf(fact_5917_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_5918_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% concat_inth
thf(fact_5919_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_5920_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_5921_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_5922_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_5923_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_5924_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_5925_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_5926_self__append__conv,axiom,
    ! [A: $tType,Y: list @ A,Ys: list @ A] :
      ( ( Y
        = ( append @ A @ Y @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_5927_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_5928_self__append__conv2,axiom,
    ! [A: $tType,Y: list @ A,Xs: list @ A] :
      ( ( Y
        = ( append @ A @ Xs @ Y ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_5929_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_5930_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_5931_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_5932_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_5933_removeAll__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X @ Xs ) @ ( removeAll @ A @ X @ Ys ) ) ) ).

% removeAll_append
thf(fact_5934_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) ).

% append1_eq_conv
thf(fact_5935_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_5936_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_5937_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_5938_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_5939_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% nth_append_length
thf(fact_5940_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,N2: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
      = ( nth @ A @ Ys @ N2 ) ) ).

% nth_append_length_plus
thf(fact_5941_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y )
      = ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% list_update_length
thf(fact_5942_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_5943_n__lists__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_5944_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss1: list @ ( list @ A ),Xs3: list @ A,Xs5: list @ A,Xss22: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs5 ) @ Xss22 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs3 ) )
              & ( Zs
                = ( append @ A @ Xs5 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_5945_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss12: list @ ( list @ A ),Xs2: list @ A,Xs4: list @ A,Xss23: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs4 ) @ Xss23 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs2 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_5946_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_5947_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_5948_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X5: A,Xs2: list @ A] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) ).

% rev_induct
thf(fact_5949_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y3: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y3 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_5950_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_5951_Cons__eq__append__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys6: list @ A] :
            ( ( ( cons @ A @ X @ Ys6 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys6 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_5952_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys6: list @ A] :
            ( ( Ys
              = ( cons @ A @ X @ Ys6 ) )
            & ( ( append @ A @ Ys6 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_5953_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X5: A] : ( P @ ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ( ! [X5: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_5954_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A3: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A3 @ As2 ) )
      = ( set_Cons @ A @ A3 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_5955_Cons__eq__appendI,axiom,
    ! [A: $tType,X: A,Xs1: list @ A,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_5956_append__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys ) ) ) ).

% append_Cons
thf(fact_5957_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X @ Xs ) )
      = ( append @ A @ X @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_5958_split__list,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) ) ) ).

% split_list
thf(fact_5959_split__list__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_5960_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 ) ) ) ).

% split_list_prop
thf(fact_5961_split__list__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_5962_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ~ ( P @ X5 ) ) ) ).

% split_list_propE
thf(fact_5963_append__Cons__eq__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Xs6: list @ A,Ys7: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) )
            = ( append @ A @ Xs6 @ ( cons @ A @ X @ Ys7 ) ) )
          = ( ( Xs = Xs6 )
            & ( Ys = Ys7 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_5964_in__set__conv__decomp,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_5965_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_last_prop
thf(fact_5966_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_first_prop
thf(fact_5967_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ( ( P @ X5 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_last_propE
thf(fact_5968_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ( ( P @ X5 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_first_propE
thf(fact_5969_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_5970_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_5971_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: list @ A,X2: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P @ X2 )
            & ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y5 ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_5972_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: list @ A,X2: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P @ X2 )
            & ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y5 ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_5973_replicate__app__Cons__same,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N2 @ X ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_5974_replicate__add,axiom,
    ! [A: $tType,N2: nat,M: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N2 @ M ) @ X )
      = ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( replicate @ A @ M @ X ) ) ) ).

% replicate_add
thf(fact_5975_append__replicate__commute,axiom,
    ! [A: $tType,N2: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N2 @ X ) ) ) ).

% append_replicate_commute
thf(fact_5976_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_5977_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_5978_enumerate__append__eq,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_5979_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys ) ) ) ).

% remdups_append2
thf(fact_5980_remove1__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X @ Xs ) @ Ys ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_5981_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Ys @ Xs ) )
     => ? [M4: nat,N3: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M4 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_5982_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X5: A,Xs4: list @ A,Y3: A,Ys5: list @ A] :
            ( ( X5 != Y3 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X5 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_5983_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs2: list @ A,Ys4: list @ A,Zs2: list @ A,Y3: A] :
          ( Ws
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_5984_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs3: list @ A,Y5: A,Ys3: list @ A] :
            ( ( member @ A @ Y5 @ ( set2 @ A @ Xs3 ) )
            & ( distinct @ A @ Xs3 )
            & ( As3
              = ( append @ A @ Xs3 @ ( cons @ A @ Y5 @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_5985_replicate__append__same,axiom,
    ! [A: $tType,I2: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I2 @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I2 @ X ) ) ) ).

% replicate_append_same
thf(fact_5986_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ I2 @ X )
        = ( append @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_5987_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A2 @ Xs )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_5988_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_5989_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_5990_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_5991_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_5992_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_5993_nth__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Xs @ N2 ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_5994_list__update__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X )
          = ( append @ A @ ( list_update @ A @ Xs @ N2 @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_5995_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_5996_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_5997_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_5998_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_5999_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys )
            = ( append @ A @ Ys @ Xs ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6000_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I3: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I3 ) @ Js @ ( upto_aux @ I3 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6001_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
              & ( P @ X2 ) ) ) ) ).

% extract_Some_iff
thf(fact_6002_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
              & ( P @ X3 ) ) ) ) ).

% extract_SomeE
thf(fact_6003_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_6004_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P @ X2 ) ) ) ) ).

% extract_None_iff
thf(fact_6005_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs ) ) ) ) )
      & ( ~ ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y5: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_6006_upto_Opelims,axiom,
    ! [X: int,Xa2: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% upto.pelims
thf(fact_6007_upto__empty,axiom,
    ! [J: int,I2: int] :
      ( ( ord_less @ int @ J @ I2 )
     => ( ( upto @ I2 @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6008_upto__Nil2,axiom,
    ! [I2: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I2 @ J ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil2
thf(fact_6009_upto__Nil,axiom,
    ! [I2: int,J: int] :
      ( ( ( upto @ I2 @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil
thf(fact_6010_upto__single,axiom,
    ! [I2: int] :
      ( ( upto @ I2 @ I2 )
      = ( cons @ int @ I2 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_6011_nth__upto,axiom,
    ! [I2: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I2 @ J ) @ K )
        = ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6012_length__upto,axiom,
    ! [I2: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I2 @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I2 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6013_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6014_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6015_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6016_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6017_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I3: int,J3: int] : ( append @ int @ ( upto @ I3 @ J3 ) ) ) ) ).

% upto_aux_def
thf(fact_6018_option_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > B,X22: A] :
      ( ( case_option @ B @ A @ F1 @ F22 @ ( some @ A @ X22 ) )
      = ( F22 @ X22 ) ) ).

% option.simps(5)
thf(fact_6019_upto__code,axiom,
    ( upto
    = ( ^ [I3: int,J3: int] : ( upto_aux @ I3 @ J3 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_6020_distinct__upto,axiom,
    ! [I2: int,J: int] : ( distinct @ int @ ( upto @ I2 @ J ) ) ).

% distinct_upto
thf(fact_6021_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ I3 @ J3 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_6022_upto__split2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6023_upto__split1,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6024_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ I3 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6025_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_6026_upto_Oelims,axiom,
    ! [X: int,Xa2: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6027_upto_Osimps,axiom,
    ( upto
    = ( ^ [I3: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I3 @ J3 ) @ ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6028_upto__rec1,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_6029_upto__rec2,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6030_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6031_upto__split3,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6032_upto_Opsimps,axiom,
    ! [I2: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J ) )
     => ( ( ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6033_INF__filter__not__bot,axiom,
    ! [I7: $tType,A: $tType,B3: set @ I7,F4: I7 > ( filter @ A )] :
      ( ! [X10: set @ I7] :
          ( ( ord_less_eq @ ( set @ I7 ) @ X10 @ B3 )
         => ( ( finite_finite @ I7 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ B3 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_6034_DERIV__even__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6035_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6036_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,Z2: A,X: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S3 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z2 ) ) @ Y @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6037_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,Z2: A,X: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S3 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ Z2 @ X2 ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6038_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_6039_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_6040_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_6041_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6042_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6043_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G6: real > real] :
      ( ! [X5: real] :
          ( ( member @ real @ X5 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G6 @ X5 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6044_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6045_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6046_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_6047_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6048_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6049_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6050_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6051_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,X: A,Z2: A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ Z2 ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6052_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6053_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_6054_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
              @ ( times_times @ A @ E5 @ D5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6055_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6056_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G6: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X5: A] : ( has_field_derivative @ A @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
              @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6057_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G6: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ S )
             => ( has_field_derivative @ A @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6058_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( sin @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6059_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( exp @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6060_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X5: real] :
                ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X )
              = ( F2 @ Y ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_6061_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6062_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X ) ) @ ( times_times @ A @ Db @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_6063_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ E5 ) @ ( times_times @ A @ D5 @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6064_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ C2 )
            @ ( divide_divide @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_6065_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( times_times @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6066_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( times_times @ A @ C2 @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_6067_has__field__derivative__cosh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X2: A11] : ( cosh @ A11 @ ( G @ X2 ) )
            @ ( times_times @ A11 @ ( sinh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6068_has__field__derivative__sinh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X2: A11] : ( sinh @ A11 @ ( G @ X2 ) )
            @ ( times_times @ A11 @ ( cosh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6069_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_6070_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X2: A] : X2
          @ ( one_one @ A )
          @ F4 ) ) ).

% DERIV_ident
thf(fact_6071_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F4: filter @ A,G: A > A,G6: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G6 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( plus_plus @ A @ ( F2 @ Z6 ) @ ( G @ Z6 ) )
              @ ( plus_plus @ A @ F8 @ G6 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_6072_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ D5 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_6073_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S3 ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6074_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6075_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S3 ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6076_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6077_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6078_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z4: real] :
            ( ( ord_less @ real @ A2 @ Z4 )
            & ( ord_less @ real @ Z4 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F8 @ Z4 ) ) ) ) ) ) ).

% MVT2
thf(fact_6079_DERIV__local__const,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ( F2 @ X )
                = ( F2 @ Y3 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6080_DERIV__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_6081_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( cos @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6082_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa2: A] :
          ( has_field_derivative @ A
          @ ^ [X2: A] : ( cos @ A @ ( plus_plus @ A @ X2 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa2 @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6083_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ ( suc @ N2 ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6084_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ V2 @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V2 @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V2 @ A2 ) @ ( V2 @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6085_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_6086_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ N2 )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_6087_DERIV__local__max,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y3 ) @ ( F2 @ X ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6088_DERIV__local__min,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6089_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6090_DERIV__pow,axiom,
    ! [N2: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X2: real] : ( power_power @ real @ X2 @ N2 )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_6091_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y3 @ N ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6092_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6093_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X: real,N2: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X2: real] : ( power_power @ real @ ( G @ X2 ) @ N2 )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( G @ X ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6094_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6095_case__optionE,axiom,
    ! [A: $tType,P: $o,Q: A > $o,X: option @ A] :
      ( ( case_option @ $o @ A @ P @ Q @ X )
     => ( ( ( X
            = ( none @ A ) )
         => ~ P )
       => ~ ! [Y3: A] :
              ( ( X
                = ( some @ A @ Y3 ) )
             => ~ ( Q @ Y3 ) ) ) ) ).

% case_optionE
thf(fact_6096_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,G: A > A,E: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y5: A] : ( divide_divide @ A @ ( F2 @ Y5 ) @ ( G @ Y5 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X ) ) @ ( times_times @ A @ E @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6097_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6098_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F8: A,Z2: A] :
          ( ! [Z4: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z4 @ N ) )
                @ ( F2 @ Z4 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z2 @ N ) )
                @ F8 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6099_has__real__derivative__powr,axiom,
    ! [Z2: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z2 )
     => ( has_field_derivative @ real
        @ ^ [Z6: real] : ( powr @ real @ Z6 @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z2 @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6100_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
           => ( ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X2: A] :
                      ( suminf @ A
                      @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
                  @ ( suminf @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6101_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6102_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z2: A] :
          ( ! [Z4: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ K5 )
             => ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z4 @ N ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z6 @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z2 @ N ) ) )
              @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6103_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6104_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X: real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G @ X ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6105_DERIV__powr,axiom,
    ! [G: real > real,M: real,X: real,F2: real > real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6106_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6107_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6108_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F8: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X2: real] : ( F2 @ X2 @ N3 )
          @ ( F8 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X5 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F8 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N3: nat,X5: real,Y3: real] :
                    ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X5 @ N3 ) @ ( F2 @ Y3 @ N3 ) ) ) @ ( times_times @ real @ ( L5 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X5 @ Y3 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X2: real] : ( suminf @ real @ ( F2 @ X2 ) )
                  @ ( suminf @ real @ ( F8 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6109_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6110_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6111_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6112_has__field__derivative__tanh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,X: A11,Db: A11,S: set @ A11] :
          ( ( ( cosh @ A11 @ ( G @ X ) )
           != ( zero_zero @ A11 ) )
         => ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
           => ( has_field_derivative @ A11
              @ ^ [X2: A11] : ( tanh @ A11 @ ( G @ X2 ) )
              @ ( times_times @ A11 @ ( minus_minus @ A11 @ ( one_one @ A11 ) @ ( power_power @ A11 @ ( tanh @ A11 @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6113_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6114_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6115_artanh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6116_DERIV__power__series_H,axiom,
    ! [R2: real,F2: nat > real,X0: real] :
      ( ! [X5: real] :
          ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X5 @ N ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( has_field_derivative @ real
            @ ^ [X2: real] :
                ( suminf @ real
                @ ^ [N: nat] : ( times_times @ real @ ( F2 @ N ) @ ( power_power @ real @ X2 @ ( suc @ N ) ) ) )
            @ ( suminf @ real
              @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X0 @ N ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6117_DERIV__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6118_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6119_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6120_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N2: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6121_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N2: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6122_DERIV__odd__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6123_Maclaurin,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6124_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N2 ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6125_Maclaurin__minus,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ H2 @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H2 @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6126_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6127_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T4: real] :
            ( ( ( ord_less @ nat @ M4 @ N2 )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6128_Taylor,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N2 ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6129_Taylor__up,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6130_Taylor__down,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6131_Maclaurin__lemma2,axiom,
    ! [N2: nat,H2: real,Diff: nat > real > real,K: nat,B3: real] :
      ( ! [M4: nat,T4: real] :
          ( ( ( ord_less @ nat @ M4 @ N2 )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N2
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N2 )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ U2 @ P6 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ M2 ) ) )
                    @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N2 @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ T8 @ P6 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6132_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6133_DERIV__real__root__generic,axiom,
    ! [N2: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N2 ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6134_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6135_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arcsin @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6136_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_6137_take__bit__num__simps_I2_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_6138_take__bit__num__simps_I5_J,axiom,
    ! [R: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_6139_take__bit__num__simps_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N2 @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_6140_take__bit__num__simps_I4_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_6141_take__bit__num__simps_I6_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_6142_take__bit__num__simps_I7_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_6143_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6144_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N @ M ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_6145_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6146_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_6147_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ F4 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6148_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A > A,F4: filter @ A,D7: A] :
          ( ( has_derivative @ A @ A @ F2 @ D5 @ F4 )
         => ( ! [X5: A] :
                ( ( times_times @ A @ X5 @ D7 )
                = ( D5 @ X5 ) )
           => ( has_field_derivative @ A @ F2 @ D7 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6149_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F5: A > A,D8: A] : ( has_derivative @ A @ A @ F5 @ ( times_times @ A @ D8 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6150_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F8: D > real,X: D,S: set @ D,G: D > C,G6: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G6 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X2: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G6 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6151_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F4: filter @ A,G: A > B,G6: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G6 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [X2: A] : ( plus_plus @ B @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_6152_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F4: filter @ C,Y: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ ( G @ X2 ) @ Y )
            @ ^ [X2: C] : ( times_times @ A @ ( G6 @ X2 ) @ Y )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_6153_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F4: filter @ C,X: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G @ X2 ) )
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G6 @ X2 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_6154_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ N2 @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ one2 )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_6155_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_6156_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F8: D > A,X: D,S: set @ D,G: D > A,G6: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G6 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ ( G6 @ H ) ) @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6157_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G6: A > A > B,F2: C > A,S: set @ C,X: C,F8: C > A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X2: C] : ( G @ ( F2 @ X2 ) )
                  @ ^ [Y5: C] : ( G6 @ ( F2 @ X ) @ ( F8 @ Y5 ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6158_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( exp @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( exp @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_6159_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_6160_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_6161_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( sin @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( cos @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_6162_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( sinh @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_6163_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( cosh @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_6164_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S3: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G6 @ H ) ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S3 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6165_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S3: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6166_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F8: C > A,S3: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
           => ( has_derivative @ C @ A
              @ ^ [X2: C] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F8 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S3 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6167_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F8: real,G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F8 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ F8 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6168_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( cos @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_6169_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S3: set @ A,N2: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
         => ( has_derivative @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
            @ ^ [Y5: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N2 ) @ ( F8 @ Y5 ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_derivative_power
thf(fact_6170_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( ln_ln @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6171_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_6172_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S3: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X ) ) @ ( G6 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X ) ) ) ) @ ( divide_divide @ A @ ( F8 @ H ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S3 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6173_has__derivative__prod,axiom,
    ! [B: $tType,I7: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I6: set @ I7,F2: I7 > A > B,F8: I7 > A > B,X: A,S3: set @ A] :
          ( ! [I4: I7] :
              ( ( member @ I7 @ I4 @ I6 )
             => ( has_derivative @ A @ B @ ( F2 @ I4 ) @ ( F8 @ I4 ) @ ( topolo174197925503356063within @ A @ X @ S3 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X2: A] :
                ( groups7121269368397514597t_prod @ I7 @ B
                @ ^ [I3: I7] : ( F2 @ I3 @ X2 )
                @ I6 )
            @ ^ [Y5: A] :
                ( groups7311177749621191930dd_sum @ I7 @ B
                @ ^ [I3: I7] :
                    ( times_times @ B @ ( F8 @ I3 @ Y5 )
                    @ ( groups7121269368397514597t_prod @ I7 @ B
                      @ ^ [J3: I7] : ( F2 @ J3 @ X )
                      @ ( minus_minus @ ( set @ I7 ) @ I6 @ ( insert @ I7 @ I3 @ ( bot_bot @ ( set @ I7 ) ) ) ) ) )
                @ I6 )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_derivative_prod
thf(fact_6174_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,X8: set @ A,F2: A > real,F8: A > real] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
             => ( ( member @ A @ X @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X2: A] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F8 @ H ) @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G6 @ H ) @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6175_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( sqrt @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6176_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( arctan @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_6177_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( tan @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6178_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arccos @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6179_and__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6180_and__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6181_and__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6182_and__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6183_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_6184_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_6185_and__not__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_6186_and__not__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N2 ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_6187_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_6188_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N2: num,Q2: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( some @ num @ Q2 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( numeral_numeral @ int @ Q2 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_6189_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(8)
thf(fact_6190_and__not__num__eq__None__iff,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_6191_int__numeral__not__and__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N2 @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_6192_int__numeral__and__not__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% int_numeral_and_not_num
thf(fact_6193_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M3: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A4: nat,X2: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P6 ) ) )
                  @ X2 )
              @ A4 )
          @ ( product_Pair @ nat @ num @ N @ M3 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_6194_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X: A,F2: real > Aa,G6: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X2 ) ) ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6195_continuous__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F4: filter @ A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F4
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_Pair
thf(fact_6196_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6197_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 ) ) ) ) ).

% continuous_power
thf(fact_6198_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X2: num] : ( H2 @ ( F22 @ X2 ) )
        @ ^ [X2: num] : ( H2 @ ( F32 @ X2 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_6199_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6200_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6201_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6202_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6203_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6204_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_6205_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_6206_isCont__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_Pair
thf(fact_6207_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X5: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X5 )
                      & ( ord_less_eq @ A @ X5 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6208_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X5: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X5 )
                      & ( ord_less_eq @ A @ X5 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y ) ) ) ) ) ) ) ).

% IVT
thf(fact_6209_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X5 )
              & ( ord_less_eq @ real @ X5 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M8: real] :
            ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ M8 ) ) )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ M8 ) )
               => ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y4 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6210_isCont__real__sqrt,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_6211_isCont__real__root,axiom,
    ! [X: real,N2: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( root @ N2 ) ) ).

% isCont_real_root
thf(fact_6212_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6213_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6214_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6215_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 ) ) ) ) ).

% isCont_power
thf(fact_6216_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ M8 @ ( F2 @ X3 ) ) )
                & ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6217_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) )
                & ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6218_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
              ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6219_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z4: real] :
              ( ( ord_less_eq @ real @ A2 @ Z4 )
             => ( ( ord_less_eq @ real @ Z4 @ B2 )
               => ( ( G @ ( F2 @ Z4 ) )
                  = Z4 ) ) )
         => ( ! [Z4: real] :
                ( ( ord_less_eq @ real @ A2 @ Z4 )
               => ( ( ord_less_eq @ real @ Z4 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6220_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6221_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G4: A > A] :
                ( ! [Z6: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z6 ) @ ( F2 @ X ) )
                    = ( times_times @ A @ ( G4 @ Z6 ) @ ( minus_minus @ A @ Z6 @ X ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ G4 )
                & ( ( G4 @ X )
                  = L2 ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6222_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) )
                & ! [N7: A] :
                    ( ( ord_less @ A @ N7 @ M8 )
                   => ? [X5: real] :
                        ( ( ord_less_eq @ real @ A2 @ X5 )
                        & ( ord_less_eq @ real @ X5 @ B2 )
                        & ( ord_less @ A @ N7 @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6223_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6224_DERIV__inverse__function,axiom,
    ! [F2: real > real,D5: real,G: real > real,X: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D5 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D5
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X )
         => ( ( ord_less @ real @ X @ B2 )
           => ( ! [Y3: real] :
                  ( ( ord_less @ real @ A2 @ Y3 )
                 => ( ( ord_less @ real @ Y3 @ B2 )
                   => ( ( F2 @ ( G @ Y3 ) )
                      = Y3 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D5 ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6225_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N2: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W3 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% isCont_polynom
thf(fact_6226_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6227_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6228_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y3 @ N ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6229_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6230_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6231_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z4 @ X ) ) @ D2 )
           => ( ( G @ ( F2 @ Z4 ) )
              = Z4 ) )
       => ( ! [Z4: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z4 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6232_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G6: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z4: real] :
            ( ( ord_less_eq @ real @ A2 @ Z4 )
           => ( ( ord_less_eq @ real @ Z4 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z4: real] :
              ( ( ord_less_eq @ real @ A2 @ Z4 )
             => ( ( ord_less_eq @ real @ Z4 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z4: real] :
                ( ( ord_less @ real @ A2 @ Z4 )
               => ( ( ord_less @ real @ Z4 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G6 @ Z4 ) @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z4: real] :
                  ( ( ord_less @ real @ A2 @ Z4 )
                 => ( ( ord_less @ real @ Z4 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F8 @ Z4 ) @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G6 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F8 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6233_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6234_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ K5 @ N ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] :
                    ( suminf @ Aa
                    @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ ( F2 @ X2 ) @ N ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6235_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H ) @ N ) @ ( power_power @ A @ X @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6236_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A3 ) ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% image_Fpow_mono
thf(fact_6237_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6238_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6239_power__tendsto__0__iff,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6240_tendsto__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,G: A > C,B2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F4 )
           => ( filterlim @ A @ ( product_prod @ B @ C )
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_Pair
thf(fact_6241_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_6242_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( root @ N2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_root
thf(fact_6243_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L2: filter @ B,X: A,S3: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S3 )
           => ( filterlim @ A @ B @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_6244_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L2: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X5 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L2 ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6245_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) )
           => ( ! [X5: A] :
                  ( ( X5 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X5 ) @ ( F2 @ X5 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6246_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6247_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6248_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6249_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6250_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
          = ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y5 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6251_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
         => ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y5 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6252_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I6: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( F2 @ X2 @ I4 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I3: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F2 @ I3 ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F4 ) ) ) ).

% tendsto_one_prod'
thf(fact_6253_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6254_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_6255_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6256_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6257_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6258_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6259_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_6260_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_6261_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_6262_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A,N2: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( root @ N2 @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N2 @ X ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_6263_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N2 ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_6264_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6265_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_6266_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6267_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X2: B] : ( plus_plus @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6268_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_6269_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6270_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_6271_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_6272_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( artanh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_6273_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6274_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6275_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R2: real,A2: A,F2: A > B,G: A > B,L2: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ R2 )
                 => ( ( F2 @ X5 )
                    = ( G @ X5 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6276_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A] :
                        ( ( ( X2 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6277_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L5 ) ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6278_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
                & ! [X3: A] :
                    ( ( ( X3 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S2 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L5 ) ) @ R ) ) ) ) ) ) ).

% LIM_D
thf(fact_6279_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X2 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6280_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ord_less @ real @ ( F2 @ X3 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6281_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L2
         != ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6282_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6283_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6284_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6285_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6286_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( one_one @ A ) ) @ Z6 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6287_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L2: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L2 ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6288_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6289_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6290_Fpow__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% Fpow_mono
thf(fact_6291_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6292_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X4: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X4 @ A7 )
                & ( finite_finite @ A @ X4 ) ) ) ) ) ).

% Fpow_def
thf(fact_6293_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6294_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6295_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X5: A] :
                ( ( X5
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ S )
                 => ( sums @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X5 @ N ) )
                    @ ( F2 @ X5 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6296_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X5: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ S )
               => ( sums @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X5 @ N ) )
                  @ ( F2 @ X5 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6297_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6298_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6299_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X2: real] : ( divide_divide @ real @ ( cos @ real @ X2 ) @ ( sin @ real @ X2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6300_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6301_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_6302_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_6303_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( A2 @ N ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_6304_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_6305_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_6306_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: nat > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X2: nat] : ( F2 @ ( suc @ X2 ) )
        @ F4
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F2 @ F4 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_6307_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_6308_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [U4: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ X @ ( U4 @ N9 ) )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_6309_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ? [U4: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ ( U4 @ N9 ) @ X )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_6310_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_6311_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_6312_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_6313_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_6314_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X8: nat > A,Y7: nat > A,X: A,Y: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y7 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% lim_mono
thf(fact_6315_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,Y7: nat > A,Y: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
           => ( ? [N7: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y7 @ N3 ) ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6316_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C6 ) )
           => ( ord_less_eq @ A @ L2 @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_6317_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,N4: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C6 @ L2 ) ) ) ) ).

% Lim_bounded2
thf(fact_6318_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_6319_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N3 )
               => ( ord_less_eq @ A @ ( X8 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_6320_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_6321_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6322_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X2: nat] : ( times_times @ nat @ X2 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6323_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6324_monoseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( topological_monoseq @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X8 @ I4 ) ) @ B3 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6325_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( root @ N @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_6326_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N9: nat] : ( ord_less_eq @ A @ ( A2 @ N9 ) @ X )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ M2 ) @ ( A2 @ N9 ) ) ) )
              | ( ! [N9: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N9 ) )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ N9 ) @ ( A2 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6327_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6328_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X: A,L2: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L2 )
           => ( filterlim @ nat @ A
              @ ^ [N: nat] : ( X8 @ ( times_times @ nat @ N @ L2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6329_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) ) ) ) ) ).

% telescope_summable
thf(fact_6330_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6331_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N: nat] : ( minus_minus @ real @ ( F2 @ N ) @ ( G @ N ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L4: real] :
                ( ! [N9: nat] : ( ord_less_eq @ real @ ( F2 @ N9 ) @ L4 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) )
                & ! [N9: nat] : ( ord_less_eq @ real @ L4 @ ( G @ N9 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6332_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R4: real] :
        ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less @ real @ R4 @ ( X8 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( X8 @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6333_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6334_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( root @ N @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6335_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_6336_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( plus_plus @ real @ R @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6337_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L2: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ L2 )
       => ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [N9: nat] : ( ord_less_eq @ real @ L2 @ ( plus_plus @ real @ ( F2 @ N9 ) @ E2 ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6338_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6339_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6340_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6341_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6342_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6343_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6344_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6345_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6346_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6347_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6348_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N: nat] : ( root @ N @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_6349_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( plus_plus @ real @ R @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6350_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6351_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L5 ) ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6352_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N9 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N9 ) @ L5 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6353_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6354_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6355_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y5: B] : ( power_power @ A @ X @ ( F2 @ Y5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6356_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6357_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6358_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6359_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z2: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z2 @ ( S @ N ) ) ) @ ( F2 @ Z2 ) ) @ ( S @ N ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6360_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6361_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6362_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ) ).

% summable
thf(fact_6363_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K3: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6364_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K3: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6365_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6366_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6367_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6368_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6369_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L4: real] :
              ( ! [N9: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                  @ L4 )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) )
              & ! [N9: nat] :
                  ( ord_less_eq @ real @ L4
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6370_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6371_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_6372_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6373_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6374_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6375_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X2: A] : ( divide_divide @ A @ X2 @ Y ) ) ) ).

% bounded_linear_divide
thf(fact_6376_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X2: A] : ( times_times @ A @ X2 @ Y ) ) ) ).

% bounded_linear_mult_left
thf(fact_6377_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G @ X2 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6378_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ ( G @ X2 ) @ Y ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6379_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X ) ) ) ).

% bounded_linear_mult_right
thf(fact_6380_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F5: real > real] :
        ? [C4: real] :
          ( F5
          = ( ^ [X2: real] : ( times_times @ real @ X2 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6381_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6382_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6383_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6384_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6385_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X5: A,Y3: A] :
              ( ( F2 @ ( plus_plus @ A @ X5 @ Y3 ) )
              = ( plus_plus @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
         => ( ! [R4: real,X5: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R4 @ X5 ) )
                = ( real_V8093663219630862766scaleR @ B @ R4 @ ( F2 @ X5 ) ) )
           => ( ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6386_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ real
              @ ^ [Y5: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6387_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ? [E4: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6388_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_6389_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S3: set @ A,F2: A > B,F8: A > B] :
          ( ( member @ A @ X @ S3 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
                & ? [E4: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H ) @ S3 )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_6390_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E: real,F8: A > B,S: set @ A,X: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( ( real_V3181309239436604168linear @ A @ B @ F8 )
           => ( ! [Y3: A] :
                  ( ( member @ A @ Y3 @ S )
                 => ( ( Y3 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X ) @ E )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y3 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y3 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y3 @ X ) ) ) @ ( H6 @ Y3 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_6391_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_6392_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_6393_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) )
          = ( ( X != Y ) ) ) ) ).

% zero_less_dist_iff
thf(fact_6394_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_le_zero_iff
thf(fact_6395_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: real,A2: A,Y: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_6396_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y5 ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_6397_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X: A,E: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E ) ) ) ).

% dist_commute_lessI
thf(fact_6398_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S8: set @ A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ S8 )
             => ? [E4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
                  & ! [Y5: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X2 ) @ E4 )
                     => ( member @ A @ Y5 @ S8 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_6399_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_6400_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ) ).

% dist_pos_lt
thf(fact_6401_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_6402_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) @ E )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E ) ) ) ).

% dist_triangle_lt
thf(fact_6403_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less @ A @ X5 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ).

% Sup_notin_open
thf(fact_6404_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less @ A @ X @ X5 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ).

% Inf_notin_open
thf(fact_6405_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) ) ) ).

% dist_triangle
thf(fact_6406_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) ) ) ).

% dist_triangle2
thf(fact_6407_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y ) ) ) ) ).

% dist_triangle3
thf(fact_6408_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E ) ) ) ).

% dist_triangle_le
thf(fact_6409_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ).

% zero_le_dist
thf(fact_6410_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I: nat] :
              ( ( member @ A @ X @ ( A8 @ I ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) ) )
          & ! [S10: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S10 )
                & ( member @ A @ X @ S10 ) )
             => ? [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I4 ) @ S10 ) ) ) ) ).

% first_countable_basis
thf(fact_6411_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S8: set @ A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ S8 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X2 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S8 ) ) ) ) ) ) ).

% open_subopen
thf(fact_6412_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ S3 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X5 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S3 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S3 ) ) ) ).

% openI
thf(fact_6413_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S3: set @ A,T6: set @ A] :
          ( ( member @ A @ A2 @ S3 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( ord_less_eq @ ( set @ A ) @ S3 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T6 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_6414_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X @ S3 )
           => ( ( ord_less @ A @ X @ Y )
             => ? [B6: A] :
                  ( ( ord_less @ A @ X @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B6 ) @ S3 ) ) ) ) ) ) ).

% open_right
thf(fact_6415_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X @ S3 )
           => ( ( ord_less @ A @ Y @ X )
             => ? [B6: A] :
                  ( ( ord_less @ A @ B6 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B6 @ X ) @ S3 ) ) ) ) ) ) ).

% open_left
thf(fact_6416_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_6417_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,A2: A,S3: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S3 )
             => ( ! [X5: A] :
                    ( ( member @ A @ X5 @ S3 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D2 )
                     => ( ( F2 @ X5 )
                        = ( G @ X5 ) ) ) )
               => ( has_field_derivative @ A @ G @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_6418_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X @ S )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G @ X16 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_6419_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M3 ) @ ( X4 @ N ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_6420_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S6: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S6 @ N ) @ ( S6 @ N6 ) ) @ E4 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_6421_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) @ E ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_6422_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_6423_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S8 )
               => ( ( member @ A @ F0 @ S8 )
                 => ? [N6: nat] :
                    ! [N: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N )
                     => ( member @ A @ ( F2 @ N ) @ S8 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_6424_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L2: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X5: C] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X5 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L2 ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_6425_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L2: B,X: A,S3: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ X @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X16: A] :
                  ( ( member @ A @ X16 @ S3 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G @ X16 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_6426_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X1: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X1 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_r
thf(fact_6427_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_l
thf(fact_6428_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,X22: A,E: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X42 ) @ E ) ) ) ) ) ).

% dist_triangle_third
thf(fact_6429_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G7: filter @ B,X: A,S3: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G7 @ ( topolo174197925503356063within @ A @ X @ S3 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G7 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S3 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                       => ( ( F2 @ X16 )
                          = ( G @ X16 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_6430_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M4 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_6431_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less @ nat @ M3 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F5 @ M3 ) @ ( F5 @ N ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_6432_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A] :
                        ( ( ( X2 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_6433_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
                & ! [X3: A] :
                    ( ( ( X3 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S2 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L5 ) @ R ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_6434_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L5 ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_6435_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L2: B,A2: A,R2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( ! [X5: A] :
                  ( ( X5 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ R2 )
                   => ( ( F2 @ X5 )
                      = ( G @ X5 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_6436_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N9 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N9 ) @ L5 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_6437_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_6438_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_6439_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [J3: nat] :
            ? [M9: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M9 @ M3 )
             => ! [N: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M3 ) @ ( X4 @ N ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_6440_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_6441_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G: C > D,L2: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L2 ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_6442_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S3: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S3 )
           => ( ( topolo1002775350975398744n_open @ A @ S3 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_6443_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No )
                    & ! [N: nat] :
                        ( ( ord_less_eq @ nat @ No @ N )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_6444_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S8: set @ A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [K2: set @ A] :
                  ( ( finite_finite @ A @ K2 )
                  & ( ord_less_eq @ ( set @ A ) @ S8
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X2: A] :
                            ( collect @ A
                            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ E4 ) )
                        @ K2 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_6445_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y5 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y5 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_6446_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I2 ) ) ) ).

% greaterThan_iff
thf(fact_6447_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_6448_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_6449_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less @ A @ L ) ) ) ) ) ).

% greaterThan_def
thf(fact_6450_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S3: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S3 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S3 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_6451_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_6452_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [A6: A,B6: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A6 ) )
              & ( member @ A @ Y @ ( set_ord_greaterThan @ A @ B6 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A6 ) @ ( set_ord_greaterThan @ A @ B6 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_6453_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X2: real] : ( F2 @ ( plus_plus @ real @ X2 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_6454_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P2: A,F13: filter @ B,C2: A,L2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P2 @ ( set_ord_greaterThan @ A @ P2 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L2
                = ( times_times @ A @ C2 @ P2 ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
                @ ( topolo174197925503356063within @ A @ L2 @ ( set_ord_greaterThan @ A @ L2 ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_6455_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_6456_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( if @ B @ ( ord_less_eq @ A @ X2 @ A2 ) @ ( G @ X2 ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_6457_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_6458_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S3: set @ A] :
          ( ! [A6: A,B6: A,X5: A] :
              ( ( member @ A @ A6 @ S3 )
             => ( ( member @ A @ B6 @ S3 )
               => ( ( ord_less_eq @ A @ A6 @ X5 )
                 => ( ( ord_less_eq @ A @ X5 @ B6 )
                   => ( member @ A @ X5 @ S3 ) ) ) ) )
         => ? [A6: A,B6: A] :
              ( ( S3
                = ( bot_bot @ ( set @ A ) ) )
              | ( S3
                = ( top_top @ ( set @ A ) ) )
              | ( S3
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S3
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S3
                = ( set_ord_greaterThan @ A @ A6 ) )
              | ( S3
                = ( set_ord_atLeast @ A @ A6 ) )
              | ( S3
                = ( set_or5935395276787703475ssThan @ A @ A6 @ B6 ) )
              | ( S3
                = ( set_or3652927894154168847AtMost @ A @ A6 @ B6 ) )
              | ( S3
                = ( set_or7035219750837199246ssThan @ A @ A6 @ B6 ) )
              | ( S3
                = ( set_or1337092689740270186AtMost @ A @ A6 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_6459_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I2 ) ) ) ).

% atLeast_iff
thf(fact_6460_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_6461_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I2 ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I2 ) ) ) ) ).

% image_add_atLeast
thf(fact_6462_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ L3 @ L2 ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_6463_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_6464_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( set_ord_greaterThan @ nat @ K ) ) ).

% atLeast_Suc_greaterThan
thf(fact_6465_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_6466_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_6467_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less_eq @ A @ L ) ) ) ) ) ).

% atLeast_def
thf(fact_6468_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L2 ) ) ) ).

% not_UNIV_le_Ici
thf(fact_6469_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_6470_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_6471_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_6472_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_6473_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_6474_tanh__real__at__bot,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) @ ( at_bot @ real ) ).

% tanh_real_at_bot
thf(fact_6475_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_6476_artanh__real__at__right__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ).

% artanh_real_at_right_1
thf(fact_6477_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X5: real] :
          ( ( ord_less_eq @ real @ X5 @ B2 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_6478_filterlim__pow__at__bot__odd,axiom,
    ! [N2: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N2 )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_6479_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_6480_filterlim__pow__at__bot__even,axiom,
    ! [N2: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N2 )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_6481_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A] :
          ( ( filterlim @ A @ A
            @ ^ [X2: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_6482_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6483_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( plus_plus @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_add_at_top
thf(fact_6484_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_6485_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( plus_plus @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_tendsto_add_at_top
thf(fact_6486_filterlim__pow__at__top,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N2 )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6487_tanh__real__at__top,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) ) @ ( at_top @ real ) ).

% tanh_real_at_top
thf(fact_6488_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6489_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6490_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_6491_artanh__real__at__left__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_lessThan @ real @ ( one_one @ real ) ) ) ).

% artanh_real_at_left_1
thf(fact_6492_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6493_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6494_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_6495_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6496_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X2: real] : ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ X2 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6497_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6498_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6499_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6500_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X2: real] : ( divide_divide @ real @ ( power_power @ real @ X2 @ K ) @ ( exp @ real @ X2 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6501_tendsto__exp__limit__at__top,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ Y5 ) ) @ Y5 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6502_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6503_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6504_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X5: real] :
          ( ( ord_less_eq @ real @ B2 @ X5 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6505_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6506_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6507_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N2: nat,B3: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N2 )
             => ( eventually @ A
                @ ^ [Z6: A] :
                    ( ord_less_eq @ real @ B3
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6508_lhopital__right__at__top,axiom,
    ! [G: real > real,X: real,G6: real > real,F2: real > real,F8: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G6 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_6509_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( suc @ I3 ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_6510_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N: nat] : ( P @ ( plus_plus @ nat @ N @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6511_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N6 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6512_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6513_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( plus_plus @ nat @ I3 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6514_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ C2 @ X5 )
             => ( P @ X5 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6515_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N6 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6516_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X5: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X5 )
         => ( P @ X5 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6517_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N )
           => ( P @ N ) ) ) ) ).

% eventually_sequentially
thf(fact_6518_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_6519_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6520_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6521_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N @ N6 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6522_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6523_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N @ N6 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6524_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B5: A] :
                  ( ( ord_less @ A @ B5 @ ( top_top @ A ) )
                  & ! [Z6: A] :
                      ( ( ord_less @ A @ B5 @ Z6 )
                     => ( P @ Z6 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6525_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X5: A,Y3: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6526_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B5: A] :
                  ( ( ord_less @ A @ B5 @ X )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ B5 @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ X )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6527_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B5: A] :
                ( ( ord_less @ A @ B5 @ X )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ B5 @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ X )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6528_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B5: A] :
                ( ( ord_less @ A @ X @ B5 )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ X @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ B5 )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6529_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B5: A] :
                  ( ( ord_less @ A @ X @ B5 )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ X @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ B5 )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_6530_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B5: real] :
              ! [X2: A] :
                ( ( ord_less_eq @ real @ B5 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6531_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( G @ N ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N: B] : ( ord_less_eq @ A @ ( G @ N ) @ ( H2 @ N ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6532_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L: A] :
                ( ( ord_less @ A @ L @ X )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ L @ ( F2 @ X2 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X @ U2 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6533_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y: A,F2: B > A,F4: filter @ B] :
          ( ! [A6: A] :
              ( ( ord_less @ A @ A6 @ Y )
             => ( eventually @ B
                @ ^ [X2: B] : ( ord_less @ A @ A6 @ ( F2 @ X2 ) )
                @ F4 ) )
         => ( ! [A6: A] :
                ( ( ord_less @ A @ Y @ A6 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A6 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_6534_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ A2 @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6535_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6536_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6537_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6538_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_6539_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ Z9 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6540_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_6541_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6542_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6543_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6544_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N: B] : ( ord_less_eq @ real @ ( F2 @ N ) @ ( G @ N ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N: B] : ( ord_less_eq @ real @ ( G @ N ) @ ( H2 @ N ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6545_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) )
             => ( ! [I: nat] : ( member @ A @ X @ ( A8 @ I ) )
               => ~ ! [S10: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S10 )
                     => ( ( member @ A @ X @ S10 )
                       => ( eventually @ nat
                          @ ^ [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S10 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_6546_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X2: real] : ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_6547_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ S3 )
                   => ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 ) )
                     => ( P @ X2 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6548_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X2: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 )
                   => ( P @ X2 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6549_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X5 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6550_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X5 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_6551_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X2: A] : ( P @ ( plus_plus @ A @ X2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6552_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L2: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ L2 @ ( F2 @ N ) )
            @ F4 )
         => ( ! [X5: A] :
                ( ( ord_less @ A @ L2 @ X5 )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ ( F2 @ N ) @ X5 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6553_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ L2 )
            @ F4 )
         => ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ L2 )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ X5 @ ( F2 @ N ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_6554_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6555_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6556_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G: B > A,Y: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X2: B] : ( ord_less_eq @ A @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6557_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I3 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6558_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ ( F2 @ I3 ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6559_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X2: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X2 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6560_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6561_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( F2 @ X2 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6562_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X2: real] : ( P @ ( plus_plus @ real @ X2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_6563_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B3: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B3 ) ) )
      = ( ? [X4: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X4 @ B3 )
            & ( finite_finite @ B @ X4 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X4 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6564_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6565_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X2: real] : ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_6566_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ S3 )
                   => ( ( ( X2 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 ) )
                     => ( P @ X2 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_6567_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P2: A > $o] :
          ( ( eventually @ A @ P2 @ ( at_infinity @ A ) )
          = ( ? [B5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B5 )
                & ! [X2: A] :
                    ( ( ord_less_eq @ real @ B5 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
                   => ( P2 @ X2 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6568_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6569_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ L5 @ ( F2 @ X2 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_6570_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B,E: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L2 ) @ E )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_6571_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ( eventually @ B
                @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L2 ) @ E2 )
                @ F4 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ).

% tendstoI
thf(fact_6572_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
          = ( ! [E4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L2 ) @ E4 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_6573_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( G @ N ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6574_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X2: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6575_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X5: A,Y3: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ B6 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6576_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X5: A,Y3: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X5 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ A2 @ B6 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_6577_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_6578_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X2: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_6579_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_6580_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6581_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6582_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L2 ) ) @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_6583_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6584_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L2 ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6585_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_6586_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_6587_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_6588_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( F2 @ X2 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_6589_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_6590_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_6591_lhopital,axiom,
    ! [F2: real > real,X: real,G: real > real,G6: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G6 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6592_lhopital__left,axiom,
    ! [F2: real > real,X: real,G: real > real,G6: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G6 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6593_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_6594_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_6595_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_6596_lhopital__at__top,axiom,
    ! [G: real > real,X: real,G6: real > real,F2: real > real,F8: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G6 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6597_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G6: real > real,F2: real > real,F8: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G6 @ X2 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6598_lhopital__left__at__top,axiom,
    ! [G: real > real,X: real,G6: real > real,F2: real > real,F8: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G6 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6599_lhopital__right,axiom,
    ! [F2: real > real,X: real,G: real > real,G6: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G6 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_6600_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G6: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G0 @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G6 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F0 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G0 @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F0 @ X2 ) @ ( G0 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_6601_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_6602_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G6: real > real,F2: real > real,F8: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G6 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G6 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_6603_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A4: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A4 )
               => ! [B5: nat] :
                    ( ( ord_less @ nat @ A4 @ B5 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A4 @ B5 ) ) ) @ ( G @ A4 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6604_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6605_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X2: A] :
              ! [Y5: A] :
                ( ( ord_less_eq @ A @ X2 @ Y5 )
               => ( P @ Y5 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6606_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P4: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P4 @ X2 )
                  & ! [Y5: A] :
                      ( ( P4 @ Y5 )
                     => ( ord_less_eq @ A @ Y5 @ X2 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_6607_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [Y5: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ X2 ) @ Y5 ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_6608_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_6609_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_6610_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_6611_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X2: nat] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_6612_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X2: nat] : ( plus_plus @ A @ ( F2 @ X2 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_6613_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X2: nat] : ( plus_plus @ A @ ( F2 @ X2 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_6614_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_6615_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( X8 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_6616_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N: nat] : ( X8 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_6617_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,K5: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_6618_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_6619_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ! [X5: A] :
                  ( ( P @ X5 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ Y4 @ X5 ) )
                   => ( Q @ X5 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_6620_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X2: nat] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6621_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_6622_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_6623_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_6624_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X8: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_6625_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_6626_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_6627_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_6628_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6629_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K5 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_6630_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [X2: A] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N ) @ ( uminus_uminus @ A @ X2 ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6631_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [N6: nat] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N ) @ ( uminus_uminus @ A @ ( X8 @ N6 ) ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6632_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ B9 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_6633_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X2 ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_6634_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F3: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ A2 @ ( F3 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F3 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F3 )
                   => ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F3 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_6635_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y
            = ( ( Xa2
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( Y
                = ( ~ ( ( Deg2 = Xa2 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_6636_decseq__bounded,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ B3 @ ( X8 @ I4 ) )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_6637_open__diagonal__complement,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y5 ) )
              & ( X2 != Y5 ) ) ) ) ) ).

% open_diagonal_complement
thf(fact_6638_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y5 ) )
              & ( ord_less @ A @ X2 @ Y5 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6639_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y5 ) )
              & ( ord_less @ A @ Y5 @ X2 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6640_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z6: list @ A] :
              ? [X2: A,Xs3: list @ A] :
                ( ( Z6
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( member @ A @ X2 @ A7 )
                & ( member @ ( list @ A ) @ Xs3 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_6641_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P4: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P4 ) ) ) ) ).

% Ball_Collect
thf(fact_6642_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_6643_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_6644_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y3: A] :
              ( ( ord_less_eq @ A @ X5 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X5 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_6645_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y5: A] :
              ( ( ord_less_eq @ A @ X2 @ Y5 )
             => ( ord_less_eq @ B @ ( F5 @ Y5 ) @ ( F5 @ X2 ) ) ) ) ) ) ).

% antimono_def
thf(fact_6646_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I2 ) ) ) ) ) ).

% decseqD
thf(fact_6647_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X4 @ N ) @ ( X4 @ M3 ) ) ) ) ) ) ).

% decseq_def
thf(fact_6648_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I2: nat] :
          ( ( order_antimono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ ( suc @ I2 ) ) @ ( A3 @ I2 ) ) ) ) ).

% decseq_SucD
thf(fact_6649_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_6650_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F5 @ ( suc @ N ) ) @ ( F5 @ N ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_6651_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B5: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ B5 @ X2 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6652_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B5: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ X2 @ B5 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6653_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I3: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I3 ) )
                & ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_6654_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X8 @ N2 ) ) ) ) ) ).

% decseq_ge
thf(fact_6655_decseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ B3 @ ( X8 @ I4 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ L6 @ ( X8 @ I ) ) ) ) ) ).

% decseq_convergent
thf(fact_6656_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X2: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X4 )
            & ! [X2: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi2: nat,Ma2: nat] :
                ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                & ( ( Mi2 = Ma2 )
                 => ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                & ( ( Mi2 != Ma2 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma2 )
                    & ! [X2: nat] :
                        ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X2 )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_6657_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S4: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ A2 @ ( S4 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ B @ ( S4 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N: nat] : ( X8 @ ( S4 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_6658_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa2
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( Deg2 = Xa2 )
                & ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                    & ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi2: nat,Ma2: nat] :
                        ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                        & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I3: nat] :
                            ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                        & ( ( Mi2 = Ma2 )
                         => ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        & ( ( Mi2 != Ma2 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                            & ! [X2: nat] :
                                ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                 => ( ( ord_less @ nat @ Mi2 @ X2 )
                                    & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_6659_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa2
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ~ ( ( Deg2 = Xa2 )
                  & ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi2: nat,Ma2: nat] :
                          ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                          & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                          & ( ( Mi2 = Ma2 )
                           => ! [X2: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                          & ( ( Mi2 != Ma2 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                              & ! [X2: nat] :
                                  ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                   => ( ( ord_less @ nat @ Mi2 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_6660_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) )
               => ( Xa2
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa2 ) )
                 => ( ( Deg2 = Xa2 )
                    & ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                        & ! [X2: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi2: nat,Ma2: nat] :
                            ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                            & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I3: nat] :
                                ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                            & ( ( Mi2 = Ma2 )
                             => ! [X2: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                            & ( ( Mi2 != Ma2 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                & ! [X2: nat] :
                                    ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                     => ( ( ord_less @ nat @ Mi2 @ X2 )
                                        & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_6661_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) )
               => ( Xa2
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa2 ) )
                 => ~ ( ( Deg2 = Xa2 )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_6662_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6663_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6664_Union__maximal__sets,axiom,
    ! [A: $tType,F11: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ F11 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T9: set @ A] :
                ( ( member @ ( set @ A ) @ T9 @ F11 )
                & ! [X2: set @ A] :
                    ( ( member @ ( set @ A ) @ X2 @ F11 )
                   => ~ ( ord_less @ ( set @ A ) @ T9 @ X2 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F11 ) ) ) ).

% Union_maximal_sets
thf(fact_6665_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y
                  = ( Xa2
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( Y
                    = ( ( Deg2 = Xa2 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa2 ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_6666_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6667_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N )
                  & ? [Xys: list @ A,X2: A,Y5: A,Xs5: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X2 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_6668_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_6669_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R @ N2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N2 )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N2 ) ) ) ).

% lexn_length
thf(fact_6670_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X2: A,Y5: A,Xs5: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X2 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_6671_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F5: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y5: A] :
                  ( ( ord_less @ nat @ ( F5 @ X2 ) @ ( F5 @ Y5 ) )
                  | ( ( ord_less_eq @ nat @ ( F5 @ X2 ) @ ( F5 @ Y5 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_6672_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( lex @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) ) ) ) ) ).

% Cons_in_lex
thf(fact_6673_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R ) ) ).

% Nil_notin_lex
thf(fact_6674_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R ) ) ).

% Nil2_notin_lex
thf(fact_6675_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) ) ) ).

% lex_append_leftI
thf(fact_6676_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_6677_lex__append__leftD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_leftD
thf(fact_6678_lex__append__left__iff,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_left_iff
thf(fact_6679_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_rightI
thf(fact_6680_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R2 ) ) ) ) ).

% mlex_leq
thf(fact_6681_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R2 ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 ) ) ) ) ).

% mlex_iff
thf(fact_6682_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R2 ) ) ) ).

% mlex_less
thf(fact_6683_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ).

% in_measure
thf(fact_6684_in__finite__psubset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A3 @ B3 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
        & ( finite_finite @ A @ B3 ) ) ) ).

% in_finite_psubset
thf(fact_6685_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A7: set @ A,B8: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
              & ( finite_finite @ A @ B8 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_6686_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y7: set @ B,X8: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y7 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X2: B] : ( member @ B @ X2 @ Y7 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y7 @ G @ F4 ) )
          = ( map_filter_on @ B @ C @ Y7 @ ( comp @ A @ C @ B @ F2 @ G ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_6687_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [P4: A > $o] :
                  ( ( eventually @ A @ P4 @ F9 )
                  & ! [X2: A,Y5: A] :
                      ( ( ( P4 @ X2 )
                        & ( P4 @ Y5 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ E4 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_6688_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X5 )
              & ( ord_less_eq @ real @ X5 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X5: real] :
              ( ( ( ord_less @ real @ A2 @ X5 )
                & ( ord_less @ real @ X5 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X5: real] :
                  ( ( ( ord_less @ real @ A2 @ X5 )
                    & ( ord_less @ real @ X5 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_6689_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_6690_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_6691_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_6692_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_6693_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_6694_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_6695_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_6696_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N2: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% differentiable_power
thf(fact_6697_lenlex__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R ) ) ) ).

% lenlex_irreflexive
thf(fact_6698_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R ) ) ).

% Nil_lenlex_iff2
thf(fact_6699_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_6700_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_6701_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R2: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R2 ) ) ) ) ).

% lenlex_append1
thf(fact_6702_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N2: A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N2 @ Ns ) ) @ ( lenlex @ A @ R ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N2 ) @ R ) )
        | ( ( M = N2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_6703_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L4: real,Z4: real] :
              ( ( ord_less @ real @ A2 @ Z4 )
              & ( ord_less @ real @ Z4 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L4 @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L4 ) ) ) ) ) ) ).

% MVT
thf(fact_6704_continuous__artanh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( member @ real
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
              @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( artanh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_artanh
thf(fact_6705_continuous__on__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S: set @ A,F2: A > B,G: A > C] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ C @ S @ G )
           => ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_Pair
thf(fact_6706_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ S )
                 => ( ( G @ X5 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_6707_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_6708_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_6709_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_6710_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_6711_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_6712_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,N2: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X2: A] : ( root @ N2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_6713_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A3: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A3 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A3
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_6714_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N2: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ N2 ) ) ) ) ).

% continuous_on_power
thf(fact_6715_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_6716_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_6717_continuous__on__arcosh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_6718_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_6719_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y ) ) ) ) ) ) ) ).

% IVT'
thf(fact_6720_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_6721_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X2: C] : ( G @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_6722_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A3 ) )
         => ( ! [X5: A,Y3: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X5 @ Y3 )
                   => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A3 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_6723_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_6724_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                  = ( collect @ A
                    @ ^ [X2: A] :
                        ( ( member @ A @ X2 @ S )
                        & ( ord_less @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_6725_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X2: real] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_6726_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C3: real,D4: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D4 ) )
            & ( ord_less_eq @ real @ C3 @ D4 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_6727_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X2: A] :
                      ( ( member @ A @ X2 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_6728_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X5: C] :
                  ( ( member @ C @ X5 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
                    & ( ( ( F2 @ X5 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_6729_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) )
             => ( ! [X5: A] :
                    ( ( member @ A @ X5 @ S )
                   => ( ( F2 @ X5 )
                     != ( one_one @ real ) ) )
               => ( ! [X5: A] :
                      ( ( member @ A @ X5 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_6730_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arccos ).

% continuous_on_arccos'
thf(fact_6731_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arcsin ).

% continuous_on_arcsin'
thf(fact_6732_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X2: A] : ( arccos @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_6733_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X2: A] : ( arcsin @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_6734_continuous__on__artanh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_6735_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6736_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ A2 @ X5 )
             => ( ( ord_less_eq @ A @ X5 @ B2 )
               => ? [Y4: A] : ( has_field_derivative @ A @ F2 @ Y4 @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_6737_continuous__on__artanh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ A3 )
           => ( member @ real @ ( F2 @ X5 ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X2: real] : ( artanh @ real @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_artanh'
thf(fact_6738_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X5: real] :
                ( ( ord_less @ real @ A2 @ X5 )
               => ( ( ord_less @ real @ X5 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z4: real] :
                ( ( ord_less @ real @ A2 @ Z4 )
                & ( ord_less @ real @ Z4 @ B2 )
                & ( ( F8 @ Z4 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_6739_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F8 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_6740_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_6741_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_6742_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_6743_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less @ real @ A2 @ X5 )
           => ( ( ord_less @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_6744_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less @ real @ A2 @ X5 )
           => ( ( ord_less @ real @ X5 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_6745_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6746_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F2 @ X )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_6747_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X5: A] :
                  ( ( ord_less @ A @ A2 @ X5 )
                 => ( ( ord_less @ A @ X5 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X5 ) ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_6748_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X5: real] :
                ( ( ord_less @ real @ A2 @ X5 )
               => ( ( ord_less @ real @ X5 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z4: real] :
                ( ( ord_less @ real @ A2 @ Z4 )
                & ( ord_less @ real @ Z4 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z4 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_6749_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X2: A] : X2 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X2: A] : X2 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6750_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X2: list @ A,Y5: list @ A] :
                ? [A4: A,V5: list @ A] :
                  ( ( Y5
                    = ( append @ A @ X2 @ ( cons @ A @ A4 @ V5 ) ) )
                  | ? [U2: list @ A,B5: A,C4: A,W3: list @ A,Z6: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ C4 ) @ R5 )
                      & ( X2
                        = ( append @ A @ U2 @ ( cons @ A @ B5 @ W3 ) ) )
                      & ( Y5
                        = ( append @ A @ U2 @ ( cons @ A @ C4 @ Z6 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_6751_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A4: A,B5: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A15: A,B14: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A15 ) @ Ra )
                        | ( ( A4 = A15 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B5 @ B14 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_6752_in__lex__prod,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A5 @ B4 ) ) @ ( lex_prod @ A @ B @ R @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A5 ) @ R )
        | ( ( A2 = A5 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B4 ) @ S ) ) ) ) ).

% in_lex_prod
thf(fact_6753_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X: list @ A,B2: A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_6754_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R ) )
      = ( ? [A4: A,X2: list @ A] :
            ( Y
            = ( cons @ A @ A4 @ X2 ) ) ) ) ).

% lexord_Nil_left
thf(fact_6755_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R ) ) ).

% lexord_Nil_right
thf(fact_6756_lexord__linear,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A,Y: list @ A] :
      ( ! [A6: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ B6 ) @ R )
          | ( A6 = B6 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A6 ) @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
        | ( X = Y )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_linear
thf(fact_6757_lexord__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irreflexive
thf(fact_6758_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V2: list @ A,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_leftI
thf(fact_6759_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A,Y3: A,Z4: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y3 ) @ R )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Z4 ) @ R ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_6760_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U: list @ A,V2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) )
     => ( ! [A6: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A6 ) @ R )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_append_leftD
thf(fact_6761_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list @ A,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ? [B11: A,Z3: list @ A] :
          ( Y
          = ( cons @ A @ B11 @ Z3 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_rightI
thf(fact_6762_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_6763_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lex @ A @ R ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y ) ) ) ) ).

% lexord_lex
thf(fact_6764_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),U: list @ A,X: list @ A,Y: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A2 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_left_rightI
thf(fact_6765_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_6766_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R: set @ ( product_prod @ A @ A ),V2: list @ A,Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V2 ) @ ( append @ A @ W @ Z2 ) ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_sufI
thf(fact_6767_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_6768_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P4: A > $o,R6: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X9: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X2: A,Y5: B] :
                        ( ( X9 = X2 )
                        & ( P4 @ X2 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y5 ) @ ( R6 @ X2 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_6769_same__fstI,axiom,
    ! [B: $tType,A: $tType,P: A > $o,X: A,Y8: B,Y: B,R2: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y8 @ Y ) @ ( R2 @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y8 ) @ ( product_Pair @ A @ B @ X @ Y ) ) @ ( same_fst @ A @ B @ P @ R2 ) ) ) ) ).

% same_fstI
thf(fact_6770_relpow__finite__bounded1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 )
              @ ( collect @ nat
                @ ^ [N: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
                    & ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_6771_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,C6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C6 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C6 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_6772_relpow__1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( one_one @ nat ) @ R2 )
      = R2 ) ).

% relpow_1
thf(fact_6773_finite__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% finite_relpow
thf(fact_6774_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) )
     => ( X = Y ) ) ).

% relpow_0_E
thf(fact_6775_relpow__0__I,axiom,
    ! [A: $tType,X: A,R2: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) ) ).

% relpow_0_I
thf(fact_6776_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A ),Z2: A,N2: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 ) ) ) ) ).

% relpow_Suc_I2
thf(fact_6777_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% relpow_Suc_E2
thf(fact_6778_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 ) )
     => ? [Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% relpow_Suc_D2
thf(fact_6779_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y: A,N2: nat,R2: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 ) ) ) ) ).

% relpow_Suc_I
thf(fact_6780_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ R2 ) ) ) ).

% relpow_Suc_E
thf(fact_6781_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N2: nat,R2: set @ ( product_prod @ A @ A ),X3: A,Y4: A,Z3: A] :
      ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R2 ) )
     => ? [W2: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ W2 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ W2 @ Z3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% relpow_Suc_D2'
thf(fact_6782_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S3 )
                   => ( ord_less_eq @ A @ Xa @ X5 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_6783_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S3 )
                   => ( ord_less_eq @ A @ X5 @ Xa ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_6784_relpowp__relpow__eq,axiom,
    ! [A: $tType,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N2
        @ ^ [X2: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R2 ) )
      = ( ^ [X2: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_6785_relpow__E,axiom,
    ! [A: $tType,X: A,Z2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R2 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ R2 ) ) ) ) ) ).

% relpow_E
thf(fact_6786_relpow__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R2 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_6787_relpow__empty,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_6788_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa ) @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_6789_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Xa ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_6790_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) )
      = ( ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F5 @ N2 )
              = B2 )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ N2 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F5 @ I3 ) @ ( F5 @ ( suc @ I3 ) ) ) @ R2 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_6791_relpow__finite__bounded,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 )
            @ ( collect @ nat
              @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_6792_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S8: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X2: set @ A] :
                    ( ( member @ ( set @ A ) @ X2 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X2 ) )
                & ( ord_less_eq @ ( set @ A ) @ S8 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D8: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D8 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D8 )
                  & ( ord_less_eq @ ( set @ A ) @ S8 @ ( complete_Sup_Sup @ ( set @ A ) @ D8 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_6793_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X3: set @ A] :
                  ( ( member @ ( set @ A ) @ X3 @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X3 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_6794_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_6795_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I3 @ R6 )
              @ ( collect @ nat
                @ ^ [I3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I3 )
                    & ( ord_less_eq @ nat @ I3 @ ( suc @ N ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_6796_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 )
            @ ( collect @ nat
              @ ^ [N: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
                  & ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_6797_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ! [A6: A,B6: B] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ R )
           => ( P @ A6 @ B6 ) )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A6 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% trancl_induct2
thf(fact_6798_trancl_Ocases,axiom,
    ! [A: $tType,A12: A,A23: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ A23 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ A23 ) @ R )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ B6 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A23 ) @ R ) ) ) ) ).

% trancl.cases
thf(fact_6799_trancl_Osimps,axiom,
    ! [A: $tType,A12: A,A23: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ A23 ) @ ( transitive_trancl @ A @ R ) )
      = ( ? [A4: A,B5: A] :
            ( ( A12 = A4 )
            & ( A23 = B5 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B5 ) @ R ) )
        | ? [A4: A,B5: A,C4: A] :
            ( ( A12 = A4 )
            & ( A23 = C4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B5 ) @ ( transitive_trancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ C4 ) @ R ) ) ) ) ).

% trancl.simps
thf(fact_6800_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) ) ) ).

% trancl.r_into_trancl
thf(fact_6801_tranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
       => ~ ! [C3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C3 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ C3 @ B2 ) @ R ) ) ) ) ).

% tranclE
thf(fact_6802_trancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_trans
thf(fact_6803_trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ R )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R )
               => ( ( P @ Y3 )
                 => ( P @ Z4 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% trancl_induct
thf(fact_6804_r__r__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ).

% r_r_into_trancl
thf(fact_6805_converse__tranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% converse_tranclE
thf(fact_6806_irrefl__trancl__rD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
       => ( X != Y ) ) ) ).

% irrefl_trancl_rD
thf(fact_6807_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% Transitive_Closure.trancl_into_trancl
thf(fact_6808_trancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_into_trancl2
thf(fact_6809_trancl__trans__induct,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),P: A > A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [X5: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y3 ) @ R )
           => ( P @ X5 @ Y3 ) )
       => ( ! [X5: A,Y3: A,Z4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y3 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( P @ X5 @ Y3 )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ ( transitive_trancl @ A @ R ) )
                 => ( ( P @ Y3 @ Z4 )
                   => ( P @ X5 @ Z4 ) ) ) ) )
         => ( P @ X @ Y ) ) ) ) ).

% trancl_trans_induct
thf(fact_6810_converse__trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ B2 ) @ ( transitive_trancl @ A @ R ) )
               => ( ( P @ Z4 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_trancl_induct
thf(fact_6811_finite__trancl__ntranl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) @ ( one_one @ nat ) ) @ R2 ) ) ) ).

% finite_trancl_ntranl
thf(fact_6812_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_6813_trancl__power,axiom,
    ! [A: $tType,P2: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( transitive_trancl @ A @ R2 ) )
      = ( ? [N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( member @ ( product_prod @ A @ A ) @ P2 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ) ).

% trancl_power
thf(fact_6814_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z6: A,Z5: A,Vs2: list @ A] :
                  ( ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z6 @ Vs2 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z6 @ Z5 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z5 @ Vs2 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_6815_the__elem__set,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% the_elem_set
thf(fact_6816_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6817_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% append_listrel1I
thf(fact_6818_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_6819_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R ) ) ).

% not_listrel1_Nil
thf(fact_6820_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R ) ) ).

% not_Nil_listrel1
thf(fact_6821_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I2
thf(fact_6822_listrel1__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_6823_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I1
thf(fact_6824_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ! [Y3: A] :
            ( ( Ys
              = ( cons @ A @ Y3 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6825_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
     => ( ! [X5: A] :
            ( ( Xs
              = ( cons @ A @ X5 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6826_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% listrel1I
thf(fact_6827_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ~ ! [X5: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y3 ) @ R )
           => ! [Us3: list @ A,Vs3: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X5 @ Vs3 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y3 @ Vs3 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6828_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6829_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
      = ( ? [Y5: A,N: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N ) @ Y5 ) @ R )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N @ Y5 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_6830_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_6831_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F3: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ B2 @ ( F3 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F3 @ N9 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F3 )
                   => ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F3 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_6832_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ) ).

% mono_pow
thf(fact_6833_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_6834_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A3: A,B3: A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ A3 ) @ ( compow @ ( A > A ) @ N2 @ F2 @ B3 ) ) ) ) ) ).

% funpow_mono
thf(fact_6835_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A3: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A3 @ B3 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) ) ) ) ).

% mono_inf
thf(fact_6836_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y5: A] :
              ( ( ord_less_eq @ A @ X2 @ Y5 )
             => ( ord_less_eq @ B @ ( F5 @ X2 ) @ ( F5 @ Y5 ) ) ) ) ) ) ).

% mono_def
thf(fact_6837_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y3: A] :
              ( ( ord_less_eq @ A @ X5 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_6838_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoE
thf(fact_6839_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoD
thf(fact_6840_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_6841_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X4 @ M3 ) @ ( X4 @ N ) ) ) ) ) ) ).

% incseq_def
thf(fact_6842_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I2: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I2 ) @ ( A3 @ ( suc @ I2 ) ) ) ) ) ).

% incseq_SucD
thf(fact_6843_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_6844_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F5 @ N ) @ ( F5 @ ( suc @ N ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_6845_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_6846_mono__times__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N2 ) ) ) ).

% mono_times_nat
thf(fact_6847_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_6848_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_6849_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_6850_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_6851_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N2: A,M6: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
              = ( set_or7035219750837199246ssThan @ B @ M6 @ N5 ) )
           => ( ( ord_less @ A @ M @ N2 )
             => ( ( F2 @ M )
                = M6 ) ) ) ) ) ).

% mono_image_least
thf(fact_6852_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P2 @ ( F2 @ P2 ) )
           => ( ord_less_eq @ A @ P2 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_6853_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P2 ) @ P2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P2 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_6854_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I2: nat,J: nat,X: A,Y: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less_eq @ A @ X @ Y )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I2 @ F2 @ X ) @ ( compow @ ( A > A ) @ J @ F2 @ Y ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_6855_incseq__bounded,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( X8 @ I4 ) @ B3 )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_6856_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_6857_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I6 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I6 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_6858_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_6859_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I6 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I6 ) ) ) ) ) ).

% mono_INF
thf(fact_6860_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_6861_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N2 ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_6862_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_6863_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N2 @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_6864_incseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( X8 @ I4 ) @ B3 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ ( X8 @ I ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_6865_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_6866_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N8: nat] :
                  ( ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N8 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N8 )
                         => ( ( ord_less @ nat @ M2 @ N9 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N9 ) ) ) ) )
                  & ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ N9 )
                     => ( ( F2 @ N8 )
                        = ( F2 @ N9 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_6867_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S4: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ ( S4 @ N9 ) @ A2 )
               => ( ! [N9: nat] : ( ord_less @ B @ B2 @ ( S4 @ N9 ) )
                 => ( ( order_mono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N: nat] : ( X8 @ ( S4 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_6868_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys )
      = ( ? [F5: nat > nat] :
            ( ( order_mono @ nat @ nat @ F5 )
            & ( ( image @ nat @ nat @ F5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I3 )
                  = ( nth @ A @ Ys @ ( F5 @ I3 ) ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I3 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) )
                  = ( ( F5 @ I3 )
                    = ( F5 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_6869_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A7: set @ C,F5: C > A,G4: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: C] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ ( F5 @ A4 ) @ ( G4 @ A4 ) ) )
                & ( member @ C @ A4 @ A7 ) ) ) ) ) ).

% image2_def
thf(fact_6870_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_6871_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_6872_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_6873_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) ) ) ).

% mono_Int
thf(fact_6874_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_6875_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      & ( ( X != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_6876_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_6877_remdups__adj_Oelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X5: A] :
              ( ( X
                = ( cons @ A @ X5 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X5 @ ( nil @ A ) ) ) )
         => ~ ! [X5: A,Y3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ~ ( ( ( X5 = Y3 )
                     => ( Y
                        = ( remdups_adj @ A @ ( cons @ A @ X5 @ Xs2 ) ) ) )
                    & ( ( X5 != Y3 )
                     => ( Y
                        = ( cons @ A @ X5 @ ( remdups_adj @ A @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_6878_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_6879_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_6880_image2__eqI,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: A,F2: B > A,X: B,C2: C,G: B > C,A3: set @ B] :
      ( ( B2
        = ( F2 @ X ) )
     => ( ( C2
          = ( G @ X ) )
       => ( ( member @ B @ X @ A3 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A3 @ F2 @ G ) ) ) ) ) ).

% image2_eqI
thf(fact_6881_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
          ( ? [Y5: A,Ys3: list @ A] :
              ( ( X17
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) ) )
          | ? [X2: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X2 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) )
              & ( Less @ X2 @ Y5 ) )
          | ? [X2: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X2 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) )
              & ~ ( Less @ X2 @ Y5 )
              & ~ ( Less @ Y5 @ X2 )
              & ( P6 @ Xs3 @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_6882_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I2 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I2 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_6883_remdups__adj__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_6884_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_6885_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
            ( ? [Y5: A,Ys3: list @ A] :
                ( ( X17
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) ) )
            | ? [X2: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ( ord_less @ A @ X2 @ Y5 ) )
            | ? [X2: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ~ ( ord_less @ A @ X2 @ Y5 )
                & ~ ( ord_less @ A @ Y5 @ X2 )
                & ( P6 @ Xs3 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_6886_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_6887_and__not__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y
                 != ( none @ num ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y
                     != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_6888_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_6889_map__option__eq__Some,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xo: option @ B,Y: A] :
      ( ( ( map_option @ B @ A @ F2 @ Xo )
        = ( some @ A @ Y ) )
      = ( ? [Z6: B] :
            ( ( Xo
              = ( some @ B @ Z6 ) )
            & ( ( F2 @ Z6 )
              = Y ) ) ) ) ).

% map_option_eq_Some
thf(fact_6890_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N: nat] : ( ord_less @ A @ ( F5 @ N ) @ ( F5 @ ( suc @ N ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_6891_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N: A] : ( plus_plus @ A @ N @ K ) ) ) ).

% strict_mono_add
thf(fact_6892_map__option__cong,axiom,
    ! [B: $tType,A: $tType,X: option @ A,Y: option @ A,F2: A > B,G: A > B] :
      ( ( X = Y )
     => ( ! [A6: A] :
            ( ( Y
              = ( some @ A @ A6 ) )
           => ( ( F2 @ A6 )
              = ( G @ A6 ) ) )
       => ( ( map_option @ A @ B @ F2 @ X )
          = ( map_option @ A @ B @ G @ Y ) ) ) ) ).

% map_option_cong
thf(fact_6893_option_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X22: A] :
      ( ( map_option @ A @ B @ F2 @ ( some @ A @ X22 ) )
      = ( some @ B @ ( F2 @ X22 ) ) ) ).

% option.simps(9)
thf(fact_6894_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(5)
thf(fact_6895_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% strict_monoD
thf(fact_6896_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y3: A] :
              ( ( ord_less @ A @ X5 @ Y3 )
             => ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_6897_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y5: A] :
              ( ( ord_less @ A @ X2 @ Y5 )
             => ( ord_less @ B @ ( F5 @ X2 ) @ ( F5 @ Y5 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_6898_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% strict_mono_less
thf(fact_6899_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N2: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) ) ) ).

% strict_mono_imp_increasing
thf(fact_6900_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% strict_mono_less_eq
thf(fact_6901_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R: A > B,M: A,N2: A] :
          ( ( order_strict_mono @ A @ B @ R )
         => ( ( ord_less_eq @ A @ M @ N2 )
           => ( ord_less_eq @ B @ ( R @ M ) @ ( R @ N2 ) ) ) ) ) ).

% strict_mono_leD
thf(fact_6902_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(6)
thf(fact_6903_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(9)
thf(fact_6904_map__option__case,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F5: B > A] :
            ( case_option @ ( option @ A ) @ B @ ( none @ A )
            @ ^ [X2: B] : ( some @ A @ ( F5 @ X2 ) ) ) ) ) ).

% map_option_case
thf(fact_6905_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X5: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X5 @ Y3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y3 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_6906_and__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y
               != ( none @ num ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M4: num] :
                    ( X
                    = ( bit0 @ M4 ) )
               => ( ( Xa2 = one2 )
                 => ( Y
                   != ( none @ num ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                 => ( ( ? [M4: num] :
                          ( X
                          = ( bit1 @ M4 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_6907_xor__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ! [N3: num] :
                ( ( Xa2
                  = ( bit0 @ N3 ) )
               => ( Y
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit1 @ N3 ) )
                 => ( Y
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y
                     != ( some @ num @ ( bit1 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_6908_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_6909_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_6910_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(5)
thf(fact_6911_and__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(5)
thf(fact_6912_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_6913_and__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_6914_and__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N2 ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_6915_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_6916_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_6917_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_6918_and__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(8)
thf(fact_6919_and__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(6)
thf(fact_6920_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(9)
thf(fact_6921_xor__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ ( bit1 @ N2 ) ) ) ).

% xor_num.simps(2)
thf(fact_6922_xor__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ ( bit0 @ N2 ) ) ) ).

% xor_num.simps(3)
thf(fact_6923_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_6924_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_6925_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_6926_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_6927_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ) ).

% numeral_and_num
thf(fact_6928_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% numeral_xor_num
thf(fact_6929_and__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(9)
thf(fact_6930_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F8: real > real] :
      ( ! [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X5: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F8 @ X5 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_6931_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(6)
thf(fact_6932_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(8)
thf(fact_6933_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_6934_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_6935_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I6 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I4 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I6 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I6 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_6936_lenlex__append2,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R2 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R2 ) ) ) ) ).

% lenlex_append2
thf(fact_6937_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_6938_closed__diagonal,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Y5: product_prod @ A @ A] :
            ? [X2: A] :
              ( Y5
              = ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ) ) ).

% closed_diagonal
thf(fact_6939_irrefl__def,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R5 ) ) ) ).

% irrefl_def
thf(fact_6940_irreflI,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ! [A6: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A6 ) @ R2 )
     => ( irrefl @ A @ R2 ) ) ).

% irreflI
thf(fact_6941_irrefl__lex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R ) ) ) ).

% irrefl_lex
thf(fact_6942_lexord__irrefl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R2 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_irrefl
thf(fact_6943_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y5 ) )
              & ( ord_less_eq @ A @ Y5 @ X2 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_6944_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y5 ) )
              & ( ord_less_eq @ A @ X2 @ Y5 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_6945_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_6946_lexl__not__refl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R ) ) ) ).

% lexl_not_refl
thf(fact_6947_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S3: set @ A,Y: A] :
          ( ( topolo7761053866217962861closed @ A @ S3 )
         => ( ~ ( member @ A @ Y @ S3 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S3 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_6948_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S3: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S3 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S3 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S3 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_6949_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ A3 )
           => ? [A16: set @ A] :
                ( ( member @ A @ X @ A16 )
                & ( topolo7761053866217962861closed @ A @ A16 )
                & ( ord_less_eq @ ( set @ A ) @ A16 @ A3 )
                & ( eventually @ A
                  @ ^ [Y5: A] : ( member @ A @ Y5 @ A16 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_6950_inj__sgn__power,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( inj_on @ real @ real
        @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N2 ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_6951_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_rtrancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 )
            @ ( collect @ nat
              @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_6952_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_6953_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B5: A] : ( divide_divide @ A @ B5 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_6954_tranclD,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z4 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ Y ) @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% tranclD
thf(fact_6955_rtranclD,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( A2 = B2 )
        | ( ( A2 != B2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtranclD
thf(fact_6956_tranclD2,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z4 ) @ ( transitive_rtrancl @ A @ R2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ Y ) @ R2 ) ) ) ).

% tranclD2
thf(fact_6957_trancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ).

% trancl_into_rtrancl
thf(fact_6958_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R2 ) )
      = ( ( X = Y )
        | ( ( X != Y )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtrancl_eq_or_trancl
thf(fact_6959_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl1
thf(fact_6960_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl2
thf(fact_6961_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_trancl_trancl
thf(fact_6962_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_rtrancl_trancl
thf(fact_6963_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_6964_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_6965_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_6966_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_6967_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X2: A] : X2
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_6968_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_6969_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_6970_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B5: A] : ( plus_plus @ A @ B5 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_6971_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X5: A,Y3: A] :
              ( ( ord_less @ A @ X5 @ Y3 )
             => ( ( F2 @ X5 )
               != ( F2 @ Y3 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_6972_rtrancl_Ocases,axiom,
    ! [A: $tType,A12: A,A23: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ A23 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A23 != A12 )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ B6 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A23 ) @ R ) ) ) ) ).

% rtrancl.cases
thf(fact_6973_rtrancl_Osimps,axiom,
    ! [A: $tType,A12: A,A23: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ A23 ) @ ( transitive_rtrancl @ A @ R ) )
      = ( ? [A4: A] :
            ( ( A12 = A4 )
            & ( A23 = A4 ) )
        | ? [A4: A,B5: A,C4: A] :
            ( ( A12 = A4 )
            & ( A23 = C4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B5 ) @ ( transitive_rtrancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ C4 ) @ R ) ) ) ) ).

% rtrancl.simps
thf(fact_6974_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A2: A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( transitive_rtrancl @ A @ R ) ) ).

% rtrancl.rtrancl_refl
thf(fact_6975_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl.rtrancl_into_rtrancl
thf(fact_6976_rtranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A2 != B2 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R ) ) ) ) ).

% rtranclE
thf(fact_6977_rtrancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl_trans
thf(fact_6978_rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ A2 )
       => ( ! [Y3: A,Z4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_rtrancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R )
               => ( ( P @ Y3 )
                 => ( P @ Z4 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% rtrancl_induct
thf(fact_6979_converse__rtranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( X != Z2 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% converse_rtranclE
thf(fact_6980_converse__rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ B2 )
       => ( ! [Y3: A,Z4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
               => ( ( P @ Z4 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_rtrancl_induct
thf(fact_6981_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% converse_rtrancl_into_rtrancl
thf(fact_6982_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A6 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtrancl_induct2
thf(fact_6983_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa2: A,Xb3: B,Za: A,Zb: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb3 ) @ ( product_Pair @ A @ B @ Za @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( ( product_Pair @ A @ B @ Xa2 @ Xb3 )
         != ( product_Pair @ A @ B @ Za @ Zb ) )
       => ~ ! [A6: A,B6: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb3 ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ R )
             => ~ ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Za @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) ) ) ) ) ).

% converse_rtranclE2
thf(fact_6984_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Bx @ By )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A6 @ B6 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtrancl_induct2
thf(fact_6985_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X5: A,Y3: A] :
              ( ( ord_less @ A @ X5 @ Y3 )
             => ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( F2 @ X5 )
                   != ( F2 @ Y3 ) ) ) ) )
         => ( ! [X5: A,Y3: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X5 @ Y3 )
                    | ( ord_less_eq @ A @ Y3 @ X5 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_6986_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ).

% subset_inj_on
thf(fact_6987_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( inj_on @ A @ B @ F2 @ B3 ) ) ) ).

% inj_on_subset
thf(fact_6988_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( ( image @ A @ B @ F2 @ A3 )
              = ( image @ A @ B @ F2 @ B3 ) )
            = ( A3 = B3 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_6989_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( member @ A @ A2 @ B3 )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A3 ) )
            = ( member @ A @ A2 @ A3 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_6990_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S3
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_6991_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_6992_finite__surj__inj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ A @ A @ F2 @ A3 ) )
       => ( inj_on @ A @ A @ F2 @ A3 ) ) ) ).

% finite_surj_inj
thf(fact_6993_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( finite_finite @ A @ A3 ) ) ) ) ).

% inj_on_finite
thf(fact_6994_endo__inj__surj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A3 ) @ A3 )
       => ( ( inj_on @ A @ A @ F2 @ A3 )
         => ( ( image @ A @ A @ F2 @ A3 )
            = A3 ) ) ) ) ).

% endo_inj_surj
thf(fact_6995_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,A9: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F5: A > B] :
              ( ( inj_on @ A @ B @ F5 @ A3 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ A9 ) ) )
        = ( ? [G4: B > A] :
              ( ( image @ B @ A @ G4 @ A9 )
              = A3 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_6996_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% inj_image_subset_iff
thf(fact_6997_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_6998_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_6999_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( finite_card @ B @ A3 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A3 ) ) ).

% pigeonhole
thf(fact_7000_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7001_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,X: B,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A3 @ F2 @ X ) @ B3 ) ) ) ) ).

% the_inv_into_into
thf(fact_7002_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_7003_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_7004_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F2: B > C] :
      ( ! [I4: A,J2: A] :
          ( ( member @ A @ I4 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I4 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I4 ) ) ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I6 )
           => ( inj_on @ B @ C @ F2 @ ( A3 @ I4 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_7005_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A3 )
           => ( ( finite_finite @ A @ A3 )
             => ( ( finite_finite @ B @ B3 )
               => ( ( finite_card @ A @ A3 )
                  = ( finite_card @ B @ B3 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_7006_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S3 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S3 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S3 ) @ T6 )
           => ( ( ! [X2: B] :
                    ( ( member @ B @ X2 @ T6 )
                   => ? [Y5: A] :
                        ( ( member @ A @ Y5 @ S3 )
                        & ( ( F2 @ Y5 )
                          = X2 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S3 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_7007_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_7008_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C6: set @ A,A3: set @ C,B3: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ! [X5: C] :
            ( ( member @ C @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B3 @ X5 ) @ C6 ) )
       => ( ( member @ C @ J @ A3 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B3 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X2: C] : ( image @ A @ B @ F2 @ ( B3 @ X2 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_7009_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ? [F5: A > B] :
                ( ( inj_on @ A @ B @ F5 @ A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ B3 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_7010_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_7011_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) )
         => ? [F3: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B3 )
              & ( inj_on @ A @ B @ F3 @ A3 ) ) ) ) ) ).

% card_le_inj
thf(fact_7012_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_7013_funpow__inj__finite,axiom,
    ! [A: $tType,P2: A > A,X: A] :
      ( ( inj_on @ A @ A @ P2 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y5: A] :
              ? [N: nat] :
                ( Y5
                = ( compow @ ( A > A ) @ N @ P2 @ X ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P2 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_7014_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A3 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A3 @ B3 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_7015_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S3 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S3 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_7016_inj__split__Cons,axiom,
    ! [A: $tType,X8: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs3: list @ A,N: A] : ( cons @ A @ N @ Xs3 ) )
      @ X8 ) ).

% inj_split_Cons
thf(fact_7017_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_7018_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_7019_inj__on__Cons1,axiom,
    ! [A: $tType,X: A,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ A3 ) ).

% inj_on_Cons1
thf(fact_7020_inj__Some,axiom,
    ! [A: $tType,A3: set @ A] : ( inj_on @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ).

% inj_Some
thf(fact_7021_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X8: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( F2 @ X2 ) )
      @ X8 ) ).

% inj_on_convol_ident
thf(fact_7022_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I3: A,J3: B] : ( product_Pair @ B @ A @ J3 @ I3 ) )
      @ A3 ) ).

% swap_inj_on
thf(fact_7023_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N4 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_7024_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X4: $o > A,Y9: $o > A] :
              ( ( ord_less_eq @ A @ ( X4 @ $false ) @ ( Y9 @ $false ) )
              & ( ord_less_eq @ A @ ( X4 @ $true ) @ ( Y9 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_7025_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [N3: nat,F3: nat > A] :
          ( ( A3
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F3
            @ ( collect @ nat
              @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_7026_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [F3: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F3 @ A3 )
            = ( collect @ nat
              @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) )
          & ( inj_on @ A @ nat @ F3 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_7027_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ I6 )
           => ( ord_less @ nat @ X5 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I6 ) ) ) ).

% inj_on_nth
thf(fact_7028_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ~ ( finite_finite @ A @ S3 ) )
      = ( ? [F5: nat > A] :
            ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S3 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_7029_infinite__countable__subset,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ~ ( finite_finite @ A @ S3 )
     => ? [F3: nat > A] :
          ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S3 ) ) ) ).

% infinite_countable_subset
thf(fact_7030_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_7031_inj__on__funpow__least,axiom,
    ! [A: $tType,N2: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ S )
        = S )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N2 )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K2: nat] : ( compow @ ( A > A ) @ K2 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% inj_on_funpow_least
thf(fact_7032_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_7033_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_7034_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( ! [X5: nat] :
                ( ~ ( member @ nat @ X5 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X5 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_7035_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S3 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S3 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_7036_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa2 )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( insert @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y
             != ( insert @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X5: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ Xs2 ) )
               => ! [Y3: A,Ys4: list @ A] :
                    ( ( Xa2
                      = ( cons @ A @ Y3 @ Ys4 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X5 @ Xs2 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_7037_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X2: B] : ( set2 @ A @ ( F2 @ X2 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_7038_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_7039_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_7040_Un__subset__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C6 )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
        & ( ord_less_eq @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Un_subset_iff
thf(fact_7041_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_7042_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_append
thf(fact_7043_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_7044_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_7045_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > ( list @ B ),G: A > ( list @ B )] :
      ( ( Xs = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X5 )
              = ( G @ X5 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) ).

% list_bind_cong
thf(fact_7046_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_7047_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_7048_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_7049_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_7050_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_7051_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_7052_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( A4
                = ( sup_sup @ A @ A4 @ B5 ) )
              & ( A4 != B5 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_7053_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_7054_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_7055_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_7056_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_7057_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_7058_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_7059_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_7060_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_7061_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_7062_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_7063_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_7064_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_7065_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_7066_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_7067_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_7068_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X ) ) ) ) ).

% sup_least
thf(fact_7069_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y5: A] :
              ( ( sup_sup @ A @ X2 @ Y5 )
              = Y5 ) ) ) ) ).

% le_iff_sup
thf(fact_7070_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_7071_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_7072_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X5: A,Y3: A] : ( ord_less_eq @ A @ X5 @ ( F2 @ X5 @ Y3 ) )
         => ( ! [X5: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F2 @ X5 @ Y3 ) )
           => ( ! [X5: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X5 )
                 => ( ( ord_less_eq @ A @ Z4 @ X5 )
                   => ( ord_less_eq @ A @ ( F2 @ Y3 @ Z4 ) @ X5 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_7073_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_7074_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_7075_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_7076_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_7077_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_7078_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_7079_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B5 ) ) ) ) ) ).

% sup.order_iff
thf(fact_7080_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_7081_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_7082_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B5 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_7083_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( sup_sup @ A @ A4 @ B5 )
              = B5 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_7084_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_7085_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_7086_Un__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ ( sup_sup @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_7087_Un__least,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C6 ) ) ) ).

% Un_least
thf(fact_7088_Un__upper1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ).

% Un_upper1
thf(fact_7089_Un__upper2,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ).

% Un_upper2
thf(fact_7090_Un__absorb1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B3 )
        = B3 ) ) ).

% Un_absorb1
thf(fact_7091_Un__absorb2,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B3 )
        = A3 ) ) ).

% Un_absorb2
thf(fact_7092_subset__UnE,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
     => ~ ! [A16: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A16 @ A3 )
           => ! [B15: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B15 @ B3 )
               => ( C6
                 != ( sup_sup @ ( set @ A ) @ A16 @ B15 ) ) ) ) ) ).

% subset_UnE
thf(fact_7093_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B8 )
            = B8 ) ) ) ).

% subset_Un_eq
thf(fact_7094_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_7095_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_7096_Diff__partition,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
        = B3 ) ) ).

% Diff_partition
thf(fact_7097_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_7098_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ C6 )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C6 @ A3 ) ) ).

% Un_Int_assoc_eq
thf(fact_7099_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A3: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) ).

% mono_sup
thf(fact_7100_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% mono_Un
thf(fact_7101_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_7102_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P2: A,Q2: A,R: A] :
          ( ( ord_less_eq @ A @ P2 @ ( sup_sup @ A @ Q2 @ R ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P2 @ ( uminus_uminus @ A @ Q2 ) ) @ R ) ) ) ).

% sup_neg_inf
thf(fact_7103_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% shunt2
thf(fact_7104_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_7105_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_7106_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_7107_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_7108_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ).

% card_Un_le
thf(fact_7109_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_7110_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_7111_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_7112_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_7113_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_7114_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B3 ) ) ) ).

% Inter_Un_subset
thf(fact_7115_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_7116_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_7117_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_7118_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_7119_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_7120_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_7121_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_7122_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_7123_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_7124_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7125_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_7126_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B3: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B3 ) ) ) ).

% SUP_nat_binary
thf(fact_7127_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7128_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X2: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X2 )
        @ ^ [X2: A,Y5: A] : ( ord_less @ A @ Y5 @ X2 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_7129_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_7130_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_7131_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_7132_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_7133_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_7134_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_7135_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_7136_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_7137_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_7138_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_7139_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_7140_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_7141_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_7142_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_7143_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_7144_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_7145_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( F2 @ X5 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_7146_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_7147_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C6: set @ A,B3: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I3: B] : ( if @ A @ ( member @ B @ I3 @ ( image @ A @ B @ G @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G @ I3 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_7148_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N2: int,S3: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( power_int @ A @ X2 @ N2 )
            @ ^ [Y5: A] : ( times_times @ A @ Y5 @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S3 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_7149_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_7150_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_7151_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_7152_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_7153_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_7154_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N2: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N2 ) )
          = ( power_power @ A @ X @ N2 ) ) ) ).

% power_int_of_nat
thf(fact_7155_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N2: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_7156_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_7157_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_7158_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N2: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% power_int_numeral
thf(fact_7159_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: num,N2: int,Y: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( real_Vector_of_real @ A @ Y ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_7160_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y: real,X: num,N2: int] :
          ( ( ( real_Vector_of_real @ A @ Y )
            = ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N2 ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_7161_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_7162_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_7163_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_7164_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_7165_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_int @ A @ A2 @ N2 ) ) ) ) ).

% power_int_minus_left_even
thf(fact_7166_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_7167_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N2: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N2 ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_7168_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X5: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ X5 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y3 ) @ Q )
             => ( X5 = Y3 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separatorE
thf(fact_7169_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X5: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ B2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X5 ) @ Q )
             => ( Y3 = X5 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separator_converseE
thf(fact_7170_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_7171_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_7172_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R2 )
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ S3 ) )
      = ( ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S3 ) ) ) ) ).

% sup_Un_eq2
thf(fact_7173_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% zero_le_power_int
thf(fact_7174_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_7175_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_7176_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% zero_less_power_int
thf(fact_7177_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_7178_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N2: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N2 ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_commutes
thf(fact_7179_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_7180_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N2: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_one_over
thf(fact_7181_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_7182_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M: int,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M != N2 ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M @ N2 ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% power_int_diff
thf(fact_7183_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) ) ) ).

% power_int_minus_one_minus
thf(fact_7184_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_7185_atLeastLessThan__add__Un,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_7186_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y5: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y5 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_7187_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y5: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A2 ) @ ( transitive_trancl @ A @ R ) )
                  | ( X2 = A2 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y5 ) @ ( transitive_trancl @ A @ R ) )
                  | ( Y5 = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_7188_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_7189_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,N2: int] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N2 ) @ ( power_int @ A @ Y @ N2 ) ) ) ) ) ) ).

% power_int_mono
thf(fact_7190_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_7191_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% one_le_power_int
thf(fact_7192_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power_int
thf(fact_7193_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N2 )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ N2 ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% power_int_add
thf(fact_7194_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A2: A,N2: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_7195_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_7196_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_7197_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N2
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_7198_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_7199_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less_eq @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_7200_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_7201_trancl__insert,axiom,
    ! [A: $tType,Y: A,X: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A4: A,B5: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ Y ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ B5 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_7202_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_int @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_7203_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N2
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_minus_mult
thf(fact_7204_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_7205_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_7206_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X2: A,N: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N ) @ ( power_power @ A @ X2 @ ( nat2 @ N ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_7207_Pow__set_I2_J,axiom,
    ! [B: $tType,X: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert @ B @ X ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_7208_powr__real__of__int_H,axiom,
    ! [X: real,N2: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( X
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N2 ) )
       => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N2 ) )
          = ( power_int @ real @ X @ N2 ) ) ) ) ).

% powr_real_of_int'
thf(fact_7209_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,N2: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( power_int @ A @ ( F2 @ X2 ) @ N2 )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_7210_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X: C,F8: C > A,S3: set @ C,N2: int] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S3 ) )
           => ( has_derivative @ C @ A
              @ ^ [X2: C] : ( power_int @ A @ ( F2 @ X2 ) @ N2 )
              @ ^ [H: C] : ( times_times @ A @ ( F8 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S3 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_7211_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A17: set @ B,B16: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A17 )
        = B16 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B16 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A17 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_7212_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A4 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_7213_principal__le__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A3 ) @ ( principal @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% principal_le_iff
thf(fact_7214_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A17: set @ B,F1: B > C,B16: set @ C,F22: D > A,B23: set @ D] :
      ( ( member @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A17 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A17 ) @ B16 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B16 ) ) ) ) ) ).

% Func_map
thf(fact_7215_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I6: set @ A,F4: A > ( set @ B ),F2: B > C,G7: D > ( set @ C ),J4: set @ D] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I6 )
           => ! [J2: A] :
                ( ( member @ A @ J2 @ I6 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I4 ) @ ( F4 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J2 ) @ ( F4 @ I4 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G7 @ J3 ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I3: A] : ( principal @ B @ ( F4 @ I3 ) )
                @ I6 ) ) )
          = ( ! [X2: D] :
                ( ( member @ D @ X2 @ J4 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ I6 )
                    & ! [Z6: B] :
                        ( ( member @ B @ Z6 @ ( F4 @ Y5 ) )
                       => ( member @ C @ ( F2 @ Z6 ) @ ( G7 @ X2 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_7216_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X2: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_7217_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X2: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E4: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X2 ) @ E4 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_7218_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A4 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_7219_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A7 ) ) ) ) ).

% Id_on_def
thf(fact_7220_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,X: B,A3: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite @ A @ B3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B3 ) )
          @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y5 ) )
          @ A3
          @ B3 ) ) ) ).

% fold_union_pair
thf(fact_7221_Id__onI,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id_on @ A @ A3 ) ) ) ).

% Id_onI
thf(fact_7222_Id__on__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( id_on @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A3 ) ) ) ).

% Id_on_fold
thf(fact_7223_Id__on__iff,axiom,
    ! [A: $tType,X: A,Y: A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( id_on @ A @ A3 ) )
      = ( ( X = Y )
        & ( member @ A @ X @ A3 ) ) ) ).

% Id_on_iff
thf(fact_7224_Id__on__eqI,axiom,
    ! [A: $tType,A2: A,B2: A,A3: set @ A] :
      ( ( A2 = B2 )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id_on @ A @ A3 ) ) ) ) ).

% Id_on_eqI
thf(fact_7225_Id__onE,axiom,
    ! [A: $tType,C2: product_prod @ A @ A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ C2 @ ( id_on @ A @ A3 ) )
     => ~ ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( C2
             != ( product_Pair @ A @ A @ X5 @ X5 ) ) ) ) ).

% Id_onE
thf(fact_7226_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_7227_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G4 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_7228_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E4: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X2: A,Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ E4 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_7229_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,X8: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S3 ) @ X8 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A18: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z6 ) @ A18 )
                @ A18 ) )
          @ X8
          @ S3 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_7230_relpow__add,axiom,
    ! [A: $tType,M: nat,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M @ N2 ) @ R2 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M @ R2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ).

% relpow_add
thf(fact_7231_relpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R2 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) @ R2 ) ) ).

% relpow.simps(2)
thf(fact_7232_relcomp_Ocases,axiom,
    ! [A: $tType,C: $tType,B: $tType,A12: A,A23: C,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R @ S ) )
     => ~ ! [B6: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B6 ) @ R )
           => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B6 @ A23 ) @ S ) ) ) ).

% relcomp.cases
thf(fact_7233_relcomp_Osimps,axiom,
    ! [B: $tType,C: $tType,A: $tType,A12: A,A23: C,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R @ S ) )
      = ( ? [A4: A,B5: B,C4: C] :
            ( ( A12 = A4 )
            & ( A23 = C4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B5 ) @ R )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B5 @ C4 ) @ S ) ) ) ) ).

% relcomp.simps
thf(fact_7234_relcomp_OrelcompI,axiom,
    ! [A: $tType,C: $tType,B: $tType,A2: A,B2: B,R: set @ ( product_prod @ A @ B ),C2: C,S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B2 @ C2 ) @ S )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ C2 ) @ ( relcomp @ A @ B @ C @ R @ S ) ) ) ) ).

% relcomp.relcompI
thf(fact_7235_relcompE,axiom,
    ! [A: $tType,B: $tType,C: $tType,Xz: product_prod @ A @ B,R: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R @ S ) )
     => ~ ! [X5: A,Y3: C,Z4: B] :
            ( ( Xz
              = ( product_Pair @ A @ B @ X5 @ Z4 ) )
           => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X5 @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y3 @ Z4 ) @ S ) ) ) ) ).

% relcompE
thf(fact_7236_relcompEpair,axiom,
    ! [A: $tType,B: $tType,C: $tType,A2: A,C2: B,R: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ C2 ) @ ( relcomp @ A @ C @ B @ R @ S ) )
     => ~ ! [B6: C] :
            ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ B6 ) @ R )
           => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B6 @ C2 ) @ S ) ) ) ).

% relcompEpair
thf(fact_7237_uniformity__refl,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o,X: A] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ( E5 @ ( product_Pair @ A @ A @ X @ X ) ) ) ) ).

% uniformity_refl
thf(fact_7238_uniformity__trans,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ? [D9: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ D9 @ ( topolo7806501430040627800ormity @ A ) )
              & ! [X3: A,Y4: A,Z3: A] :
                  ( ( D9 @ ( product_Pair @ A @ A @ X3 @ Y4 ) )
                 => ( ( D9 @ ( product_Pair @ A @ A @ Y4 @ Z3 ) )
                   => ( E5 @ ( product_Pair @ A @ A @ X3 @ Z3 ) ) ) ) ) ) ) ).

% uniformity_trans
thf(fact_7239_uniformity__transE,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ~ ! [D9: ( product_prod @ A @ A ) > $o] :
                ( ( eventually @ ( product_prod @ A @ A ) @ D9 @ ( topolo7806501430040627800ormity @ A ) )
               => ~ ! [X3: A,Y4: A] :
                      ( ( D9 @ ( product_Pair @ A @ A @ X3 @ Y4 ) )
                     => ! [Z3: A] :
                          ( ( D9 @ ( product_Pair @ A @ A @ Y4 @ Z3 ) )
                         => ( E5 @ ( product_Pair @ A @ A @ X3 @ Z3 ) ) ) ) ) ) ) ).

% uniformity_transE
thf(fact_7240_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ C ),S6: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X2: A,Z6: B] :
                ? [Y5: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Y5 ) @ R5 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y5 @ Z6 ) @ S6 ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_7241_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu3: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_7242_uniformity__sym,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ( eventually @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y5: A] : ( E5 @ ( product_Pair @ A @ A @ Y5 @ X2 ) ) )
            @ ( topolo7806501430040627800ormity @ A ) ) ) ) ).

% uniformity_sym
thf(fact_7243_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_7244_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [P4: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P4 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N6: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ M3 )
                     => ( P4 @ ( product_Pair @ A @ A @ ( X4 @ N ) @ ( X4 @ M3 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_7245_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ R2 )
     => ( ( finite_finite @ ( product_prod @ B @ C ) @ S3 )
       => ( ( relcomp @ A @ B @ C @ R2 @ S3 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X2: A,Y5: B,A7: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z6: C,A18: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y5 = W3 ) @ ( insert @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Z6 ) @ A18 ) @ A18 ) )
                  @ A7
                  @ S3 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R2 ) ) ) ) ).

% relcomp_fold
thf(fact_7246_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E4: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X2: complex,Y5: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X2 @ Y5 ) @ E4 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_7247_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E4: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X2: real,Y5: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X2 @ Y5 ) @ E4 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_7248_totally__bounded__def,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S8: set @ A] :
            ! [E6: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ E6 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [X4: set @ A] :
                  ( ( finite_finite @ A @ X4 )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ S8 )
                     => ? [Y5: A] :
                          ( ( member @ A @ Y5 @ X4 )
                          & ( E6 @ ( product_Pair @ A @ A @ Y5 @ X2 ) ) ) ) ) ) ) ) ) ).

% totally_bounded_def
thf(fact_7249_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,R2: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X @ R2 ) @ S3 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A18: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z6 ) @ A18 )
                @ A18 ) )
          @ ( relcomp @ C @ A @ B @ R2 @ S3 )
          @ S3 ) ) ) ).

% insert_relcomp_fold
thf(fact_7250_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
                & ! [X2: A,Y5: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ E4 )
                   => ( P @ ( product_Pair @ A @ A @ X2 @ Y5 ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_7251_tendsto__iff__uniformity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo7287701948861334536_space @ B )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
          = ( ! [E6: ( product_prod @ B @ B ) > $o] :
                ( ( eventually @ ( product_prod @ B @ B ) @ E6 @ ( topolo7806501430040627800ormity @ B ) )
               => ( eventually @ A
                  @ ^ [X2: A] : ( E6 @ ( product_Pair @ B @ B @ ( F2 @ X2 ) @ L2 ) )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff_uniformity
thf(fact_7252_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S3: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X2: C,Y5: A,A7: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z6: B,A18: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y5 = W3 ) @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X2 @ Z6 ) @ A18 ) @ A18 ) )
              @ A7
              @ S3 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_7253_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_7254_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( ^ [Xs3: list @ A] : Xs3 ) ) ).

% map_ident
thf(fact_7255_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_7256_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_7257_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_7258_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F2: A > B,V2: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F2 @ V2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F2 ) @ V2 ) ) ).

% list.map_comp
thf(fact_7259_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_7260_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G ) @ Xs ) ) ).

% map_map
thf(fact_7261_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G @ Xs ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X2 )
              = ( G @ X2 ) ) ) ) ) ).

% map_eq_conv
thf(fact_7262_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_7263_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys ) ) ) ).

% map_append
thf(fact_7264_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N2: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N2 @ X ) )
      = ( replicate @ A @ N2 @ ( F2 @ X ) ) ) ).

% map_replicate
thf(fact_7265_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V2: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V2 ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V2 ) ) ) ).

% list.set_map
thf(fact_7266_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_7267_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G ) ) ) ).

% map_comp_map
thf(fact_7268_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) ) ) ).

% List.map.comp
thf(fact_7269_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_7270_nth__map,axiom,
    ! [B: $tType,A: $tType,N2: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N2 )
        = ( F2 @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% nth_map
thf(fact_7271_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X2: B] : ( cons @ A @ ( F2 @ X2 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_7272_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7273_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7274_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_7275_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_7276_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_7277_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs = Ys ) ) ) ).

% map_inj_on
thf(fact_7278_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_7279_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys ) ) ) ).

% map_injective
thf(fact_7280_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs3: list @ A,F5: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F5 @ Xs3 ) ) ) ) ).

% List.bind_def
thf(fact_7281_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X2: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_7282_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_7283_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_7284_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_7285_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( ( F2 @ Z6 )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_7286_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( X
              = ( F2 @ Z6 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_7287_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z4: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z4 @ Zs2 ) )
          & ( ( F2 @ Z4 )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_7288_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z4: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z4 @ Zs2 ) )
          & ( X
            = ( F2 @ Z4 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_7289_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X222: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X222 ) ) ) ).

% list.simps(9)
thf(fact_7290_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N2 ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y5: A] : ( cons @ A @ Y5 @ Ys3 )
              @ Xs )
          @ ( n_lists @ A @ N2 @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7291_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_7292_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_7293_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_7294_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y ) ) ) ).

% map_update
thf(fact_7295_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
thf(fact_7296_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_7297_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_7298_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z4 )
              = ( G @ Z4 ) ) )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_7299_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: list @ A,F2: A > B,G: A > B] :
      ( ! [Z4: A] :
          ( ( member @ A @ Z4 @ ( set2 @ A @ X ) )
         => ( ( F2 @ Z4 )
            = ( G @ Z4 ) ) )
     => ( ( map @ A @ B @ F2 @ X )
        = ( map @ A @ B @ G @ X ) ) ) ).

% list.map_cong0
thf(fact_7300_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Xa2: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z4: A,Za2: A] :
          ( ( member @ A @ Z4 @ ( set2 @ A @ X ) )
         => ( ( member @ A @ Za2 @ ( set2 @ A @ Xa2 ) )
           => ( ( ( F2 @ Z4 )
                = ( Fa @ Za2 ) )
             => ( Z4 = Za2 ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ Fa @ Xa2 ) )
       => ( X = Xa2 ) ) ) ).

% list.inj_map_strong
thf(fact_7301_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G: A > B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X5 )
            = ( G @ X5 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G @ Xs ) ) ) ).

% map_ext
thf(fact_7302_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X5 )
            = X5 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_7303_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > B,G: A > B] :
      ( ( Xs = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X5 )
              = ( G @ X5 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G @ Ys ) ) ) ) ).

% map_cong
thf(fact_7304_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F2: A > B] :
      ( ( ? [Xs3: list @ A] :
            ( Ys
            = ( map @ A @ B @ F2 @ Xs3 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ Ys ) )
           => ? [Y5: A] :
                ( X2
                = ( F2 @ Y5 ) ) ) ) ) ).

% ex_map_conv
thf(fact_7305_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_7306_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_7307_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( ~ ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_7308_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ X @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_7309_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_7310_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A3 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A3 ) ) ).

% inj_on_mapI
thf(fact_7311_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X2: B,Z6: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y5 ) )
            @ Z6
            @ B3 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_7312_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ A @ B ),K: A,V1: B,V22: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V1 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V22 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
thf(fact_7313_uniformity__trans_H,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [E5: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ E5 @ ( topolo7806501430040627800ormity @ A ) )
         => ( eventually @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) )
            @ ( product_case_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ $o
              @ ( product_case_prod @ A @ A @ ( ( product_prod @ A @ A ) > $o )
                @ ^ [X2: A,Y5: A] :
                    ( product_case_prod @ A @ A @ $o
                    @ ^ [Y6: A,Z6: A] :
                        ( ( Y5 = Y6 )
                       => ( E5 @ ( product_Pair @ A @ A @ X2 @ Z6 ) ) ) ) ) )
            @ ( prod_filter @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ ( topolo7806501430040627800ormity @ A ) @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformity_trans'
thf(fact_7314_map__snd__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_7315_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X2: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_7316_enumerate__Suc__eq,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( enumerate @ A @ ( suc @ N2 ) @ Xs )
      = ( map @ ( product_prod @ nat @ A ) @ ( product_prod @ nat @ A ) @ ( product_apfst @ nat @ nat @ A @ suc ) @ ( enumerate @ A @ N2 @ Xs ) ) ) ).

% enumerate_Suc_eq
thf(fact_7317_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_7318_eventually__prod__same,axiom,
    ! [A: $tType,P: ( product_prod @ A @ A ) > $o,F4: filter @ A] :
      ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( prod_filter @ A @ A @ F4 @ F4 ) )
      = ( ? [Q7: A > $o] :
            ( ( eventually @ A @ Q7 @ F4 )
            & ! [X2: A,Y5: A] :
                ( ( Q7 @ X2 )
               => ( ( Q7 @ Y5 )
                 => ( P @ ( product_Pair @ A @ A @ X2 @ Y5 ) ) ) ) ) ) ) ).

% eventually_prod_same
thf(fact_7319_eventually__prod__filter,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,F4: filter @ A,G7: filter @ B] :
      ( ( eventually @ ( product_prod @ A @ B ) @ P @ ( prod_filter @ A @ B @ F4 @ G7 ) )
      = ( ? [Pf: A > $o,Pg: B > $o] :
            ( ( eventually @ A @ Pf @ F4 )
            & ( eventually @ B @ Pg @ G7 )
            & ! [X2: A,Y5: B] :
                ( ( Pf @ X2 )
               => ( ( Pg @ Y5 )
                 => ( P @ ( product_Pair @ A @ B @ X2 @ Y5 ) ) ) ) ) ) ) ).

% eventually_prod_filter
thf(fact_7320_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_7321_nhds__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A2: A,B2: B] :
          ( ( topolo7230453075368039082e_nhds @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) )
          = ( prod_filter @ A @ B @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ B @ B2 ) ) ) ) ).

% nhds_prod
thf(fact_7322_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_7323_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_7324_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B,G7: filter @ B,F4: filter @ A,G: A > C,H6: filter @ C] :
      ( ( filterlim @ A @ B @ F2 @ G7 @ F4 )
     => ( ( filterlim @ A @ C @ G @ H6 @ F4 )
       => ( filterlim @ A @ ( product_prod @ B @ C )
          @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( prod_filter @ B @ C @ G7 @ H6 )
          @ F4 ) ) ) ).

% filterlim_Pair
thf(fact_7325_tendsto__mult__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X2: product_prod @ A @ A] : ( times_times @ A @ ( product_fst @ A @ A @ X2 ) @ ( product_snd @ A @ A @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_mult_Pair
thf(fact_7326_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X2: product_prod @ A @ A] : ( plus_plus @ A @ ( product_fst @ A @ A @ X2 ) @ ( product_snd @ A @ A @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_add_Pair
thf(fact_7327_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys3 )
              @ Xs3 ) ) ) ) ).

% product_concat_map
thf(fact_7328_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_7329_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X17: A,X24: list @ A] : ( H2 @ ( F22 @ X17 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_7330_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_7331_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X21: A,X222: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) ).

% list.simps(5)
thf(fact_7332_eventually__prod__sequentially,axiom,
    ! [P: ( product_prod @ nat @ nat ) > $o] :
      ( ( eventually @ ( product_prod @ nat @ nat ) @ P @ ( prod_filter @ nat @ nat @ ( at_top @ nat ) @ ( at_top @ nat ) ) )
      = ( ? [N6: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ N6 @ M3 )
           => ! [N: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N )
               => ( P @ ( product_Pair @ nat @ nat @ N @ M3 ) ) ) ) ) ) ).

% eventually_prod_sequentially
thf(fact_7333_remdups__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X @ ( nil @ A ) )
        @ ^ [Y5: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( X = Y5 ) @ ( cons @ A @ Y5 @ Xs3 ) @ ( cons @ A @ X @ ( cons @ A @ Y5 @ Xs3 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_7334_transpose_Oelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ ( list @ A ) ) )
         => ( Y
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X5: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) )
               => ( Y
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X5
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs2
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_7335_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_7336_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_7337_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_7338_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_7339_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_7340_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_7341_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_7342_transpose_Opelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ ( list @ A ) ) )
           => ( ( Y
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X5: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) )
                 => ( ( Y
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X5
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs2
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_7343_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_7344_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_7345_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_7346_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X5: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs2
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs2 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_7347_remdups__adj_Opelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X
                  = ( cons @ A @ X5 @ ( nil @ A ) ) )
               => ( ( Y
                    = ( cons @ A @ X5 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) )
           => ~ ! [X5: A,Y3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Xs2 ) ) )
                 => ( ( ( ( X5 = Y3 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X5 @ Xs2 ) ) ) )
                      & ( ( X5 != Y3 )
                       => ( Y
                          = ( cons @ A @ X5 @ ( remdups_adj @ A @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7348_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7349_remdups__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N2 ) )
      = ( upt @ M @ N2 ) ) ).

% remdups_upt
thf(fact_7350_length__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I2 @ J ) )
      = ( minus_minus @ nat @ J @ I2 ) ) ).

% length_upt
thf(fact_7351_upt__conv__Nil,axiom,
    ! [J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( upt @ I2 @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7352_sorted__list__of__set__range,axiom,
    ! [M: nat,N2: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
      = ( upt @ M @ N2 ) ) ).

% sorted_list_of_set_range
thf(fact_7353_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( upt @ I2 @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I2 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7354_nth__upt,axiom,
    ! [I2: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ K ) ) ) ).

% nth_upt
thf(fact_7355_map__fst__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_7356_upt__rec__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7357_enumerate__map__upt,axiom,
    ! [A: $tType,N2: nat,F2: nat > A,M: nat] :
      ( ( enumerate @ A @ N2 @ ( map @ nat @ A @ F2 @ ( upt @ N2 @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K2: nat] : ( product_Pair @ nat @ A @ K2 @ ( F2 @ K2 ) )
        @ ( upt @ N2 @ M ) ) ) ).

% enumerate_map_upt
thf(fact_7358_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] :
      ( ( map @ nat @ A
        @ ^ [I3: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I2 ) )
      = ( replicate @ A @ I2 @ X ) ) ).

% map_replicate_trivial
thf(fact_7359_map__add__upt,axiom,
    ! [N2: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ I3 @ N2 )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% map_add_upt
thf(fact_7360_map__Suc__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% map_Suc_upt
thf(fact_7361_distinct__upt,axiom,
    ! [I2: nat,J: nat] : ( distinct @ nat @ ( upt @ I2 @ J ) ) ).

% distinct_upt
thf(fact_7362_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N2: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N2 @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N2 @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7363_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7364_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I3: nat,J3: nat] : ( set2 @ nat @ ( upt @ I3 @ J3 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_7365_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ N @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7366_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7367_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast_upt
thf(fact_7368_upt__0,axiom,
    ! [I2: nat] :
      ( ( upt @ I2 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7369_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) ) ) ) ).

% atMost_upto
thf(fact_7370_upt__conv__Cons,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( upt @ I2 @ J )
        = ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_7371_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N2: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I3: nat] : ( F2 @ ( suc @ I3 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% map_upt_Suc
thf(fact_7372_map__decr__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) )
      = ( upt @ M @ N2 ) ) ).

% map_decr_upt
thf(fact_7373_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_7374_upt__add__eq__append,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7375_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,N2: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ N2 @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) ) @ I2 )
        = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) ) ).

% nth_map_upt
thf(fact_7376_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J: nat,X: nat,Xs: list @ nat] :
      ( ( ( upt @ I2 @ J )
        = ( cons @ nat @ X @ Xs ) )
      = ( ( ord_less @ nat @ I2 @ J )
        & ( I2 = X )
        & ( ( upt @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7377_upt__rec,axiom,
    ( upt
    = ( ^ [I3: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I3 @ J3 ) @ ( cons @ nat @ I3 @ ( upt @ ( suc @ I3 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7378_enumerate__replicate__eq,axiom,
    ! [A: $tType,N2: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N2 @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7379_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N2 @ M ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I4 )
              = ( F2 @ ( plus_plus @ nat @ M @ I4 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_7380_upt__Suc__append,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7381_upt__Suc,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7382_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N2
          = ( zero_zero @ nat ) ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I4 ) )
              = N2 ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I3: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I3 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7383_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) )
       => ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y ) ) ) ) ).

% map_of_is_SomeI
thf(fact_7384_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),Y: B,X: A] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( some @ B @ Y )
          = ( map_of @ A @ B @ Xys2 @ X ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% Some_eq_map_of_iff
thf(fact_7385_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% map_of_eq_Some_iff
thf(fact_7386_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Y: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Y ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs ) ) ) ).

% map_of_SomeD
thf(fact_7387_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X: B,L2: list @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ L2 ) )
     => ? [X5: B] :
          ( ( map_of @ A @ B @ L2 @ K )
          = ( some @ B @ X5 ) ) ) ).

% weak_map_of_SomeI
thf(fact_7388_map__of__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
        = ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
           => ( ( map_of @ A @ B @ Xs @ X5 )
              = ( map_of @ A @ B @ Ys @ X5 ) ) )
       => ( ( map_of @ A @ B @ Xs )
          = ( map_of @ A @ B @ Ys ) ) ) ) ).

% map_of_eqI
thf(fact_7389_map__of__Cons__code_I2_J,axiom,
    ! [C: $tType,B: $tType,L2: B,K: B,V2: C,Ps: list @ ( product_prod @ B @ C )] :
      ( ( ( L2 = K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L2 @ V2 ) @ Ps ) @ K )
          = ( some @ C @ V2 ) ) )
      & ( ( L2 != K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L2 @ V2 ) @ Ps ) @ K )
          = ( map_of @ B @ C @ Ps @ K ) ) ) ) ).

% map_of_Cons_code(2)
thf(fact_7390_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,Xs: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K2: A,V5: C] : ( product_Pair @ A @ B @ K2 @ ( F2 @ V5 ) ) )
          @ Xs ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( map_of @ A @ C @ Xs ) ) ) ).

% map_of_map
thf(fact_7391_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( set2 @ ( product_prod @ A @ B ) @ Xs )
        = ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [K2: A,V5: B] :
                ( ( map_of @ A @ B @ Xs @ K2 )
                = ( some @ B @ V5 ) ) ) ) ) ) ).

% set_map_of_compr
thf(fact_7392_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,T2: list @ ( product_prod @ A @ C ),K: A,X: C] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T2 @ K )
          = ( some @ C @ X ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K2: A] : ( product_Pair @ B @ C @ ( F2 @ K2 ) ) )
              @ T2 )
            @ ( F2 @ K ) )
          = ( some @ C @ X ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_7393_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( F2 @ X2 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7394_prod__filter__assoc,axiom,
    ! [A: $tType,B: $tType,C: $tType,F4: filter @ A,G7: filter @ B,H6: filter @ C] :
      ( ( prod_filter @ ( product_prod @ A @ B ) @ C @ ( prod_filter @ A @ B @ F4 @ G7 ) @ H6 )
      = ( filtermap @ ( product_prod @ A @ ( product_prod @ B @ C ) ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
        @ ( product_case_prod @ A @ ( product_prod @ B @ C ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
          @ ^ [X2: A] :
              ( product_case_prod @ B @ C @ ( product_prod @ ( product_prod @ A @ B ) @ C )
              @ ^ [Y5: B] : ( product_Pair @ ( product_prod @ A @ B ) @ C @ ( product_Pair @ A @ B @ X2 @ Y5 ) ) ) )
        @ ( prod_filter @ A @ ( product_prod @ B @ C ) @ F4 @ ( prod_filter @ B @ C @ G7 @ H6 ) ) ) ) ).

% prod_filter_assoc
thf(fact_7395_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ns ) )
               => ( X2
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7396_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( plus_plus @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_7397_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_7398_sum__list__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N2 ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum_list_upt
thf(fact_7399_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_7400_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_7401_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7402_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7403_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_7404_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
            = ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ A2 ) ) ) ) ) ).

% filtermap_nhds_times
thf(fact_7405_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > A,G: C > B,F4: filter @ C] :
      ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) )
      @ ( filtermap @ C @ ( product_prod @ A @ B )
        @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ F4 )
      @ ( prod_filter @ A @ B @ ( filtermap @ C @ A @ F2 @ F4 ) @ ( filtermap @ C @ B @ G @ F4 ) ) ) ).

% filtermap_Pair
thf(fact_7406_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X5 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7407_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                 => ( X2
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7408_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7409_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_7410_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N2 @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7411_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_7412_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X2: A] : X2
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_7413_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7414_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7415_at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          = ( filtermap @ A @ A
            @ ^ [X2: A] : ( plus_plus @ A @ X2 @ A2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_to_0
thf(fact_7416_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_7417_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_7418_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7419_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_7420_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F5: B > nat,Xs3: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F5 @ Xs3 ) ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7421_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X2: C] : R
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_7422_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_7423_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [C2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo174197925503356063within @ A @ P2 @ ( set_ord_greaterThan @ A @ P2 ) ) )
            = ( topolo174197925503356063within @ A @ ( times_times @ A @ C2 @ P2 ) @ ( set_ord_greaterThan @ A @ ( times_times @ A @ C2 @ P2 ) ) ) ) ) ) ).

% filtermap_times_pos_at_right
thf(fact_7424_prod__filter__principal__singleton,axiom,
    ! [A: $tType,B: $tType,X: A,F4: filter @ B] :
      ( ( prod_filter @ A @ B @ ( principal @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ F4 )
      = ( filtermap @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ F4 ) ) ).

% prod_filter_principal_singleton
thf(fact_7425_prod__filter__principal__singleton2,axiom,
    ! [B: $tType,A: $tType,F4: filter @ A,X: B] :
      ( ( prod_filter @ A @ B @ F4 @ ( principal @ B @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( filtermap @ A @ ( product_prod @ A @ B )
        @ ^ [A4: A] : ( product_Pair @ A @ B @ A4 @ X )
        @ F4 ) ) ).

% prod_filter_principal_singleton2
thf(fact_7426_cauchy__filter__metric__filtermap,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V768167426530841204y_dist @ B )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( topolo6773858410816713723filter @ B @ ( filtermap @ A @ B @ F2 @ F4 ) )
          = ( ! [E4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
               => ? [P4: A > $o] :
                    ( ( eventually @ A @ P4 @ F4 )
                    & ! [X2: A,Y5: A] :
                        ( ( ( P4 @ X2 )
                          & ( P4 @ Y5 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ ( F2 @ Y5 ) ) @ E4 ) ) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
thf(fact_7427_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7428_card__length__sum__list__rec,axiom,
    ! [M: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7429_card__length__sum__list,axiom,
    ! [M: nat,N4: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L )
                = N4 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N4 @ M ) @ ( one_one @ nat ) ) @ N4 ) ) ).

% card_length_sum_list
thf(fact_7430_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( F2 @ X2 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7431_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7432_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X5: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X5 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y3 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7433_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K2: A] : ( product_Pair @ A @ B @ K2 @ ( F2 @ K2 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F2 ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_7434_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7435_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X2: B,Y5: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y5 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_7436_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_7437_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R2: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X2: B,Y5: B] : ( R2 @ ( F2 @ X2 ) @ ( F2 @ Y5 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_7438_sorted__wrt__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_wrt_upt
thf(fact_7439_sorted__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_upt
thf(fact_7440_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7441_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7442_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7443_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N2: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N2 @ X ) ) ) ).

% sorted_replicate
thf(fact_7444_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_7445_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7446_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_7447_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7448_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7449_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_7450_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_7451_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_7452_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7453_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7454_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7455_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L2 )
            & ( distinct @ A @ L2 ) ) ) ) ).

% strict_sorted_iff
thf(fact_7456_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ! [Y5: A] :
                    ( ( member @ A @ Y5 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X2 @ Y5 ) ) ) ) ) ) ).

% sorted_append
thf(fact_7457_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( ( sorted_wrt @ A @ P @ Xs )
        & ( sorted_wrt @ A @ P @ Ys )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Ys ) )
               => ( P @ X2 @ Y5 ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_7458_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_7459_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7460_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa2 )
     => ~ ! [X5: A,Ys4: list @ A] :
            ( ( Xa2
              = ( cons @ A @ X5 @ Ys4 ) )
           => ( ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                 => ( X @ X5 @ Xa3 ) )
              & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7461_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X @ Ys ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
           => ( P @ X @ X2 ) )
        & ( sorted_wrt @ A @ P @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7462_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P4: A > A > $o,Xs3: list @ A] :
          ! [I3: nat,J3: nat] :
            ( ( ord_less @ nat @ I3 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P4 @ ( nth @ A @ Xs3 @ I3 ) @ ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7463_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I2: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I2 @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7464_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs ) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7465_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X5: A,Y3: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( P @ X5 @ Y3 )
             => ( Q @ X5 @ Y3 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_7466_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_7467_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_7468_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7469_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_7470_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa2 )
     => ( ( Xa2
         != ( nil @ A ) )
       => ~ ! [X5: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X5 @ Ys4 ) )
             => ~ ( ! [Xa: A] :
                      ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X5 @ Xa ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7471_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa2 )
        = Y )
     => ( ( ( Xa2
            = ( nil @ A ) )
         => ~ Y )
       => ~ ! [X5: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X5 @ Ys4 ) )
             => ( Y
                = ( ~ ( ! [Y5: A] :
                          ( ( member @ A @ Y5 @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X5 @ Y5 ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7472_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ? [X5: list @ A] :
              ( ( ( set2 @ A @ X5 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X5 )
              & ( distinct @ A @ X5 )
              & ! [Y4: list @ A] :
                  ( ( ( ( set2 @ A @ Y4 )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y4 )
                    & ( distinct @ A @ Y4 ) )
                 => ( Y4 = X5 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7473_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7474_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_7475_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ ( suc @ I3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7476_at__right__to__0,axiom,
    ! [A2: real] :
      ( ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) )
      = ( filtermap @ real @ real
        @ ^ [X2: real] : ( plus_plus @ real @ X2 @ A2 )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_right_to_0
thf(fact_7477_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ~ ! [L4: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L4 )
               => ( ( ( set2 @ A @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ A ) @ L4 )
                   != ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7478_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7479_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7480_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I2 @ ( nth @ nat @ Ns @ I2 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7481_sorted__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_7482_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7483_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,L2: list @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
              & ( ( set2 @ A @ L2 )
                = A3 )
              & ( ( size_size @ ( list @ A ) @ L2 )
                = ( finite_card @ A @ A3 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A3 )
              = L2 ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7484_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X5 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7485_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7486_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ~ ! [L4: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L4 ) )
               => ( ( ( set2 @ B @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ B ) @ L4 )
                   != ( finite_card @ B @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_7487_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) ).

% rev_is_rev_conv
thf(fact_7488_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_7489_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_7490_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_7491_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_7492_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_7493_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_7494_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_7495_rev__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N2 @ X ) )
      = ( replicate @ A @ N2 @ X ) ) ).

% rev_replicate
thf(fact_7496_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_7497_inj__on__rev,axiom,
    ! [A: $tType,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A3 ) ).

% inj_on_rev
thf(fact_7498_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_7499_singleton__rev__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_7500_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_7501_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_7502_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_7503_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_7504_sorted__upto,axiom,
    ! [M: int,N2: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N2 ) ) ).

% sorted_upto
thf(fact_7505_sorted__wrt__upto,axiom,
    ! [I2: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I2 @ J ) ) ).

% sorted_wrt_upto
thf(fact_7506_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X2: A,Y5: A] : ( P @ Y5 @ X2 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_7507_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_7508_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_7509_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_7510_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S3 ) ) ).

% folding_insort_key.inj_on
thf(fact_7511_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X2: A] : X2 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7512_rev__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N2 ) ) ) ) ) ).

% rev_nth
thf(fact_7513_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_7514_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_7515_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I3 ) ) @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7516_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7517_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7518_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I2 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7519_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I2 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ).

% transpose_column
thf(fact_7520_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X2: A] :
            ( ( Q @ X2 )
            & ( P @ X2 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_7521_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( P @ X5 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_7522_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_append
thf(fact_7523_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( remove1 @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_7524_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( removeAll @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_7525_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) ) ) ).

% set_filter
thf(fact_7526_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ~ ( P @ X5 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_7527_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_7528_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_7529_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X2: B] :
                  ( ( F2 @ X2 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_7530_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_7531_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ( X2
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_7532_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_7533_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_7534_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_7535_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X @ Xs ) )
      = ( remove1 @ A @ X @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_7536_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X2: A] :
            ( filter2 @ A
            @ ^ [Y5: A] : ( X2 != Y5 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_7537_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P @ X )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_7538_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_7539_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_7540_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( filter2 @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( filter2 @ A @ P @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_7541_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_shuffles
thf(fact_7542_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs ) ) ) ).

% distinct_filter
thf(fact_7543_Cons__eq__filterD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs3 ) ) )
          & ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X3 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs3 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_7544_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs3 ) ) )
          & ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X3 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs3 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_7545_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs2 ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X2 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs2 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_7546_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs2 ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X2 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs2 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_7547_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ Y @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X2: A] :
              ( ( F2 @ Y )
              = ( F2 @ X2 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
            @ Y )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_7548_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X2 ) ) ) ) ).

% empty_filter_conv
thf(fact_7549_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X2 ) ) ) ) ).

% filter_empty_conv
thf(fact_7550_inter__set__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_7551_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = Xs )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) ) ) ) ).

% filter_id_conv
thf(fact_7552_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( filter2 @ A @ P @ Xs )
          = ( filter2 @ A @ Q @ Ys ) ) ) ) ).

% filter_cong
thf(fact_7553_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_7554_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_7555_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
              @ X )
            @ Xs ) )
        @ X )
      = ( filter2 @ A
        @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
          @ X )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_7556_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_7557_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_7558_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_7559_filter__concat,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P2 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P2 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_7560_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_7561_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_7562_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7563_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X5 )
               => ( ( F2 @ X5 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7564_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_7565_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( X2 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_7566_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_7567_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_7568_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_7569_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_7570_length__filter__conv__card,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P2 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P2 @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7571_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_7572_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I2 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_7573_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ) ).

% transpose_column_length
thf(fact_7574_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B,L2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L2 ) )
              & ( ( set2 @ B @ L2 )
                = A3 )
              & ( ( size_size @ ( list @ B ) @ L2 )
                = ( finite_card @ B @ A3 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = L2 ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_7575_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_7576_tl__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( tl @ nat @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ N2 ) ) ).

% tl_upt
thf(fact_7577_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) ).

% tl_append2
thf(fact_7578_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7579_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7580_tl__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N2 @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_7581_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_7582_map__of__filter__in,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Z2: A,P: B > A > $o] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Z2 ) )
     => ( ( P @ K @ Z2 )
       => ( ( map_of @ B @ A @ ( filter2 @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) @ Xs ) @ K )
          = ( some @ A @ Z2 ) ) ) ) ).

% map_of_filter_in
thf(fact_7583_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_7584_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_7585_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_7586_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_7587_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z6: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_7588_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_7589_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) ).

% list.sel(3)
thf(fact_7590_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_7591_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_7592_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_7593_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_7594_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7595_nth__tl,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( suc @ N2 ) ) ) ) ).

% nth_tl
thf(fact_7596_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7597_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B,B3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( ord_less_eq @ ( set @ B ) @ B3 @ S3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B3 ) )
           => ( ( finite_finite @ B @ A3 )
             => ( ( finite_finite @ B @ B3 )
               => ( A3 = B3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_7598_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_7599_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
            = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_7600_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_7601_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_7602_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_7603_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_7604_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_7605_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S3 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_7606_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_7607_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_7608_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X @ A3 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_7609_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_7610_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X: B,Y: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( member @ B @ X @ S3 )
       => ( ( member @ B @ Y @ S3 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_7611_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_7612_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X2: B] : ( if @ ( option @ A ) @ ( P @ X2 ) @ ( some @ A @ ( F2 @ X2 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_7613_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) @ A2 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys @ A2 ) ) ) ).

% foldr_append
thf(fact_7614_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N2: nat,X: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N2 @ X ) )
      = ( compow @ ( A > A ) @ N2 @ ( F2 @ X ) ) ) ).

% foldr_replicate
thf(fact_7615_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L2: list @ B,K: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L2 = K )
       => ( ! [A6: A,X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ L2 ) )
             => ( ( F2 @ X5 @ A6 )
                = ( G @ X5 @ A6 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L2 @ A2 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_7616_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_7617_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_7618_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F2: C > B,Xs: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs @ A2 ) ) ).

% foldr_map
thf(fact_7619_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y5: A] : ( cons @ A @ Y5 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X ) ) ) ).

% map_filter_simps(1)
thf(fact_7620_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7621_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X2: B,B5: A] : ( plus_plus @ A @ ( F5 @ X2 ) @ ( times_times @ A @ A4 @ B5 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7622_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7623_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = Y ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7624_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X2: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7625_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_7626_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7627_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs ) )
      = ( takeWhile @ A @ P @ Xs ) ) ).

% takeWhile_idem
thf(fact_7628_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = Xs )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_7629_takeWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_7630_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( P @ X5 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_7631_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_7632_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_7633_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_7634_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( takeWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_7635_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A,L2: list @ A] :
      ( ~ ( P @ X )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ X @ L2 ) ) )
        = ( takeWhile @ A @ P @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_7636_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_7637_takeWhile__cong,axiom,
    ! [A: $tType,L2: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L2 = K )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ L2 ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( takeWhile @ A @ P @ L2 )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_7638_set__takeWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( P @ X ) ) ) ).

% set_takeWhileD
thf(fact_7639_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_7640_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_7641_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7642_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_7643_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) )
      & ( ~ ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( P @ X3 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_7644_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_7645_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ J )
         => ( P @ ( nth @ A @ Xs @ I4 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7646_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7647_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P4: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y5: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs3 ) ) ) ) ).

% extract_def
thf(fact_7648_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_7649_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs ) )
      = ( dropWhile @ A @ P @ Xs ) ) ).

% dropWhile_idem
thf(fact_7650_hd__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( hd @ nat @ ( upt @ I2 @ J ) )
        = I2 ) ) ).

% hd_upt
thf(fact_7651_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_7652_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_7653_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_7654_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( P @ X5 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( dropWhile @ A @ P @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_7655_dropWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_7656_hd__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N2 @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_7657_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) ) ) ).

% dropWhile_replicate
thf(fact_7658_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( dropWhile @ A @ P @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_7659_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_7660_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_7661_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_7662_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] :
                ( X2
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7663_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List2: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
thf(fact_7664_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_7665_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_7666_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_7667_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_7668_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_7669_dropWhile__cong,axiom,
    ! [A: $tType,L2: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L2 = K )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ L2 ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( dropWhile @ A @ P @ L2 )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_7670_set__dropWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_7671_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_7672_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_7673_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_7674_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_7675_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ps2: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps2 @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps2 @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_7676_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( P @ Y )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_7677_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y5: A] : ( Y5 = X )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7678_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( dropWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_7679_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_7680_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_7681_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_7682_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_7683_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_7684_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_7685_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_7686_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
        & ~ ( P @ Y ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_7687_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
         => ~ ( P @ X5 ) )
     => ( ( takeWhile @ A @ P @ Xs )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_7688_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List3: list @ A] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_7689_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P @ Ys ) ) )
      & ( ~ ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( P @ X3 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_7690_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z2: A,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_7691_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_7692_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_7693_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] : ( X2 = Y )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7694_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7695_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_7696_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y5: A] : ( Y5 != X )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y5: A] : ( Y5 != X )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_7697_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y5: A] : ( Y5 != X )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y5: A] : ( Y5 != X )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_7698_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7699_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F5: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F5 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F5 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7700_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X2 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7701_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P4: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X2: A,Xa4: list @ A] : ( some @ A @ X2 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs3 ) ) ) ) ).

% find_dropWhile
thf(fact_7702_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F5: A > $o,Xs3: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F5 @ Xs3 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F5 ) @ Xs3 ) ) ) ) ).

% partition_filter_conv
thf(fact_7703_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( find @ A @ P @ Xs )
          = ( find @ A @ Q @ Ys ) ) ) ) ).

% find_cong
thf(fact_7704_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ Xs ) ) ).

% partition_filter1
thf(fact_7705_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ A @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( find @ A @ P @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_7706_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_7707_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P @ X2 ) ) ) ) ).

% find_None_iff
thf(fact_7708_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P @ X2 ) ) ) ) ).

% find_None_iff2
thf(fact_7709_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7710_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Yes ) )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ No4 ) )
           => ~ ( P @ X3 ) ) ) ) ).

% partition_P
thf(fact_7711_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes2 ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X @ No ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_7712_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_7713_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No4 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_7714_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I3 ) )
            & ( X
              = ( nth @ A @ Xs @ I3 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I3 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7715_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I3 ) )
            & ( X
              = ( nth @ A @ Xs @ I3 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I3 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7716_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,D5: set @ A,M: A > ( option @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ D5 )
       => ( ( restrict_map @ A @ B @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ D5 )
          = ( map_upds @ A @ B @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( set2 @ A @ Xs ) ) ) @ Xs @ Ys ) ) ) ) ).

% restrict_map_upds
thf(fact_7717_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F5: A > ( option @ B ),Xs3: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F5 )
            @ ( filter2 @ A
              @ ^ [X2: A] :
                  ( ( F5 @ X2 )
                 != ( none @ B ) )
              @ Xs3 ) ) ) ) ).

% map_filter_def
thf(fact_7718_map__upds__apply__nontin,axiom,
    ! [B: $tType,A: $tType,X: A,Xs: list @ A,F2: A > ( option @ B ),Ys: list @ B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( map_upds @ A @ B @ F2 @ Xs @ Ys @ X )
        = ( F2 @ X ) ) ) ).

% map_upds_apply_nontin
thf(fact_7719_option_Ocollapse,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( ( some @ A @ ( the2 @ A @ Option ) )
        = Option ) ) ).

% option.collapse
thf(fact_7720_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ Zs ) @ Ys )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append_drop
thf(fact_7721_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( append @ B @ Ys @ Zs ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append2_drop
thf(fact_7722_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I2: nat,M: A > ( option @ B ),Ys: list @ B,Y: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( list_update @ B @ Ys @ I2 @ Y ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% map_upds_list_update2_drop
thf(fact_7723_option_Osel,axiom,
    ! [A: $tType,X22: A] :
      ( ( the2 @ A @ ( some @ A @ X22 ) )
      = X22 ) ).

% option.sel
thf(fact_7724_option_Oexhaust__sel,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( Option
        = ( some @ A @ ( the2 @ A @ Option ) ) ) ) ).

% option.exhaust_sel
thf(fact_7725_option_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ~ ( ( ( Option
                = ( none @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Option
                = ( some @ A @ ( the2 @ A @ Option ) ) )
              & ~ ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ) ).

% option.split_sel_asm
thf(fact_7726_option_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ( ( Option
            = ( none @ A ) )
         => ( P @ F1 ) )
        & ( ( Option
            = ( some @ A @ ( the2 @ A @ Option ) ) )
         => ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ).

% option.split_sel
thf(fact_7727_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),X: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ Ys )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ X @ ( some @ B @ ( nth @ B @ Ys @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_7728_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,B3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ S3 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B3 )
             => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) @ B3 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_7729_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: A,Xs: list @ A,F2: A > B,V2: B] :
      ( ~ ( member @ A @ Y @ ( set2 @ A @ Xs ) )
     => ( ( map @ A @ B @ ( fun_upd @ A @ B @ F2 @ Y @ V2 ) @ Xs )
        = ( map @ A @ B @ F2 @ Xs ) ) ) ).

% map_fun_upd
thf(fact_7730_image__map__upd,axiom,
    ! [B: $tType,A: $tType,X: A,A3: set @ A,M: A > ( option @ B ),Y: B] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( image @ A @ ( option @ B ) @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ ( some @ B @ Y ) ) @ A3 )
        = ( image @ A @ ( option @ B ) @ M @ A3 ) ) ) ).

% image_map_upd
thf(fact_7731_map__upds__Cons,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,As3: list @ A,B2: B,Bs: list @ B] :
      ( ( map_upds @ A @ B @ M @ ( cons @ A @ A2 @ As3 ) @ ( cons @ B @ B2 @ Bs ) )
      = ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs ) ) ).

% map_upds_Cons
thf(fact_7732_map__upds__twist,axiom,
    ! [A: $tType,B: $tType,A2: A,As3: list @ A,M: A > ( option @ B ),B2: B,Bs: list @ B] :
      ( ~ ( member @ A @ A2 @ ( set2 @ A @ As3 ) )
     => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ As3 @ Bs ) @ A2 @ ( some @ B @ B2 ) ) ) ) ).

% map_upds_twist
thf(fact_7733_map__option__o__map__upd,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,M: A > ( option @ C ),A2: A,B2: C] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( fun_upd @ A @ ( option @ C ) @ M @ A2 @ ( some @ C @ B2 ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ M ) @ A2 @ ( some @ B @ ( F2 @ B2 ) ) ) ) ).

% map_option_o_map_upd
thf(fact_7734_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),X: A,Y: B] :
      ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ ( some @ B @ Y ) ) @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( restrict_map @ A @ B @ M @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% restrict_upd_same
thf(fact_7735_map__upd__Some__unfold,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),A2: B,B2: A,X: B,Y: A] :
      ( ( ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) @ X )
        = ( some @ A @ Y ) )
      = ( ( ( X = A2 )
          & ( B2 = Y ) )
        | ( ( X != A2 )
          & ( ( M @ X )
            = ( some @ A @ Y ) ) ) ) ) ).

% map_upd_Some_unfold
thf(fact_7736_map__upd__triv,axiom,
    ! [A: $tType,B: $tType,T2: B > ( option @ A ),K: B,X: A] :
      ( ( ( T2 @ K )
        = ( some @ A @ X ) )
     => ( ( fun_upd @ B @ ( option @ A ) @ T2 @ K @ ( some @ A @ X ) )
        = T2 ) ) ).

% map_upd_triv
thf(fact_7737_map__upd__eqD1,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,X: B,N2: A > ( option @ B ),Y: B] :
      ( ( ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ X ) )
        = ( fun_upd @ A @ ( option @ B ) @ N2 @ A2 @ ( some @ B @ Y ) ) )
     => ( X = Y ) ) ).

% map_upd_eqD1
thf(fact_7738_map__upd__nonempty,axiom,
    ! [B: $tType,A: $tType,T2: A > ( option @ B ),K: A,X: B] :
      ( ( fun_upd @ A @ ( option @ B ) @ T2 @ K @ ( some @ B @ X ) )
     != ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_upd_nonempty
thf(fact_7739_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,G: A > B > B,A3: set @ A,S: B,T2: B,B3: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ G )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
         => ( ( finite_finite @ A @ A3 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ A3 )
                 => ( ( F2 @ X5 )
                    = ( G @ X5 ) ) )
             => ( ( S = T2 )
               => ( ( A3 = B3 )
                 => ( ( finite_fold @ A @ B @ F2 @ S @ A3 )
                    = ( finite_fold @ A @ B @ G @ T2 @ B3 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_7740_finite__range__updI,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),A2: B,B2: A] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ ( fun_upd @ B @ ( option @ A ) @ F2 @ A2 @ ( some @ A @ B2 ) ) @ ( top_top @ ( set @ B ) ) ) ) ) ).

% finite_range_updI
thf(fact_7741_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S3: set @ A,F2: A > B > B,G: C > A,R2: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S3 )
       => ( finite4664212375090638736ute_on @ C @ B @ R2 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_7742_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
thf(fact_7743_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
              = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A3 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
thf(fact_7744_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A3 ) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
thf(fact_7745_map__of_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,Ps: list @ ( product_prod @ A @ B )] :
      ( ( map_of @ A @ B @ ( cons @ ( product_prod @ A @ B ) @ P2 @ Ps ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ Ps ) @ ( product_fst @ A @ B @ P2 ) @ ( some @ B @ ( product_snd @ A @ B @ P2 ) ) ) ) ).

% map_of.simps(2)
thf(fact_7746_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,X: A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ A3 )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_7747_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_7748_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),K: A,V2: B] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( some @ B @ V2 ) ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) ) ) ) ).

% graph_map_upd
thf(fact_7749_ran__map__upd,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( none @ A ) )
     => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) ) )
        = ( insert @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ) ).

% ran_map_upd
thf(fact_7750_graph__restrictD_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V2: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( member @ A @ K @ A3 ) ) ).

% graph_restrictD(1)
thf(fact_7751_ranI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ).

% ranI
thf(fact_7752_in__graphI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),K: B,V2: A] :
      ( ( ( M @ K )
        = ( some @ A @ V2 ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ V2 ) @ ( graph @ B @ A @ M ) ) ) ).

% in_graphI
thf(fact_7753_in__graphD,axiom,
    ! [A: $tType,B: $tType,K: A,V2: B,M: A > ( option @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( graph @ A @ B @ M ) )
     => ( ( M @ K )
        = ( some @ B @ V2 ) ) ) ).

% in_graphD
thf(fact_7754_ran__restrictD,axiom,
    ! [B: $tType,A: $tType,Y: A,M: B > ( option @ A ),A3: set @ B] :
      ( ( member @ A @ Y @ ( ran @ B @ A @ ( restrict_map @ B @ A @ M @ A3 ) ) )
     => ? [X5: B] :
          ( ( member @ B @ X5 @ A3 )
          & ( ( M @ X5 )
            = ( some @ A @ Y ) ) ) ) ).

% ran_restrictD
thf(fact_7755_ran__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ B
            @ ^ [B5: B] :
              ? [A4: A] :
                ( ( M3 @ A4 )
                = ( some @ B @ B5 ) ) ) ) ) ).

% ran_def
thf(fact_7756_graph__restrictD_I2_J,axiom,
    ! [A: $tType,B: $tType,K: A,V2: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( ( M @ K )
        = ( some @ B @ V2 ) ) ) ).

% graph_restrictD(2)
thf(fact_7757_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: A,B5: B] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ A4 @ B5 ) )
                & ( ( M3 @ A4 )
                  = ( some @ B @ B5 ) ) ) ) ) ) ).

% graph_def
thf(fact_7758_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),X: B,Y: A,Z2: A] :
      ( ( ( M @ X )
        = ( some @ A @ Y ) )
     => ( ( inj_on @ B @ ( option @ A ) @ M @ ( dom @ B @ A @ M ) )
       => ( ~ ( member @ A @ Z2 @ ( ran @ B @ A @ M ) )
         => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ X @ ( some @ A @ Z2 ) ) )
            = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( ran @ B @ A @ M ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% ran_map_upd_Some
thf(fact_7759_uniformly__continuous__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo7287701948861334536_space @ A )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [S: set @ A,F2: A > B,E5: ( product_prod @ B @ B ) > $o] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ S @ F2 )
         => ( ( eventually @ ( product_prod @ B @ B ) @ E5 @ ( topolo7806501430040627800ormity @ B ) )
           => ( eventually @ ( product_prod @ A @ A )
              @ ( product_case_prod @ A @ A @ $o
                @ ^ [X2: A,Y5: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ( member @ A @ Y5 @ S )
                     => ( E5 @ ( product_Pair @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y5 ) ) ) ) ) )
              @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformly_continuous_onD
thf(fact_7760_dom__const,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( some @ B @ ( F2 @ X2 ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% dom_const
thf(fact_7761_domI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ B @ A2 @ ( dom @ B @ A @ M ) ) ) ).

% domI
thf(fact_7762_domD,axiom,
    ! [A: $tType,B: $tType,A2: A,M: A > ( option @ B )] :
      ( ( member @ A @ A2 @ ( dom @ A @ B @ M ) )
     => ? [B6: B] :
          ( ( M @ A2 )
          = ( some @ B @ B6 ) ) ) ).

% domD
thf(fact_7763_insert__dom,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Y: A] :
      ( ( ( F2 @ X )
        = ( some @ A @ Y ) )
     => ( ( insert @ B @ X @ ( dom @ B @ A @ F2 ) )
        = ( dom @ B @ A @ F2 ) ) ) ).

% insert_dom
thf(fact_7764_finite__set__of__finite__maps,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( finite_finite @ ( A > ( option @ B ) )
          @ ( collect @ ( A > ( option @ B ) )
            @ ^ [M3: A > ( option @ B )] :
                ( ( ( dom @ A @ B @ M3 )
                  = A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( ran @ A @ B @ M3 ) @ B3 ) ) ) ) ) ) ).

% finite_set_of_finite_maps
thf(fact_7765_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( image @ A @ ( product_prod @ A @ B )
            @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( the2 @ B @ ( M3 @ X2 ) ) )
            @ ( dom @ A @ B @ M3 ) ) ) ) ).

% graph_eq_to_snd_dom
thf(fact_7766_finite__Map__induct,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),P: ( A > ( option @ B ) ) > $o] :
      ( ( finite_finite @ A @ ( dom @ A @ B @ M ) )
     => ( ( P
          @ ^ [X2: A] : ( none @ B ) )
       => ( ! [K3: A,V3: B,M4: A > ( option @ B )] :
              ( ( finite_finite @ A @ ( dom @ A @ B @ M4 ) )
             => ( ~ ( member @ A @ K3 @ ( dom @ A @ B @ M4 ) )
               => ( ( P @ M4 )
                 => ( P @ ( fun_upd @ A @ ( option @ B ) @ M4 @ K3 @ ( some @ B @ V3 ) ) ) ) ) )
         => ( P @ M ) ) ) ) ).

% finite_Map_induct
thf(fact_7767_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S6: set @ A,F5: A > B] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ S6 )
                     => ! [Y5: A] :
                          ( ( member @ A @ Y5 @ S6 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X2 ) @ D3 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ Y5 ) @ ( F5 @ X2 ) ) @ E4 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_7768_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X: A] :
      ( ( ( dom @ A @ B @ F2 )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ? [V5: B] :
            ( F2
            = ( fun_upd @ A @ ( option @ B )
              @ ^ [X2: A] : ( none @ B )
              @ X
              @ ( some @ B @ V5 ) ) ) ) ) ).

% dom_eq_singleton_conv
thf(fact_7769_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,M: A > ( option @ B )] :
      ( ( ( set2 @ A @ Xs )
        = ( dom @ A @ B @ M ) )
     => ( ( map_of @ A @ B
          @ ( map @ A @ ( product_prod @ A @ B )
            @ ^ [K2: A] : ( product_Pair @ A @ B @ K2 @ ( the2 @ B @ ( M @ K2 ) ) )
            @ Xs ) )
        = M ) ) ).

% map_of_map_keys
thf(fact_7770_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A,Y5: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ S6 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ ( F2 @ Y5 ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_7771_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
            & ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( suc @ N2 ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs3: list @ A,N: A] : ( cons @ A @ N @ Xs3 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) )
          @ ^ [Uu3: list @ A] : A3 ) ) ) ).

% lists_length_Suc_eq
thf(fact_7772_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set @ nat,Xs: list @ A,I2: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A3 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I2 @ ( plus_plus @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P6 ) @ I2 ) @ A3 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7773_mem__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
      = ( ( member @ A @ A2 @ A3 )
        & ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ) ).

% mem_Sigma_iff
thf(fact_7774_SigmaI,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B2: B,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ B @ B2 @ ( B3 @ A2 ) )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) ) ) ) ).

% SigmaI
thf(fact_7775_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_7776_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_7777_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_7778_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Xs ) ) ).

% map_fst_zip
thf(fact_7779_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Ys ) ) ).

% map_snd_zip
thf(fact_7780_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_Cons_Cons
thf(fact_7781_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Us: list @ B,Ys: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) ).

% zip_append
thf(fact_7782_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu3: A] : ( set2 @ B @ Ys ) ) ) ).

% set_product
thf(fact_7783_map__of__zip__is__None,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ X )
          = ( none @ B ) )
        = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ) ) ).

% map_of_zip_is_None
thf(fact_7784_dom__map__of__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( dom @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) )
        = ( set2 @ A @ Xs ) ) ) ).

% dom_map_of_zip
thf(fact_7785_insert__Times__insert,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B2: B,B3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( insert @ A @ A2 @ A3 )
        @ ^ [Uu3: A] : ( insert @ B @ B2 @ B3 ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 )
        @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu3: A] : ( insert @ B @ B2 @ B3 ) )
          @ ( product_Sigma @ A @ B @ ( insert @ A @ A2 @ A3 )
            @ ^ [Uu3: A] : B3 ) ) ) ) ).

% insert_Times_insert
thf(fact_7786_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ).

% nth_zip
thf(fact_7787_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs ) @ ( hd @ B @ Ys ) ) ) ) ) ).

% hd_zip
thf(fact_7788_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,C6: set @ B,B3: set @ A,D5: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : C6 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu3: A] : D5 ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( C6
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
          & ( ord_less_eq @ ( set @ B ) @ C6 @ D5 ) ) ) ) ).

% times_subset_iff
thf(fact_7789_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ).

% zip_rev
thf(fact_7790_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_7791_Restr__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
            @ ( product_Sigma @ A @ A @ B3
              @ ^ [Uu3: A] : B3 ) )
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) ) ) ) ).

% Restr_subset
thf(fact_7792_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X: A,C6: set @ A,A3: set @ B,B3: set @ B] :
      ( ( member @ A @ X @ C6 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A3
            @ ^ [Uu3: B] : C6 )
          @ ( product_Sigma @ B @ A @ B3
            @ ^ [Uu3: B] : C6 ) )
        = ( ord_less_eq @ ( set @ B ) @ A3 @ B3 ) ) ) ).

% Times_subset_cancel2
thf(fact_7793_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C6: set @ A,B3: A > ( set @ B ),D5: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( B3 @ X5 ) @ ( D5 @ X5 ) ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) @ ( product_Sigma @ A @ B @ C6 @ D5 ) ) ) ) ).

% Sigma_mono
thf(fact_7794_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs: list @ B] :
      ( ( distinct @ A @ Ys )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) ) ) ).

% distinct_zipI2
thf(fact_7795_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% distinct_zipI1
thf(fact_7796_map__of__zip__inject,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs: list @ B,Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Ys )
        = ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( ( size_size @ ( list @ A ) @ Zs )
          = ( size_size @ ( list @ B ) @ Xs ) )
       => ( ( distinct @ B @ Xs )
         => ( ( ( map_of @ B @ A @ ( zip @ B @ A @ Xs @ Ys ) )
              = ( map_of @ B @ A @ ( zip @ B @ A @ Xs @ Zs ) ) )
           => ( Ys = Zs ) ) ) ) ) ).

% map_of_zip_inject
thf(fact_7797_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_7798_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I2: nat,X: A,Ys: list @ B,Y: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_update
thf(fact_7799_SigmaE,axiom,
    ! [A: $tType,B: $tType,C2: product_prod @ A @ B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ~ ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ! [Y3: B] :
                ( ( member @ B @ Y3 @ ( B3 @ X5 ) )
               => ( C2
                 != ( product_Pair @ A @ B @ X5 @ Y3 ) ) ) ) ) ).

% SigmaE
thf(fact_7800_SigmaD1,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ( member @ A @ A2 @ A3 ) ) ).

% SigmaD1
thf(fact_7801_SigmaD2,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ).

% SigmaD2
thf(fact_7802_SigmaE2,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ~ ( ( member @ A @ A2 @ A3 )
         => ~ ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ) ).

% SigmaE2
thf(fact_7803_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ).

% set_zip_rightD
thf(fact_7804_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_7805_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ~ ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ~ ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ) ).

% in_set_zipE
thf(fact_7806_zip__same,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
        & ( A2 = B2 ) ) ) ).

% zip_same
thf(fact_7807_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Xy2: product_prod @ A @ B,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( cons @ ( product_prod @ A @ B ) @ Xy2 @ Xys2 ) )
     => ~ ! [X5: A,Xs4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X5 @ Xs4 ) )
           => ! [Y3: B,Ys5: list @ B] :
                ( ( Ys
                  = ( cons @ B @ Y3 @ Ys5 ) )
               => ( ( Xy2
                    = ( product_Pair @ A @ B @ X5 @ Y3 ) )
                 => ( Xys2
                   != ( zip @ A @ B @ Xs4 @ Ys5 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_7808_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) )
       => ( ( A2 = B2 )
          | ( member @ A @ A2 @ A3 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_7809_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs ) @ Ys )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_fst
thf(fact_7810_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P: B > $o,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P @ Ys ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_snd
thf(fact_7811_swap__product,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B3: set @ A] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [I3: B,J3: A] : ( product_Pair @ A @ B @ J3 @ I3 ) )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu3: B] : B3 ) )
      = ( product_Sigma @ A @ B @ B3
        @ ^ [Uu3: A] : A3 ) ) ).

% swap_product
thf(fact_7812_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,I2: nat,Xy2: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ Xy2 )
      = ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ ( product_fst @ A @ B @ Xy2 ) ) @ ( list_update @ B @ Ys @ I2 @ ( product_snd @ A @ B @ Xy2 ) ) ) ) ).

% update_zip
thf(fact_7813_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y5: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X2: A,Z6: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y5 @ Z6 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_7814_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X2: A,Y5: B,Z6: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y5 @ Z6 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_7815_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_7816_image__paired__Times,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F2: C > A,G: D > B,A3: set @ C,B3: set @ D] :
      ( ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y5: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y5 ) ) )
        @ ( product_Sigma @ C @ D @ A3
          @ ^ [Uu3: C] : B3 ) )
      = ( product_Sigma @ A @ B @ ( image @ C @ A @ F2 @ A3 )
        @ ^ [Uu3: A] : ( image @ D @ B @ G @ B3 ) ) ) ).

% image_paired_Times
thf(fact_7817_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H2: B > C > A,F2: D > B,Xs: list @ D,G: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H2 ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X2: D] : ( H2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_7818_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y2: list @ A,Z: list @ A] : ( Y2 = Z ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X2: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X2 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y2: A,Z: A] : ( Y2 = Z )
                  @ X2 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_7819_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : B3 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) ) ) ).

% card_cartesian_product
thf(fact_7820_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X2: B,Y5: A] : ( product_Pair @ A @ B @ Y5 @ X2 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs3 ) ) ) ) ).

% zip_commute
thf(fact_7821_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ~ ! [Y3: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_7822_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ B @ Y @ ( set2 @ B @ Ys ) )
       => ~ ! [X5: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_7823_map__of__zip__is__Some,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
        = ( ? [Y5: B] :
              ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ X )
              = ( some @ B @ Y5 ) ) ) ) ) ).

% map_of_zip_is_Some
thf(fact_7824_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( zip @ A @ B @ Xs @ Ys )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys ) ) ) ) ).

% zip_eq_conv
thf(fact_7825_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G: D > B,Xs: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X2: D,Y5: C] : ( F2 @ ( product_Pair @ B @ C @ ( G @ X2 ) @ Y5 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys ) ) ) ).

% map_zip_map
thf(fact_7826_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X2: B,Y5: D] : ( F2 @ ( product_Pair @ B @ C @ X2 @ ( G @ Y5 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys ) ) ) ).

% map_zip_map2
thf(fact_7827_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B,S3: set @ ( product_prod @ A @ B ),Y: B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : B3 )
        @ S3 )
     => ( ( member @ B @ Y @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S3 ) ) ) ) ).

% subset_fst_imageI
thf(fact_7828_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B,S3: set @ ( product_prod @ A @ B ),X: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : B3 )
        @ S3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S3 ) ) ) ) ).

% subset_snd_imageI
thf(fact_7829_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys ) ) ) ).

% zip_map1
thf(fact_7830_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X2: A,Y5: C] : ( product_Pair @ A @ B @ X2 @ ( F2 @ Y5 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys ) ) ) ).

% zip_map2
thf(fact_7831_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: C > A,Xs: list @ C,G: D > B,Ys: list @ D] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G @ Ys ) )
      = ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y5: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y5 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys ) ) ) ).

% zip_map_map
thf(fact_7832_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z6: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z6 @ Y ) @ ( zip @ A @ B @ Zs3 @ Ys ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_7833_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y5: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y5 ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_7834_map__of__zip__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ ( map @ A @ B @ F2 @ Xs ) ) )
      = ( ^ [X2: A] : ( if @ ( option @ B ) @ ( member @ A @ X2 @ ( set2 @ A @ Xs ) ) @ ( some @ B @ ( F2 @ X2 ) ) @ ( none @ B ) ) ) ) ).

% map_of_zip_map
thf(fact_7835_map__of__zip__upd,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,Xs: list @ A,Zs: list @ B,X: A,Y: B,Z2: B] :
      ( ( ( size_size @ ( list @ B ) @ Ys )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( size_size @ ( list @ B ) @ Zs )
          = ( size_size @ ( list @ A ) @ Xs ) )
       => ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) @ X @ ( some @ B @ Y ) )
              = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Zs ) ) @ X @ ( some @ B @ Z2 ) ) )
           => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) )
              = ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Zs ) ) ) ) ) ) ) ).

% map_of_zip_upd
thf(fact_7836_ran__map__of__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs )
       => ( ( ran @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) )
          = ( set2 @ B @ Ys ) ) ) ) ).

% ran_map_of_zip
thf(fact_7837_Sigma__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_Sigma @ A @ B )
      = ( ^ [A7: set @ A,B8: A > ( set @ B )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
            @ ( image @ A @ ( set @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] :
                  ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
                  @ ( image @ B @ ( set @ ( product_prod @ A @ B ) )
                    @ ^ [Y5: B] : ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
                    @ ( B8 @ X2 ) ) )
              @ A7 ) ) ) ) ).

% Sigma_def
thf(fact_7838_product__fold,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( product_Sigma @ A @ B @ A3
            @ ^ [Uu3: A] : B3 )
          = ( finite_fold @ A @ ( set @ ( product_prod @ A @ B ) )
            @ ^ [X2: A,Z6: set @ ( product_prod @ A @ B )] :
                ( finite_fold @ B @ ( set @ ( product_prod @ A @ B ) )
                @ ^ [Y5: B] : ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) )
                @ Z6
                @ B3 )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) )
            @ A3 ) ) ) ) ).

% product_fold
thf(fact_7839_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P6 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P6 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7840_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
      = ( ? [N: nat] :
            ( ( ( nth @ A @ Xs @ N )
              = ( product_fst @ A @ B @ P2 ) )
            & ( ( nth @ B @ Ys @ N )
              = ( product_snd @ A @ B @ P2 ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ).

% in_set_zip
thf(fact_7841_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,I2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs )
       => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ ( nth @ A @ Xs @ I2 ) )
            = ( some @ B @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ) ).

% map_of_zip_nth
thf(fact_7842_uniformly__continuous__on__uniformity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo7287701948861334536_space @ A )
        & ( topolo7287701948861334536_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S6: set @ A,F5: A > B] :
              ( filterlim @ ( product_prod @ A @ A ) @ ( product_prod @ B @ B )
              @ ( product_case_prod @ A @ A @ ( product_prod @ B @ B )
                @ ^ [X2: A,Y5: A] : ( product_Pair @ B @ B @ ( F5 @ X2 ) @ ( F5 @ Y5 ) ) )
              @ ( topolo7806501430040627800ormity @ B )
              @ ( inf_inf @ ( filter @ ( product_prod @ A @ A ) ) @ ( topolo7806501430040627800ormity @ A )
                @ ( principal @ ( product_prod @ A @ A )
                  @ ( product_Sigma @ A @ A @ S6
                    @ ^ [Uu3: A] : S6 ) ) ) ) ) ) ) ).

% uniformly_continuous_on_uniformity
thf(fact_7843_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs3: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A7 )
              @ ( zip @ A @ nat @ Xs3 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7844_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X2: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y5: A,Z6: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y5 @ Z6 ) @ R )
              @ X2 ) ) ) ) ).

% listrel_iff_zip
thf(fact_7845_nths__nil,axiom,
    ! [A: $tType,A3: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A3 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_7846_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ).

% listrel_rtrancl_refl
thf(fact_7847_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_7848_nths__singleton,axiom,
    ! [A: $tType,A3: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_7849_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,I6: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs ) @ I6 )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs @ I6 ) ) ) ).

% nths_map
thf(fact_7850_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_7851_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_7852_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_7853_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) ) ).

% listrel.Nil
thf(fact_7854_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_7855_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_7856_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( nths @ A @ Xs @ I6 ) ) ) ).

% distinct_nthsI
thf(fact_7857_notin__set__nthsI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% notin_set_nthsI
thf(fact_7858_in__set__nthsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_nthsD
thf(fact_7859_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member @ nat @ I4 @ I6 ) )
     => ( ( nths @ A @ Xs @ I6 )
        = Xs ) ) ).

% nths_all
thf(fact_7860_set__nths__subset,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) @ ( set2 @ A @ Xs ) ) ).

% set_nths_subset
thf(fact_7861_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I6: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% sorted_nths
thf(fact_7862_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) ) ) ) ).

% listrel.Cons
thf(fact_7863_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys: list @ A,Xs: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [Y3: B,Ys4: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y3 @ Ys4 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons1
thf(fact_7864_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [X5: A,Xs2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X5 @ Xs2 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons2
thf(fact_7865_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_7866_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( zip @ nat @ A @ ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) @ Xs3 ) ) ) ).

% enumerate_eq_zip
thf(fact_7867_nths__append,axiom,
    ! [A: $tType,L2: list @ A,L3: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L2 @ L3 ) @ A3 )
      = ( append @ A @ ( nths @ A @ L2 @ A3 )
        @ ( nths @ A @ L3
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L2 ) ) @ A3 ) ) ) ) ) ).

% nths_append
thf(fact_7868_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_7869_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_7870_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ ( nths @ A @ Xs @ S ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S ) ) ) ).

% filter_in_nths
thf(fact_7871_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I6 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member @ nat @ I3 @ I6 ) ) ) ) ) ).

% length_nths
thf(fact_7872_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A12: list @ A,A23: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A12 @ A23 ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( A12
            = ( nil @ A ) )
          & ( A23
            = ( nil @ B ) ) )
        | ? [X2: A,Y5: B,Xs3: list @ A,Ys3: list @ B] :
            ( ( A12
              = ( cons @ A @ X2 @ Xs3 ) )
            & ( A23
              = ( cons @ B @ Y5 @ Ys3 ) )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R )
            & ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys3 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel.simps
thf(fact_7873_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A12: list @ A,A23: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A12 @ A23 ) @ ( listrel @ A @ B @ R ) )
     => ( ( ( A12
            = ( nil @ A ) )
         => ( A23
           != ( nil @ B ) ) )
       => ~ ! [X5: A,Y3: B,Xs2: list @ A] :
              ( ( A12
                = ( cons @ A @ X5 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A23
                    = ( cons @ B @ Y3 @ Ys4 ) )
                 => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y3 ) @ R )
                   => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_7874_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X5: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X5 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y5: list @ A,Z6: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y5 )
                = ( size_size @ ( list @ A ) @ Z6 ) )
            @ X5 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_7875_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X5: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X5 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y5: list @ A,Z6: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y5 )
                    = ( size_size @ ( list @ A ) @ Z6 ) )
                @ X5 ) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
thf(fact_7876_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_subset_rtrancl_listrel1
thf(fact_7877_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_7878_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P4: A > $o,Xs3: list @ A] :
            ( nths @ A @ Xs3
            @ ( collect @ nat
              @ ^ [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
                  & ( P4 @ ( nth @ A @ Xs3 @ I3 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7879_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [N: nat] :
            ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N ) @ ( nth @ B @ Ys @ N ) ) @ R ) ) ) ) ).

% listrel_iff_nth
thf(fact_7880_nths__Cons,axiom,
    ! [A: $tType,X: A,L2: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L2 ) @ A3 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L2
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A3 ) ) ) ) ) ).

% nths_Cons
thf(fact_7881_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I6 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I3: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs @ I3 ) )
            & ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member @ nat @ I3 @ I6 ) ) ) ) ).

% set_nths
thf(fact_7882_map__upds__fold__map__upd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_upds @ A @ B )
      = ( ^ [M3: A > ( option @ B ),Ks2: list @ A,Vs2: list @ B] :
            ( foldl @ ( A > ( option @ B ) ) @ ( product_prod @ A @ B )
            @ ^ [N: A > ( option @ B )] :
                ( product_case_prod @ A @ B @ ( A > ( option @ B ) )
                @ ^ [K2: A,V5: B] : ( fun_upd @ A @ ( option @ B ) @ N @ K2 @ ( some @ B @ V5 ) ) )
            @ M3
            @ ( zip @ A @ B @ Ks2 @ Vs2 ) ) ) ) ).

% map_upds_fold_map_upd
thf(fact_7883_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I3: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I3 ) @ ( nth @ B @ Ys @ I3 ) ) )
            & ( ord_less @ nat @ I3 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_7884_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_7885_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_7886_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_7887_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_7888_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_7889_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            & ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_7890_min__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ M @ N2 ) ) ) ).

% min_Suc_Suc
thf(fact_7891_min__0L,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_7892_min__0R,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_7893_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N2 ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_7894_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N2 ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_7895_foldl__append,axiom,
    ! [A: $tType,B: $tType,F2: A > B > A,A2: A,Xs: list @ B,Ys: list @ B] :
      ( ( foldl @ A @ B @ F2 @ A2 @ ( append @ B @ Xs @ Ys ) )
      = ( foldl @ A @ B @ F2 @ ( foldl @ A @ B @ F2 @ A2 @ Xs ) @ Ys ) ) ).

% foldl_append
thf(fact_7896_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(1)
thf(fact_7897_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_7898_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_7899_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_7900_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_7901_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_7902_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_7903_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N2 ) ) ) ) ).

% take_bit_of_mask
thf(fact_7904_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_7905_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(3)
thf(fact_7906_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_7907_min__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_7908_min__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% min_numeral_Suc
thf(fact_7909_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I2: nat,X: A,J: nat,Y: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I2 @ X ) @ ( replicate @ B @ J @ Y ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I2 @ J ) @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_replicate
thf(fact_7910_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_zip
thf(fact_7911_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: A > B > A,A2: A,F2: C > B,Xs: list @ C] :
      ( ( foldl @ A @ B @ G @ A2 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( foldl @ A @ C
        @ ^ [A4: A,X2: C] : ( G @ A4 @ ( F2 @ X2 ) )
        @ A2
        @ Xs ) ) ).

% foldl_map
thf(fact_7912_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_7913_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_7914_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_7915_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_7916_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_7917_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_7918_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( A4
              = ( ord_min @ A @ A4 @ B5 ) ) ) ) ) ).

% min.order_iff
thf(fact_7919_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_7920_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_7921_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( ord_min @ A @ A4 @ B5 )
              = A4 ) ) ) ) ).

% min.absorb_iff1
thf(fact_7922_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B5: A,A4: A] :
              ( ( ord_min @ A @ A4 @ B5 )
              = B5 ) ) ) ) ).

% min.absorb_iff2
thf(fact_7923_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_7924_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_7925_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            | ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_7926_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B5: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B5 ) @ A4 @ B5 ) ) ) ) ).

% min_def
thf(fact_7927_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_7928_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_7929_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B5: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B5 ) @ A4 @ B5 ) ) ) ) ).

% min_def_raw
thf(fact_7930_foldl__cong,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: A,L2: list @ B,K: list @ B,F2: A > B > A,G: A > B > A] :
      ( ( A2 = B2 )
     => ( ( L2 = K )
       => ( ! [A6: A,X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ L2 ) )
             => ( ( F2 @ A6 @ X5 )
                = ( G @ A6 @ X5 ) ) )
         => ( ( foldl @ A @ B @ F2 @ A2 @ L2 )
            = ( foldl @ A @ B @ G @ B2 @ K ) ) ) ) ) ).

% foldl_cong
thf(fact_7931_foldl__Cons,axiom,
    ! [B: $tType,A: $tType,F2: B > A > B,A2: B,X: A,Xs: list @ A] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( cons @ A @ X @ Xs ) )
      = ( foldl @ B @ A @ F2 @ ( F2 @ A2 @ X ) @ Xs ) ) ).

% foldl_Cons
thf(fact_7932_foldl__Nil,axiom,
    ! [A: $tType,B: $tType,F2: B > A > B,A2: B] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( nil @ A ) )
      = A2 ) ).

% foldl_Nil
thf(fact_7933_concat__bit__assoc__sym,axiom,
    ! [M: nat,N2: nat,K: int,L2: int,R: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N2 @ K @ L2 ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N2 ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N2 ) @ L2 @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_7934_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_min
thf(fact_7935_nat__mult__min__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N2 ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_7936_nat__mult__min__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N2 @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N2 ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_7937_min__diff,axiom,
    ! [M: nat,I2: nat,N2: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I2 ) @ ( minus_minus @ nat @ N2 @ I2 ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N2 ) @ I2 ) ) ).

% min_diff
thf(fact_7938_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_7939_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_7940_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_7941_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_7942_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_7943_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            | ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_7944_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_7945_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B5: A] :
              ( ( A4
                = ( ord_min @ A @ A4 @ B5 ) )
              & ( A4 != B5 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_7946_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_7947_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_7948_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N2 @ K @ L2 ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N2 ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N2 ) @ L2 ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_7949_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y @ P2 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_7950_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y @ P2 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_7951_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_7952_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_7953_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y @ P2 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_7954_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y @ P2 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_7955_min__Suc2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ M5 @ N2 ) )
        @ M ) ) ).

% min_Suc2
thf(fact_7956_min__Suc1,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ N2 @ M5 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_7957_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F5: B > A > A,Xs3: list @ B,A4: A] :
            ( foldl @ A @ B
            @ ^ [X2: A,Y5: B] : ( F5 @ Y5 @ X2 )
            @ A4
            @ ( rev @ B @ Xs3 ) ) ) ) ).

% foldr_conv_foldl
thf(fact_7958_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F5: A > B > A,A4: A,Xs3: list @ B] :
            ( foldr @ B @ A
            @ ^ [X2: B,Y5: A] : ( F5 @ Y5 @ X2 )
            @ ( rev @ B @ Xs3 )
            @ A4 ) ) ) ).

% foldl_conv_foldr
thf(fact_7959_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N2 ) ) ) ) ) ).

% mod_exp_eq
thf(fact_7960_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_7961_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( case_list @ A @ A @ X
            @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_7962_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: A > B,B3: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A3 @ F2 )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : B3 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 ) ) ).

% Gr_incl
thf(fact_7963_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_7964_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_7965_GrD2,axiom,
    ! [A: $tType,B: $tType,X: A,Fx: B,A3: set @ A,F2: A > B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Fx ) @ ( bNF_Gr @ A @ B @ A3 @ F2 ) )
     => ( ( F2 @ X )
        = Fx ) ) ).

% GrD2
thf(fact_7966_GrD1,axiom,
    ! [B: $tType,A: $tType,X: A,Fx: B,A3: set @ A,F2: A > B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Fx ) @ ( bNF_Gr @ A @ B @ A3 @ F2 ) )
     => ( member @ A @ X @ A3 ) ) ).

% GrD1
thf(fact_7967_Gr__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr @ A @ B )
      = ( ^ [A7: set @ A,F5: A > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: A] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ A4 @ ( F5 @ A4 ) ) )
                & ( member @ A @ A4 @ A7 ) ) ) ) ) ).

% Gr_def
thf(fact_7968_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ! [X5: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ Xs2 ) )
               => ( Y
                 != ( case_list @ A @ A @ X5
                    @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X5 @ ( min_list @ A @ Xs2 ) )
                    @ Xs2 ) ) )
           => ~ ( ( X
                  = ( nil @ A ) )
               => ( Y
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_7969_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M3: nat,N: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ) ).

% pred_nat_def
thf(fact_7970_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_7971_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X224: list @ A] : X213 ) ) ).

% hd_def
thf(fact_7972_less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N2 ) @ ( transitive_trancl @ nat @ pred_nat ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% less_eq
thf(fact_7973_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N2 ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% pred_nat_trancl_eq_le
thf(fact_7974_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X )
           => ( ! [X5: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X5 @ Xs2 ) )
                 => ( ( Y
                      = ( case_list @ A @ A @ X5
                        @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X5 @ ( min_list @ A @ Xs2 ) )
                        @ Xs2 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X5 @ Xs2 ) ) ) )
             => ~ ( ( X
                    = ( nil @ A ) )
                 => ( ( Y
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_7975_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa2: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa2 )
            = Y )
         => ( ! [X5: A] :
                ( ( Xa2
                  = ( cons @ A @ X5 @ ( nil @ A ) ) )
               => ( Y != X5 ) )
           => ( ! [X5: A,Y3: A,Zs2: list @ A] :
                  ( ( Xa2
                    = ( cons @ A @ X5 @ ( cons @ A @ Y3 @ Zs2 ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X @ X5 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) @ X5 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) )
             => ~ ( ( Xa2
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_7976_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( nil @ A ) ) )
          = X ) ) ).

% arg_min_list.simps(1)
thf(fact_7977_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( member @ A @ ( arg_min_list @ A @ B @ F2 @ Xs ) @ ( set2 @ A @ Xs ) ) ) ) ).

% arg_min_list_in
thf(fact_7978_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A,Y: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) @ X @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_7979_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I3 @ X )
              = ( take @ A @ I3 @ Y ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I3 ) @ ( nth @ A @ Y @ I3 ) ) @ R ) ) ) ) ).

% lexord_take_index_conv
thf(fact_7980_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I3: int,N: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( semiring_1_of_nat @ real @ N ) ) )
          & ( N
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_7981_take__take,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N2 @ M ) @ Xs ) ) ).

% take_take
thf(fact_7982_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_7983_take__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ N2 @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_7984_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs3: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_7985_take__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( take @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_7986_take__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N2 @ Xs ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_7987_take__all__iff,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( take @ A @ N2 @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% take_all_iff
thf(fact_7988_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 )
     => ( ( take @ A @ N2 @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_7989_nth__take,axiom,
    ! [A: $tType,I2: nat,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( nth @ A @ ( take @ A @ N2 @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ I2 ) ) ) ).

% nth_take
thf(fact_7990_take__upt,axiom,
    ! [I2: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ M ) @ N2 )
     => ( ( take @ nat @ M @ ( upt @ I2 @ N2 ) )
        = ( upt @ I2 @ ( plus_plus @ nat @ I2 @ M ) ) ) ) ).

% take_upt
thf(fact_7991_take__update__cancel,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( take @ A @ N2 @ ( list_update @ A @ Xs @ M @ Y ) )
        = ( take @ A @ N2 @ Xs ) ) ) ).

% take_update_cancel
thf(fact_7992_length__take,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N2 @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_take
thf(fact_7993_nths__upt__eq__take,axiom,
    ! [A: $tType,L2: list @ A,N2: nat] :
      ( ( nths @ A @ L2 @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( take @ A @ N2 @ L2 ) ) ).

% nths_upt_eq_take
thf(fact_7994_take__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( take @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( ord_min @ nat @ I2 @ K ) @ X ) ) ).

% take_replicate
thf(fact_7995_take__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( take @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% take_append
thf(fact_7996_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_7997_take__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_7998_dom__map__upds,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),Xs: list @ A,Ys: list @ B] :
      ( ( dom @ A @ B @ ( map_upds @ A @ B @ M @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) ) @ ( dom @ A @ B @ M ) ) ) ).

% dom_map_upds
thf(fact_7999_take__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( take @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( take @ B @ N2 @ Xs ) ) ) ).

% take_map
thf(fact_8000_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P4: A > $o,Xs3: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P4 @ Xs3 ) ) @ Xs3 ) ) ) ).

% takeWhile_eq_take
thf(fact_8001_take__update__swap,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N2: nat,X: A] :
      ( ( take @ A @ M @ ( list_update @ A @ Xs @ N2 @ X ) )
      = ( list_update @ A @ ( take @ A @ M @ Xs ) @ N2 @ X ) ) ).

% take_update_swap
thf(fact_8002_take__tl,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N2 ) @ Xs ) ) ) ).

% take_tl
thf(fact_8003_tl__take,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_8004_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N2 @ Xs ) ) ) ) ).

% sorted_take
thf(fact_8005_sorted__wrt__take,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N2: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( take @ A @ N2 @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_8006_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_8007_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X5: real] :
      ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X5 ) ) ).

% Rats_no_top_le
thf(fact_8008_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I2 @ Xs ) ) ) ).

% distinct_take
thf(fact_8009_take__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( take @ A @ N2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_8010_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_8011_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_8012_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_8013_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_8014_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_8015_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ! [I4: nat] :
          ( ( take @ A @ I4 @ Xs )
          = ( take @ A @ I4 @ Ys ) )
     => ( Xs = Ys ) ) ).

% take_equalityI
thf(fact_8016_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_8017_Rats__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_1
thf(fact_8018_Rats__dense__in__real,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [X5: real] :
          ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X5 )
          & ( ord_less @ real @ X5 @ Y ) ) ) ).

% Rats_dense_in_real
thf(fact_8019_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X5: real] :
      ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X5 @ X ) ) ).

% Rats_no_bot_less
thf(fact_8020_in__set__takeD,axiom,
    ! [A: $tType,X: A,N2: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_8021_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_8022_set__take__subset,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_8023_take__zip,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( take @ ( product_prod @ A @ B ) @ N2 @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( take @ A @ N2 @ Xs ) @ ( take @ B @ N2 @ Ys ) ) ) ).

% take_zip
thf(fact_8024_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws2: list @ B,N3: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws2 ) )
         => ( ( N3
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
           => ( ( Zs2
                = ( take @ A @ N3 @ Xs ) )
             => ( ( Ws2
                  = ( take @ B @ N3 @ Ys ) )
               => ( P @ ( zip @ A @ B @ Zs2 @ Ws2 ) ) ) ) ) )
     => ( P @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_obtain_same_length
thf(fact_8025_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ K )
             => ( ( nth @ A @ Xs @ I4 )
                = ( nth @ A @ Ys @ I4 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_8026_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,P: A > $o] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I4 ) ) ) )
     => ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P @ ( nth @ A @ Xs @ N2 ) ) )
       => ( ( takeWhile @ A @ P @ Xs )
          = ( take @ A @ N2 @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_8027_take__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M3: nat] : ( cons @ A @ X @ ( take @ A @ M3 @ Xs ) )
        @ N2 ) ) ).

% take_Cons
thf(fact_8028_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N2: nat,X: A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N2 @ X ) @ Ys )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ ( take @ B @ N2 @ Ys ) ) ) ).

% zip_replicate1
thf(fact_8029_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I3: int,J3: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_8030_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N2: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N2 @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ Y )
        @ ( take @ A @ N2 @ Xs ) ) ) ).

% zip_replicate2
thf(fact_8031_take__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_8032_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N2 ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N2 @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_8033_map__upd__upds__conv__if,axiom,
    ! [A: $tType,B: $tType,X: A,Ys: list @ B,Xs: list @ A,F2: A > ( option @ B ),Y: B] :
      ( ( ( member @ A @ X @ ( set2 @ A @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) ) )
       => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X @ ( some @ B @ Y ) ) @ Xs @ Ys )
          = ( map_upds @ A @ B @ F2 @ Xs @ Ys ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) ) )
       => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X @ ( some @ B @ Y ) ) @ Xs @ Ys )
          = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ F2 @ Xs @ Ys ) @ X @ ( some @ B @ Y ) ) ) ) ) ).

% map_upd_upds_conv_if
thf(fact_8034_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) @ Xs ) ) ).

% map_fst_zip_take
thf(fact_8035_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ B,Ys: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ Ys ) ) ).

% map_snd_zip_take
thf(fact_8036_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ~ ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I4 @ Xs )
                  = ( take @ A @ I4 @ Ys ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Ys @ I4 ) ) @ R ) ) ) ) ) ).

% lex_take_index
thf(fact_8037_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N2 @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_8038_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I2 ) @ Xs )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_8039_nth__image,axiom,
    ! [A: $tType,L2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L2 ) )
        = ( set2 @ A @ ( take @ A @ L2 @ Xs ) ) ) ) ).

% nth_image
thf(fact_8040_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N2: nat,X: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M != N2 )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) @ M )
            = ( nth @ A @ Xs @ M ) ) ) ) ) ).

% nth_repl
thf(fact_8041_pos__n__replace,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N2 ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_8042_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X2: list @ A] : X2 ) ) ).

% drop0
thf(fact_8043_drop__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N2 @ M ) @ Xs ) ) ).

% drop_drop
thf(fact_8044_drop__upt,axiom,
    ! [M: nat,I2: nat,J: nat] :
      ( ( drop @ nat @ M @ ( upt @ I2 @ J ) )
      = ( upt @ ( plus_plus @ nat @ I2 @ M ) @ J ) ) ).

% drop_upt
thf(fact_8045_drop__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ N2 @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_8046_length__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N2 @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_drop
thf(fact_8047_drop__update__cancel,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N2 @ X ) )
        = ( drop @ A @ M @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_8048_append__take__drop__id,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( drop @ A @ N2 @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_8049_drop__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( drop @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I2 ) @ X ) ) ).

% drop_replicate
thf(fact_8050_drop__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N2 @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% drop_eq_Nil2
thf(fact_8051_drop__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% drop_eq_Nil
thf(fact_8052_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 )
     => ( ( drop @ A @ N2 @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_8053_drop__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( drop @ A @ N2 @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_8054_drop__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_8055_nth__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,I2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N2 @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N2 @ I2 ) ) ) ) ).

% nth_drop
thf(fact_8056_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_8057_take__add,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I2 @ J ) @ Xs )
      = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( take @ A @ J @ ( drop @ A @ I2 @ Xs ) ) ) ) ).

% take_add
thf(fact_8058_drop__take,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N2 ) @ ( drop @ A @ N2 @ Xs ) ) ) ).

% drop_take
thf(fact_8059_take__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N2 @ M ) @ Xs ) ) ) ).

% take_drop
thf(fact_8060_drop__zip,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( drop @ ( product_prod @ A @ B ) @ N2 @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( drop @ A @ N2 @ Xs ) @ ( drop @ B @ N2 @ Ys ) ) ) ).

% drop_zip
thf(fact_8061_set__drop__subset,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_8062_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_8063_in__set__dropD,axiom,
    ! [A: $tType,X: A,N2: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_8064_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_8065_drop__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( drop @ A @ N2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_8066_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I2 @ Xs ) ) ) ).

% distinct_drop
thf(fact_8067_nth__via__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( drop @ A @ N2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ( ( nth @ A @ Xs @ N2 )
        = Y ) ) ).

% nth_via_drop
thf(fact_8068_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N2: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( drop @ A @ N2 @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_8069_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N2 @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_8070_drop__Suc,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ Xs )
      = ( drop @ A @ N2 @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_8071_tl__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N2 @ Xs ) )
      = ( drop @ A @ N2 @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_8072_drop__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X @ Xs )
        @ ^ [M3: nat] : ( drop @ A @ M3 @ Xs )
        @ N2 ) ) ).

% drop_Cons
thf(fact_8073_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( nths @ A @ Xs3 @ ( collect @ nat @ ( ord_less_eq @ nat @ N ) ) ) ) ) ).

% drop_eq_nths
thf(fact_8074_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N2 @ X ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs ) @ ( minus_minus @ nat @ N2 @ M ) @ X ) ) ) ).

% drop_update_swap
thf(fact_8075_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P4: A > $o,Xs3: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P4 @ Xs3 ) ) @ Xs3 ) ) ) ).

% dropWhile_eq_drop
thf(fact_8076_drop__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( drop @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( drop @ B @ N2 @ Xs ) ) ) ).

% drop_map
thf(fact_8077_nths__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,I6: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N2 @ Xs ) @ I6 )
      = ( nths @ A @ Xs @ ( image @ nat @ nat @ ( plus_plus @ nat @ N2 ) @ I6 ) ) ) ).

% nths_drop
thf(fact_8078_drop__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_8079_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_8080_hd__drop__conv__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N2 @ Xs ) )
        = ( nth @ A @ Xs @ N2 ) ) ) ).

% hd_drop_conv_nth
thf(fact_8081_drop__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) @ Xs ) ) ) ).

% drop_rev
thf(fact_8082_rev__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_8083_rev__take,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I2 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_8084_take__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) @ Xs ) ) ) ).

% take_rev
thf(fact_8085_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) )
        = ( drop @ A @ I2 @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_8086_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) @ ( zip @ A @ B @ Ys @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_8087_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( append @ B @ Ys @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Ys ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Zs ) ) ) ).

% zip_append2
thf(fact_8088_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I2 @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_8089_id__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_8090_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,A2: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I2 @ A2 )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_8091_take__hd__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N2 @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N2 ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_8092_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R5 ) ) ) ) ) ) ).

% listrel_def
thf(fact_8093_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) @ ( take @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ) ).

% rotate_drop_take
thf(fact_8094_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( rotate @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate_is_Nil_conv
thf(fact_8095_set__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate
thf(fact_8096_length__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N2 @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate
thf(fact_8097_distinct__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rotate
thf(fact_8098_rotate__Suc,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ ( suc @ N2 ) @ Xs )
      = ( rotate1 @ A @ ( rotate @ A @ N2 @ Xs ) ) ) ).

% rotate_Suc
thf(fact_8099_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_8100_rotate__id,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_8101_rotate__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( rotate @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate @ B @ N2 @ Xs ) ) ) ).

% rotate_map
thf(fact_8102_rotate__add,axiom,
    ! [A: $tType,M: nat,N2: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N2 ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N2 ) ) ) ).

% rotate_add
thf(fact_8103_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ).

% rotate_conv_mod
thf(fact_8104_rotate__append,axiom,
    ! [A: $tType,L2: list @ A,Q2: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L2 ) @ ( append @ A @ L2 @ Q2 ) )
      = ( append @ A @ Q2 @ L2 ) ) ).

% rotate_append
thf(fact_8105_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( R @ X @ Y )
     => ( ( listrelp @ A @ B @ R @ Xs @ Ys )
       => ( listrelp @ A @ B @ R @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) ).

% listrelp.Cons
thf(fact_8106_rotate__def,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat] : ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( rotate1 @ A ) ) ) ) ).

% rotate_def
thf(fact_8107_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( listrelp @ A @ B @ R @ ( nil @ A ) @ ( nil @ B ) ) ).

% listrelp.Nil
thf(fact_8108_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N2 @ Xs ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N2 ) @ Xs ) ) ).

% rotate_rotate
thf(fact_8109_rotate1__rotate__swap,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate1 @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( rotate @ A @ N2 @ ( rotate1 @ A @ Xs ) ) ) ).

% rotate1_rotate_swap
thf(fact_8110_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A12: list @ A,A23: list @ B] :
      ( ( listrelp @ A @ B @ R @ A12 @ A23 )
     => ( ( ( A12
            = ( nil @ A ) )
         => ( A23
           != ( nil @ B ) ) )
       => ~ ! [X5: A,Y3: B,Xs2: list @ A] :
              ( ( A12
                = ( cons @ A @ X5 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A23
                    = ( cons @ B @ Y3 @ Ys4 ) )
                 => ( ( R @ X5 @ Y3 )
                   => ~ ( listrelp @ A @ B @ R @ Xs2 @ Ys4 ) ) ) ) ) ) ).

% listrelp.cases
thf(fact_8111_listrelp_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R5: A > B > $o,A1: list @ A,A22: list @ B] :
            ( ( ( A1
                = ( nil @ A ) )
              & ( A22
                = ( nil @ B ) ) )
            | ? [X2: A,Y5: B,Xs3: list @ A,Ys3: list @ B] :
                ( ( A1
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A22
                  = ( cons @ B @ Y5 @ Ys3 ) )
                & ( R5 @ X2 @ Y5 )
                & ( listrelp @ A @ B @ R5 @ Xs3 @ Ys3 ) ) ) ) ) ).

% listrelp.simps
thf(fact_8112_rotate__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% rotate_rev
thf(fact_8113_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X2: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R ) )
      = ( ^ [X2: list @ A,Y5: list @ B] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X2 @ Y5 ) @ ( listrel @ A @ B @ R ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_8114_nth__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,M: nat] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_8115_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N2 @ Xs ) )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_8116_comp__fun__idem__on_Ofold__insert__idem2,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A3 ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem2
thf(fact_8117_comp__fun__idem__on_Ofold__insert__idem,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem
thf(fact_8118_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S3: set @ A,F2: A > B > B,G: C > A,R2: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S3 )
       => ( finite673082921795544331dem_on @ C @ B @ R2 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_8119_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > A,G: C > B,A3: set @ C] :
      ( ( image @ C @ ( product_prod @ A @ B )
        @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ A3 )
      = ( product_Sigma @ A @ B @ ( image @ C @ A @ F2 @ A3 )
        @ ^ [X2: A] : ( image @ C @ B @ G @ ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) ) ) ) ).

% image_split_eq_Sigma
thf(fact_8120_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_8121_finite__vimageD_H,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ B] :
      ( ( finite_finite @ A @ ( vimage @ A @ B @ F2 @ A3 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite @ B @ A3 ) ) ) ).

% finite_vimageD'
thf(fact_8122_vimage__subsetD,axiom,
    ! [A: $tType,B: $tType,F2: B > A,B3: set @ A,A3: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ B3 ) @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% vimage_subsetD
thf(fact_8123_image__subset__iff__subset__vimage,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
      = ( ord_less_eq @ ( set @ B ) @ A3 @ ( vimage @ B @ A @ F2 @ B3 ) ) ) ).

% image_subset_iff_subset_vimage
thf(fact_8124_image__vimage__subset,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( vimage @ B @ A @ F2 @ A3 ) ) @ A3 ) ).

% image_vimage_subset
thf(fact_8125_vimage__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ A3 ) @ ( vimage @ B @ A @ F2 @ B3 ) ) ) ).

% vimage_mono
thf(fact_8126_subset__vimage__iff,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B,B3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( vimage @ A @ B @ F2 @ B3 ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ( member @ B @ ( F2 @ X2 ) @ B3 ) ) ) ) ).

% subset_vimage_iff
thf(fact_8127_continuous__imp__open__vimage,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [S: set @ A,F2: A > B,B3: set @ B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( topolo1002775350975398744n_open @ B @ B3 )
             => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B3 ) @ S )
               => ( topolo1002775350975398744n_open @ A @ ( vimage @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ).

% continuous_imp_open_vimage
thf(fact_8128_less__rat__def,axiom,
    ( ( ord_less @ rat )
    = ( ^ [X2: rat,Y5: rat] : ( positive @ ( minus_minus @ rat @ Y5 @ X2 ) ) ) ) ).

% less_rat_def
thf(fact_8129_vimage__Suc__insert__Suc,axiom,
    ! [N2: nat,A3: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert @ nat @ ( suc @ N2 ) @ A3 ) )
      = ( insert @ nat @ N2 @ ( vimage @ nat @ nat @ suc @ A3 ) ) ) ).

% vimage_Suc_insert_Suc
thf(fact_8130_vimage__Suc__insert__0,axiom,
    ! [A3: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert @ nat @ ( zero_zero @ nat ) @ A3 ) )
      = ( vimage @ nat @ nat @ suc @ A3 ) ) ).

% vimage_Suc_insert_0
thf(fact_8131_finite__vimage__Suc__iff,axiom,
    ! [F4: set @ nat] :
      ( ( finite_finite @ nat @ ( vimage @ nat @ nat @ suc @ F4 ) )
      = ( finite_finite @ nat @ F4 ) ) ).

% finite_vimage_Suc_iff
thf(fact_8132_Pair__vimage__Sigma,axiom,
    ! [B: $tType,A: $tType,X: B,A3: set @ B,F2: B > ( set @ A )] :
      ( ( ( member @ B @ X @ A3 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A3 @ F2 ) )
          = ( F2 @ X ) ) )
      & ( ~ ( member @ B @ X @ A3 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A3 @ F2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Pair_vimage_Sigma
thf(fact_8133_vimage__subset__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ B,A3: set @ A] :
      ( ( bij_betw @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B3 ) @ A3 )
        = ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ).

% vimage_subset_eq
thf(fact_8134_vimage__subsetI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B3 ) @ A3 ) ) ) ).

% vimage_subsetI
thf(fact_8135_card__vimage__inj,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( ( finite_card @ A @ ( vimage @ A @ B @ F2 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% card_vimage_inj
thf(fact_8136_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D5: set @ A,A3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D5 )
     => ( ( finite_finite @ B @ A3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A3 ) @ D5 ) ) @ ( finite_card @ B @ A3 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_8137_set__decode__div__2,axiom,
    ! [X: nat] :
      ( ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( vimage @ nat @ nat @ suc @ ( nat_set_decode @ X ) ) ) ).

% set_decode_div_2
thf(fact_8138_set__encode__vimage__Suc,axiom,
    ! [A3: set @ nat] :
      ( ( nat_set_encode @ ( vimage @ nat @ nat @ suc @ A3 ) )
      = ( divide_divide @ nat @ ( nat_set_encode @ A3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% set_encode_vimage_Suc
thf(fact_8139_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X2: A] :
                ( ( F2 @ X2 )
                = A2 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_8140_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) @ A3 )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( ( F2 @ X2 )
                  = A2 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_8141_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( P @ X5 ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ ( set2 @ A @ Ys ) )
           => ~ ( P @ Y3 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P ) @ ( insert @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% inv_image_partition
thf(fact_8142_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X2: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X2 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X2 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_8143_ntrancl__Suc,axiom,
    ! [A: $tType,N2: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( suc @ N2 ) @ R2 )
      = ( relcomp @ A @ A @ A @ ( transitive_ntrancl @ A @ N2 @ R2 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( id @ A ) @ R2 ) ) ) ).

% ntrancl_Suc
thf(fact_8144_IdI,axiom,
    ! [A: $tType,A2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id @ A ) ) ).

% IdI
thf(fact_8145_pair__in__Id__conv,axiom,
    ! [A: $tType,A2: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id @ A ) )
      = ( A2 = B2 ) ) ).

% pair_in_Id_conv
thf(fact_8146_Id__def,axiom,
    ! [A: $tType] :
      ( ( id @ A )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [P6: product_prod @ A @ A] :
          ? [X2: A] :
            ( P6
            = ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ) ).

% Id_def
thf(fact_8147_IdD,axiom,
    ! [A: $tType,A2: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id @ A ) )
     => ( A2 = B2 ) ) ).

% IdD
thf(fact_8148_IdE,axiom,
    ! [A: $tType,P2: product_prod @ A @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( id @ A ) )
     => ~ ! [X5: A] :
            ( P2
           != ( product_Pair @ A @ A @ X5 @ X5 ) ) ) ).

% IdE
thf(fact_8149_reflcl__set__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ^ [X2: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R )
        @ ^ [Y2: A,Z: A] : ( Y2 = Z ) )
      = ( ^ [X2: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R @ ( id @ A ) ) ) ) ) ).

% reflcl_set_eq
thf(fact_8150_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y5: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( sup_sup @ A @ X2 ) @ Y5 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_8151_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y5: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( inf_inf @ A @ X2 ) @ Y5 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_8152_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
             => ! [A19: A] :
                  ( ( member @ A @ A19 @ A3 )
                 => ( ord_less_eq @ A @ X @ A19 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_8153_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ X @ A6 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_8154_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X )
             => ! [A19: A] :
                  ( ( member @ A @ A19 @ A3 )
                 => ( ord_less_eq @ A @ A19 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_8155_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ A6 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_8156_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_8157_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_8158_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_8159_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_8160_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_8161_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B3 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_8162_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B3 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_8163_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B3 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_8164_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B3 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
                = ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_8165_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y5: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_max @ A @ X2 ) @ Y5 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_8166_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y5: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_min @ A @ X2 ) @ Y5 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_8167_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_8168_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_8169_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_8170_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_8171_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A3 )
                = M )
              = ( ( member @ A @ M @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_8172_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_8173_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ( member @ A @ M @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_8174_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X )
             => ! [A19: A] :
                  ( ( member @ A @ A19 @ A3 )
                 => ( ord_less_eq @ A @ A19 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_8175_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ A6 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_8176_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_8177_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_8178_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ A3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( member @ A @ X @ A3 )
             => ( ( lattic643756798350308766er_Min @ A @ A3 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_8179_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X ) ) ) ) ).

% Min_le
thf(fact_8180_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max.coboundedI

% Type constructors (756)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( filter @ A11 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( set @ A11 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounded_lattice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( condit1219197933456340205attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( counta3822494911875563373attice @ A20 )
     => ( counta3822494911875563373attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple592849572758109894attice @ A20 )
     => ( comple592849572758109894attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4967611905675639751up_bot @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4346867609351753570nf_top @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple6319245703460814977attice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( boolea8198339166811842893lgebra @ A20 )
     => ( boolea8198339166811842893lgebra @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( semilattice_sup @ A20 )
     => ( semilattice_sup @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( semilattice_inf @ A20 )
     => ( semilattice_inf @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order_top @ A20 )
     => ( order_top @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order_bot @ A20 )
     => ( order_bot @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( preorder @ A20 )
     => ( preorder @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( lattice @ A20 )
     => ( lattice @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( order @ A20 )
     => ( order @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ord @ A20 )
     => ( ord @ ( A11 > A20 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( uminus @ A20 )
     => ( uminus @ ( A11 > A20 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_14,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_15,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_16,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_17,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_18,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_19,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_20,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_21,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_22,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_23,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_24,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_25,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_26,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_27,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_28,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_29,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_30,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_31,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_32,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_33,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_34,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_35,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_36,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_37,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_38,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_39,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_40,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_41,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_42,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_43,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_44,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_45,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_46,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_47,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_48,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_49,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_50,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_51,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_52,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_53,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_54,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_55,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_56,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_57,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_58,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_59,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_60,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_61,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_62,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_63,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_64,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_65,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_66,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_67,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_68,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_69,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_70,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_71,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_72,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_73,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_74,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_75,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_76,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_77,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_78,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_79,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_80,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_81,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_82,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_83,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_84,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_85,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_86,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_87,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_88,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_89,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_90,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_91,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Power_Opower_93,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_94,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_95,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_96,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_97,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_98,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_99,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_100,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_101,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_102,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_103,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_104,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_105,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_106,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_107,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_108,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_109,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_110,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_111,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_112,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_113,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_114,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_115,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_116,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_117,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_118,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_119,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_120,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_121,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_122,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_123,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_124,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_125,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_126,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_127,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_128,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_129,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_130,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_131,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_132,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_133,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_134,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_135,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_136,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_137,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_138,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_139,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_140,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_141,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_142,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_143,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_144,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_145,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_146,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_147,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_148,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_149,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_150,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_151,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_152,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_153,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_154,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_155,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_156,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_157,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_158,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_159,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_160,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_161,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_162,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_163,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_164,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_165,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_166,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_167,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_168,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_169,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_170,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_171,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_172,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_173,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_174,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_175,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_176,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_177,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_178,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_179,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_180,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_181,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_182,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_183,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_184,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_185,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_186,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_187,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_188,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_189,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_190,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_191,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_192,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_193,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_194,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_195,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_196,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_197,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_198,axiom,
    ! [A11: $tType] : ( order_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_199,axiom,
    ! [A11: $tType] : ( order_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_200,axiom,
    ! [A11: $tType] : ( preorder @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_201,axiom,
    ! [A11: $tType] : ( lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_202,axiom,
    ! [A11: $tType] : ( order @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_203,axiom,
    ! [A11: $tType] : ( ord @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_204,axiom,
    ! [A11: $tType] : ( uminus @ ( set @ A11 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_205,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_206,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_207,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_208,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_209,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_210,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_211,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_212,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_213,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_214,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_215,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_216,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_217,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_218,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_219,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_220,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_221,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_222,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_223,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_224,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_225,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_226,axiom,
    ! [A11: $tType] : ( size @ ( list @ A11 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_227,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_228,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_229,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_230,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_231,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_232,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_233,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_234,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_235,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_236,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_237,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_238,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_239,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_240,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_241,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_242,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_243,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_244,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_245,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_246,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_247,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_248,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_249,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_250,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_251,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_252,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_253,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_254,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_255,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_256,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_257,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_258,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_259,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_260,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_261,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_262,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_263,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_264,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_265,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_266,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_267,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_268,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_269,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_270,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_271,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_272,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_273,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_274,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_275,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_276,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_277,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_278,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_279,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_280,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_281,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_282,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_283,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_284,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_285,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_286,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_287,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_288,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_289,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_290,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_291,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_292,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_293,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_294,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_295,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_296,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_297,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_298,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_299,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_300,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_301,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_302,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_303,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_304,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_305,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_306,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_307,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_308,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_309,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_310,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_311,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_312,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_313,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_314,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_315,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_316,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_317,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_318,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_319,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_320,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_321,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_322,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_323,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_324,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_325,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_326,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_327,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_328,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_329,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_330,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_331,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_332,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_333,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_334,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_335,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_336,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_337,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_338,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_339,axiom,
    ! [A11: $tType] : ( order_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_340,axiom,
    ! [A11: $tType] : ( order_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_341,axiom,
    ! [A11: $tType] : ( preorder @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_342,axiom,
    ! [A11: $tType] : ( lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_343,axiom,
    ! [A11: $tType] : ( order @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_344,axiom,
    ! [A11: $tType] : ( ord @ ( filter @ A11 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_345,axiom,
    ! [A11: $tType] : ( size @ ( option @ A11 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_346,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_347,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_348,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_349,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_350,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_351,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_352,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_353,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_354,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_355,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_356,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_357,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_358,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_359,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_360,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_361,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_362,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_363,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_364,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_365,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_366,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_367,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_368,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_369,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_370,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_371,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_372,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_373,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_374,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_375,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_376,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_377,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_378,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_379,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_380,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_381,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_382,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_383,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_384,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_385,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_386,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_387,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_388,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_389,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_390,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_391,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_392,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_393,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_394,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_395,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_396,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_397,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_398,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_399,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_400,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_401,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_402,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_403,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_404,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_405,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_406,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_407,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_408,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_409,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_410,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_411,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_412,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_413,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_414,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_415,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_416,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_417,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_418,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_419,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_420,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_421,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_422,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_423,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_424,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_425,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_426,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_427,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_428,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_429,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_430,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_431,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_432,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_433,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_434,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_435,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_436,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_437,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_438,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_439,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_440,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_441,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_442,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_443,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_444,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_445,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_446,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_447,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_448,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_449,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_450,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_451,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_452,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_453,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_454,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_455,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_456,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_457,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_458,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_459,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_460,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_461,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_462,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_463,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_464,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_465,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_466,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_467,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_468,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_469,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_470,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_471,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_472,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ( topolo4958980785337419405_space @ A11 )
        & ( topolo4958980785337419405_space @ A20 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A11 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_473,axiom,
    ! [A11: $tType,A20: $tType] :
      ( ( ( topological_t2_space @ A11 )
        & ( topological_t2_space @ A20 ) )
     => ( topological_t2_space @ ( product_prod @ A11 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_474,axiom,
    ! [A11: $tType,A20: $tType] : ( size @ ( product_prod @ A11 @ A20 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_475,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_476,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_477,axiom,
    counta3822494911875563373attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_478,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_479,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_480,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_481,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_482,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_483,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_484,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_485,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_486,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_487,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_488,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_489,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_490,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_491,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_492,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_493,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_494,axiom,
    uminus @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_495,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_496,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_497,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_498,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_499,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_500,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_501,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_502,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_503,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_504,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_505,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_506,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_507,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_508,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_509,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_510,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_511,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_512,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_513,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_514,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_515,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_516,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_517,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_518,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_519,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_520,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_521,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_522,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_523,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_524,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_525,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_526,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_527,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_528,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_529,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_530,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_531,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_532,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_533,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_534,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_535,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_536,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_537,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_538,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_539,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_540,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_541,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_542,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_543,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_544,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_545,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_546,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_547,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_548,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_549,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_550,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_551,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_552,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_553,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_554,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_555,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_556,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_557,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_558,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_559,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_560,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_561,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_562,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_563,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_564,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_565,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_566,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_567,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_568,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_569,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_570,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_571,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_572,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_573,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_574,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_575,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_576,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_577,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_578,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_579,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_580,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_581,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_582,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_583,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_584,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_585,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_586,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_587,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_588,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_589,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_590,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_591,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_592,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X4: A] : ( P @ X4 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ na ) ) @ ( vEBT_VEBT_low @ xa @ na ) ).

%------------------------------------------------------------------------------
